/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var ie=["require","exports","vs/editor/common/core/range","vs/base/common/charCode","vs/base/common/errors","vs/editor/common/core/position","vs/editor/common/core/offsetRange","vs/base/common/arrays","vs/base/common/strings","vs/base/common/arraysFind","vs/editor/common/diff/defaultLinesDiffComputer/algorithms/diffAlgorithm","vs/base/common/assert","vs/base/common/lifecycle","vs/base/common/event","vs/base/common/uint","vs/editor/common/core/lineRange","vs/base/common/map","vs/base/common/objects","vs/editor/common/diff/defaultLinesDiffComputer/utils","vs/editor/common/diff/rangeMapping","vs/base/common/platform","vs/base/common/uri","vs/base/common/functional","vs/base/common/iterator","vs/base/common/linkedList","vs/base/common/stopwatch","vs/base/common/cancellation","vs/base/common/types","vs/base/common/codiconsUtil","vs/base/common/diff/diff","vs/editor/common/core/characterClassifier","vs/editor/common/core/textLength","vs/editor/common/core/wordHelper","vs/editor/common/diff/defaultLinesDiffComputer/algorithms/myersDiffAlgorithm","vs/editor/common/diff/defaultLinesDiffComputer/linesSliceCharSequence","vs/editor/common/diff/linesDiffComputer","vs/editor/common/diff/legacyLinesDiffComputer","vs/base/common/collections","vs/base/common/color","vs/base/common/diff/diffChange","vs/base/common/keyCodes","vs/base/common/lazy","vs/base/common/marshallingIds","vs/base/common/cache","vs/base/common/codiconsLibrary","vs/base/common/codicons","vs/base/common/hash","vs/editor/common/core/editOperation","vs/editor/common/core/selection","vs/editor/common/core/positionToOffset","vs/editor/common/core/textEdit","vs/editor/common/core/wordCharacterClassifier","vs/editor/common/diff/defaultLinesDiffComputer/heuristicSequenceOptimizations","vs/editor/common/diff/defaultLinesDiffComputer/lineSequence","vs/editor/common/diff/defaultLinesDiffComputer/algorithms/dynamicProgrammingDiffing","vs/editor/common/diff/defaultLinesDiffComputer/computeMovedLines","vs/editor/common/diff/defaultLinesDiffComputer/defaultLinesDiffComputer","vs/editor/common/diff/linesDiffComputers","vs/editor/common/encodedTokenAttributes","vs/editor/common/languages/defaultDocumentColorsComputer","vs/editor/common/languages/linkComputer","vs/editor/common/languages/supports/inplaceReplaceSupport","vs/editor/common/model","vs/editor/common/model/prefixSumComputer","vs/editor/common/model/mirrorTextModel","vs/editor/common/model/textModelSearch","vs/editor/common/services/findSectionHeaders","vs/editor/common/services/unicodeTextModelHighlighter","vs/editor/common/standalone/standaloneEnums","vs/editor/common/tokenizationRegistry","vs/nls!vs/base/common/platform","vs/nls","vs/nls!vs/editor/common/services/editorSimpleWorker","vs/base/common/process","vs/base/common/path","vs/nls!vs/editor/common/languages","vs/editor/common/languages","vs/editor/common/services/editorBaseApi","vs/css","vs/base/common/worker/simpleWorker","vs/editor/common/services/editorSimpleWorker"],re=function(x){for(var i=[],t=0,n=x.length;t<n;t++)i[t]=ie[x[t]];return i};const Ze=this,Qe=typeof global=="object"?global:{};var Le;(function(x){x.global=Ze;class i{get isWindows(){return this._detect(),this._isWindows}get isNode(){return this._detect(),this._isNode}get isElectronRenderer(){return this._detect(),this._isElectronRenderer}get isWebWorker(){return this._detect(),this._isWebWorker}get isElectronNodeIntegrationWebWorker(){return this._detect(),this._isElectronNodeIntegrationWebWorker}constructor(){this._detected=!1,this._isWindows=!1,this._isNode=!1,this._isElectronRenderer=!1,this._isWebWorker=!1,this._isElectronNodeIntegrationWebWorker=!1}_detect(){this._detected||(this._detected=!0,this._isWindows=i._isWindows(),this._isNode=typeof module<"u"&&!!module.exports,this._isElectronRenderer=typeof process<"u"&&typeof process.versions<"u"&&typeof process.versions.electron<"u"&&process.type==="renderer",this._isWebWorker=typeof x.global.importScripts=="function",this._isElectronNodeIntegrationWebWorker=this._isWebWorker&&typeof process<"u"&&typeof process.versions<"u"&&typeof process.versions.electron<"u"&&process.type==="worker")}static _isWindows(){return typeof navigator<"u"&&navigator.userAgent&&navigator.userAgent.indexOf("Windows")>=0?!0:typeof process<"u"?process.platform==="win32":!1}}x.Environment=i})(Le||(Le={}));var Le;(function(x){class i{constructor(g,E,d){this.type=g,this.detail=E,this.timestamp=d}}x.LoaderEvent=i;class t{constructor(g){this._events=[new i(1,"",g)]}record(g,E){this._events.push(new i(g,E,x.Utilities.getHighPerformanceTimestamp()))}getEvents(){return this._events}}x.LoaderEventRecorder=t;class n{record(g,E){}getEvents(){return[]}}n.INSTANCE=new n,x.NullLoaderEventRecorder=n})(Le||(Le={}));var Le;(function(x){class i{static fileUriToFilePath(n,p){if(p=decodeURI(p).replace(/%23/g,"#"),n){if(/^file:\/\/\//.test(p))return p.substr(8);if(/^file:\/\//.test(p))return p.substr(5)}else if(/^file:\/\//.test(p))return p.substr(7);return p}static startsWith(n,p){return n.length>=p.length&&n.substr(0,p.length)===p}static endsWith(n,p){return n.length>=p.length&&n.substr(n.length-p.length)===p}static containsQueryString(n){return/^[^\#]*\?/gi.test(n)}static isAbsolutePath(n){return/^((http:\/\/)|(https:\/\/)|(file:\/\/)|(\/))/.test(n)}static forEachProperty(n,p){if(n){let g;for(g in n)n.hasOwnProperty(g)&&p(g,n[g])}}static isEmpty(n){let p=!0;return i.forEachProperty(n,()=>{p=!1}),p}static recursiveClone(n){if(!n||typeof n!="object"||n instanceof RegExp||!Array.isArray(n)&&Object.getPrototypeOf(n)!==Object.prototype)return n;let p=Array.isArray(n)?[]:{};return i.forEachProperty(n,(g,E)=>{E&&typeof E=="object"?p[g]=i.recursiveClone(E):p[g]=E}),p}static generateAnonymousModule(){return"===anonymous"+i.NEXT_ANONYMOUS_ID+++"==="}static isAnonymousModule(n){return i.startsWith(n,"===anonymous")}static getHighPerformanceTimestamp(){return this.PERFORMANCE_NOW_PROBED||(this.PERFORMANCE_NOW_PROBED=!0,this.HAS_PERFORMANCE_NOW=x.global.performance&&typeof x.global.performance.now=="function"),this.HAS_PERFORMANCE_NOW?x.global.performance.now():Date.now()}}i.NEXT_ANONYMOUS_ID=1,i.PERFORMANCE_NOW_PROBED=!1,i.HAS_PERFORMANCE_NOW=!1,x.Utilities=i})(Le||(Le={}));var Le;(function(x){function i(p){if(p instanceof Error)return p;const g=new Error(p.message||String(p)||"Unknown Error");return p.stack&&(g.stack=p.stack),g}x.ensureError=i;class t{static validateConfigurationOptions(g){function E(d){if(d.phase==="loading"){console.error('Loading "'+d.moduleId+'" failed'),console.error(d),console.error("Here are the modules that depend on it:"),console.error(d.neededBy);return}if(d.phase==="factory"){console.error('The factory function of "'+d.moduleId+'" has thrown an exception'),console.error(d),console.error("Here are the modules that depend on it:"),console.error(d.neededBy);return}}if(g=g||{},typeof g.baseUrl!="string"&&(g.baseUrl=""),typeof g.isBuild!="boolean"&&(g.isBuild=!1),typeof g.paths!="object"&&(g.paths={}),typeof g.config!="object"&&(g.config={}),typeof g.catchError>"u"&&(g.catchError=!1),typeof g.recordStats>"u"&&(g.recordStats=!1),typeof g.urlArgs!="string"&&(g.urlArgs=""),typeof g.onError!="function"&&(g.onError=E),Array.isArray(g.ignoreDuplicateModules)||(g.ignoreDuplicateModules=[]),g.baseUrl.length>0&&(x.Utilities.endsWith(g.baseUrl,"/")||(g.baseUrl+="/")),typeof g.cspNonce!="string"&&(g.cspNonce=""),typeof g.preferScriptTags>"u"&&(g.preferScriptTags=!1),g.nodeCachedData&&typeof g.nodeCachedData=="object"&&(typeof g.nodeCachedData.seed!="string"&&(g.nodeCachedData.seed="seed"),(typeof g.nodeCachedData.writeDelay!="number"||g.nodeCachedData.writeDelay<0)&&(g.nodeCachedData.writeDelay=1e3*7),!g.nodeCachedData.path||typeof g.nodeCachedData.path!="string")){const d=i(new Error("INVALID cached data configuration, 'path' MUST be set"));d.phase="configuration",g.onError(d),g.nodeCachedData=void 0}return g}static mergeConfigurationOptions(g=null,E=null){let d=x.Utilities.recursiveClone(E||{});return x.Utilities.forEachProperty(g,(a,l)=>{a==="ignoreDuplicateModules"&&typeof d.ignoreDuplicateModules<"u"?d.ignoreDuplicateModules=d.ignoreDuplicateModules.concat(l):a==="paths"&&typeof d.paths<"u"?x.Utilities.forEachProperty(l,(c,$)=>d.paths[c]=$):a==="config"&&typeof d.config<"u"?x.Utilities.forEachProperty(l,(c,$)=>d.config[c]=$):d[a]=x.Utilities.recursiveClone(l)}),t.validateConfigurationOptions(d)}}x.ConfigurationOptionsUtil=t;class n{constructor(g,E){if(this._env=g,this.options=t.mergeConfigurationOptions(E),this._createIgnoreDuplicateModulesMap(),this._createSortedPathsRules(),this.options.baseUrl===""&&this.options.nodeRequire&&this.options.nodeRequire.main&&this.options.nodeRequire.main.filename&&this._env.isNode){let d=this.options.nodeRequire.main.filename,a=Math.max(d.lastIndexOf("/"),d.lastIndexOf("\\"));this.options.baseUrl=d.substring(0,a+1)}}_createIgnoreDuplicateModulesMap(){this.ignoreDuplicateModulesMap={};for(let g=0;g<this.options.ignoreDuplicateModules.length;g++)this.ignoreDuplicateModulesMap[this.options.ignoreDuplicateModules[g]]=!0}_createSortedPathsRules(){this.sortedPathsRules=[],x.Utilities.forEachProperty(this.options.paths,(g,E)=>{Array.isArray(E)?this.sortedPathsRules.push({from:g,to:E}):this.sortedPathsRules.push({from:g,to:[E]})}),this.sortedPathsRules.sort((g,E)=>E.from.length-g.from.length)}cloneAndMerge(g){return new n(this._env,t.mergeConfigurationOptions(g,this.options))}getOptionsLiteral(){return this.options}_applyPaths(g){let E;for(let d=0,a=this.sortedPathsRules.length;d<a;d++)if(E=this.sortedPathsRules[d],x.Utilities.startsWith(g,E.from)){let l=[];for(let c=0,$=E.to.length;c<$;c++)l.push(E.to[c]+g.substr(E.from.length));return l}return[g]}_addUrlArgsToUrl(g){return x.Utilities.containsQueryString(g)?g+"&"+this.options.urlArgs:g+"?"+this.options.urlArgs}_addUrlArgsIfNecessaryToUrl(g){return this.options.urlArgs?this._addUrlArgsToUrl(g):g}_addUrlArgsIfNecessaryToUrls(g){if(this.options.urlArgs)for(let E=0,d=g.length;E<d;E++)g[E]=this._addUrlArgsToUrl(g[E]);return g}moduleIdToPaths(g){if(this._env.isNode&&this.options.amdModulesPattern instanceof RegExp&&!this.options.amdModulesPattern.test(g))return this.isBuild()?["empty:"]:["node|"+g];let E=g,d;if(!x.Utilities.endsWith(E,".js")&&!x.Utilities.isAbsolutePath(E)){d=this._applyPaths(E);for(let a=0,l=d.length;a<l;a++)this.isBuild()&&d[a]==="empty:"||(x.Utilities.isAbsolutePath(d[a])||(d[a]=this.options.baseUrl+d[a]),!x.Utilities.endsWith(d[a],".js")&&!x.Utilities.containsQueryString(d[a])&&(d[a]=d[a]+".js"))}else!x.Utilities.endsWith(E,".js")&&!x.Utilities.containsQueryString(E)&&(E=E+".js"),d=[E];return this._addUrlArgsIfNecessaryToUrls(d)}requireToUrl(g){let E=g;return x.Utilities.isAbsolutePath(E)||(E=this._applyPaths(E)[0],x.Utilities.isAbsolutePath(E)||(E=this.options.baseUrl+E)),this._addUrlArgsIfNecessaryToUrl(E)}isBuild(){return this.options.isBuild}shouldInvokeFactory(g){return!!(!this.options.isBuild||x.Utilities.isAnonymousModule(g)||this.options.buildForceInvokeFactory&&this.options.buildForceInvokeFactory[g])}isDuplicateMessageIgnoredFor(g){return this.ignoreDuplicateModulesMap.hasOwnProperty(g)}getConfigForModule(g){if(this.options.config)return this.options.config[g]}shouldCatchError(){return this.options.catchError}shouldRecordStats(){return this.options.recordStats}onError(g){this.options.onError(g)}}x.Configuration=n})(Le||(Le={}));var Le;(function(x){class i{constructor(l){this._env=l,this._scriptLoader=null,this._callbackMap={}}load(l,c,$,m){if(!this._scriptLoader)if(this._env.isWebWorker)this._scriptLoader=new p;else if(this._env.isElectronRenderer){const{preferScriptTags:e}=l.getConfig().getOptionsLiteral();e?this._scriptLoader=new t:this._scriptLoader=new g(this._env)}else this._env.isNode?this._scriptLoader=new g(this._env):this._scriptLoader=new t;let L={callback:$,errorback:m};if(this._callbackMap.hasOwnProperty(c)){this._callbackMap[c].push(L);return}this._callbackMap[c]=[L],this._scriptLoader.load(l,c,()=>this.triggerCallback(c),e=>this.triggerErrorback(c,e))}triggerCallback(l){let c=this._callbackMap[l];delete this._callbackMap[l];for(let $=0;$<c.length;$++)c[$].callback()}triggerErrorback(l,c){let $=this._callbackMap[l];delete this._callbackMap[l];for(let m=0;m<$.length;m++)$[m].errorback(c)}}class t{attachListeners(l,c,$){let m=()=>{l.removeEventListener("load",L),l.removeEventListener("error",e)},L=b=>{m(),c()},e=b=>{m(),$(b)};l.addEventListener("load",L),l.addEventListener("error",e)}load(l,c,$,m){if(/^node\|/.test(c)){let L=l.getConfig().getOptionsLiteral(),e=E(l.getRecorder(),L.nodeRequire||x.global.nodeRequire),b=c.split("|"),N=null;try{N=e(b[1])}catch(R){m(R);return}l.enqueueDefineAnonymousModule([],()=>N),$()}else{let L=document.createElement("script");L.setAttribute("async","async"),L.setAttribute("type","text/javascript"),this.attachListeners(L,$,m);const{trustedTypesPolicy:e}=l.getConfig().getOptionsLiteral();e&&(c=e.createScriptURL(c)),L.setAttribute("src",c);const{cspNonce:b}=l.getConfig().getOptionsLiteral();b&&L.setAttribute("nonce",b),document.getElementsByTagName("head")[0].appendChild(L)}}}function n(a){const{trustedTypesPolicy:l}=a.getConfig().getOptionsLiteral();try{return(l?self.eval(l.createScript("","true")):new Function("true")).call(self),!0}catch{return!1}}class p{constructor(){this._cachedCanUseEval=null}_canUseEval(l){return this._cachedCanUseEval===null&&(this._cachedCanUseEval=n(l)),this._cachedCanUseEval}load(l,c,$,m){if(/^node\|/.test(c)){const L=l.getConfig().getOptionsLiteral(),e=E(l.getRecorder(),L.nodeRequire||x.global.nodeRequire),b=c.split("|");let N=null;try{N=e(b[1])}catch(R){m(R);return}l.enqueueDefineAnonymousModule([],function(){return N}),$()}else{const{trustedTypesPolicy:L}=l.getConfig().getOptionsLiteral();if(!(/^((http:)|(https:)|(file:))/.test(c)&&c.substring(0,self.origin.length)!==self.origin)&&this._canUseEval(l)){fetch(c).then(b=>{if(b.status!==200)throw new Error(b.statusText);return b.text()}).then(b=>{b=`${b}
//# sourceURL=${c}`,(L?self.eval(L.createScript("",b)):new Function(b)).call(self),$()}).then(void 0,m);return}try{L&&(c=L.createScriptURL(c)),importScripts(c),$()}catch(b){m(b)}}}}class g{constructor(l){this._env=l,this._didInitialize=!1,this._didPatchNodeRequire=!1}_init(l){this._didInitialize||(this._didInitialize=!0,this._fs=l("fs"),this._vm=l("vm"),this._path=l("path"),this._crypto=l("crypto"))}_initNodeRequire(l,c){const{nodeCachedData:$}=c.getConfig().getOptionsLiteral();if(!$||this._didPatchNodeRequire)return;this._didPatchNodeRequire=!0;const m=this,L=l("module");function e(b){const N=b.constructor;let R=function(w){try{return b.require(w)}finally{}};return R.resolve=function(w,v){return N._resolveFilename(w,b,!1,v)},R.resolve.paths=function(w){return N._resolveLookupPaths(w,b)},R.main=process.mainModule,R.extensions=N._extensions,R.cache=N._cache,R}L.prototype._compile=function(b,N){const R=L.wrap(b.replace(/^#!.*/,"")),A=c.getRecorder(),w=m._getCachedDataPath($,N),v={filename:N};let h;try{const M=m._fs.readFileSync(w);h=M.slice(0,16),v.cachedData=M.slice(16),A.record(60,w)}catch{A.record(61,w)}const u=new m._vm.Script(R,v),r=u.runInThisContext(v),o=m._path.dirname(N),f=e(this),T=[this.exports,f,this,N,o,process,Qe,Buffer],_=r.apply(this.exports,T);return m._handleCachedData(u,R,w,!v.cachedData,c),m._verifyCachedData(u,R,w,h,c),_}}load(l,c,$,m){const L=l.getConfig().getOptionsLiteral(),e=E(l.getRecorder(),L.nodeRequire||x.global.nodeRequire),b=L.nodeInstrumenter||function(R){return R};this._init(e),this._initNodeRequire(e,l);let N=l.getRecorder();if(/^node\|/.test(c)){let R=c.split("|"),A=null;try{A=e(R[1])}catch(w){m(w);return}l.enqueueDefineAnonymousModule([],()=>A),$()}else{c=x.Utilities.fileUriToFilePath(this._env.isWindows,c);const R=this._path.normalize(c),A=this._getElectronRendererScriptPathOrUri(R),w=!!L.nodeCachedData,v=w?this._getCachedDataPath(L.nodeCachedData,c):void 0;this._readSourceAndCachedData(R,v,N,(h,u,r,o)=>{if(h){m(h);return}let f;u.charCodeAt(0)===g._BOM?f=g._PREFIX+u.substring(1)+g._SUFFIX:f=g._PREFIX+u+g._SUFFIX,f=b(f,R);const T={filename:A,cachedData:r},_=this._createAndEvalScript(l,f,T,$,m);this._handleCachedData(_,f,v,w&&!r,l),this._verifyCachedData(_,f,v,o,l)})}}_createAndEvalScript(l,c,$,m,L){const e=l.getRecorder();e.record(31,$.filename);const b=new this._vm.Script(c,$),N=b.runInThisContext($),R=l.getGlobalAMDDefineFunc();let A=!1;const w=function(){return A=!0,R.apply(null,arguments)};return w.amd=R.amd,N.call(x.global,l.getGlobalAMDRequireFunc(),w,$.filename,this._path.dirname($.filename)),e.record(32,$.filename),A?m():L(new Error(`Didn't receive define call in ${$.filename}!`)),b}_getElectronRendererScriptPathOrUri(l){if(!this._env.isElectronRenderer)return l;let c=l.match(/^([a-z])\:(.*)/i);return c?`file:///${(c[1].toUpperCase()+":"+c[2]).replace(/\\/g,"/")}`:`file://${l}`}_getCachedDataPath(l,c){const $=this._crypto.createHash("md5").update(c,"utf8").update(l.seed,"utf8").update(process.arch,"").digest("hex"),m=this._path.basename(c).replace(/\.js$/,"");return this._path.join(l.path,`${m}-${$}.code`)}_handleCachedData(l,c,$,m,L){l.cachedDataRejected?this._fs.unlink($,e=>{L.getRecorder().record(62,$),this._createAndWriteCachedData(l,c,$,L),e&&L.getConfig().onError(e)}):m&&this._createAndWriteCachedData(l,c,$,L)}_createAndWriteCachedData(l,c,$,m){let L=Math.ceil(m.getConfig().getOptionsLiteral().nodeCachedData.writeDelay*(1+Math.random())),e=-1,b=0,N;const R=()=>{setTimeout(()=>{N||(N=this._crypto.createHash("md5").update(c,"utf8").digest());const A=l.createCachedData();if(!(A.length===0||A.length===e||b>=5)){if(A.length<e){R();return}e=A.length,this._fs.writeFile($,Buffer.concat([N,A]),w=>{w&&m.getConfig().onError(w),m.getRecorder().record(63,$),R()})}},L*Math.pow(4,b++))};R()}_readSourceAndCachedData(l,c,$,m){if(!c)this._fs.readFile(l,{encoding:"utf8"},m);else{let L,e,b,N=2;const R=A=>{A?m(A):--N===0&&m(void 0,L,e,b)};this._fs.readFile(l,{encoding:"utf8"},(A,w)=>{L=w,R(A)}),this._fs.readFile(c,(A,w)=>{!A&&w&&w.length>0?(b=w.slice(0,16),e=w.slice(16),$.record(60,c)):$.record(61,c),R()})}}_verifyCachedData(l,c,$,m,L){m&&(l.cachedDataRejected||setTimeout(()=>{const e=this._crypto.createHash("md5").update(c,"utf8").digest();m.equals(e)||(L.getConfig().onError(new Error(`FAILED TO VERIFY CACHED DATA, deleting stale '${$}' now, but a RESTART IS REQUIRED`)),this._fs.unlink($,b=>{b&&L.getConfig().onError(b)}))},Math.ceil(5e3*(1+Math.random()))))}}g._BOM=65279,g._PREFIX="(function (require, define, __filename, __dirname) { ",g._SUFFIX=`
});`;function E(a,l){if(l.__$__isRecorded)return l;const c=function(m){a.record(33,m);try{return l(m)}finally{a.record(34,m)}};return c.__$__isRecorded=!0,c}x.ensureRecordedNodeRequire=E;function d(a){return new i(a)}x.createScriptLoader=d})(Le||(Le={}));var Le;(function(x){class i{constructor(a){let l=a.lastIndexOf("/");l!==-1?this.fromModulePath=a.substr(0,l+1):this.fromModulePath=""}static _normalizeModuleId(a){let l=a,c;for(c=/\/\.\//;c.test(l);)l=l.replace(c,"/");for(l=l.replace(/^\.\//g,""),c=/\/(([^\/])|([^\/][^\/\.])|([^\/\.][^\/])|([^\/][^\/][^\/]+))\/\.\.\//;c.test(l);)l=l.replace(c,"/");return l=l.replace(/^(([^\/])|([^\/][^\/\.])|([^\/\.][^\/])|([^\/][^\/][^\/]+))\/\.\.\//,""),l}resolveModule(a){let l=a;return x.Utilities.isAbsolutePath(l)||(x.Utilities.startsWith(l,"./")||x.Utilities.startsWith(l,"../"))&&(l=i._normalizeModuleId(this.fromModulePath+l)),l}}i.ROOT=new i(""),x.ModuleIdResolver=i;class t{constructor(a,l,c,$,m,L){this.id=a,this.strId=l,this.dependencies=c,this._callback=$,this._errorback=m,this.moduleIdResolver=L,this.exports={},this.error=null,this.exportsPassedIn=!1,this.unresolvedDependenciesCount=this.dependencies.length,this._isComplete=!1}static _safeInvokeFunction(a,l){try{return{returnedValue:a.apply(x.global,l),producedError:null}}catch(c){return{returnedValue:null,producedError:c}}}static _invokeFactory(a,l,c,$){return a.shouldInvokeFactory(l)?a.shouldCatchError()?this._safeInvokeFunction(c,$):{returnedValue:c.apply(x.global,$),producedError:null}:{returnedValue:null,producedError:null}}complete(a,l,c,$){this._isComplete=!0;let m=null;if(this._callback)if(typeof this._callback=="function"){a.record(21,this.strId);let L=t._invokeFactory(l,this.strId,this._callback,c);m=L.producedError,a.record(22,this.strId),!m&&typeof L.returnedValue<"u"&&(!this.exportsPassedIn||x.Utilities.isEmpty(this.exports))&&(this.exports=L.returnedValue)}else this.exports=this._callback;if(m){let L=x.ensureError(m);L.phase="factory",L.moduleId=this.strId,L.neededBy=$(this.id),this.error=L,l.onError(L)}this.dependencies=null,this._callback=null,this._errorback=null,this.moduleIdResolver=null}onDependencyError(a){return this._isComplete=!0,this.error=a,this._errorback?(this._errorback(a),!0):!1}isComplete(){return this._isComplete}}x.Module=t;class n{constructor(){this._nextId=0,this._strModuleIdToIntModuleId=new Map,this._intModuleIdToStrModuleId=[],this.getModuleId("exports"),this.getModuleId("module"),this.getModuleId("require")}getMaxModuleId(){return this._nextId}getModuleId(a){let l=this._strModuleIdToIntModuleId.get(a);return typeof l>"u"&&(l=this._nextId++,this._strModuleIdToIntModuleId.set(a,l),this._intModuleIdToStrModuleId[l]=a),l}getStrModuleId(a){return this._intModuleIdToStrModuleId[a]}}class p{constructor(a){this.id=a}}p.EXPORTS=new p(0),p.MODULE=new p(1),p.REQUIRE=new p(2),x.RegularDependency=p;class g{constructor(a,l,c){this.id=a,this.pluginId=l,this.pluginParam=c}}x.PluginDependency=g;class E{constructor(a,l,c,$,m=0){this._env=a,this._scriptLoader=l,this._loaderAvailableTimestamp=m,this._defineFunc=c,this._requireFunc=$,this._moduleIdProvider=new n,this._config=new x.Configuration(this._env),this._hasDependencyCycle=!1,this._modules2=[],this._knownModules2=[],this._inverseDependencies2=[],this._inversePluginDependencies2=new Map,this._currentAnonymousDefineCall=null,this._recorder=null,this._buildInfoPath=[],this._buildInfoDefineStack=[],this._buildInfoDependencies=[],this._requireFunc.moduleManager=this}reset(){return new E(this._env,this._scriptLoader,this._defineFunc,this._requireFunc,this._loaderAvailableTimestamp)}getGlobalAMDDefineFunc(){return this._defineFunc}getGlobalAMDRequireFunc(){return this._requireFunc}static _findRelevantLocationInStack(a,l){let c=L=>L.replace(/\\/g,"/"),$=c(a),m=l.split(/\n/);for(let L=0;L<m.length;L++){let e=m[L].match(/(.*):(\d+):(\d+)\)?$/);if(e){let b=e[1],N=e[2],R=e[3],A=Math.max(b.lastIndexOf(" ")+1,b.lastIndexOf("(")+1);if(b=b.substr(A),b=c(b),b===$){let w={line:parseInt(N,10),col:parseInt(R,10)};return w.line===1&&(w.col-=53),w}}}throw new Error("Could not correlate define call site for needle "+a)}getBuildInfo(){if(!this._config.isBuild())return null;let a=[],l=0;for(let c=0,$=this._modules2.length;c<$;c++){let m=this._modules2[c];if(!m)continue;let L=this._buildInfoPath[m.id]||null,e=this._buildInfoDefineStack[m.id]||null,b=this._buildInfoDependencies[m.id];a[l++]={id:m.strId,path:L,defineLocation:L&&e?E._findRelevantLocationInStack(L,e):null,dependencies:b,shim:null,exports:m.exports}}return a}getRecorder(){return this._recorder||(this._config.shouldRecordStats()?this._recorder=new x.LoaderEventRecorder(this._loaderAvailableTimestamp):this._recorder=x.NullLoaderEventRecorder.INSTANCE),this._recorder}getLoaderEvents(){return this.getRecorder().getEvents()}enqueueDefineAnonymousModule(a,l){if(this._currentAnonymousDefineCall!==null)throw new Error("Can only have one anonymous define call per script file");let c=null;this._config.isBuild()&&(c=new Error("StackLocation").stack||null),this._currentAnonymousDefineCall={stack:c,dependencies:a,callback:l}}defineModule(a,l,c,$,m,L=new i(a)){let e=this._moduleIdProvider.getModuleId(a);if(this._modules2[e]){this._config.isDuplicateMessageIgnoredFor(a)||console.warn("Duplicate definition of module '"+a+"'");return}let b=new t(e,a,this._normalizeDependencies(l,L),c,$,L);this._modules2[e]=b,this._config.isBuild()&&(this._buildInfoDefineStack[e]=m,this._buildInfoDependencies[e]=(b.dependencies||[]).map(N=>this._moduleIdProvider.getStrModuleId(N.id))),this._resolve(b)}_normalizeDependency(a,l){if(a==="exports")return p.EXPORTS;if(a==="module")return p.MODULE;if(a==="require")return p.REQUIRE;let c=a.indexOf("!");if(c>=0){let $=l.resolveModule(a.substr(0,c)),m=l.resolveModule(a.substr(c+1)),L=this._moduleIdProvider.getModuleId($+"!"+m),e=this._moduleIdProvider.getModuleId($);return new g(L,e,m)}return new p(this._moduleIdProvider.getModuleId(l.resolveModule(a)))}_normalizeDependencies(a,l){let c=[],$=0;for(let m=0,L=a.length;m<L;m++)c[$++]=this._normalizeDependency(a[m],l);return c}_relativeRequire(a,l,c,$){if(typeof l=="string")return this.synchronousRequire(l,a);this.defineModule(x.Utilities.generateAnonymousModule(),l,c,$,null,a)}synchronousRequire(a,l=new i(a)){let c=this._normalizeDependency(a,l),$=this._modules2[c.id];if(!$)throw new Error("Check dependency list! Synchronous require cannot resolve module '"+a+"'. This is the first mention of this module!");if(!$.isComplete())throw new Error("Check dependency list! Synchronous require cannot resolve module '"+a+"'. This module has not been resolved completely yet.");if($.error)throw $.error;return $.exports}configure(a,l){let c=this._config.shouldRecordStats();l?this._config=new x.Configuration(this._env,a):this._config=this._config.cloneAndMerge(a),this._config.shouldRecordStats()&&!c&&(this._recorder=null)}getConfig(){return this._config}_onLoad(a){if(this._currentAnonymousDefineCall!==null){let l=this._currentAnonymousDefineCall;this._currentAnonymousDefineCall=null,this.defineModule(this._moduleIdProvider.getStrModuleId(a),l.dependencies,l.callback,null,l.stack)}}_createLoadError(a,l){let c=this._moduleIdProvider.getStrModuleId(a),$=(this._inverseDependencies2[a]||[]).map(L=>this._moduleIdProvider.getStrModuleId(L));const m=x.ensureError(l);return m.phase="loading",m.moduleId=c,m.neededBy=$,m}_onLoadError(a,l){const c=this._createLoadError(a,l);this._modules2[a]||(this._modules2[a]=new t(a,this._moduleIdProvider.getStrModuleId(a),[],()=>{},null,null));let $=[];for(let e=0,b=this._moduleIdProvider.getMaxModuleId();e<b;e++)$[e]=!1;let m=!1,L=[];for(L.push(a),$[a]=!0;L.length>0;){let e=L.shift(),b=this._modules2[e];b&&(m=b.onDependencyError(c)||m);let N=this._inverseDependencies2[e];if(N)for(let R=0,A=N.length;R<A;R++){let w=N[R];$[w]||(L.push(w),$[w]=!0)}}m||this._config.onError(c)}_hasDependencyPath(a,l){let c=this._modules2[a];if(!c)return!1;let $=[];for(let L=0,e=this._moduleIdProvider.getMaxModuleId();L<e;L++)$[L]=!1;let m=[];for(m.push(c),$[a]=!0;m.length>0;){let e=m.shift().dependencies;if(e)for(let b=0,N=e.length;b<N;b++){let R=e[b];if(R.id===l)return!0;let A=this._modules2[R.id];A&&!$[R.id]&&($[R.id]=!0,m.push(A))}}return!1}_findCyclePath(a,l,c){if(a===l||c===50)return[a];let $=this._modules2[a];if(!$)return null;let m=$.dependencies;if(m)for(let L=0,e=m.length;L<e;L++){let b=this._findCyclePath(m[L].id,l,c+1);if(b!==null)return b.push(a),b}return null}_createRequire(a){let l=(c,$,m)=>this._relativeRequire(a,c,$,m);return l.toUrl=c=>this._config.requireToUrl(a.resolveModule(c)),l.getStats=()=>this.getLoaderEvents(),l.hasDependencyCycle=()=>this._hasDependencyCycle,l.config=(c,$=!1)=>{this.configure(c,$)},l.__$__nodeRequire=x.global.nodeRequire,l}_loadModule(a){if(this._modules2[a]||this._knownModules2[a])return;this._knownModules2[a]=!0;let l=this._moduleIdProvider.getStrModuleId(a),c=this._config.moduleIdToPaths(l),$=/^@[^\/]+\/[^\/]+$/;this._env.isNode&&(l.indexOf("/")===-1||$.test(l))&&c.push("node|"+l);let m=-1,L=e=>{if(m++,m>=c.length)this._onLoadError(a,e);else{let b=c[m],N=this.getRecorder();if(this._config.isBuild()&&b==="empty:"){this._buildInfoPath[a]=b,this.defineModule(this._moduleIdProvider.getStrModuleId(a),[],null,null,null),this._onLoad(a);return}N.record(10,b),this._scriptLoader.load(this,b,()=>{this._config.isBuild()&&(this._buildInfoPath[a]=b),N.record(11,b),this._onLoad(a)},R=>{N.record(12,b),L(R)})}};L(null)}_loadPluginDependency(a,l){if(this._modules2[l.id]||this._knownModules2[l.id])return;this._knownModules2[l.id]=!0;let c=$=>{this.defineModule(this._moduleIdProvider.getStrModuleId(l.id),[],$,null,null)};c.error=$=>{this._config.onError(this._createLoadError(l.id,$))},a.load(l.pluginParam,this._createRequire(i.ROOT),c,this._config.getOptionsLiteral())}_resolve(a){let l=a.dependencies;if(l)for(let c=0,$=l.length;c<$;c++){let m=l[c];if(m===p.EXPORTS){a.exportsPassedIn=!0,a.unresolvedDependenciesCount--;continue}if(m===p.MODULE){a.unresolvedDependenciesCount--;continue}if(m===p.REQUIRE){a.unresolvedDependenciesCount--;continue}let L=this._modules2[m.id];if(L&&L.isComplete()){if(L.error){a.onDependencyError(L.error);return}a.unresolvedDependenciesCount--;continue}if(this._hasDependencyPath(m.id,a.id)){this._hasDependencyCycle=!0,console.warn("There is a dependency cycle between '"+this._moduleIdProvider.getStrModuleId(m.id)+"' and '"+this._moduleIdProvider.getStrModuleId(a.id)+"'. The cyclic path follows:");let e=this._findCyclePath(m.id,a.id,0)||[];e.reverse(),e.push(m.id),console.warn(e.map(b=>this._moduleIdProvider.getStrModuleId(b)).join(` => 
`)),a.unresolvedDependenciesCount--;continue}if(this._inverseDependencies2[m.id]=this._inverseDependencies2[m.id]||[],this._inverseDependencies2[m.id].push(a.id),m instanceof g){let e=this._modules2[m.pluginId];if(e&&e.isComplete()){this._loadPluginDependency(e.exports,m);continue}let b=this._inversePluginDependencies2.get(m.pluginId);b||(b=[],this._inversePluginDependencies2.set(m.pluginId,b)),b.push(m),this._loadModule(m.pluginId);continue}this._loadModule(m.id)}a.unresolvedDependenciesCount===0&&this._onModuleComplete(a)}_onModuleComplete(a){let l=this.getRecorder();if(a.isComplete())return;let c=a.dependencies,$=[];if(c)for(let b=0,N=c.length;b<N;b++){let R=c[b];if(R===p.EXPORTS){$[b]=a.exports;continue}if(R===p.MODULE){$[b]={id:a.strId,config:()=>this._config.getConfigForModule(a.strId)};continue}if(R===p.REQUIRE){$[b]=this._createRequire(a.moduleIdResolver);continue}let A=this._modules2[R.id];if(A){$[b]=A.exports;continue}$[b]=null}const m=b=>(this._inverseDependencies2[b]||[]).map(N=>this._moduleIdProvider.getStrModuleId(N));a.complete(l,this._config,$,m);let L=this._inverseDependencies2[a.id];if(this._inverseDependencies2[a.id]=null,L)for(let b=0,N=L.length;b<N;b++){let R=L[b],A=this._modules2[R];A.unresolvedDependenciesCount--,A.unresolvedDependenciesCount===0&&this._onModuleComplete(A)}let e=this._inversePluginDependencies2.get(a.id);if(e){this._inversePluginDependencies2.delete(a.id);for(let b=0,N=e.length;b<N;b++)this._loadPluginDependency(a.exports,e[b])}}}x.ModuleManager=E})(Le||(Le={}));var ne,Le;(function(x){const i=new x.Environment;let t=null;const n=function(d,a,l){typeof d!="string"&&(l=a,a=d,d=null),(typeof a!="object"||!Array.isArray(a))&&(l=a,a=null),a||(a=["require","exports","module"]),d?t.defineModule(d,a,l,null,null):t.enqueueDefineAnonymousModule(a,l)};n.amd={jQuery:!0};const p=function(d,a=!1){t.configure(d,a)},g=function(){if(arguments.length===1){if(arguments[0]instanceof Object&&!Array.isArray(arguments[0])){p(arguments[0]);return}if(typeof arguments[0]=="string")return t.synchronousRequire(arguments[0])}if((arguments.length===2||arguments.length===3)&&Array.isArray(arguments[0])){t.defineModule(x.Utilities.generateAnonymousModule(),arguments[0],arguments[1],arguments[2],null);return}throw new Error("Unrecognized require call")};g.config=p,g.getConfig=function(){return t.getConfig().getOptionsLiteral()},g.reset=function(){t=t.reset()},g.getBuildInfo=function(){return t.getBuildInfo()},g.getStats=function(){return t.getLoaderEvents()},g.define=n;function E(){if(typeof x.global.require<"u"||typeof require<"u"){const d=x.global.require||require;if(typeof d=="function"&&typeof d.resolve=="function"){const a=x.ensureRecordedNodeRequire(t.getRecorder(),d);x.global.nodeRequire=a,g.nodeRequire=a,g.__$__nodeRequire=a}}i.isNode&&!i.isElectronRenderer&&!i.isElectronNodeIntegrationWebWorker?module.exports=g:(i.isElectronRenderer||(x.global.define=n),x.global.require=g)}x.init=E,(typeof x.global.define!="function"||!x.global.define.amd)&&(t=new x.ModuleManager(i,x.createScriptLoader(i),n,g,x.Utilities.getHighPerformanceTimestamp()),typeof x.global.require<"u"&&typeof x.global.require!="function"&&g.config(x.global.require),ne=function(){return n.apply(null,arguments)},ne.amd=n.amd,typeof doNotInitLoader>"u"&&E())})(Le||(Le={})),ne(ie[78],re([0,1]),function(x,i){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.load=t;function t(d,a,l,c){if(c=c||{},(c["vs/css"]||{}).disabled){l({});return}const m=a.toUrl(d+".css");n(d,m,()=>{l({})},L=>{typeof l.error=="function"&&l.error("Could not find "+m+".")})}function n(d,a,l,c){if(p(d,a)){l();return}g(d,a,l,c)}function p(d,a){const l=window.document.getElementsByTagName("link");for(let c=0,$=l.length;c<$;c++){const m=l[c].getAttribute("data-name"),L=l[c].getAttribute("href");if(m===d||L===a)return!0}return!1}function g(d,a,l,c){const $=document.createElement("link");$.setAttribute("rel","stylesheet"),$.setAttribute("type","text/css"),$.setAttribute("data-name",d),E(d,$,l,c),$.setAttribute("href",a),(window.document.head||window.document.getElementsByTagName("head")[0]).appendChild($)}function E(d,a,l,c){const $=()=>{a.removeEventListener("load",m),a.removeEventListener("error",L)},m=e=>{$(),l()},L=e=>{$(),c(e)};a.addEventListener("load",m),a.addEventListener("error",L)}}),ne("vs/nls",["require","exports"],function(x,i){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.localize=c,i.localize2=$,i.getConfiguredDefaultLocale=m,i.setPseudoTranslation=L,i.create=e,i.load=b;let t=typeof document<"u"&&document.location&&document.location.hash.indexOf("pseudo=true")>=0;const n="i-default";function p(N,R){let A;return R.length===0?A=N:A=N.replace(/\{(\d+)\}/g,(w,v)=>{const h=v[0],u=R[h];let r=w;return typeof u=="string"?r=u:(typeof u=="number"||typeof u=="boolean"||u===void 0||u===null)&&(r=String(u)),r}),t&&(A="\uFF3B"+A.replace(/[aouei]/g,"$&$&")+"\uFF3D"),A}function g(N,R){let A=N[R];return A||(A=N["*"],A)?A:null}function E(N){return N.charAt(N.length-1)==="/"?N:N+"/"}async function d(N,R,A){const w=E(N)+E(R)+"vscode/"+E(A),v=await fetch(w);if(v.ok)return await v.json();throw new Error(`${v.status} - ${v.statusText}`)}function a(N){return function(R,A){const w=Array.prototype.slice.call(arguments,2);return p(N[R],w)}}function l(N){return(R,A,...w)=>({value:p(N[R],w),original:p(A,w)})}function c(N,R,...A){return p(R,A)}function $(N,R,...A){const w=p(R,A);return{value:w,original:w}}function m(N){}function L(N){t=N}function e(N,R){return{localize:a(R[N]),localize2:l(R[N]),getConfiguredDefaultLocale:R.getConfiguredDefaultLocale??(A=>{})}}function b(N,R,A,w){const v=w["vs/nls"]??{};if(!N||N.length===0)return A({localize:c,localize2:$,getConfiguredDefaultLocale:()=>v.availableLanguages?.["*"]});const h=v.availableLanguages?g(v.availableLanguages,N):null,u=h===null||h===n;let r=".nls";u||(r=r+"."+h);const o=f=>{Array.isArray(f)?(f.localize=a(f),f.localize2=l(f)):(f.localize=a(f[N]),f.localize2=l(f[N])),f.getConfiguredDefaultLocale=()=>v.availableLanguages?.["*"],A(f)};typeof v.loadBundle=="function"?v.loadBundle(N,h,(f,T)=>{f?R([N+".nls"],o):o(T)}):v.translationServiceUrl&&!u?(async()=>{try{const f=await d(v.translationServiceUrl,h,N);return o(f)}catch(f){if(!h.includes("-"))return console.error(f),R([N+".nls"],o);try{const T=h.split("-")[0],_=await d(v.translationServiceUrl,T,N);return v.availableLanguages??={},v.availableLanguages["*"]=T,o(_)}catch(T){return console.error(T),R([N+".nls"],o)}}})():R([N+r],o,f=>{if(r===".nls"){console.error("Failed trying to load default language strings",f);return}console.error(`Failed to load message bundle for language ${h}. Falling back to the default language:`,f),R([N+".nls"],o)})}}),function(){const x=globalThis.MonacoEnvironment,i=x&&x.baseUrl?x.baseUrl:"../../../";function t(c,$){if(x?.createTrustedTypesPolicy)try{return x.createTrustedTypesPolicy(c,$)}catch(m){console.warn(m);return}try{return self.trustedTypes?.createPolicy(c,$)}catch(m){console.warn(m);return}}const n=t("amdLoader",{createScriptURL:c=>c,createScript:(c,...$)=>{const m=$.slice(0,-1).join(","),L=$.pop().toString();return`(function anonymous(${m}) { ${L}
})`}});function p(){try{return(n?globalThis.eval(n.createScript("","true")):new Function("true")).call(globalThis),!0}catch{return!1}}function g(){return new Promise((c,$)=>{if(typeof globalThis.define=="function"&&globalThis.define.amd)return c();const m=i+"vs/loader.js";if(!(/^((http:)|(https:)|(file:))/.test(m)&&m.substring(0,globalThis.origin.length)!==globalThis.origin)&&p()){fetch(m).then(e=>{if(e.status!==200)throw new Error(e.statusText);return e.text()}).then(e=>{e=`${e}
//# sourceURL=${m}`,(n?globalThis.eval(n.createScript("",e)):new Function(e)).call(globalThis),c()}).then(void 0,$);return}n?importScripts(n.createScriptURL(m)):importScripts(m),c()})}function E(){require.config({baseUrl:i,catchError:!0,trustedTypesPolicy:n,amdModulesPattern:/^vs\//})}function d(c){g().then(()=>{E(),require([c],function($){setTimeout(function(){const m=$.create((L,e)=>{globalThis.postMessage(L,e)},null);for(globalThis.onmessage=L=>m.onmessage(L.data,L.ports);l.length>0;){const L=l.shift();m.onmessage(L.data,L.ports)}},0)})})}typeof globalThis.define=="function"&&globalThis.define.amd&&E();let a=!0;const l=[];globalThis.onmessage=c=>{if(!a){l.push(c);return}a=!1,d(c.data)}}(),ne(ie[9],re([0,1]),function(x,i){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.$pb=void 0,i.$ib=t,i.$jb=n,i.$kb=p,i.$lb=g,i.$mb=E,i.$nb=d,i.$ob=a,i.$qb=c,i.$rb=$,i.$sb=m,i.$tb=L,i.$ub=e;function t(b,N){const R=n(b,N);if(R!==-1)return b[R]}function n(b,N,R=b.length-1){for(let A=R;A>=0;A--){const w=b[A];if(N(w))return A}return-1}function p(b,N){const R=g(b,N);return R===-1?void 0:b[R]}function g(b,N,R=0,A=b.length){let w=R,v=A;for(;w<v;){const h=Math.floor((w+v)/2);N(b[h])?w=h+1:v=h}return w-1}function E(b,N){const R=d(b,N);return R===b.length?void 0:b[R]}function d(b,N,R=0,A=b.length){let w=R,v=A;for(;w<v;){const h=Math.floor((w+v)/2);N(b[h])?v=h:w=h+1}return w}function a(b,N,R=0,A=b.length){const w=d(b,N,R,A);return w===b.length?-1:w}class l{static{this.assertInvariants=!1}constructor(N){this.e=N,this.c=0}findLastMonotonous(N){if(l.assertInvariants){if(this.d){for(const A of this.e)if(this.d(A)&&!N(A))throw new Error("MonotonousArray: current predicate must be weaker than (or equal to) the previous predicate.")}this.d=N}const R=g(this.e,N,this.c);return this.c=R+1,R===-1?void 0:this.e[R]}}i.$pb=l;function c(b,N){if(b.length===0)return;let R=b[0];for(let A=1;A<b.length;A++){const w=b[A];N(w,R)>0&&(R=w)}return R}function $(b,N){if(b.length===0)return;let R=b[0];for(let A=1;A<b.length;A++){const w=b[A];N(w,R)>=0&&(R=w)}return R}function m(b,N){return c(b,(R,A)=>-N(R,A))}function L(b,N){if(b.length===0)return-1;let R=0;for(let A=1;A<b.length;A++){const w=b[A];N(w,b[R])>0&&(R=A)}return R}function e(b,N){for(const R of b){const A=N(R);if(A!==void 0)return A}}}),ne(ie[3],re([0,1]),function(x,i){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.CharCode=void 0;var t;(function(n){n[n.Null=0]="Null",n[n.Backspace=8]="Backspace",n[n.Tab=9]="Tab",n[n.LineFeed=10]="LineFeed",n[n.CarriageReturn=13]="CarriageReturn",n[n.Space=32]="Space",n[n.ExclamationMark=33]="ExclamationMark",n[n.DoubleQuote=34]="DoubleQuote",n[n.Hash=35]="Hash",n[n.DollarSign=36]="DollarSign",n[n.PercentSign=37]="PercentSign",n[n.Ampersand=38]="Ampersand",n[n.SingleQuote=39]="SingleQuote",n[n.OpenParen=40]="OpenParen",n[n.CloseParen=41]="CloseParen",n[n.Asterisk=42]="Asterisk",n[n.Plus=43]="Plus",n[n.Comma=44]="Comma",n[n.Dash=45]="Dash",n[n.Period=46]="Period",n[n.Slash=47]="Slash",n[n.Digit0=48]="Digit0",n[n.Digit1=49]="Digit1",n[n.Digit2=50]="Digit2",n[n.Digit3=51]="Digit3",n[n.Digit4=52]="Digit4",n[n.Digit5=53]="Digit5",n[n.Digit6=54]="Digit6",n[n.Digit7=55]="Digit7",n[n.Digit8=56]="Digit8",n[n.Digit9=57]="Digit9",n[n.Colon=58]="Colon",n[n.Semicolon=59]="Semicolon",n[n.LessThan=60]="LessThan",n[n.Equals=61]="Equals",n[n.GreaterThan=62]="GreaterThan",n[n.QuestionMark=63]="QuestionMark",n[n.AtSign=64]="AtSign",n[n.A=65]="A",n[n.B=66]="B",n[n.C=67]="C",n[n.D=68]="D",n[n.E=69]="E",n[n.F=70]="F",n[n.G=71]="G",n[n.H=72]="H",n[n.I=73]="I",n[n.J=74]="J",n[n.K=75]="K",n[n.L=76]="L",n[n.M=77]="M",n[n.N=78]="N",n[n.O=79]="O",n[n.P=80]="P",n[n.Q=81]="Q",n[n.R=82]="R",n[n.S=83]="S",n[n.T=84]="T",n[n.U=85]="U",n[n.V=86]="V",n[n.W=87]="W",n[n.X=88]="X",n[n.Y=89]="Y",n[n.Z=90]="Z",n[n.OpenSquareBracket=91]="OpenSquareBracket",n[n.Backslash=92]="Backslash",n[n.CloseSquareBracket=93]="CloseSquareBracket",n[n.Caret=94]="Caret",n[n.Underline=95]="Underline",n[n.BackTick=96]="BackTick",n[n.a=97]="a",n[n.b=98]="b",n[n.c=99]="c",n[n.d=100]="d",n[n.e=101]="e",n[n.f=102]="f",n[n.g=103]="g",n[n.h=104]="h",n[n.i=105]="i",n[n.j=106]="j",n[n.k=107]="k",n[n.l=108]="l",n[n.m=109]="m",n[n.n=110]="n",n[n.o=111]="o",n[n.p=112]="p",n[n.q=113]="q",n[n.r=114]="r",n[n.s=115]="s",n[n.t=116]="t",n[n.u=117]="u",n[n.v=118]="v",n[n.w=119]="w",n[n.x=120]="x",n[n.y=121]="y",n[n.z=122]="z",n[n.OpenCurlyBrace=123]="OpenCurlyBrace",n[n.Pipe=124]="Pipe",n[n.CloseCurlyBrace=125]="CloseCurlyBrace",n[n.Tilde=126]="Tilde",n[n.NoBreakSpace=160]="NoBreakSpace",n[n.U_Combining_Grave_Accent=768]="U_Combining_Grave_Accent",n[n.U_Combining_Acute_Accent=769]="U_Combining_Acute_Accent",n[n.U_Combining_Circumflex_Accent=770]="U_Combining_Circumflex_Accent",n[n.U_Combining_Tilde=771]="U_Combining_Tilde",n[n.U_Combining_Macron=772]="U_Combining_Macron",n[n.U_Combining_Overline=773]="U_Combining_Overline",n[n.U_Combining_Breve=774]="U_Combining_Breve",n[n.U_Combining_Dot_Above=775]="U_Combining_Dot_Above",n[n.U_Combining_Diaeresis=776]="U_Combining_Diaeresis",n[n.U_Combining_Hook_Above=777]="U_Combining_Hook_Above",n[n.U_Combining_Ring_Above=778]="U_Combining_Ring_Above",n[n.U_Combining_Double_Acute_Accent=779]="U_Combining_Double_Acute_Accent",n[n.U_Combining_Caron=780]="U_Combining_Caron",n[n.U_Combining_Vertical_Line_Above=781]="U_Combining_Vertical_Line_Above",n[n.U_Combining_Double_Vertical_Line_Above=782]="U_Combining_Double_Vertical_Line_Above",n[n.U_Combining_Double_Grave_Accent=783]="U_Combining_Double_Grave_Accent",n[n.U_Combining_Candrabindu=784]="U_Combining_Candrabindu",n[n.U_Combining_Inverted_Breve=785]="U_Combining_Inverted_Breve",n[n.U_Combining_Turned_Comma_Above=786]="U_Combining_Turned_Comma_Above",n[n.U_Combining_Comma_Above=787]="U_Combining_Comma_Above",n[n.U_Combining_Reversed_Comma_Above=788]="U_Combining_Reversed_Comma_Above",n[n.U_Combining_Comma_Above_Right=789]="U_Combining_Comma_Above_Right",n[n.U_Combining_Grave_Accent_Below=790]="U_Combining_Grave_Accent_Below",n[n.U_Combining_Acute_Accent_Below=791]="U_Combining_Acute_Accent_Below",n[n.U_Combining_Left_Tack_Below=792]="U_Combining_Left_Tack_Below",n[n.U_Combining_Right_Tack_Below=793]="U_Combining_Right_Tack_Below",n[n.U_Combining_Left_Angle_Above=794]="U_Combining_Left_Angle_Above",n[n.U_Combining_Horn=795]="U_Combining_Horn",n[n.U_Combining_Left_Half_Ring_Below=796]="U_Combining_Left_Half_Ring_Below",n[n.U_Combining_Up_Tack_Below=797]="U_Combining_Up_Tack_Below",n[n.U_Combining_Down_Tack_Below=798]="U_Combining_Down_Tack_Below",n[n.U_Combining_Plus_Sign_Below=799]="U_Combining_Plus_Sign_Below",n[n.U_Combining_Minus_Sign_Below=800]="U_Combining_Minus_Sign_Below",n[n.U_Combining_Palatalized_Hook_Below=801]="U_Combining_Palatalized_Hook_Below",n[n.U_Combining_Retroflex_Hook_Below=802]="U_Combining_Retroflex_Hook_Below",n[n.U_Combining_Dot_Below=803]="U_Combining_Dot_Below",n[n.U_Combining_Diaeresis_Below=804]="U_Combining_Diaeresis_Below",n[n.U_Combining_Ring_Below=805]="U_Combining_Ring_Below",n[n.U_Combining_Comma_Below=806]="U_Combining_Comma_Below",n[n.U_Combining_Cedilla=807]="U_Combining_Cedilla",n[n.U_Combining_Ogonek=808]="U_Combining_Ogonek",n[n.U_Combining_Vertical_Line_Below=809]="U_Combining_Vertical_Line_Below",n[n.U_Combining_Bridge_Below=810]="U_Combining_Bridge_Below",n[n.U_Combining_Inverted_Double_Arch_Below=811]="U_Combining_Inverted_Double_Arch_Below",n[n.U_Combining_Caron_Below=812]="U_Combining_Caron_Below",n[n.U_Combining_Circumflex_Accent_Below=813]="U_Combining_Circumflex_Accent_Below",n[n.U_Combining_Breve_Below=814]="U_Combining_Breve_Below",n[n.U_Combining_Inverted_Breve_Below=815]="U_Combining_Inverted_Breve_Below",n[n.U_Combining_Tilde_Below=816]="U_Combining_Tilde_Below",n[n.U_Combining_Macron_Below=817]="U_Combining_Macron_Below",n[n.U_Combining_Low_Line=818]="U_Combining_Low_Line",n[n.U_Combining_Double_Low_Line=819]="U_Combining_Double_Low_Line",n[n.U_Combining_Tilde_Overlay=820]="U_Combining_Tilde_Overlay",n[n.U_Combining_Short_Stroke_Overlay=821]="U_Combining_Short_Stroke_Overlay",n[n.U_Combining_Long_Stroke_Overlay=822]="U_Combining_Long_Stroke_Overlay",n[n.U_Combining_Short_Solidus_Overlay=823]="U_Combining_Short_Solidus_Overlay",n[n.U_Combining_Long_Solidus_Overlay=824]="U_Combining_Long_Solidus_Overlay",n[n.U_Combining_Right_Half_Ring_Below=825]="U_Combining_Right_Half_Ring_Below",n[n.U_Combining_Inverted_Bridge_Below=826]="U_Combining_Inverted_Bridge_Below",n[n.U_Combining_Square_Below=827]="U_Combining_Square_Below",n[n.U_Combining_Seagull_Below=828]="U_Combining_Seagull_Below",n[n.U_Combining_X_Above=829]="U_Combining_X_Above",n[n.U_Combining_Vertical_Tilde=830]="U_Combining_Vertical_Tilde",n[n.U_Combining_Double_Overline=831]="U_Combining_Double_Overline",n[n.U_Combining_Grave_Tone_Mark=832]="U_Combining_Grave_Tone_Mark",n[n.U_Combining_Acute_Tone_Mark=833]="U_Combining_Acute_Tone_Mark",n[n.U_Combining_Greek_Perispomeni=834]="U_Combining_Greek_Perispomeni",n[n.U_Combining_Greek_Koronis=835]="U_Combining_Greek_Koronis",n[n.U_Combining_Greek_Dialytika_Tonos=836]="U_Combining_Greek_Dialytika_Tonos",n[n.U_Combining_Greek_Ypogegrammeni=837]="U_Combining_Greek_Ypogegrammeni",n[n.U_Combining_Bridge_Above=838]="U_Combining_Bridge_Above",n[n.U_Combining_Equals_Sign_Below=839]="U_Combining_Equals_Sign_Below",n[n.U_Combining_Double_Vertical_Line_Below=840]="U_Combining_Double_Vertical_Line_Below",n[n.U_Combining_Left_Angle_Below=841]="U_Combining_Left_Angle_Below",n[n.U_Combining_Not_Tilde_Above=842]="U_Combining_Not_Tilde_Above",n[n.U_Combining_Homothetic_Above=843]="U_Combining_Homothetic_Above",n[n.U_Combining_Almost_Equal_To_Above=844]="U_Combining_Almost_Equal_To_Above",n[n.U_Combining_Left_Right_Arrow_Below=845]="U_Combining_Left_Right_Arrow_Below",n[n.U_Combining_Upwards_Arrow_Below=846]="U_Combining_Upwards_Arrow_Below",n[n.U_Combining_Grapheme_Joiner=847]="U_Combining_Grapheme_Joiner",n[n.U_Combining_Right_Arrowhead_Above=848]="U_Combining_Right_Arrowhead_Above",n[n.U_Combining_Left_Half_Ring_Above=849]="U_Combining_Left_Half_Ring_Above",n[n.U_Combining_Fermata=850]="U_Combining_Fermata",n[n.U_Combining_X_Below=851]="U_Combining_X_Below",n[n.U_Combining_Left_Arrowhead_Below=852]="U_Combining_Left_Arrowhead_Below",n[n.U_Combining_Right_Arrowhead_Below=853]="U_Combining_Right_Arrowhead_Below",n[n.U_Combining_Right_Arrowhead_And_Up_Arrowhead_Below=854]="U_Combining_Right_Arrowhead_And_Up_Arrowhead_Below",n[n.U_Combining_Right_Half_Ring_Above=855]="U_Combining_Right_Half_Ring_Above",n[n.U_Combining_Dot_Above_Right=856]="U_Combining_Dot_Above_Right",n[n.U_Combining_Asterisk_Below=857]="U_Combining_Asterisk_Below",n[n.U_Combining_Double_Ring_Below=858]="U_Combining_Double_Ring_Below",n[n.U_Combining_Zigzag_Above=859]="U_Combining_Zigzag_Above",n[n.U_Combining_Double_Breve_Below=860]="U_Combining_Double_Breve_Below",n[n.U_Combining_Double_Breve=861]="U_Combining_Double_Breve",n[n.U_Combining_Double_Macron=862]="U_Combining_Double_Macron",n[n.U_Combining_Double_Macron_Below=863]="U_Combining_Double_Macron_Below",n[n.U_Combining_Double_Tilde=864]="U_Combining_Double_Tilde",n[n.U_Combining_Double_Inverted_Breve=865]="U_Combining_Double_Inverted_Breve",n[n.U_Combining_Double_Rightwards_Arrow_Below=866]="U_Combining_Double_Rightwards_Arrow_Below",n[n.U_Combining_Latin_Small_Letter_A=867]="U_Combining_Latin_Small_Letter_A",n[n.U_Combining_Latin_Small_Letter_E=868]="U_Combining_Latin_Small_Letter_E",n[n.U_Combining_Latin_Small_Letter_I=869]="U_Combining_Latin_Small_Letter_I",n[n.U_Combining_Latin_Small_Letter_O=870]="U_Combining_Latin_Small_Letter_O",n[n.U_Combining_Latin_Small_Letter_U=871]="U_Combining_Latin_Small_Letter_U",n[n.U_Combining_Latin_Small_Letter_C=872]="U_Combining_Latin_Small_Letter_C",n[n.U_Combining_Latin_Small_Letter_D=873]="U_Combining_Latin_Small_Letter_D",n[n.U_Combining_Latin_Small_Letter_H=874]="U_Combining_Latin_Small_Letter_H",n[n.U_Combining_Latin_Small_Letter_M=875]="U_Combining_Latin_Small_Letter_M",n[n.U_Combining_Latin_Small_Letter_R=876]="U_Combining_Latin_Small_Letter_R",n[n.U_Combining_Latin_Small_Letter_T=877]="U_Combining_Latin_Small_Letter_T",n[n.U_Combining_Latin_Small_Letter_V=878]="U_Combining_Latin_Small_Letter_V",n[n.U_Combining_Latin_Small_Letter_X=879]="U_Combining_Latin_Small_Letter_X",n[n.LINE_SEPARATOR=8232]="LINE_SEPARATOR",n[n.PARAGRAPH_SEPARATOR=8233]="PARAGRAPH_SEPARATOR",n[n.NEXT_LINE=133]="NEXT_LINE",n[n.U_CIRCUMFLEX=94]="U_CIRCUMFLEX",n[n.U_GRAVE_ACCENT=96]="U_GRAVE_ACCENT",n[n.U_DIAERESIS=168]="U_DIAERESIS",n[n.U_MACRON=175]="U_MACRON",n[n.U_ACUTE_ACCENT=180]="U_ACUTE_ACCENT",n[n.U_CEDILLA=184]="U_CEDILLA",n[n.U_MODIFIER_LETTER_LEFT_ARROWHEAD=706]="U_MODIFIER_LETTER_LEFT_ARROWHEAD",n[n.U_MODIFIER_LETTER_RIGHT_ARROWHEAD=707]="U_MODIFIER_LETTER_RIGHT_ARROWHEAD",n[n.U_MODIFIER_LETTER_UP_ARROWHEAD=708]="U_MODIFIER_LETTER_UP_ARROWHEAD",n[n.U_MODIFIER_LETTER_DOWN_ARROWHEAD=709]="U_MODIFIER_LETTER_DOWN_ARROWHEAD",n[n.U_MODIFIER_LETTER_CENTRED_RIGHT_HALF_RING=722]="U_MODIFIER_LETTER_CENTRED_RIGHT_HALF_RING",n[n.U_MODIFIER_LETTER_CENTRED_LEFT_HALF_RING=723]="U_MODIFIER_LETTER_CENTRED_LEFT_HALF_RING",n[n.U_MODIFIER_LETTER_UP_TACK=724]="U_MODIFIER_LETTER_UP_TACK",n[n.U_MODIFIER_LETTER_DOWN_TACK=725]="U_MODIFIER_LETTER_DOWN_TACK",n[n.U_MODIFIER_LETTER_PLUS_SIGN=726]="U_MODIFIER_LETTER_PLUS_SIGN",n[n.U_MODIFIER_LETTER_MINUS_SIGN=727]="U_MODIFIER_LETTER_MINUS_SIGN",n[n.U_BREVE=728]="U_BREVE",n[n.U_DOT_ABOVE=729]="U_DOT_ABOVE",n[n.U_RING_ABOVE=730]="U_RING_ABOVE",n[n.U_OGONEK=731]="U_OGONEK",n[n.U_SMALL_TILDE=732]="U_SMALL_TILDE",n[n.U_DOUBLE_ACUTE_ACCENT=733]="U_DOUBLE_ACUTE_ACCENT",n[n.U_MODIFIER_LETTER_RHOTIC_HOOK=734]="U_MODIFIER_LETTER_RHOTIC_HOOK",n[n.U_MODIFIER_LETTER_CROSS_ACCENT=735]="U_MODIFIER_LETTER_CROSS_ACCENT",n[n.U_MODIFIER_LETTER_EXTRA_HIGH_TONE_BAR=741]="U_MODIFIER_LETTER_EXTRA_HIGH_TONE_BAR",n[n.U_MODIFIER_LETTER_HIGH_TONE_BAR=742]="U_MODIFIER_LETTER_HIGH_TONE_BAR",n[n.U_MODIFIER_LETTER_MID_TONE_BAR=743]="U_MODIFIER_LETTER_MID_TONE_BAR",n[n.U_MODIFIER_LETTER_LOW_TONE_BAR=744]="U_MODIFIER_LETTER_LOW_TONE_BAR",n[n.U_MODIFIER_LETTER_EXTRA_LOW_TONE_BAR=745]="U_MODIFIER_LETTER_EXTRA_LOW_TONE_BAR",n[n.U_MODIFIER_LETTER_YIN_DEPARTING_TONE_MARK=746]="U_MODIFIER_LETTER_YIN_DEPARTING_TONE_MARK",n[n.U_MODIFIER_LETTER_YANG_DEPARTING_TONE_MARK=747]="U_MODIFIER_LETTER_YANG_DEPARTING_TONE_MARK",n[n.U_MODIFIER_LETTER_UNASPIRATED=749]="U_MODIFIER_LETTER_UNASPIRATED",n[n.U_MODIFIER_LETTER_LOW_DOWN_ARROWHEAD=751]="U_MODIFIER_LETTER_LOW_DOWN_ARROWHEAD",n[n.U_MODIFIER_LETTER_LOW_UP_ARROWHEAD=752]="U_MODIFIER_LETTER_LOW_UP_ARROWHEAD",n[n.U_MODIFIER_LETTER_LOW_LEFT_ARROWHEAD=753]="U_MODIFIER_LETTER_LOW_LEFT_ARROWHEAD",n[n.U_MODIFIER_LETTER_LOW_RIGHT_ARROWHEAD=754]="U_MODIFIER_LETTER_LOW_RIGHT_ARROWHEAD",n[n.U_MODIFIER_LETTER_LOW_RING=755]="U_MODIFIER_LETTER_LOW_RING",n[n.U_MODIFIER_LETTER_MIDDLE_GRAVE_ACCENT=756]="U_MODIFIER_LETTER_MIDDLE_GRAVE_ACCENT",n[n.U_MODIFIER_LETTER_MIDDLE_DOUBLE_GRAVE_ACCENT=757]="U_MODIFIER_LETTER_MIDDLE_DOUBLE_GRAVE_ACCENT",n[n.U_MODIFIER_LETTER_MIDDLE_DOUBLE_ACUTE_ACCENT=758]="U_MODIFIER_LETTER_MIDDLE_DOUBLE_ACUTE_ACCENT",n[n.U_MODIFIER_LETTER_LOW_TILDE=759]="U_MODIFIER_LETTER_LOW_TILDE",n[n.U_MODIFIER_LETTER_RAISED_COLON=760]="U_MODIFIER_LETTER_RAISED_COLON",n[n.U_MODIFIER_LETTER_BEGIN_HIGH_TONE=761]="U_MODIFIER_LETTER_BEGIN_HIGH_TONE",n[n.U_MODIFIER_LETTER_END_HIGH_TONE=762]="U_MODIFIER_LETTER_END_HIGH_TONE",n[n.U_MODIFIER_LETTER_BEGIN_LOW_TONE=763]="U_MODIFIER_LETTER_BEGIN_LOW_TONE",n[n.U_MODIFIER_LETTER_END_LOW_TONE=764]="U_MODIFIER_LETTER_END_LOW_TONE",n[n.U_MODIFIER_LETTER_SHELF=765]="U_MODIFIER_LETTER_SHELF",n[n.U_MODIFIER_LETTER_OPEN_SHELF=766]="U_MODIFIER_LETTER_OPEN_SHELF",n[n.U_MODIFIER_LETTER_LOW_LEFT_ARROW=767]="U_MODIFIER_LETTER_LOW_LEFT_ARROW",n[n.U_GREEK_LOWER_NUMERAL_SIGN=885]="U_GREEK_LOWER_NUMERAL_SIGN",n[n.U_GREEK_TONOS=900]="U_GREEK_TONOS",n[n.U_GREEK_DIALYTIKA_TONOS=901]="U_GREEK_DIALYTIKA_TONOS",n[n.U_GREEK_KORONIS=8125]="U_GREEK_KORONIS",n[n.U_GREEK_PSILI=8127]="U_GREEK_PSILI",n[n.U_GREEK_PERISPOMENI=8128]="U_GREEK_PERISPOMENI",n[n.U_GREEK_DIALYTIKA_AND_PERISPOMENI=8129]="U_GREEK_DIALYTIKA_AND_PERISPOMENI",n[n.U_GREEK_PSILI_AND_VARIA=8141]="U_GREEK_PSILI_AND_VARIA",n[n.U_GREEK_PSILI_AND_OXIA=8142]="U_GREEK_PSILI_AND_OXIA",n[n.U_GREEK_PSILI_AND_PERISPOMENI=8143]="U_GREEK_PSILI_AND_PERISPOMENI",n[n.U_GREEK_DASIA_AND_VARIA=8157]="U_GREEK_DASIA_AND_VARIA",n[n.U_GREEK_DASIA_AND_OXIA=8158]="U_GREEK_DASIA_AND_OXIA",n[n.U_GREEK_DASIA_AND_PERISPOMENI=8159]="U_GREEK_DASIA_AND_PERISPOMENI",n[n.U_GREEK_DIALYTIKA_AND_VARIA=8173]="U_GREEK_DIALYTIKA_AND_VARIA",n[n.U_GREEK_DIALYTIKA_AND_OXIA=8174]="U_GREEK_DIALYTIKA_AND_OXIA",n[n.U_GREEK_VARIA=8175]="U_GREEK_VARIA",n[n.U_GREEK_OXIA=8189]="U_GREEK_OXIA",n[n.U_GREEK_DASIA=8190]="U_GREEK_DASIA",n[n.U_IDEOGRAPHIC_FULL_STOP=12290]="U_IDEOGRAPHIC_FULL_STOP",n[n.U_LEFT_CORNER_BRACKET=12300]="U_LEFT_CORNER_BRACKET",n[n.U_RIGHT_CORNER_BRACKET=12301]="U_RIGHT_CORNER_BRACKET",n[n.U_LEFT_BLACK_LENTICULAR_BRACKET=12304]="U_LEFT_BLACK_LENTICULAR_BRACKET",n[n.U_RIGHT_BLACK_LENTICULAR_BRACKET=12305]="U_RIGHT_BLACK_LENTICULAR_BRACKET",n[n.U_OVERLINE=8254]="U_OVERLINE",n[n.UTF8_BOM=65279]="UTF8_BOM",n[n.U_FULLWIDTH_SEMICOLON=65307]="U_FULLWIDTH_SEMICOLON",n[n.U_FULLWIDTH_COMMA=65292]="U_FULLWIDTH_COMMA"})(t||(i.CharCode=t={}))}),ne(ie[37],re([0,1]),function(x,i){"use strict";var t;Object.defineProperty(i,"__esModule",{value:!0}),i.$O=void 0,i.$K=n,i.$L=p,i.$M=g,i.$N=E;function n(a,l){const c=Object.create(null);for(const $ of a){const m=l($);let L=c[m];L||(L=c[m]=[]),L.push($)}return c}function p(a,l){const c=[],$=[];for(const m of a)l.has(m)||c.push(m);for(const m of l)a.has(m)||$.push(m);return{removed:c,added:$}}function g(a,l){const c=[],$=[];for(const[m,L]of a)l.has(m)||c.push(L);for(const[m,L]of l)a.has(m)||$.push(L);return{removed:c,added:$}}function E(a,l){const c=new Set;for(const $ of l)a.has($)&&c.add($);return c}class d{static{t=Symbol.toStringTag}constructor(l,c){this.b=c,this.a=new Map,this[t]="SetWithKey";for(const $ of l)this.add($)}get size(){return this.a.size}add(l){const c=this.b(l);return this.a.set(c,l),this}delete(l){return this.a.delete(this.b(l))}has(l){return this.a.has(this.b(l))}*entries(){for(const l of this.a.values())yield[l,l]}keys(){return this.values()}*values(){for(const l of this.a.values())yield l}clear(){this.a.clear()}forEach(l,c){this.a.forEach($=>l.call(c,$,$,this))}[Symbol.iterator](){return this.values()}}i.$O=d}),ne(ie[38],re([0,1,3]),function(x,i,t){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.$lu=i.$ku=i.$ju=i.$iu=void 0;function n(a,l){const c=Math.pow(10,l);return Math.round(a*c)/c}class p{constructor(l,c,$,m=1){this._rgbaBrand=void 0,this.r=Math.min(255,Math.max(0,l))|0,this.g=Math.min(255,Math.max(0,c))|0,this.b=Math.min(255,Math.max(0,$))|0,this.a=n(Math.max(Math.min(1,m),0),3)}static equals(l,c){return l.r===c.r&&l.g===c.g&&l.b===c.b&&l.a===c.a}}i.$iu=p;class g{constructor(l,c,$,m){this._hslaBrand=void 0,this.h=Math.max(Math.min(360,l),0)|0,this.s=n(Math.max(Math.min(1,c),0),3),this.l=n(Math.max(Math.min(1,$),0),3),this.a=n(Math.max(Math.min(1,m),0),3)}static equals(l,c){return l.h===c.h&&l.s===c.s&&l.l===c.l&&l.a===c.a}static fromRGBA(l){const c=l.r/255,$=l.g/255,m=l.b/255,L=l.a,e=Math.max(c,$,m),b=Math.min(c,$,m);let N=0,R=0;const A=(b+e)/2,w=e-b;if(w>0){switch(R=Math.min(A<=.5?w/(2*A):w/(2-2*A),1),e){case c:N=($-m)/w+($<m?6:0);break;case $:N=(m-c)/w+2;break;case m:N=(c-$)/w+4;break}N*=60,N=Math.round(N)}return new g(N,R,A,L)}static i(l,c,$){return $<0&&($+=1),$>1&&($-=1),$<1/6?l+(c-l)*6*$:$<1/2?c:$<2/3?l+(c-l)*(2/3-$)*6:l}static toRGBA(l){const c=l.h/360,{s:$,l:m,a:L}=l;let e,b,N;if($===0)e=b=N=m;else{const R=m<.5?m*(1+$):m+$-m*$,A=2*m-R;e=g.i(A,R,c+1/3),b=g.i(A,R,c),N=g.i(A,R,c-1/3)}return new p(Math.round(e*255),Math.round(b*255),Math.round(N*255),L)}}i.$ju=g;class E{constructor(l,c,$,m){this._hsvaBrand=void 0,this.h=Math.max(Math.min(360,l),0)|0,this.s=n(Math.max(Math.min(1,c),0),3),this.v=n(Math.max(Math.min(1,$),0),3),this.a=n(Math.max(Math.min(1,m),0),3)}static equals(l,c){return l.h===c.h&&l.s===c.s&&l.v===c.v&&l.a===c.a}static fromRGBA(l){const c=l.r/255,$=l.g/255,m=l.b/255,L=Math.max(c,$,m),e=Math.min(c,$,m),b=L-e,N=L===0?0:b/L;let R;return b===0?R=0:L===c?R=(($-m)/b%6+6)%6:L===$?R=(m-c)/b+2:R=(c-$)/b+4,new E(Math.round(R*60),N,L,l.a)}static toRGBA(l){const{h:c,s:$,v:m,a:L}=l,e=m*$,b=e*(1-Math.abs(c/60%2-1)),N=m-e;let[R,A,w]=[0,0,0];return c<60?(R=e,A=b):c<120?(R=b,A=e):c<180?(A=e,w=b):c<240?(A=b,w=e):c<300?(R=b,w=e):c<=360&&(R=e,w=b),R=Math.round((R+N)*255),A=Math.round((A+N)*255),w=Math.round((w+N)*255),new p(R,A,w,L)}}i.$ku=E;class d{static fromHex(l){return d.Format.CSS.parseHex(l)||d.red}static equals(l,c){return!l&&!c?!0:!l||!c?!1:l.equals(c)}get hsla(){return this.i?this.i:g.fromRGBA(this.rgba)}get hsva(){return this.j?this.j:E.fromRGBA(this.rgba)}constructor(l){if(l)if(l instanceof p)this.rgba=l;else if(l instanceof g)this.i=l,this.rgba=g.toRGBA(l);else if(l instanceof E)this.j=l,this.rgba=E.toRGBA(l);else throw new Error("Invalid color ctor argument");else throw new Error("Color needs a value")}equals(l){return!!l&&p.equals(this.rgba,l.rgba)&&g.equals(this.hsla,l.hsla)&&E.equals(this.hsva,l.hsva)}getRelativeLuminance(){const l=d.k(this.rgba.r),c=d.k(this.rgba.g),$=d.k(this.rgba.b),m=.2126*l+.7152*c+.0722*$;return n(m,4)}static k(l){const c=l/255;return c<=.03928?c/12.92:Math.pow((c+.055)/1.055,2.4)}getContrastRatio(l){const c=this.getRelativeLuminance(),$=l.getRelativeLuminance();return c>$?(c+.05)/($+.05):($+.05)/(c+.05)}isDarker(){return(this.rgba.r*299+this.rgba.g*587+this.rgba.b*114)/1e3<128}isLighter(){return(this.rgba.r*299+this.rgba.g*587+this.rgba.b*114)/1e3>=128}isLighterThan(l){const c=this.getRelativeLuminance(),$=l.getRelativeLuminance();return c>$}isDarkerThan(l){const c=this.getRelativeLuminance(),$=l.getRelativeLuminance();return c<$}lighten(l){return new d(new g(this.hsla.h,this.hsla.s,this.hsla.l+this.hsla.l*l,this.hsla.a))}darken(l){return new d(new g(this.hsla.h,this.hsla.s,this.hsla.l-this.hsla.l*l,this.hsla.a))}transparent(l){const{r:c,g:$,b:m,a:L}=this.rgba;return new d(new p(c,$,m,L*l))}isTransparent(){return this.rgba.a===0}isOpaque(){return this.rgba.a===1}opposite(){return new d(new p(255-this.rgba.r,255-this.rgba.g,255-this.rgba.b,this.rgba.a))}blend(l){const c=l.rgba,$=this.rgba.a,m=c.a,L=$+m*(1-$);if(L<1e-6)return d.transparent;const e=this.rgba.r*$/L+c.r*m*(1-$)/L,b=this.rgba.g*$/L+c.g*m*(1-$)/L,N=this.rgba.b*$/L+c.b*m*(1-$)/L;return new d(new p(e,b,N,L))}makeOpaque(l){if(this.isOpaque()||l.rgba.a!==1)return this;const{r:c,g:$,b:m,a:L}=this.rgba;return new d(new p(l.rgba.r-L*(l.rgba.r-c),l.rgba.g-L*(l.rgba.g-$),l.rgba.b-L*(l.rgba.b-m),1))}flatten(...l){const c=l.reduceRight(($,m)=>d.o(m,$));return d.o(this,c)}static o(l,c){const $=1-l.rgba.a;return new d(new p($*c.rgba.r+l.rgba.a*l.rgba.r,$*c.rgba.g+l.rgba.a*l.rgba.g,$*c.rgba.b+l.rgba.a*l.rgba.b))}toString(){return this.u||(this.u=d.Format.CSS.format(this)),this.u}static getLighterColor(l,c,$){if(l.isLighterThan(c))return l;$=$||.5;const m=l.getRelativeLuminance(),L=c.getRelativeLuminance();return $=$*(L-m)/L,l.lighten($)}static getDarkerColor(l,c,$){if(l.isDarkerThan(c))return l;$=$||.5;const m=l.getRelativeLuminance(),L=c.getRelativeLuminance();return $=$*(m-L)/m,l.darken($)}static{this.white=new d(new p(255,255,255,1))}static{this.black=new d(new p(0,0,0,1))}static{this.red=new d(new p(255,0,0,1))}static{this.blue=new d(new p(0,0,255,1))}static{this.green=new d(new p(0,255,0,1))}static{this.cyan=new d(new p(0,255,255,1))}static{this.lightgrey=new d(new p(211,211,211,1))}static{this.transparent=new d(new p(0,0,0,0))}}i.$lu=d,function(a){let l;(function(c){let $;(function(m){function L(r){return r.rgba.a===1?`rgb(${r.rgba.r}, ${r.rgba.g}, ${r.rgba.b})`:a.Format.CSS.formatRGBA(r)}m.formatRGB=L;function e(r){return`rgba(${r.rgba.r}, ${r.rgba.g}, ${r.rgba.b}, ${+r.rgba.a.toFixed(2)})`}m.formatRGBA=e;function b(r){return r.hsla.a===1?`hsl(${r.hsla.h}, ${(r.hsla.s*100).toFixed(2)}%, ${(r.hsla.l*100).toFixed(2)}%)`:a.Format.CSS.formatHSLA(r)}m.formatHSL=b;function N(r){return`hsla(${r.hsla.h}, ${(r.hsla.s*100).toFixed(2)}%, ${(r.hsla.l*100).toFixed(2)}%, ${r.hsla.a.toFixed(2)})`}m.formatHSLA=N;function R(r){const o=r.toString(16);return o.length!==2?"0"+o:o}function A(r){return`#${R(r.rgba.r)}${R(r.rgba.g)}${R(r.rgba.b)}`}m.formatHex=A;function w(r,o=!1){return o&&r.rgba.a===1?a.Format.CSS.formatHex(r):`#${R(r.rgba.r)}${R(r.rgba.g)}${R(r.rgba.b)}${R(Math.round(r.rgba.a*255))}`}m.formatHexA=w;function v(r){return r.isOpaque()?a.Format.CSS.formatHex(r):a.Format.CSS.formatRGBA(r)}m.format=v;function h(r){const o=r.length;if(o===0||r.charCodeAt(0)!==t.CharCode.Hash)return null;if(o===7){const f=16*u(r.charCodeAt(1))+u(r.charCodeAt(2)),T=16*u(r.charCodeAt(3))+u(r.charCodeAt(4)),_=16*u(r.charCodeAt(5))+u(r.charCodeAt(6));return new a(new p(f,T,_,1))}if(o===9){const f=16*u(r.charCodeAt(1))+u(r.charCodeAt(2)),T=16*u(r.charCodeAt(3))+u(r.charCodeAt(4)),_=16*u(r.charCodeAt(5))+u(r.charCodeAt(6)),M=16*u(r.charCodeAt(7))+u(r.charCodeAt(8));return new a(new p(f,T,_,M/255))}if(o===4){const f=u(r.charCodeAt(1)),T=u(r.charCodeAt(2)),_=u(r.charCodeAt(3));return new a(new p(16*f+f,16*T+T,16*_+_))}if(o===5){const f=u(r.charCodeAt(1)),T=u(r.charCodeAt(2)),_=u(r.charCodeAt(3)),M=u(r.charCodeAt(4));return new a(new p(16*f+f,16*T+T,16*_+_,(16*M+M)/255))}return null}m.parseHex=h;function u(r){switch(r){case t.CharCode.Digit0:return 0;case t.CharCode.Digit1:return 1;case t.CharCode.Digit2:return 2;case t.CharCode.Digit3:return 3;case t.CharCode.Digit4:return 4;case t.CharCode.Digit5:return 5;case t.CharCode.Digit6:return 6;case t.CharCode.Digit7:return 7;case t.CharCode.Digit8:return 8;case t.CharCode.Digit9:return 9;case t.CharCode.a:return 10;case t.CharCode.A:return 10;case t.CharCode.b:return 11;case t.CharCode.B:return 11;case t.CharCode.c:return 12;case t.CharCode.C:return 12;case t.CharCode.d:return 13;case t.CharCode.D:return 13;case t.CharCode.e:return 14;case t.CharCode.E:return 14;case t.CharCode.f:return 15;case t.CharCode.F:return 15}return 0}})($=c.CSS||(c.CSS={}))})(l=a.Format||(a.Format={}))}(d||(i.$lu=d={}))}),ne(ie[39],re([0,1]),function(x,i){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.$Pt=void 0;class t{constructor(p,g,E,d){this.originalStart=p,this.originalLength=g,this.modifiedStart=E,this.modifiedLength=d}getOriginalEnd(){return this.originalStart+this.originalLength}getModifiedEnd(){return this.modifiedStart+this.modifiedLength}}i.$Pt=t}),ne(ie[4],re([0,1]),function(x,i){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.$fb=i.$eb=i.$db=i.$cb=i.$bb=i.$_=i.$8=i.$Z=i.$Y=void 0,i.setUnexpectedErrorHandler=n,i.$2=p,i.$3=g,i.$4=E,i.$5=d,i.$6=a,i.$7=c,i.$9=m,i.$0=L,i.$$=e,i.$ab=N;class t{constructor(){this.b=[],this.a=function(r){setTimeout(()=>{throw r.stack?v.isErrorNoTelemetry(r)?new v(r.message+`

`+r.stack):new Error(r.message+`

`+r.stack):r},0)}}addListener(r){return this.b.push(r),()=>{this.d(r)}}c(r){this.b.forEach(o=>{o(r)})}d(r){this.b.splice(this.b.indexOf(r),1)}setUnexpectedErrorHandler(r){this.a=r}getUnexpectedErrorHandler(){return this.a}onUnexpectedError(r){this.a(r),this.c(r)}onUnexpectedExternalError(r){this.a(r)}}i.$Y=t,i.$Z=new t;function n(u){i.$Z.setUnexpectedErrorHandler(u)}function p(u){if(!u||typeof u!="object")return!1;const r=u;return r.code==="EPIPE"&&r.syscall?.toUpperCase()==="WRITE"}function g(u){c(u)||i.$Z.onUnexpectedError(u)}function E(u){c(u)||i.$Z.onUnexpectedExternalError(u)}function d(u){if(u instanceof Error){const{name:r,message:o}=u,f=u.stacktrace||u.stack;return{$isError:!0,name:r,message:o,stack:f,noTelemetry:v.isErrorNoTelemetry(u)}}return u}function a(u){let r;return u.noTelemetry?r=new v:(r=new Error,r.name=u.name),r.message=u.message,r.stack=u.stack,r}const l="Canceled";function c(u){return u instanceof $?!0:u instanceof Error&&u.name===l&&u.message===l}class $ extends Error{constructor(){super(l),this.name=this.message}}i.$8=$;function m(){const u=new Error(l);return u.name=u.message,u}function L(u){return u?new Error(`Illegal argument: ${u}`):new Error("Illegal argument")}function e(u){return u?new Error(`Illegal state: ${u}`):new Error("Illegal state")}class b extends TypeError{constructor(r){super(r?`${r} is read-only and cannot be changed`:"Cannot change read-only property")}}i.$_=b;function N(u){return u?u.message?u.message:u.stack?u.stack.split(`
`)[0]:String(u):"Error"}class R extends Error{constructor(r){super("NotImplemented"),r&&(this.message=r)}}i.$bb=R;class A extends Error{constructor(r){super("NotSupported"),r&&(this.message=r)}}i.$cb=A;class w extends Error{constructor(){super(...arguments),this.isExpected=!0}}i.$db=w;class v extends Error{constructor(r){super(r),this.name="CodeExpectedError"}static fromError(r){if(r instanceof v)return r;const o=new v;return o.message=r.message,o.stack=r.stack,o}static isErrorNoTelemetry(r){return r.name==="CodeExpectedError"}}i.$eb=v;class h extends Error{constructor(r){super(r||"An unexpected bug occurred."),Object.setPrototypeOf(this,h.prototype)}}i.$fb=h}),ne(ie[7],re([0,1,4,9]),function(x,i,t,n){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.$dc=i.$cc=i.$bc=i.$_b=i.$$b=i.CompareResult=void 0,i.$vb=p,i.$wb=g,i.$xb=E,i.$yb=d,i.$zb=a,i.$Ab=l,i.$Bb=c,i.$Cb=$,i.$Db=m,i.$Eb=L,i.$Fb=e,i.$Gb=b,i.$Hb=N,i.top=R,i.$Jb=A,i.$Kb=v,i.$Lb=h,i.$Mb=u,i.$Nb=r,i.$Ob=o,i.$Pb=f,i.$Qb=T,i.$Rb=_,i.$Sb=M,i.$Tb=j,i.$Ub=F,i.$Vb=I,i.$Wb=S,i.$Xb=D,i.$Yb=q,i.$Zb=X,i.$1b=B,i.$2b=y,i.$3b=Y,i.$4b=Z,i.$5b=H,i.$6b=Q,i.$7b=C,i.$8b=k,i.$9b=oe,i.$0b=we,i.$ac=Pe;function p(U,W=0){return U[U.length-(1+W)]}function g(U){if(U.length===0)throw new Error("Invalid tail call");return[U.slice(0,U.length-1),U[U.length-1]]}function E(U,W,V=(J,ee)=>J===ee){if(U===W)return!0;if(!U||!W||U.length!==W.length)return!1;for(let J=0,ee=U.length;J<ee;J++)if(!V(U[J],W[J]))return!1;return!0}function d(U,W){const V=U.length-1;W<V&&(U[W]=U[V]),U.pop()}function a(U,W,V){return l(U.length,J=>V(U[J],W))}function l(U,W){let V=0,J=U-1;for(;V<=J;){const ee=(V+J)/2|0,he=W(ee);if(he<0)V=ee+1;else if(he>0)J=ee-1;else return ee}return-(V+1)}function c(U,W,V){if(U=U|0,U>=W.length)throw new TypeError("invalid index");const J=W[Math.floor(W.length*Math.random())],ee=[],he=[],de=[];for(const Ee of W){const ve=V(Ee,J);ve<0?ee.push(Ee):ve>0?he.push(Ee):de.push(Ee)}return U<ee.length?c(U,ee,V):U<ee.length+de.length?de[0]:c(U-(ee.length+de.length),he,V)}function $(U,W){const V=[];let J;for(const ee of U.slice(0).sort(W))!J||W(J[0],ee)!==0?(J=[ee],V.push(J)):J.push(ee);return V}function*m(U,W){let V,J;for(const ee of U)J!==void 0&&W(J,ee)?V.push(ee):(V&&(yield V),V=[ee]),J=ee;V&&(yield V)}function L(U,W){for(let V=0;V<=U.length;V++)W(V===0?void 0:U[V-1],V===U.length?void 0:U[V])}function e(U,W){for(let V=0;V<U.length;V++)W(V===0?void 0:U[V-1],U[V],V+1===U.length?void 0:U[V+1])}function b(U,W,V){const J=[];function ee(Ee,ve,_e){if(ve===0&&_e.length===0)return;const se=J[J.length-1];se&&se.start+se.deleteCount===Ee?(se.deleteCount+=ve,se.toInsert.push(..._e)):J.push({start:Ee,deleteCount:ve,toInsert:_e})}let he=0,de=0;for(;;){if(he===U.length){ee(he,0,W.slice(de));break}if(de===W.length){ee(he,U.length-he,[]);break}const Ee=U[he],ve=W[de],_e=V(Ee,ve);_e===0?(he+=1,de+=1):_e<0?(ee(he,1,[]),he+=1):_e>0&&(ee(he,0,[ve]),de+=1)}return J}function N(U,W,V){const J=b(U,W,V),ee=[],he=[];for(const de of J)ee.push(...U.slice(de.start,de.start+de.deleteCount)),he.push(...de.toInsert);return{removed:ee,added:he}}function R(U,W,V){if(V===0)return[];const J=U.slice(0,V).sort(W);return w(U,W,J,V,U.length),J}function A(U,W,V,J,ee){return V===0?Promise.resolve([]):new Promise((he,de)=>{(async()=>{const Ee=U.length,ve=U.slice(0,V).sort(W);for(let _e=V,se=Math.min(V+J,Ee);_e<Ee;_e=se,se=Math.min(se+J,Ee)){if(_e>V&&await new Promise(te=>setTimeout(te)),ee&&ee.isCancellationRequested)throw new t.$8;w(U,W,ve,_e,se)}return ve})().then(he,de)})}function w(U,W,V,J,ee){for(const he=V.length;J<ee;J++){const de=U[J];if(W(de,V[he-1])<0){V.pop();const Ee=(0,n.$nb)(V,ve=>W(de,ve)<0);V.splice(Ee,0,de)}}}function v(U){return U.filter(W=>!!W)}function h(U){let W=0;for(let V=0;V<U.length;V++)U[V]&&(U[W]=U[V],W+=1);U.length=W}function u(U,W,V){U.splice(V,0,U.splice(W,1)[0])}function r(U){return!Array.isArray(U)||U.length===0}function o(U){return Array.isArray(U)&&U.length>0}function f(U,W=V=>V){const V=new Set;return U.filter(J=>{const ee=W(J);return V.has(ee)?!1:(V.add(ee),!0)})}function T(U){const W=new Set;return V=>{const J=U(V);return W.has(J)?!1:(W.add(J),!0)}}function _(U,W){return U.length>0?U[0]:W}function M(U,W){return U.length>0?U[U.length-1]:W}function j(U,W,V=(J,ee)=>J===ee){let J=0;for(let ee=0,he=Math.min(U.length,W.length);ee<he&&V(U[ee],W[ee]);ee++)J++;return J}function F(U,W){let V=typeof W=="number"?U:0;typeof W=="number"?V=U:(V=0,W=U);const J=[];if(V<=W)for(let ee=V;ee<W;ee++)J.push(ee);else for(let ee=V;ee>W;ee--)J.push(ee);return J}function I(U,W,V){return U.reduce((J,ee)=>(J[W(ee)]=V?V(ee):ee,J),Object.create(null))}function S(U,W){return U.push(W),()=>D(U,W)}function D(U,W){const V=U.indexOf(W);if(V>-1)return U.splice(V,1),W}function q(U,W,V){const J=U.slice(0,W),ee=U.slice(W);return J.concat(V,ee)}function X(U,W){let V;if(typeof W=="number"){let J=W;V=()=>{const ee=Math.sin(J++)*179426549;return ee-Math.floor(ee)}}else V=Math.random;for(let J=U.length-1;J>0;J-=1){const ee=Math.floor(V()*(J+1)),he=U[J];U[J]=U[ee],U[ee]=he}}function B(U,W){const V=U.indexOf(W);V>-1&&(U.splice(V,1),U.unshift(W))}function y(U,W){const V=U.indexOf(W);V>-1&&(U.splice(V,1),U.push(W))}function Y(U,W){for(const V of W)U.push(V)}function Z(U,W){return Array.isArray(U)?U.map(W):W(U)}function H(U){return Array.isArray(U)?U:[U]}function Q(U){return U[Math.floor(Math.random()*U.length)]}function C(U,W,V){const J=z(U,W),ee=U.length,he=V.length;U.length=ee+he;for(let de=ee-1;de>=J;de--)U[de+he]=U[de];for(let de=0;de<he;de++)U[de+J]=V[de]}function k(U,W,V,J){const ee=z(U,W);let he=U.splice(ee,V);return he===void 0&&(he=[]),C(U,ee,J),he}function z(U,W){return W<0?Math.max(W+U.length,0):Math.min(W,U.length)}var fe;(function(U){function W(he){return he<0}U.isLessThan=W;function V(he){return he<=0}U.isLessThanOrEqual=V;function J(he){return he>0}U.isGreaterThan=J;function ee(he){return he===0}U.isNeitherLessOrGreaterThan=ee,U.greaterThan=1,U.lessThan=-1,U.neitherLessOrGreaterThan=0})(fe||(i.CompareResult=fe={}));function oe(U,W){return(V,J)=>W(U(V),U(J))}function we(...U){return(W,V)=>{for(const J of U){const ee=J(W,V);if(!fe.isNeitherLessOrGreaterThan(ee))return ee}return fe.neitherLessOrGreaterThan}}const s=(U,W)=>U-W;i.$$b=s;const Te=(U,W)=>(0,i.$$b)(U?1:0,W?1:0);i.$_b=Te;function Pe(U){return(W,V)=>-U(W,V)}class We{constructor(W){this.g=W,this.c=0,this.d=this.g.length-1}get length(){return this.d-this.c+1}takeWhile(W){let V=this.c;for(;V<this.g.length&&W(this.g[V]);)V++;const J=V===this.c?null:this.g.slice(this.c,V);return this.c=V,J}takeFromEndWhile(W){let V=this.d;for(;V>=0&&W(this.g[V]);)V--;const J=V===this.d?null:this.g.slice(V+1,this.d+1);return this.d=V,J}peek(){if(this.length!==0)return this.g[this.c]}peekLast(){if(this.length!==0)return this.g[this.d]}dequeue(){const W=this.g[this.c];return this.c++,W}removeLast(){const W=this.g[this.d];return this.d--,W}takeCount(W){const V=this.g.slice(this.c,this.c+W);return this.c+=W,V}}i.$bc=We;class Me{static{this.empty=new Me(W=>{})}constructor(W){this.iterate=W}forEach(W){this.iterate(V=>(W(V),!0))}toArray(){const W=[];return this.iterate(V=>(W.push(V),!0)),W}filter(W){return new Me(V=>this.iterate(J=>W(J)?V(J):!0))}map(W){return new Me(V=>this.iterate(J=>V(W(J))))}some(W){let V=!1;return this.iterate(J=>(V=W(J),!V)),V}findFirst(W){let V;return this.iterate(J=>W(J)?(V=J,!1):!0),V}findLast(W){let V;return this.iterate(J=>(W(J)&&(V=J),!0)),V}findLastMaxBy(W){let V,J=!0;return this.iterate(ee=>((J||fe.isGreaterThan(W(ee,V)))&&(J=!1,V=ee),!0)),V}}i.$cc=Me;class Oe{constructor(W){this.c=W}static createSortPermutation(W,V){const J=Array.from(W.keys()).sort((ee,he)=>V(W[ee],W[he]));return new Oe(J)}apply(W){return W.map((V,J)=>W[this.c[J]])}inverse(){const W=this.c.slice();for(let V=0;V<this.c.length;V++)W[this.c[V]]=V;return new Oe(W)}}i.$dc=Oe}),ne(ie[11],re([0,1,4]),function(x,i,t){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.ok=n,i.$hd=p,i.$id=g,i.$jd=E,i.$kd=d,i.$ld=a;function n(l,c){if(!l)throw new Error(c?`Assertion failed (${c})`:"Assertion Failed")}function p(l,c="Unreachable"){throw new Error(c)}function g(l,c="unexpected state"){if(!l)throw new t.$fb(`Assertion Failed: ${c}`)}function E(l){l||(0,t.$3)(new t.$fb("Soft Assertion Failed"))}function d(l){if(!l()){debugger;l(),(0,t.$3)(new t.$fb("Assertion Failed"))}}function a(l,c){let $=0;for(;$<l.length-1;){const m=l[$],L=l[$+1];if(!c(m,L))return!1;$++}return!0}}),ne(ie[22],re([0,1]),function(x,i){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.$gb=t;function t(n,p){const g=this;let E=!1,d;return function(){if(E)return d;if(E=!0,p)try{d=n.apply(g,arguments)}finally{p()}else d=n.apply(g,arguments);return d}}}),ne(ie[23],re([0,1]),function(x,i){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.Iterable=void 0;var t;(function(n){function p(r){return r&&typeof r=="object"&&typeof r[Symbol.iterator]=="function"}n.is=p;const g=Object.freeze([]);function E(){return g}n.empty=E;function*d(r){yield r}n.single=d;function a(r){return p(r)?r:d(r)}n.wrap=a;function l(r){return r||g}n.from=l;function*c(r){for(let o=r.length-1;o>=0;o--)yield r[o]}n.reverse=c;function $(r){return!r||r[Symbol.iterator]().next().done===!0}n.isEmpty=$;function m(r){return r[Symbol.iterator]().next().value}n.first=m;function L(r,o){let f=0;for(const T of r)if(o(T,f++))return!0;return!1}n.some=L;function e(r,o){for(const f of r)if(o(f))return f}n.find=e;function*b(r,o){for(const f of r)o(f)&&(yield f)}n.filter=b;function*N(r,o){let f=0;for(const T of r)yield o(T,f++)}n.map=N;function*R(r,o){let f=0;for(const T of r)yield*o(T,f++)}n.flatMap=R;function*A(...r){for(const o of r)yield*o}n.concat=A;function w(r,o,f){let T=f;for(const _ of r)T=o(T,_);return T}n.reduce=w;function*v(r,o,f=r.length){for(o<0&&(o+=r.length),f<0?f+=r.length:f>r.length&&(f=r.length);o<f;o++)yield r[o]}n.slice=v;function h(r,o=Number.POSITIVE_INFINITY){const f=[];if(o===0)return[f,r];const T=r[Symbol.iterator]();for(let _=0;_<o;_++){const M=T.next();if(M.done)return[f,n.empty()];f.push(M.value)}return[f,{[Symbol.iterator](){return T}}]}n.consume=h;async function u(r){const o=[];for await(const f of r)o.push(f);return Promise.resolve(o)}n.asyncToArray=u})(t||(i.Iterable=t={}))}),ne(ie[40],re([0,1]),function(x,i){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.KeyMod=i.KeyCodeUtils=i.$Vr=i.$Ur=i.$Tr=i.$Sr=i.$Rr=i.ScanCode=i.KeyCode=void 0,i.$Wr=L;var t;(function(e){e[e.DependsOnKbLayout=-1]="DependsOnKbLayout",e[e.Unknown=0]="Unknown",e[e.Backspace=1]="Backspace",e[e.Tab=2]="Tab",e[e.Enter=3]="Enter",e[e.Shift=4]="Shift",e[e.Ctrl=5]="Ctrl",e[e.Alt=6]="Alt",e[e.PauseBreak=7]="PauseBreak",e[e.CapsLock=8]="CapsLock",e[e.Escape=9]="Escape",e[e.Space=10]="Space",e[e.PageUp=11]="PageUp",e[e.PageDown=12]="PageDown",e[e.End=13]="End",e[e.Home=14]="Home",e[e.LeftArrow=15]="LeftArrow",e[e.UpArrow=16]="UpArrow",e[e.RightArrow=17]="RightArrow",e[e.DownArrow=18]="DownArrow",e[e.Insert=19]="Insert",e[e.Delete=20]="Delete",e[e.Digit0=21]="Digit0",e[e.Digit1=22]="Digit1",e[e.Digit2=23]="Digit2",e[e.Digit3=24]="Digit3",e[e.Digit4=25]="Digit4",e[e.Digit5=26]="Digit5",e[e.Digit6=27]="Digit6",e[e.Digit7=28]="Digit7",e[e.Digit8=29]="Digit8",e[e.Digit9=30]="Digit9",e[e.KeyA=31]="KeyA",e[e.KeyB=32]="KeyB",e[e.KeyC=33]="KeyC",e[e.KeyD=34]="KeyD",e[e.KeyE=35]="KeyE",e[e.KeyF=36]="KeyF",e[e.KeyG=37]="KeyG",e[e.KeyH=38]="KeyH",e[e.KeyI=39]="KeyI",e[e.KeyJ=40]="KeyJ",e[e.KeyK=41]="KeyK",e[e.KeyL=42]="KeyL",e[e.KeyM=43]="KeyM",e[e.KeyN=44]="KeyN",e[e.KeyO=45]="KeyO",e[e.KeyP=46]="KeyP",e[e.KeyQ=47]="KeyQ",e[e.KeyR=48]="KeyR",e[e.KeyS=49]="KeyS",e[e.KeyT=50]="KeyT",e[e.KeyU=51]="KeyU",e[e.KeyV=52]="KeyV",e[e.KeyW=53]="KeyW",e[e.KeyX=54]="KeyX",e[e.KeyY=55]="KeyY",e[e.KeyZ=56]="KeyZ",e[e.Meta=57]="Meta",e[e.ContextMenu=58]="ContextMenu",e[e.F1=59]="F1",e[e.F2=60]="F2",e[e.F3=61]="F3",e[e.F4=62]="F4",e[e.F5=63]="F5",e[e.F6=64]="F6",e[e.F7=65]="F7",e[e.F8=66]="F8",e[e.F9=67]="F9",e[e.F10=68]="F10",e[e.F11=69]="F11",e[e.F12=70]="F12",e[e.F13=71]="F13",e[e.F14=72]="F14",e[e.F15=73]="F15",e[e.F16=74]="F16",e[e.F17=75]="F17",e[e.F18=76]="F18",e[e.F19=77]="F19",e[e.F20=78]="F20",e[e.F21=79]="F21",e[e.F22=80]="F22",e[e.F23=81]="F23",e[e.F24=82]="F24",e[e.NumLock=83]="NumLock",e[e.ScrollLock=84]="ScrollLock",e[e.Semicolon=85]="Semicolon",e[e.Equal=86]="Equal",e[e.Comma=87]="Comma",e[e.Minus=88]="Minus",e[e.Period=89]="Period",e[e.Slash=90]="Slash",e[e.Backquote=91]="Backquote",e[e.BracketLeft=92]="BracketLeft",e[e.Backslash=93]="Backslash",e[e.BracketRight=94]="BracketRight",e[e.Quote=95]="Quote",e[e.OEM_8=96]="OEM_8",e[e.IntlBackslash=97]="IntlBackslash",e[e.Numpad0=98]="Numpad0",e[e.Numpad1=99]="Numpad1",e[e.Numpad2=100]="Numpad2",e[e.Numpad3=101]="Numpad3",e[e.Numpad4=102]="Numpad4",e[e.Numpad5=103]="Numpad5",e[e.Numpad6=104]="Numpad6",e[e.Numpad7=105]="Numpad7",e[e.Numpad8=106]="Numpad8",e[e.Numpad9=107]="Numpad9",e[e.NumpadMultiply=108]="NumpadMultiply",e[e.NumpadAdd=109]="NumpadAdd",e[e.NUMPAD_SEPARATOR=110]="NUMPAD_SEPARATOR",e[e.NumpadSubtract=111]="NumpadSubtract",e[e.NumpadDecimal=112]="NumpadDecimal",e[e.NumpadDivide=113]="NumpadDivide",e[e.KEY_IN_COMPOSITION=114]="KEY_IN_COMPOSITION",e[e.ABNT_C1=115]="ABNT_C1",e[e.ABNT_C2=116]="ABNT_C2",e[e.AudioVolumeMute=117]="AudioVolumeMute",e[e.AudioVolumeUp=118]="AudioVolumeUp",e[e.AudioVolumeDown=119]="AudioVolumeDown",e[e.BrowserSearch=120]="BrowserSearch",e[e.BrowserHome=121]="BrowserHome",e[e.BrowserBack=122]="BrowserBack",e[e.BrowserForward=123]="BrowserForward",e[e.MediaTrackNext=124]="MediaTrackNext",e[e.MediaTrackPrevious=125]="MediaTrackPrevious",e[e.MediaStop=126]="MediaStop",e[e.MediaPlayPause=127]="MediaPlayPause",e[e.LaunchMediaPlayer=128]="LaunchMediaPlayer",e[e.LaunchMail=129]="LaunchMail",e[e.LaunchApp2=130]="LaunchApp2",e[e.Clear=131]="Clear",e[e.MAX_VALUE=132]="MAX_VALUE"})(t||(i.KeyCode=t={}));var n;(function(e){e[e.DependsOnKbLayout=-1]="DependsOnKbLayout",e[e.None=0]="None",e[e.Hyper=1]="Hyper",e[e.Super=2]="Super",e[e.Fn=3]="Fn",e[e.FnLock=4]="FnLock",e[e.Suspend=5]="Suspend",e[e.Resume=6]="Resume",e[e.Turbo=7]="Turbo",e[e.Sleep=8]="Sleep",e[e.WakeUp=9]="WakeUp",e[e.KeyA=10]="KeyA",e[e.KeyB=11]="KeyB",e[e.KeyC=12]="KeyC",e[e.KeyD=13]="KeyD",e[e.KeyE=14]="KeyE",e[e.KeyF=15]="KeyF",e[e.KeyG=16]="KeyG",e[e.KeyH=17]="KeyH",e[e.KeyI=18]="KeyI",e[e.KeyJ=19]="KeyJ",e[e.KeyK=20]="KeyK",e[e.KeyL=21]="KeyL",e[e.KeyM=22]="KeyM",e[e.KeyN=23]="KeyN",e[e.KeyO=24]="KeyO",e[e.KeyP=25]="KeyP",e[e.KeyQ=26]="KeyQ",e[e.KeyR=27]="KeyR",e[e.KeyS=28]="KeyS",e[e.KeyT=29]="KeyT",e[e.KeyU=30]="KeyU",e[e.KeyV=31]="KeyV",e[e.KeyW=32]="KeyW",e[e.KeyX=33]="KeyX",e[e.KeyY=34]="KeyY",e[e.KeyZ=35]="KeyZ",e[e.Digit1=36]="Digit1",e[e.Digit2=37]="Digit2",e[e.Digit3=38]="Digit3",e[e.Digit4=39]="Digit4",e[e.Digit5=40]="Digit5",e[e.Digit6=41]="Digit6",e[e.Digit7=42]="Digit7",e[e.Digit8=43]="Digit8",e[e.Digit9=44]="Digit9",e[e.Digit0=45]="Digit0",e[e.Enter=46]="Enter",e[e.Escape=47]="Escape",e[e.Backspace=48]="Backspace",e[e.Tab=49]="Tab",e[e.Space=50]="Space",e[e.Minus=51]="Minus",e[e.Equal=52]="Equal",e[e.BracketLeft=53]="BracketLeft",e[e.BracketRight=54]="BracketRight",e[e.Backslash=55]="Backslash",e[e.IntlHash=56]="IntlHash",e[e.Semicolon=57]="Semicolon",e[e.Quote=58]="Quote",e[e.Backquote=59]="Backquote",e[e.Comma=60]="Comma",e[e.Period=61]="Period",e[e.Slash=62]="Slash",e[e.CapsLock=63]="CapsLock",e[e.F1=64]="F1",e[e.F2=65]="F2",e[e.F3=66]="F3",e[e.F4=67]="F4",e[e.F5=68]="F5",e[e.F6=69]="F6",e[e.F7=70]="F7",e[e.F8=71]="F8",e[e.F9=72]="F9",e[e.F10=73]="F10",e[e.F11=74]="F11",e[e.F12=75]="F12",e[e.PrintScreen=76]="PrintScreen",e[e.ScrollLock=77]="ScrollLock",e[e.Pause=78]="Pause",e[e.Insert=79]="Insert",e[e.Home=80]="Home",e[e.PageUp=81]="PageUp",e[e.Delete=82]="Delete",e[e.End=83]="End",e[e.PageDown=84]="PageDown",e[e.ArrowRight=85]="ArrowRight",e[e.ArrowLeft=86]="ArrowLeft",e[e.ArrowDown=87]="ArrowDown",e[e.ArrowUp=88]="ArrowUp",e[e.NumLock=89]="NumLock",e[e.NumpadDivide=90]="NumpadDivide",e[e.NumpadMultiply=91]="NumpadMultiply",e[e.NumpadSubtract=92]="NumpadSubtract",e[e.NumpadAdd=93]="NumpadAdd",e[e.NumpadEnter=94]="NumpadEnter",e[e.Numpad1=95]="Numpad1",e[e.Numpad2=96]="Numpad2",e[e.Numpad3=97]="Numpad3",e[e.Numpad4=98]="Numpad4",e[e.Numpad5=99]="Numpad5",e[e.Numpad6=100]="Numpad6",e[e.Numpad7=101]="Numpad7",e[e.Numpad8=102]="Numpad8",e[e.Numpad9=103]="Numpad9",e[e.Numpad0=104]="Numpad0",e[e.NumpadDecimal=105]="NumpadDecimal",e[e.IntlBackslash=106]="IntlBackslash",e[e.ContextMenu=107]="ContextMenu",e[e.Power=108]="Power",e[e.NumpadEqual=109]="NumpadEqual",e[e.F13=110]="F13",e[e.F14=111]="F14",e[e.F15=112]="F15",e[e.F16=113]="F16",e[e.F17=114]="F17",e[e.F18=115]="F18",e[e.F19=116]="F19",e[e.F20=117]="F20",e[e.F21=118]="F21",e[e.F22=119]="F22",e[e.F23=120]="F23",e[e.F24=121]="F24",e[e.Open=122]="Open",e[e.Help=123]="Help",e[e.Select=124]="Select",e[e.Again=125]="Again",e[e.Undo=126]="Undo",e[e.Cut=127]="Cut",e[e.Copy=128]="Copy",e[e.Paste=129]="Paste",e[e.Find=130]="Find",e[e.AudioVolumeMute=131]="AudioVolumeMute",e[e.AudioVolumeUp=132]="AudioVolumeUp",e[e.AudioVolumeDown=133]="AudioVolumeDown",e[e.NumpadComma=134]="NumpadComma",e[e.IntlRo=135]="IntlRo",e[e.KanaMode=136]="KanaMode",e[e.IntlYen=137]="IntlYen",e[e.Convert=138]="Convert",e[e.NonConvert=139]="NonConvert",e[e.Lang1=140]="Lang1",e[e.Lang2=141]="Lang2",e[e.Lang3=142]="Lang3",e[e.Lang4=143]="Lang4",e[e.Lang5=144]="Lang5",e[e.Abort=145]="Abort",e[e.Props=146]="Props",e[e.NumpadParenLeft=147]="NumpadParenLeft",e[e.NumpadParenRight=148]="NumpadParenRight",e[e.NumpadBackspace=149]="NumpadBackspace",e[e.NumpadMemoryStore=150]="NumpadMemoryStore",e[e.NumpadMemoryRecall=151]="NumpadMemoryRecall",e[e.NumpadMemoryClear=152]="NumpadMemoryClear",e[e.NumpadMemoryAdd=153]="NumpadMemoryAdd",e[e.NumpadMemorySubtract=154]="NumpadMemorySubtract",e[e.NumpadClear=155]="NumpadClear",e[e.NumpadClearEntry=156]="NumpadClearEntry",e[e.ControlLeft=157]="ControlLeft",e[e.ShiftLeft=158]="ShiftLeft",e[e.AltLeft=159]="AltLeft",e[e.MetaLeft=160]="MetaLeft",e[e.ControlRight=161]="ControlRight",e[e.ShiftRight=162]="ShiftRight",e[e.AltRight=163]="AltRight",e[e.MetaRight=164]="MetaRight",e[e.BrightnessUp=165]="BrightnessUp",e[e.BrightnessDown=166]="BrightnessDown",e[e.MediaPlay=167]="MediaPlay",e[e.MediaRecord=168]="MediaRecord",e[e.MediaFastForward=169]="MediaFastForward",e[e.MediaRewind=170]="MediaRewind",e[e.MediaTrackNext=171]="MediaTrackNext",e[e.MediaTrackPrevious=172]="MediaTrackPrevious",e[e.MediaStop=173]="MediaStop",e[e.Eject=174]="Eject",e[e.MediaPlayPause=175]="MediaPlayPause",e[e.MediaSelect=176]="MediaSelect",e[e.LaunchMail=177]="LaunchMail",e[e.LaunchApp2=178]="LaunchApp2",e[e.LaunchApp1=179]="LaunchApp1",e[e.SelectTask=180]="SelectTask",e[e.LaunchScreenSaver=181]="LaunchScreenSaver",e[e.BrowserSearch=182]="BrowserSearch",e[e.BrowserHome=183]="BrowserHome",e[e.BrowserBack=184]="BrowserBack",e[e.BrowserForward=185]="BrowserForward",e[e.BrowserStop=186]="BrowserStop",e[e.BrowserRefresh=187]="BrowserRefresh",e[e.BrowserFavorites=188]="BrowserFavorites",e[e.ZoomToggle=189]="ZoomToggle",e[e.MailReply=190]="MailReply",e[e.MailForward=191]="MailForward",e[e.MailSend=192]="MailSend",e[e.MAX_VALUE=193]="MAX_VALUE"})(n||(i.ScanCode=n={}));class p{constructor(){this._keyCodeToStr=[],this._strToKeyCode=Object.create(null)}define(b,N){this._keyCodeToStr[b]=N,this._strToKeyCode[N.toLowerCase()]=b}keyCodeToStr(b){return this._keyCodeToStr[b]}strToKeyCode(b){return this._strToKeyCode[b.toLowerCase()]||t.Unknown}}const g=new p,E=new p,d=new p;i.$Rr=new Array(230),i.$Sr={};const a=[],l=Object.create(null),c=Object.create(null);i.$Tr={lowerCaseToEnum:e=>c[e]||n.None,toEnum:e=>l[e]||n.None,toString:e=>a[e]||"None"},i.$Ur=[],i.$Vr=[];for(let e=0;e<=n.MAX_VALUE;e++)i.$Ur[e]=t.DependsOnKbLayout;for(let e=0;e<=t.MAX_VALUE;e++)i.$Vr[e]=n.DependsOnKbLayout;(function(){const e="",b=[[1,n.None,"None",t.Unknown,"unknown",0,"VK_UNKNOWN",e,e],[1,n.Hyper,"Hyper",t.Unknown,e,0,e,e,e],[1,n.Super,"Super",t.Unknown,e,0,e,e,e],[1,n.Fn,"Fn",t.Unknown,e,0,e,e,e],[1,n.FnLock,"FnLock",t.Unknown,e,0,e,e,e],[1,n.Suspend,"Suspend",t.Unknown,e,0,e,e,e],[1,n.Resume,"Resume",t.Unknown,e,0,e,e,e],[1,n.Turbo,"Turbo",t.Unknown,e,0,e,e,e],[1,n.Sleep,"Sleep",t.Unknown,e,0,"VK_SLEEP",e,e],[1,n.WakeUp,"WakeUp",t.Unknown,e,0,e,e,e],[0,n.KeyA,"KeyA",t.KeyA,"A",65,"VK_A",e,e],[0,n.KeyB,"KeyB",t.KeyB,"B",66,"VK_B",e,e],[0,n.KeyC,"KeyC",t.KeyC,"C",67,"VK_C",e,e],[0,n.KeyD,"KeyD",t.KeyD,"D",68,"VK_D",e,e],[0,n.KeyE,"KeyE",t.KeyE,"E",69,"VK_E",e,e],[0,n.KeyF,"KeyF",t.KeyF,"F",70,"VK_F",e,e],[0,n.KeyG,"KeyG",t.KeyG,"G",71,"VK_G",e,e],[0,n.KeyH,"KeyH",t.KeyH,"H",72,"VK_H",e,e],[0,n.KeyI,"KeyI",t.KeyI,"I",73,"VK_I",e,e],[0,n.KeyJ,"KeyJ",t.KeyJ,"J",74,"VK_J",e,e],[0,n.KeyK,"KeyK",t.KeyK,"K",75,"VK_K",e,e],[0,n.KeyL,"KeyL",t.KeyL,"L",76,"VK_L",e,e],[0,n.KeyM,"KeyM",t.KeyM,"M",77,"VK_M",e,e],[0,n.KeyN,"KeyN",t.KeyN,"N",78,"VK_N",e,e],[0,n.KeyO,"KeyO",t.KeyO,"O",79,"VK_O",e,e],[0,n.KeyP,"KeyP",t.KeyP,"P",80,"VK_P",e,e],[0,n.KeyQ,"KeyQ",t.KeyQ,"Q",81,"VK_Q",e,e],[0,n.KeyR,"KeyR",t.KeyR,"R",82,"VK_R",e,e],[0,n.KeyS,"KeyS",t.KeyS,"S",83,"VK_S",e,e],[0,n.KeyT,"KeyT",t.KeyT,"T",84,"VK_T",e,e],[0,n.KeyU,"KeyU",t.KeyU,"U",85,"VK_U",e,e],[0,n.KeyV,"KeyV",t.KeyV,"V",86,"VK_V",e,e],[0,n.KeyW,"KeyW",t.KeyW,"W",87,"VK_W",e,e],[0,n.KeyX,"KeyX",t.KeyX,"X",88,"VK_X",e,e],[0,n.KeyY,"KeyY",t.KeyY,"Y",89,"VK_Y",e,e],[0,n.KeyZ,"KeyZ",t.KeyZ,"Z",90,"VK_Z",e,e],[0,n.Digit1,"Digit1",t.Digit1,"1",49,"VK_1",e,e],[0,n.Digit2,"Digit2",t.Digit2,"2",50,"VK_2",e,e],[0,n.Digit3,"Digit3",t.Digit3,"3",51,"VK_3",e,e],[0,n.Digit4,"Digit4",t.Digit4,"4",52,"VK_4",e,e],[0,n.Digit5,"Digit5",t.Digit5,"5",53,"VK_5",e,e],[0,n.Digit6,"Digit6",t.Digit6,"6",54,"VK_6",e,e],[0,n.Digit7,"Digit7",t.Digit7,"7",55,"VK_7",e,e],[0,n.Digit8,"Digit8",t.Digit8,"8",56,"VK_8",e,e],[0,n.Digit9,"Digit9",t.Digit9,"9",57,"VK_9",e,e],[0,n.Digit0,"Digit0",t.Digit0,"0",48,"VK_0",e,e],[1,n.Enter,"Enter",t.Enter,"Enter",13,"VK_RETURN",e,e],[1,n.Escape,"Escape",t.Escape,"Escape",27,"VK_ESCAPE",e,e],[1,n.Backspace,"Backspace",t.Backspace,"Backspace",8,"VK_BACK",e,e],[1,n.Tab,"Tab",t.Tab,"Tab",9,"VK_TAB",e,e],[1,n.Space,"Space",t.Space,"Space",32,"VK_SPACE",e,e],[0,n.Minus,"Minus",t.Minus,"-",189,"VK_OEM_MINUS","-","OEM_MINUS"],[0,n.Equal,"Equal",t.Equal,"=",187,"VK_OEM_PLUS","=","OEM_PLUS"],[0,n.BracketLeft,"BracketLeft",t.BracketLeft,"[",219,"VK_OEM_4","[","OEM_4"],[0,n.BracketRight,"BracketRight",t.BracketRight,"]",221,"VK_OEM_6","]","OEM_6"],[0,n.Backslash,"Backslash",t.Backslash,"\\",220,"VK_OEM_5","\\","OEM_5"],[0,n.IntlHash,"IntlHash",t.Unknown,e,0,e,e,e],[0,n.Semicolon,"Semicolon",t.Semicolon,";",186,"VK_OEM_1",";","OEM_1"],[0,n.Quote,"Quote",t.Quote,"'",222,"VK_OEM_7","'","OEM_7"],[0,n.Backquote,"Backquote",t.Backquote,"`",192,"VK_OEM_3","`","OEM_3"],[0,n.Comma,"Comma",t.Comma,",",188,"VK_OEM_COMMA",",","OEM_COMMA"],[0,n.Period,"Period",t.Period,".",190,"VK_OEM_PERIOD",".","OEM_PERIOD"],[0,n.Slash,"Slash",t.Slash,"/",191,"VK_OEM_2","/","OEM_2"],[1,n.CapsLock,"CapsLock",t.CapsLock,"CapsLock",20,"VK_CAPITAL",e,e],[1,n.F1,"F1",t.F1,"F1",112,"VK_F1",e,e],[1,n.F2,"F2",t.F2,"F2",113,"VK_F2",e,e],[1,n.F3,"F3",t.F3,"F3",114,"VK_F3",e,e],[1,n.F4,"F4",t.F4,"F4",115,"VK_F4",e,e],[1,n.F5,"F5",t.F5,"F5",116,"VK_F5",e,e],[1,n.F6,"F6",t.F6,"F6",117,"VK_F6",e,e],[1,n.F7,"F7",t.F7,"F7",118,"VK_F7",e,e],[1,n.F8,"F8",t.F8,"F8",119,"VK_F8",e,e],[1,n.F9,"F9",t.F9,"F9",120,"VK_F9",e,e],[1,n.F10,"F10",t.F10,"F10",121,"VK_F10",e,e],[1,n.F11,"F11",t.F11,"F11",122,"VK_F11",e,e],[1,n.F12,"F12",t.F12,"F12",123,"VK_F12",e,e],[1,n.PrintScreen,"PrintScreen",t.Unknown,e,0,e,e,e],[1,n.ScrollLock,"ScrollLock",t.ScrollLock,"ScrollLock",145,"VK_SCROLL",e,e],[1,n.Pause,"Pause",t.PauseBreak,"PauseBreak",19,"VK_PAUSE",e,e],[1,n.Insert,"Insert",t.Insert,"Insert",45,"VK_INSERT",e,e],[1,n.Home,"Home",t.Home,"Home",36,"VK_HOME",e,e],[1,n.PageUp,"PageUp",t.PageUp,"PageUp",33,"VK_PRIOR",e,e],[1,n.Delete,"Delete",t.Delete,"Delete",46,"VK_DELETE",e,e],[1,n.End,"End",t.End,"End",35,"VK_END",e,e],[1,n.PageDown,"PageDown",t.PageDown,"PageDown",34,"VK_NEXT",e,e],[1,n.ArrowRight,"ArrowRight",t.RightArrow,"RightArrow",39,"VK_RIGHT","Right",e],[1,n.ArrowLeft,"ArrowLeft",t.LeftArrow,"LeftArrow",37,"VK_LEFT","Left",e],[1,n.ArrowDown,"ArrowDown",t.DownArrow,"DownArrow",40,"VK_DOWN","Down",e],[1,n.ArrowUp,"ArrowUp",t.UpArrow,"UpArrow",38,"VK_UP","Up",e],[1,n.NumLock,"NumLock",t.NumLock,"NumLock",144,"VK_NUMLOCK",e,e],[1,n.NumpadDivide,"NumpadDivide",t.NumpadDivide,"NumPad_Divide",111,"VK_DIVIDE",e,e],[1,n.NumpadMultiply,"NumpadMultiply",t.NumpadMultiply,"NumPad_Multiply",106,"VK_MULTIPLY",e,e],[1,n.NumpadSubtract,"NumpadSubtract",t.NumpadSubtract,"NumPad_Subtract",109,"VK_SUBTRACT",e,e],[1,n.NumpadAdd,"NumpadAdd",t.NumpadAdd,"NumPad_Add",107,"VK_ADD",e,e],[1,n.NumpadEnter,"NumpadEnter",t.Enter,e,0,e,e,e],[1,n.Numpad1,"Numpad1",t.Numpad1,"NumPad1",97,"VK_NUMPAD1",e,e],[1,n.Numpad2,"Numpad2",t.Numpad2,"NumPad2",98,"VK_NUMPAD2",e,e],[1,n.Numpad3,"Numpad3",t.Numpad3,"NumPad3",99,"VK_NUMPAD3",e,e],[1,n.Numpad4,"Numpad4",t.Numpad4,"NumPad4",100,"VK_NUMPAD4",e,e],[1,n.Numpad5,"Numpad5",t.Numpad5,"NumPad5",101,"VK_NUMPAD5",e,e],[1,n.Numpad6,"Numpad6",t.Numpad6,"NumPad6",102,"VK_NUMPAD6",e,e],[1,n.Numpad7,"Numpad7",t.Numpad7,"NumPad7",103,"VK_NUMPAD7",e,e],[1,n.Numpad8,"Numpad8",t.Numpad8,"NumPad8",104,"VK_NUMPAD8",e,e],[1,n.Numpad9,"Numpad9",t.Numpad9,"NumPad9",105,"VK_NUMPAD9",e,e],[1,n.Numpad0,"Numpad0",t.Numpad0,"NumPad0",96,"VK_NUMPAD0",e,e],[1,n.NumpadDecimal,"NumpadDecimal",t.NumpadDecimal,"NumPad_Decimal",110,"VK_DECIMAL",e,e],[0,n.IntlBackslash,"IntlBackslash",t.IntlBackslash,"OEM_102",226,"VK_OEM_102",e,e],[1,n.ContextMenu,"ContextMenu",t.ContextMenu,"ContextMenu",93,e,e,e],[1,n.Power,"Power",t.Unknown,e,0,e,e,e],[1,n.NumpadEqual,"NumpadEqual",t.Unknown,e,0,e,e,e],[1,n.F13,"F13",t.F13,"F13",124,"VK_F13",e,e],[1,n.F14,"F14",t.F14,"F14",125,"VK_F14",e,e],[1,n.F15,"F15",t.F15,"F15",126,"VK_F15",e,e],[1,n.F16,"F16",t.F16,"F16",127,"VK_F16",e,e],[1,n.F17,"F17",t.F17,"F17",128,"VK_F17",e,e],[1,n.F18,"F18",t.F18,"F18",129,"VK_F18",e,e],[1,n.F19,"F19",t.F19,"F19",130,"VK_F19",e,e],[1,n.F20,"F20",t.F20,"F20",131,"VK_F20",e,e],[1,n.F21,"F21",t.F21,"F21",132,"VK_F21",e,e],[1,n.F22,"F22",t.F22,"F22",133,"VK_F22",e,e],[1,n.F23,"F23",t.F23,"F23",134,"VK_F23",e,e],[1,n.F24,"F24",t.F24,"F24",135,"VK_F24",e,e],[1,n.Open,"Open",t.Unknown,e,0,e,e,e],[1,n.Help,"Help",t.Unknown,e,0,e,e,e],[1,n.Select,"Select",t.Unknown,e,0,e,e,e],[1,n.Again,"Again",t.Unknown,e,0,e,e,e],[1,n.Undo,"Undo",t.Unknown,e,0,e,e,e],[1,n.Cut,"Cut",t.Unknown,e,0,e,e,e],[1,n.Copy,"Copy",t.Unknown,e,0,e,e,e],[1,n.Paste,"Paste",t.Unknown,e,0,e,e,e],[1,n.Find,"Find",t.Unknown,e,0,e,e,e],[1,n.AudioVolumeMute,"AudioVolumeMute",t.AudioVolumeMute,"AudioVolumeMute",173,"VK_VOLUME_MUTE",e,e],[1,n.AudioVolumeUp,"AudioVolumeUp",t.AudioVolumeUp,"AudioVolumeUp",175,"VK_VOLUME_UP",e,e],[1,n.AudioVolumeDown,"AudioVolumeDown",t.AudioVolumeDown,"AudioVolumeDown",174,"VK_VOLUME_DOWN",e,e],[1,n.NumpadComma,"NumpadComma",t.NUMPAD_SEPARATOR,"NumPad_Separator",108,"VK_SEPARATOR",e,e],[0,n.IntlRo,"IntlRo",t.ABNT_C1,"ABNT_C1",193,"VK_ABNT_C1",e,e],[1,n.KanaMode,"KanaMode",t.Unknown,e,0,e,e,e],[0,n.IntlYen,"IntlYen",t.Unknown,e,0,e,e,e],[1,n.Convert,"Convert",t.Unknown,e,0,e,e,e],[1,n.NonConvert,"NonConvert",t.Unknown,e,0,e,e,e],[1,n.Lang1,"Lang1",t.Unknown,e,0,e,e,e],[1,n.Lang2,"Lang2",t.Unknown,e,0,e,e,e],[1,n.Lang3,"Lang3",t.Unknown,e,0,e,e,e],[1,n.Lang4,"Lang4",t.Unknown,e,0,e,e,e],[1,n.Lang5,"Lang5",t.Unknown,e,0,e,e,e],[1,n.Abort,"Abort",t.Unknown,e,0,e,e,e],[1,n.Props,"Props",t.Unknown,e,0,e,e,e],[1,n.NumpadParenLeft,"NumpadParenLeft",t.Unknown,e,0,e,e,e],[1,n.NumpadParenRight,"NumpadParenRight",t.Unknown,e,0,e,e,e],[1,n.NumpadBackspace,"NumpadBackspace",t.Unknown,e,0,e,e,e],[1,n.NumpadMemoryStore,"NumpadMemoryStore",t.Unknown,e,0,e,e,e],[1,n.NumpadMemoryRecall,"NumpadMemoryRecall",t.Unknown,e,0,e,e,e],[1,n.NumpadMemoryClear,"NumpadMemoryClear",t.Unknown,e,0,e,e,e],[1,n.NumpadMemoryAdd,"NumpadMemoryAdd",t.Unknown,e,0,e,e,e],[1,n.NumpadMemorySubtract,"NumpadMemorySubtract",t.Unknown,e,0,e,e,e],[1,n.NumpadClear,"NumpadClear",t.Clear,"Clear",12,"VK_CLEAR",e,e],[1,n.NumpadClearEntry,"NumpadClearEntry",t.Unknown,e,0,e,e,e],[1,n.None,e,t.Ctrl,"Ctrl",17,"VK_CONTROL",e,e],[1,n.None,e,t.Shift,"Shift",16,"VK_SHIFT",e,e],[1,n.None,e,t.Alt,"Alt",18,"VK_MENU",e,e],[1,n.None,e,t.Meta,"Meta",91,"VK_COMMAND",e,e],[1,n.ControlLeft,"ControlLeft",t.Ctrl,e,0,"VK_LCONTROL",e,e],[1,n.ShiftLeft,"ShiftLeft",t.Shift,e,0,"VK_LSHIFT",e,e],[1,n.AltLeft,"AltLeft",t.Alt,e,0,"VK_LMENU",e,e],[1,n.MetaLeft,"MetaLeft",t.Meta,e,0,"VK_LWIN",e,e],[1,n.ControlRight,"ControlRight",t.Ctrl,e,0,"VK_RCONTROL",e,e],[1,n.ShiftRight,"ShiftRight",t.Shift,e,0,"VK_RSHIFT",e,e],[1,n.AltRight,"AltRight",t.Alt,e,0,"VK_RMENU",e,e],[1,n.MetaRight,"MetaRight",t.Meta,e,0,"VK_RWIN",e,e],[1,n.BrightnessUp,"BrightnessUp",t.Unknown,e,0,e,e,e],[1,n.BrightnessDown,"BrightnessDown",t.Unknown,e,0,e,e,e],[1,n.MediaPlay,"MediaPlay",t.Unknown,e,0,e,e,e],[1,n.MediaRecord,"MediaRecord",t.Unknown,e,0,e,e,e],[1,n.MediaFastForward,"MediaFastForward",t.Unknown,e,0,e,e,e],[1,n.MediaRewind,"MediaRewind",t.Unknown,e,0,e,e,e],[1,n.MediaTrackNext,"MediaTrackNext",t.MediaTrackNext,"MediaTrackNext",176,"VK_MEDIA_NEXT_TRACK",e,e],[1,n.MediaTrackPrevious,"MediaTrackPrevious",t.MediaTrackPrevious,"MediaTrackPrevious",177,"VK_MEDIA_PREV_TRACK",e,e],[1,n.MediaStop,"MediaStop",t.MediaStop,"MediaStop",178,"VK_MEDIA_STOP",e,e],[1,n.Eject,"Eject",t.Unknown,e,0,e,e,e],[1,n.MediaPlayPause,"MediaPlayPause",t.MediaPlayPause,"MediaPlayPause",179,"VK_MEDIA_PLAY_PAUSE",e,e],[1,n.MediaSelect,"MediaSelect",t.LaunchMediaPlayer,"LaunchMediaPlayer",181,"VK_MEDIA_LAUNCH_MEDIA_SELECT",e,e],[1,n.LaunchMail,"LaunchMail",t.LaunchMail,"LaunchMail",180,"VK_MEDIA_LAUNCH_MAIL",e,e],[1,n.LaunchApp2,"LaunchApp2",t.LaunchApp2,"LaunchApp2",183,"VK_MEDIA_LAUNCH_APP2",e,e],[1,n.LaunchApp1,"LaunchApp1",t.Unknown,e,0,"VK_MEDIA_LAUNCH_APP1",e,e],[1,n.SelectTask,"SelectTask",t.Unknown,e,0,e,e,e],[1,n.LaunchScreenSaver,"LaunchScreenSaver",t.Unknown,e,0,e,e,e],[1,n.BrowserSearch,"BrowserSearch",t.BrowserSearch,"BrowserSearch",170,"VK_BROWSER_SEARCH",e,e],[1,n.BrowserHome,"BrowserHome",t.BrowserHome,"BrowserHome",172,"VK_BROWSER_HOME",e,e],[1,n.BrowserBack,"BrowserBack",t.BrowserBack,"BrowserBack",166,"VK_BROWSER_BACK",e,e],[1,n.BrowserForward,"BrowserForward",t.BrowserForward,"BrowserForward",167,"VK_BROWSER_FORWARD",e,e],[1,n.BrowserStop,"BrowserStop",t.Unknown,e,0,"VK_BROWSER_STOP",e,e],[1,n.BrowserRefresh,"BrowserRefresh",t.Unknown,e,0,"VK_BROWSER_REFRESH",e,e],[1,n.BrowserFavorites,"BrowserFavorites",t.Unknown,e,0,"VK_BROWSER_FAVORITES",e,e],[1,n.ZoomToggle,"ZoomToggle",t.Unknown,e,0,e,e,e],[1,n.MailReply,"MailReply",t.Unknown,e,0,e,e,e],[1,n.MailForward,"MailForward",t.Unknown,e,0,e,e,e],[1,n.MailSend,"MailSend",t.Unknown,e,0,e,e,e],[1,n.None,e,t.KEY_IN_COMPOSITION,"KeyInComposition",229,e,e,e],[1,n.None,e,t.ABNT_C2,"ABNT_C2",194,"VK_ABNT_C2",e,e],[1,n.None,e,t.OEM_8,"OEM_8",223,"VK_OEM_8",e,e],[1,n.None,e,t.Unknown,e,0,"VK_KANA",e,e],[1,n.None,e,t.Unknown,e,0,"VK_HANGUL",e,e],[1,n.None,e,t.Unknown,e,0,"VK_JUNJA",e,e],[1,n.None,e,t.Unknown,e,0,"VK_FINAL",e,e],[1,n.None,e,t.Unknown,e,0,"VK_HANJA",e,e],[1,n.None,e,t.Unknown,e,0,"VK_KANJI",e,e],[1,n.None,e,t.Unknown,e,0,"VK_CONVERT",e,e],[1,n.None,e,t.Unknown,e,0,"VK_NONCONVERT",e,e],[1,n.None,e,t.Unknown,e,0,"VK_ACCEPT",e,e],[1,n.None,e,t.Unknown,e,0,"VK_MODECHANGE",e,e],[1,n.None,e,t.Unknown,e,0,"VK_SELECT",e,e],[1,n.None,e,t.Unknown,e,0,"VK_PRINT",e,e],[1,n.None,e,t.Unknown,e,0,"VK_EXECUTE",e,e],[1,n.None,e,t.Unknown,e,0,"VK_SNAPSHOT",e,e],[1,n.None,e,t.Unknown,e,0,"VK_HELP",e,e],[1,n.None,e,t.Unknown,e,0,"VK_APPS",e,e],[1,n.None,e,t.Unknown,e,0,"VK_PROCESSKEY",e,e],[1,n.None,e,t.Unknown,e,0,"VK_PACKET",e,e],[1,n.None,e,t.Unknown,e,0,"VK_DBE_SBCSCHAR",e,e],[1,n.None,e,t.Unknown,e,0,"VK_DBE_DBCSCHAR",e,e],[1,n.None,e,t.Unknown,e,0,"VK_ATTN",e,e],[1,n.None,e,t.Unknown,e,0,"VK_CRSEL",e,e],[1,n.None,e,t.Unknown,e,0,"VK_EXSEL",e,e],[1,n.None,e,t.Unknown,e,0,"VK_EREOF",e,e],[1,n.None,e,t.Unknown,e,0,"VK_PLAY",e,e],[1,n.None,e,t.Unknown,e,0,"VK_ZOOM",e,e],[1,n.None,e,t.Unknown,e,0,"VK_NONAME",e,e],[1,n.None,e,t.Unknown,e,0,"VK_PA1",e,e],[1,n.None,e,t.Unknown,e,0,"VK_OEM_CLEAR",e,e]],N=[],R=[];for(const A of b){const[w,v,h,u,r,o,f,T,_]=A;if(R[v]||(R[v]=!0,a[v]=h,l[h]=v,c[h.toLowerCase()]=v,w&&(i.$Ur[v]=u,u!==t.Unknown&&u!==t.Enter&&u!==t.Ctrl&&u!==t.Shift&&u!==t.Alt&&u!==t.Meta&&(i.$Vr[u]=v))),!N[u]){if(N[u]=!0,!r)throw new Error(`String representation missing for key code ${u} around scan code ${h}`);g.define(u,r),E.define(u,T||r),d.define(u,_||T||r)}o&&(i.$Rr[o]=u),f&&(i.$Sr[f]=u)}i.$Vr[t.Enter]=n.Enter})();var $;(function(e){function b(h){return g.keyCodeToStr(h)}e.toString=b;function N(h){return g.strToKeyCode(h)}e.fromString=N;function R(h){return E.keyCodeToStr(h)}e.toUserSettingsUS=R;function A(h){return d.keyCodeToStr(h)}e.toUserSettingsGeneral=A;function w(h){return E.strToKeyCode(h)||d.strToKeyCode(h)}e.fromUserSettings=w;function v(h){if(h>=t.Numpad0&&h<=t.NumpadDivide)return null;switch(h){case t.UpArrow:return"Up";case t.DownArrow:return"Down";case t.LeftArrow:return"Left";case t.RightArrow:return"Right"}return g.keyCodeToStr(h)}e.toElectronAccelerator=v})($||(i.KeyCodeUtils=$={}));var m;(function(e){e[e.CtrlCmd=2048]="CtrlCmd",e[e.Shift=1024]="Shift",e[e.Alt=512]="Alt",e[e.WinCtrl=256]="WinCtrl"})(m||(i.KeyMod=m={}));function L(e,b){const N=(b&65535)<<16>>>0;return(e|N)>>>0}}),ne(ie[41],re([0,1]),function(x,i){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.$X=void 0;class t{constructor(p){this.d=p,this.a=!1}get hasValue(){return this.a}get value(){if(!this.a)try{this.b=this.d()}catch(p){this.c=p}finally{this.a=!0}if(this.c)throw this.c;return this.b}get rawValue(){return this.b}}i.$X=t}),ne(ie[24],re([0,1]),function(x,i){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.$8c=void 0;class t{static{this.Undefined=new t(void 0)}constructor(g){this.element=g,this.next=t.Undefined,this.prev=t.Undefined}}class n{constructor(){this.a=t.Undefined,this.b=t.Undefined,this.c=0}get size(){return this.c}isEmpty(){return this.a===t.Undefined}clear(){let g=this.a;for(;g!==t.Undefined;){const E=g.next;g.prev=t.Undefined,g.next=t.Undefined,g=E}this.a=t.Undefined,this.b=t.Undefined,this.c=0}unshift(g){return this.d(g,!1)}push(g){return this.d(g,!0)}d(g,E){const d=new t(g);if(this.a===t.Undefined)this.a=d,this.b=d;else if(E){const l=this.b;this.b=d,d.prev=l,l.next=d}else{const l=this.a;this.a=d,d.next=l,l.prev=d}this.c+=1;let a=!1;return()=>{a||(a=!0,this.e(d))}}shift(){if(this.a!==t.Undefined){const g=this.a.element;return this.e(this.a),g}}pop(){if(this.b!==t.Undefined){const g=this.b.element;return this.e(this.b),g}}e(g){if(g.prev!==t.Undefined&&g.next!==t.Undefined){const E=g.prev;E.next=g.next,g.next.prev=E}else g.prev===t.Undefined&&g.next===t.Undefined?(this.a=t.Undefined,this.b=t.Undefined):g.next===t.Undefined?(this.b=this.b.prev,this.b.next=t.Undefined):g.prev===t.Undefined&&(this.a=this.a.next,this.a.prev=t.Undefined);this.c-=1}*[Symbol.iterator](){let g=this.a;for(;g!==t.Undefined;)yield g.element,g=g.next}}i.$8c=n}),ne(ie[16],re([0,1]),function(x,i){"use strict";var t,n,p;Object.defineProperty(i,"__esModule",{value:!0}),i.$Kc=i.$Jc=i.$Ic=i.$Hc=i.$Gc=i.$Fc=i.Touch=i.$Ec=i.$Dc=void 0,i.$Ac=g,i.$Bc=E,i.$Cc=d,i.$Lc=v;function g(h,u,r){let o=h.get(u);return o===void 0&&(o=r,h.set(u,o)),o}function E(h){const u=[];return h.forEach((r,o)=>{u.push(`${o} => ${r}`)}),`Map(${h.size}) {${u.join(", ")}}`}function d(h){const u=[];return h.forEach(r=>{u.push(r)}),`Set(${h.size}) {${u.join(", ")}}`}class a{constructor(u,r){this.uri=u,this.value=r}}function l(h){return Array.isArray(h)}class c{static{this.c=u=>u.toString()}constructor(u,r){if(this[t]="ResourceMap",u instanceof c)this.d=new Map(u.d),this.e=r??c.c;else if(l(u)){this.d=new Map,this.e=r??c.c;for(const[o,f]of u)this.set(o,f)}else this.d=new Map,this.e=u??c.c}set(u,r){return this.d.set(this.e(u),new a(u,r)),this}get(u){return this.d.get(this.e(u))?.value}has(u){return this.d.has(this.e(u))}get size(){return this.d.size}clear(){this.d.clear()}delete(u){return this.d.delete(this.e(u))}forEach(u,r){typeof r<"u"&&(u=u.bind(r));for(const[o,f]of this.d)u(f.value,f.uri,this)}*values(){for(const u of this.d.values())yield u.value}*keys(){for(const u of this.d.values())yield u.uri}*entries(){for(const u of this.d.values())yield[u.uri,u.value]}*[(t=Symbol.toStringTag,Symbol.iterator)](){for(const[,u]of this.d)yield[u.uri,u.value]}}i.$Dc=c;class ${constructor(u,r){this[n]="ResourceSet",!u||typeof u=="function"?this.c=new c(u):(this.c=new c(r),u.forEach(this.add,this))}get size(){return this.c.size}add(u){return this.c.set(u,u),this}clear(){this.c.clear()}delete(u){return this.c.delete(u)}forEach(u,r){this.c.forEach((o,f)=>u.call(r,f,f,this))}has(u){return this.c.has(u)}entries(){return this.c.entries()}keys(){return this.c.keys()}values(){return this.c.keys()}[(n=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}i.$Ec=$;var m;(function(h){h[h.None=0]="None",h[h.AsOld=1]="AsOld",h[h.AsNew=2]="AsNew"})(m||(i.Touch=m={}));class L{constructor(){this[p]="LinkedMap",this.c=new Map,this.d=void 0,this.e=void 0,this.f=0,this.g=0}clear(){this.c.clear(),this.d=void 0,this.e=void 0,this.f=0,this.g++}isEmpty(){return!this.d&&!this.e}get size(){return this.f}get first(){return this.d?.value}get last(){return this.e?.value}has(u){return this.c.has(u)}get(u,r=m.None){const o=this.c.get(u);if(o)return r!==m.None&&this.m(o,r),o.value}set(u,r,o=m.None){let f=this.c.get(u);if(f)f.value=r,o!==m.None&&this.m(f,o);else{switch(f={key:u,value:r,next:void 0,previous:void 0},o){case m.None:this.k(f);break;case m.AsOld:this.j(f);break;case m.AsNew:this.k(f);break;default:this.k(f);break}this.c.set(u,f),this.f++}return this}delete(u){return!!this.remove(u)}remove(u){const r=this.c.get(u);if(r)return this.c.delete(u),this.l(r),this.f--,r.value}shift(){if(!this.d&&!this.e)return;if(!this.d||!this.e)throw new Error("Invalid list");const u=this.d;return this.c.delete(u.key),this.l(u),this.f--,u.value}forEach(u,r){const o=this.g;let f=this.d;for(;f;){if(r?u.bind(r)(f.value,f.key,this):u(f.value,f.key,this),this.g!==o)throw new Error("LinkedMap got modified during iteration.");f=f.next}}keys(){const u=this,r=this.g;let o=this.d;const f={[Symbol.iterator](){return f},next(){if(u.g!==r)throw new Error("LinkedMap got modified during iteration.");if(o){const T={value:o.key,done:!1};return o=o.next,T}else return{value:void 0,done:!0}}};return f}values(){const u=this,r=this.g;let o=this.d;const f={[Symbol.iterator](){return f},next(){if(u.g!==r)throw new Error("LinkedMap got modified during iteration.");if(o){const T={value:o.value,done:!1};return o=o.next,T}else return{value:void 0,done:!0}}};return f}entries(){const u=this,r=this.g;let o=this.d;const f={[Symbol.iterator](){return f},next(){if(u.g!==r)throw new Error("LinkedMap got modified during iteration.");if(o){const T={value:[o.key,o.value],done:!1};return o=o.next,T}else return{value:void 0,done:!0}}};return f}[(p=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}h(u){if(u>=this.size)return;if(u===0){this.clear();return}let r=this.d,o=this.size;for(;r&&o>u;)this.c.delete(r.key),r=r.next,o--;this.d=r,this.f=o,r&&(r.previous=void 0),this.g++}i(u){if(u>=this.size)return;if(u===0){this.clear();return}let r=this.e,o=this.size;for(;r&&o>u;)this.c.delete(r.key),r=r.previous,o--;this.e=r,this.f=o,r&&(r.next=void 0),this.g++}j(u){if(!this.d&&!this.e)this.e=u;else if(this.d)u.next=this.d,this.d.previous=u;else throw new Error("Invalid list");this.d=u,this.g++}k(u){if(!this.d&&!this.e)this.d=u;else if(this.e)u.previous=this.e,this.e.next=u;else throw new Error("Invalid list");this.e=u,this.g++}l(u){if(u===this.d&&u===this.e)this.d=void 0,this.e=void 0;else if(u===this.d){if(!u.next)throw new Error("Invalid list");u.next.previous=void 0,this.d=u.next}else if(u===this.e){if(!u.previous)throw new Error("Invalid list");u.previous.next=void 0,this.e=u.previous}else{const r=u.next,o=u.previous;if(!r||!o)throw new Error("Invalid list");r.previous=o,o.next=r}u.next=void 0,u.previous=void 0,this.g++}m(u,r){if(!this.d||!this.e)throw new Error("Invalid list");if(!(r!==m.AsOld&&r!==m.AsNew)){if(r===m.AsOld){if(u===this.d)return;const o=u.next,f=u.previous;u===this.e?(f.next=void 0,this.e=f):(o.previous=f,f.next=o),u.previous=void 0,u.next=this.d,this.d.previous=u,this.d=u,this.g++}else if(r===m.AsNew){if(u===this.e)return;const o=u.next,f=u.previous;u===this.d?(o.previous=void 0,this.d=o):(o.previous=f,f.next=o),u.next=void 0,u.previous=this.e,this.e.next=u,this.e=u,this.g++}}}toJSON(){const u=[];return this.forEach((r,o)=>{u.push([o,r])}),u}fromJSON(u){this.clear();for(const[r,o]of u)this.set(r,o)}}i.$Fc=L;class e extends L{constructor(u,r=1){super(),this.n=u,this.o=Math.min(Math.max(0,r),1)}get limit(){return this.n}set limit(u){this.n=u,this.p()}get ratio(){return this.o}set ratio(u){this.o=Math.min(Math.max(0,u),1),this.p()}get(u,r=m.AsNew){return super.get(u,r)}peek(u){return super.get(u,m.None)}set(u,r){return super.set(u,r,m.AsNew),this}p(){this.size>this.n&&this.q(Math.round(this.n*this.o))}}class b extends e{constructor(u,r=1){super(u,r)}q(u){this.h(u)}set(u,r){return super.set(u,r),this.p(),this}}i.$Gc=b;class N extends e{constructor(u,r=1){super(u,r)}q(u){this.i(u)}set(u,r){return this.n<=this.size&&!this.has(u)&&this.q(Math.round(this.n*this.o)-1),super.set(u,r),this}}i.$Hc=N;class R{constructor(){this.c=new Map}add(u){return this.c.set(u,(this.c.get(u)||0)+1),this}delete(u){let r=this.c.get(u)||0;return r===0?!1:(r--,r===0?this.c.delete(u):this.c.set(u,r),!0)}has(u){return this.c.has(u)}}i.$Ic=R;class A{constructor(u){if(this.c=new Map,this.d=new Map,u)for(const[r,o]of u)this.set(r,o)}clear(){this.c.clear(),this.d.clear()}set(u,r){this.c.set(u,r),this.d.set(r,u)}get(u){return this.c.get(u)}getKey(u){return this.d.get(u)}delete(u){const r=this.c.get(u);return r===void 0?!1:(this.c.delete(u),this.d.delete(r),!0)}forEach(u,r){this.c.forEach((o,f)=>{u.call(r,o,f,this)})}keys(){return this.c.keys()}values(){return this.c.values()}}i.$Jc=A;class w{constructor(){this.c=new Map}add(u,r){let o=this.c.get(u);o||(o=new Set,this.c.set(u,o)),o.add(r)}delete(u,r){const o=this.c.get(u);o&&(o.delete(r),o.size===0&&this.c.delete(u))}forEach(u,r){const o=this.c.get(u);o&&o.forEach(r)}get(u){const r=this.c.get(u);return r||new Set}}i.$Kc=w;function v(h,u){if(h===u)return!0;if(h.size!==u.size)return!1;for(const[r,o]of h)if(!u.has(r)||u.get(r)!==o)return!1;for(const[r]of u)if(!h.has(r))return!1;return!0}}),ne(ie[12],re([0,1,7,37,16,22,23]),function(x,i,t,n,p,g,E){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.$7c=i.$5c=i.$4c=i.$3c=i.$2c=i.$1c=i.$Zc=i.$Yc=i.$Xc=i.$Wc=i.$Mc=void 0,i.$Nc=c,i.$Oc=$,i.$Pc=m,i.$Qc=b,i.$Rc=N,i.$Sc=R,i.$Tc=A,i.$Uc=w,i.$Vc=v,i.$6c=F;const d=!1;let a=null;class l{constructor(){this.b=new Map}static{this.a=0}c(D){let q=this.b.get(D);return q||(q={parent:null,source:null,isSingleton:!1,value:D,idx:l.a++},this.b.set(D,q)),q}trackDisposable(D){const q=this.c(D);q.source||(q.source=new Error().stack)}setParent(D,q){const X=this.c(D);X.parent=q}markAsDisposed(D){this.b.delete(D)}markAsSingleton(D){this.c(D).isSingleton=!0}f(D,q){const X=q.get(D);if(X)return X;const B=D.parent?this.f(this.c(D.parent),q):D;return q.set(D,B),B}getTrackedDisposables(){const D=new Map;return[...this.b.entries()].filter(([,X])=>X.source!==null&&!this.f(X,D).isSingleton).flatMap(([X])=>X)}computeLeakingDisposables(D=10,q){let X;if(q)X=q;else{const H=new Map,Q=[...this.b.values()].filter(k=>k.source!==null&&!this.f(k,H).isSingleton);if(Q.length===0)return;const C=new Set(Q.map(k=>k.value));if(X=Q.filter(k=>!(k.parent&&C.has(k.parent))),X.length===0)throw new Error("There are cyclic diposable chains!")}if(!X)return;function B(H){function Q(k,z){for(;k.length>0&&z.some(fe=>typeof fe=="string"?fe===k[0]:k[0].match(fe));)k.shift()}const C=H.source.split(`
`).map(k=>k.trim().replace("at ","")).filter(k=>k!=="");return Q(C,["Error",/^trackDisposable \(.*\)$/,/^DisposableTracker.trackDisposable \(.*\)$/]),C.reverse()}const y=new p.$Kc;for(const H of X){const Q=B(H);for(let C=0;C<=Q.length;C++)y.add(Q.slice(0,C).join(`
`),H)}X.sort((0,t.$9b)(H=>H.idx,t.$$b));let Y="",Z=0;for(const H of X.slice(0,D)){Z++;const Q=B(H),C=[];for(let k=0;k<Q.length;k++){let z=Q[k];z=`(shared with ${y.get(Q.slice(0,k+1).join(`
`)).size}/${X.length} leaks) at ${z}`;const oe=y.get(Q.slice(0,k).join(`
`)),we=(0,n.$K)([...oe].map(s=>B(s)[k]),s=>s);delete we[Q[k]];for(const[s,Te]of Object.entries(we))C.unshift(`    - stacktraces of ${Te.length} other leaks continue with ${s}`);C.unshift(z)}Y+=`


==================== Leaking disposable ${Z}/${X.length}: ${H.value.constructor.name} ====================
${C.join(`
`)}
============================================================

`}return X.length>D&&(Y+=`


... and ${X.length-D} more leaking disposables

`),{leaks:X,details:Y}}}i.$Mc=l;function c(S){a=S}if(d){const S="__is_disposable_tracked__";c(new class{trackDisposable(D){const q=new Error("Potentially leaked disposable").stack;setTimeout(()=>{D[S]||console.log(q)},3e3)}setParent(D,q){if(D&&D!==u.None)try{D[S]=!0}catch{}}markAsDisposed(D){if(D&&D!==u.None)try{D[S]=!0}catch{}}markAsSingleton(D){}})}function $(S){return a?.trackDisposable(S),S}function m(S){a?.markAsDisposed(S)}function L(S,D){a?.setParent(S,D)}function e(S,D){if(a)for(const q of S)a.setParent(q,D)}function b(S){return a?.markAsSingleton(S),S}function N(S){return typeof S=="object"&&S!==null&&typeof S.dispose=="function"&&S.dispose.length===0}function R(S){if(E.Iterable.is(S)){const D=[];for(const q of S)if(q)try{q.dispose()}catch(X){D.push(X)}if(D.length===1)throw D[0];if(D.length>1)throw new AggregateError(D,"Encountered errors while disposing of store");return Array.isArray(S)?[]:S}else if(S)return S.dispose(),S}function A(S){for(const D of S)N(D)&&D.dispose();return[]}function w(...S){const D=v(()=>R(S));return e(S,D),D}function v(S){const D=$({dispose:(0,g.$gb)(()=>{m(D),S()})});return D}class h{static{this.DISABLE_DISPOSED_WARNING=!1}constructor(){this.f=new Set,this.g=!1,$(this)}dispose(){this.g||(m(this),this.g=!0,this.clear())}get isDisposed(){return this.g}clear(){if(this.f.size!==0)try{R(this.f)}finally{this.f.clear()}}add(D){if(!D)return D;if(D===this)throw new Error("Cannot register a disposable on itself!");return L(D,this),this.g?h.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this.f.add(D),D}delete(D){if(D){if(D===this)throw new Error("Cannot dispose a disposable on itself!");this.f.delete(D),D.dispose()}}deleteAndLeak(D){D&&this.f.has(D)&&(this.f.delete(D),L(D,null))}}i.$Wc=h;class u{static{this.None=Object.freeze({dispose(){}})}constructor(){this.q=new h,$(this),L(this.q,this)}dispose(){m(this),this.q.dispose()}B(D){if(D===this)throw new Error("Cannot register a disposable on itself!");return this.q.add(D)}}i.$Xc=u;class r{constructor(){this.b=!1,$(this)}get value(){return this.b?void 0:this.a}set value(D){this.b||D===this.a||(this.a?.dispose(),D&&L(D,this),this.a=D)}clear(){this.value=void 0}dispose(){this.b=!0,m(this),this.a?.dispose(),this.a=void 0}clearAndLeak(){const D=this.a;return this.a=void 0,D&&L(D,null),D}}i.$Yc=r;class o{constructor(D){this.a=new r,this.b=!1,this.a.value=D}get value(){return this.a.value}set value(D){this.b||D===this.a.value||(this.a.value=D)}dispose(){this.b=!0,this.a.dispose()}}i.$Zc=o;class f{constructor(D){this.b=D,this.a=1}acquire(){return this.a++,this}release(){return--this.a===0&&this.b.dispose(),this}}i.$1c=f;class T{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,$(this)}set(D){let q=D;return this.unset=()=>q=void 0,this.isset=()=>q!==void 0,this.dispose=()=>{q&&(q(),q=void 0,m(this))},this}}i.$2c=T;class _{constructor(){this.a=new Map}acquire(D,...q){let X=this.a.get(D);X||(X={counter:0,object:this.b(D,...q)},this.a.set(D,X));const{object:B}=X,y=(0,g.$gb)(()=>{--X.counter===0&&(this.c(D,X.object),this.a.delete(D))});return X.counter++,{object:B,dispose:y}}}i.$3c=_;class M{constructor(D){this.a=D}async acquire(D,...q){const X=this.a.acquire(D,...q);try{return{object:await X.object,dispose:()=>X.dispose()}}catch(B){throw X.dispose(),B}}}i.$4c=M;class j{constructor(D){this.object=D}dispose(){}}i.$5c=j;function F(S){const D=new h;try{S(D)}finally{D.dispose()}}class I{constructor(){this.a=new Map,this.b=!1,$(this)}dispose(){m(this),this.b=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(this.a.size)try{R(this.a.values())}finally{this.a.clear()}}has(D){return this.a.has(D)}get size(){return this.a.size}get(D){return this.a.get(D)}set(D,q,X=!1){this.b&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),X||this.a.get(D)?.dispose(),this.a.set(D,q)}deleteAndDispose(D){this.a.get(D)?.dispose(),this.a.delete(D)}deleteAndLeak(D){const q=this.a.get(D);return this.a.delete(D),q}keys(){return this.a.keys()}values(){return this.a.values()}[Symbol.iterator](){return this.a[Symbol.iterator]()}}i.$7c=I}),ne(ie[42],re([0,1]),function(x,i){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.MarshalledId=void 0;var t;(function(n){n[n.Uri=1]="Uri",n[n.Regexp=2]="Regexp",n[n.ScmResource=3]="ScmResource",n[n.ScmResourceGroup=4]="ScmResourceGroup",n[n.ScmProvider=5]="ScmProvider",n[n.CommentController=6]="CommentController",n[n.CommentThread=7]="CommentThread",n[n.CommentThreadInstance=8]="CommentThreadInstance",n[n.CommentThreadReply=9]="CommentThreadReply",n[n.CommentNode=10]="CommentNode",n[n.CommentThreadNode=11]="CommentThreadNode",n[n.TimelineActionContext=12]="TimelineActionContext",n[n.NotebookCellActionContext=13]="NotebookCellActionContext",n[n.NotebookActionContext=14]="NotebookActionContext",n[n.TerminalContext=15]="TerminalContext",n[n.TestItemContext=16]="TestItemContext",n[n.Date=17]="Date",n[n.TestMessageMenuArgs=18]="TestMessageMenuArgs"})(t||(i.MarshalledId=t={}))}),ne(ie[25],re([0,1]),function(x,i){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.$he=void 0;const t=globalThis.performance&&typeof globalThis.performance.now=="function";class n{static create(g){return new n(g)}constructor(g){this.c=t&&g===!1?Date.now:globalThis.performance.now.bind(globalThis.performance),this.a=this.c(),this.b=-1}stop(){this.b=this.c()}reset(){this.a=this.c(),this.b=-1}elapsed(){return this.b!==-1?this.b-this.a:this.c()-this.a}}i.$he=n}),ne(ie[13],re([0,1,4,22,12,24,25]),function(x,i,t,n,p,g,E){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.$xe=i.$we=i.$ve=i.$ue=i.$te=i.$se=i.$re=i.$qe=i.$pe=i.$oe=i.$ne=i.$me=i.$le=i.$je=i.Event=void 0,i.$ke=L;const d=!1,a=!1,l=!1;var c;(function(B){B.None=()=>p.$Xc.None;function y(se){if(l){const{onDidAddListener:te}=se,ae=b.create();let ue=0;se.onDidAddListener=()=>{++ue===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),ae.print()),te?.()}}}function Y(se,te){return s(se,()=>{},0,void 0,!0,void 0,te)}B.defer=Y;function Z(se){return(te,ae=null,ue)=>{let ce=!1,me;return me=se($e=>{if(!ce)return me?me.dispose():ce=!0,te.call(ae,$e)},null,ue),ce&&me.dispose(),me}}B.once=Z;function H(se,te,ae){return oe((ue,ce=null,me)=>se($e=>ue.call(ce,te($e)),null,me),ae)}B.map=H;function Q(se,te,ae){return oe((ue,ce=null,me)=>se($e=>{te($e),ue.call(ce,$e)},null,me),ae)}B.forEach=Q;function C(se,te,ae){return oe((ue,ce=null,me)=>se($e=>te($e)&&ue.call(ce,$e),null,me),ae)}B.filter=C;function k(se){return se}B.signal=k;function z(...se){return(te,ae=null,ue)=>{const ce=(0,p.$Uc)(...se.map(me=>me($e=>te.call(ae,$e))));return we(ce,ue)}}B.any=z;function fe(se,te,ae,ue){let ce=ae;return H(se,me=>(ce=te(ce,me),ce),ue)}B.reduce=fe;function oe(se,te){let ae;const ue={onWillAddFirstListener(){ae=se(ce.fire,ce)},onDidRemoveLastListener(){ae?.dispose()}};te||y(ue);const ce=new r(ue);return te?.add(ce),ce.event}function we(se,te){return te instanceof Array?te.push(se):te&&te.add(se),se}function s(se,te,ae=100,ue=!1,ce=!1,me,$e){let Ne,Ae,Be,xe=0,ge;const je={leakWarningThreshold:me,onWillAddFirstListener(){Ne=se(ze=>{xe++,Ae=te(Ae,ze),ue&&!Be&&(qe.fire(Ae),Ae=void 0),ge=()=>{const Xe=Ae;Ae=void 0,Be=void 0,(!ue||xe>1)&&qe.fire(Xe),xe=0},typeof ae=="number"?(clearTimeout(Be),Be=setTimeout(ge,ae)):Be===void 0&&(Be=0,queueMicrotask(ge))})},onWillRemoveListener(){ce&&xe>0&&ge?.()},onDidRemoveLastListener(){ge=void 0,Ne.dispose()}};$e||y(je);const qe=new r(je);return $e?.add(qe),qe.event}B.debounce=s;function Te(se,te=0,ae){return B.debounce(se,(ue,ce)=>ue?(ue.push(ce),ue):[ce],te,void 0,!0,void 0,ae)}B.accumulate=Te;function Pe(se,te=(ue,ce)=>ue===ce,ae){let ue=!0,ce;return C(se,me=>{const $e=ue||!te(me,ce);return ue=!1,ce=me,$e},ae)}B.latch=Pe;function We(se,te,ae){return[B.filter(se,te,ae),B.filter(se,ue=>!te(ue),ae)]}B.split=We;function Me(se,te=!1,ae=[],ue){let ce=ae.slice(),me=se(Ae=>{ce?ce.push(Ae):Ne.fire(Ae)});ue&&ue.add(me);const $e=()=>{ce?.forEach(Ae=>Ne.fire(Ae)),ce=null},Ne=new r({onWillAddFirstListener(){me||(me=se(Ae=>Ne.fire(Ae)),ue&&ue.add(me))},onDidAddFirstListener(){ce&&(te?setTimeout($e):$e())},onDidRemoveLastListener(){me&&me.dispose(),me=null}});return ue&&ue.add(Ne),Ne.event}B.buffer=Me;function Oe(se,te){return(ue,ce,me)=>{const $e=te(new W);return se(function(Ne){const Ae=$e.evaluate(Ne);Ae!==U&&ue.call(ce,Ae)},void 0,me)}}B.chain=Oe;const U=Symbol("HaltChainable");class W{constructor(){this.f=[]}map(te){return this.f.push(te),this}forEach(te){return this.f.push(ae=>(te(ae),ae)),this}filter(te){return this.f.push(ae=>te(ae)?ae:U),this}reduce(te,ae){let ue=ae;return this.f.push(ce=>(ue=te(ue,ce),ue)),this}latch(te=(ae,ue)=>ae===ue){let ae=!0,ue;return this.f.push(ce=>{const me=ae||!te(ce,ue);return ae=!1,ue=ce,me?ce:U}),this}evaluate(te){for(const ae of this.f)if(te=ae(te),te===U)break;return te}}function V(se,te,ae=ue=>ue){const ue=(...Ne)=>$e.fire(ae(...Ne)),ce=()=>se.on(te,ue),me=()=>se.removeListener(te,ue),$e=new r({onWillAddFirstListener:ce,onDidRemoveLastListener:me});return $e.event}B.fromNodeEventEmitter=V;function J(se,te,ae=ue=>ue){const ue=(...Ne)=>$e.fire(ae(...Ne)),ce=()=>se.addEventListener(te,ue),me=()=>se.removeEventListener(te,ue),$e=new r({onWillAddFirstListener:ce,onDidRemoveLastListener:me});return $e.event}B.fromDOMEventEmitter=J;function ee(se){return new Promise(te=>Z(se)(te))}B.toPromise=ee;function he(se){const te=new r;return se.then(ae=>{te.fire(ae)},()=>{te.fire(void 0)}).finally(()=>{te.dispose()}),te.event}B.fromPromise=he;function de(se,te,ae){return te(ae),se(ue=>te(ue))}B.runAndSubscribe=de;class Ee{constructor(te,ae){this._observable=te,this.f=0,this.g=!1;const ue={onWillAddFirstListener:()=>{te.addObserver(this)},onDidRemoveLastListener:()=>{te.removeObserver(this)}};ae||y(ue),this.emitter=new r(ue),ae&&ae.add(this.emitter)}beginUpdate(te){this.f++}handlePossibleChange(te){}handleChange(te,ae){this.g=!0}endUpdate(te){this.f--,this.f===0&&(this._observable.reportChanges(),this.g&&(this.g=!1,this.emitter.fire(this._observable.get())))}}function ve(se,te){return new Ee(se,te).emitter.event}B.fromObservable=ve;function _e(se){return(te,ae,ue)=>{let ce=0,me=!1;const $e={beginUpdate(){ce++},endUpdate(){ce--,ce===0&&(se.reportChanges(),me&&(me=!1,te.call(ae)))},handlePossibleChange(){},handleChange(){me=!0}};se.addObserver($e),se.reportChanges();const Ne={dispose(){se.removeObserver($e)}};return ue instanceof p.$Wc?ue.add(Ne):Array.isArray(ue)&&ue.push(Ne),Ne}}B.fromObservableLight=_e})(c||(i.Event=c={}));class ${static{this.all=new Set}static{this.f=0}constructor(y){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${y}_${$.f++}`,$.all.add(this)}start(y){this.g=new E.$he,this.listenerCount=y}stop(){if(this.g){const y=this.g.elapsed();this.durations.push(y),this.elapsedOverall+=y,this.invocationCount+=1,this.g=void 0}}}i.$je=$;let m=-1;function L(B){const y=m;return m=B,{dispose(){m=y}}}class e{static{this.f=1}constructor(y,Y,Z=(e.f++).toString(16).padStart(3,"0")){this.j=y,this.threshold=Y,this.name=Z,this.h=0}dispose(){this.g?.clear()}check(y,Y){const Z=this.threshold;if(Z<=0||Y<Z)return;this.g||(this.g=new Map);const H=this.g.get(y.value)||0;if(this.g.set(y.value,H+1),this.h-=1,this.h<=0){this.h=Z*.5;const[Q,C]=this.getMostFrequentStack(),k=`[${this.name}] potential listener LEAK detected, having ${Y} listeners already. MOST frequent listener (${C}):`;console.warn(k),console.warn(Q);const z=new N(k,Q);this.j(z)}return()=>{const Q=this.g.get(y.value)||0;this.g.set(y.value,Q-1)}}getMostFrequentStack(){if(!this.g)return;let y,Y=0;for(const[Z,H]of this.g)(!y||Y<H)&&(y=[Z,H],Y=H);return y}}class b{static create(){const y=new Error;return new b(y.stack??"")}constructor(y){this.value=y}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}class N extends Error{constructor(y,Y){super(y),this.name="ListenerLeakError",this.stack=Y}}i.$le=N;class R extends Error{constructor(y,Y){super(y),this.name="ListenerRefusalError",this.stack=Y}}i.$me=R;let A=0;class w{constructor(y){this.value=y,this.id=A++}}const v=2,h=(B,y)=>{if(B instanceof w)y(B);else for(let Y=0;Y<B.length;Y++){const Z=B[Y];Z&&y(Z)}};let u;if(d){const B=[];setInterval(()=>{B.length!==0&&(console.warn("[LEAKING LISTENERS] GC'ed these listeners that were NOT yet disposed:"),console.warn(B.join(`
`)),B.length=0)},3e3),u=new FinalizationRegistry(y=>{typeof y=="string"&&B.push(y)})}class r{constructor(y){this.z=0,this.f=y,this.g=m>0||this.f?.leakWarningThreshold?new e(y?.onListenerError??t.$3,this.f?.leakWarningThreshold??m):void 0,this.j=this.f?._profName?new $(this.f._profName):void 0,this.w=this.f?.deliveryQueue}dispose(){if(!this.m){if(this.m=!0,this.w?.current===this&&this.w.reset(),this.u){if(a){const y=this.u;queueMicrotask(()=>{h(y,Y=>Y.stack?.print())})}this.u=void 0,this.z=0}this.f?.onDidRemoveLastListener?.(),this.g?.dispose()}}get event(){return this.q??=(y,Y,Z)=>{if(this.g&&this.z>this.g.threshold**2){const z=`[${this.g.name}] REFUSES to accept new listeners because it exceeded its threshold by far (${this.z} vs ${this.g.threshold})`;console.warn(z);const fe=this.g.getMostFrequentStack()??["UNKNOWN stack",-1],oe=new R(`${z}. HINT: Stack shows most frequent listener (${fe[1]}-times)`,fe[0]);return(this.f?.onListenerError||t.$3)(oe),p.$Xc.None}if(this.m)return p.$Xc.None;Y&&(y=y.bind(Y));const H=new w(y);let Q,C;this.g&&this.z>=Math.ceil(this.g.threshold*.2)&&(H.stack=b.create(),Q=this.g.check(H.stack,this.z+1)),a&&(H.stack=C??b.create()),this.u?this.u instanceof w?(this.w??=new f,this.u=[this.u,H]):this.u.push(H):(this.f?.onWillAddFirstListener?.(this),this.u=H,this.f?.onDidAddFirstListener?.(this)),this.z++;const k=(0,p.$Vc)(()=>{u?.unregister(k),Q?.(),this.A(H)});if(Z instanceof p.$Wc?Z.add(k):Array.isArray(Z)&&Z.push(k),u){const z=new Error().stack.split(`
`).slice(2,3).join(`
`).trim(),fe=/(file:|vscode-file:\/\/vscode-app)?(\/[^:]*:\d+:\d+)/.exec(z);u.register(k,fe?.[2]??z,k)}return k},this.q}A(y){if(this.f?.onWillRemoveListener?.(this),!this.u)return;if(this.z===1){this.u=void 0,this.f?.onDidRemoveLastListener?.(this),this.z=0;return}const Y=this.u,Z=Y.indexOf(y);if(Z===-1)throw console.log("disposed?",this.m),console.log("size?",this.z),console.log("arr?",JSON.stringify(this.u)),new Error("Attempted to dispose unknown listener");this.z--,Y[Z]=void 0;const H=this.w.current===this;if(this.z*v<=Y.length){let Q=0;for(let C=0;C<Y.length;C++)Y[C]?Y[Q++]=Y[C]:H&&(this.w.end--,Q<this.w.i&&this.w.i--);Y.length=Q}}B(y,Y){if(!y)return;const Z=this.f?.onListenerError||t.$3;if(!Z){y.value(Y);return}try{y.value(Y)}catch(H){Z(H)}}C(y){const Y=y.current.u;for(;y.i<y.end;)this.B(Y[y.i++],y.value);y.reset()}fire(y){if(this.w?.current&&(this.C(this.w),this.j?.stop()),this.j?.start(this.z),this.u)if(this.u instanceof w)this.B(this.u,y);else{const Y=this.w;Y.enqueue(this,y,this.u.length),this.C(Y)}this.j?.stop()}hasListeners(){return this.z>0}}i.$ne=r;const o=()=>new f;i.$oe=o;class f{constructor(){this.i=-1,this.end=0}enqueue(y,Y,Z){this.i=0,this.end=Z,this.current=y,this.value=Y}reset(){this.i=this.end,this.current=void 0,this.value=void 0}}class T extends r{async fireAsync(y,Y,Z){if(this.u)for(this.h||(this.h=new g.$8c),h(this.u,H=>this.h.push([H.value,y]));this.h.size>0&&!Y.isCancellationRequested;){const[H,Q]=this.h.shift(),C=[],k={...Q,token:Y,waitUntil:z=>{if(Object.isFrozen(C))throw new Error("waitUntil can NOT be called asynchronous");Z&&(z=Z(z,H)),C.push(z)}};try{H(k)}catch(z){(0,t.$3)(z);continue}Object.freeze(C),await Promise.allSettled(C).then(z=>{for(const fe of z)fe.status==="rejected"&&(0,t.$3)(fe.reason)})}}}i.$pe=T;class _ extends r{get isPaused(){return this.h!==0}constructor(y){super(y),this.h=0,this.s=new g.$8c,this.t=y?.merge}pause(){this.h++}resume(){if(this.h!==0&&--this.h===0)if(this.t){if(this.s.size>0){const y=Array.from(this.s);this.s.clear(),super.fire(this.t(y))}}else for(;!this.h&&this.s.size!==0;)super.fire(this.s.shift())}fire(y){this.z&&(this.h!==0?this.s.push(y):super.fire(y))}}i.$qe=_;class M extends _{constructor(y){super(y),this.k=y.delay??100}fire(y){this.o||(this.pause(),this.o=setTimeout(()=>{this.o=void 0,this.resume()},this.k)),super.fire(y)}}i.$re=M;class j extends r{constructor(y){super(y),this.h=[],this.k=y?.merge}fire(y){this.hasListeners()&&(this.h.push(y),this.h.length===1&&queueMicrotask(()=>{this.k?super.fire(this.k(this.h)):this.h.forEach(Y=>super.fire(Y)),this.h=[]}))}}i.$se=j;class F{constructor(){this.g=!1,this.h=[],this.f=new r({onWillAddFirstListener:()=>this.j(),onDidRemoveLastListener:()=>this.k()})}get event(){return this.f.event}add(y){const Y={event:y,listener:null};this.h.push(Y),this.g&&this.m(Y);const Z=()=>{this.g&&this.o(Y);const H=this.h.indexOf(Y);this.h.splice(H,1)};return(0,p.$Vc)((0,n.$gb)(Z))}j(){this.g=!0,this.h.forEach(y=>this.m(y))}k(){this.g=!1,this.h.forEach(y=>this.o(y))}m(y){y.listener=y.event(Y=>this.f.fire(Y))}o(y){y.listener?.dispose(),y.listener=null}dispose(){this.f.dispose();for(const y of this.h)y.listener?.dispose();this.h=[]}}i.$te=F;class I{constructor(y,Y,Z,H){this.f=new p.$Wc;const Q=this.f.add(new F),C=this.f.add(new p.$7c);function k(z){C.set(z,Q.add(H(z)))}for(const z of y)k(z);this.f.add(Y(z=>{k(z)})),this.f.add(Z(z=>{C.deleteAndDispose(z)})),this.event=Q.event}dispose(){this.f.dispose()}}i.$ue=I;class S{constructor(){this.f=[]}wrapEvent(y,Y,Z){return(H,Q,C)=>y(k=>{const z=this.f[this.f.length-1];if(!Y){z?z.buffers.push(()=>H.call(Q,k)):H.call(Q,k);return}const fe=z;if(!fe){H.call(Q,Y(Z,k));return}fe.items??=[],fe.items.push(k),fe.buffers.length===0&&z.buffers.push(()=>{fe.reducedResult??=Z?fe.items.reduce(Y,Z):fe.items.reduce(Y),H.call(Q,fe.reducedResult)})},void 0,C)}bufferEvents(y){const Y={buffers:new Array};this.f.push(Y);const Z=y();return this.f.pop(),Y.buffers.forEach(H=>H()),Z}}i.$ve=S;class D{constructor(){this.f=!1,this.g=c.None,this.h=p.$Xc.None,this.j=new r({onDidAddFirstListener:()=>{this.f=!0,this.h=this.g(this.j.fire,this.j)},onDidRemoveLastListener:()=>{this.f=!1,this.h.dispose()}}),this.event=this.j.event}set input(y){this.g=y,this.f&&(this.h.dispose(),this.h=y(this.j.fire,this.j))}dispose(){this.h.dispose(),this.j.dispose()}}i.$we=D;class q{static const(y){return new X(y)}constructor(y){this.g=y,this.f=new r,this.onDidChange=this.f.event}get value(){return this.g}set value(y){y!==this.g&&(this.g=y,this.f.fire(void 0))}}i.$xe=q;class X{constructor(y){this.value=y,this.onDidChange=c.None}}}),ne(ie[26],re([0,1,13]),function(x,i,t){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.$ye=i.CancellationToken=void 0,i.$ze=d;const n=Object.freeze(function(a,l){const c=setTimeout(a.bind(l),0);return{dispose(){clearTimeout(c)}}});var p;(function(a){function l(c){return c===a.None||c===a.Cancelled||c instanceof g?!0:!c||typeof c!="object"?!1:typeof c.isCancellationRequested=="boolean"&&typeof c.onCancellationRequested=="function"}a.isCancellationToken=l,a.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:t.Event.None}),a.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:n})})(p||(i.CancellationToken=p={}));class g{constructor(){this.a=!1,this.b=null}cancel(){this.a||(this.a=!0,this.b&&(this.b.fire(void 0),this.dispose()))}get isCancellationRequested(){return this.a}get onCancellationRequested(){return this.a?n:(this.b||(this.b=new t.$ne),this.b.event)}dispose(){this.b&&(this.b.dispose(),this.b=null)}}class E{constructor(l){this.f=void 0,this.g=void 0,this.g=l&&l.onCancellationRequested(this.cancel,this)}get token(){return this.f||(this.f=new g),this.f}cancel(){this.f?this.f instanceof g&&this.f.cancel():this.f=p.Cancelled}dispose(l=!1){l&&this.cancel(),this.g?.dispose(),this.f?this.f instanceof g&&this.f.dispose():this.f=p.None}}i.$ye=E;function d(a){const l=new E;return a.add({dispose(){l.cancel()}}),l.token}}),ne(ie[43],re([0,1,26]),function(x,i,t){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.$bf=i.$af=i.$$e=void 0,i.$_e=p;class n{constructor(a){this.b=a,this.a=null}get(){if(this.a)return this.a;const a=new t.$ye,l=this.b(a.token);return this.a={promise:l,dispose:()=>{this.a=null,a.cancel(),a.dispose()}},this.a}}i.$$e=n;function p(d){return d}class g{constructor(a,l){this.a=void 0,this.b=void 0,typeof a=="function"?(this.c=a,this.d=p):(this.c=l,this.d=a.getCacheKey)}get(a){const l=this.d(a);return this.b!==l&&(this.b=l,this.a=this.c(a)),this.a}}i.$af=g;class E{get cachedValues(){return this.a}constructor(a,l){this.a=new Map,this.b=new Map,typeof a=="function"?(this.c=a,this.d=p):(this.c=l,this.d=a.getCacheKey)}get(a){const l=this.d(a);if(this.b.has(l))return this.b.get(l);const c=this.c(a);return this.a.set(a,c),this.b.set(l,c),c}}i.$bf=E}),ne(ie[27],re([0,1]),function(x,i){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.$gg=t,i.$hg=n,i.$ig=p,i.$jg=g,i.$kg=E,i.$lg=d,i.$mg=a,i.$ng=l,i.$og=c,i.$pg=$,i.$qg=m,i.$rg=L,i.$sg=e,i.$tg=N,i.$ug=R,i.$vg=A,i.$wg=w,i.$xg=v;function t(h){return typeof h=="string"}function n(h){return Array.isArray(h)&&h.every(u=>t(u))}function p(h){return typeof h=="object"&&h!==null&&!Array.isArray(h)&&!(h instanceof RegExp)&&!(h instanceof Date)}function g(h){const u=Object.getPrototypeOf(Uint8Array);return typeof h=="object"&&h instanceof u}function E(h){return typeof h=="number"&&!isNaN(h)}function d(h){return!!h&&typeof h[Symbol.iterator]=="function"}function a(h){return h===!0||h===!1}function l(h){return typeof h>"u"}function c(h){return!$(h)}function $(h){return l(h)||h===null}function m(h,u){if(!h)throw new Error(u?`Unexpected type, expected '${u}'`:"Unexpected type")}function L(h){if($(h))throw new Error("Assertion Failed: argument is undefined or null");return h}function e(...h){const u=[];for(let r=0;r<h.length;r++){const o=h[r];if($(o))throw new Error(`Assertion Failed: argument at index ${r} is undefined or null`);u.push(o)}return u}const b=Object.prototype.hasOwnProperty;function N(h){if(!p(h))return!1;for(const u in h)if(b.call(h,u))return!1;return!0}function R(h){return typeof h=="function"}function A(...h){return h.length>0&&h.every(R)}function w(h,u){const r=Math.min(h.length,u.length);for(let o=0;o<r;o++)v(h[o],u[o])}function v(h,u){if(t(u)){if(typeof h!==u)throw new Error(`argument does not match constraint: typeof ${u}`)}else if(R(u)){try{if(h instanceof u)return}catch{}if(!$(h)&&h.constructor===u||u.length===1&&u.call(void 0,h)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}}),ne(ie[28],re([0,1,27]),function(x,i,t){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.$1j=p,i.$2j=g;const n=Object.create(null);function p(E,d){if((0,t.$gg)(d)){const a=n[d];if(a===void 0)throw new Error(`${E} references an unknown codicon: ${d}`);d=a}return n[E]=d,{id:E}}function g(){return n}}),ne(ie[44],re([0,1,28]),function(x,i,t){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.$3j=void 0,i.$3j={add:(0,t.$1j)("add",6e4),plus:(0,t.$1j)("plus",6e4),gistNew:(0,t.$1j)("gist-new",6e4),repoCreate:(0,t.$1j)("repo-create",6e4),lightbulb:(0,t.$1j)("lightbulb",60001),lightBulb:(0,t.$1j)("light-bulb",60001),repo:(0,t.$1j)("repo",60002),repoDelete:(0,t.$1j)("repo-delete",60002),gistFork:(0,t.$1j)("gist-fork",60003),repoForked:(0,t.$1j)("repo-forked",60003),gitPullRequest:(0,t.$1j)("git-pull-request",60004),gitPullRequestAbandoned:(0,t.$1j)("git-pull-request-abandoned",60004),recordKeys:(0,t.$1j)("record-keys",60005),keyboard:(0,t.$1j)("keyboard",60005),tag:(0,t.$1j)("tag",60006),gitPullRequestLabel:(0,t.$1j)("git-pull-request-label",60006),tagAdd:(0,t.$1j)("tag-add",60006),tagRemove:(0,t.$1j)("tag-remove",60006),person:(0,t.$1j)("person",60007),personFollow:(0,t.$1j)("person-follow",60007),personOutline:(0,t.$1j)("person-outline",60007),personFilled:(0,t.$1j)("person-filled",60007),gitBranch:(0,t.$1j)("git-branch",60008),gitBranchCreate:(0,t.$1j)("git-branch-create",60008),gitBranchDelete:(0,t.$1j)("git-branch-delete",60008),sourceControl:(0,t.$1j)("source-control",60008),mirror:(0,t.$1j)("mirror",60009),mirrorPublic:(0,t.$1j)("mirror-public",60009),star:(0,t.$1j)("star",60010),starAdd:(0,t.$1j)("star-add",60010),starDelete:(0,t.$1j)("star-delete",60010),starEmpty:(0,t.$1j)("star-empty",60010),comment:(0,t.$1j)("comment",60011),commentAdd:(0,t.$1j)("comment-add",60011),alert:(0,t.$1j)("alert",60012),warning:(0,t.$1j)("warning",60012),search:(0,t.$1j)("search",60013),searchSave:(0,t.$1j)("search-save",60013),logOut:(0,t.$1j)("log-out",60014),signOut:(0,t.$1j)("sign-out",60014),logIn:(0,t.$1j)("log-in",60015),signIn:(0,t.$1j)("sign-in",60015),eye:(0,t.$1j)("eye",60016),eyeUnwatch:(0,t.$1j)("eye-unwatch",60016),eyeWatch:(0,t.$1j)("eye-watch",60016),circleFilled:(0,t.$1j)("circle-filled",60017),primitiveDot:(0,t.$1j)("primitive-dot",60017),closeDirty:(0,t.$1j)("close-dirty",60017),debugBreakpoint:(0,t.$1j)("debug-breakpoint",60017),debugBreakpointDisabled:(0,t.$1j)("debug-breakpoint-disabled",60017),debugHint:(0,t.$1j)("debug-hint",60017),terminalDecorationSuccess:(0,t.$1j)("terminal-decoration-success",60017),primitiveSquare:(0,t.$1j)("primitive-square",60018),edit:(0,t.$1j)("edit",60019),pencil:(0,t.$1j)("pencil",60019),info:(0,t.$1j)("info",60020),issueOpened:(0,t.$1j)("issue-opened",60020),gistPrivate:(0,t.$1j)("gist-private",60021),gitForkPrivate:(0,t.$1j)("git-fork-private",60021),lock:(0,t.$1j)("lock",60021),mirrorPrivate:(0,t.$1j)("mirror-private",60021),close:(0,t.$1j)("close",60022),removeClose:(0,t.$1j)("remove-close",60022),x:(0,t.$1j)("x",60022),repoSync:(0,t.$1j)("repo-sync",60023),sync:(0,t.$1j)("sync",60023),clone:(0,t.$1j)("clone",60024),desktopDownload:(0,t.$1j)("desktop-download",60024),beaker:(0,t.$1j)("beaker",60025),microscope:(0,t.$1j)("microscope",60025),vm:(0,t.$1j)("vm",60026),deviceDesktop:(0,t.$1j)("device-desktop",60026),file:(0,t.$1j)("file",60027),fileText:(0,t.$1j)("file-text",60027),more:(0,t.$1j)("more",60028),ellipsis:(0,t.$1j)("ellipsis",60028),kebabHorizontal:(0,t.$1j)("kebab-horizontal",60028),mailReply:(0,t.$1j)("mail-reply",60029),reply:(0,t.$1j)("reply",60029),organization:(0,t.$1j)("organization",60030),organizationFilled:(0,t.$1j)("organization-filled",60030),organizationOutline:(0,t.$1j)("organization-outline",60030),newFile:(0,t.$1j)("new-file",60031),fileAdd:(0,t.$1j)("file-add",60031),newFolder:(0,t.$1j)("new-folder",60032),fileDirectoryCreate:(0,t.$1j)("file-directory-create",60032),trash:(0,t.$1j)("trash",60033),trashcan:(0,t.$1j)("trashcan",60033),history:(0,t.$1j)("history",60034),clock:(0,t.$1j)("clock",60034),folder:(0,t.$1j)("folder",60035),fileDirectory:(0,t.$1j)("file-directory",60035),symbolFolder:(0,t.$1j)("symbol-folder",60035),logoGithub:(0,t.$1j)("logo-github",60036),markGithub:(0,t.$1j)("mark-github",60036),github:(0,t.$1j)("github",60036),terminal:(0,t.$1j)("terminal",60037),console:(0,t.$1j)("console",60037),repl:(0,t.$1j)("repl",60037),zap:(0,t.$1j)("zap",60038),symbolEvent:(0,t.$1j)("symbol-event",60038),error:(0,t.$1j)("error",60039),stop:(0,t.$1j)("stop",60039),variable:(0,t.$1j)("variable",60040),symbolVariable:(0,t.$1j)("symbol-variable",60040),array:(0,t.$1j)("array",60042),symbolArray:(0,t.$1j)("symbol-array",60042),symbolModule:(0,t.$1j)("symbol-module",60043),symbolPackage:(0,t.$1j)("symbol-package",60043),symbolNamespace:(0,t.$1j)("symbol-namespace",60043),symbolObject:(0,t.$1j)("symbol-object",60043),symbolMethod:(0,t.$1j)("symbol-method",60044),symbolFunction:(0,t.$1j)("symbol-function",60044),symbolConstructor:(0,t.$1j)("symbol-constructor",60044),symbolBoolean:(0,t.$1j)("symbol-boolean",60047),symbolNull:(0,t.$1j)("symbol-null",60047),symbolNumeric:(0,t.$1j)("symbol-numeric",60048),symbolNumber:(0,t.$1j)("symbol-number",60048),symbolStructure:(0,t.$1j)("symbol-structure",60049),symbolStruct:(0,t.$1j)("symbol-struct",60049),symbolParameter:(0,t.$1j)("symbol-parameter",60050),symbolTypeParameter:(0,t.$1j)("symbol-type-parameter",60050),symbolKey:(0,t.$1j)("symbol-key",60051),symbolText:(0,t.$1j)("symbol-text",60051),symbolReference:(0,t.$1j)("symbol-reference",60052),goToFile:(0,t.$1j)("go-to-file",60052),symbolEnum:(0,t.$1j)("symbol-enum",60053),symbolValue:(0,t.$1j)("symbol-value",60053),symbolRuler:(0,t.$1j)("symbol-ruler",60054),symbolUnit:(0,t.$1j)("symbol-unit",60054),activateBreakpoints:(0,t.$1j)("activate-breakpoints",60055),archive:(0,t.$1j)("archive",60056),arrowBoth:(0,t.$1j)("arrow-both",60057),arrowDown:(0,t.$1j)("arrow-down",60058),arrowLeft:(0,t.$1j)("arrow-left",60059),arrowRight:(0,t.$1j)("arrow-right",60060),arrowSmallDown:(0,t.$1j)("arrow-small-down",60061),arrowSmallLeft:(0,t.$1j)("arrow-small-left",60062),arrowSmallRight:(0,t.$1j)("arrow-small-right",60063),arrowSmallUp:(0,t.$1j)("arrow-small-up",60064),arrowUp:(0,t.$1j)("arrow-up",60065),bell:(0,t.$1j)("bell",60066),bold:(0,t.$1j)("bold",60067),book:(0,t.$1j)("book",60068),bookmark:(0,t.$1j)("bookmark",60069),debugBreakpointConditionalUnverified:(0,t.$1j)("debug-breakpoint-conditional-unverified",60070),debugBreakpointConditional:(0,t.$1j)("debug-breakpoint-conditional",60071),debugBreakpointConditionalDisabled:(0,t.$1j)("debug-breakpoint-conditional-disabled",60071),debugBreakpointDataUnverified:(0,t.$1j)("debug-breakpoint-data-unverified",60072),debugBreakpointData:(0,t.$1j)("debug-breakpoint-data",60073),debugBreakpointDataDisabled:(0,t.$1j)("debug-breakpoint-data-disabled",60073),debugBreakpointLogUnverified:(0,t.$1j)("debug-breakpoint-log-unverified",60074),debugBreakpointLog:(0,t.$1j)("debug-breakpoint-log",60075),debugBreakpointLogDisabled:(0,t.$1j)("debug-breakpoint-log-disabled",60075),briefcase:(0,t.$1j)("briefcase",60076),broadcast:(0,t.$1j)("broadcast",60077),browser:(0,t.$1j)("browser",60078),bug:(0,t.$1j)("bug",60079),calendar:(0,t.$1j)("calendar",60080),caseSensitive:(0,t.$1j)("case-sensitive",60081),check:(0,t.$1j)("check",60082),checklist:(0,t.$1j)("checklist",60083),chevronDown:(0,t.$1j)("chevron-down",60084),chevronLeft:(0,t.$1j)("chevron-left",60085),chevronRight:(0,t.$1j)("chevron-right",60086),chevronUp:(0,t.$1j)("chevron-up",60087),chromeClose:(0,t.$1j)("chrome-close",60088),chromeMaximize:(0,t.$1j)("chrome-maximize",60089),chromeMinimize:(0,t.$1j)("chrome-minimize",60090),chromeRestore:(0,t.$1j)("chrome-restore",60091),circleOutline:(0,t.$1j)("circle-outline",60092),circle:(0,t.$1j)("circle",60092),debugBreakpointUnverified:(0,t.$1j)("debug-breakpoint-unverified",60092),terminalDecorationIncomplete:(0,t.$1j)("terminal-decoration-incomplete",60092),circleSlash:(0,t.$1j)("circle-slash",60093),circuitBoard:(0,t.$1j)("circuit-board",60094),clearAll:(0,t.$1j)("clear-all",60095),clippy:(0,t.$1j)("clippy",60096),closeAll:(0,t.$1j)("close-all",60097),cloudDownload:(0,t.$1j)("cloud-download",60098),cloudUpload:(0,t.$1j)("cloud-upload",60099),code:(0,t.$1j)("code",60100),collapseAll:(0,t.$1j)("collapse-all",60101),colorMode:(0,t.$1j)("color-mode",60102),commentDiscussion:(0,t.$1j)("comment-discussion",60103),creditCard:(0,t.$1j)("credit-card",60105),dash:(0,t.$1j)("dash",60108),dashboard:(0,t.$1j)("dashboard",60109),database:(0,t.$1j)("database",60110),debugContinue:(0,t.$1j)("debug-continue",60111),debugDisconnect:(0,t.$1j)("debug-disconnect",60112),debugPause:(0,t.$1j)("debug-pause",60113),debugRestart:(0,t.$1j)("debug-restart",60114),debugStart:(0,t.$1j)("debug-start",60115),debugStepInto:(0,t.$1j)("debug-step-into",60116),debugStepOut:(0,t.$1j)("debug-step-out",60117),debugStepOver:(0,t.$1j)("debug-step-over",60118),debugStop:(0,t.$1j)("debug-stop",60119),debug:(0,t.$1j)("debug",60120),deviceCameraVideo:(0,t.$1j)("device-camera-video",60121),deviceCamera:(0,t.$1j)("device-camera",60122),deviceMobile:(0,t.$1j)("device-mobile",60123),diffAdded:(0,t.$1j)("diff-added",60124),diffIgnored:(0,t.$1j)("diff-ignored",60125),diffModified:(0,t.$1j)("diff-modified",60126),diffRemoved:(0,t.$1j)("diff-removed",60127),diffRenamed:(0,t.$1j)("diff-renamed",60128),diff:(0,t.$1j)("diff",60129),diffSidebyside:(0,t.$1j)("diff-sidebyside",60129),discard:(0,t.$1j)("discard",60130),editorLayout:(0,t.$1j)("editor-layout",60131),emptyWindow:(0,t.$1j)("empty-window",60132),exclude:(0,t.$1j)("exclude",60133),extensions:(0,t.$1j)("extensions",60134),eyeClosed:(0,t.$1j)("eye-closed",60135),fileBinary:(0,t.$1j)("file-binary",60136),fileCode:(0,t.$1j)("file-code",60137),fileMedia:(0,t.$1j)("file-media",60138),filePdf:(0,t.$1j)("file-pdf",60139),fileSubmodule:(0,t.$1j)("file-submodule",60140),fileSymlinkDirectory:(0,t.$1j)("file-symlink-directory",60141),fileSymlinkFile:(0,t.$1j)("file-symlink-file",60142),fileZip:(0,t.$1j)("file-zip",60143),files:(0,t.$1j)("files",60144),filter:(0,t.$1j)("filter",60145),flame:(0,t.$1j)("flame",60146),foldDown:(0,t.$1j)("fold-down",60147),foldUp:(0,t.$1j)("fold-up",60148),fold:(0,t.$1j)("fold",60149),folderActive:(0,t.$1j)("folder-active",60150),folderOpened:(0,t.$1j)("folder-opened",60151),gear:(0,t.$1j)("gear",60152),gift:(0,t.$1j)("gift",60153),gistSecret:(0,t.$1j)("gist-secret",60154),gist:(0,t.$1j)("gist",60155),gitCommit:(0,t.$1j)("git-commit",60156),gitCompare:(0,t.$1j)("git-compare",60157),compareChanges:(0,t.$1j)("compare-changes",60157),gitMerge:(0,t.$1j)("git-merge",60158),githubAction:(0,t.$1j)("github-action",60159),githubAlt:(0,t.$1j)("github-alt",60160),globe:(0,t.$1j)("globe",60161),grabber:(0,t.$1j)("grabber",60162),graph:(0,t.$1j)("graph",60163),gripper:(0,t.$1j)("gripper",60164),heart:(0,t.$1j)("heart",60165),home:(0,t.$1j)("home",60166),horizontalRule:(0,t.$1j)("horizontal-rule",60167),hubot:(0,t.$1j)("hubot",60168),inbox:(0,t.$1j)("inbox",60169),issueReopened:(0,t.$1j)("issue-reopened",60171),issues:(0,t.$1j)("issues",60172),italic:(0,t.$1j)("italic",60173),jersey:(0,t.$1j)("jersey",60174),json:(0,t.$1j)("json",60175),kebabVertical:(0,t.$1j)("kebab-vertical",60176),key:(0,t.$1j)("key",60177),law:(0,t.$1j)("law",60178),lightbulbAutofix:(0,t.$1j)("lightbulb-autofix",60179),linkExternal:(0,t.$1j)("link-external",60180),link:(0,t.$1j)("link",60181),listOrdered:(0,t.$1j)("list-ordered",60182),listUnordered:(0,t.$1j)("list-unordered",60183),liveShare:(0,t.$1j)("live-share",60184),loading:(0,t.$1j)("loading",60185),location:(0,t.$1j)("location",60186),mailRead:(0,t.$1j)("mail-read",60187),mail:(0,t.$1j)("mail",60188),markdown:(0,t.$1j)("markdown",60189),megaphone:(0,t.$1j)("megaphone",60190),mention:(0,t.$1j)("mention",60191),milestone:(0,t.$1j)("milestone",60192),gitPullRequestMilestone:(0,t.$1j)("git-pull-request-milestone",60192),mortarBoard:(0,t.$1j)("mortar-board",60193),move:(0,t.$1j)("move",60194),multipleWindows:(0,t.$1j)("multiple-windows",60195),mute:(0,t.$1j)("mute",60196),noNewline:(0,t.$1j)("no-newline",60197),note:(0,t.$1j)("note",60198),octoface:(0,t.$1j)("octoface",60199),openPreview:(0,t.$1j)("open-preview",60200),package:(0,t.$1j)("package",60201),paintcan:(0,t.$1j)("paintcan",60202),pin:(0,t.$1j)("pin",60203),play:(0,t.$1j)("play",60204),run:(0,t.$1j)("run",60204),plug:(0,t.$1j)("plug",60205),preserveCase:(0,t.$1j)("preserve-case",60206),preview:(0,t.$1j)("preview",60207),project:(0,t.$1j)("project",60208),pulse:(0,t.$1j)("pulse",60209),question:(0,t.$1j)("question",60210),quote:(0,t.$1j)("quote",60211),radioTower:(0,t.$1j)("radio-tower",60212),reactions:(0,t.$1j)("reactions",60213),references:(0,t.$1j)("references",60214),refresh:(0,t.$1j)("refresh",60215),regex:(0,t.$1j)("regex",60216),remoteExplorer:(0,t.$1j)("remote-explorer",60217),remote:(0,t.$1j)("remote",60218),remove:(0,t.$1j)("remove",60219),replaceAll:(0,t.$1j)("replace-all",60220),replace:(0,t.$1j)("replace",60221),repoClone:(0,t.$1j)("repo-clone",60222),repoForcePush:(0,t.$1j)("repo-force-push",60223),repoPull:(0,t.$1j)("repo-pull",60224),repoPush:(0,t.$1j)("repo-push",60225),report:(0,t.$1j)("report",60226),requestChanges:(0,t.$1j)("request-changes",60227),rocket:(0,t.$1j)("rocket",60228),rootFolderOpened:(0,t.$1j)("root-folder-opened",60229),rootFolder:(0,t.$1j)("root-folder",60230),rss:(0,t.$1j)("rss",60231),ruby:(0,t.$1j)("ruby",60232),saveAll:(0,t.$1j)("save-all",60233),saveAs:(0,t.$1j)("save-as",60234),save:(0,t.$1j)("save",60235),screenFull:(0,t.$1j)("screen-full",60236),screenNormal:(0,t.$1j)("screen-normal",60237),searchStop:(0,t.$1j)("search-stop",60238),server:(0,t.$1j)("server",60240),settingsGear:(0,t.$1j)("settings-gear",60241),settings:(0,t.$1j)("settings",60242),shield:(0,t.$1j)("shield",60243),smiley:(0,t.$1j)("smiley",60244),sortPrecedence:(0,t.$1j)("sort-precedence",60245),splitHorizontal:(0,t.$1j)("split-horizontal",60246),splitVertical:(0,t.$1j)("split-vertical",60247),squirrel:(0,t.$1j)("squirrel",60248),starFull:(0,t.$1j)("star-full",60249),starHalf:(0,t.$1j)("star-half",60250),symbolClass:(0,t.$1j)("symbol-class",60251),symbolColor:(0,t.$1j)("symbol-color",60252),symbolConstant:(0,t.$1j)("symbol-constant",60253),symbolEnumMember:(0,t.$1j)("symbol-enum-member",60254),symbolField:(0,t.$1j)("symbol-field",60255),symbolFile:(0,t.$1j)("symbol-file",60256),symbolInterface:(0,t.$1j)("symbol-interface",60257),symbolKeyword:(0,t.$1j)("symbol-keyword",60258),symbolMisc:(0,t.$1j)("symbol-misc",60259),symbolOperator:(0,t.$1j)("symbol-operator",60260),symbolProperty:(0,t.$1j)("symbol-property",60261),wrench:(0,t.$1j)("wrench",60261),wrenchSubaction:(0,t.$1j)("wrench-subaction",60261),symbolSnippet:(0,t.$1j)("symbol-snippet",60262),tasklist:(0,t.$1j)("tasklist",60263),telescope:(0,t.$1j)("telescope",60264),textSize:(0,t.$1j)("text-size",60265),threeBars:(0,t.$1j)("three-bars",60266),thumbsdown:(0,t.$1j)("thumbsdown",60267),thumbsup:(0,t.$1j)("thumbsup",60268),tools:(0,t.$1j)("tools",60269),triangleDown:(0,t.$1j)("triangle-down",60270),triangleLeft:(0,t.$1j)("triangle-left",60271),triangleRight:(0,t.$1j)("triangle-right",60272),triangleUp:(0,t.$1j)("triangle-up",60273),twitter:(0,t.$1j)("twitter",60274),unfold:(0,t.$1j)("unfold",60275),unlock:(0,t.$1j)("unlock",60276),unmute:(0,t.$1j)("unmute",60277),unverified:(0,t.$1j)("unverified",60278),verified:(0,t.$1j)("verified",60279),versions:(0,t.$1j)("versions",60280),vmActive:(0,t.$1j)("vm-active",60281),vmOutline:(0,t.$1j)("vm-outline",60282),vmRunning:(0,t.$1j)("vm-running",60283),watch:(0,t.$1j)("watch",60284),whitespace:(0,t.$1j)("whitespace",60285),wholeWord:(0,t.$1j)("whole-word",60286),window:(0,t.$1j)("window",60287),wordWrap:(0,t.$1j)("word-wrap",60288),zoomIn:(0,t.$1j)("zoom-in",60289),zoomOut:(0,t.$1j)("zoom-out",60290),listFilter:(0,t.$1j)("list-filter",60291),listFlat:(0,t.$1j)("list-flat",60292),listSelection:(0,t.$1j)("list-selection",60293),selection:(0,t.$1j)("selection",60293),listTree:(0,t.$1j)("list-tree",60294),debugBreakpointFunctionUnverified:(0,t.$1j)("debug-breakpoint-function-unverified",60295),debugBreakpointFunction:(0,t.$1j)("debug-breakpoint-function",60296),debugBreakpointFunctionDisabled:(0,t.$1j)("debug-breakpoint-function-disabled",60296),debugStackframeActive:(0,t.$1j)("debug-stackframe-active",60297),circleSmallFilled:(0,t.$1j)("circle-small-filled",60298),debugStackframeDot:(0,t.$1j)("debug-stackframe-dot",60298),terminalDecorationMark:(0,t.$1j)("terminal-decoration-mark",60298),debugStackframe:(0,t.$1j)("debug-stackframe",60299),debugStackframeFocused:(0,t.$1j)("debug-stackframe-focused",60299),debugBreakpointUnsupported:(0,t.$1j)("debug-breakpoint-unsupported",60300),symbolString:(0,t.$1j)("symbol-string",60301),debugReverseContinue:(0,t.$1j)("debug-reverse-continue",60302),debugStepBack:(0,t.$1j)("debug-step-back",60303),debugRestartFrame:(0,t.$1j)("debug-restart-frame",60304),debugAlt:(0,t.$1j)("debug-alt",60305),callIncoming:(0,t.$1j)("call-incoming",60306),callOutgoing:(0,t.$1j)("call-outgoing",60307),menu:(0,t.$1j)("menu",60308),expandAll:(0,t.$1j)("expand-all",60309),feedback:(0,t.$1j)("feedback",60310),gitPullRequestReviewer:(0,t.$1j)("git-pull-request-reviewer",60310),groupByRefType:(0,t.$1j)("group-by-ref-type",60311),ungroupByRefType:(0,t.$1j)("ungroup-by-ref-type",60312),account:(0,t.$1j)("account",60313),gitPullRequestAssignee:(0,t.$1j)("git-pull-request-assignee",60313),bellDot:(0,t.$1j)("bell-dot",60314),debugConsole:(0,t.$1j)("debug-console",60315),library:(0,t.$1j)("library",60316),output:(0,t.$1j)("output",60317),runAll:(0,t.$1j)("run-all",60318),syncIgnored:(0,t.$1j)("sync-ignored",60319),pinned:(0,t.$1j)("pinned",60320),githubInverted:(0,t.$1j)("github-inverted",60321),serverProcess:(0,t.$1j)("server-process",60322),serverEnvironment:(0,t.$1j)("server-environment",60323),pass:(0,t.$1j)("pass",60324),issueClosed:(0,t.$1j)("issue-closed",60324),stopCircle:(0,t.$1j)("stop-circle",60325),playCircle:(0,t.$1j)("play-circle",60326),record:(0,t.$1j)("record",60327),debugAltSmall:(0,t.$1j)("debug-alt-small",60328),vmConnect:(0,t.$1j)("vm-connect",60329),cloud:(0,t.$1j)("cloud",60330),merge:(0,t.$1j)("merge",60331),export:(0,t.$1j)("export",60332),graphLeft:(0,t.$1j)("graph-left",60333),magnet:(0,t.$1j)("magnet",60334),notebook:(0,t.$1j)("notebook",60335),redo:(0,t.$1j)("redo",60336),checkAll:(0,t.$1j)("check-all",60337),pinnedDirty:(0,t.$1j)("pinned-dirty",60338),passFilled:(0,t.$1j)("pass-filled",60339),circleLargeFilled:(0,t.$1j)("circle-large-filled",60340),circleLarge:(0,t.$1j)("circle-large",60341),circleLargeOutline:(0,t.$1j)("circle-large-outline",60341),combine:(0,t.$1j)("combine",60342),gather:(0,t.$1j)("gather",60342),table:(0,t.$1j)("table",60343),variableGroup:(0,t.$1j)("variable-group",60344),typeHierarchy:(0,t.$1j)("type-hierarchy",60345),typeHierarchySub:(0,t.$1j)("type-hierarchy-sub",60346),typeHierarchySuper:(0,t.$1j)("type-hierarchy-super",60347),gitPullRequestCreate:(0,t.$1j)("git-pull-request-create",60348),runAbove:(0,t.$1j)("run-above",60349),runBelow:(0,t.$1j)("run-below",60350),notebookTemplate:(0,t.$1j)("notebook-template",60351),debugRerun:(0,t.$1j)("debug-rerun",60352),workspaceTrusted:(0,t.$1j)("workspace-trusted",60353),workspaceUntrusted:(0,t.$1j)("workspace-untrusted",60354),workspaceUnknown:(0,t.$1j)("workspace-unknown",60355),terminalCmd:(0,t.$1j)("terminal-cmd",60356),terminalDebian:(0,t.$1j)("terminal-debian",60357),terminalLinux:(0,t.$1j)("terminal-linux",60358),terminalPowershell:(0,t.$1j)("terminal-powershell",60359),terminalTmux:(0,t.$1j)("terminal-tmux",60360),terminalUbuntu:(0,t.$1j)("terminal-ubuntu",60361),terminalBash:(0,t.$1j)("terminal-bash",60362),arrowSwap:(0,t.$1j)("arrow-swap",60363),copy:(0,t.$1j)("copy",60364),personAdd:(0,t.$1j)("person-add",60365),filterFilled:(0,t.$1j)("filter-filled",60366),wand:(0,t.$1j)("wand",60367),debugLineByLine:(0,t.$1j)("debug-line-by-line",60368),inspect:(0,t.$1j)("inspect",60369),layers:(0,t.$1j)("layers",60370),layersDot:(0,t.$1j)("layers-dot",60371),layersActive:(0,t.$1j)("layers-active",60372),compass:(0,t.$1j)("compass",60373),compassDot:(0,t.$1j)("compass-dot",60374),compassActive:(0,t.$1j)("compass-active",60375),azure:(0,t.$1j)("azure",60376),issueDraft:(0,t.$1j)("issue-draft",60377),gitPullRequestClosed:(0,t.$1j)("git-pull-request-closed",60378),gitPullRequestDraft:(0,t.$1j)("git-pull-request-draft",60379),debugAll:(0,t.$1j)("debug-all",60380),debugCoverage:(0,t.$1j)("debug-coverage",60381),runErrors:(0,t.$1j)("run-errors",60382),folderLibrary:(0,t.$1j)("folder-library",60383),debugContinueSmall:(0,t.$1j)("debug-continue-small",60384),beakerStop:(0,t.$1j)("beaker-stop",60385),graphLine:(0,t.$1j)("graph-line",60386),graphScatter:(0,t.$1j)("graph-scatter",60387),pieChart:(0,t.$1j)("pie-chart",60388),bracket:(0,t.$1j)("bracket",60175),bracketDot:(0,t.$1j)("bracket-dot",60389),bracketError:(0,t.$1j)("bracket-error",60390),lockSmall:(0,t.$1j)("lock-small",60391),azureDevops:(0,t.$1j)("azure-devops",60392),verifiedFilled:(0,t.$1j)("verified-filled",60393),newline:(0,t.$1j)("newline",60394),layout:(0,t.$1j)("layout",60395),layoutActivitybarLeft:(0,t.$1j)("layout-activitybar-left",60396),layoutActivitybarRight:(0,t.$1j)("layout-activitybar-right",60397),layoutPanelLeft:(0,t.$1j)("layout-panel-left",60398),layoutPanelCenter:(0,t.$1j)("layout-panel-center",60399),layoutPanelJustify:(0,t.$1j)("layout-panel-justify",60400),layoutPanelRight:(0,t.$1j)("layout-panel-right",60401),layoutPanel:(0,t.$1j)("layout-panel",60402),layoutSidebarLeft:(0,t.$1j)("layout-sidebar-left",60403),layoutSidebarRight:(0,t.$1j)("layout-sidebar-right",60404),layoutStatusbar:(0,t.$1j)("layout-statusbar",60405),layoutMenubar:(0,t.$1j)("layout-menubar",60406),layoutCentered:(0,t.$1j)("layout-centered",60407),target:(0,t.$1j)("target",60408),indent:(0,t.$1j)("indent",60409),recordSmall:(0,t.$1j)("record-small",60410),errorSmall:(0,t.$1j)("error-small",60411),terminalDecorationError:(0,t.$1j)("terminal-decoration-error",60411),arrowCircleDown:(0,t.$1j)("arrow-circle-down",60412),arrowCircleLeft:(0,t.$1j)("arrow-circle-left",60413),arrowCircleRight:(0,t.$1j)("arrow-circle-right",60414),arrowCircleUp:(0,t.$1j)("arrow-circle-up",60415),layoutSidebarRightOff:(0,t.$1j)("layout-sidebar-right-off",60416),layoutPanelOff:(0,t.$1j)("layout-panel-off",60417),layoutSidebarLeftOff:(0,t.$1j)("layout-sidebar-left-off",60418),blank:(0,t.$1j)("blank",60419),heartFilled:(0,t.$1j)("heart-filled",60420),map:(0,t.$1j)("map",60421),mapHorizontal:(0,t.$1j)("map-horizontal",60421),foldHorizontal:(0,t.$1j)("fold-horizontal",60421),mapFilled:(0,t.$1j)("map-filled",60422),mapHorizontalFilled:(0,t.$1j)("map-horizontal-filled",60422),foldHorizontalFilled:(0,t.$1j)("fold-horizontal-filled",60422),circleSmall:(0,t.$1j)("circle-small",60423),bellSlash:(0,t.$1j)("bell-slash",60424),bellSlashDot:(0,t.$1j)("bell-slash-dot",60425),commentUnresolved:(0,t.$1j)("comment-unresolved",60426),gitPullRequestGoToChanges:(0,t.$1j)("git-pull-request-go-to-changes",60427),gitPullRequestNewChanges:(0,t.$1j)("git-pull-request-new-changes",60428),searchFuzzy:(0,t.$1j)("search-fuzzy",60429),commentDraft:(0,t.$1j)("comment-draft",60430),send:(0,t.$1j)("send",60431),sparkle:(0,t.$1j)("sparkle",60432),insert:(0,t.$1j)("insert",60433),mic:(0,t.$1j)("mic",60434),thumbsdownFilled:(0,t.$1j)("thumbsdown-filled",60435),thumbsupFilled:(0,t.$1j)("thumbsup-filled",60436),coffee:(0,t.$1j)("coffee",60437),snake:(0,t.$1j)("snake",60438),game:(0,t.$1j)("game",60439),vr:(0,t.$1j)("vr",60440),chip:(0,t.$1j)("chip",60441),piano:(0,t.$1j)("piano",60442),music:(0,t.$1j)("music",60443),micFilled:(0,t.$1j)("mic-filled",60444),repoFetch:(0,t.$1j)("repo-fetch",60445),copilot:(0,t.$1j)("copilot",60446),lightbulbSparkle:(0,t.$1j)("lightbulb-sparkle",60447),robot:(0,t.$1j)("robot",60448),sparkleFilled:(0,t.$1j)("sparkle-filled",60449),diffSingle:(0,t.$1j)("diff-single",60450),diffMultiple:(0,t.$1j)("diff-multiple",60451),surroundWith:(0,t.$1j)("surround-with",60452),share:(0,t.$1j)("share",60453),gitStash:(0,t.$1j)("git-stash",60454),gitStashApply:(0,t.$1j)("git-stash-apply",60455),gitStashPop:(0,t.$1j)("git-stash-pop",60456),vscode:(0,t.$1j)("vscode",60457),vscodeInsiders:(0,t.$1j)("vscode-insiders",60458),codeOss:(0,t.$1j)("code-oss",60459),runCoverage:(0,t.$1j)("run-coverage",60460),runAllCoverage:(0,t.$1j)("run-all-coverage",60461),coverage:(0,t.$1j)("coverage",60462),githubProject:(0,t.$1j)("github-project",60463),mapVertical:(0,t.$1j)("map-vertical",60464),foldVertical:(0,t.$1j)("fold-vertical",60464),mapVerticalFilled:(0,t.$1j)("map-vertical-filled",60465),foldVerticalFilled:(0,t.$1j)("fold-vertical-filled",60465),goToSearch:(0,t.$1j)("go-to-search",60466),percentage:(0,t.$1j)("percentage",60467),sortPercentage:(0,t.$1j)("sort-percentage",60467),attach:(0,t.$1j)("attach",60468)}}),ne(ie[45],re([0,1,28,44]),function(x,i,t,n){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.$6j=i.$5j=void 0,i.$4j=p;function p(){return Object.values(i.$6j)}i.$5j={dialogError:(0,t.$1j)("dialog-error","error"),dialogWarning:(0,t.$1j)("dialog-warning","warning"),dialogInfo:(0,t.$1j)("dialog-info","info"),dialogClose:(0,t.$1j)("dialog-close","close"),treeItemExpanded:(0,t.$1j)("tree-item-expanded","chevron-down"),treeFilterOnTypeOn:(0,t.$1j)("tree-filter-on-type-on","list-filter"),treeFilterOnTypeOff:(0,t.$1j)("tree-filter-on-type-off","list-selection"),treeFilterClear:(0,t.$1j)("tree-filter-clear","close"),treeItemLoading:(0,t.$1j)("tree-item-loading","loading"),menuSelection:(0,t.$1j)("menu-selection","check"),menuSubmenu:(0,t.$1j)("menu-submenu","chevron-right"),menuBarMore:(0,t.$1j)("menubar-more","more"),scrollbarButtonLeft:(0,t.$1j)("scrollbar-button-left","triangle-left"),scrollbarButtonRight:(0,t.$1j)("scrollbar-button-right","triangle-right"),scrollbarButtonUp:(0,t.$1j)("scrollbar-button-up","triangle-up"),scrollbarButtonDown:(0,t.$1j)("scrollbar-button-down","triangle-down"),toolBarMore:(0,t.$1j)("toolbar-more","more"),quickInputBack:(0,t.$1j)("quick-input-back","arrow-left"),dropDownButton:(0,t.$1j)("drop-down-button",60084),symbolCustomColor:(0,t.$1j)("symbol-customcolor",60252),exportIcon:(0,t.$1j)("export",60332),workspaceUnspecified:(0,t.$1j)("workspace-unspecified",60355),newLine:(0,t.$1j)("newline",60394),thumbsDownFilled:(0,t.$1j)("thumbsdown-filled",60435),thumbsUpFilled:(0,t.$1j)("thumbsup-filled",60436),gitFetch:(0,t.$1j)("git-fetch",60445),lightbulbSparkleAutofix:(0,t.$1j)("lightbulb-sparkle-autofix",60447),debugBreakpointPending:(0,t.$1j)("debug-breakpoint-pending",60377)},i.$6j={...n.$3j,...i.$5j}}),ne(ie[17],re([0,1,27]),function(x,i,t){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.$eo=n,i.$fo=p,i.$go=E,i.$ho=a,i.$io=l,i.$jo=c,i.$ko=$,i.$lo=m,i.$mo=L,i.$no=e,i.$oo=b,i.$po=N,i.$qo=R;function n(A){if(!A||typeof A!="object"||A instanceof RegExp)return A;const w=Array.isArray(A)?[]:{};return Object.entries(A).forEach(([v,h])=>{w[v]=h&&typeof h=="object"?n(h):h}),w}function p(A){if(!A||typeof A!="object")return A;const w=[A];for(;w.length>0;){const v=w.shift();Object.freeze(v);for(const h in v)if(g.call(v,h)){const u=v[h];typeof u=="object"&&!Object.isFrozen(u)&&!(0,t.$jg)(u)&&w.push(u)}}return A}const g=Object.prototype.hasOwnProperty;function E(A,w){return d(A,w,new Set)}function d(A,w,v){if((0,t.$pg)(A))return A;const h=w(A);if(typeof h<"u")return h;if(Array.isArray(A)){const u=[];for(const r of A)u.push(d(r,w,v));return u}if((0,t.$ig)(A)){if(v.has(A))throw new Error("Cannot clone recursive data-structure");v.add(A);const u={};for(const r in A)g.call(A,r)&&(u[r]=d(A[r],w,v));return v.delete(A),u}return A}function a(A,w,v=!0){return(0,t.$ig)(A)?((0,t.$ig)(w)&&Object.keys(w).forEach(h=>{h in A?v&&((0,t.$ig)(A[h])&&(0,t.$ig)(w[h])?a(A[h],w[h],v):A[h]=w[h]):A[h]=w[h]}),A):w}function l(A,w){if(A===w)return!0;if(A==null||w===null||w===void 0||typeof A!=typeof w||typeof A!="object"||Array.isArray(A)!==Array.isArray(w))return!1;let v,h;if(Array.isArray(A)){if(A.length!==w.length)return!1;for(v=0;v<A.length;v++)if(!l(A[v],w[v]))return!1}else{const u=[];for(h in A)u.push(h);u.sort();const r=[];for(h in w)r.push(h);if(r.sort(),!l(u,r))return!1;for(v=0;v<u.length;v++)if(!l(A[u[v]],w[u[v]]))return!1}return!0}function c(A){const w=new Set;return JSON.stringify(A,(v,h)=>{if((0,t.$ig)(h)||Array.isArray(h)){if(w.has(h))return"[Circular]";w.add(h)}return typeof h=="bigint"?`[BigInt ${h.toString()}]`:h})}function $(A,w){const v=Object.create(null);return!A||!w||Object.keys(w).forEach(u=>{const r=A[u],o=w[u];l(r,o)||(v[u]=o)}),v}function m(A,w){const v=w.toLowerCase(),h=Object.keys(A).find(u=>u.toLowerCase()===v);return h?A[h]:A[w]}function L(A,w){const v=Object.create(null);for(const[h,u]of Object.entries(A))w(h,u)&&(v[h]=u);return v}function e(A){let w=[];for(;Object.prototype!==A;)w=w.concat(Object.getOwnPropertyNames(A)),A=Object.getPrototypeOf(A);return w}function b(A){const w=[];for(const v of e(A))typeof A[v]=="function"&&w.push(v);return w}function N(A,w){const v=u=>function(){const r=Array.prototype.slice.call(arguments,0);return w(u,r)},h={};for(const u of A)h[u]=v(u);return h}function R(A,w){const v={};for(const[h,u]of Object.entries(A))v[h]=w(u,h);return v}}),ne(ie[14],re([0,1]),function(x,i){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.Constants=void 0,i.$cf=n,i.$df=p;var t;(function(g){g[g.MAX_SAFE_SMALL_INTEGER=1073741824]="MAX_SAFE_SMALL_INTEGER",g[g.MIN_SAFE_SMALL_INTEGER=-1073741824]="MIN_SAFE_SMALL_INTEGER",g[g.MAX_UINT_8=255]="MAX_UINT_8",g[g.MAX_UINT_16=65535]="MAX_UINT_16",g[g.MAX_UINT_32=4294967295]="MAX_UINT_32",g[g.UNICODE_SUPPLEMENTARY_PLANE_BEGIN=65536]="UNICODE_SUPPLEMENTARY_PLANE_BEGIN"})(t||(i.Constants=t={}));function n(g){return g<0?0:g>t.MAX_UINT_8?t.MAX_UINT_8:g|0}function p(g){return g<0?0:g>t.MAX_UINT_32?t.MAX_UINT_32:g|0}}),ne(ie[8],re([0,1,43,3,41,14]),function(x,i,t,n,p,g){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.$fg=i.$eg=i.$dg=i.GraphemeBreakType=i.$6f=i.$Xf=i.$Qf=i.$Pf=void 0,i.$ef=E,i.$ff=a,i.$gf=c,i.$hf=$,i.$if=m,i.$jf=L,i.$kf=e,i.$lf=b,i.$mf=N,i.$nf=R,i.$of=A,i.$pf=w,i.$qf=v,i.$rf=h,i.$sf=u,i.$tf=r,i.$uf=o,i.$vf=f,i.$wf=T,i.$xf=_,i.$yf=M,i.$zf=j,i.$Af=F,i.$Bf=I,i.$Cf=S,i.$Df=D,i.$Ef=q,i.$Ff=X,i.$Gf=B,i.$Hf=y,i.$If=Y,i.$Jf=Z,i.$Kf=H,i.$Lf=Q,i.$Mf=C,i.$Nf=k,i.$Of=z,i.$Rf=s,i.$Sf=Te,i.$Tf=Pe,i.$Uf=We,i.$Vf=U,i.$Wf=V,i.$Yf=J,i.$Zf=ee,i.$1f=he,i.$2f=de,i.$3f=ve,i.$4f=_e,i.$5f=te,i.$7f=ae,i.$8f=ue,i.$9f=ce,i.$0f=me,i.$$f=$e,i.$_f=Ne,i.$ag=Ae,i.$bg=Be,i.$cg=ze;function E(P){return!P||typeof P!="string"?!0:P.trim().length===0}const d=/{(\d+)}/g;function a(P,...O){return O.length===0?P:P.replace(d,function(G,K){const le=parseInt(K,10);return isNaN(le)||le<0||le>=O.length?G:O[le]})}const l=/{([^}]+)}/g;function c(P,O){return Object.keys(O).length===0?P:P.replace(l,(G,K)=>O[K]??G)}function $(P){return P.replace(/[<>"'&]/g,O=>{switch(O){case"<":return"&lt;";case">":return"&gt;";case'"':return"&quot;";case"'":return"&apos;";case"&":return"&amp;"}return O})}function m(P){return P.replace(/[<>&]/g,function(O){switch(O){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return O}})}function L(P){return P.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}function e(P,O){let G=0,K=P.indexOf(O);for(;K!==-1;)G++,K=P.indexOf(O,K+O.length);return G}function b(P,O,G="\u2026"){return P.length<=O?P:`${P.substr(0,O)}${G}`}function N(P,O,G="\u2026"){if(P.length<=O)return P;const K=Math.ceil(O/2)-G.length/2,le=Math.floor(O/2)-G.length/2;return`${P.substr(0,K)}${G}${P.substr(P.length-le)}`}function R(P,O=" "){const G=A(P,O);return w(G,O)}function A(P,O){if(!P||!O)return P;const G=O.length;if(G===0||P.length===0)return P;let K=0;for(;P.indexOf(O,K)===K;)K=K+G;return P.substring(K)}function w(P,O){if(!P||!O)return P;const G=O.length,K=P.length;if(G===0||K===0)return P;let le=K,be=-1;for(;be=P.lastIndexOf(O,le-1),!(be===-1||be+G!==le);){if(be===0)return"";le=be}return P.substring(0,le)}function v(P){return P.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}function h(P){return P.replace(/\*/g,"")}function u(P,O,G={}){if(!P)throw new Error("Cannot create regex from empty string");O||(P=L(P)),G.wholeWord&&(/\B/.test(P.charAt(0))||(P="\\b"+P),/\B/.test(P.charAt(P.length-1))||(P=P+"\\b"));let K="";return G.global&&(K+="g"),G.matchCase||(K+="i"),G.multiline&&(K+="m"),G.unicode&&(K+="u"),new RegExp(P,K)}function r(P){return P.source==="^"||P.source==="^$"||P.source==="$"||P.source==="^\\s*$"?!1:!!(P.exec("")&&P.lastIndex===0)}function o(P){return P.split(/\r\n|\r|\n/)}function f(P){const O=[],G=P.split(/(\r\n|\r|\n)/);for(let K=0;K<Math.ceil(G.length/2);K++)O.push(G[2*K]+(G[2*K+1]??""));return O}function T(P){for(let O=0,G=P.length;O<G;O++){const K=P.charCodeAt(O);if(K!==n.CharCode.Space&&K!==n.CharCode.Tab)return O}return-1}function _(P,O=0,G=P.length){for(let K=O;K<G;K++){const le=P.charCodeAt(K);if(le!==n.CharCode.Space&&le!==n.CharCode.Tab)return P.substring(O,K)}return P.substring(O,G)}function M(P,O=P.length-1){for(let G=O;G>=0;G--){const K=P.charCodeAt(G);if(K!==n.CharCode.Space&&K!==n.CharCode.Tab)return G}return-1}function j(P,O,G){const K=[];let le=0;for(const be of P.matchAll(O)){if(K.push(P.slice(le,be.index)),be.index===void 0)throw new Error("match.index should be defined");le=be.index+be[0].length,K.push(G(be[0],...be.slice(1),be.index,P,be.groups))}return K.push(P.slice(le)),Promise.all(K).then(be=>be.join(""))}function F(P,O){return P<O?-1:P>O?1:0}function I(P,O,G=0,K=P.length,le=0,be=O.length){for(;G<K&&le<be;G++,le++){const De=P.charCodeAt(G),Fe=O.charCodeAt(le);if(De<Fe)return-1;if(De>Fe)return 1}const Re=K-G,Se=be-le;return Re<Se?-1:Re>Se?1:0}function S(P,O){return D(P,O,0,P.length,0,O.length)}function D(P,O,G=0,K=P.length,le=0,be=O.length){for(;G<K&&le<be;G++,le++){let De=P.charCodeAt(G),Fe=O.charCodeAt(le);if(De===Fe)continue;if(De>=128||Fe>=128)return I(P.toLowerCase(),O.toLowerCase(),G,K,le,be);X(De)&&(De-=32),X(Fe)&&(Fe-=32);const pe=De-Fe;if(pe!==0)return pe}const Re=K-G,Se=be-le;return Re<Se?-1:Re>Se?1:0}function q(P){return P>=n.CharCode.Digit0&&P<=n.CharCode.Digit9}function X(P){return P>=n.CharCode.a&&P<=n.CharCode.z}function B(P){return P>=n.CharCode.A&&P<=n.CharCode.Z}function y(P,O){return P.length===O.length&&D(P,O)===0}function Y(P,O){const G=O.length;return O.length>P.length?!1:D(P,O,0,G)===0}function Z(P,O){const G=Math.min(P.length,O.length);let K;for(K=0;K<G;K++)if(P.charCodeAt(K)!==O.charCodeAt(K))return K;return G}function H(P,O){const G=Math.min(P.length,O.length);let K;const le=P.length-1,be=O.length-1;for(K=0;K<G;K++)if(P.charCodeAt(le-K)!==O.charCodeAt(be-K))return K;return G}function Q(P){return 55296<=P&&P<=56319}function C(P){return 56320<=P&&P<=57343}function k(P,O){return(P-55296<<10)+(O-56320)+65536}function z(P,O,G){const K=P.charCodeAt(G);if(Q(K)&&G+1<O){const le=P.charCodeAt(G+1);if(C(le))return k(K,le)}return K}function fe(P,O){const G=P.charCodeAt(O-1);if(C(G)&&O>1){const K=P.charCodeAt(O-2);if(Q(K))return k(K,G)}return G}class oe{get offset(){return this.e}constructor(O,G=0){this.c=O,this.d=O.length,this.e=G}setOffset(O){this.e=O}prevCodePoint(){const O=fe(this.c,this.e);return this.e-=O>=g.Constants.UNICODE_SUPPLEMENTARY_PLANE_BEGIN?2:1,O}nextCodePoint(){const O=z(this.c,this.d,this.e);return this.e+=O>=g.Constants.UNICODE_SUPPLEMENTARY_PLANE_BEGIN?2:1,O}eol(){return this.e>=this.d}}i.$Pf=oe;class we{get offset(){return this.c.offset}constructor(O,G=0){this.c=new oe(O,G)}nextGraphemeLength(){const O=je.getInstance(),G=this.c,K=G.offset;let le=O.getGraphemeBreakType(G.nextCodePoint());for(;!G.eol();){const be=G.offset,Re=O.getGraphemeBreakType(G.nextCodePoint());if(xe(le,Re)){G.setOffset(be);break}le=Re}return G.offset-K}prevGraphemeLength(){const O=je.getInstance(),G=this.c,K=G.offset;let le=O.getGraphemeBreakType(G.prevCodePoint());for(;G.offset>0;){const be=G.offset,Re=O.getGraphemeBreakType(G.prevCodePoint());if(xe(Re,le)){G.setOffset(be);break}le=Re}return K-G.offset}eol(){return this.c.eol()}}i.$Qf=we;function s(P,O){return new we(P,O).nextGraphemeLength()}function Te(P,O){return new we(P,O).prevGraphemeLength()}function Pe(P,O){O>0&&C(P.charCodeAt(O))&&O--;const G=O+s(P,O);return[G-Te(P,G),G]}function We(P){const O=new we(P);let G=0;for(;!O.eol();)G++,O.nextGraphemeLength();return G}let Me;function Oe(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function U(P){return Me||(Me=Oe()),Me.test(P)}const W=/^[\t\n\r\x20-\x7E]*$/;function V(P){return W.test(P)}i.$Xf=/[\u2028\u2029]/;function J(P){return i.$Xf.test(P)}function ee(P){return P>=11904&&P<=55215||P>=63744&&P<=64255||P>=65281&&P<=65374}function he(P){return P>=127462&&P<=127487||P===8986||P===8987||P===9200||P===9203||P>=9728&&P<=10175||P===11088||P===11093||P>=127744&&P<=128591||P>=128640&&P<=128764||P>=128992&&P<=129008||P>=129280&&P<=129535||P>=129648&&P<=129782}function de(P,O,G=""){const K=P.trimStart();if(K.length<O)return K;const le=/\b/g;let be=0;for(;le.test(K)&&!(K.length-le.lastIndex<O);)be=le.lastIndex,le.lastIndex+=1;return be===0?K:G+K.substring(be).trimStart()}const Ee=/(?:(?:\x1b\[|\x9B)[=?>!]?[\d;:]*["$#'* ]?[a-zA-Z@^`{}|~])|(:?\x1b\].*?\x07)/g;function*ve(P){let O=0;for(const G of P.matchAll(Ee))O!==G.index&&(yield{isCode:!1,str:P.substring(O,G.index)}),yield{isCode:!0,str:G[0]},O=G.index+G[0].length;O!==P.length&&(yield{isCode:!1,str:P.substring(O)})}function _e(P){return P&&(P=P.replace(Ee,"")),P}const se=/\\\[.*?\\\]/g;function te(P){return _e(P).replace(se,"")}i.$6f=String.fromCharCode(n.CharCode.UTF8_BOM);function ae(P){return!!(P&&P.length>0&&P.charCodeAt(0)===n.CharCode.UTF8_BOM)}function ue(P){return ae(P)?P.substr(1):P}function ce(P,O){if(!P||!O||P.length<O.length)return!1;const G=O.length,K=P.toLowerCase();let le=0,be=-1;for(;le<G;){const Re=K.indexOf(O[le],be+1);if(Re<0)return!1;be=Re,le++}return!0}function me(P,O=!1){return P?(O&&(P=P.replace(/\\./g,"")),P.toLowerCase()!==P):!1}function $e(P){return P.charAt(0).toUpperCase()+P.slice(1)}function Ne(P,O=1){if(O===0)return"";let G=-1;do G=P.indexOf(`
`,G+1),O--;while(O>0&&G>=0);return G===-1?P:(P[G-1]==="\r"&&G--,P.substr(0,G))}function Ae(P){const O=n.CharCode.Z-n.CharCode.A+1;return P=P%(2*O),P<O?String.fromCharCode(n.CharCode.a+P):String.fromCharCode(n.CharCode.A+P-O)}function Be(P){return je.getInstance().getGraphemeBreakType(P)}function xe(P,O){return P===ge.Other?O!==ge.Extend&&O!==ge.SpacingMark:P===ge.CR&&O===ge.LF?!1:P===ge.Control||P===ge.CR||P===ge.LF||O===ge.Control||O===ge.CR||O===ge.LF?!0:!(P===ge.L&&(O===ge.L||O===ge.V||O===ge.LV||O===ge.LVT)||(P===ge.LV||P===ge.V)&&(O===ge.V||O===ge.T)||(P===ge.LVT||P===ge.T)&&O===ge.T||O===ge.Extend||O===ge.ZWJ||O===ge.SpacingMark||P===ge.Prepend||P===ge.ZWJ&&O===ge.Extended_Pictographic||P===ge.Regional_Indicator&&O===ge.Regional_Indicator)}var ge;(function(P){P[P.Other=0]="Other",P[P.Prepend=1]="Prepend",P[P.CR=2]="CR",P[P.LF=3]="LF",P[P.Control=4]="Control",P[P.Extend=5]="Extend",P[P.Regional_Indicator=6]="Regional_Indicator",P[P.SpacingMark=7]="SpacingMark",P[P.L=8]="L",P[P.V=9]="V",P[P.T=10]="T",P[P.LV=11]="LV",P[P.LVT=12]="LVT",P[P.ZWJ=13]="ZWJ",P[P.Extended_Pictographic=14]="Extended_Pictographic"})(ge||(i.GraphemeBreakType=ge={}));class je{static{this.c=null}static getInstance(){return je.c||(je.c=new je),je.c}constructor(){this.d=qe()}getGraphemeBreakType(O){if(O<32)return O===n.CharCode.LineFeed?ge.LF:O===n.CharCode.CarriageReturn?ge.CR:ge.Control;if(O<127)return ge.Other;const G=this.d,K=G.length/3;let le=1;for(;le<=K;)if(O<G[3*le])le=2*le;else if(O>G[3*le+1])le=2*le+1;else return G[3*le+2];return ge.Other}}function qe(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function ze(P,O){if(P===0)return 0;const G=Xe(P,O);if(G!==void 0)return G;const K=new oe(O,P);return K.prevCodePoint(),K.offset}function Xe(P,O){const G=new oe(O,P);let K=G.prevCodePoint();for(;Ce(K)||K===He.emojiVariantSelector||K===He.enclosingKeyCap;){if(G.offset===0)return;K=G.prevCodePoint()}if(!he(K))return;let le=G.offset;return le>0&&G.prevCodePoint()===He.zwj&&(le=G.offset),le}function Ce(P){return 127995<=P&&P<=127999}var He;(function(P){P[P.zwj=8205]="zwj",P[P.emojiVariantSelector=65039]="emojiVariantSelector",P[P.enclosingKeyCap=8419]="enclosingKeyCap"})(He||(He={})),i.$dg="\xA0";class Ue{static{this.c=new p.$X(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125,119846,109],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}'))}static{this.d=new t.$af({getCacheKey:JSON.stringify},O=>{function G(pe){const ye=new Map;for(let ke=0;ke<pe.length;ke+=2)ye.set(pe[ke],pe[ke+1]);return ye}function K(pe,ye){const ke=new Map(pe);for(const[Ge,Ye]of ye)ke.set(Ge,Ye);return ke}function le(pe,ye){if(!pe)return ye;const ke=new Map;for(const[Ge,Ye]of pe)ye.has(Ge)&&ke.set(Ge,Ye);return ke}const be=this.c.value;let Re=O.filter(pe=>!pe.startsWith("_")&&pe in be);Re.length===0&&(Re=["_default"]);let Se;for(const pe of Re){const ye=G(be[pe]);Se=le(Se,ye)}const De=G(be._common),Fe=K(De,Se);return new Ue(Fe)})}static getInstance(O){return Ue.d.get(Array.from(O))}static{this.e=new p.$X(()=>Object.keys(Ue.c.value).filter(O=>!O.startsWith("_")))}static getLocales(){return Ue.e.value}constructor(O){this.f=O}isAmbiguous(O){return this.f.has(O)}containsAmbiguousCharacter(O){for(let G=0;G<O.length;G++){const K=O.codePointAt(G);if(typeof K=="number"&&this.isAmbiguous(K))return!0}return!1}getPrimaryConfusable(O){return this.f.get(O)}getConfusableCodePoints(){return new Set(this.f.keys())}}i.$eg=Ue;class Ve{static c(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static{this.d=void 0}static e(){return this.d||(this.d=new Set(Ve.c())),this.d}static isInvisibleCharacter(O){return Ve.e().has(O)}static containsInvisibleCharacter(O){for(let G=0;G<O.length;G++){const K=O.codePointAt(G);if(typeof K=="number"&&Ve.isInvisibleCharacter(K))return!0}return!1}static get codePoints(){return Ve.e()}}i.$fg=Ve});var Je=this&&this.__createBinding||(Object.create?function(x,i,t,n){n===void 0&&(n=t);var p=Object.getOwnPropertyDescriptor(i,t);(!p||("get"in p?!i.__esModule:p.writable||p.configurable))&&(p={enumerable:!0,get:function(){return i[t]}}),Object.defineProperty(x,n,p)}:function(x,i,t,n){n===void 0&&(n=t),x[n]=i[t]}),Ke=this&&this.__setModuleDefault||(Object.create?function(x,i){Object.defineProperty(x,"default",{enumerable:!0,value:i})}:function(x,i){x.default=i}),Ie=this&&this.__importStar||function(x){if(x&&x.__esModule)return x;var i={};if(x!=null)for(var t in x)t!=="default"&&Object.prototype.hasOwnProperty.call(x,t)&&Je(i,x,t);return Ke(i,x),i};ne(ie[46],re([0,1,8]),function(x,i,t){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.$Aj=i.$yj=void 0,i.$uj=n,i.$vj=p,i.$wj=g,i.$xj=d,i.$zj=b,t=Ie(t);function n(R){return p(R,0)}function p(R,A){switch(typeof R){case"object":return R===null?g(349,A):Array.isArray(R)?a(R,A):l(R,A);case"string":return d(R,A);case"boolean":return E(R,A);case"number":return g(R,A);case"undefined":return g(937,A);default:return g(617,A)}}function g(R,A){return(A<<5)-A+R|0}function E(R,A){return g(R?433:863,A)}function d(R,A){A=g(149417,A);for(let w=0,v=R.length;w<v;w++)A=g(R.charCodeAt(w),A);return A}function a(R,A){return A=g(104579,A),R.reduce((w,v)=>p(v,w),A)}function l(R,A){return A=g(181387,A),Object.keys(R).sort().reduce((w,v)=>(w=d(v,w),p(R[v],w)),A)}class c{constructor(){this.g=0}get value(){return this.g}hash(A){return this.g=p(A,this.g),this.g}}i.$yj=c;var $;(function(R){R[R.BLOCK_SIZE=64]="BLOCK_SIZE",R[R.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})($||($={}));function m(R,A,w=32){const v=w-A,h=~((1<<v)-1);return(R<<A|(h&R)>>>v)>>>0}function L(R,A=0,w=R.byteLength,v=0){for(let h=0;h<w;h++)R[A+h]=v}function e(R,A,w="0"){for(;R.length<A;)R=w+R;return R}function b(R,A=32){return R instanceof ArrayBuffer?Array.from(new Uint8Array(R)).map(w=>w.toString(16).padStart(2,"0")).join(""):e((R>>>0).toString(16),A/4)}class N{static{this.g=new DataView(new ArrayBuffer(320))}constructor(){this.h=1732584193,this.l=4023233417,this.m=2562383102,this.n=271733878,this.o=3285377520,this.p=new Uint8Array($.BLOCK_SIZE+3),this.q=new DataView(this.p.buffer),this.r=0,this.t=0,this.u=0,this.v=!1}update(A){const w=A.length;if(w===0)return;const v=this.p;let h=this.r,u=this.u,r,o;for(u!==0?(r=u,o=-1,u=0):(r=A.charCodeAt(0),o=0);;){let f=r;if(t.$Lf(r))if(o+1<w){const T=A.charCodeAt(o+1);t.$Mf(T)?(o++,f=t.$Nf(r,T)):f=$.UNICODE_REPLACEMENT}else{u=r;break}else t.$Mf(r)&&(f=$.UNICODE_REPLACEMENT);if(h=this.w(v,h,f),o++,o<w)r=A.charCodeAt(o);else break}this.r=h,this.u=u}w(A,w,v){return v<128?A[w++]=v:v<2048?(A[w++]=192|(v&1984)>>>6,A[w++]=128|(v&63)>>>0):v<65536?(A[w++]=224|(v&61440)>>>12,A[w++]=128|(v&4032)>>>6,A[w++]=128|(v&63)>>>0):(A[w++]=240|(v&1835008)>>>18,A[w++]=128|(v&258048)>>>12,A[w++]=128|(v&4032)>>>6,A[w++]=128|(v&63)>>>0),w>=$.BLOCK_SIZE&&(this.y(),w-=$.BLOCK_SIZE,this.t+=$.BLOCK_SIZE,A[0]=A[$.BLOCK_SIZE+0],A[1]=A[$.BLOCK_SIZE+1],A[2]=A[$.BLOCK_SIZE+2]),w}digest(){return this.v||(this.v=!0,this.u&&(this.u=0,this.r=this.w(this.p,this.r,$.UNICODE_REPLACEMENT)),this.t+=this.r,this.x()),b(this.h)+b(this.l)+b(this.m)+b(this.n)+b(this.o)}x(){this.p[this.r++]=128,L(this.p,this.r),this.r>56&&(this.y(),L(this.p));const A=8*this.t;this.q.setUint32(56,Math.floor(A/4294967296),!1),this.q.setUint32(60,A%4294967296,!1),this.y()}y(){const A=N.g,w=this.q;for(let M=0;M<64;M+=4)A.setUint32(M,w.getUint32(M,!1),!1);for(let M=64;M<320;M+=4)A.setUint32(M,m(A.getUint32(M-12,!1)^A.getUint32(M-32,!1)^A.getUint32(M-56,!1)^A.getUint32(M-64,!1),1),!1);let v=this.h,h=this.l,u=this.m,r=this.n,o=this.o,f,T,_;for(let M=0;M<80;M++)M<20?(f=h&u|~h&r,T=1518500249):M<40?(f=h^u^r,T=1859775393):M<60?(f=h&u|h&r|u&r,T=2400959708):(f=h^u^r,T=3395469782),_=m(v,5)+f+o+T+A.getUint32(M*4,!1)&4294967295,o=r,r=u,u=m(h,30),h=v,v=_;this.h=this.h+v&4294967295,this.l=this.l+h&4294967295,this.m=this.m+u&4294967295,this.n=this.n+r&4294967295,this.o=this.o+o&4294967295}}i.$Aj=N}),ne(ie[29],re([0,1,39,46,14]),function(x,i,t,n,p){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.$St=i.$Qt=void 0,i.$Rt=E;class g{constructor(L){this.a=L}getElements(){const L=this.a,e=new Int32Array(L.length);for(let b=0,N=L.length;b<N;b++)e[b]=L.charCodeAt(b);return e}}i.$Qt=g;function E(m,L,e){return new $(new g(m),new g(L)).ComputeDiff(e).changes}class d{static Assert(L,e){if(!L)throw new Error(e)}}class a{static Copy(L,e,b,N,R){for(let A=0;A<R;A++)b[N+A]=L[e+A]}static Copy2(L,e,b,N,R){for(let A=0;A<R;A++)b[N+A]=L[e+A]}}var l;(function(m){m[m.MaxDifferencesHistory=1447]="MaxDifferencesHistory"})(l||(l={}));class c{constructor(){this.a=[],this.b=p.Constants.MAX_SAFE_SMALL_INTEGER,this.c=p.Constants.MAX_SAFE_SMALL_INTEGER,this.d=0,this.e=0}MarkNextChange(){(this.d>0||this.e>0)&&this.a.push(new t.$Pt(this.b,this.d,this.c,this.e)),this.d=0,this.e=0,this.b=p.Constants.MAX_SAFE_SMALL_INTEGER,this.c=p.Constants.MAX_SAFE_SMALL_INTEGER}AddOriginalElement(L,e){this.b=Math.min(this.b,L),this.c=Math.min(this.c,e),this.d++}AddModifiedElement(L,e){this.b=Math.min(this.b,L),this.c=Math.min(this.c,e),this.e++}getChanges(){return(this.d>0||this.e>0)&&this.MarkNextChange(),this.a}getReverseChanges(){return(this.d>0||this.e>0)&&this.MarkNextChange(),this.a.reverse(),this.a}}class ${constructor(L,e,b=null){this.a=b,this.b=L,this.c=e;const[N,R,A]=$.o(L),[w,v,h]=$.o(e);this.d=A&&h,this.e=N,this.f=R,this.g=w,this.h=v,this.k=[],this.m=[]}static n(L){return L.length>0&&typeof L[0]=="string"}static o(L){const e=L.getElements();if($.n(e)){const b=new Int32Array(e.length);for(let N=0,R=e.length;N<R;N++)b[N]=(0,n.$xj)(e[N],0);return[e,b,!0]}return e instanceof Int32Array?[[],e,!1]:[[],new Int32Array(e),!1]}p(L,e){return this.f[L]!==this.h[e]?!1:this.d?this.e[L]===this.g[e]:!0}q(L,e){if(!this.p(L,e))return!1;const b=$.r(this.b,L),N=$.r(this.c,e);return b===N}static r(L,e){return typeof L.getStrictElement=="function"?L.getStrictElement(e):null}s(L,e){return this.f[L]!==this.f[e]?!1:this.d?this.e[L]===this.e[e]:!0}u(L,e){return this.h[L]!==this.h[e]?!1:this.d?this.g[L]===this.g[e]:!0}ComputeDiff(L){return this.v(0,this.f.length-1,0,this.h.length-1,L)}v(L,e,b,N,R){const A=[!1];let w=this.w(L,e,b,N,A);return R&&(w=this.z(w)),{quitEarly:A[0],changes:w}}w(L,e,b,N,R){for(R[0]=!1;L<=e&&b<=N&&this.p(L,b);)L++,b++;for(;e>=L&&N>=b&&this.p(e,N);)e--,N--;if(L>e||b>N){let r;return b<=N?(d.Assert(L===e+1,"originalStart should only be one more than originalEnd"),r=[new t.$Pt(L,0,b,N-b+1)]):L<=e?(d.Assert(b===N+1,"modifiedStart should only be one more than modifiedEnd"),r=[new t.$Pt(L,e-L+1,b,0)]):(d.Assert(L===e+1,"originalStart should only be one more than originalEnd"),d.Assert(b===N+1,"modifiedStart should only be one more than modifiedEnd"),r=[]),r}const A=[0],w=[0],v=this.y(L,e,b,N,A,w,R),h=A[0],u=w[0];if(v!==null)return v;if(!R[0]){const r=this.w(L,h,b,u,R);let o=[];return R[0]?o=[new t.$Pt(h+1,e-(h+1)+1,u+1,N-(u+1)+1)]:o=this.w(h+1,e,u+1,N,R),this.H(r,o)}return[new t.$Pt(L,e-L+1,b,N-b+1)]}x(L,e,b,N,R,A,w,v,h,u,r,o,f,T,_,M,j,F){let I=null,S=null,D=new c,q=e,X=b,B=f[0]-M[0]-N,y=p.Constants.MIN_SAFE_SMALL_INTEGER,Y=this.k.length-1;do{const Z=B+L;Z===q||Z<X&&h[Z-1]<h[Z+1]?(r=h[Z+1],T=r-B-N,r<y&&D.MarkNextChange(),y=r,D.AddModifiedElement(r+1,T),B=Z+1-L):(r=h[Z-1]+1,T=r-B-N,r<y&&D.MarkNextChange(),y=r-1,D.AddOriginalElement(r,T+1),B=Z-1-L),Y>=0&&(h=this.k[Y],L=h[0],q=1,X=h.length-1)}while(--Y>=-1);if(I=D.getReverseChanges(),F[0]){let Z=f[0]+1,H=M[0]+1;if(I!==null&&I.length>0){const Q=I[I.length-1];Z=Math.max(Z,Q.getOriginalEnd()),H=Math.max(H,Q.getModifiedEnd())}S=[new t.$Pt(Z,o-Z+1,H,_-H+1)]}else{D=new c,q=A,X=w,B=f[0]-M[0]-v,y=p.Constants.MAX_SAFE_SMALL_INTEGER,Y=j?this.m.length-1:this.m.length-2;do{const Z=B+R;Z===q||Z<X&&u[Z-1]>=u[Z+1]?(r=u[Z+1]-1,T=r-B-v,r>y&&D.MarkNextChange(),y=r+1,D.AddOriginalElement(r+1,T+1),B=Z+1-R):(r=u[Z-1],T=r-B-v,r>y&&D.MarkNextChange(),y=r,D.AddModifiedElement(r+1,T+1),B=Z-1-R),Y>=0&&(u=this.m[Y],R=u[0],q=1,X=u.length-1)}while(--Y>=-1);S=D.getChanges()}return this.H(I,S)}y(L,e,b,N,R,A,w){let v=0,h=0,u=0,r=0,o=0,f=0;L--,b--,R[0]=0,A[0]=0,this.k=[],this.m=[];const T=e-L+(N-b),_=T+1,M=new Int32Array(_),j=new Int32Array(_),F=N-b,I=e-L,S=L-b,D=e-N,X=(I-F)%2===0;M[F]=L,j[I]=e,w[0]=!1;for(let B=1;B<=T/2+1;B++){let y=0,Y=0;u=this.J(F-B,B,F,_),r=this.J(F+B,B,F,_);for(let H=u;H<=r;H+=2){H===u||H<r&&M[H-1]<M[H+1]?v=M[H+1]:v=M[H-1]+1,h=v-(H-F)-S;const Q=v;for(;v<e&&h<N&&this.p(v+1,h+1);)v++,h++;if(M[H]=v,v+h>y+Y&&(y=v,Y=h),!X&&Math.abs(H-I)<=B-1&&v>=j[H])return R[0]=v,A[0]=h,Q<=j[H]&&l.MaxDifferencesHistory>0&&B<=l.MaxDifferencesHistory+1?this.x(F,u,r,S,I,o,f,D,M,j,v,e,R,h,N,A,X,w):null}const Z=(y-L+(Y-b)-B)/2;if(this.a!==null&&!this.a(y,Z))return w[0]=!0,R[0]=y,A[0]=Y,Z>0&&l.MaxDifferencesHistory>0&&B<=l.MaxDifferencesHistory+1?this.x(F,u,r,S,I,o,f,D,M,j,v,e,R,h,N,A,X,w):(L++,b++,[new t.$Pt(L,e-L+1,b,N-b+1)]);o=this.J(I-B,B,I,_),f=this.J(I+B,B,I,_);for(let H=o;H<=f;H+=2){H===o||H<f&&j[H-1]>=j[H+1]?v=j[H+1]-1:v=j[H-1],h=v-(H-I)-D;const Q=v;for(;v>L&&h>b&&this.p(v,h);)v--,h--;if(j[H]=v,X&&Math.abs(H-F)<=B&&v<=M[H])return R[0]=v,A[0]=h,Q>=M[H]&&l.MaxDifferencesHistory>0&&B<=l.MaxDifferencesHistory+1?this.x(F,u,r,S,I,o,f,D,M,j,v,e,R,h,N,A,X,w):null}if(B<=l.MaxDifferencesHistory){let H=new Int32Array(r-u+2);H[0]=F-u+1,a.Copy2(M,u,H,1,r-u+1),this.k.push(H),H=new Int32Array(f-o+2),H[0]=I-o+1,a.Copy2(j,o,H,1,f-o+1),this.m.push(H)}}return this.x(F,u,r,S,I,o,f,D,M,j,v,e,R,h,N,A,X,w)}z(L){for(let e=0;e<L.length;e++){const b=L[e],N=e<L.length-1?L[e+1].originalStart:this.f.length,R=e<L.length-1?L[e+1].modifiedStart:this.h.length,A=b.originalLength>0,w=b.modifiedLength>0;for(;b.originalStart+b.originalLength<N&&b.modifiedStart+b.modifiedLength<R&&(!A||this.s(b.originalStart,b.originalStart+b.originalLength))&&(!w||this.u(b.modifiedStart,b.modifiedStart+b.modifiedLength));){const h=this.q(b.originalStart,b.modifiedStart);if(this.q(b.originalStart+b.originalLength,b.modifiedStart+b.modifiedLength)&&!h)break;b.originalStart++,b.modifiedStart++}const v=[null];if(e<L.length-1&&this.I(L[e],L[e+1],v)){L[e]=v[0],L.splice(e+1,1),e--;continue}}for(let e=L.length-1;e>=0;e--){const b=L[e];let N=0,R=0;if(e>0){const r=L[e-1];N=r.originalStart+r.originalLength,R=r.modifiedStart+r.modifiedLength}const A=b.originalLength>0,w=b.modifiedLength>0;let v=0,h=this.G(b.originalStart,b.originalLength,b.modifiedStart,b.modifiedLength);for(let r=1;;r++){const o=b.originalStart-r,f=b.modifiedStart-r;if(o<N||f<R||A&&!this.s(o,o+b.originalLength)||w&&!this.u(f,f+b.modifiedLength))break;const _=(o===N&&f===R?5:0)+this.G(o,b.originalLength,f,b.modifiedLength);_>h&&(h=_,v=r)}b.originalStart-=v,b.modifiedStart-=v;const u=[null];if(e>0&&this.I(L[e-1],L[e],u)){L[e-1]=u[0],L.splice(e,1),e++;continue}}if(this.d)for(let e=1,b=L.length;e<b;e++){const N=L[e-1],R=L[e],A=R.originalStart-N.originalStart-N.originalLength,w=N.originalStart,v=R.originalStart+R.originalLength,h=v-w,u=N.modifiedStart,r=R.modifiedStart+R.modifiedLength,o=r-u;if(A<5&&h<20&&o<20){const f=this.A(w,h,u,o,A);if(f){const[T,_]=f;(T!==N.originalStart+N.originalLength||_!==N.modifiedStart+N.modifiedLength)&&(N.originalLength=T-N.originalStart,N.modifiedLength=_-N.modifiedStart,R.originalStart=T+A,R.modifiedStart=_+A,R.originalLength=v-R.originalStart,R.modifiedLength=r-R.modifiedStart)}}}return L}A(L,e,b,N,R){if(e<R||N<R)return null;const A=L+e-R+1,w=b+N-R+1;let v=0,h=0,u=0;for(let r=L;r<A;r++)for(let o=b;o<w;o++){const f=this.B(r,o,R);f>0&&f>v&&(v=f,h=r,u=o)}return v>0?[h,u]:null}B(L,e,b){let N=0;for(let R=0;R<b;R++){if(!this.p(L+R,e+R))return 0;N+=this.e[L+R].length}return N}C(L){return L<=0||L>=this.f.length-1?!0:this.d&&/^\s*$/.test(this.e[L])}D(L,e){if(this.C(L)||this.C(L-1))return!0;if(e>0){const b=L+e;if(this.C(b-1)||this.C(b))return!0}return!1}E(L){return L<=0||L>=this.h.length-1?!0:this.d&&/^\s*$/.test(this.g[L])}F(L,e){if(this.E(L)||this.E(L-1))return!0;if(e>0){const b=L+e;if(this.E(b-1)||this.E(b))return!0}return!1}G(L,e,b,N){const R=this.D(L,e)?1:0,A=this.F(b,N)?1:0;return R+A}H(L,e){const b=[];if(L.length===0||e.length===0)return e.length>0?e:L;if(this.I(L[L.length-1],e[0],b)){const N=new Array(L.length+e.length-1);return a.Copy(L,0,N,0,L.length-1),N[L.length-1]=b[0],a.Copy(e,1,N,L.length,e.length-1),N}else{const N=new Array(L.length+e.length);return a.Copy(L,0,N,0,L.length),a.Copy(e,0,N,L.length,e.length),N}}I(L,e,b){if(d.Assert(L.originalStart<=e.originalStart,"Left change is not less than or equal to right change"),d.Assert(L.modifiedStart<=e.modifiedStart,"Left change is not less than or equal to right change"),L.originalStart+L.originalLength>=e.originalStart||L.modifiedStart+L.modifiedLength>=e.modifiedStart){const N=L.originalStart;let R=L.originalLength;const A=L.modifiedStart;let w=L.modifiedLength;return L.originalStart+L.originalLength>=e.originalStart&&(R=e.originalStart+e.originalLength-L.originalStart),L.modifiedStart+L.modifiedLength>=e.modifiedStart&&(w=e.modifiedStart+e.modifiedLength-L.modifiedStart),b[0]=new t.$Pt(N,R,A,w),!0}else return b[0]=null,!1}J(L,e,b,N){if(L>=0&&L<N)return L;const R=b,A=N-b-1,w=e%2===0;if(L<0){const v=R%2===0;return w===v?0:1}else{const v=A%2===0;return w===v?N-1:N-2}}}i.$St=$}),ne(ie[30],re([0,1,14]),function(x,i,t){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.$fu=i.$eu=void 0;class n{constructor(d){const a=(0,t.$cf)(d);this.c=a,this.a=n.d(a),this.b=new Map}static d(d){const a=new Uint8Array(256);return a.fill(d),a}set(d,a){const l=(0,t.$cf)(a);d>=0&&d<256?this.a[d]=l:this.b.set(d,l)}get(d){return d>=0&&d<256?this.a[d]:this.b.get(d)||this.c}clear(){this.a.fill(this.c),this.b.clear()}}i.$eu=n;var p;(function(E){E[E.False=0]="False",E[E.True=1]="True"})(p||(p={}));class g{constructor(){this.a=new n(p.False)}add(d){this.a.set(d,p.True)}has(d){return this.a.get(d)===p.True}clear(){return this.a.clear()}}i.$fu=g}),ne(ie[6],re([0,1,4]),function(x,i,t){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.$Ut=i.$Tt=void 0;class n{static addRange(E,d){let a=0;for(;a<d.length&&d[a].endExclusive<E.start;)a++;let l=a;for(;l<d.length&&d[l].start<=E.endExclusive;)l++;if(a===l)d.splice(a,0,E);else{const c=Math.min(E.start,d[a].start),$=Math.max(E.endExclusive,d[l-1].endExclusive);d.splice(a,l-a,new n(c,$))}}static tryCreate(E,d){if(!(E>d))return new n(E,d)}static ofLength(E){return new n(0,E)}static ofStartAndLength(E,d){return new n(E,E+d)}constructor(E,d){if(this.start=E,this.endExclusive=d,E>d)throw new t.$fb(`Invalid range: ${this.toString()}`)}get isEmpty(){return this.start===this.endExclusive}delta(E){return new n(this.start+E,this.endExclusive+E)}deltaStart(E){return new n(this.start+E,this.endExclusive)}deltaEnd(E){return new n(this.start,this.endExclusive+E)}get length(){return this.endExclusive-this.start}toString(){return`[${this.start}, ${this.endExclusive})`}equals(E){return this.start===E.start&&this.endExclusive===E.endExclusive}containsRange(E){return this.start<=E.start&&E.endExclusive<=this.endExclusive}contains(E){return this.start<=E&&E<this.endExclusive}join(E){return new n(Math.min(this.start,E.start),Math.max(this.endExclusive,E.endExclusive))}intersect(E){const d=Math.max(this.start,E.start),a=Math.min(this.endExclusive,E.endExclusive);if(d<=a)return new n(d,a)}intersects(E){const d=Math.max(this.start,E.start),a=Math.min(this.endExclusive,E.endExclusive);return d<a}intersectsOrTouches(E){const d=Math.max(this.start,E.start),a=Math.min(this.endExclusive,E.endExclusive);return d<=a}isBefore(E){return this.endExclusive<=E.start}isAfter(E){return this.start>=E.endExclusive}slice(E){return E.slice(this.start,this.endExclusive)}substring(E){return E.substring(this.start,this.endExclusive)}clip(E){if(this.isEmpty)throw new t.$fb(`Invalid clipping range: ${this.toString()}`);return Math.max(this.start,Math.min(this.endExclusive-1,E))}clipCyclic(E){if(this.isEmpty)throw new t.$fb(`Invalid clipping range: ${this.toString()}`);return E<this.start?this.endExclusive-(this.start-E)%this.length:E>=this.endExclusive?this.start+(E-this.start)%this.length:E}map(E){const d=[];for(let a=this.start;a<this.endExclusive;a++)d.push(E(a));return d}forEach(E){for(let d=this.start;d<this.endExclusive;d++)E(d)}}i.$Tt=n;class p{constructor(){this.a=[]}addRange(E){let d=0;for(;d<this.a.length&&this.a[d].endExclusive<E.start;)d++;let a=d;for(;a<this.a.length&&this.a[a].start<=E.endExclusive;)a++;if(d===a)this.a.splice(d,0,E);else{const l=Math.min(E.start,this.a[d].start),c=Math.max(E.endExclusive,this.a[a-1].endExclusive);this.a.splice(d,a-d,new n(l,c))}}toString(){return this.a.map(E=>E.toString()).join(", ")}intersectsStrict(E){let d=0;for(;d<this.a.length&&this.a[d].endExclusive<=E.start;)d++;return d<this.a.length&&this.a[d].start<E.endExclusive}intersectWithRange(E){const d=new p;for(const a of this.a){const l=a.intersect(E);l&&d.addRange(l)}return d}intersectWithRangeLength(E){return this.intersectWithRange(E).length}get length(){return this.a.reduce((E,d)=>E+d.length,0)}}i.$Ut=p}),ne(ie[5],re([0,1]),function(x,i){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.$Lt=void 0;class t{constructor(p,g){this.lineNumber=p,this.column=g}with(p=this.lineNumber,g=this.column){return p===this.lineNumber&&g===this.column?this:new t(p,g)}delta(p=0,g=0){return this.with(this.lineNumber+p,this.column+g)}equals(p){return t.equals(this,p)}static equals(p,g){return!p&&!g?!0:!!p&&!!g&&p.lineNumber===g.lineNumber&&p.column===g.column}isBefore(p){return t.isBefore(this,p)}static isBefore(p,g){return p.lineNumber<g.lineNumber?!0:g.lineNumber<p.lineNumber?!1:p.column<g.column}isBeforeOrEqual(p){return t.isBeforeOrEqual(this,p)}static isBeforeOrEqual(p,g){return p.lineNumber<g.lineNumber?!0:g.lineNumber<p.lineNumber?!1:p.column<=g.column}static compare(p,g){const E=p.lineNumber|0,d=g.lineNumber|0;if(E===d){const a=p.column|0,l=g.column|0;return a-l}return E-d}clone(){return new t(this.lineNumber,this.column)}toString(){return"("+this.lineNumber+","+this.column+")"}static lift(p){return new t(p.lineNumber,p.column)}static isIPosition(p){return p&&typeof p.lineNumber=="number"&&typeof p.column=="number"}toJSON(){return{lineNumber:this.lineNumber,column:this.column}}}i.$Lt=t}),ne(ie[2],re([0,1,5]),function(x,i,t){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.$Mt=void 0;class n{constructor(g,E,d,a){g>d||g===d&&E>a?(this.startLineNumber=d,this.startColumn=a,this.endLineNumber=g,this.endColumn=E):(this.startLineNumber=g,this.startColumn=E,this.endLineNumber=d,this.endColumn=a)}isEmpty(){return n.isEmpty(this)}static isEmpty(g){return g.startLineNumber===g.endLineNumber&&g.startColumn===g.endColumn}containsPosition(g){return n.containsPosition(this,g)}static containsPosition(g,E){return!(E.lineNumber<g.startLineNumber||E.lineNumber>g.endLineNumber||E.lineNumber===g.startLineNumber&&E.column<g.startColumn||E.lineNumber===g.endLineNumber&&E.column>g.endColumn)}static strictContainsPosition(g,E){return!(E.lineNumber<g.startLineNumber||E.lineNumber>g.endLineNumber||E.lineNumber===g.startLineNumber&&E.column<=g.startColumn||E.lineNumber===g.endLineNumber&&E.column>=g.endColumn)}containsRange(g){return n.containsRange(this,g)}static containsRange(g,E){return!(E.startLineNumber<g.startLineNumber||E.endLineNumber<g.startLineNumber||E.startLineNumber>g.endLineNumber||E.endLineNumber>g.endLineNumber||E.startLineNumber===g.startLineNumber&&E.startColumn<g.startColumn||E.endLineNumber===g.endLineNumber&&E.endColumn>g.endColumn)}strictContainsRange(g){return n.strictContainsRange(this,g)}static strictContainsRange(g,E){return!(E.startLineNumber<g.startLineNumber||E.endLineNumber<g.startLineNumber||E.startLineNumber>g.endLineNumber||E.endLineNumber>g.endLineNumber||E.startLineNumber===g.startLineNumber&&E.startColumn<=g.startColumn||E.endLineNumber===g.endLineNumber&&E.endColumn>=g.endColumn)}plusRange(g){return n.plusRange(this,g)}static plusRange(g,E){let d,a,l,c;return E.startLineNumber<g.startLineNumber?(d=E.startLineNumber,a=E.startColumn):E.startLineNumber===g.startLineNumber?(d=E.startLineNumber,a=Math.min(E.startColumn,g.startColumn)):(d=g.startLineNumber,a=g.startColumn),E.endLineNumber>g.endLineNumber?(l=E.endLineNumber,c=E.endColumn):E.endLineNumber===g.endLineNumber?(l=E.endLineNumber,c=Math.max(E.endColumn,g.endColumn)):(l=g.endLineNumber,c=g.endColumn),new n(d,a,l,c)}intersectRanges(g){return n.intersectRanges(this,g)}static intersectRanges(g,E){let d=g.startLineNumber,a=g.startColumn,l=g.endLineNumber,c=g.endColumn;const $=E.startLineNumber,m=E.startColumn,L=E.endLineNumber,e=E.endColumn;return d<$?(d=$,a=m):d===$&&(a=Math.max(a,m)),l>L?(l=L,c=e):l===L&&(c=Math.min(c,e)),d>l||d===l&&a>c?null:new n(d,a,l,c)}equalsRange(g){return n.equalsRange(this,g)}static equalsRange(g,E){return!g&&!E?!0:!!g&&!!E&&g.startLineNumber===E.startLineNumber&&g.startColumn===E.startColumn&&g.endLineNumber===E.endLineNumber&&g.endColumn===E.endColumn}getEndPosition(){return n.getEndPosition(this)}static getEndPosition(g){return new t.$Lt(g.endLineNumber,g.endColumn)}getStartPosition(){return n.getStartPosition(this)}static getStartPosition(g){return new t.$Lt(g.startLineNumber,g.startColumn)}toString(){return"["+this.startLineNumber+","+this.startColumn+" -> "+this.endLineNumber+","+this.endColumn+"]"}setEndPosition(g,E){return new n(this.startLineNumber,this.startColumn,g,E)}setStartPosition(g,E){return new n(g,E,this.endLineNumber,this.endColumn)}collapseToStart(){return n.collapseToStart(this)}static collapseToStart(g){return new n(g.startLineNumber,g.startColumn,g.startLineNumber,g.startColumn)}collapseToEnd(){return n.collapseToEnd(this)}static collapseToEnd(g){return new n(g.endLineNumber,g.endColumn,g.endLineNumber,g.endColumn)}delta(g){return new n(this.startLineNumber+g,this.startColumn,this.endLineNumber+g,this.endColumn)}static fromPositions(g,E=g){return new n(g.lineNumber,g.column,E.lineNumber,E.column)}static lift(g){return g?new n(g.startLineNumber,g.startColumn,g.endLineNumber,g.endColumn):null}static isIRange(g){return g&&typeof g.startLineNumber=="number"&&typeof g.startColumn=="number"&&typeof g.endLineNumber=="number"&&typeof g.endColumn=="number"}static areIntersectingOrTouching(g,E){return!(g.endLineNumber<E.startLineNumber||g.endLineNumber===E.startLineNumber&&g.endColumn<E.startColumn||E.endLineNumber<g.startLineNumber||E.endLineNumber===g.startLineNumber&&E.endColumn<g.startColumn)}static areIntersecting(g,E){return!(g.endLineNumber<E.startLineNumber||g.endLineNumber===E.startLineNumber&&g.endColumn<=E.startColumn||E.endLineNumber<g.startLineNumber||E.endLineNumber===g.startLineNumber&&E.endColumn<=g.startColumn)}static compareRangesUsingStarts(g,E){if(g&&E){const l=g.startLineNumber|0,c=E.startLineNumber|0;if(l===c){const $=g.startColumn|0,m=E.startColumn|0;if($===m){const L=g.endLineNumber|0,e=E.endLineNumber|0;if(L===e){const b=g.endColumn|0,N=E.endColumn|0;return b-N}return L-e}return $-m}return l-c}return(g?1:0)-(E?1:0)}static compareRangesUsingEnds(g,E){return g.endLineNumber===E.endLineNumber?g.endColumn===E.endColumn?g.startLineNumber===E.startLineNumber?g.startColumn-E.startColumn:g.startLineNumber-E.startLineNumber:g.endColumn-E.endColumn:g.endLineNumber-E.endLineNumber}static spansMultipleLines(g){return g.endLineNumber>g.startLineNumber}toJSON(){return this}}i.$Mt=n}),ne(ie[47],re([0,1,2]),function(x,i,t){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.$Nt=void 0;class n{static insert(g,E){return{range:new t.$Mt(g.lineNumber,g.column,g.lineNumber,g.column),text:E,forceMoveMarkers:!0}}static delete(g){return{range:g,text:null}}static replace(g,E){return{range:g,text:E}}static replaceMove(g,E){return{range:g,text:E,forceMoveMarkers:!0}}}i.$Nt=n}),ne(ie[15],re([0,1,4,6,2,9]),function(x,i,t,n,p,g){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.$Wt=i.$Vt=void 0;class E{static fromRange(l){return new E(l.startLineNumber,l.endLineNumber)}static fromRangeInclusive(l){return new E(l.startLineNumber,l.endLineNumber+1)}static subtract(l,c){return c?l.startLineNumber<c.startLineNumber&&c.endLineNumberExclusive<l.endLineNumberExclusive?[new E(l.startLineNumber,c.startLineNumber),new E(c.endLineNumberExclusive,l.endLineNumberExclusive)]:c.startLineNumber<=l.startLineNumber&&l.endLineNumberExclusive<=c.endLineNumberExclusive?[]:c.endLineNumberExclusive<l.endLineNumberExclusive?[new E(Math.max(c.endLineNumberExclusive,l.startLineNumber),l.endLineNumberExclusive)]:[new E(l.startLineNumber,Math.min(c.startLineNumber,l.endLineNumberExclusive))]:[l]}static joinMany(l){if(l.length===0)return[];let c=new d(l[0].slice());for(let $=1;$<l.length;$++)c=c.getUnion(new d(l[$].slice()));return c.ranges}static join(l){if(l.length===0)throw new t.$fb("lineRanges cannot be empty");let c=l[0].startLineNumber,$=l[0].endLineNumberExclusive;for(let m=1;m<l.length;m++)c=Math.min(c,l[m].startLineNumber),$=Math.max($,l[m].endLineNumberExclusive);return new E(c,$)}static ofLength(l,c){return new E(l,l+c)}static deserialize(l){return new E(l[0],l[1])}constructor(l,c){if(l>c)throw new t.$fb(`startLineNumber ${l} cannot be after endLineNumberExclusive ${c}`);this.startLineNumber=l,this.endLineNumberExclusive=c}contains(l){return this.startLineNumber<=l&&l<this.endLineNumberExclusive}get isEmpty(){return this.startLineNumber===this.endLineNumberExclusive}delta(l){return new E(this.startLineNumber+l,this.endLineNumberExclusive+l)}deltaLength(l){return new E(this.startLineNumber,this.endLineNumberExclusive+l)}get length(){return this.endLineNumberExclusive-this.startLineNumber}join(l){return new E(Math.min(this.startLineNumber,l.startLineNumber),Math.max(this.endLineNumberExclusive,l.endLineNumberExclusive))}toString(){return`[${this.startLineNumber},${this.endLineNumberExclusive})`}intersect(l){const c=Math.max(this.startLineNumber,l.startLineNumber),$=Math.min(this.endLineNumberExclusive,l.endLineNumberExclusive);if(c<=$)return new E(c,$)}intersectsStrict(l){return this.startLineNumber<l.endLineNumberExclusive&&l.startLineNumber<this.endLineNumberExclusive}overlapOrTouch(l){return this.startLineNumber<=l.endLineNumberExclusive&&l.startLineNumber<=this.endLineNumberExclusive}equals(l){return this.startLineNumber===l.startLineNumber&&this.endLineNumberExclusive===l.endLineNumberExclusive}toInclusiveRange(){return this.isEmpty?null:new p.$Mt(this.startLineNumber,1,this.endLineNumberExclusive-1,Number.MAX_SAFE_INTEGER)}toExclusiveRange(){return new p.$Mt(this.startLineNumber,1,this.endLineNumberExclusive,1)}mapToLineArray(l){const c=[];for(let $=this.startLineNumber;$<this.endLineNumberExclusive;$++)c.push(l($));return c}forEach(l){for(let c=this.startLineNumber;c<this.endLineNumberExclusive;c++)l(c)}serialize(){return[this.startLineNumber,this.endLineNumberExclusive]}includes(l){return this.startLineNumber<=l&&l<this.endLineNumberExclusive}toOffsetRange(){return new n.$Tt(this.startLineNumber-1,this.endLineNumberExclusive-1)}}i.$Vt=E;class d{constructor(l=[]){this.c=l}get ranges(){return this.c}addRange(l){if(l.length===0)return;const c=(0,g.$nb)(this.c,m=>m.endLineNumberExclusive>=l.startLineNumber),$=(0,g.$lb)(this.c,m=>m.startLineNumber<=l.endLineNumberExclusive)+1;if(c===$)this.c.splice(c,0,l);else if(c===$-1){const m=this.c[c];this.c[c]=m.join(l)}else{const m=this.c[c].join(this.c[$-1]).join(l);this.c.splice(c,$-c,m)}}contains(l){const c=(0,g.$kb)(this.c,$=>$.startLineNumber<=l);return!!c&&c.endLineNumberExclusive>l}intersects(l){const c=(0,g.$kb)(this.c,$=>$.startLineNumber<l.endLineNumberExclusive);return!!c&&c.endLineNumberExclusive>l.startLineNumber}getUnion(l){if(this.c.length===0)return l;if(l.c.length===0)return this;const c=[];let $=0,m=0,L=null;for(;$<this.c.length||m<l.c.length;){let e=null;if($<this.c.length&&m<l.c.length){const b=this.c[$],N=l.c[m];b.startLineNumber<N.startLineNumber?(e=b,$++):(e=N,m++)}else $<this.c.length?(e=this.c[$],$++):(e=l.c[m],m++);L===null?L=e:L.endLineNumberExclusive>=e.startLineNumber?L=new E(L.startLineNumber,Math.max(L.endLineNumberExclusive,e.endLineNumberExclusive)):(c.push(L),L=e)}return L!==null&&c.push(L),new d(c)}subtractFrom(l){const c=(0,g.$nb)(this.c,e=>e.endLineNumberExclusive>=l.startLineNumber),$=(0,g.$lb)(this.c,e=>e.startLineNumber<=l.endLineNumberExclusive)+1;if(c===$)return new d([l]);const m=[];let L=l.startLineNumber;for(let e=c;e<$;e++){const b=this.c[e];b.startLineNumber>L&&m.push(new E(L,b.startLineNumber)),L=b.endLineNumberExclusive}return L<l.endLineNumberExclusive&&m.push(new E(L,l.endLineNumberExclusive)),new d(m)}toString(){return this.c.map(l=>l.toString()).join(", ")}getIntersection(l){const c=[];let $=0,m=0;for(;$<this.c.length&&m<l.c.length;){const L=this.c[$],e=l.c[m],b=L.intersect(e);b&&!b.isEmpty&&c.push(b),L.endLineNumberExclusive<e.endLineNumberExclusive?$++:m++}return new d(c)}getWithDelta(l){return new d(this.c.map(c=>c.delta(l)))}}i.$Wt=d}),ne(ie[48],re([0,1,5,2]),function(x,i,t,n){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.$Ot=i.SelectionDirection=void 0;var p;(function(E){E[E.LTR=0]="LTR",E[E.RTL=1]="RTL"})(p||(i.SelectionDirection=p={}));class g extends n.$Mt{constructor(d,a,l,c){super(d,a,l,c),this.selectionStartLineNumber=d,this.selectionStartColumn=a,this.positionLineNumber=l,this.positionColumn=c}toString(){return"["+this.selectionStartLineNumber+","+this.selectionStartColumn+" -> "+this.positionLineNumber+","+this.positionColumn+"]"}equalsSelection(d){return g.selectionsEqual(this,d)}static selectionsEqual(d,a){return d.selectionStartLineNumber===a.selectionStartLineNumber&&d.selectionStartColumn===a.selectionStartColumn&&d.positionLineNumber===a.positionLineNumber&&d.positionColumn===a.positionColumn}getDirection(){return this.selectionStartLineNumber===this.startLineNumber&&this.selectionStartColumn===this.startColumn?p.LTR:p.RTL}setEndPosition(d,a){return this.getDirection()===p.LTR?new g(this.startLineNumber,this.startColumn,d,a):new g(d,a,this.startLineNumber,this.startColumn)}getPosition(){return new t.$Lt(this.positionLineNumber,this.positionColumn)}getSelectionStart(){return new t.$Lt(this.selectionStartLineNumber,this.selectionStartColumn)}setStartPosition(d,a){return this.getDirection()===p.LTR?new g(d,a,this.endLineNumber,this.endColumn):new g(this.endLineNumber,this.endColumn,d,a)}static fromPositions(d,a=d){return new g(d.lineNumber,d.column,a.lineNumber,a.column)}static fromRange(d,a){return a===p.LTR?new g(d.startLineNumber,d.startColumn,d.endLineNumber,d.endColumn):new g(d.endLineNumber,d.endColumn,d.startLineNumber,d.startColumn)}static liftSelection(d){return new g(d.selectionStartLineNumber,d.selectionStartColumn,d.positionLineNumber,d.positionColumn)}static selectionsArrEqual(d,a){if(d&&!a||!d&&a)return!1;if(!d&&!a)return!0;if(d.length!==a.length)return!1;for(let l=0,c=d.length;l<c;l++)if(!this.selectionsEqual(d[l],a[l]))return!1;return!0}static isISelection(d){return d&&typeof d.selectionStartLineNumber=="number"&&typeof d.selectionStartColumn=="number"&&typeof d.positionLineNumber=="number"&&typeof d.positionColumn=="number"}static createWithDirection(d,a,l,c,$){return $===p.LTR?new g(d,a,l,c):new g(l,c,d,a)}}i.$Ot=g}),ne(ie[31],re([0,1,5,2]),function(x,i,t,n){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.$Xt=void 0;class p{static{this.zero=new p(0,0)}static lengthDiffNonNegative(E,d){return d.isLessThan(E)?p.zero:E.lineCount===d.lineCount?new p(0,d.columnCount-E.columnCount):new p(d.lineCount-E.lineCount,d.columnCount)}static betweenPositions(E,d){return E.lineNumber===d.lineNumber?new p(0,d.column-E.column):new p(d.lineNumber-E.lineNumber,d.column-1)}static ofRange(E){return p.betweenPositions(E.getStartPosition(),E.getEndPosition())}static ofText(E){let d=0,a=0;for(const l of E)l===`
`?(d++,a=0):a++;return new p(d,a)}constructor(E,d){this.lineCount=E,this.columnCount=d}isZero(){return this.lineCount===0&&this.columnCount===0}isLessThan(E){return this.lineCount!==E.lineCount?this.lineCount<E.lineCount:this.columnCount<E.columnCount}isGreaterThan(E){return this.lineCount!==E.lineCount?this.lineCount>E.lineCount:this.columnCount>E.columnCount}isGreaterThanOrEqualTo(E){return this.lineCount!==E.lineCount?this.lineCount>E.lineCount:this.columnCount>=E.columnCount}equals(E){return this.lineCount===E.lineCount&&this.columnCount===E.columnCount}compare(E){return this.lineCount!==E.lineCount?this.lineCount-E.lineCount:this.columnCount-E.columnCount}add(E){return E.lineCount===0?new p(this.lineCount,this.columnCount+E.columnCount):new p(this.lineCount+E.lineCount,E.columnCount)}createRange(E){return this.lineCount===0?new n.$Mt(E.lineNumber,E.column,E.lineNumber,E.column+this.columnCount):new n.$Mt(E.lineNumber,E.column,E.lineNumber+this.lineCount,this.columnCount+1)}toRange(){return new n.$Mt(1,1,this.lineCount+1,this.columnCount+1)}addToPosition(E){return this.lineCount===0?new t.$Lt(E.lineNumber,E.column+this.columnCount):new t.$Lt(E.lineNumber+this.lineCount,this.columnCount+1)}toString(){return`${this.lineCount},${this.columnCount}`}}i.$Xt=p}),ne(ie[49],re([0,1,9,6,5,2,31]),function(x,i,t,n,p,g,E){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.$Yt=void 0;class d{constructor(l){this.text=l,this.a=[],this.a.push(0);for(let c=0;c<l.length;c++)l.charAt(c)===`
`&&this.a.push(c+1)}getOffset(l){return this.a[l.lineNumber-1]+l.column-1}getOffsetRange(l){return new n.$Tt(this.getOffset(l.getStartPosition()),this.getOffset(l.getEndPosition()))}getPosition(l){const c=(0,t.$lb)(this.a,L=>L<=l),$=c+1,m=l-this.a[c]+1;return new p.$Lt($,m)}getRange(l){return g.$Mt.fromPositions(this.getPosition(l.start),this.getPosition(l.endExclusive))}getTextLength(l){return E.$Xt.ofRange(this.getRange(l))}get textLength(){const l=this.a.length-1;return new E.$Xt(l,this.text.length-this.a[l])}}i.$Yt=d}),ne(ie[50],re([0,1,11,4,5,49,2,31]),function(x,i,t,n,p,g,E,d){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.$4t=i.$3t=i.$2t=i.$1t=i.$Zt=void 0;class a{static single(b,N){return new a([new l(b,N)])}constructor(b){this.edits=b,(0,t.$kd)(()=>(0,t.$ld)(b,(N,R)=>N.range.getEndPosition().isBeforeOrEqual(R.range.getStartPosition())))}normalize(){const b=[];for(const N of this.edits)if(b.length>0&&b[b.length-1].range.getEndPosition().equals(N.range.getStartPosition())){const R=b[b.length-1];b[b.length-1]=new l(R.range.plusRange(N.range),R.text+N.text)}else N.isEmpty||b.push(N);return new a(b)}mapPosition(b){let N=0,R=0,A=0;for(const w of this.edits){const v=w.range.getStartPosition(),h=w.range.getEndPosition();if(b.isBeforeOrEqual(v))break;const u=d.$Xt.ofText(w.text);if(b.isBefore(h)){const r=new p.$Lt(v.lineNumber+N,v.column+(v.lineNumber+N===R?A:0)),o=u.addToPosition(r);return c(r,o)}N+=u.lineCount-(w.range.endLineNumber-w.range.startLineNumber),u.lineCount===0?h.lineNumber!==v.lineNumber?A+=u.columnCount-(h.column-1):A+=u.columnCount-(h.column-v.column):A=u.columnCount,R=h.lineNumber+N}return new p.$Lt(b.lineNumber+N,b.column+(b.lineNumber+N===R?A:0))}mapRange(b){function N(v){return v instanceof p.$Lt?v:v.getStartPosition()}function R(v){return v instanceof p.$Lt?v:v.getEndPosition()}const A=N(this.mapPosition(b.getStartPosition())),w=R(this.mapPosition(b.getEndPosition()));return c(A,w)}inverseMapPosition(b,N){return this.inverse(N).mapPosition(b)}inverseMapRange(b,N){return this.inverse(N).mapRange(b)}apply(b){let N="",R=new p.$Lt(1,1);for(const w of this.edits){const v=w.range,h=v.getStartPosition(),u=v.getEndPosition(),r=c(R,h);r.isEmpty()||(N+=b.getValueOfRange(r)),N+=w.text,R=u}const A=c(R,b.endPositionExclusive);return A.isEmpty()||(N+=b.getValueOfRange(A)),N}applyToString(b){const N=new L(b);return this.apply(N)}inverse(b){const N=this.getNewRanges();return new a(this.edits.map((R,A)=>new l(N[A],b.getValueOfRange(R.range))))}getNewRanges(){const b=[];let N=0,R=0,A=0;for(const w of this.edits){const v=d.$Xt.ofText(w.text),h=p.$Lt.lift({lineNumber:w.range.startLineNumber+R,column:w.range.startColumn+(w.range.startLineNumber===N?A:0)}),u=v.createRange(h);b.push(u),R=u.endLineNumber-w.range.endLineNumber,A=u.endColumn-w.range.endColumn,N=w.range.endLineNumber}return b}}i.$Zt=a;class l{constructor(b,N){this.range=b,this.text=N}get isEmpty(){return this.range.isEmpty()&&this.text.length===0}static equals(b,N){return b.range.equalsRange(N.range)&&b.text===N.text}toSingleEditOperation(){return{range:this.range,text:this.text}}}i.$1t=l;function c(e,b){if(e.lineNumber===b.lineNumber&&e.column===Number.MAX_SAFE_INTEGER)return E.$Mt.fromPositions(b,b);if(!e.isBeforeOrEqual(b))throw new n.$fb("start must be before end");return new E.$Mt(e.lineNumber,e.column,b.lineNumber,b.column)}class ${get endPositionExclusive(){return this.length.addToPosition(new p.$Lt(1,1))}getValue(){return this.getValueOfRange(this.length.toRange())}}i.$2t=$;class m extends ${constructor(b,N){(0,t.$id)(N>=1),super(),this.c=b,this.d=N}getValueOfRange(b){if(b.startLineNumber===b.endLineNumber)return this.c(b.startLineNumber).substring(b.startColumn-1,b.endColumn-1);let N=this.c(b.startLineNumber).substring(b.startColumn-1);for(let R=b.startLineNumber+1;R<b.endLineNumber;R++)N+=`
`+this.c(R);return N+=`
`+this.c(b.endLineNumber).substring(0,b.endColumn-1),N}get length(){const b=this.c(this.d);return new d.$Xt(this.d-1,b.length)}}i.$3t=m;class L extends ${constructor(b){super(),this.value=b,this.c=new g.$Yt(this.value)}getValueOfRange(b){return this.c.getOffsetRange(b).substring(this.value)}get length(){return this.c.textLength}}i.$4t=L}),ne(ie[51],re([0,1,3,16,30]),function(x,i,t,n,p){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.$gu=i.WordCharacterClass=void 0,i.$hu=a;var g;(function(l){l[l.Regular=0]="Regular",l[l.Whitespace=1]="Whitespace",l[l.WordSeparator=2]="WordSeparator"})(g||(i.WordCharacterClass=g={}));class E extends p.$eu{constructor(c,$){super(g.Regular),this.e=null,this.f=null,this.g=[],this.intlSegmenterLocales=$,this.intlSegmenterLocales.length>0?this.e=new Intl.Segmenter(this.intlSegmenterLocales,{granularity:"word"}):this.e=null;for(let m=0,L=c.length;m<L;m++)this.set(c.charCodeAt(m),g.WordSeparator);this.set(t.CharCode.Space,g.Whitespace),this.set(t.CharCode.Tab,g.Whitespace)}findPrevIntlWordBeforeOrAtOffset(c,$){let m=null;for(const L of this.h(c)){if(L.index>$)break;m=L}return m}findNextIntlWordAtOrAfterOffset(c,$){for(const m of this.h(c))if(!(m.index<$))return m;return null}h(c){return this.e?this.f===c?this.g:(this.f=c,this.g=this.j(this.e.segment(c)),this.g):[]}j(c){const $=[];for(const m of c)this.k(m)&&$.push(m);return $}k(c){return!!c.isWordLike}}i.$gu=E;const d=new n.$Gc(10);function a(l,c){const $=`${l}/${c.join(",")}`;let m=d.get($);return m||(m=new E(l,c),d.set($,m)),m}}),ne(ie[32],re([0,1,23,12,24]),function(x,i,t,n,p){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.$lt=i.$kt=void 0,i.$mt=E,i.$nt=a,i.$ot=l,i.$kt="`~!@#$%^&*()-=+[{]}\\|;:'\",.<>/?";function g($=""){let m="(-?\\d*\\.\\d\\w*)|([^";for(const L of i.$kt)$.indexOf(L)>=0||(m+="\\"+L);return m+="\\s]+)",new RegExp(m,"g")}i.$lt=g();function E($){let m=i.$lt;if($&&$ instanceof RegExp)if($.global)m=$;else{let L="g";$.ignoreCase&&(L+="i"),$.multiline&&(L+="m"),$.unicode&&(L+="u"),m=new RegExp($.source,L)}return m.lastIndex=0,m}const d=new p.$8c;d.unshift({maxLen:1e3,windowSize:15,timeBudget:150});function a($){const m=d.unshift($);return(0,n.$Vc)(m)}function l($,m,L,e,b){if(m=E(m),b||(b=t.Iterable.first(d)),L.length>b.maxLen){let v=$-b.maxLen/2;return v<0?v=0:e+=v,L=L.substring(v,$+b.maxLen/2),l($,m,L,e,b)}const N=Date.now(),R=$-1-e;let A=-1,w=null;for(let v=1;!(Date.now()-N>=b.timeBudget);v++){const h=R-b.windowSize*v;m.lastIndex=Math.max(0,h);const u=c(m,L,R,A);if(!u&&w||(w=u,h<=0))break;A=h}if(w){const v={word:w[0],startColumn:e+1+w.index,endColumn:e+1+w.index+w[0].length};return m.lastIndex=0,v}return null}function c($,m,L,e){let b;for(;b=$.exec(m);){const N=b.index||0;if(N<=L&&$.lastIndex>=L)return b;if(e>0&&N>e)return null}return null}}),ne(ie[10],re([0,1,7,4,6]),function(x,i,t,n,p){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.$z4=i.$y4=i.$x4=i.$w4=i.$v4=void 0;class g{static trivial($,m){return new g([new E(p.$Tt.ofLength($.length),p.$Tt.ofLength(m.length))],!1)}static trivialTimedOut($,m){return new g([new E(p.$Tt.ofLength($.length),p.$Tt.ofLength(m.length))],!0)}constructor($,m){this.diffs=$,this.hitTimeout=m}}i.$v4=g;class E{static invert($,m){const L=[];return(0,t.$Eb)($,(e,b)=>{L.push(E.fromOffsetPairs(e?e.getEndExclusives():d.zero,b?b.getStarts():new d(m,(e?e.seq2Range.endExclusive-e.seq1Range.endExclusive:0)+m)))}),L}static fromOffsetPairs($,m){return new E(new p.$Tt($.offset1,m.offset1),new p.$Tt($.offset2,m.offset2))}constructor($,m){this.seq1Range=$,this.seq2Range=m}swap(){return new E(this.seq2Range,this.seq1Range)}toString(){return`${this.seq1Range} <-> ${this.seq2Range}`}join($){return new E(this.seq1Range.join($.seq1Range),this.seq2Range.join($.seq2Range))}delta($){return $===0?this:new E(this.seq1Range.delta($),this.seq2Range.delta($))}deltaStart($){return $===0?this:new E(this.seq1Range.deltaStart($),this.seq2Range.deltaStart($))}deltaEnd($){return $===0?this:new E(this.seq1Range.deltaEnd($),this.seq2Range.deltaEnd($))}intersectsOrTouches($){return this.seq1Range.intersectsOrTouches($.seq1Range)||this.seq2Range.intersectsOrTouches($.seq2Range)}intersect($){const m=this.seq1Range.intersect($.seq1Range),L=this.seq2Range.intersect($.seq2Range);if(!(!m||!L))return new E(m,L)}getStarts(){return new d(this.seq1Range.start,this.seq2Range.start)}getEndExclusives(){return new d(this.seq1Range.endExclusive,this.seq2Range.endExclusive)}}i.$w4=E;class d{static{this.zero=new d(0,0)}static{this.max=new d(Number.MAX_SAFE_INTEGER,Number.MAX_SAFE_INTEGER)}constructor($,m){this.offset1=$,this.offset2=m}toString(){return`${this.offset1} <-> ${this.offset2}`}delta($){return $===0?this:new d(this.offset1+$,this.offset2+$)}equals($){return this.offset1===$.offset1&&this.offset2===$.offset2}}i.$x4=d;class a{static{this.instance=new a}isValid(){return!0}}i.$y4=a;class l{constructor($){if(this.e=$,this.c=Date.now(),this.d=!0,$<=0)throw new n.$fb("timeout must be positive")}isValid(){if(!(Date.now()-this.c<this.e)&&this.d){this.d=!1;debugger}return this.d}disable(){this.e=Number.MAX_SAFE_INTEGER,this.isValid=()=>!0,this.d=!0}}i.$z4=l}),ne(ie[33],re([0,1,6,10]),function(x,i,t,n){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.$E4=void 0;class p{compute(l,c,$=n.$y4.instance){if(l.length===0||c.length===0)return n.$v4.trivial(l,c);const m=l,L=c;function e(r,o){for(;r<m.length&&o<L.length&&m.getElement(r)===L.getElement(o);)r++,o++;return r}let b=0;const N=new E;N.set(0,e(0,0));const R=new d;R.set(0,N.get(0)===0?null:new g(null,0,0,N.get(0)));let A=0;e:for(;;){if(b++,!$.isValid())return n.$v4.trivialTimedOut(m,L);const r=-Math.min(b,L.length+b%2),o=Math.min(b,m.length+b%2);for(A=r;A<=o;A+=2){let f=0;const T=A===o?-1:N.get(A+1),_=A===r?-1:N.get(A-1)+1;f++;const M=Math.min(Math.max(T,_),m.length),j=M-A;if(f++,M>m.length||j>L.length)continue;const F=e(M,j);N.set(A,F);const I=M===T?R.get(A+1):R.get(A-1);if(R.set(A,F!==M?new g(I,M,j,F-M):I),N.get(A)===m.length&&N.get(A)-A===L.length)break e}}let w=R.get(A);const v=[];let h=m.length,u=L.length;for(;;){const r=w?w.x+w.length:0,o=w?w.y+w.length:0;if((r!==h||o!==u)&&v.push(new n.$w4(new t.$Tt(r,h),new t.$Tt(o,u))),!w)break;h=w.x,u=w.y,w=w.prev}return v.reverse(),new n.$v4(v,!1)}}i.$E4=p;class g{constructor(l,c,$,m){this.prev=l,this.x=c,this.y=$,this.length=m}}class E{constructor(){this.a=new Int32Array(10),this.b=new Int32Array(10)}get(l){return l<0?(l=-l-1,this.b[l]):this.a[l]}set(l,c){if(l<0){if(l=-l-1,l>=this.b.length){const $=this.b;this.b=new Int32Array($.length*2),this.b.set($)}this.b[l]=c}else{if(l>=this.a.length){const $=this.a;this.a=new Int32Array($.length*2),this.a.set($)}this.a[l]=c}}}class d{constructor(){this.a=[],this.b=[]}get(l){return l<0?(l=-l-1,this.b[l]):this.a[l]}set(l,c){l<0?(l=-l-1,this.b[l]=c):this.a[l]=c}}}),ne(ie[52],re([0,1,7,6,10]),function(x,i,t,n,p){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.$I4=g,i.$J4=l,i.$K4=c,i.$L4=m,i.$M4=L;function g(e,b,N){let R=N;return R=E(e,b,R),R=E(e,b,R),R=d(e,b,R),R}function E(e,b,N){if(N.length===0)return N;const R=[];R.push(N[0]);for(let w=1;w<N.length;w++){const v=R[R.length-1];let h=N[w];if(h.seq1Range.isEmpty||h.seq2Range.isEmpty){const u=h.seq1Range.start-v.seq1Range.endExclusive;let r;for(r=1;r<=u&&!(e.getElement(h.seq1Range.start-r)!==e.getElement(h.seq1Range.endExclusive-r)||b.getElement(h.seq2Range.start-r)!==b.getElement(h.seq2Range.endExclusive-r));r++);if(r--,r===u){R[R.length-1]=new p.$w4(new n.$Tt(v.seq1Range.start,h.seq1Range.endExclusive-u),new n.$Tt(v.seq2Range.start,h.seq2Range.endExclusive-u));continue}h=h.delta(-r)}R.push(h)}const A=[];for(let w=0;w<R.length-1;w++){const v=R[w+1];let h=R[w];if(h.seq1Range.isEmpty||h.seq2Range.isEmpty){const u=v.seq1Range.start-h.seq1Range.endExclusive;let r;for(r=0;r<u&&!(!e.isStronglyEqual(h.seq1Range.start+r,h.seq1Range.endExclusive+r)||!b.isStronglyEqual(h.seq2Range.start+r,h.seq2Range.endExclusive+r));r++);if(r===u){R[w+1]=new p.$w4(new n.$Tt(h.seq1Range.start+u,v.seq1Range.endExclusive),new n.$Tt(h.seq2Range.start+u,v.seq2Range.endExclusive));continue}r>0&&(h=h.delta(r))}A.push(h)}return R.length>0&&A.push(R[R.length-1]),A}function d(e,b,N){if(!e.getBoundaryScore||!b.getBoundaryScore)return N;for(let R=0;R<N.length;R++){const A=R>0?N[R-1]:void 0,w=N[R],v=R+1<N.length?N[R+1]:void 0,h=new n.$Tt(A?A.seq1Range.endExclusive+1:0,v?v.seq1Range.start-1:e.length),u=new n.$Tt(A?A.seq2Range.endExclusive+1:0,v?v.seq2Range.start-1:b.length);w.seq1Range.isEmpty?N[R]=a(w,e,b,h,u):w.seq2Range.isEmpty&&(N[R]=a(w.swap(),b,e,u,h).swap())}return N}function a(e,b,N,R,A){let v=1;for(;e.seq1Range.start-v>=R.start&&e.seq2Range.start-v>=A.start&&N.isStronglyEqual(e.seq2Range.start-v,e.seq2Range.endExclusive-v)&&v<100;)v++;v--;let h=0;for(;e.seq1Range.start+h<R.endExclusive&&e.seq2Range.endExclusive+h<A.endExclusive&&N.isStronglyEqual(e.seq2Range.start+h,e.seq2Range.endExclusive+h)&&h<100;)h++;if(v===0&&h===0)return e;let u=0,r=-1;for(let o=-v;o<=h;o++){const f=e.seq2Range.start+o,T=e.seq2Range.endExclusive+o,_=e.seq1Range.start+o,M=b.getBoundaryScore(_)+N.getBoundaryScore(f)+N.getBoundaryScore(T);M>r&&(r=M,u=o)}return e.delta(u)}function l(e,b,N){const R=[];for(const A of N){const w=R[R.length-1];if(!w){R.push(A);continue}A.seq1Range.start-w.seq1Range.endExclusive<=2||A.seq2Range.start-w.seq2Range.endExclusive<=2?R[R.length-1]=new p.$w4(w.seq1Range.join(A.seq1Range),w.seq2Range.join(A.seq2Range)):R.push(A)}return R}function c(e,b,N){const R=p.$w4.invert(N,e.length),A=[];let w=new p.$x4(0,0);function v(u,r){if(u.offset1<w.offset1||u.offset2<w.offset2)return;const o=e.findWordContaining(u.offset1),f=b.findWordContaining(u.offset2);if(!o||!f)return;let T=new p.$w4(o,f);const _=T.intersect(r);let M=_.seq1Range.length,j=_.seq2Range.length;for(;R.length>0;){const F=R[0];if(!(F.seq1Range.intersects(T.seq1Range)||F.seq2Range.intersects(T.seq2Range)))break;const S=e.findWordContaining(F.seq1Range.start),D=b.findWordContaining(F.seq2Range.start),q=new p.$w4(S,D),X=q.intersect(F);if(M+=X.seq1Range.length,j+=X.seq2Range.length,T=T.join(q),T.seq1Range.endExclusive>=F.seq1Range.endExclusive)R.shift();else break}M+j<(T.seq1Range.length+T.seq2Range.length)*2/3&&A.push(T),w=T.getEndExclusives()}for(;R.length>0;){const u=R.shift();u.seq1Range.isEmpty||(v(u.getStarts(),u),v(u.getEndExclusives().delta(-1),u))}return $(N,A)}function $(e,b){const N=[];for(;e.length>0||b.length>0;){const R=e[0],A=b[0];let w;R&&(!A||R.seq1Range.start<A.seq1Range.start)?w=e.shift():w=b.shift(),N.length>0&&N[N.length-1].seq1Range.endExclusive>=w.seq1Range.start?N[N.length-1]=N[N.length-1].join(w):N.push(w)}return N}function m(e,b,N){let R=N;if(R.length===0)return R;let A=0,w;do{w=!1;const v=[R[0]];for(let h=1;h<R.length;h++){let o=function(T,_){const M=new n.$Tt(r.seq1Range.endExclusive,u.seq1Range.start);return e.getText(M).replace(/\s/g,"").length<=4&&(T.seq1Range.length+T.seq2Range.length>5||_.seq1Range.length+_.seq2Range.length>5)};const u=R[h],r=v[v.length-1];o(r,u)?(w=!0,v[v.length-1]=v[v.length-1].join(u)):v.push(u)}R=v}while(A++<10&&w);return R}function L(e,b,N){let R=N;if(R.length===0)return R;let A=0,w;do{w=!1;const h=[R[0]];for(let u=1;u<R.length;u++){let f=function(_,M){const j=new n.$Tt(o.seq1Range.endExclusive,r.seq1Range.start);if(e.countLinesIn(j)>5||j.length>500)return!1;const I=e.getText(j).trim();if(I.length>20||I.split(/\r\n|\r|\n/).length>1)return!1;const S=e.countLinesIn(_.seq1Range),D=_.seq1Range.length,q=b.countLinesIn(_.seq2Range),X=_.seq2Range.length,B=e.countLinesIn(M.seq1Range),y=M.seq1Range.length,Y=b.countLinesIn(M.seq2Range),Z=M.seq2Range.length,H=2*40+50;function Q(C){return Math.min(C,H)}return Math.pow(Math.pow(Q(S*40+D),1.5)+Math.pow(Q(q*40+X),1.5),1.5)+Math.pow(Math.pow(Q(B*40+y),1.5)+Math.pow(Q(Y*40+Z),1.5),1.5)>(H**1.5)**1.5*1.3};const r=R[u],o=h[h.length-1];f(o,r)?(w=!0,h[h.length-1]=h[h.length-1].join(r)):h.push(r)}R=h}while(A++<10&&w);const v=[];return(0,t.$Fb)(R,(h,u,r)=>{let o=u;function f(I){return I.length>0&&I.trim().length<=3&&u.seq1Range.length+u.seq2Range.length>100}const T=e.extendToFullLines(u.seq1Range),_=e.getText(new n.$Tt(T.start,u.seq1Range.start));f(_)&&(o=o.deltaStart(-_.length));const M=e.getText(new n.$Tt(u.seq1Range.endExclusive,T.endExclusive));f(M)&&(o=o.deltaEnd(M.length));const j=p.$w4.fromOffsetPairs(h?h.getEndExclusives():p.$x4.zero,r?r.getStarts():p.$x4.max),F=o.intersect(j);v.length>0&&F.getStarts().equals(v[v.length-1].getEndExclusives())?v[v.length-1]=v[v.length-1].join(F):v.push(F)}),v}}),ne(ie[53],re([0,1,3]),function(x,i,t){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.$H4=void 0;class n{constructor(E,d){this.a=E,this.b=d}getElement(E){return this.a[E]}get length(){return this.a.length}getBoundaryScore(E){const d=E===0?0:p(this.b[E-1]),a=E===this.b.length?0:p(this.b[E]);return 1e3-(d+a)}getText(E){return this.b.slice(E.start,E.endExclusive).join(`
`)}isStronglyEqual(E,d){return this.b[E]===this.b[d]}}i.$H4=n;function p(g){let E=0;for(;E<g.length&&(g.charCodeAt(E)===t.CharCode.Space||g.charCodeAt(E)===t.CharCode.Tab);)E++;return E}}),ne(ie[18],re([0,1,3]),function(x,i,t){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.$C4=i.$A4=void 0,i.$B4=p;class n{constructor(d,a){this.width=d,this.height=a,this.a=[],this.a=new Array(d*a)}get(d,a){return this.a[d+a*this.width]}set(d,a,l){this.a[d+a*this.width]=l}}i.$A4=n;function p(E){return E===t.CharCode.Space||E===t.CharCode.Tab}class g{static{this.a=new Map}static b(d){let a=this.a.get(d);return a===void 0&&(a=this.a.size,this.a.set(d,a)),a}constructor(d,a,l){this.range=d,this.lines=a,this.source=l,this.d=[];let c=0;for(let $=d.startLineNumber-1;$<d.endLineNumberExclusive-1;$++){const m=a[$];for(let e=0;e<m.length;e++){c++;const b=m[e],N=g.b(b);this.d[N]=(this.d[N]||0)+1}c++;const L=g.b(`
`);this.d[L]=(this.d[L]||0)+1}this.c=c}computeSimilarity(d){let a=0;const l=Math.max(this.d.length,d.d.length);for(let c=0;c<l;c++)a+=Math.abs((this.d[c]??0)-(d.d[c]??0));return 1-a/(this.c+d.c)}}i.$C4=g}),ne(ie[54],re([0,1,6,10,18]),function(x,i,t,n,p){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.$D4=void 0;class g{compute(d,a,l=n.$y4.instance,c){if(d.length===0||a.length===0)return n.$v4.trivial(d,a);const $=new p.$A4(d.length,a.length),m=new p.$A4(d.length,a.length),L=new p.$A4(d.length,a.length);for(let v=0;v<d.length;v++)for(let h=0;h<a.length;h++){if(!l.isValid())return n.$v4.trivialTimedOut(d,a);const u=v===0?0:$.get(v-1,h),r=h===0?0:$.get(v,h-1);let o;d.getElement(v)===a.getElement(h)?(v===0||h===0?o=0:o=$.get(v-1,h-1),v>0&&h>0&&m.get(v-1,h-1)===3&&(o+=L.get(v-1,h-1)),o+=c?c(v,h):1):o=-1;const f=Math.max(u,r,o);if(f===o){const T=v>0&&h>0?L.get(v-1,h-1):0;L.set(v,h,T+1),m.set(v,h,3)}else f===u?(L.set(v,h,0),m.set(v,h,1)):f===r&&(L.set(v,h,0),m.set(v,h,2));$.set(v,h,f)}const e=[];let b=d.length,N=a.length;function R(v,h){(v+1!==b||h+1!==N)&&e.push(new n.$w4(new t.$Tt(v+1,b),new t.$Tt(h+1,N))),b=v,N=h}let A=d.length-1,w=a.length-1;for(;A>=0&&w>=0;)m.get(A,w)===3?(R(A,w),A--,w--):m.get(A,w)===1?A--:w--;return R(-1,-1),e.reverse(),new n.$v4(e,!1)}}i.$D4=g}),ne(ie[34],re([0,1,9,3,6,5,2,18]),function(x,i,t,n,p,g,E,d){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.$F4=void 0;class a{constructor(b,N,R){this.lines=b,this.considerWhitespaceChanges=R,this.b=[],this.c=[],this.d=[];let A=!1;N.start>0&&N.endExclusive>=b.length&&(N=new p.$Tt(N.start-1,N.endExclusive),A=!0),this.lineRange=N,this.c[0]=0;for(let w=this.lineRange.start;w<this.lineRange.endExclusive;w++){let v=b[w],h=0;if(A)h=v.length,v="",A=!1;else if(!R){const u=v.trimStart();h=v.length-u.length,v=u.trimEnd()}this.d.push(h);for(let u=0;u<v.length;u++)this.b.push(v.charCodeAt(u));w<b.length-1&&(this.b.push(10),this.c[w-this.lineRange.start+1]=this.b.length)}this.d.push(0)}toString(){return`Slice: "${this.text}"`}get text(){return this.getText(new p.$Tt(0,this.length))}getText(b){return this.b.slice(b.start,b.endExclusive).map(N=>String.fromCharCode(N)).join("")}getElement(b){return this.b[b]}get length(){return this.b.length}getBoundaryScore(b){const N=L(b>0?this.b[b-1]:-1),R=L(b<this.b.length?this.b[b]:-1);if(N===c.LineBreakCR&&R===c.LineBreakLF)return 0;if(N===c.LineBreakLF)return 150;let A=0;return N!==R&&(A+=10,N===c.WordLower&&R===c.WordUpper&&(A+=1)),A+=m(N),A+=m(R),A}translateOffset(b){if(this.lineRange.isEmpty)return new g.$Lt(this.lineRange.start+1,1);const N=(0,t.$lb)(this.c,R=>R<=b);return new g.$Lt(this.lineRange.start+N+1,b-this.c[N]+this.d[N]+1)}translateRange(b){return E.$Mt.fromPositions(this.translateOffset(b.start),this.translateOffset(b.endExclusive))}findWordContaining(b){if(b<0||b>=this.b.length||!l(this.b[b]))return;let N=b;for(;N>0&&l(this.b[N-1]);)N--;let R=b;for(;R<this.b.length&&l(this.b[R]);)R++;return new p.$Tt(N,R)}countLinesIn(b){return this.translateOffset(b.endExclusive).lineNumber-this.translateOffset(b.start).lineNumber}isStronglyEqual(b,N){return this.b[b]===this.b[N]}extendToFullLines(b){const N=(0,t.$kb)(this.c,A=>A<=b.start)??0,R=(0,t.$mb)(this.c,A=>b.endExclusive<=A)??this.b.length;return new p.$Tt(N,R)}}i.$F4=a;function l(e){return e>=n.CharCode.a&&e<=n.CharCode.z||e>=n.CharCode.A&&e<=n.CharCode.Z||e>=n.CharCode.Digit0&&e<=n.CharCode.Digit9}var c;(function(e){e[e.WordLower=0]="WordLower",e[e.WordUpper=1]="WordUpper",e[e.WordNumber=2]="WordNumber",e[e.End=3]="End",e[e.Other=4]="Other",e[e.Separator=5]="Separator",e[e.Space=6]="Space",e[e.LineBreakCR=7]="LineBreakCR",e[e.LineBreakLF=8]="LineBreakLF"})(c||(c={}));const $={[c.WordLower]:0,[c.WordUpper]:0,[c.WordNumber]:0,[c.End]:10,[c.Other]:2,[c.Separator]:30,[c.Space]:3,[c.LineBreakCR]:10,[c.LineBreakLF]:10};function m(e){return $[e]}function L(e){return e===n.CharCode.LineFeed?c.LineBreakLF:e===n.CharCode.CarriageReturn?c.LineBreakCR:(0,d.$B4)(e)?c.Space:e>=n.CharCode.a&&e<=n.CharCode.z?c.WordLower:e>=n.CharCode.A&&e<=n.CharCode.Z?c.WordUpper:e>=n.CharCode.Digit0&&e<=n.CharCode.Digit9?c.WordNumber:e===-1?c.End:e===n.CharCode.Comma||e===n.CharCode.Semicolon?c.Separator:c.Other}}),ne(ie[35],re([0,1]),function(x,i){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.$9t=i.$8t=void 0;class t{constructor(g,E,d){this.changes=g,this.moves=E,this.hitTimeout=d}}i.$8t=t;class n{constructor(g,E){this.lineRangeMapping=g,this.changes=E}flip(){return new n(this.lineRangeMapping.flip(),this.changes.map(g=>g.flip()))}}i.$9t=n}),ne(ie[19],re([0,1,4,15,2,50]),function(x,i,t,n,p,g){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.$7t=i.$6t=i.$5t=void 0;class E{static inverse(c,$,m){const L=[];let e=1,b=1;for(const R of c){const A=new E(new n.$Vt(e,R.original.startLineNumber),new n.$Vt(b,R.modified.startLineNumber));A.modified.isEmpty||L.push(A),e=R.original.endLineNumberExclusive,b=R.modified.endLineNumberExclusive}const N=new E(new n.$Vt(e,$+1),new n.$Vt(b,m+1));return N.modified.isEmpty||L.push(N),L}static clip(c,$,m){const L=[];for(const e of c){const b=e.original.intersect($),N=e.modified.intersect(m);b&&!b.isEmpty&&N&&!N.isEmpty&&L.push(new E(b,N))}return L}constructor(c,$){this.original=c,this.modified=$}toString(){return`{${this.original.toString()}->${this.modified.toString()}}`}flip(){return new E(this.modified,this.original)}join(c){return new E(this.original.join(c.original),this.modified.join(c.modified))}get changedLineCount(){return Math.max(this.original.length,this.modified.length)}toRangeMapping(){const c=this.original.toInclusiveRange(),$=this.modified.toInclusiveRange();if(c&&$)return new a(c,$);if(this.original.startLineNumber===1||this.modified.startLineNumber===1){if(!(this.modified.startLineNumber===1&&this.original.startLineNumber===1))throw new t.$fb("not a valid diff");return new a(new p.$Mt(this.original.startLineNumber,1,this.original.endLineNumberExclusive,1),new p.$Mt(this.modified.startLineNumber,1,this.modified.endLineNumberExclusive,1))}else return new a(new p.$Mt(this.original.startLineNumber-1,Number.MAX_SAFE_INTEGER,this.original.endLineNumberExclusive-1,Number.MAX_SAFE_INTEGER),new p.$Mt(this.modified.startLineNumber-1,Number.MAX_SAFE_INTEGER,this.modified.endLineNumberExclusive-1,Number.MAX_SAFE_INTEGER))}}i.$5t=E;class d extends E{static fromRangeMappings(c){const $=n.$Vt.join(c.map(L=>n.$Vt.fromRangeInclusive(L.originalRange))),m=n.$Vt.join(c.map(L=>n.$Vt.fromRangeInclusive(L.modifiedRange)));return new d($,m,c)}constructor(c,$,m){super(c,$),this.innerChanges=m}flip(){return new d(this.modified,this.original,this.innerChanges?.map(c=>c.flip()))}withInnerChangesFromLineRanges(){return new d(this.original,this.modified,[this.toRangeMapping()])}}i.$6t=d;class a{constructor(c,$){this.originalRange=c,this.modifiedRange=$}toString(){return`{${this.originalRange.toString()}->${this.modifiedRange.toString()}}`}flip(){return new a(this.modifiedRange,this.originalRange)}toTextEdit(c){const $=c.getValueOfRange(this.modifiedRange);return new g.$1t(this.originalRange,$)}}i.$7t=a}),ne(ie[55],re([0,1,10,19,7,9,16,15,6,34,18,33]),function(x,i,t,n,p,g,E,d,a,l,c,$){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.$G4=m;function m(w,v,h,u,r,o){let{moves:f,excludedChanges:T}=e(w,v,h,o);if(!o.isValid())return[];const _=w.filter(j=>!T.has(j)),M=b(_,u,r,v,h,o);return(0,p.$3b)(f,M),f=R(f),f=f.filter(j=>{const F=j.original.toOffsetRange().slice(v).map(S=>S.trim());return F.join(`
`).length>=15&&L(F,S=>S.length>=2)>=2}),f=A(w,f),f}function L(w,v){let h=0;for(const u of w)v(u)&&h++;return h}function e(w,v,h,u){const r=[],o=w.filter(_=>_.modified.isEmpty&&_.original.length>=3).map(_=>new c.$C4(_.original,v,_)),f=new Set(w.filter(_=>_.original.isEmpty&&_.modified.length>=3).map(_=>new c.$C4(_.modified,h,_))),T=new Set;for(const _ of o){let M=-1,j;for(const F of f){const I=_.computeSimilarity(F);I>M&&(M=I,j=F)}if(M>.9&&j&&(f.delete(j),r.push(new n.$5t(_.range,j.range)),T.add(_.source),T.add(j.source)),!u.isValid())return{moves:r,excludedChanges:T}}return{moves:r,excludedChanges:T}}function b(w,v,h,u,r,o){const f=[],T=new E.$Kc;for(const I of w)for(let S=I.original.startLineNumber;S<I.original.endLineNumberExclusive-2;S++){const D=`${v[S-1]}:${v[S+1-1]}:${v[S+2-1]}`;T.add(D,{range:new d.$Vt(S,S+3)})}const _=[];w.sort((0,p.$9b)(I=>I.modified.startLineNumber,p.$$b));for(const I of w){let S=[];for(let D=I.modified.startLineNumber;D<I.modified.endLineNumberExclusive-2;D++){const q=`${h[D-1]}:${h[D+1-1]}:${h[D+2-1]}`,X=new d.$Vt(D,D+3),B=[];T.forEach(q,({range:y})=>{for(const Z of S)if(Z.originalLineRange.endLineNumberExclusive+1===y.endLineNumberExclusive&&Z.modifiedLineRange.endLineNumberExclusive+1===X.endLineNumberExclusive){Z.originalLineRange=new d.$Vt(Z.originalLineRange.startLineNumber,y.endLineNumberExclusive),Z.modifiedLineRange=new d.$Vt(Z.modifiedLineRange.startLineNumber,X.endLineNumberExclusive),B.push(Z);return}const Y={modifiedLineRange:X,originalLineRange:y};_.push(Y),B.push(Y)}),S=B}if(!o.isValid())return[]}_.sort((0,p.$ac)((0,p.$9b)(I=>I.modifiedLineRange.length,p.$$b)));const M=new d.$Wt,j=new d.$Wt;for(const I of _){const S=I.modifiedLineRange.startLineNumber-I.originalLineRange.startLineNumber,D=M.subtractFrom(I.modifiedLineRange),q=j.subtractFrom(I.originalLineRange).getWithDelta(S),X=D.getIntersection(q);for(const B of X.ranges){if(B.length<3)continue;const y=B,Y=B.delta(-S);f.push(new n.$5t(Y,y)),M.addRange(y),j.addRange(Y)}}f.sort((0,p.$9b)(I=>I.original.startLineNumber,p.$$b));const F=new g.$pb(w);for(let I=0;I<f.length;I++){const S=f[I],D=F.findLastMonotonous(Q=>Q.original.startLineNumber<=S.original.startLineNumber),q=(0,g.$kb)(w,Q=>Q.modified.startLineNumber<=S.modified.startLineNumber),X=Math.max(S.original.startLineNumber-D.original.startLineNumber,S.modified.startLineNumber-q.modified.startLineNumber),B=F.findLastMonotonous(Q=>Q.original.startLineNumber<S.original.endLineNumberExclusive),y=(0,g.$kb)(w,Q=>Q.modified.startLineNumber<S.modified.endLineNumberExclusive),Y=Math.max(B.original.endLineNumberExclusive-S.original.endLineNumberExclusive,y.modified.endLineNumberExclusive-S.modified.endLineNumberExclusive);let Z;for(Z=0;Z<X;Z++){const Q=S.original.startLineNumber-Z-1,C=S.modified.startLineNumber-Z-1;if(Q>u.length||C>r.length||M.contains(C)||j.contains(Q)||!N(u[Q-1],r[C-1],o))break}Z>0&&(j.addRange(new d.$Vt(S.original.startLineNumber-Z,S.original.startLineNumber)),M.addRange(new d.$Vt(S.modified.startLineNumber-Z,S.modified.startLineNumber)));let H;for(H=0;H<Y;H++){const Q=S.original.endLineNumberExclusive+H,C=S.modified.endLineNumberExclusive+H;if(Q>u.length||C>r.length||M.contains(C)||j.contains(Q)||!N(u[Q-1],r[C-1],o))break}H>0&&(j.addRange(new d.$Vt(S.original.endLineNumberExclusive,S.original.endLineNumberExclusive+H)),M.addRange(new d.$Vt(S.modified.endLineNumberExclusive,S.modified.endLineNumberExclusive+H))),(Z>0||H>0)&&(f[I]=new n.$5t(new d.$Vt(S.original.startLineNumber-Z,S.original.endLineNumberExclusive+H),new d.$Vt(S.modified.startLineNumber-Z,S.modified.endLineNumberExclusive+H)))}return f}function N(w,v,h){if(w.trim()===v.trim())return!0;if(w.length>300&&v.length>300)return!1;const r=new $.$E4().compute(new l.$F4([w],new a.$Tt(0,1),!1),new l.$F4([v],new a.$Tt(0,1),!1),h);let o=0;const f=t.$w4.invert(r.diffs,w.length);for(const j of f)j.seq1Range.forEach(F=>{(0,c.$B4)(w.charCodeAt(F))||o++});function T(j){let F=0;for(let I=0;I<w.length;I++)(0,c.$B4)(j.charCodeAt(I))||F++;return F}const _=T(w.length>v.length?w:v);return o/_>.6&&_>10}function R(w){if(w.length===0)return w;w.sort((0,p.$9b)(h=>h.original.startLineNumber,p.$$b));const v=[w[0]];for(let h=1;h<w.length;h++){const u=v[v.length-1],r=w[h],o=r.original.startLineNumber-u.original.endLineNumberExclusive,f=r.modified.startLineNumber-u.modified.endLineNumberExclusive;if(o>=0&&f>=0&&o+f<=2){v[v.length-1]=u.join(r);continue}v.push(r)}return v}function A(w,v){const h=new g.$pb(w);return v=v.filter(u=>{const r=h.findLastMonotonous(T=>T.original.startLineNumber<u.original.endLineNumberExclusive)||new n.$5t(new d.$Vt(1,1),new d.$Vt(1,1)),o=(0,g.$kb)(w,T=>T.modified.startLineNumber<u.modified.endLineNumberExclusive);return r!==o}),v}}),ne(ie[56],re([0,1,7,11,15,6,2,10,54,33,55,52,53,34,35,19]),function(x,i,t,n,p,g,E,d,a,l,c,$,m,L,e,b){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.$N4=void 0,i.$O4=R,i.$P4=A;class N{constructor(){this.e=new a.$D4,this.f=new l.$E4}computeDiff(v,h,u){if(v.length<=1&&(0,t.$xb)(v,h,(H,Q)=>H===Q))return new e.$8t([],[],!1);if(v.length===1&&v[0].length===0||h.length===1&&h[0].length===0)return new e.$8t([new b.$6t(new p.$Vt(1,v.length+1),new p.$Vt(1,h.length+1),[new b.$7t(new E.$Mt(1,1,v.length,v[v.length-1].length+1),new E.$Mt(1,1,h.length,h[h.length-1].length+1))])],[],!1);const r=u.maxComputationTimeMs===0?d.$y4.instance:new d.$z4(u.maxComputationTimeMs),o=!u.ignoreTrimWhitespace,f=new Map;function T(H){let Q=f.get(H);return Q===void 0&&(Q=f.size,f.set(H,Q)),Q}const _=v.map(H=>T(H.trim())),M=h.map(H=>T(H.trim())),j=new m.$H4(_,v),F=new m.$H4(M,h),I=j.length+F.length<1700?this.e.compute(j,F,r,(H,Q)=>v[H]===h[Q]?h[Q].length===0?.1:1+Math.log(1+h[Q].length):.99):this.f.compute(j,F,r);let S=I.diffs,D=I.hitTimeout;S=(0,$.$I4)(j,F,S),S=(0,$.$L4)(j,F,S);const q=[],X=H=>{if(o)for(let Q=0;Q<H;Q++){const C=B+Q,k=y+Q;if(v[C]!==h[k]){const z=this.j(v,h,new d.$w4(new g.$Tt(C,C+1),new g.$Tt(k,k+1)),r,o);for(const fe of z.mappings)q.push(fe);z.hitTimeout&&(D=!0)}}};let B=0,y=0;for(const H of S){(0,n.$kd)(()=>H.seq1Range.start-B===H.seq2Range.start-y);const Q=H.seq1Range.start-B;X(Q),B=H.seq1Range.endExclusive,y=H.seq2Range.endExclusive;const C=this.j(v,h,H,r,o);C.hitTimeout&&(D=!0);for(const k of C.mappings)q.push(k)}X(v.length-B);const Y=R(q,v,h);let Z=[];return u.computeMoves&&(Z=this.h(Y,v,h,_,M,r,o)),(0,n.$kd)(()=>{function H(C,k){if(C.lineNumber<1||C.lineNumber>k.length)return!1;const z=k[C.lineNumber-1];return!(C.column<1||C.column>z.length+1)}function Q(C,k){return!(C.startLineNumber<1||C.startLineNumber>k.length+1||C.endLineNumberExclusive<1||C.endLineNumberExclusive>k.length+1)}for(const C of Y){if(!C.innerChanges)return!1;for(const k of C.innerChanges)if(!(H(k.modifiedRange.getStartPosition(),h)&&H(k.modifiedRange.getEndPosition(),h)&&H(k.originalRange.getStartPosition(),v)&&H(k.originalRange.getEndPosition(),v)))return!1;if(!Q(C.modified,h)||!Q(C.original,v))return!1}return!0}),new e.$8t(Y,Z,D)}h(v,h,u,r,o,f,T){return(0,c.$G4)(v,h,u,r,o,f).map(j=>{const F=this.j(h,u,new d.$w4(j.original.toOffsetRange(),j.modified.toOffsetRange()),f,T),I=R(F.mappings,h,u,!0);return new e.$9t(j,I)})}j(v,h,u,r,o){const f=new L.$F4(v,u.seq1Range,o),T=new L.$F4(h,u.seq2Range,o),_=f.length+T.length<500?this.e.compute(f,T,r):this.f.compute(f,T,r);let M=_.diffs;return M=(0,$.$I4)(f,T,M),M=(0,$.$K4)(f,T,M),M=(0,$.$J4)(f,T,M),M=(0,$.$M4)(f,T,M),{mappings:M.map(F=>new b.$7t(f.translateRange(F.seq1Range),T.translateRange(F.seq2Range))),hitTimeout:_.hitTimeout}}}i.$N4=N;function R(w,v,h,u=!1){const r=[];for(const o of(0,t.$Db)(w.map(f=>A(f,v,h)),(f,T)=>f.original.overlapOrTouch(T.original)||f.modified.overlapOrTouch(T.modified))){const f=o[0],T=o[o.length-1];r.push(new b.$6t(f.original.join(T.original),f.modified.join(T.modified),o.map(_=>_.innerChanges[0])))}return(0,n.$kd)(()=>!u&&r.length>0&&(r[0].modified.startLineNumber!==r[0].original.startLineNumber||h.length-r[r.length-1].modified.endLineNumberExclusive!==v.length-r[r.length-1].original.endLineNumberExclusive)?!1:(0,n.$ld)(r,(o,f)=>f.original.startLineNumber-o.original.endLineNumberExclusive===f.modified.startLineNumber-o.modified.endLineNumberExclusive&&o.original.endLineNumberExclusive<f.original.startLineNumber&&o.modified.endLineNumberExclusive<f.modified.startLineNumber)),r}function A(w,v,h){let u=0,r=0;w.modifiedRange.endColumn===1&&w.originalRange.endColumn===1&&w.originalRange.startLineNumber+u<=w.originalRange.endLineNumber&&w.modifiedRange.startLineNumber+u<=w.modifiedRange.endLineNumber&&(r=-1),w.modifiedRange.startColumn-1>=h[w.modifiedRange.startLineNumber-1].length&&w.originalRange.startColumn-1>=v[w.originalRange.startLineNumber-1].length&&w.originalRange.startLineNumber<=w.originalRange.endLineNumber+r&&w.modifiedRange.startLineNumber<=w.modifiedRange.endLineNumber+r&&(u=1);const o=new p.$Vt(w.originalRange.startLineNumber+u,w.originalRange.endLineNumber+1+r),f=new p.$Vt(w.modifiedRange.startLineNumber+u,w.modifiedRange.endLineNumber+1+r);return new b.$6t(o,f,[w])}}),ne(ie[36],re([0,1,3,29,35,19,8,2,11,15]),function(x,i,t,n,p,g,E,d,a,l){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.$$t=i.$0t=void 0,E=Ie(E);const c=3;class ${computeDiff(r,o,f){const _=new A(r,o,{maxComputationTime:f.maxComputationTimeMs,shouldIgnoreTrimWhitespace:f.ignoreTrimWhitespace,shouldComputeCharChanges:!0,shouldMakePrettyDiff:!0,shouldPostProcessCharChanges:!0}).computeDiff(),M=[];let j=null;for(const F of _.changes){let I;F.originalEndLineNumber===0?I=new l.$Vt(F.originalStartLineNumber+1,F.originalStartLineNumber+1):I=new l.$Vt(F.originalStartLineNumber,F.originalEndLineNumber+1);let S;F.modifiedEndLineNumber===0?S=new l.$Vt(F.modifiedStartLineNumber+1,F.modifiedStartLineNumber+1):S=new l.$Vt(F.modifiedStartLineNumber,F.modifiedEndLineNumber+1);let D=new g.$6t(I,S,F.charChanges?.map(q=>new g.$7t(new d.$Mt(q.originalStartLineNumber,q.originalStartColumn,q.originalEndLineNumber,q.originalEndColumn),new d.$Mt(q.modifiedStartLineNumber,q.modifiedStartColumn,q.modifiedEndLineNumber,q.modifiedEndColumn))));j&&(j.modified.endLineNumberExclusive===D.modified.startLineNumber||j.original.endLineNumberExclusive===D.original.startLineNumber)&&(D=new g.$6t(j.original.join(D.original),j.modified.join(D.modified),j.innerChanges&&D.innerChanges?j.innerChanges.concat(D.innerChanges):void 0),M.pop()),M.push(D),j=D}return(0,a.$kd)(()=>(0,a.$ld)(M,(F,I)=>I.original.startLineNumber-F.original.endLineNumberExclusive===I.modified.startLineNumber-F.modified.endLineNumberExclusive&&F.original.endLineNumberExclusive<I.original.startLineNumber&&F.modified.endLineNumberExclusive<I.modified.startLineNumber)),new p.$8t(M,[],_.quitEarly)}}i.$0t=$;function m(u,r,o,f){return new n.$St(u,r,o).ComputeDiff(f)}class L{constructor(r){const o=[],f=[];for(let T=0,_=r.length;T<_;T++)o[T]=w(r[T],1),f[T]=v(r[T],1);this.lines=r,this.a=o,this.b=f}getElements(){const r=[];for(let o=0,f=this.lines.length;o<f;o++)r[o]=this.lines[o].substring(this.a[o]-1,this.b[o]-1);return r}getStrictElement(r){return this.lines[r]}getStartLineNumber(r){return r+1}getEndLineNumber(r){return r+1}createCharSequence(r,o,f){const T=[],_=[],M=[];let j=0;for(let F=o;F<=f;F++){const I=this.lines[F],S=r?this.a[F]:1,D=r?this.b[F]:I.length+1;for(let q=S;q<D;q++)T[j]=I.charCodeAt(q-1),_[j]=F+1,M[j]=q,j++;!r&&F<f&&(T[j]=t.CharCode.LineFeed,_[j]=F+1,M[j]=I.length+1,j++)}return new e(T,_,M)}}class e{constructor(r,o,f){this.a=r,this.b=o,this.d=f}toString(){return"["+this.a.map((r,o)=>(r===t.CharCode.LineFeed?"\\n":String.fromCharCode(r))+`-(${this.b[o]},${this.d[o]})`).join(", ")+"]"}e(r,o){if(r<0||r>=o.length)throw new Error("Illegal index")}getElements(){return this.a}getStartLineNumber(r){return r>0&&r===this.b.length?this.getEndLineNumber(r-1):(this.e(r,this.b),this.b[r])}getEndLineNumber(r){return r===-1?this.getStartLineNumber(r+1):(this.e(r,this.b),this.a[r]===t.CharCode.LineFeed?this.b[r]+1:this.b[r])}getStartColumn(r){return r>0&&r===this.d.length?this.getEndColumn(r-1):(this.e(r,this.d),this.d[r])}getEndColumn(r){return r===-1?this.getStartColumn(r+1):(this.e(r,this.d),this.a[r]===t.CharCode.LineFeed?1:this.d[r]+1)}}class b{constructor(r,o,f,T,_,M,j,F){this.originalStartLineNumber=r,this.originalStartColumn=o,this.originalEndLineNumber=f,this.originalEndColumn=T,this.modifiedStartLineNumber=_,this.modifiedStartColumn=M,this.modifiedEndLineNumber=j,this.modifiedEndColumn=F}static createFromDiffChange(r,o,f){const T=o.getStartLineNumber(r.originalStart),_=o.getStartColumn(r.originalStart),M=o.getEndLineNumber(r.originalStart+r.originalLength-1),j=o.getEndColumn(r.originalStart+r.originalLength-1),F=f.getStartLineNumber(r.modifiedStart),I=f.getStartColumn(r.modifiedStart),S=f.getEndLineNumber(r.modifiedStart+r.modifiedLength-1),D=f.getEndColumn(r.modifiedStart+r.modifiedLength-1);return new b(T,_,M,j,F,I,S,D)}}function N(u){if(u.length<=1)return u;const r=[u[0]];let o=r[0];for(let f=1,T=u.length;f<T;f++){const _=u[f],M=_.originalStart-(o.originalStart+o.originalLength),j=_.modifiedStart-(o.modifiedStart+o.modifiedLength);Math.min(M,j)<c?(o.originalLength=_.originalStart+_.originalLength-o.originalStart,o.modifiedLength=_.modifiedStart+_.modifiedLength-o.modifiedStart):(r.push(_),o=_)}return r}class R{constructor(r,o,f,T,_){this.originalStartLineNumber=r,this.originalEndLineNumber=o,this.modifiedStartLineNumber=f,this.modifiedEndLineNumber=T,this.charChanges=_}static createFromDiffResult(r,o,f,T,_,M,j){let F,I,S,D,q;if(o.originalLength===0?(F=f.getStartLineNumber(o.originalStart)-1,I=0):(F=f.getStartLineNumber(o.originalStart),I=f.getEndLineNumber(o.originalStart+o.originalLength-1)),o.modifiedLength===0?(S=T.getStartLineNumber(o.modifiedStart)-1,D=0):(S=T.getStartLineNumber(o.modifiedStart),D=T.getEndLineNumber(o.modifiedStart+o.modifiedLength-1)),M&&o.originalLength>0&&o.originalLength<20&&o.modifiedLength>0&&o.modifiedLength<20&&_()){const X=f.createCharSequence(r,o.originalStart,o.originalStart+o.originalLength-1),B=T.createCharSequence(r,o.modifiedStart,o.modifiedStart+o.modifiedLength-1);if(X.getElements().length>0&&B.getElements().length>0){let y=m(X,B,_,!0).changes;j&&(y=N(y)),q=[];for(let Y=0,Z=y.length;Y<Z;Y++)q.push(b.createFromDiffChange(y[Y],X,B))}}return new R(F,I,S,D,q)}}class A{constructor(r,o,f){this.a=f.shouldComputeCharChanges,this.b=f.shouldPostProcessCharChanges,this.d=f.shouldIgnoreTrimWhitespace,this.e=f.shouldMakePrettyDiff,this.f=r,this.g=o,this.h=new L(r),this.j=new L(o),this.k=h(f.maxComputationTime),this.l=h(f.maxComputationTime===0?0:Math.min(f.maxComputationTime,5e3))}computeDiff(){if(this.h.lines.length===1&&this.h.lines[0].length===0)return this.j.lines.length===1&&this.j.lines[0].length===0?{quitEarly:!1,changes:[]}:{quitEarly:!1,changes:[{originalStartLineNumber:1,originalEndLineNumber:1,modifiedStartLineNumber:1,modifiedEndLineNumber:this.j.lines.length,charChanges:void 0}]};if(this.j.lines.length===1&&this.j.lines[0].length===0)return{quitEarly:!1,changes:[{originalStartLineNumber:1,originalEndLineNumber:this.h.lines.length,modifiedStartLineNumber:1,modifiedEndLineNumber:1,charChanges:void 0}]};const r=m(this.h,this.j,this.k,this.e),o=r.changes,f=r.quitEarly;if(this.d){const j=[];for(let F=0,I=o.length;F<I;F++)j.push(R.createFromDiffResult(this.d,o[F],this.h,this.j,this.l,this.a,this.b));return{quitEarly:f,changes:j}}const T=[];let _=0,M=0;for(let j=-1,F=o.length;j<F;j++){const I=j+1<F?o[j+1]:null,S=I?I.originalStart:this.f.length,D=I?I.modifiedStart:this.g.length;for(;_<S&&M<D;){const q=this.f[_],X=this.g[M];if(q!==X){{let B=w(q,1),y=w(X,1);for(;B>1&&y>1;){const Y=q.charCodeAt(B-2),Z=X.charCodeAt(y-2);if(Y!==Z)break;B--,y--}(B>1||y>1)&&this.m(T,_+1,1,B,M+1,1,y)}{let B=v(q,1),y=v(X,1);const Y=q.length+1,Z=X.length+1;for(;B<Y&&y<Z;){const H=q.charCodeAt(B-1),Q=q.charCodeAt(y-1);if(H!==Q)break;B++,y++}(B<Y||y<Z)&&this.m(T,_+1,B,Y,M+1,y,Z)}}_++,M++}I&&(T.push(R.createFromDiffResult(this.d,I,this.h,this.j,this.l,this.a,this.b)),_+=I.originalLength,M+=I.modifiedLength)}return{quitEarly:f,changes:T}}m(r,o,f,T,_,M,j){if(this.n(r,o,f,T,_,M,j))return;let F;this.a&&(F=[new b(o,f,o,T,_,M,_,j)]),r.push(new R(o,o,_,_,F))}n(r,o,f,T,_,M,j){const F=r.length;if(F===0)return!1;const I=r[F-1];return I.originalEndLineNumber===0||I.modifiedEndLineNumber===0?!1:I.originalEndLineNumber===o&&I.modifiedEndLineNumber===_?(this.a&&I.charChanges&&I.charChanges.push(new b(o,f,o,T,_,M,_,j)),!0):I.originalEndLineNumber+1===o&&I.modifiedEndLineNumber+1===_?(I.originalEndLineNumber=o,I.modifiedEndLineNumber=_,this.a&&I.charChanges&&I.charChanges.push(new b(o,f,o,T,_,M,_,j)),!0):!1}}i.$$t=A;function w(u,r){const o=E.$wf(u);return o===-1?r:o+1}function v(u,r){const o=E.$yf(u);return o===-1?r:o+2}function h(u){if(u===0)return()=>!0;const r=Date.now();return()=>Date.now()-r<u}}),ne(ie[57],re([0,1,36,56]),function(x,i,t,n){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.$Q4=void 0,i.$Q4={getLegacy:()=>new t.$0t,getDefault:()=>new n.$N4}}),ne(ie[58],re([0,1]),function(x,i){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.$su=i.MetadataConsts=i.StandardTokenType=i.ColorId=i.FontStyle=i.LanguageId=void 0;var t;(function(a){a[a.Null=0]="Null",a[a.PlainText=1]="PlainText"})(t||(i.LanguageId=t={}));var n;(function(a){a[a.NotSet=-1]="NotSet",a[a.None=0]="None",a[a.Italic=1]="Italic",a[a.Bold=2]="Bold",a[a.Underline=4]="Underline",a[a.Strikethrough=8]="Strikethrough"})(n||(i.FontStyle=n={}));var p;(function(a){a[a.None=0]="None",a[a.DefaultForeground=1]="DefaultForeground",a[a.DefaultBackground=2]="DefaultBackground"})(p||(i.ColorId=p={}));var g;(function(a){a[a.Other=0]="Other",a[a.Comment=1]="Comment",a[a.String=2]="String",a[a.RegEx=3]="RegEx"})(g||(i.StandardTokenType=g={}));var E;(function(a){a[a.LANGUAGEID_MASK=255]="LANGUAGEID_MASK",a[a.TOKEN_TYPE_MASK=768]="TOKEN_TYPE_MASK",a[a.BALANCED_BRACKETS_MASK=1024]="BALANCED_BRACKETS_MASK",a[a.FONT_STYLE_MASK=30720]="FONT_STYLE_MASK",a[a.FOREGROUND_MASK=16744448]="FOREGROUND_MASK",a[a.BACKGROUND_MASK=4278190080]="BACKGROUND_MASK",a[a.ITALIC_MASK=2048]="ITALIC_MASK",a[a.BOLD_MASK=4096]="BOLD_MASK",a[a.UNDERLINE_MASK=8192]="UNDERLINE_MASK",a[a.STRIKETHROUGH_MASK=16384]="STRIKETHROUGH_MASK",a[a.SEMANTIC_USE_ITALIC=1]="SEMANTIC_USE_ITALIC",a[a.SEMANTIC_USE_BOLD=2]="SEMANTIC_USE_BOLD",a[a.SEMANTIC_USE_UNDERLINE=4]="SEMANTIC_USE_UNDERLINE",a[a.SEMANTIC_USE_STRIKETHROUGH=8]="SEMANTIC_USE_STRIKETHROUGH",a[a.SEMANTIC_USE_FOREGROUND=16]="SEMANTIC_USE_FOREGROUND",a[a.SEMANTIC_USE_BACKGROUND=32]="SEMANTIC_USE_BACKGROUND",a[a.LANGUAGEID_OFFSET=0]="LANGUAGEID_OFFSET",a[a.TOKEN_TYPE_OFFSET=8]="TOKEN_TYPE_OFFSET",a[a.BALANCED_BRACKETS_OFFSET=10]="BALANCED_BRACKETS_OFFSET",a[a.FONT_STYLE_OFFSET=11]="FONT_STYLE_OFFSET",a[a.FOREGROUND_OFFSET=15]="FOREGROUND_OFFSET",a[a.BACKGROUND_OFFSET=24]="BACKGROUND_OFFSET"})(E||(i.MetadataConsts=E={}));class d{static getLanguageId(l){return(l&E.LANGUAGEID_MASK)>>>E.LANGUAGEID_OFFSET}static getTokenType(l){return(l&E.TOKEN_TYPE_MASK)>>>E.TOKEN_TYPE_OFFSET}static containsBalancedBrackets(l){return(l&E.BALANCED_BRACKETS_MASK)!==0}static getFontStyle(l){return(l&E.FONT_STYLE_MASK)>>>E.FONT_STYLE_OFFSET}static getForeground(l){return(l&E.FOREGROUND_MASK)>>>E.FOREGROUND_OFFSET}static getBackground(l){return(l&E.BACKGROUND_MASK)>>>E.BACKGROUND_OFFSET}static getClassNameFromMetadata(l){let $="mtk"+this.getForeground(l);const m=this.getFontStyle(l);return m&n.Italic&&($+=" mtki"),m&n.Bold&&($+=" mtkb"),m&n.Underline&&($+=" mtku"),m&n.Strikethrough&&($+=" mtks"),$}static getInlineStyleFromMetadata(l,c){const $=this.getForeground(l),m=this.getFontStyle(l);let L=`color: ${c[$]};`;m&n.Italic&&(L+="font-style: italic;"),m&n.Bold&&(L+="font-weight: bold;");let e="";return m&n.Underline&&(e+=" underline"),m&n.Strikethrough&&(e+=" line-through"),e&&(L+=`text-decoration:${e};`),L}static getPresentationFromMetadata(l){const c=this.getForeground(l),$=this.getFontStyle(l);return{foreground:c,italic:!!($&n.Italic),bold:!!($&n.Bold),underline:!!($&n.Underline),strikethrough:!!($&n.Strikethrough)}}}i.$su=d}),ne(ie[59],re([0,1,38]),function(x,i,t){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.$R4=$;function n(m){const L=[];for(const e of m){const b=Number(e);(b||b===0&&e.replace(/\s/g,"")!=="")&&L.push(b)}return L}function p(m,L,e,b){return{red:m/255,blue:e/255,green:L/255,alpha:b}}function g(m,L){const e=L.index,b=L[0].length;if(!e)return;const N=m.positionAt(e);return{startLineNumber:N.lineNumber,startColumn:N.column,endLineNumber:N.lineNumber,endColumn:N.column+b}}function E(m,L){if(!m)return;const e=t.$lu.Format.CSS.parseHex(L);if(e)return{range:m,color:p(e.rgba.r,e.rgba.g,e.rgba.b,e.rgba.a)}}function d(m,L,e){if(!m||L.length!==1)return;const N=L[0].values(),R=n(N);return{range:m,color:p(R[0],R[1],R[2],e?R[3]:1)}}function a(m,L,e){if(!m||L.length!==1)return;const N=L[0].values(),R=n(N),A=new t.$lu(new t.$ju(R[0],R[1]/100,R[2]/100,e?R[3]:1));return{range:m,color:p(A.rgba.r,A.rgba.g,A.rgba.b,A.rgba.a)}}function l(m,L){return typeof m=="string"?[...m.matchAll(L)]:m.findMatches(L)}function c(m){const L=[],b=l(m,/\b(rgb|rgba|hsl|hsla)(\([0-9\s,.\%]*\))|(#)([A-Fa-f0-9]{3})\b|(#)([A-Fa-f0-9]{4})\b|(#)([A-Fa-f0-9]{6})\b|(#)([A-Fa-f0-9]{8})\b/gm);if(b.length>0)for(const N of b){const R=N.filter(h=>h!==void 0),A=R[1],w=R[2];if(!w)continue;let v;if(A==="rgb"){const h=/^\(\s*(25[0-5]|2[0-4][0-9]|1[0-9]{2}|[1-9][0-9]|[0-9])\s*,\s*(25[0-5]|2[0-4][0-9]|1[0-9]{2}|[1-9][0-9]|[0-9])\s*,\s*(25[0-5]|2[0-4][0-9]|1[0-9]{2}|[1-9][0-9]|[0-9])\s*\)$/gm;v=d(g(m,N),l(w,h),!1)}else if(A==="rgba"){const h=/^\(\s*(25[0-5]|2[0-4][0-9]|1[0-9]{2}|[1-9][0-9]|[0-9])\s*,\s*(25[0-5]|2[0-4][0-9]|1[0-9]{2}|[1-9][0-9]|[0-9])\s*,\s*(25[0-5]|2[0-4][0-9]|1[0-9]{2}|[1-9][0-9]|[0-9])\s*,\s*(0[.][0-9]+|[.][0-9]+|[01][.]|[01])\s*\)$/gm;v=d(g(m,N),l(w,h),!0)}else if(A==="hsl"){const h=/^\(\s*(36[0]|3[0-5][0-9]|[12][0-9][0-9]|[1-9]?[0-9])\s*,\s*(100|\d{1,2}[.]\d*|\d{1,2})%\s*,\s*(100|\d{1,2}[.]\d*|\d{1,2})%\s*\)$/gm;v=a(g(m,N),l(w,h),!1)}else if(A==="hsla"){const h=/^\(\s*(36[0]|3[0-5][0-9]|[12][0-9][0-9]|[1-9]?[0-9])\s*,\s*(100|\d{1,2}[.]\d*|\d{1,2})%\s*,\s*(100|\d{1,2}[.]\d*|\d{1,2})%\s*,\s*(0[.][0-9]+|[.][0-9]+|[01][.]|[01])\s*\)$/gm;v=a(g(m,N),l(w,h),!0)}else A==="#"&&(v=E(g(m,N),A+w));v&&L.push(v)}return L}function $(m){return!m||typeof m.getValue!="function"||typeof m.positionAt!="function"?[]:c(m)}}),ne(ie[60],re([0,1,3,30]),function(x,i,t,n){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.$q4=i.$p4=i.State=void 0,i.$r4=L;var p;(function(e){e[e.Invalid=0]="Invalid",e[e.Start=1]="Start",e[e.H=2]="H",e[e.HT=3]="HT",e[e.HTT=4]="HTT",e[e.HTTP=5]="HTTP",e[e.F=6]="F",e[e.FI=7]="FI",e[e.FIL=8]="FIL",e[e.BeforeColon=9]="BeforeColon",e[e.AfterColon=10]="AfterColon",e[e.AlmostThere=11]="AlmostThere",e[e.End=12]="End",e[e.Accept=13]="Accept",e[e.LastKnownState=14]="LastKnownState"})(p||(i.State=p={}));class g{constructor(b,N,R){const A=new Uint8Array(b*N);for(let w=0,v=b*N;w<v;w++)A[w]=R;this.a=A,this.rows=b,this.cols=N}get(b,N){return this.a[b*this.cols+N]}set(b,N,R){this.a[b*this.cols+N]=R}}class E{constructor(b){let N=0,R=p.Invalid;for(let w=0,v=b.length;w<v;w++){const[h,u,r]=b[w];u>N&&(N=u),h>R&&(R=h),r>R&&(R=r)}N++,R++;const A=new g(R,N,p.Invalid);for(let w=0,v=b.length;w<v;w++){const[h,u,r]=b[w];A.set(h,u,r)}this.a=A,this.b=N}nextState(b,N){return N<0||N>=this.b?p.Invalid:this.a.get(b,N)}}i.$p4=E;let d=null;function a(){return d===null&&(d=new E([[p.Start,t.CharCode.h,p.H],[p.Start,t.CharCode.H,p.H],[p.Start,t.CharCode.f,p.F],[p.Start,t.CharCode.F,p.F],[p.H,t.CharCode.t,p.HT],[p.H,t.CharCode.T,p.HT],[p.HT,t.CharCode.t,p.HTT],[p.HT,t.CharCode.T,p.HTT],[p.HTT,t.CharCode.p,p.HTTP],[p.HTT,t.CharCode.P,p.HTTP],[p.HTTP,t.CharCode.s,p.BeforeColon],[p.HTTP,t.CharCode.S,p.BeforeColon],[p.HTTP,t.CharCode.Colon,p.AfterColon],[p.F,t.CharCode.i,p.FI],[p.F,t.CharCode.I,p.FI],[p.FI,t.CharCode.l,p.FIL],[p.FI,t.CharCode.L,p.FIL],[p.FIL,t.CharCode.e,p.BeforeColon],[p.FIL,t.CharCode.E,p.BeforeColon],[p.BeforeColon,t.CharCode.Colon,p.AfterColon],[p.AfterColon,t.CharCode.Slash,p.AlmostThere],[p.AlmostThere,t.CharCode.Slash,p.End]])),d}var l;(function(e){e[e.None=0]="None",e[e.ForceTermination=1]="ForceTermination",e[e.CannotEndIn=2]="CannotEndIn"})(l||(l={}));let c=null;function $(){if(c===null){c=new n.$eu(l.None);const e=` 	<>'"\u3001\u3002\uFF61\uFF64\uFF0C\uFF0E\uFF1A\uFF1B\u2018\u3008\u300C\u300E\u3014\uFF08\uFF3B\uFF5B\uFF62\uFF63\uFF5D\uFF3D\uFF09\u3015\u300F\u300D\u3009\u2019\uFF40\uFF5E\u2026`;for(let N=0;N<e.length;N++)c.set(e.charCodeAt(N),l.ForceTermination);const b=".,;:";for(let N=0;N<b.length;N++)c.set(b.charCodeAt(N),l.CannotEndIn)}return c}class m{static a(b,N,R,A,w){let v=w-1;do{const h=N.charCodeAt(v);if(b.get(h)!==l.CannotEndIn)break;v--}while(v>A);if(A>0){const h=N.charCodeAt(A-1),u=N.charCodeAt(v);(h===t.CharCode.OpenParen&&u===t.CharCode.CloseParen||h===t.CharCode.OpenSquareBracket&&u===t.CharCode.CloseSquareBracket||h===t.CharCode.OpenCurlyBrace&&u===t.CharCode.CloseCurlyBrace)&&v--}return{range:{startLineNumber:R,startColumn:A+1,endLineNumber:R,endColumn:v+2},url:N.substring(A,v+1)}}static computeLinks(b,N=a()){const R=$(),A=[];for(let w=1,v=b.getLineCount();w<=v;w++){const h=b.getLineContent(w),u=h.length;let r=0,o=0,f=0,T=p.Start,_=!1,M=!1,j=!1,F=!1;for(;r<u;){let I=!1;const S=h.charCodeAt(r);if(T===p.Accept){let D;switch(S){case t.CharCode.OpenParen:_=!0,D=l.None;break;case t.CharCode.CloseParen:D=_?l.None:l.ForceTermination;break;case t.CharCode.OpenSquareBracket:j=!0,M=!0,D=l.None;break;case t.CharCode.CloseSquareBracket:j=!1,D=M?l.None:l.ForceTermination;break;case t.CharCode.OpenCurlyBrace:F=!0,D=l.None;break;case t.CharCode.CloseCurlyBrace:D=F?l.None:l.ForceTermination;break;case t.CharCode.SingleQuote:case t.CharCode.DoubleQuote:case t.CharCode.BackTick:f===S?D=l.ForceTermination:f===t.CharCode.SingleQuote||f===t.CharCode.DoubleQuote||f===t.CharCode.BackTick?D=l.None:D=l.ForceTermination;break;case t.CharCode.Asterisk:D=f===t.CharCode.Asterisk?l.ForceTermination:l.None;break;case t.CharCode.Pipe:D=f===t.CharCode.Pipe?l.ForceTermination:l.None;break;case t.CharCode.Space:D=j?l.None:l.ForceTermination;break;default:D=R.get(S)}D===l.ForceTermination&&(A.push(m.a(R,h,w,o,r)),I=!0)}else if(T===p.End){let D;S===t.CharCode.OpenSquareBracket?(M=!0,D=l.None):D=R.get(S),D===l.ForceTermination?I=!0:T=p.Accept}else T=N.nextState(T,S),T===p.Invalid&&(I=!0);I&&(T=p.Start,_=!1,M=!1,F=!1,o=r+1,f=S),r++}T===p.Accept&&A.push(m.a(R,h,w,o,u))}return A}}i.$q4=m;function L(e){return!e||typeof e.getLineCount!="function"||typeof e.getLineContent!="function"?[]:m.computeLinks(e)}}),ne(ie[61],re([0,1]),function(x,i){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.$s4=void 0;class t{constructor(){this.c=[["true","false"],["True","False"],["Private","Public","Friend","ReadOnly","Partial","Protected","WriteOnly"],["public","protected","private"]]}static{this.INSTANCE=new t}navigateValueSet(p,g,E,d,a){if(p&&g){const l=this.a(g,a);if(l)return{range:p,value:l}}if(E&&d){const l=this.a(d,a);if(l)return{range:E,value:l}}return null}a(p,g){const E=this.b(p,g);return E!==null?E:this.d(p,g)}b(p,g){const E=Math.pow(10,p.length-(p.lastIndexOf(".")+1));let d=Number(p);const a=parseFloat(p);return!isNaN(d)&&!isNaN(a)&&d===a?d===0&&!g?null:(d=Math.floor(d*E),d+=g?E:-E,String(d/E)):null}d(p,g){return this.e(this.c,p,g)}e(p,g,E){let d=null;for(let a=0,l=p.length;d===null&&a<l;a++)d=this.f(p[a],g,E);return d}f(p,g,E){let d=p.indexOf(g);return d>=0?(d+=E?1:-1,d<0?d=p.length-1:d%=p.length,p[d]):null}}i.$s4=t}),ne(ie[62],re([0,1,17]),function(x,i,t){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.$fw=i.$ew=i.$dw=i.ModelConstants=i.PositionAffinity=i.TrackedRangeStickiness=i.$bw=i.$aw=i.EndOfLineSequence=i.DefaultEndOfLine=i.EndOfLinePreference=i.InjectedTextCursorStops=i.MinimapSectionHeaderStyle=i.MinimapPosition=i.GlyphMarginLane=i.OverviewRulerLane=void 0,i.$cw=e,i.$gw=v;var n;(function(h){h[h.Left=1]="Left",h[h.Center=2]="Center",h[h.Right=4]="Right",h[h.Full=7]="Full"})(n||(i.OverviewRulerLane=n={}));var p;(function(h){h[h.Left=1]="Left",h[h.Center=2]="Center",h[h.Right=3]="Right"})(p||(i.GlyphMarginLane=p={}));var g;(function(h){h[h.Inline=1]="Inline",h[h.Gutter=2]="Gutter"})(g||(i.MinimapPosition=g={}));var E;(function(h){h[h.Normal=1]="Normal",h[h.Underlined=2]="Underlined"})(E||(i.MinimapSectionHeaderStyle=E={}));var d;(function(h){h[h.Both=0]="Both",h[h.Right=1]="Right",h[h.Left=2]="Left",h[h.None=3]="None"})(d||(i.InjectedTextCursorStops=d={}));var a;(function(h){h[h.TextDefined=0]="TextDefined",h[h.LF=1]="LF",h[h.CRLF=2]="CRLF"})(a||(i.EndOfLinePreference=a={}));var l;(function(h){h[h.LF=1]="LF",h[h.CRLF=2]="CRLF"})(l||(i.DefaultEndOfLine=l={}));var c;(function(h){h[h.LF=0]="LF",h[h.CRLF=1]="CRLF"})(c||(i.EndOfLineSequence=c={}));class ${get originalIndentSize(){return this.a?"tabSize":this.indentSize}constructor(u){this._textModelResolvedOptionsBrand=void 0,this.tabSize=Math.max(1,u.tabSize|0),u.indentSize==="tabSize"?(this.indentSize=this.tabSize,this.a=!0):(this.indentSize=Math.max(1,u.indentSize|0),this.a=!1),this.insertSpaces=!!u.insertSpaces,this.defaultEOL=u.defaultEOL|0,this.trimAutoWhitespace=!!u.trimAutoWhitespace,this.bracketPairColorizationOptions=u.bracketPairColorizationOptions}equals(u){return this.tabSize===u.tabSize&&this.a===u.a&&this.indentSize===u.indentSize&&this.insertSpaces===u.insertSpaces&&this.defaultEOL===u.defaultEOL&&this.trimAutoWhitespace===u.trimAutoWhitespace&&(0,t.$io)(this.bracketPairColorizationOptions,u.bracketPairColorizationOptions)}createChangeEvent(u){return{tabSize:this.tabSize!==u.tabSize,indentSize:this.indentSize!==u.indentSize,insertSpaces:this.insertSpaces!==u.insertSpaces,trimAutoWhitespace:this.trimAutoWhitespace!==u.trimAutoWhitespace}}}i.$aw=$;class m{constructor(u,r){this._findMatchBrand=void 0,this.range=u,this.matches=r}}i.$bw=m;var L;(function(h){h[h.AlwaysGrowsWhenTypingAtEdges=0]="AlwaysGrowsWhenTypingAtEdges",h[h.NeverGrowsWhenTypingAtEdges=1]="NeverGrowsWhenTypingAtEdges",h[h.GrowsOnlyWhenTypingBefore=2]="GrowsOnlyWhenTypingBefore",h[h.GrowsOnlyWhenTypingAfter=3]="GrowsOnlyWhenTypingAfter"})(L||(i.TrackedRangeStickiness=L={}));function e(h){return h&&typeof h.read=="function"}var b;(function(h){h[h.Left=0]="Left",h[h.Right=1]="Right",h[h.None=2]="None",h[h.LeftOfInjectedText=3]="LeftOfInjectedText",h[h.RightOfInjectedText=4]="RightOfInjectedText"})(b||(i.PositionAffinity=b={}));var N;(function(h){h[h.FIRST_LINE_DETECTION_LENGTH_LIMIT=1e3]="FIRST_LINE_DETECTION_LENGTH_LIMIT"})(N||(i.ModelConstants=N={}));class R{constructor(u,r,o,f,T,_){this.identifier=u,this.range=r,this.text=o,this.forceMoveMarkers=f,this.isAutoWhitespaceEdit=T,this._isTracked=_}}i.$dw=R;class A{constructor(u,r,o){this.regex=u,this.wordSeparators=r,this.simpleSearch=o}}i.$ew=A;class w{constructor(u,r,o){this.reverseEdits=u,this.changes=r,this.trimAutoWhitespaceLineNumbers=o}}i.$fw=w;function v(h){return!h.isTooLargeForSyncing()&&!h.isForSimpleWidget}}),ne(ie[63],re([0,1,7,14]),function(x,i,t,n){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.$lw=i.$kw=i.$jw=void 0;class p{constructor(a){this.a=a,this.b=new Uint32Array(a.length),this.c=new Int32Array(1),this.c[0]=-1}getCount(){return this.a.length}insertValues(a,l){a=(0,n.$df)(a);const c=this.a,$=this.b,m=l.length;return m===0?!1:(this.a=new Uint32Array(c.length+m),this.a.set(c.subarray(0,a),0),this.a.set(c.subarray(a),a+m),this.a.set(l,a),a-1<this.c[0]&&(this.c[0]=a-1),this.b=new Uint32Array(this.a.length),this.c[0]>=0&&this.b.set($.subarray(0,this.c[0]+1)),!0)}setValue(a,l){return a=(0,n.$df)(a),l=(0,n.$df)(l),this.a[a]===l?!1:(this.a[a]=l,a-1<this.c[0]&&(this.c[0]=a-1),!0)}removeValues(a,l){a=(0,n.$df)(a),l=(0,n.$df)(l);const c=this.a,$=this.b;if(a>=c.length)return!1;const m=c.length-a;return l>=m&&(l=m),l===0?!1:(this.a=new Uint32Array(c.length-l),this.a.set(c.subarray(0,a),0),this.a.set(c.subarray(a+l),a),this.b=new Uint32Array(this.a.length),a-1<this.c[0]&&(this.c[0]=a-1),this.c[0]>=0&&this.b.set($.subarray(0,this.c[0]+1)),!0)}getTotalSum(){return this.a.length===0?0:this.d(this.a.length-1)}getPrefixSum(a){return a<0?0:(a=(0,n.$df)(a),this.d(a))}d(a){if(a<=this.c[0])return this.b[a];let l=this.c[0]+1;l===0&&(this.b[0]=this.a[0],l++),a>=this.a.length&&(a=this.a.length-1);for(let c=l;c<=a;c++)this.b[c]=this.b[c-1]+this.a[c];return this.c[0]=Math.max(this.c[0],a),this.b[a]}getIndexOf(a){a=Math.floor(a),this.getTotalSum();let l=0,c=this.a.length-1,$=0,m=0,L=0;for(;l<=c;)if($=l+(c-l)/2|0,m=this.b[$],L=m-this.a[$],a<L)c=$-1;else if(a>=m)l=$+1;else break;return new E($,a-L)}}i.$jw=p;class g{constructor(a){this.a=a,this.b=!1,this.c=-1,this.d=[],this.e=[]}getTotalSum(){return this.g(),this.e.length}getPrefixSum(a){return this.g(),a===0?0:this.d[a-1]}getIndexOf(a){this.g();const l=this.e[a],c=l>0?this.d[l-1]:0;return new E(l,a-c)}removeValues(a,l){this.a.splice(a,l),this.f(a)}insertValues(a,l){this.a=(0,t.$Yb)(this.a,a,l),this.f(a)}f(a){this.b=!1,this.c=Math.min(this.c,a-1)}g(){if(!this.b){for(let a=this.c+1,l=this.a.length;a<l;a++){const c=this.a[a],$=a>0?this.d[a-1]:0;this.d[a]=$+c;for(let m=0;m<c;m++)this.e[$+m]=a}this.d.length=this.a.length,this.e.length=this.d[this.d.length-1],this.b=!0,this.c=this.a.length-1}}setValue(a,l){this.a[a]!==l&&(this.a[a]=l,this.f(a))}}i.$kw=g;class E{constructor(a,l){this.index=a,this.remainder=l,this._prefixSumIndexOfResultBrand=void 0,this.index=a,this.remainder=l}}i.$lw=E}),ne(ie[64],re([0,1,8,5,63]),function(x,i,t,n,p){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.$mw=void 0;class g{constructor(d,a,l,c){this.d=d,this.f=a,this.g=l,this.h=c,this.j=null,this.k=null}dispose(){this.f.length=0}get version(){return this.h}getText(){return this.k===null&&(this.k=this.f.join(this.g)),this.k}onEvents(d){d.eol&&d.eol!==this.g&&(this.g=d.eol,this.j=null);const a=d.changes;for(const l of a)this.o(l.range),this.p(new n.$Lt(l.range.startLineNumber,l.range.startColumn),l.text);this.h=d.versionId,this.k=null}l(){if(!this.j){const d=this.g.length,a=this.f.length,l=new Uint32Array(a);for(let c=0;c<a;c++)l[c]=this.f[c].length+d;this.j=new p.$jw(l)}}n(d,a){this.f[d]=a,this.j&&this.j.setValue(d,this.f[d].length+this.g.length)}o(d){if(d.startLineNumber===d.endLineNumber){if(d.startColumn===d.endColumn)return;this.n(d.startLineNumber-1,this.f[d.startLineNumber-1].substring(0,d.startColumn-1)+this.f[d.startLineNumber-1].substring(d.endColumn-1));return}this.n(d.startLineNumber-1,this.f[d.startLineNumber-1].substring(0,d.startColumn-1)+this.f[d.endLineNumber-1].substring(d.endColumn-1)),this.f.splice(d.startLineNumber,d.endLineNumber-d.startLineNumber),this.j&&this.j.removeValues(d.startLineNumber,d.endLineNumber-d.startLineNumber)}p(d,a){if(a.length===0)return;const l=(0,t.$uf)(a);if(l.length===1){this.n(d.lineNumber-1,this.f[d.lineNumber-1].substring(0,d.column-1)+l[0]+this.f[d.lineNumber-1].substring(d.column-1));return}l[l.length-1]+=this.f[d.lineNumber-1].substring(d.column-1),this.n(d.lineNumber-1,this.f[d.lineNumber-1].substring(0,d.column-1)+l[0]);const c=new Uint32Array(l.length-1);for(let $=1;$<l.length;$++)this.f.splice(d.lineNumber+$-1,0,l[$]),c[$-1]=l[$].length+this.g.length;this.j&&this.j.insertValues(d.lineNumber,c)}}i.$mw=g}),ne(ie[65],re([0,1,3,8,51,5,2,62]),function(x,i,t,n,p,g,E,d){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.$fD=i.$dD=i.$aD=void 0,i.$bD=c,i.$cD=$,i.$eD=N,n=Ie(n);const a=999;class l{constructor(w,v,h,u){this.searchString=w,this.isRegex=v,this.matchCase=h,this.wordSeparators=u}parseSearchRequest(){if(this.searchString==="")return null;let w;this.isRegex?w=c(this.searchString):w=this.searchString.indexOf(`
`)>=0;let v=null;try{v=n.$sf(this.searchString,this.isRegex,{matchCase:this.matchCase,wholeWord:!1,multiline:w,global:!0,unicode:!0})}catch{return null}if(!v)return null;let h=!this.isRegex&&!w;return h&&this.searchString.toLowerCase()!==this.searchString.toUpperCase()&&(h=this.matchCase),new d.$ew(v,this.wordSeparators?(0,p.$hu)(this.wordSeparators,[]):null,h?this.searchString:null)}}i.$aD=l;function c(A){if(!A||A.length===0)return!1;for(let w=0,v=A.length;w<v;w++){const h=A.charCodeAt(w);if(h===t.CharCode.LineFeed)return!0;if(h===t.CharCode.Backslash){if(w++,w>=v)break;const u=A.charCodeAt(w);if(u===t.CharCode.n||u===t.CharCode.r||u===t.CharCode.W)return!0}}return!1}function $(A,w,v){if(!v)return new d.$bw(A,null);const h=[];for(let u=0,r=w.length;u<r;u++)h[u]=w[u];return new d.$bw(A,h)}class m{constructor(w){const v=[];let h=0;for(let u=0,r=w.length;u<r;u++)w.charCodeAt(u)===t.CharCode.LineFeed&&(v[h++]=u);this.a=v}findLineFeedCountBeforeOffset(w){const v=this.a;let h=0,u=v.length-1;if(u===-1||w<=v[0])return 0;for(;h<u;){const r=h+((u-h)/2>>0);v[r]>=w?u=r-1:v[r+1]>=w?(h=r,u=r):h=r+1}return h+1}}class L{static findMatches(w,v,h,u,r){const o=v.parseSearchRequest();return o?o.regex.multiline?this.b(w,h,new R(o.wordSeparators,o.regex),u,r):this.c(w,h,o,u,r):[]}static a(w,v,h,u,r,o){let f,T=0;u?(T=u.findLineFeedCountBeforeOffset(r),f=v+r+T):f=v+r;let _;if(u){const I=u.findLineFeedCountBeforeOffset(r+o.length)-T;_=f+o.length+I}else _=f+o.length;const M=w.getPositionAt(f),j=w.getPositionAt(_);return new E.$Mt(M.lineNumber,M.column,j.lineNumber,j.column)}static b(w,v,h,u,r){const o=w.getOffsetAt(v.getStartPosition()),f=w.getValueInRange(v,d.EndOfLinePreference.LF),T=w.getEOL()===`\r
`?new m(f):null,_=[];let M=0,j;for(h.reset(0);j=h.next(f);)if(_[M++]=$(this.a(w,o,f,T,j.index,j[0]),j,u),M>=r)return _;return _}static c(w,v,h,u,r){const o=[];let f=0;if(v.startLineNumber===v.endLineNumber){const _=w.getLineContent(v.startLineNumber).substring(v.startColumn-1,v.endColumn-1);return f=this.d(h,_,v.startLineNumber,v.startColumn-1,f,o,u,r),o}const T=w.getLineContent(v.startLineNumber).substring(v.startColumn-1);f=this.d(h,T,v.startLineNumber,v.startColumn-1,f,o,u,r);for(let _=v.startLineNumber+1;_<v.endLineNumber&&f<r;_++)f=this.d(h,w.getLineContent(_),_,0,f,o,u,r);if(f<r){const _=w.getLineContent(v.endLineNumber).substring(0,v.endColumn-1);f=this.d(h,_,v.endLineNumber,0,f,o,u,r)}return o}static d(w,v,h,u,r,o,f,T){const _=w.wordSeparators;if(!f&&w.simpleSearch){const F=w.simpleSearch,I=F.length,S=v.length;let D=-I;for(;(D=v.indexOf(F,D+I))!==-1;)if((!_||N(_,v,S,D,I))&&(o[r++]=new d.$bw(new E.$Mt(h,D+1+u,h,D+1+I+u),null),r>=T))return r;return r}const M=new R(w.wordSeparators,w.regex);let j;M.reset(0);do if(j=M.next(v),j&&(o[r++]=$(new E.$Mt(h,j.index+1+u,h,j.index+1+j[0].length+u),j,f),r>=T))return r;while(j);return r}static findNextMatch(w,v,h,u){const r=v.parseSearchRequest();if(!r)return null;const o=new R(r.wordSeparators,r.regex);return r.regex.multiline?this.e(w,h,o,u):this.f(w,h,o,u)}static e(w,v,h,u){const r=new g.$Lt(v.lineNumber,1),o=w.getOffsetAt(r),f=w.getLineCount(),T=w.getValueInRange(new E.$Mt(r.lineNumber,r.column,f,w.getLineMaxColumn(f)),d.EndOfLinePreference.LF),_=w.getEOL()===`\r
`?new m(T):null;h.reset(v.column-1);const M=h.next(T);return M?$(this.a(w,o,T,_,M.index,M[0]),M,u):v.lineNumber!==1||v.column!==1?this.e(w,new g.$Lt(1,1),h,u):null}static f(w,v,h,u){const r=w.getLineCount(),o=v.lineNumber,f=w.getLineContent(o),T=this.g(h,f,o,v.column,u);if(T)return T;for(let _=1;_<=r;_++){const M=(o+_-1)%r,j=w.getLineContent(M+1),F=this.g(h,j,M+1,1,u);if(F)return F}return null}static g(w,v,h,u,r){w.reset(u-1);const o=w.next(v);return o?$(new E.$Mt(h,o.index+1,h,o.index+1+o[0].length),o,r):null}static findPreviousMatch(w,v,h,u){const r=v.parseSearchRequest();if(!r)return null;const o=new R(r.wordSeparators,r.regex);return r.regex.multiline?this.h(w,h,o,u):this.j(w,h,o,u)}static h(w,v,h,u){const r=this.b(w,new E.$Mt(1,1,v.lineNumber,v.column),h,u,10*a);if(r.length>0)return r[r.length-1];const o=w.getLineCount();return v.lineNumber!==o||v.column!==w.getLineMaxColumn(o)?this.h(w,new g.$Lt(o,w.getLineMaxColumn(o)),h,u):null}static j(w,v,h,u){const r=w.getLineCount(),o=v.lineNumber,f=w.getLineContent(o).substring(0,v.column-1),T=this.k(h,f,o,u);if(T)return T;for(let _=1;_<=r;_++){const M=(r+o-_-1)%r,j=w.getLineContent(M+1),F=this.k(h,j,M+1,u);if(F)return F}return null}static k(w,v,h,u){let r=null,o;for(w.reset(0);o=w.next(v);)r=$(new E.$Mt(h,o.index+1,h,o.index+1+o[0].length),o,u);return r}}i.$dD=L;function e(A,w,v,h,u){if(h===0)return!0;const r=w.charCodeAt(h-1);if(A.get(r)!==p.WordCharacterClass.Regular||r===t.CharCode.CarriageReturn||r===t.CharCode.LineFeed)return!0;if(u>0){const o=w.charCodeAt(h);if(A.get(o)!==p.WordCharacterClass.Regular)return!0}return!1}function b(A,w,v,h,u){if(h+u===v)return!0;const r=w.charCodeAt(h+u);if(A.get(r)!==p.WordCharacterClass.Regular||r===t.CharCode.CarriageReturn||r===t.CharCode.LineFeed)return!0;if(u>0){const o=w.charCodeAt(h+u-1);if(A.get(o)!==p.WordCharacterClass.Regular)return!0}return!1}function N(A,w,v,h,u){return e(A,w,v,h,u)&&b(A,w,v,h,u)}class R{constructor(w,v){this._wordSeparators=w,this.a=v,this.b=-1,this.c=0}reset(w){this.a.lastIndex=w,this.b=-1,this.c=0}next(w){const v=w.length;let h;do{if(this.b+this.c===v||(h=this.a.exec(w),!h))return null;const u=h.index,r=h[0].length;if(u===this.b&&r===this.c){if(r===0){n.$Of(w,v,this.a.lastIndex)>65535?this.a.lastIndex+=2:this.a.lastIndex+=1;continue}return null}if(this.b=u,this.c=r,!this._wordSeparators||N(this._wordSeparators,w,v,u,r))return h}while(h);return null}}i.$fD=R}),ne(ie[66],re([0,1]),function(x,i){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.$S4=p;const t=new RegExp("\\bMARK:\\s*(.*)$","d"),n=/^-+|-+$/g;function p(l,c){let $=[];if(c.findRegionSectionHeaders&&c.foldingRules?.markers){const m=g(l,c);$=$.concat(m)}if(c.findMarkSectionHeaders){const m=E(l);$=$.concat(m)}return $}function g(l,c){const $=[],m=l.getLineCount();for(let L=1;L<=m;L++){const e=l.getLineContent(L),b=e.match(c.foldingRules.markers.start);if(b){const N={startLineNumber:L,startColumn:b[0].length+1,endLineNumber:L,endColumn:e.length+1};if(N.endColumn>N.startColumn){const R={range:N,...a(e.substring(b[0].length)),shouldBeInComments:!1};(R.text||R.hasSeparatorLine)&&$.push(R)}}}return $}function E(l){const c=[],$=l.getLineCount();for(let m=1;m<=$;m++){const L=l.getLineContent(m);d(L,m,c)}return c}function d(l,c,$){t.lastIndex=0;const m=t.exec(l);if(m){const L=m.indices[1][0]+1,e=m.indices[1][1]+1,b={startLineNumber:c,startColumn:L,endLineNumber:c,endColumn:e};if(b.endColumn>b.startColumn){const N={range:b,...a(m[1]),shouldBeInComments:!0};(N.text||N.hasSeparatorLine)&&$.push(N)}}}function a(l){l=l.trim();const c=l.startsWith("-");return l=l.replace(n,""),{text:l,hasSeparatorLine:c}}}),ne(ie[67],re([0,1,2,65,8,11,32]),function(x,i,t,n,p,g,E){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.UnicodeHighlighterReasonKind=i.$o4=void 0,p=Ie(p);class d{static computeUnicodeHighlights(e,b,N){const R=N?N.startLineNumber:1,A=N?N.endLineNumber:e.getLineCount(),w=new c(b),v=w.getCandidateCodePoints();let h;v==="allNonBasicAscii"?h=new RegExp("[^\\t\\n\\r\\x20-\\x7E]","g"):h=new RegExp(`${a(Array.from(v))}`,"g");const u=new n.$fD(null,h),r=[];let o=!1,f,T=0,_=0,M=0;e:for(let j=R,F=A;j<=F;j++){const I=e.getLineContent(j),S=I.length;u.reset(0);do if(f=u.next(I),f){let D=f.index,q=f.index+f[0].length;if(D>0){const Y=I.charCodeAt(D-1);p.$Lf(Y)&&D--}if(q+1<S){const Y=I.charCodeAt(q-1);p.$Lf(Y)&&q++}const X=I.substring(D,q);let B=(0,E.$ot)(D+1,E.$lt,I,0);B&&B.endColumn<=D+1&&(B=null);const y=w.shouldHighlightNonBasicASCII(X,B?B.word:null);if(y!==m.None){if(y===m.Ambiguous?T++:y===m.Invisible?_++:y===m.NonBasicASCII?M++:(0,g.$hd)(y),r.length>=1e3){o=!0;break e}r.push(new t.$Mt(j,D+1,j,q+1))}}while(f)}return{ranges:r,hasMore:o,ambiguousCharacterCount:T,invisibleCharacterCount:_,nonBasicAsciiCharacterCount:M}}static computeUnicodeHighlightReason(e,b){const N=new c(b);switch(N.shouldHighlightNonBasicASCII(e,null)){case m.None:return null;case m.Invisible:return{kind:l.Invisible};case m.Ambiguous:{const A=e.codePointAt(0),w=N.ambiguousCharacters.getPrimaryConfusable(A),v=p.$eg.getLocales().filter(h=>!p.$eg.getInstance(new Set([...b.allowedLocales,h])).isAmbiguous(A));return{kind:l.Ambiguous,confusableWith:String.fromCodePoint(w),notAmbiguousInLocales:v}}case m.NonBasicASCII:return{kind:l.NonBasicAscii}}}}i.$o4=d;function a(L,e){return`[${p.$jf(L.map(N=>String.fromCodePoint(N)).join(""))}]`}var l;(function(L){L[L.Ambiguous=0]="Ambiguous",L[L.Invisible=1]="Invisible",L[L.NonBasicAscii=2]="NonBasicAscii"})(l||(i.UnicodeHighlighterReasonKind=l={}));class c{constructor(e){this.b=e,this.a=new Set(e.allowedCodePoints),this.ambiguousCharacters=p.$eg.getInstance(new Set(e.allowedLocales))}getCandidateCodePoints(){if(this.b.nonBasicASCII)return"allNonBasicAscii";const e=new Set;if(this.b.invisibleCharacters)for(const b of p.$fg.codePoints)$(String.fromCodePoint(b))||e.add(b);if(this.b.ambiguousCharacters)for(const b of this.ambiguousCharacters.getConfusableCodePoints())e.add(b);for(const b of this.a)e.delete(b);return e}shouldHighlightNonBasicASCII(e,b){const N=e.codePointAt(0);if(this.a.has(N))return m.None;if(this.b.nonBasicASCII)return m.NonBasicASCII;let R=!1,A=!1;if(b)for(const w of b){const v=w.codePointAt(0),h=p.$Wf(w);R=R||h,!h&&!this.ambiguousCharacters.isAmbiguous(v)&&!p.$fg.isInvisibleCharacter(v)&&(A=!0)}return!R&&A?m.None:this.b.invisibleCharacters&&!$(e)&&p.$fg.isInvisibleCharacter(N)?m.Invisible:this.b.ambiguousCharacters&&this.ambiguousCharacters.isAmbiguous(N)?m.Ambiguous:m.None}}function $(L){return L===" "||L===`
`||L==="	"}var m;(function(L){L[L.None=0]="None",L[L.NonBasicASCII=1]="NonBasicASCII",L[L.Invisible=2]="Invisible",L[L.Ambiguous=3]="Ambiguous"})(m||(m={}))}),ne(ie[68],re([0,1]),function(x,i){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.WrappingIndent=i.TrackedRangeStickiness=i.TextEditorCursorStyle=i.TextEditorCursorBlinkingStyle=i.SymbolTag=i.SymbolKind=i.SignatureHelpTriggerKind=i.ShowLightbulbIconMode=i.SelectionDirection=i.ScrollbarVisibility=i.ScrollType=i.RenderMinimap=i.RenderLineNumbersType=i.PositionAffinity=i.PartialAcceptTriggerKind=i.OverviewRulerLane=i.OverlayWidgetPositionPreference=i.NewSymbolNameTriggerKind=i.NewSymbolNameTag=i.MouseTargetType=i.MinimapSectionHeaderStyle=i.MinimapPosition=i.MarkerTag=i.MarkerSeverity=i.KeyCode=i.InlineEditTriggerKind=i.InlineCompletionTriggerKind=i.InlayHintKind=i.InjectedTextCursorStops=i.IndentAction=i.HoverVerbosityAction=i.GlyphMarginLane=i.EndOfLineSequence=i.EndOfLinePreference=i.EditorOption=i.EditorAutoIndentStrategy=i.DocumentHighlightKind=i.DefaultEndOfLine=i.CursorChangeReason=i.ContentWidgetPositionPreference=i.CompletionTriggerKind=i.CompletionItemTag=i.CompletionItemKind=i.CompletionItemInsertTextRule=i.CodeActionTriggerType=i.AccessibilitySupport=void 0;var t;(function(s){s[s.Unknown=0]="Unknown",s[s.Disabled=1]="Disabled",s[s.Enabled=2]="Enabled"})(t||(i.AccessibilitySupport=t={}));var n;(function(s){s[s.Invoke=1]="Invoke",s[s.Auto=2]="Auto"})(n||(i.CodeActionTriggerType=n={}));var p;(function(s){s[s.None=0]="None",s[s.KeepWhitespace=1]="KeepWhitespace",s[s.InsertAsSnippet=4]="InsertAsSnippet"})(p||(i.CompletionItemInsertTextRule=p={}));var g;(function(s){s[s.Method=0]="Method",s[s.Function=1]="Function",s[s.Constructor=2]="Constructor",s[s.Field=3]="Field",s[s.Variable=4]="Variable",s[s.Class=5]="Class",s[s.Struct=6]="Struct",s[s.Interface=7]="Interface",s[s.Module=8]="Module",s[s.Property=9]="Property",s[s.Event=10]="Event",s[s.Operator=11]="Operator",s[s.Unit=12]="Unit",s[s.Value=13]="Value",s[s.Constant=14]="Constant",s[s.Enum=15]="Enum",s[s.EnumMember=16]="EnumMember",s[s.Keyword=17]="Keyword",s[s.Text=18]="Text",s[s.Color=19]="Color",s[s.File=20]="File",s[s.Reference=21]="Reference",s[s.Customcolor=22]="Customcolor",s[s.Folder=23]="Folder",s[s.TypeParameter=24]="TypeParameter",s[s.User=25]="User",s[s.Issue=26]="Issue",s[s.Snippet=27]="Snippet"})(g||(i.CompletionItemKind=g={}));var E;(function(s){s[s.Deprecated=1]="Deprecated"})(E||(i.CompletionItemTag=E={}));var d;(function(s){s[s.Invoke=0]="Invoke",s[s.TriggerCharacter=1]="TriggerCharacter",s[s.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(d||(i.CompletionTriggerKind=d={}));var a;(function(s){s[s.EXACT=0]="EXACT",s[s.ABOVE=1]="ABOVE",s[s.BELOW=2]="BELOW"})(a||(i.ContentWidgetPositionPreference=a={}));var l;(function(s){s[s.NotSet=0]="NotSet",s[s.ContentFlush=1]="ContentFlush",s[s.RecoverFromMarkers=2]="RecoverFromMarkers",s[s.Explicit=3]="Explicit",s[s.Paste=4]="Paste",s[s.Undo=5]="Undo",s[s.Redo=6]="Redo"})(l||(i.CursorChangeReason=l={}));var c;(function(s){s[s.LF=1]="LF",s[s.CRLF=2]="CRLF"})(c||(i.DefaultEndOfLine=c={}));var $;(function(s){s[s.Text=0]="Text",s[s.Read=1]="Read",s[s.Write=2]="Write"})($||(i.DocumentHighlightKind=$={}));var m;(function(s){s[s.None=0]="None",s[s.Keep=1]="Keep",s[s.Brackets=2]="Brackets",s[s.Advanced=3]="Advanced",s[s.Full=4]="Full"})(m||(i.EditorAutoIndentStrategy=m={}));var L;(function(s){s[s.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",s[s.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",s[s.accessibilitySupport=2]="accessibilitySupport",s[s.accessibilityPageSize=3]="accessibilityPageSize",s[s.ariaLabel=4]="ariaLabel",s[s.ariaRequired=5]="ariaRequired",s[s.autoClosingBrackets=6]="autoClosingBrackets",s[s.autoClosingComments=7]="autoClosingComments",s[s.screenReaderAnnounceInlineSuggestion=8]="screenReaderAnnounceInlineSuggestion",s[s.autoClosingDelete=9]="autoClosingDelete",s[s.autoClosingOvertype=10]="autoClosingOvertype",s[s.autoClosingQuotes=11]="autoClosingQuotes",s[s.autoIndent=12]="autoIndent",s[s.automaticLayout=13]="automaticLayout",s[s.autoSurround=14]="autoSurround",s[s.bracketPairColorization=15]="bracketPairColorization",s[s.guides=16]="guides",s[s.codeLens=17]="codeLens",s[s.codeLensFontFamily=18]="codeLensFontFamily",s[s.codeLensFontSize=19]="codeLensFontSize",s[s.colorDecorators=20]="colorDecorators",s[s.colorDecoratorsLimit=21]="colorDecoratorsLimit",s[s.columnSelection=22]="columnSelection",s[s.comments=23]="comments",s[s.contextmenu=24]="contextmenu",s[s.copyWithSyntaxHighlighting=25]="copyWithSyntaxHighlighting",s[s.cursorBlinking=26]="cursorBlinking",s[s.cursorSmoothCaretAnimation=27]="cursorSmoothCaretAnimation",s[s.cursorStyle=28]="cursorStyle",s[s.cursorSurroundingLines=29]="cursorSurroundingLines",s[s.cursorSurroundingLinesStyle=30]="cursorSurroundingLinesStyle",s[s.cursorWidth=31]="cursorWidth",s[s.disableLayerHinting=32]="disableLayerHinting",s[s.disableMonospaceOptimizations=33]="disableMonospaceOptimizations",s[s.domReadOnly=34]="domReadOnly",s[s.dragAndDrop=35]="dragAndDrop",s[s.dropIntoEditor=36]="dropIntoEditor",s[s.emptySelectionClipboard=37]="emptySelectionClipboard",s[s.experimentalWhitespaceRendering=38]="experimentalWhitespaceRendering",s[s.extraEditorClassName=39]="extraEditorClassName",s[s.fastScrollSensitivity=40]="fastScrollSensitivity",s[s.find=41]="find",s[s.fixedOverflowWidgets=42]="fixedOverflowWidgets",s[s.folding=43]="folding",s[s.foldingStrategy=44]="foldingStrategy",s[s.foldingHighlight=45]="foldingHighlight",s[s.foldingImportsByDefault=46]="foldingImportsByDefault",s[s.foldingMaximumRegions=47]="foldingMaximumRegions",s[s.unfoldOnClickAfterEndOfLine=48]="unfoldOnClickAfterEndOfLine",s[s.fontFamily=49]="fontFamily",s[s.fontInfo=50]="fontInfo",s[s.fontLigatures=51]="fontLigatures",s[s.fontSize=52]="fontSize",s[s.fontWeight=53]="fontWeight",s[s.fontVariations=54]="fontVariations",s[s.formatOnPaste=55]="formatOnPaste",s[s.formatOnType=56]="formatOnType",s[s.glyphMargin=57]="glyphMargin",s[s.gotoLocation=58]="gotoLocation",s[s.hideCursorInOverviewRuler=59]="hideCursorInOverviewRuler",s[s.hover=60]="hover",s[s.inDiffEditor=61]="inDiffEditor",s[s.inlineSuggest=62]="inlineSuggest",s[s.inlineEdit=63]="inlineEdit",s[s.letterSpacing=64]="letterSpacing",s[s.lightbulb=65]="lightbulb",s[s.lineDecorationsWidth=66]="lineDecorationsWidth",s[s.lineHeight=67]="lineHeight",s[s.lineNumbers=68]="lineNumbers",s[s.lineNumbersMinChars=69]="lineNumbersMinChars",s[s.linkedEditing=70]="linkedEditing",s[s.links=71]="links",s[s.matchBrackets=72]="matchBrackets",s[s.minimap=73]="minimap",s[s.mouseStyle=74]="mouseStyle",s[s.mouseWheelScrollSensitivity=75]="mouseWheelScrollSensitivity",s[s.mouseWheelZoom=76]="mouseWheelZoom",s[s.multiCursorMergeOverlapping=77]="multiCursorMergeOverlapping",s[s.multiCursorModifier=78]="multiCursorModifier",s[s.multiCursorPaste=79]="multiCursorPaste",s[s.multiCursorLimit=80]="multiCursorLimit",s[s.occurrencesHighlight=81]="occurrencesHighlight",s[s.overviewRulerBorder=82]="overviewRulerBorder",s[s.overviewRulerLanes=83]="overviewRulerLanes",s[s.padding=84]="padding",s[s.pasteAs=85]="pasteAs",s[s.parameterHints=86]="parameterHints",s[s.peekWidgetDefaultFocus=87]="peekWidgetDefaultFocus",s[s.placeholder=88]="placeholder",s[s.definitionLinkOpensInPeek=89]="definitionLinkOpensInPeek",s[s.quickSuggestions=90]="quickSuggestions",s[s.quickSuggestionsDelay=91]="quickSuggestionsDelay",s[s.readOnly=92]="readOnly",s[s.readOnlyMessage=93]="readOnlyMessage",s[s.renameOnType=94]="renameOnType",s[s.renderControlCharacters=95]="renderControlCharacters",s[s.renderFinalNewline=96]="renderFinalNewline",s[s.renderLineHighlight=97]="renderLineHighlight",s[s.renderLineHighlightOnlyWhenFocus=98]="renderLineHighlightOnlyWhenFocus",s[s.renderValidationDecorations=99]="renderValidationDecorations",s[s.renderWhitespace=100]="renderWhitespace",s[s.revealHorizontalRightPadding=101]="revealHorizontalRightPadding",s[s.roundedSelection=102]="roundedSelection",s[s.rulers=103]="rulers",s[s.scrollbar=104]="scrollbar",s[s.scrollBeyondLastColumn=105]="scrollBeyondLastColumn",s[s.scrollBeyondLastLine=106]="scrollBeyondLastLine",s[s.scrollPredominantAxis=107]="scrollPredominantAxis",s[s.selectionClipboard=108]="selectionClipboard",s[s.selectionHighlight=109]="selectionHighlight",s[s.selectOnLineNumbers=110]="selectOnLineNumbers",s[s.showFoldingControls=111]="showFoldingControls",s[s.showUnused=112]="showUnused",s[s.snippetSuggestions=113]="snippetSuggestions",s[s.smartSelect=114]="smartSelect",s[s.smoothScrolling=115]="smoothScrolling",s[s.stickyScroll=116]="stickyScroll",s[s.stickyTabStops=117]="stickyTabStops",s[s.stopRenderingLineAfter=118]="stopRenderingLineAfter",s[s.suggest=119]="suggest",s[s.suggestFontSize=120]="suggestFontSize",s[s.suggestLineHeight=121]="suggestLineHeight",s[s.suggestOnTriggerCharacters=122]="suggestOnTriggerCharacters",s[s.suggestSelection=123]="suggestSelection",s[s.tabCompletion=124]="tabCompletion",s[s.tabIndex=125]="tabIndex",s[s.unicodeHighlighting=126]="unicodeHighlighting",s[s.unusualLineTerminators=127]="unusualLineTerminators",s[s.useShadowDOM=128]="useShadowDOM",s[s.useTabStops=129]="useTabStops",s[s.wordBreak=130]="wordBreak",s[s.wordSegmenterLocales=131]="wordSegmenterLocales",s[s.wordSeparators=132]="wordSeparators",s[s.wordWrap=133]="wordWrap",s[s.wordWrapBreakAfterCharacters=134]="wordWrapBreakAfterCharacters",s[s.wordWrapBreakBeforeCharacters=135]="wordWrapBreakBeforeCharacters",s[s.wordWrapColumn=136]="wordWrapColumn",s[s.wordWrapOverride1=137]="wordWrapOverride1",s[s.wordWrapOverride2=138]="wordWrapOverride2",s[s.wrappingIndent=139]="wrappingIndent",s[s.wrappingStrategy=140]="wrappingStrategy",s[s.showDeprecated=141]="showDeprecated",s[s.inlayHints=142]="inlayHints",s[s.editorClassName=143]="editorClassName",s[s.pixelRatio=144]="pixelRatio",s[s.tabFocusMode=145]="tabFocusMode",s[s.layoutInfo=146]="layoutInfo",s[s.wrappingInfo=147]="wrappingInfo",s[s.defaultColorDecorators=148]="defaultColorDecorators",s[s.colorDecoratorsActivatedOn=149]="colorDecoratorsActivatedOn",s[s.inlineCompletionsAccessibilityVerbose=150]="inlineCompletionsAccessibilityVerbose"})(L||(i.EditorOption=L={}));var e;(function(s){s[s.TextDefined=0]="TextDefined",s[s.LF=1]="LF",s[s.CRLF=2]="CRLF"})(e||(i.EndOfLinePreference=e={}));var b;(function(s){s[s.LF=0]="LF",s[s.CRLF=1]="CRLF"})(b||(i.EndOfLineSequence=b={}));var N;(function(s){s[s.Left=1]="Left",s[s.Center=2]="Center",s[s.Right=3]="Right"})(N||(i.GlyphMarginLane=N={}));var R;(function(s){s[s.Increase=0]="Increase",s[s.Decrease=1]="Decrease"})(R||(i.HoverVerbosityAction=R={}));var A;(function(s){s[s.None=0]="None",s[s.Indent=1]="Indent",s[s.IndentOutdent=2]="IndentOutdent",s[s.Outdent=3]="Outdent"})(A||(i.IndentAction=A={}));var w;(function(s){s[s.Both=0]="Both",s[s.Right=1]="Right",s[s.Left=2]="Left",s[s.None=3]="None"})(w||(i.InjectedTextCursorStops=w={}));var v;(function(s){s[s.Type=1]="Type",s[s.Parameter=2]="Parameter"})(v||(i.InlayHintKind=v={}));var h;(function(s){s[s.Automatic=0]="Automatic",s[s.Explicit=1]="Explicit"})(h||(i.InlineCompletionTriggerKind=h={}));var u;(function(s){s[s.Invoke=0]="Invoke",s[s.Automatic=1]="Automatic"})(u||(i.InlineEditTriggerKind=u={}));var r;(function(s){s[s.DependsOnKbLayout=-1]="DependsOnKbLayout",s[s.Unknown=0]="Unknown",s[s.Backspace=1]="Backspace",s[s.Tab=2]="Tab",s[s.Enter=3]="Enter",s[s.Shift=4]="Shift",s[s.Ctrl=5]="Ctrl",s[s.Alt=6]="Alt",s[s.PauseBreak=7]="PauseBreak",s[s.CapsLock=8]="CapsLock",s[s.Escape=9]="Escape",s[s.Space=10]="Space",s[s.PageUp=11]="PageUp",s[s.PageDown=12]="PageDown",s[s.End=13]="End",s[s.Home=14]="Home",s[s.LeftArrow=15]="LeftArrow",s[s.UpArrow=16]="UpArrow",s[s.RightArrow=17]="RightArrow",s[s.DownArrow=18]="DownArrow",s[s.Insert=19]="Insert",s[s.Delete=20]="Delete",s[s.Digit0=21]="Digit0",s[s.Digit1=22]="Digit1",s[s.Digit2=23]="Digit2",s[s.Digit3=24]="Digit3",s[s.Digit4=25]="Digit4",s[s.Digit5=26]="Digit5",s[s.Digit6=27]="Digit6",s[s.Digit7=28]="Digit7",s[s.Digit8=29]="Digit8",s[s.Digit9=30]="Digit9",s[s.KeyA=31]="KeyA",s[s.KeyB=32]="KeyB",s[s.KeyC=33]="KeyC",s[s.KeyD=34]="KeyD",s[s.KeyE=35]="KeyE",s[s.KeyF=36]="KeyF",s[s.KeyG=37]="KeyG",s[s.KeyH=38]="KeyH",s[s.KeyI=39]="KeyI",s[s.KeyJ=40]="KeyJ",s[s.KeyK=41]="KeyK",s[s.KeyL=42]="KeyL",s[s.KeyM=43]="KeyM",s[s.KeyN=44]="KeyN",s[s.KeyO=45]="KeyO",s[s.KeyP=46]="KeyP",s[s.KeyQ=47]="KeyQ",s[s.KeyR=48]="KeyR",s[s.KeyS=49]="KeyS",s[s.KeyT=50]="KeyT",s[s.KeyU=51]="KeyU",s[s.KeyV=52]="KeyV",s[s.KeyW=53]="KeyW",s[s.KeyX=54]="KeyX",s[s.KeyY=55]="KeyY",s[s.KeyZ=56]="KeyZ",s[s.Meta=57]="Meta",s[s.ContextMenu=58]="ContextMenu",s[s.F1=59]="F1",s[s.F2=60]="F2",s[s.F3=61]="F3",s[s.F4=62]="F4",s[s.F5=63]="F5",s[s.F6=64]="F6",s[s.F7=65]="F7",s[s.F8=66]="F8",s[s.F9=67]="F9",s[s.F10=68]="F10",s[s.F11=69]="F11",s[s.F12=70]="F12",s[s.F13=71]="F13",s[s.F14=72]="F14",s[s.F15=73]="F15",s[s.F16=74]="F16",s[s.F17=75]="F17",s[s.F18=76]="F18",s[s.F19=77]="F19",s[s.F20=78]="F20",s[s.F21=79]="F21",s[s.F22=80]="F22",s[s.F23=81]="F23",s[s.F24=82]="F24",s[s.NumLock=83]="NumLock",s[s.ScrollLock=84]="ScrollLock",s[s.Semicolon=85]="Semicolon",s[s.Equal=86]="Equal",s[s.Comma=87]="Comma",s[s.Minus=88]="Minus",s[s.Period=89]="Period",s[s.Slash=90]="Slash",s[s.Backquote=91]="Backquote",s[s.BracketLeft=92]="BracketLeft",s[s.Backslash=93]="Backslash",s[s.BracketRight=94]="BracketRight",s[s.Quote=95]="Quote",s[s.OEM_8=96]="OEM_8",s[s.IntlBackslash=97]="IntlBackslash",s[s.Numpad0=98]="Numpad0",s[s.Numpad1=99]="Numpad1",s[s.Numpad2=100]="Numpad2",s[s.Numpad3=101]="Numpad3",s[s.Numpad4=102]="Numpad4",s[s.Numpad5=103]="Numpad5",s[s.Numpad6=104]="Numpad6",s[s.Numpad7=105]="Numpad7",s[s.Numpad8=106]="Numpad8",s[s.Numpad9=107]="Numpad9",s[s.NumpadMultiply=108]="NumpadMultiply",s[s.NumpadAdd=109]="NumpadAdd",s[s.NUMPAD_SEPARATOR=110]="NUMPAD_SEPARATOR",s[s.NumpadSubtract=111]="NumpadSubtract",s[s.NumpadDecimal=112]="NumpadDecimal",s[s.NumpadDivide=113]="NumpadDivide",s[s.KEY_IN_COMPOSITION=114]="KEY_IN_COMPOSITION",s[s.ABNT_C1=115]="ABNT_C1",s[s.ABNT_C2=116]="ABNT_C2",s[s.AudioVolumeMute=117]="AudioVolumeMute",s[s.AudioVolumeUp=118]="AudioVolumeUp",s[s.AudioVolumeDown=119]="AudioVolumeDown",s[s.BrowserSearch=120]="BrowserSearch",s[s.BrowserHome=121]="BrowserHome",s[s.BrowserBack=122]="BrowserBack",s[s.BrowserForward=123]="BrowserForward",s[s.MediaTrackNext=124]="MediaTrackNext",s[s.MediaTrackPrevious=125]="MediaTrackPrevious",s[s.MediaStop=126]="MediaStop",s[s.MediaPlayPause=127]="MediaPlayPause",s[s.LaunchMediaPlayer=128]="LaunchMediaPlayer",s[s.LaunchMail=129]="LaunchMail",s[s.LaunchApp2=130]="LaunchApp2",s[s.Clear=131]="Clear",s[s.MAX_VALUE=132]="MAX_VALUE"})(r||(i.KeyCode=r={}));var o;(function(s){s[s.Hint=1]="Hint",s[s.Info=2]="Info",s[s.Warning=4]="Warning",s[s.Error=8]="Error"})(o||(i.MarkerSeverity=o={}));var f;(function(s){s[s.Unnecessary=1]="Unnecessary",s[s.Deprecated=2]="Deprecated"})(f||(i.MarkerTag=f={}));var T;(function(s){s[s.Inline=1]="Inline",s[s.Gutter=2]="Gutter"})(T||(i.MinimapPosition=T={}));var _;(function(s){s[s.Normal=1]="Normal",s[s.Underlined=2]="Underlined"})(_||(i.MinimapSectionHeaderStyle=_={}));var M;(function(s){s[s.UNKNOWN=0]="UNKNOWN",s[s.TEXTAREA=1]="TEXTAREA",s[s.GUTTER_GLYPH_MARGIN=2]="GUTTER_GLYPH_MARGIN",s[s.GUTTER_LINE_NUMBERS=3]="GUTTER_LINE_NUMBERS",s[s.GUTTER_LINE_DECORATIONS=4]="GUTTER_LINE_DECORATIONS",s[s.GUTTER_VIEW_ZONE=5]="GUTTER_VIEW_ZONE",s[s.CONTENT_TEXT=6]="CONTENT_TEXT",s[s.CONTENT_EMPTY=7]="CONTENT_EMPTY",s[s.CONTENT_VIEW_ZONE=8]="CONTENT_VIEW_ZONE",s[s.CONTENT_WIDGET=9]="CONTENT_WIDGET",s[s.OVERVIEW_RULER=10]="OVERVIEW_RULER",s[s.SCROLLBAR=11]="SCROLLBAR",s[s.OVERLAY_WIDGET=12]="OVERLAY_WIDGET",s[s.OUTSIDE_EDITOR=13]="OUTSIDE_EDITOR"})(M||(i.MouseTargetType=M={}));var j;(function(s){s[s.AIGenerated=1]="AIGenerated"})(j||(i.NewSymbolNameTag=j={}));var F;(function(s){s[s.Invoke=0]="Invoke",s[s.Automatic=1]="Automatic"})(F||(i.NewSymbolNameTriggerKind=F={}));var I;(function(s){s[s.TOP_RIGHT_CORNER=0]="TOP_RIGHT_CORNER",s[s.BOTTOM_RIGHT_CORNER=1]="BOTTOM_RIGHT_CORNER",s[s.TOP_CENTER=2]="TOP_CENTER"})(I||(i.OverlayWidgetPositionPreference=I={}));var S;(function(s){s[s.Left=1]="Left",s[s.Center=2]="Center",s[s.Right=4]="Right",s[s.Full=7]="Full"})(S||(i.OverviewRulerLane=S={}));var D;(function(s){s[s.Word=0]="Word",s[s.Line=1]="Line",s[s.Suggest=2]="Suggest"})(D||(i.PartialAcceptTriggerKind=D={}));var q;(function(s){s[s.Left=0]="Left",s[s.Right=1]="Right",s[s.None=2]="None",s[s.LeftOfInjectedText=3]="LeftOfInjectedText",s[s.RightOfInjectedText=4]="RightOfInjectedText"})(q||(i.PositionAffinity=q={}));var X;(function(s){s[s.Off=0]="Off",s[s.On=1]="On",s[s.Relative=2]="Relative",s[s.Interval=3]="Interval",s[s.Custom=4]="Custom"})(X||(i.RenderLineNumbersType=X={}));var B;(function(s){s[s.None=0]="None",s[s.Text=1]="Text",s[s.Blocks=2]="Blocks"})(B||(i.RenderMinimap=B={}));var y;(function(s){s[s.Smooth=0]="Smooth",s[s.Immediate=1]="Immediate"})(y||(i.ScrollType=y={}));var Y;(function(s){s[s.Auto=1]="Auto",s[s.Hidden=2]="Hidden",s[s.Visible=3]="Visible"})(Y||(i.ScrollbarVisibility=Y={}));var Z;(function(s){s[s.LTR=0]="LTR",s[s.RTL=1]="RTL"})(Z||(i.SelectionDirection=Z={}));var H;(function(s){s.Off="off",s.OnCode="onCode",s.On="on"})(H||(i.ShowLightbulbIconMode=H={}));var Q;(function(s){s[s.Invoke=1]="Invoke",s[s.TriggerCharacter=2]="TriggerCharacter",s[s.ContentChange=3]="ContentChange"})(Q||(i.SignatureHelpTriggerKind=Q={}));var C;(function(s){s[s.File=0]="File",s[s.Module=1]="Module",s[s.Namespace=2]="Namespace",s[s.Package=3]="Package",s[s.Class=4]="Class",s[s.Method=5]="Method",s[s.Property=6]="Property",s[s.Field=7]="Field",s[s.Constructor=8]="Constructor",s[s.Enum=9]="Enum",s[s.Interface=10]="Interface",s[s.Function=11]="Function",s[s.Variable=12]="Variable",s[s.Constant=13]="Constant",s[s.String=14]="String",s[s.Number=15]="Number",s[s.Boolean=16]="Boolean",s[s.Array=17]="Array",s[s.Object=18]="Object",s[s.Key=19]="Key",s[s.Null=20]="Null",s[s.EnumMember=21]="EnumMember",s[s.Struct=22]="Struct",s[s.Event=23]="Event",s[s.Operator=24]="Operator",s[s.TypeParameter=25]="TypeParameter"})(C||(i.SymbolKind=C={}));var k;(function(s){s[s.Deprecated=1]="Deprecated"})(k||(i.SymbolTag=k={}));var z;(function(s){s[s.Hidden=0]="Hidden",s[s.Blink=1]="Blink",s[s.Smooth=2]="Smooth",s[s.Phase=3]="Phase",s[s.Expand=4]="Expand",s[s.Solid=5]="Solid"})(z||(i.TextEditorCursorBlinkingStyle=z={}));var fe;(function(s){s[s.Line=1]="Line",s[s.Block=2]="Block",s[s.Underline=3]="Underline",s[s.LineThin=4]="LineThin",s[s.BlockOutline=5]="BlockOutline",s[s.UnderlineThin=6]="UnderlineThin"})(fe||(i.TextEditorCursorStyle=fe={}));var oe;(function(s){s[s.AlwaysGrowsWhenTypingAtEdges=0]="AlwaysGrowsWhenTypingAtEdges",s[s.NeverGrowsWhenTypingAtEdges=1]="NeverGrowsWhenTypingAtEdges",s[s.GrowsOnlyWhenTypingBefore=2]="GrowsOnlyWhenTypingBefore",s[s.GrowsOnlyWhenTypingAfter=3]="GrowsOnlyWhenTypingAfter"})(oe||(i.TrackedRangeStickiness=oe={}));var we;(function(s){s[s.None=0]="None",s[s.Same=1]="Same",s[s.Indent=2]="Indent",s[s.DeepIndent=3]="DeepIndent"})(we||(i.WrappingIndent=we={}))}),ne(ie[69],re([0,1,13,12,58]),function(x,i,t,n,p){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.$vu=void 0;class g{constructor(){this.a=new Map,this.b=new Map,this.c=new t.$ne,this.onDidChange=this.c.event,this.d=null}handleChange(a){this.c.fire({changedLanguages:a,changedColorMap:!1})}register(a,l){return this.a.set(a,l),this.handleChange([a]),(0,n.$Vc)(()=>{this.a.get(a)===l&&(this.a.delete(a),this.handleChange([a]))})}get(a){return this.a.get(a)||null}registerFactory(a,l){this.b.get(a)?.dispose();const c=new E(this,a,l);return this.b.set(a,c),(0,n.$Vc)(()=>{const $=this.b.get(a);!$||$!==c||(this.b.delete(a),$.dispose())})}async getOrCreate(a){const l=this.get(a);if(l)return l;const c=this.b.get(a);return!c||c.isResolved?null:(await c.resolve(),this.get(a))}isResolved(a){if(this.get(a))return!0;const c=this.b.get(a);return!!(!c||c.isResolved)}setColorMap(a){this.d=a,this.c.fire({changedLanguages:Array.from(this.a.keys()),changedColorMap:!0})}getColorMap(){return this.d}getDefaultBackground(){return this.d&&this.d.length>p.ColorId.DefaultBackground?this.d[p.ColorId.DefaultBackground]:null}}i.$vu=g;class E extends n.$Xc{get isResolved(){return this.c}constructor(a,l,c){super(),this.f=a,this.g=l,this.h=c,this.a=!1,this.b=null,this.c=!1}dispose(){this.a=!0,super.dispose()}async resolve(){return this.b||(this.b=this.j()),this.b}async j(){const a=await this.h.tokenizationSupport;this.c=!0,a&&!this.a&&this.B(this.f.register(this.g,a))}}}),ne(ie[70],re([71,72]),function(x,i){return x.create("vs/base/common/platform",i)}),ne(ie[20],re([0,1,70]),function(x,i,t){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.$I=i.$H=i.$G=i.$F=i.$E=i.OS=i.OperatingSystem=i.$B=i.$A=i.$z=i.$y=i.$x=i.Language=i.$w=i.$v=i.$u=i.$t=i.$s=i.$r=i.$q=i.$p=i.$o=i.$n=i.$m=i.$l=i.$k=i.$j=i.$i=i.Platform=i.$g=void 0,i.$h=r,i.$D=j,i.$J=F,t=Ie(t),i.$g="en";let n=!1,p=!1,g=!1,E=!1,d=!1,a=!1,l=!1,c=!1,$=!1,m=!1,L,e=i.$g,b=i.$g,N,R;const A=globalThis;let w;typeof A.vscode<"u"&&typeof A.vscode.process<"u"?w=A.vscode.process:typeof process<"u"&&typeof process?.versions?.node=="string"&&(w=process);const v=typeof w?.versions?.electron=="string",h=v&&w?.type==="renderer";if(typeof w=="object"){n=w.platform==="win32",p=w.platform==="darwin",g=w.platform==="linux",E=g&&!!w.env.SNAP&&!!w.env.SNAP_REVISION,l=v,$=!!w.env.CI||!!w.env.BUILD_ARTIFACTSTAGINGDIRECTORY,L=i.$g,e=i.$g;const I=w.env.VSCODE_NLS_CONFIG;if(I)try{const S=JSON.parse(I),D=S.availableLanguages["*"];L=S.locale,b=S.osLocale,e=D||i.$g,N=S._translationsConfigFile}catch{}d=!0}else typeof navigator=="object"&&!h?(R=navigator.userAgent,n=R.indexOf("Windows")>=0,p=R.indexOf("Macintosh")>=0,c=(R.indexOf("Macintosh")>=0||R.indexOf("iPad")>=0||R.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,g=R.indexOf("Linux")>=0,m=R?.indexOf("Mobi")>=0,a=!0,L=t.getConfiguredDefaultLocale(t.localize(0,null))||i.$g,e=L,b=navigator.language):console.error("Unable to resolve platform.");var u;(function(I){I[I.Web=0]="Web",I[I.Mac=1]="Mac",I[I.Linux=2]="Linux",I[I.Windows=3]="Windows"})(u||(i.Platform=u={}));function r(I){switch(I){case u.Web:return"Web";case u.Mac:return"Mac";case u.Linux:return"Linux";case u.Windows:return"Windows"}}let o=u.Web;p?o=u.Mac:n?o=u.Windows:g&&(o=u.Linux),i.$i=n,i.$j=p,i.$k=g,i.$l=E,i.$m=d,i.$n=l,i.$o=a,i.$p=a&&typeof A.importScripts=="function",i.$q=i.$p?A.origin:void 0,i.$r=c,i.$s=m,i.$t=$,i.$u=o,i.$v=R,i.$w=e;var f;(function(I){function S(){return i.$w}I.value=S;function D(){return i.$w.length===2?i.$w==="en":i.$w.length>=3?i.$w[0]==="e"&&i.$w[1]==="n"&&i.$w[2]==="-":!1}I.isDefaultVariant=D;function q(){return i.$w==="en"}I.isDefault=q})(f||(i.Language=f={})),i.$x=L,i.$y=b,i.$z=N,i.$A=typeof A.postMessage=="function"&&!A.importScripts,i.$B=(()=>{if(i.$A){const I=[];A.addEventListener("message",D=>{if(D.data&&D.data.vscodeScheduleAsyncWork)for(let q=0,X=I.length;q<X;q++){const B=I[q];if(B.id===D.data.vscodeScheduleAsyncWork){I.splice(q,1),B.callback();return}}});let S=0;return D=>{const q=++S;I.push({id:q,callback:D}),A.postMessage({vscodeScheduleAsyncWork:q},"*")}}return I=>setTimeout(I)})();var T;(function(I){I[I.Windows=1]="Windows",I[I.Macintosh=2]="Macintosh",I[I.Linux=3]="Linux"})(T||(i.OperatingSystem=T={})),i.OS=p||c?T.Macintosh:n?T.Windows:T.Linux;let _=!0,M=!1;function j(){if(!M){M=!0;const I=new Uint8Array(2);I[0]=1,I[1]=2,_=new Uint16Array(I.buffer)[0]===513}return _}i.$E=!!(i.$v&&i.$v.indexOf("Chrome")>=0),i.$F=!!(i.$v&&i.$v.indexOf("Firefox")>=0),i.$G=!!(!i.$E&&i.$v&&i.$v.indexOf("Safari")>=0),i.$H=!!(i.$v&&i.$v.indexOf("Edg/")>=0),i.$I=!!(i.$v&&i.$v.indexOf("Android")>=0);function F(I){return parseFloat(I)>=20}}),ne(ie[73],re([0,1,20]),function(x,i,t){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.$hc=i.$gc=i.env=i.cwd=void 0;let n;const p=globalThis.vscode;if(typeof p<"u"&&typeof p.process<"u"){const g=p.process;n={get platform(){return g.platform},get arch(){return g.arch},get env(){return g.env},cwd(){return g.cwd()}}}else typeof process<"u"?n={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:n={get platform(){return t.$i?"win32":t.$j?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};i.cwd=n.cwd,i.env=n.env,i.$gc=n.platform,i.$hc=n.arch}),ne(ie[74],re([0,1,73]),function(x,i,t){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.$wc=i.sep=i.$uc=i.$tc=i.$sc=i.$rc=i.$qc=i.$pc=i.$oc=i.$nc=i.$mc=i.$lc=i.$kc=i.$jc=i.$ic=void 0,t=Ie(t);const n=65,p=97,g=90,E=122,d=46,a=47,l=92,c=58,$=63;class m extends Error{constructor(r,o,f){let T;typeof o=="string"&&o.indexOf("not ")===0?(T="must not be",o=o.replace(/^not /,"")):T="must be";const _=r.indexOf(".")!==-1?"property":"argument";let M=`The "${r}" ${_} ${T} of type ${o}`;M+=`. Received type ${typeof f}`,super(M),this.code="ERR_INVALID_ARG_TYPE"}}function L(u,r){if(u===null||typeof u!="object")throw new m(r,"Object",u)}function e(u,r){if(typeof u!="string")throw new m(r,"string",u)}const b=t.$gc==="win32";function N(u){return u===a||u===l}function R(u){return u===a}function A(u){return u>=n&&u<=g||u>=p&&u<=E}function w(u,r,o,f){let T="",_=0,M=-1,j=0,F=0;for(let I=0;I<=u.length;++I){if(I<u.length)F=u.charCodeAt(I);else{if(f(F))break;F=a}if(f(F)){if(!(M===I-1||j===1))if(j===2){if(T.length<2||_!==2||T.charCodeAt(T.length-1)!==d||T.charCodeAt(T.length-2)!==d){if(T.length>2){const S=T.lastIndexOf(o);S===-1?(T="",_=0):(T=T.slice(0,S),_=T.length-1-T.lastIndexOf(o)),M=I,j=0;continue}else if(T.length!==0){T="",_=0,M=I,j=0;continue}}r&&(T+=T.length>0?`${o}..`:"..",_=2)}else T.length>0?T+=`${o}${u.slice(M+1,I)}`:T=u.slice(M+1,I),_=I-M-1;M=I,j=0}else F===d&&j!==-1?++j:j=-1}return T}function v(u,r){L(r,"pathObject");const o=r.dir||r.root,f=r.base||`${r.name||""}${r.ext||""}`;return o?o===r.root?`${o}${f}`:`${o}${u}${f}`:f}i.$ic={resolve(...u){let r="",o="",f=!1;for(let T=u.length-1;T>=-1;T--){let _;if(T>=0){if(_=u[T],e(_,"path"),_.length===0)continue}else r.length===0?_=t.cwd():(_=t.env[`=${r}`]||t.cwd(),(_===void 0||_.slice(0,2).toLowerCase()!==r.toLowerCase()&&_.charCodeAt(2)===l)&&(_=`${r}\\`));const M=_.length;let j=0,F="",I=!1;const S=_.charCodeAt(0);if(M===1)N(S)&&(j=1,I=!0);else if(N(S))if(I=!0,N(_.charCodeAt(1))){let D=2,q=D;for(;D<M&&!N(_.charCodeAt(D));)D++;if(D<M&&D!==q){const X=_.slice(q,D);for(q=D;D<M&&N(_.charCodeAt(D));)D++;if(D<M&&D!==q){for(q=D;D<M&&!N(_.charCodeAt(D));)D++;(D===M||D!==q)&&(F=`\\\\${X}\\${_.slice(q,D)}`,j=D)}}}else j=1;else A(S)&&_.charCodeAt(1)===c&&(F=_.slice(0,2),j=2,M>2&&N(_.charCodeAt(2))&&(I=!0,j=3));if(F.length>0)if(r.length>0){if(F.toLowerCase()!==r.toLowerCase())continue}else r=F;if(f){if(r.length>0)break}else if(o=`${_.slice(j)}\\${o}`,f=I,I&&r.length>0)break}return o=w(o,!f,"\\",N),f?`${r}\\${o}`:`${r}${o}`||"."},normalize(u){e(u,"path");const r=u.length;if(r===0)return".";let o=0,f,T=!1;const _=u.charCodeAt(0);if(r===1)return R(_)?"\\":u;if(N(_))if(T=!0,N(u.charCodeAt(1))){let j=2,F=j;for(;j<r&&!N(u.charCodeAt(j));)j++;if(j<r&&j!==F){const I=u.slice(F,j);for(F=j;j<r&&N(u.charCodeAt(j));)j++;if(j<r&&j!==F){for(F=j;j<r&&!N(u.charCodeAt(j));)j++;if(j===r)return`\\\\${I}\\${u.slice(F)}\\`;j!==F&&(f=`\\\\${I}\\${u.slice(F,j)}`,o=j)}}}else o=1;else A(_)&&u.charCodeAt(1)===c&&(f=u.slice(0,2),o=2,r>2&&N(u.charCodeAt(2))&&(T=!0,o=3));let M=o<r?w(u.slice(o),!T,"\\",N):"";return M.length===0&&!T&&(M="."),M.length>0&&N(u.charCodeAt(r-1))&&(M+="\\"),f===void 0?T?`\\${M}`:M:T?`${f}\\${M}`:`${f}${M}`},isAbsolute(u){e(u,"path");const r=u.length;if(r===0)return!1;const o=u.charCodeAt(0);return N(o)||r>2&&A(o)&&u.charCodeAt(1)===c&&N(u.charCodeAt(2))},join(...u){if(u.length===0)return".";let r,o;for(let _=0;_<u.length;++_){const M=u[_];e(M,"path"),M.length>0&&(r===void 0?r=o=M:r+=`\\${M}`)}if(r===void 0)return".";let f=!0,T=0;if(typeof o=="string"&&N(o.charCodeAt(0))){++T;const _=o.length;_>1&&N(o.charCodeAt(1))&&(++T,_>2&&(N(o.charCodeAt(2))?++T:f=!1))}if(f){for(;T<r.length&&N(r.charCodeAt(T));)T++;T>=2&&(r=`\\${r.slice(T)}`)}return i.$ic.normalize(r)},relative(u,r){if(e(u,"from"),e(r,"to"),u===r)return"";const o=i.$ic.resolve(u),f=i.$ic.resolve(r);if(o===f||(u=o.toLowerCase(),r=f.toLowerCase(),u===r))return"";let T=0;for(;T<u.length&&u.charCodeAt(T)===l;)T++;let _=u.length;for(;_-1>T&&u.charCodeAt(_-1)===l;)_--;const M=_-T;let j=0;for(;j<r.length&&r.charCodeAt(j)===l;)j++;let F=r.length;for(;F-1>j&&r.charCodeAt(F-1)===l;)F--;const I=F-j,S=M<I?M:I;let D=-1,q=0;for(;q<S;q++){const B=u.charCodeAt(T+q);if(B!==r.charCodeAt(j+q))break;B===l&&(D=q)}if(q!==S){if(D===-1)return f}else{if(I>S){if(r.charCodeAt(j+q)===l)return f.slice(j+q+1);if(q===2)return f.slice(j+q)}M>S&&(u.charCodeAt(T+q)===l?D=q:q===2&&(D=3)),D===-1&&(D=0)}let X="";for(q=T+D+1;q<=_;++q)(q===_||u.charCodeAt(q)===l)&&(X+=X.length===0?"..":"\\..");return j+=D,X.length>0?`${X}${f.slice(j,F)}`:(f.charCodeAt(j)===l&&++j,f.slice(j,F))},toNamespacedPath(u){if(typeof u!="string"||u.length===0)return u;const r=i.$ic.resolve(u);if(r.length<=2)return u;if(r.charCodeAt(0)===l){if(r.charCodeAt(1)===l){const o=r.charCodeAt(2);if(o!==$&&o!==d)return`\\\\?\\UNC\\${r.slice(2)}`}}else if(A(r.charCodeAt(0))&&r.charCodeAt(1)===c&&r.charCodeAt(2)===l)return`\\\\?\\${r}`;return u},dirname(u){e(u,"path");const r=u.length;if(r===0)return".";let o=-1,f=0;const T=u.charCodeAt(0);if(r===1)return N(T)?u:".";if(N(T)){if(o=f=1,N(u.charCodeAt(1))){let j=2,F=j;for(;j<r&&!N(u.charCodeAt(j));)j++;if(j<r&&j!==F){for(F=j;j<r&&N(u.charCodeAt(j));)j++;if(j<r&&j!==F){for(F=j;j<r&&!N(u.charCodeAt(j));)j++;if(j===r)return u;j!==F&&(o=f=j+1)}}}}else A(T)&&u.charCodeAt(1)===c&&(o=r>2&&N(u.charCodeAt(2))?3:2,f=o);let _=-1,M=!0;for(let j=r-1;j>=f;--j)if(N(u.charCodeAt(j))){if(!M){_=j;break}}else M=!1;if(_===-1){if(o===-1)return".";_=o}return u.slice(0,_)},basename(u,r){r!==void 0&&e(r,"ext"),e(u,"path");let o=0,f=-1,T=!0,_;if(u.length>=2&&A(u.charCodeAt(0))&&u.charCodeAt(1)===c&&(o=2),r!==void 0&&r.length>0&&r.length<=u.length){if(r===u)return"";let M=r.length-1,j=-1;for(_=u.length-1;_>=o;--_){const F=u.charCodeAt(_);if(N(F)){if(!T){o=_+1;break}}else j===-1&&(T=!1,j=_+1),M>=0&&(F===r.charCodeAt(M)?--M===-1&&(f=_):(M=-1,f=j))}return o===f?f=j:f===-1&&(f=u.length),u.slice(o,f)}for(_=u.length-1;_>=o;--_)if(N(u.charCodeAt(_))){if(!T){o=_+1;break}}else f===-1&&(T=!1,f=_+1);return f===-1?"":u.slice(o,f)},extname(u){e(u,"path");let r=0,o=-1,f=0,T=-1,_=!0,M=0;u.length>=2&&u.charCodeAt(1)===c&&A(u.charCodeAt(0))&&(r=f=2);for(let j=u.length-1;j>=r;--j){const F=u.charCodeAt(j);if(N(F)){if(!_){f=j+1;break}continue}T===-1&&(_=!1,T=j+1),F===d?o===-1?o=j:M!==1&&(M=1):o!==-1&&(M=-1)}return o===-1||T===-1||M===0||M===1&&o===T-1&&o===f+1?"":u.slice(o,T)},format:v.bind(null,"\\"),parse(u){e(u,"path");const r={root:"",dir:"",base:"",ext:"",name:""};if(u.length===0)return r;const o=u.length;let f=0,T=u.charCodeAt(0);if(o===1)return N(T)?(r.root=r.dir=u,r):(r.base=r.name=u,r);if(N(T)){if(f=1,N(u.charCodeAt(1))){let D=2,q=D;for(;D<o&&!N(u.charCodeAt(D));)D++;if(D<o&&D!==q){for(q=D;D<o&&N(u.charCodeAt(D));)D++;if(D<o&&D!==q){for(q=D;D<o&&!N(u.charCodeAt(D));)D++;D===o?f=D:D!==q&&(f=D+1)}}}}else if(A(T)&&u.charCodeAt(1)===c){if(o<=2)return r.root=r.dir=u,r;if(f=2,N(u.charCodeAt(2))){if(o===3)return r.root=r.dir=u,r;f=3}}f>0&&(r.root=u.slice(0,f));let _=-1,M=f,j=-1,F=!0,I=u.length-1,S=0;for(;I>=f;--I){if(T=u.charCodeAt(I),N(T)){if(!F){M=I+1;break}continue}j===-1&&(F=!1,j=I+1),T===d?_===-1?_=I:S!==1&&(S=1):_!==-1&&(S=-1)}return j!==-1&&(_===-1||S===0||S===1&&_===j-1&&_===M+1?r.base=r.name=u.slice(M,j):(r.name=u.slice(M,_),r.base=u.slice(M,j),r.ext=u.slice(_,j))),M>0&&M!==f?r.dir=u.slice(0,M-1):r.dir=r.root,r},sep:"\\",delimiter:";",win32:null,posix:null};const h=(()=>{if(b){const u=/\\/g;return()=>{const r=t.cwd().replace(u,"/");return r.slice(r.indexOf("/"))}}return()=>t.cwd()})();i.$jc={resolve(...u){let r="",o=!1;for(let f=u.length-1;f>=-1&&!o;f--){const T=f>=0?u[f]:h();e(T,"path"),T.length!==0&&(r=`${T}/${r}`,o=T.charCodeAt(0)===a)}return r=w(r,!o,"/",R),o?`/${r}`:r.length>0?r:"."},normalize(u){if(e(u,"path"),u.length===0)return".";const r=u.charCodeAt(0)===a,o=u.charCodeAt(u.length-1)===a;return u=w(u,!r,"/",R),u.length===0?r?"/":o?"./":".":(o&&(u+="/"),r?`/${u}`:u)},isAbsolute(u){return e(u,"path"),u.length>0&&u.charCodeAt(0)===a},join(...u){if(u.length===0)return".";let r;for(let o=0;o<u.length;++o){const f=u[o];e(f,"path"),f.length>0&&(r===void 0?r=f:r+=`/${f}`)}return r===void 0?".":i.$jc.normalize(r)},relative(u,r){if(e(u,"from"),e(r,"to"),u===r||(u=i.$jc.resolve(u),r=i.$jc.resolve(r),u===r))return"";const o=1,f=u.length,T=f-o,_=1,M=r.length-_,j=T<M?T:M;let F=-1,I=0;for(;I<j;I++){const D=u.charCodeAt(o+I);if(D!==r.charCodeAt(_+I))break;D===a&&(F=I)}if(I===j)if(M>j){if(r.charCodeAt(_+I)===a)return r.slice(_+I+1);if(I===0)return r.slice(_+I)}else T>j&&(u.charCodeAt(o+I)===a?F=I:I===0&&(F=0));let S="";for(I=o+F+1;I<=f;++I)(I===f||u.charCodeAt(I)===a)&&(S+=S.length===0?"..":"/..");return`${S}${r.slice(_+F)}`},toNamespacedPath(u){return u},dirname(u){if(e(u,"path"),u.length===0)return".";const r=u.charCodeAt(0)===a;let o=-1,f=!0;for(let T=u.length-1;T>=1;--T)if(u.charCodeAt(T)===a){if(!f){o=T;break}}else f=!1;return o===-1?r?"/":".":r&&o===1?"//":u.slice(0,o)},basename(u,r){r!==void 0&&e(r,"ext"),e(u,"path");let o=0,f=-1,T=!0,_;if(r!==void 0&&r.length>0&&r.length<=u.length){if(r===u)return"";let M=r.length-1,j=-1;for(_=u.length-1;_>=0;--_){const F=u.charCodeAt(_);if(F===a){if(!T){o=_+1;break}}else j===-1&&(T=!1,j=_+1),M>=0&&(F===r.charCodeAt(M)?--M===-1&&(f=_):(M=-1,f=j))}return o===f?f=j:f===-1&&(f=u.length),u.slice(o,f)}for(_=u.length-1;_>=0;--_)if(u.charCodeAt(_)===a){if(!T){o=_+1;break}}else f===-1&&(T=!1,f=_+1);return f===-1?"":u.slice(o,f)},extname(u){e(u,"path");let r=-1,o=0,f=-1,T=!0,_=0;for(let M=u.length-1;M>=0;--M){const j=u.charCodeAt(M);if(j===a){if(!T){o=M+1;break}continue}f===-1&&(T=!1,f=M+1),j===d?r===-1?r=M:_!==1&&(_=1):r!==-1&&(_=-1)}return r===-1||f===-1||_===0||_===1&&r===f-1&&r===o+1?"":u.slice(r,f)},format:v.bind(null,"/"),parse(u){e(u,"path");const r={root:"",dir:"",base:"",ext:"",name:""};if(u.length===0)return r;const o=u.charCodeAt(0)===a;let f;o?(r.root="/",f=1):f=0;let T=-1,_=0,M=-1,j=!0,F=u.length-1,I=0;for(;F>=f;--F){const S=u.charCodeAt(F);if(S===a){if(!j){_=F+1;break}continue}M===-1&&(j=!1,M=F+1),S===d?T===-1?T=F:I!==1&&(I=1):T!==-1&&(I=-1)}if(M!==-1){const S=_===0&&o?1:_;T===-1||I===0||I===1&&T===M-1&&T===_+1?r.base=r.name=u.slice(S,M):(r.name=u.slice(S,T),r.base=u.slice(S,M),r.ext=u.slice(T,M))}return _>0?r.dir=u.slice(0,_-1):o&&(r.dir="/"),r},sep:"/",delimiter:":",win32:null,posix:null},i.$jc.win32=i.$ic.win32=i.$ic,i.$jc.posix=i.$ic.posix=i.$jc,i.$kc=b?i.$ic.normalize:i.$jc.normalize,i.$lc=b?i.$ic.isAbsolute:i.$jc.isAbsolute,i.$mc=b?i.$ic.join:i.$jc.join,i.$nc=b?i.$ic.resolve:i.$jc.resolve,i.$oc=b?i.$ic.relative:i.$jc.relative,i.$pc=b?i.$ic.dirname:i.$jc.dirname,i.$qc=b?i.$ic.basename:i.$jc.basename,i.$rc=b?i.$ic.extname:i.$jc.extname,i.$sc=b?i.$ic.format:i.$jc.format,i.$tc=b?i.$ic.parse:i.$jc.parse,i.$uc=b?i.$ic.toNamespacedPath:i.$jc.toNamespacedPath,i.sep=b?i.$ic.sep:i.$jc.sep,i.$wc=b?i.$ic.delimiter:i.$jc.delimiter}),ne(ie[21],re([0,1,3,42,74,20]),function(x,i,t,n,p,g){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.URI=void 0,i.$yc=N,i.$zc=u,p=Ie(p);const E=/^\w[\w\d+.-]*$/,d=/^\//,a=/^\/\//;function l(_,M){if(!_.scheme&&M)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${_.authority}", path: "${_.path}", query: "${_.query}", fragment: "${_.fragment}"}`);if(_.scheme&&!E.test(_.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(_.path){if(_.authority){if(!d.test(_.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(a.test(_.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function c(_,M){return!_&&!M?"file":_}function $(_,M){switch(_){case"https":case"http":case"file":M?M[0]!==L&&(M=L+M):M=L;break}return M}const m="",L="/",e=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class b{static isUri(M){return M instanceof b?!0:M?typeof M.authority=="string"&&typeof M.fragment=="string"&&typeof M.path=="string"&&typeof M.query=="string"&&typeof M.scheme=="string"&&typeof M.fsPath=="string"&&typeof M.with=="function"&&typeof M.toString=="function":!1}constructor(M,j,F,I,S,D=!1){typeof M=="object"?(this.scheme=M.scheme||m,this.authority=M.authority||m,this.path=M.path||m,this.query=M.query||m,this.fragment=M.fragment||m):(this.scheme=c(M,D),this.authority=j||m,this.path=$(this.scheme,F||m),this.query=I||m,this.fragment=S||m,l(this,D))}get fsPath(){return u(this,!1)}with(M){if(!M)return this;let{scheme:j,authority:F,path:I,query:S,fragment:D}=M;return j===void 0?j=this.scheme:j===null&&(j=m),F===void 0?F=this.authority:F===null&&(F=m),I===void 0?I=this.path:I===null&&(I=m),S===void 0?S=this.query:S===null&&(S=m),D===void 0?D=this.fragment:D===null&&(D=m),j===this.scheme&&F===this.authority&&I===this.path&&S===this.query&&D===this.fragment?this:new A(j,F,I,S,D)}static parse(M,j=!1){const F=e.exec(M);return F?new A(F[2]||m,T(F[4]||m),T(F[5]||m),T(F[7]||m),T(F[9]||m),j):new A(m,m,m,m,m)}static file(M){let j=m;if(g.$i&&(M=M.replace(/\\/g,L)),M[0]===L&&M[1]===L){const F=M.indexOf(L,2);F===-1?(j=M.substring(2),M=L):(j=M.substring(2,F),M=M.substring(F)||L)}return new A("file",j,M,m,m)}static from(M,j){return new A(M.scheme,M.authority,M.path,M.query,M.fragment,j)}static joinPath(M,...j){if(!M.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let F;return g.$i&&M.scheme==="file"?F=b.file(p.$ic.join(u(M,!0),...j)).path:F=p.$jc.join(M.path,...j),M.with({path:F})}toString(M=!1){return r(this,M)}toJSON(){return this}static revive(M){if(M){if(M instanceof b)return M;{const j=new A(M);return j._formatted=M.external??null,j._fsPath=M._sep===R?M.fsPath??null:null,j}}else return M}}i.URI=b;function N(_){return!_||typeof _!="object"?!1:typeof _.scheme=="string"&&(typeof _.authority=="string"||typeof _.authority>"u")&&(typeof _.path=="string"||typeof _.path>"u")&&(typeof _.query=="string"||typeof _.query>"u")&&(typeof _.fragment=="string"||typeof _.fragment>"u")}const R=g.$i?1:void 0;class A extends b{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=u(this,!1)),this._fsPath}toString(M=!1){return M?r(this,!0):(this._formatted||(this._formatted=r(this,!1)),this._formatted)}toJSON(){const M={$mid:n.MarshalledId.Uri};return this._fsPath&&(M.fsPath=this._fsPath,M._sep=R),this._formatted&&(M.external=this._formatted),this.path&&(M.path=this.path),this.scheme&&(M.scheme=this.scheme),this.authority&&(M.authority=this.authority),this.query&&(M.query=this.query),this.fragment&&(M.fragment=this.fragment),M}}const w={[t.CharCode.Colon]:"%3A",[t.CharCode.Slash]:"%2F",[t.CharCode.QuestionMark]:"%3F",[t.CharCode.Hash]:"%23",[t.CharCode.OpenSquareBracket]:"%5B",[t.CharCode.CloseSquareBracket]:"%5D",[t.CharCode.AtSign]:"%40",[t.CharCode.ExclamationMark]:"%21",[t.CharCode.DollarSign]:"%24",[t.CharCode.Ampersand]:"%26",[t.CharCode.SingleQuote]:"%27",[t.CharCode.OpenParen]:"%28",[t.CharCode.CloseParen]:"%29",[t.CharCode.Asterisk]:"%2A",[t.CharCode.Plus]:"%2B",[t.CharCode.Comma]:"%2C",[t.CharCode.Semicolon]:"%3B",[t.CharCode.Equals]:"%3D",[t.CharCode.Space]:"%20"};function v(_,M,j){let F,I=-1;for(let S=0;S<_.length;S++){const D=_.charCodeAt(S);if(D>=t.CharCode.a&&D<=t.CharCode.z||D>=t.CharCode.A&&D<=t.CharCode.Z||D>=t.CharCode.Digit0&&D<=t.CharCode.Digit9||D===t.CharCode.Dash||D===t.CharCode.Period||D===t.CharCode.Underline||D===t.CharCode.Tilde||M&&D===t.CharCode.Slash||j&&D===t.CharCode.OpenSquareBracket||j&&D===t.CharCode.CloseSquareBracket||j&&D===t.CharCode.Colon)I!==-1&&(F+=encodeURIComponent(_.substring(I,S)),I=-1),F!==void 0&&(F+=_.charAt(S));else{F===void 0&&(F=_.substr(0,S));const q=w[D];q!==void 0?(I!==-1&&(F+=encodeURIComponent(_.substring(I,S)),I=-1),F+=q):I===-1&&(I=S)}}return I!==-1&&(F+=encodeURIComponent(_.substring(I))),F!==void 0?F:_}function h(_){let M;for(let j=0;j<_.length;j++){const F=_.charCodeAt(j);F===t.CharCode.Hash||F===t.CharCode.QuestionMark?(M===void 0&&(M=_.substr(0,j)),M+=w[F]):M!==void 0&&(M+=_[j])}return M!==void 0?M:_}function u(_,M){let j;return _.authority&&_.path.length>1&&_.scheme==="file"?j=`//${_.authority}${_.path}`:_.path.charCodeAt(0)===t.CharCode.Slash&&(_.path.charCodeAt(1)>=t.CharCode.A&&_.path.charCodeAt(1)<=t.CharCode.Z||_.path.charCodeAt(1)>=t.CharCode.a&&_.path.charCodeAt(1)<=t.CharCode.z)&&_.path.charCodeAt(2)===t.CharCode.Colon?M?j=_.path.substr(1):j=_.path[1].toLowerCase()+_.path.substr(2):j=_.path,g.$i&&(j=j.replace(/\//g,"\\")),j}function r(_,M){const j=M?h:v;let F="",{scheme:I,authority:S,path:D,query:q,fragment:X}=_;if(I&&(F+=I,F+=":"),(S||I==="file")&&(F+=L,F+=L),S){let B=S.indexOf("@");if(B!==-1){const y=S.substr(0,B);S=S.substr(B+1),B=y.lastIndexOf(":"),B===-1?F+=j(y,!1,!1):(F+=j(y.substr(0,B),!1,!1),F+=":",F+=j(y.substr(B+1),!1,!0)),F+="@"}S=S.toLowerCase(),B=S.lastIndexOf(":"),B===-1?F+=j(S,!1,!0):(F+=j(S.substr(0,B),!1,!0),F+=S.substr(B))}if(D){if(D.length>=3&&D.charCodeAt(0)===t.CharCode.Slash&&D.charCodeAt(2)===t.CharCode.Colon){const B=D.charCodeAt(1);B>=t.CharCode.A&&B<=t.CharCode.Z&&(D=`/${String.fromCharCode(B+32)}:${D.substr(3)}`)}else if(D.length>=2&&D.charCodeAt(1)===t.CharCode.Colon){const B=D.charCodeAt(0);B>=t.CharCode.A&&B<=t.CharCode.Z&&(D=`${String.fromCharCode(B+32)}:${D.substr(2)}`)}F+=j(D,!0,!1)}return q&&(F+="?",F+=j(q,!1,!1)),X&&(F+="#",F+=M?X:v(X,!1,!1)),F}function o(_){try{return decodeURIComponent(_)}catch{return _.length>3?_.substr(0,3)+o(_.substr(3)):_}}const f=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function T(_){return _.match(f)?_.replace(f,M=>o(M)):_}}),ne(ie[79],re([0,1,4,13,12,17,20,8]),function(x,i,t,n,p,g,E,d){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.SimpleWorkerServer=i.SimpleWorkerClient=void 0,i.logOnceWebWorkerWarning=c,i.create=r,d=Ie(d);const a="$initialize";let l=!1;function c(o){E.$o&&(l||(l=!0,console.warn("Could not create web worker(s). Falling back to loading web worker code in main thread, which might cause UI freezes. Please see https://github.com/microsoft/monaco-editor#faq")),console.warn(o.message))}var $;(function(o){o[o.Request=0]="Request",o[o.Reply=1]="Reply",o[o.SubscribeEvent=2]="SubscribeEvent",o[o.Event=3]="Event",o[o.UnsubscribeEvent=4]="UnsubscribeEvent"})($||($={}));class m{constructor(f,T,_,M){this.vsWorker=f,this.req=T,this.method=_,this.args=M,this.type=$.Request}}class L{constructor(f,T,_,M){this.vsWorker=f,this.seq=T,this.res=_,this.err=M,this.type=$.Reply}}class e{constructor(f,T,_,M){this.vsWorker=f,this.req=T,this.eventName=_,this.arg=M,this.type=$.SubscribeEvent}}class b{constructor(f,T,_){this.vsWorker=f,this.req=T,this.event=_,this.type=$.Event}}class N{constructor(f,T){this.vsWorker=f,this.req=T,this.type=$.UnsubscribeEvent}}class R{constructor(f){this.a=-1,this.g=f,this.b=0,this.c=Object.create(null),this.d=new Map,this.f=new Map}setWorkerId(f){this.a=f}sendMessage(f,T){const _=String(++this.b);return new Promise((M,j)=>{this.c[_]={resolve:M,reject:j},this.o(new m(this.a,_,f,T))})}listen(f,T){let _=null;const M=new n.$ne({onWillAddFirstListener:()=>{_=String(++this.b),this.d.set(_,M),this.o(new e(this.a,_,f,T))},onDidRemoveLastListener:()=>{this.d.delete(_),this.o(new N(this.a,_)),_=null}});return M.event}handleMessage(f){!f||!f.vsWorker||this.a!==-1&&f.vsWorker!==this.a||this.h(f)}h(f){switch(f.type){case $.Reply:return this.j(f);case $.Request:return this.k(f);case $.SubscribeEvent:return this.l(f);case $.Event:return this.m(f);case $.UnsubscribeEvent:return this.n(f)}}j(f){if(!this.c[f.seq]){console.warn("Got reply to unknown seq");return}const T=this.c[f.seq];if(delete this.c[f.seq],f.err){let _=f.err;f.err.$isError&&(_=new Error,_.name=f.err.name,_.message=f.err.message,_.stack=f.err.stack),T.reject(_);return}T.resolve(f.res)}k(f){const T=f.req;this.g.handleMessage(f.method,f.args).then(M=>{this.o(new L(this.a,T,M,void 0))},M=>{M.detail instanceof Error&&(M.detail=(0,t.$5)(M.detail)),this.o(new L(this.a,T,void 0,(0,t.$5)(M)))})}l(f){const T=f.req,_=this.g.handleEvent(f.eventName,f.arg)(M=>{this.o(new b(this.a,T,M))});this.f.set(T,_)}m(f){if(!this.d.has(f.req)){console.warn("Got event for unknown req");return}this.d.get(f.req).fire(f.event)}n(f){if(!this.f.has(f.req)){console.warn("Got unsubscribe for unknown req");return}this.f.get(f.req).dispose(),this.f.delete(f.req)}o(f){const T=[];if(f.type===$.Request)for(let _=0;_<f.args.length;_++)f.args[_]instanceof ArrayBuffer&&T.push(f.args[_]);else f.type===$.Reply&&f.res instanceof ArrayBuffer&&T.push(f.res);this.g.sendMessage(f,T)}}class A extends p.$Xc{constructor(f,T,_){super();let M=null;this.a=this.B(f.create("vs/base/common/worker/simpleWorker",q=>{this.c.handleMessage(q)},q=>{M?.(q)})),this.c=new R({sendMessage:(q,X)=>{this.a.postMessage(q,X)},handleMessage:(q,X)=>{if(typeof _[q]!="function")return Promise.reject(new Error("Missing method "+q+" on main thread host."));try{return Promise.resolve(_[q].apply(_,X))}catch(B){return Promise.reject(B)}},handleEvent:(q,X)=>{if(v(q)){const B=_[q].call(_,X);if(typeof B!="function")throw new Error(`Missing dynamic event ${q} on main thread host.`);return B}if(w(q)){const B=_[q];if(typeof B!="function")throw new Error(`Missing event ${q} on main thread host.`);return B}throw new Error(`Malformed event name ${q}`)}}),this.c.setWorkerId(this.a.getId());let j=null;const F=globalThis.require;typeof F<"u"&&typeof F.getConfig=="function"?j=F.getConfig():typeof globalThis.requirejs<"u"&&(j=globalThis.requirejs.s.contexts._.config);const I=(0,g.$oo)(_);this.b=this.c.sendMessage(a,[this.a.getId(),JSON.parse(JSON.stringify(j)),T,I]);const S=(q,X)=>this.g(q,X),D=(q,X)=>this.c.listen(q,X);this.f=new Promise((q,X)=>{M=X,this.b.then(B=>{q(h(B,S,D))},B=>{X(B),this.h("Worker failed to load "+T,B)})})}getProxyObject(){return this.f}g(f,T){return new Promise((_,M)=>{this.b.then(()=>{this.c.sendMessage(f,T).then(_,M)},M)})}h(f,T){console.error(f),console.info(T)}}i.SimpleWorkerClient=A;function w(o){return o[0]==="o"&&o[1]==="n"&&d.$Gf(o.charCodeAt(2))}function v(o){return/^onDynamic/.test(o)&&d.$Gf(o.charCodeAt(9))}function h(o,f,T){const _=F=>function(){const I=Array.prototype.slice.call(arguments,0);return f(F,I)},M=F=>function(I){return T(F,I)},j={};for(const F of o){if(v(F)){j[F]=M(F);continue}if(w(F)){j[F]=T(F,void 0);continue}j[F]=_(F)}return j}class u{constructor(f,T){this.a=T,this.b=null,this.c=new R({sendMessage:(_,M)=>{f(_,M)},handleMessage:(_,M)=>this.d(_,M),handleEvent:(_,M)=>this.f(_,M)})}onmessage(f){this.c.handleMessage(f)}d(f,T){if(f===a)return this.g(T[0],T[1],T[2],T[3]);if(!this.b||typeof this.b[f]!="function")return Promise.reject(new Error("Missing requestHandler or method: "+f));try{return Promise.resolve(this.b[f].apply(this.b,T))}catch(_){return Promise.reject(_)}}f(f,T){if(!this.b)throw new Error("Missing requestHandler");if(v(f)){const _=this.b[f].call(this.b,T);if(typeof _!="function")throw new Error(`Missing dynamic event ${f} on request handler.`);return _}if(w(f)){const _=this.b[f];if(typeof _!="function")throw new Error(`Missing event ${f} on request handler.`);return _}throw new Error(`Malformed event name ${f}`)}g(f,T,_,M){this.c.setWorkerId(f);const I=h(M,(S,D)=>this.c.sendMessage(S,D),(S,D)=>this.c.listen(S,D));return this.a?(this.b=this.a(I),Promise.resolve((0,g.$oo)(this.b))):(T&&(typeof T.baseUrl<"u"&&delete T.baseUrl,typeof T.paths<"u"&&typeof T.paths.vs<"u"&&delete T.paths.vs,typeof T.trustedTypesPolicy<"u"&&delete T.trustedTypesPolicy,T.catchError=!0,globalThis.require.config(T)),new Promise((S,D)=>{(globalThis.require||x)([_],X=>{if(this.b=X.create(I),!this.b){D(new Error("No RequestHandler!"));return}S((0,g.$oo)(this.b))},D)}))}}i.SimpleWorkerServer=u;function r(o){return new u(o,null)}}),ne(ie[75],re([71,72]),function(x,i){return x.create("vs/editor/common/languages",i)}),ne(ie[76],re([0,1,45,21,47,2,69,75]),function(x,i,t,n,p,g,E,d){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.InlineEditTriggerKind=i.ExternalUriOpenerPriority=i.$Ou=i.$Nu=i.InlayHintKind=i.CommentState=i.CommentMode=i.CommentThreadApplicability=i.CommentThreadState=i.CommentThreadCollapsibleState=i.Command=i.NewSymbolNameTriggerKind=i.NewSymbolNameTag=i.$Mu=i.$Lu=i.SymbolKinds=i.SymbolTag=i.$Ju=i.SymbolKind=i.DocumentHighlightKind=i.SignatureHelpTriggerKind=i.DocumentPasteTriggerKind=i.CodeActionTriggerType=i.$Hu=i.InlineCompletionTriggerKind=i.CompletionTriggerKind=i.PartialAcceptTriggerKind=i.CompletionItemInsertTextRule=i.CompletionItemTag=i.CompletionItemKinds=i.CompletionItemKind=i.HoverVerbosityAction=i.$Gu=i.$Fu=i.$Eu=void 0,i.$Iu=o,i.$Ku=T;class a{constructor(z,fe,oe){this.offset=z,this.type=fe,this.language=oe,this._tokenBrand=void 0}toString(){return"("+this.offset+", "+this.type+")"}}i.$Eu=a;class l{constructor(z,fe){this.tokens=z,this.endState=fe,this._tokenizationResultBrand=void 0}}i.$Fu=l;class c{constructor(z,fe){this.tokens=z,this.endState=fe,this._encodedTokenizationResultBrand=void 0}}i.$Gu=c;var $;(function(k){k[k.Increase=0]="Increase",k[k.Decrease=1]="Decrease"})($||(i.HoverVerbosityAction=$={}));var m;(function(k){k[k.Method=0]="Method",k[k.Function=1]="Function",k[k.Constructor=2]="Constructor",k[k.Field=3]="Field",k[k.Variable=4]="Variable",k[k.Class=5]="Class",k[k.Struct=6]="Struct",k[k.Interface=7]="Interface",k[k.Module=8]="Module",k[k.Property=9]="Property",k[k.Event=10]="Event",k[k.Operator=11]="Operator",k[k.Unit=12]="Unit",k[k.Value=13]="Value",k[k.Constant=14]="Constant",k[k.Enum=15]="Enum",k[k.EnumMember=16]="EnumMember",k[k.Keyword=17]="Keyword",k[k.Text=18]="Text",k[k.Color=19]="Color",k[k.File=20]="File",k[k.Reference=21]="Reference",k[k.Customcolor=22]="Customcolor",k[k.Folder=23]="Folder",k[k.TypeParameter=24]="TypeParameter",k[k.User=25]="User",k[k.Issue=26]="Issue",k[k.Snippet=27]="Snippet"})(m||(i.CompletionItemKind=m={}));var L;(function(k){const z=new Map;z.set(m.Method,t.$6j.symbolMethod),z.set(m.Function,t.$6j.symbolFunction),z.set(m.Constructor,t.$6j.symbolConstructor),z.set(m.Field,t.$6j.symbolField),z.set(m.Variable,t.$6j.symbolVariable),z.set(m.Class,t.$6j.symbolClass),z.set(m.Struct,t.$6j.symbolStruct),z.set(m.Interface,t.$6j.symbolInterface),z.set(m.Module,t.$6j.symbolModule),z.set(m.Property,t.$6j.symbolProperty),z.set(m.Event,t.$6j.symbolEvent),z.set(m.Operator,t.$6j.symbolOperator),z.set(m.Unit,t.$6j.symbolUnit),z.set(m.Value,t.$6j.symbolValue),z.set(m.Enum,t.$6j.symbolEnum),z.set(m.Constant,t.$6j.symbolConstant),z.set(m.Enum,t.$6j.symbolEnum),z.set(m.EnumMember,t.$6j.symbolEnumMember),z.set(m.Keyword,t.$6j.symbolKeyword),z.set(m.Snippet,t.$6j.symbolSnippet),z.set(m.Text,t.$6j.symbolText),z.set(m.Color,t.$6j.symbolColor),z.set(m.File,t.$6j.symbolFile),z.set(m.Reference,t.$6j.symbolReference),z.set(m.Customcolor,t.$6j.symbolCustomColor),z.set(m.Folder,t.$6j.symbolFolder),z.set(m.TypeParameter,t.$6j.symbolTypeParameter),z.set(m.User,t.$6j.account),z.set(m.Issue,t.$6j.issues);function fe(s){let Te=z.get(s);return Te||(console.info("No codicon found for CompletionItemKind "+s),Te=t.$6j.symbolProperty),Te}k.toIcon=fe;const oe=new Map;oe.set("method",m.Method),oe.set("function",m.Function),oe.set("constructor",m.Constructor),oe.set("field",m.Field),oe.set("variable",m.Variable),oe.set("class",m.Class),oe.set("struct",m.Struct),oe.set("interface",m.Interface),oe.set("module",m.Module),oe.set("property",m.Property),oe.set("event",m.Event),oe.set("operator",m.Operator),oe.set("unit",m.Unit),oe.set("value",m.Value),oe.set("constant",m.Constant),oe.set("enum",m.Enum),oe.set("enum-member",m.EnumMember),oe.set("enumMember",m.EnumMember),oe.set("keyword",m.Keyword),oe.set("snippet",m.Snippet),oe.set("text",m.Text),oe.set("color",m.Color),oe.set("file",m.File),oe.set("reference",m.Reference),oe.set("customcolor",m.Customcolor),oe.set("folder",m.Folder),oe.set("type-parameter",m.TypeParameter),oe.set("typeParameter",m.TypeParameter),oe.set("account",m.User),oe.set("issue",m.Issue);function we(s,Te){let Pe=oe.get(s);return typeof Pe>"u"&&!Te&&(Pe=m.Property),Pe}k.fromString=we})(L||(i.CompletionItemKinds=L={}));var e;(function(k){k[k.Deprecated=1]="Deprecated"})(e||(i.CompletionItemTag=e={}));var b;(function(k){k[k.None=0]="None",k[k.KeepWhitespace=1]="KeepWhitespace",k[k.InsertAsSnippet=4]="InsertAsSnippet"})(b||(i.CompletionItemInsertTextRule=b={}));var N;(function(k){k[k.Word=0]="Word",k[k.Line=1]="Line",k[k.Suggest=2]="Suggest"})(N||(i.PartialAcceptTriggerKind=N={}));var R;(function(k){k[k.Invoke=0]="Invoke",k[k.TriggerCharacter=1]="TriggerCharacter",k[k.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(R||(i.CompletionTriggerKind=R={}));var A;(function(k){k[k.Automatic=0]="Automatic",k[k.Explicit=1]="Explicit"})(A||(i.InlineCompletionTriggerKind=A={}));class w{constructor(z,fe,oe,we){this.range=z,this.text=fe,this.completionKind=oe,this.isSnippetText=we}equals(z){return g.$Mt.lift(this.range).equalsRange(z.range)&&this.text===z.text&&this.completionKind===z.completionKind&&this.isSnippetText===z.isSnippetText}}i.$Hu=w;var v;(function(k){k[k.Invoke=1]="Invoke",k[k.Auto=2]="Auto"})(v||(i.CodeActionTriggerType=v={}));var h;(function(k){k[k.Automatic=0]="Automatic",k[k.PasteAs=1]="PasteAs"})(h||(i.DocumentPasteTriggerKind=h={}));var u;(function(k){k[k.Invoke=1]="Invoke",k[k.TriggerCharacter=2]="TriggerCharacter",k[k.ContentChange=3]="ContentChange"})(u||(i.SignatureHelpTriggerKind=u={}));var r;(function(k){k[k.Text=0]="Text",k[k.Read=1]="Read",k[k.Write=2]="Write"})(r||(i.DocumentHighlightKind=r={}));function o(k){return k&&n.URI.isUri(k.uri)&&g.$Mt.isIRange(k.range)&&(g.$Mt.isIRange(k.originSelectionRange)||g.$Mt.isIRange(k.targetSelectionRange))}var f;(function(k){k[k.File=0]="File",k[k.Module=1]="Module",k[k.Namespace=2]="Namespace",k[k.Package=3]="Package",k[k.Class=4]="Class",k[k.Method=5]="Method",k[k.Property=6]="Property",k[k.Field=7]="Field",k[k.Constructor=8]="Constructor",k[k.Enum=9]="Enum",k[k.Interface=10]="Interface",k[k.Function=11]="Function",k[k.Variable=12]="Variable",k[k.Constant=13]="Constant",k[k.String=14]="String",k[k.Number=15]="Number",k[k.Boolean=16]="Boolean",k[k.Array=17]="Array",k[k.Object=18]="Object",k[k.Key=19]="Key",k[k.Null=20]="Null",k[k.EnumMember=21]="EnumMember",k[k.Struct=22]="Struct",k[k.Event=23]="Event",k[k.Operator=24]="Operator",k[k.TypeParameter=25]="TypeParameter"})(f||(i.SymbolKind=f={})),i.$Ju={[f.Array]:(0,d.localize)(0,null),[f.Boolean]:(0,d.localize)(1,null),[f.Class]:(0,d.localize)(2,null),[f.Constant]:(0,d.localize)(3,null),[f.Constructor]:(0,d.localize)(4,null),[f.Enum]:(0,d.localize)(5,null),[f.EnumMember]:(0,d.localize)(6,null),[f.Event]:(0,d.localize)(7,null),[f.Field]:(0,d.localize)(8,null),[f.File]:(0,d.localize)(9,null),[f.Function]:(0,d.localize)(10,null),[f.Interface]:(0,d.localize)(11,null),[f.Key]:(0,d.localize)(12,null),[f.Method]:(0,d.localize)(13,null),[f.Module]:(0,d.localize)(14,null),[f.Namespace]:(0,d.localize)(15,null),[f.Null]:(0,d.localize)(16,null),[f.Number]:(0,d.localize)(17,null),[f.Object]:(0,d.localize)(18,null),[f.Operator]:(0,d.localize)(19,null),[f.Package]:(0,d.localize)(20,null),[f.Property]:(0,d.localize)(21,null),[f.String]:(0,d.localize)(22,null),[f.Struct]:(0,d.localize)(23,null),[f.TypeParameter]:(0,d.localize)(24,null),[f.Variable]:(0,d.localize)(25,null)};function T(k,z){return(0,d.localize)(26,null,k,i.$Ju[z])}var _;(function(k){k[k.Deprecated=1]="Deprecated"})(_||(i.SymbolTag=_={}));var M;(function(k){const z=new Map;z.set(f.File,t.$6j.symbolFile),z.set(f.Module,t.$6j.symbolModule),z.set(f.Namespace,t.$6j.symbolNamespace),z.set(f.Package,t.$6j.symbolPackage),z.set(f.Class,t.$6j.symbolClass),z.set(f.Method,t.$6j.symbolMethod),z.set(f.Property,t.$6j.symbolProperty),z.set(f.Field,t.$6j.symbolField),z.set(f.Constructor,t.$6j.symbolConstructor),z.set(f.Enum,t.$6j.symbolEnum),z.set(f.Interface,t.$6j.symbolInterface),z.set(f.Function,t.$6j.symbolFunction),z.set(f.Variable,t.$6j.symbolVariable),z.set(f.Constant,t.$6j.symbolConstant),z.set(f.String,t.$6j.symbolString),z.set(f.Number,t.$6j.symbolNumber),z.set(f.Boolean,t.$6j.symbolBoolean),z.set(f.Array,t.$6j.symbolArray),z.set(f.Object,t.$6j.symbolObject),z.set(f.Key,t.$6j.symbolKey),z.set(f.Null,t.$6j.symbolNull),z.set(f.EnumMember,t.$6j.symbolEnumMember),z.set(f.Struct,t.$6j.symbolStruct),z.set(f.Event,t.$6j.symbolEvent),z.set(f.Operator,t.$6j.symbolOperator),z.set(f.TypeParameter,t.$6j.symbolTypeParameter);function fe(oe){let we=z.get(oe);return we||(console.info("No codicon found for SymbolKind "+oe),we=t.$6j.symbolProperty),we}k.toIcon=fe})(M||(i.SymbolKinds=M={}));class j{static asEditOperation(z){return p.$Nt.replace(g.$Mt.lift(z.range),z.text)}}i.$Lu=j;class F{static{this.Comment=new F("comment")}static{this.Imports=new F("imports")}static{this.Region=new F("region")}static fromValue(z){switch(z){case"comment":return F.Comment;case"imports":return F.Imports;case"region":return F.Region}return new F(z)}constructor(z){this.value=z}}i.$Mu=F;var I;(function(k){k[k.AIGenerated=1]="AIGenerated"})(I||(i.NewSymbolNameTag=I={}));var S;(function(k){k[k.Invoke=0]="Invoke",k[k.Automatic=1]="Automatic"})(S||(i.NewSymbolNameTriggerKind=S={}));var D;(function(k){function z(fe){return!fe||typeof fe!="object"?!1:typeof fe.id=="string"&&typeof fe.title=="string"}k.is=z})(D||(i.Command=D={}));var q;(function(k){k[k.Collapsed=0]="Collapsed",k[k.Expanded=1]="Expanded"})(q||(i.CommentThreadCollapsibleState=q={}));var X;(function(k){k[k.Unresolved=0]="Unresolved",k[k.Resolved=1]="Resolved"})(X||(i.CommentThreadState=X={}));var B;(function(k){k[k.Current=0]="Current",k[k.Outdated=1]="Outdated"})(B||(i.CommentThreadApplicability=B={}));var y;(function(k){k[k.Editing=0]="Editing",k[k.Preview=1]="Preview"})(y||(i.CommentMode=y={}));var Y;(function(k){k[k.Published=0]="Published",k[k.Draft=1]="Draft"})(Y||(i.CommentState=Y={}));var Z;(function(k){k[k.Type=1]="Type",k[k.Parameter=2]="Parameter"})(Z||(i.InlayHintKind=Z={}));class H{constructor(z){this.b=z,this.a=null}dispose(){this.a&&this.a.then(z=>{z&&z.dispose()})}get tokenizationSupport(){return this.a||(this.a=this.b()),this.a}}i.$Nu=H,i.$Ou=new E.$vu;var Q;(function(k){k[k.None=0]="None",k[k.Option=1]="Option",k[k.Default=2]="Default",k[k.Preferred=3]="Preferred"})(Q||(i.ExternalUriOpenerPriority=Q={}));var C;(function(k){k[k.Invoke=0]="Invoke",k[k.Automatic=1]="Automatic"})(C||(i.InlineEditTriggerKind=C={}))}),ne(ie[77],re([0,1,26,13,40,21,5,2,48,76,68]),function(x,i,t,n,p,g,E,d,a,l,c){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.$t4=void 0,i.$u4=m,c=Ie(c);class ${static{this.CtrlCmd=p.KeyMod.CtrlCmd}static{this.Shift=p.KeyMod.Shift}static{this.Alt=p.KeyMod.Alt}static{this.WinCtrl=p.KeyMod.WinCtrl}static chord(e,b){return(0,p.$Wr)(e,b)}}i.$t4=$;function m(){return{editor:void 0,languages:void 0,CancellationTokenSource:t.$ye,Emitter:n.$ne,KeyCode:c.KeyCode,KeyMod:$,Position:E.$Lt,Range:d.$Mt,Selection:a.$Ot,SelectionDirection:c.SelectionDirection,MarkerSeverity:c.MarkerSeverity,MarkerTag:c.MarkerTag,Uri:g.URI,Token:l.$Eu}}}),ne(ie[80],re([0,1,29,21,5,2,64,32,60,61,77,25,67,36,57,17,4,59,66]),function(x,i,t,n,p,g,E,d,a,l,c,$,m,L,e,b,N,R,A){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.EditorSimpleWorker=void 0,i.create=h;class w extends E.$mw{get uri(){return this.d}get eol(){return this.g}getValue(){return this.getText()}findMatches(r){const o=[];for(let f=0;f<this.f.length;f++){const T=this.f[f],_=this.offsetAt(new p.$Lt(f+1,1)),M=T.matchAll(r);for(const j of M)(j.index||j.index===0)&&(j.index=j.index+_),o.push(j)}return o}getLinesContent(){return this.f.slice(0)}getLineCount(){return this.f.length}getLineContent(r){return this.f[r-1]}getWordAtPosition(r,o){const f=(0,d.$ot)(r.column,(0,d.$mt)(o),this.f[r.lineNumber-1],0);return f?new g.$Mt(r.lineNumber,f.startColumn,r.lineNumber,f.endColumn):null}getWordUntilPosition(r,o){const f=this.getWordAtPosition(r,o);return f?{word:this.f[r.lineNumber-1].substring(f.startColumn-1,r.column-1),startColumn:f.startColumn,endColumn:r.column}:{word:"",startColumn:r.column,endColumn:r.column}}words(r){const o=this.f,f=this.q.bind(this);let T=0,_="",M=0,j=[];return{*[Symbol.iterator](){for(;;)if(M<j.length){const F=_.substring(j[M].start,j[M].end);M+=1,yield F}else if(T<o.length)_=o[T],j=f(_,r),M=0,T+=1;else break}}}getLineWords(r,o){const f=this.f[r-1],T=this.q(f,o),_=[];for(const M of T)_.push({word:f.substring(M.start,M.end),startColumn:M.start+1,endColumn:M.end+1});return _}q(r,o){const f=[];let T;for(o.lastIndex=0;(T=o.exec(r))&&T[0].length!==0;)f.push({start:T.index,end:T.index+T[0].length});return f}getValueInRange(r){if(r=this.r(r),r.startLineNumber===r.endLineNumber)return this.f[r.startLineNumber-1].substring(r.startColumn-1,r.endColumn-1);const o=this.g,f=r.startLineNumber-1,T=r.endLineNumber-1,_=[];_.push(this.f[f].substring(r.startColumn-1));for(let M=f+1;M<T;M++)_.push(this.f[M]);return _.push(this.f[T].substring(0,r.endColumn-1)),_.join(o)}offsetAt(r){return r=this.s(r),this.l(),this.j.getPrefixSum(r.lineNumber-2)+(r.column-1)}positionAt(r){r=Math.floor(r),r=Math.max(0,r),this.l();const o=this.j.getIndexOf(r),f=this.f[o.index].length;return{lineNumber:1+o.index,column:1+Math.min(o.remainder,f)}}r(r){const o=this.s({lineNumber:r.startLineNumber,column:r.startColumn}),f=this.s({lineNumber:r.endLineNumber,column:r.endColumn});return o.lineNumber!==r.startLineNumber||o.column!==r.startColumn||f.lineNumber!==r.endLineNumber||f.column!==r.endColumn?{startLineNumber:o.lineNumber,startColumn:o.column,endLineNumber:f.lineNumber,endColumn:f.column}:r}s(r){if(!p.$Lt.isIPosition(r))throw new Error("bad position");let{lineNumber:o,column:f}=r,T=!1;if(o<1)o=1,f=1,T=!0;else if(o>this.f.length)o=this.f.length,f=this.f[o-1].length+1,T=!0;else{const _=this.f[o-1].length+1;f<1?(f=1,T=!0):f>_&&(f=_,T=!0)}return T?{lineNumber:o,column:f}:r}}class v{constructor(r,o){this.d=r,this.f=Object.create(null),this.g=o,this.h=null}dispose(){this.f=Object.create(null)}j(r){return this.f[r]}k(){const r=[];return Object.keys(this.f).forEach(o=>r.push(this.f[o])),r}acceptNewModel(r){this.f[r.url]=new w(n.URI.parse(r.url),r.lines,r.EOL,r.versionId)}acceptModelChanged(r,o){if(!this.f[r])return;this.f[r].onEvents(o)}acceptRemovedModel(r){this.f[r]&&delete this.f[r]}async computeUnicodeHighlights(r,o,f){const T=this.j(r);return T?m.$o4.computeUnicodeHighlights(T,o,f):{ranges:[],hasMore:!1,ambiguousCharacterCount:0,invisibleCharacterCount:0,nonBasicAsciiCharacterCount:0}}async findSectionHeaders(r,o){const f=this.j(r);return f?(0,A.$S4)(f,o):[]}async computeDiff(r,o,f,T){const _=this.j(r),M=this.j(o);return!_||!M?null:v.l(_,M,f,T)}static l(r,o,f,T){const _=T==="advanced"?e.$Q4.getDefault():e.$Q4.getLegacy(),M=r.getLinesContent(),j=o.getLinesContent(),F=_.computeDiff(M,j,f),I=F.changes.length>0?!1:this.n(r,o);function S(D){return D.map(q=>[q.original.startLineNumber,q.original.endLineNumberExclusive,q.modified.startLineNumber,q.modified.endLineNumberExclusive,q.innerChanges?.map(X=>[X.originalRange.startLineNumber,X.originalRange.startColumn,X.originalRange.endLineNumber,X.originalRange.endColumn,X.modifiedRange.startLineNumber,X.modifiedRange.startColumn,X.modifiedRange.endLineNumber,X.modifiedRange.endColumn])])}return{identical:I,quitEarly:F.hitTimeout,changes:S(F.changes),moves:F.moves.map(D=>[D.lineRangeMapping.original.startLineNumber,D.lineRangeMapping.original.endLineNumberExclusive,D.lineRangeMapping.modified.startLineNumber,D.lineRangeMapping.modified.endLineNumberExclusive,S(D.changes)])}}static n(r,o){const f=r.getLineCount(),T=o.getLineCount();if(f!==T)return!1;for(let _=1;_<=f;_++){const M=r.getLineContent(_),j=o.getLineContent(_);if(M!==j)return!1}return!0}async computeDirtyDiff(r,o,f){const T=this.j(r),_=this.j(o);if(!T||!_)return null;const M=T.getLinesContent(),j=_.getLinesContent();return new L.$$t(M,j,{shouldComputeCharChanges:!1,shouldPostProcessCharChanges:!1,shouldIgnoreTrimWhitespace:f,shouldMakePrettyDiff:!0,maxComputationTime:1e3}).computeDiff().changes}static{this.o=1e5}async computeMoreMinimalEdits(r,o,f){const T=this.j(r);if(!T)return o;const _=[];let M;o=o.slice(0).sort((F,I)=>{if(F.range&&I.range)return g.$Mt.compareRangesUsingStarts(F.range,I.range);const S=F.range?0:1,D=I.range?0:1;return S-D});let j=0;for(let F=1;F<o.length;F++)g.$Mt.getEndPosition(o[j].range).equals(g.$Mt.getStartPosition(o[F].range))?(o[j].range=g.$Mt.fromPositions(g.$Mt.getStartPosition(o[j].range),g.$Mt.getEndPosition(o[F].range)),o[j].text+=o[F].text):(j++,o[j]=o[F]);o.length=j+1;for(let{range:F,text:I,eol:S}of o){if(typeof S=="number"&&(M=S),g.$Mt.isEmpty(F)&&!I)continue;const D=T.getValueInRange(F);if(I=I.replace(/\r\n|\n|\r/g,T.eol),D===I)continue;if(Math.max(I.length,D.length)>v.o){_.push({range:F,text:I});continue}const q=(0,t.$Rt)(D,I,f),X=T.offsetAt(g.$Mt.lift(F).getStartPosition());for(const B of q){const y=T.positionAt(X+B.originalStart),Y=T.positionAt(X+B.originalStart+B.originalLength),Z={text:I.substr(B.modifiedStart,B.modifiedLength),range:{startLineNumber:y.lineNumber,startColumn:y.column,endLineNumber:Y.lineNumber,endColumn:Y.column}};T.getValueInRange(Z.range)!==Z.text&&_.push(Z)}}return typeof M=="number"&&_.push({eol:M,text:"",range:{startLineNumber:0,startColumn:0,endLineNumber:0,endColumn:0}}),_}computeHumanReadableDiff(r,o,f){const T=this.j(r);if(!T)return o;const _=[];let M;o=o.slice(0).sort((j,F)=>{if(j.range&&F.range)return g.$Mt.compareRangesUsingStarts(j.range,F.range);const I=j.range?0:1,S=F.range?0:1;return I-S});for(let{range:j,text:F,eol:I}of o){let y=function(Z,H){return new p.$Lt(Z.lineNumber+H.lineNumber-1,H.lineNumber===1?Z.column+H.column-1:H.column)},Y=function(Z,H){const Q=[];for(let C=H.startLineNumber;C<=H.endLineNumber;C++){const k=Z[C-1];C===H.startLineNumber&&C===H.endLineNumber?Q.push(k.substring(H.startColumn-1,H.endColumn-1)):C===H.startLineNumber?Q.push(k.substring(H.startColumn-1)):C===H.endLineNumber?Q.push(k.substring(0,H.endColumn-1)):Q.push(k)}return Q};if(typeof I=="number"&&(M=I),g.$Mt.isEmpty(j)&&!F)continue;const S=T.getValueInRange(j);if(F=F.replace(/\r\n|\n|\r/g,T.eol),S===F)continue;if(Math.max(F.length,S.length)>v.o){_.push({range:j,text:F});continue}const D=S.split(/\r\n|\n|\r/),q=F.split(/\r\n|\n|\r/),X=e.$Q4.getDefault().computeDiff(D,q,f),B=g.$Mt.lift(j).getStartPosition();for(const Z of X.changes)if(Z.innerChanges)for(const H of Z.innerChanges)_.push({range:g.$Mt.fromPositions(y(B,H.originalRange.getStartPosition()),y(B,H.originalRange.getEndPosition())),text:Y(q,H.modifiedRange).join(T.eol)});else throw new N.$fb("The experimental diff algorithm always produces inner changes")}return typeof M=="number"&&_.push({eol:M,text:"",range:{startLineNumber:0,startColumn:0,endLineNumber:0,endColumn:0}}),_}async computeLinks(r){const o=this.j(r);return o?(0,a.$r4)(o):null}async computeDefaultDocumentColors(r){const o=this.j(r);return o?(0,R.$R4)(o):null}static{this.p=1e4}async textualSuggest(r,o,f,T){const _=new $.$he,M=new RegExp(f,T),j=new Set;e:for(const F of r){const I=this.j(F);if(I){for(const S of I.words(M))if(!(S===o||!isNaN(Number(S)))&&(j.add(S),j.size>v.p))break e}}return{words:Array.from(j),duration:_.elapsed()}}async computeWordRanges(r,o,f,T){const _=this.j(r);if(!_)return Object.create(null);const M=new RegExp(f,T),j=Object.create(null);for(let F=o.startLineNumber;F<o.endLineNumber;F++){const I=_.getLineWords(F,M);for(const S of I){if(!isNaN(Number(S.word)))continue;let D=j[S.word];D||(D=[],j[S.word]=D),D.push({startLineNumber:F,startColumn:S.startColumn,endLineNumber:F,endColumn:S.endColumn})}}return j}async navigateValueSet(r,o,f,T,_){const M=this.j(r);if(!M)return null;const j=new RegExp(T,_);o.startColumn===o.endColumn&&(o={startLineNumber:o.startLineNumber,startColumn:o.startColumn,endLineNumber:o.endLineNumber,endColumn:o.endColumn+1});const F=M.getValueInRange(o),I=M.getWordAtPosition({lineNumber:o.startLineNumber,column:o.startColumn},j);if(!I)return null;const S=M.getValueInRange(I);return l.$s4.INSTANCE.navigateValueSet(o,F,I,S,f)}loadForeignModule(r,o,f){const T=(j,F)=>this.d.fhr(j,F),M={host:(0,b.$po)(f,T),getMirrorModels:()=>this.k()};return this.g?(this.h=this.g(M,o),Promise.resolve((0,b.$oo)(this.h))):new Promise((j,F)=>{x([r],I=>{this.h=I.create(M,o),j((0,b.$oo)(this.h))},F)})}fmr(r,o){if(!this.h||typeof this.h[r]!="function")return Promise.reject(new Error("Missing requestHandler or method: "+r));try{return Promise.resolve(this.h[r].apply(this.h,o))}catch(f){return Promise.reject(f)}}}i.EditorSimpleWorker=v;function h(u){return new v(u,null)}typeof importScripts=="function"&&(globalThis.monaco=(0,c.$u4)())})}).call(this);

//# sourceMappingURL=https://main.vscode-cdn.net/sourcemaps/undefined/core/vs/base/worker/workerMain.js.map
