/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var oe=["require","exports","vs/base/common/lifecycle","vs/base/common/types","vs/nls!vs/code/node/cliProcessMain","vs/base/common/event","vs/platform/log/common/log","vs/nls","vs/base/common/async","vs/base/common/errors","vs/platform/files/common/files","vs/platform/instantiation/common/instantiation","vs/base/common/uri","vs/base/common/platform","vs/base/common/buffer","vs/base/common/network","vs/base/common/path","vs/base/common/resources","vs/platform/environment/common/environment","vs/platform/telemetry/common/telemetry","vs/base/common/arrays","vs/platform/extensionManagement/common/extensionManagement","vs/base/common/cancellation","vs/platform/extensions/common/extensions","vs/platform/uriIdentity/common/uriIdentity","vs/platform/userDataProfile/common/userDataProfile","vs/base/node/pfs","vs/platform/extensionManagement/common/extensionManagementUtil","vs/base/common/objects","vs/base/common/uuid","vs/platform/configuration/common/configuration","vs/base/common/map","vs/base/common/strings","vs/platform/product/common/productService","vs/base/common/json","os","vs/base/common/process","vs/platform/registry/common/platform","vs/base/common/errorMessage","vs/platform/policy/common/policy","vs/platform/configuration/common/configurationRegistry","vs/platform/telemetry/common/telemetryUtils","vs/platform/extensionManagement/common/extensionsProfileScannerService","vs/base/common/hash","vs/platform/extensions/common/extensionValidator","vs/base/common/semver/semver","vs/platform/request/common/request","vs/base/common/stream","vs/base/common/marshalling","vs/base/common/ternarySearchTree","vs/base/node/zip","vs/platform/instantiation/common/descriptors","vs/platform/files/common/watcher","vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/platform/extensionManagement/common/extensionsScannerService","vs/base/common/decorators","vs/base/common/severity","vs/base/common/processes","vs/base/node/processes","vs/base/parts/ipc/common/ipc","child_process","vs/platform/download/common/download","vs/platform/files/common/io","vs/base/common/extpath","vs/platform/instantiation/common/serviceCollection","vs/base/common/iterator","vs/platform/configuration/common/configurationModels","vs/platform/remote/common/remoteHosts","vs/platform/languagePacks/common/languagePacks","vs/platform/state/node/stateService","vs/platform/telemetry/common/commonProperties","vs/platform/extensionManagement/node/extensionSignatureVerificationService","vs/platform/extensionManagement/node/extensionManagementUtil","vs/platform/storage/common/storage","vs/base/common/amd","vs/base/common/assert","vs/base/common/jsonFormatter","vs/base/common/jsonEdit","vs/base/common/numbers","vs/base/common/skipList","vs/base/node/macAddress","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/common/jsonErrorMessages","vs/base/common/jsonErrorMessages","vs/base/common/console","vs/amdX","vs/base/node/id","vs/base/node/powershell","vs/base/node/shell","vs/base/parts/ipc/node/ipc.cp","vs/base/parts/storage/common/storage","vs/nls!vs/base/node/zip","fs","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/contextkey/common/contextkey","vs/nls!vs/platform/contextkey/common/scanner","vs/nls!vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensionManagement/common/extensionManagementCLI","vs/nls!vs/platform/extensionManagement/common/extensionNls","vs/nls!vs/platform/extensionManagement/common/extensionsScannerService","vs/nls!vs/platform/extensionManagement/node/extensionManagementService","vs/nls!vs/platform/extensionManagement/node/extensionManagementUtil","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/fileService","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/languagePacks/common/languagePacks","vs/nls!vs/platform/log/common/log","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/shell/node/shellEnv","vs/nls!vs/platform/telemetry/common/telemetryService","vs/nls!vs/platform/userDataProfile/common/userDataProfile","vs/nls!vs/platform/workspace/common/workspace","vs/platform/contextkey/common/scanner","vs/base/common/charCode","vs/platform/environment/common/environmentService","vs/platform/environment/node/userDataPath","vs/platform/environment/node/environmentService","vs/platform/extensionManagement/common/extensionNls","vs/platform/extensions/common/extensionsApiProposals","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/graph","vs/platform/contextkey/common/contextkey","vs/platform/files/node/watcher/baseWatcher","vs/platform/files/node/watcher/nodejs/nodejsWatcher","vs/platform/files/node/watcher/nodejs/nodejsClient","vs/platform/files/node/watcher/watcherClient","vs/platform/instantiation/common/instantiationService","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/common/fileService","vs/base/common/performance","vs/platform/files/node/diskFileSystemProvider","vs/platform/log/common/logService","vs/platform/log/node/spdlogLog","vs/platform/log/node/loggerService","vs/platform/policy/common/filePolicyService","vs/platform/policy/node/nativePolicyService","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurations","vs/platform/configuration/common/configurationService","vs/platform/extensionManagement/node/extensionsManifestCache","vs/platform/download/common/downloadService","vs/platform/request/node/proxy","url","vs/platform/shell/node/shellEnv","vs/platform/state/node/state","vs/platform/extensionManagement/common/extensionManagementCLI","vs/platform/extensionManagement/node/extensionsWatcher","vs/platform/languagePacks/node/languagePacks","vs/platform/telemetry/common/1dsAppender","vs/platform/telemetry/common/telemetryService","vs/platform/product/common/product","vs/platform/telemetry/node/1dsAppender","vs/platform/telemetry/node/telemetry","vs/platform/telemetry/node/telemetryUtils","vs/platform/uriIdentity/common/uriIdentityService","vs/platform/userData/common/fileUserDataProvider","vs/platform/workspace/common/workspace","vs/platform/extensionManagement/node/extensionLifecycle","vs/platform/extensionManagement/node/extensionDownloader","vs/platform/extensionManagement/node/extensionManagementService","vs/platform/extensionManagement/node/extensionsProfileScannerService","vs/platform/extensionManagement/node/extensionsScannerService","vs/platform/externalServices/common/serviceMachineId","vs/platform/externalServices/common/marketplace","vs/platform/extensionManagement/common/extensionGalleryService","vs/platform/userDataProfile/node/userDataProfile","vs/platform/request/node/requestService","vs/base/common/lazy","vs/base/common/marshallingIds","path","vs/base/common/glob","vs/platform/files/node/watcher/nodejs/nodejsWatcherLib","vs/base/common/linkedList","vs/platform/environment/node/argvHelper","crypto","https","vs/base/common/stopwatch","zlib","vs/code/node/cliProcessMain","vs/base/node/unc"],ae=function(H){for(var t=[],E=0,S=H.length;E<S;E++)t[E]=oe[H[E]];return t};define(oe[74],ae([0,1]),function(H,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$W=t.LoaderEventType=t.$V=void 0,t.$V=!1;var E;(function(w){w[w.LoaderAvailable=1]="LoaderAvailable",w[w.BeginLoadingScript=10]="BeginLoadingScript",w[w.EndLoadingScriptOK=11]="EndLoadingScriptOK",w[w.EndLoadingScriptError=12]="EndLoadingScriptError",w[w.BeginInvokeFactory=21]="BeginInvokeFactory",w[w.EndInvokeFactory=22]="EndInvokeFactory",w[w.NodeBeginEvaluatingScript=31]="NodeBeginEvaluatingScript",w[w.NodeEndEvaluatingScript=32]="NodeEndEvaluatingScript",w[w.NodeBeginNativeRequire=33]="NodeBeginNativeRequire",w[w.NodeEndNativeRequire=34]="NodeEndNativeRequire",w[w.CachedDataFound=60]="CachedDataFound",w[w.CachedDataMissed=61]="CachedDataMissed",w[w.CachedDataRejected=62]="CachedDataRejected",w[w.CachedDataCreated=63]="CachedDataCreated"})(E||(t.LoaderEventType=E={}));class S{static get(){const O=new Map,L=new Map,I=new Map,m=new Map;function l(g,N){g.has(N.detail)||g.set(N.detail,-N.timestamp)}function c(g,N){const v=g.get(N.detail);v&&(v>=0||g.set(N.detail,v+N.timestamp))}let h=[];typeof H=="function"&&typeof H.getStats=="function"&&(h=H.getStats().slice(0).sort((g,N)=>g.timestamp-N.timestamp));for(const g of h)switch(g.type){case E.BeginLoadingScript:l(O,g);break;case E.EndLoadingScriptOK:case E.EndLoadingScriptError:c(O,g);break;case E.BeginInvokeFactory:l(L,g);break;case E.EndInvokeFactory:c(L,g);break;case E.NodeBeginNativeRequire:l(I,g);break;case E.NodeEndNativeRequire:c(I,g);break;case E.NodeBeginEvaluatingScript:l(m,g);break;case E.NodeEndEvaluatingScript:c(m,g);break}let u=0;I.forEach(g=>u+=g);function $(g){const N=[];return g.forEach((v,d)=>N.push([d,v])),N}return{amdLoad:$(O),amdInvoke:$(L),nodeRequire:$(I),nodeEval:$(m),nodeRequireTotal:u}}static toMarkdownTable(O,L){let I="";const m=[];return O.forEach((l,c)=>{m[c]=l.length}),L.forEach(l=>{l.forEach((c,h)=>{typeof c>"u"&&(c=l[h]="-");const u=c.toString().length;m[h]=Math.max(u,m[h])})}),O.forEach((l,c)=>{I+=`| ${l+" ".repeat(m[c]-l.toString().length)} `}),I+=`|
`,O.forEach((l,c)=>{I+=`| ${"-".repeat(m[c])} `}),I+=`|
`,L.forEach(l=>{l.forEach((c,h)=>{typeof c<"u"&&(I+=`| ${c+" ".repeat(m[h]-c.toString().length)} `)}),I+=`|
`}),I}}t.$W=S}),define(oe[55],ae([0,1]),function(H,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$$h=S,t.$_h=w,t.$ai=O;function E(L){return(I,m,l)=>{let c=null,h=null;if(typeof l.value=="function"?(c="value",h=l.value):typeof l.get=="function"&&(c="get",h=l.get),!h)throw new Error("not supported");l[c]=L(h,m)}}function S(L,I,m){let l=null,c=null;if(typeof m.value=="function"?(l="value",c=m.value,c.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof m.get=="function"&&(l="get",c=m.get),!c)throw new Error("not supported");const h=`$memoize$${I}`;m[l]=function(...u){return this.hasOwnProperty(h)||Object.defineProperty(this,h,{configurable:!1,enumerable:!1,writable:!1,value:c.apply(this,u)}),this[h]}}function w(L,I,m){return E((l,c)=>{const h=`$debounce$${c}`,u=`$debounce$result$${c}`;return function(...$){this[u]||(this[u]=m?m():void 0),clearTimeout(this[h]),I&&(this[u]=I(this[u],...$),$=[this[u]]),this[h]=setTimeout(()=>{l.apply(this,$),this[u]=m?m():void 0},L)}})}function O(L,I,m){return E((l,c)=>{const h=`$throttle$timer$${c}`,u=`$throttle$result$${c}`,$=`$throttle$lastRun$${c}`,g=`$throttle$pending$${c}`;return function(...N){if(this[u]||(this[u]=m?m():void 0),(this[$]===null||this[$]===void 0)&&(this[$]=-Number.MAX_VALUE),I&&(this[u]=I(this[u],...N)),this[g])return;const v=this[$]+L;v<=Date.now()?(this[$]=Date.now(),l.apply(this,[this[u]]),this[u]=m?m():void 0):(this[g]=!0,this[h]=setTimeout(()=>{this[g]=!1,this[$]=Date.now(),l.apply(this,[this[u]]),this[u]=m?m():void 0},v-Date.now()))}})}}),define(oe[75],ae([0,1,9]),function(H,t,E){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ok=S,t.$hd=w,t.$id=O,t.$jd=L,t.$kd=I,t.$ld=m;function S(l,c){if(!l)throw new Error(c?`Assertion failed (${c})`:"Assertion Failed")}function w(l,c="Unreachable"){throw new Error(c)}function O(l,c="unexpected state"){if(!l)throw new E.$fb(`Assertion Failed: ${c}`)}function L(l){l||(0,E.$3)(new E.$fb("Soft Assertion Failed"))}function I(l){if(!l()){debugger;l(),(0,E.$3)(new E.$fb("Assertion Failed"))}}function m(l,c){let h=0;for(;h<l.length-1;){const u=l[h],$=l[h+1];if(!c(u,$))return!1;h++}return!0}}),define(oe[34],ae([0,1]),function(H,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ParseOptions=t.ParseErrorCode=t.SyntaxKind=t.ScanError=void 0,t.$Wn=L,t.$Xn=h,t.$Yn=u,t.$Zn=$,t.$1n=g,t.$2n=N,t.$3n=v,t.$4n=d,t.$5n=p,t.$6n=k,t.$7n=y;var E;(function(e){e[e.None=0]="None",e[e.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",e[e.UnexpectedEndOfString=2]="UnexpectedEndOfString",e[e.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",e[e.InvalidUnicode=4]="InvalidUnicode",e[e.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",e[e.InvalidCharacter=6]="InvalidCharacter"})(E||(t.ScanError=E={}));var S;(function(e){e[e.OpenBraceToken=1]="OpenBraceToken",e[e.CloseBraceToken=2]="CloseBraceToken",e[e.OpenBracketToken=3]="OpenBracketToken",e[e.CloseBracketToken=4]="CloseBracketToken",e[e.CommaToken=5]="CommaToken",e[e.ColonToken=6]="ColonToken",e[e.NullKeyword=7]="NullKeyword",e[e.TrueKeyword=8]="TrueKeyword",e[e.FalseKeyword=9]="FalseKeyword",e[e.StringLiteral=10]="StringLiteral",e[e.NumericLiteral=11]="NumericLiteral",e[e.LineCommentTrivia=12]="LineCommentTrivia",e[e.BlockCommentTrivia=13]="BlockCommentTrivia",e[e.LineBreakTrivia=14]="LineBreakTrivia",e[e.Trivia=15]="Trivia",e[e.Unknown=16]="Unknown",e[e.EOF=17]="EOF"})(S||(t.SyntaxKind=S={}));var w;(function(e){e[e.InvalidSymbol=1]="InvalidSymbol",e[e.InvalidNumberFormat=2]="InvalidNumberFormat",e[e.PropertyNameExpected=3]="PropertyNameExpected",e[e.ValueExpected=4]="ValueExpected",e[e.ColonExpected=5]="ColonExpected",e[e.CommaExpected=6]="CommaExpected",e[e.CloseBraceExpected=7]="CloseBraceExpected",e[e.CloseBracketExpected=8]="CloseBracketExpected",e[e.EndOfFileExpected=9]="EndOfFileExpected",e[e.InvalidCommentToken=10]="InvalidCommentToken",e[e.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",e[e.UnexpectedEndOfString=12]="UnexpectedEndOfString",e[e.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",e[e.InvalidUnicode=14]="InvalidUnicode",e[e.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",e[e.InvalidCharacter=16]="InvalidCharacter"})(w||(t.ParseErrorCode=w={}));var O;(function(e){e.DEFAULT={allowTrailingComma:!0}})(O||(t.ParseOptions=O={}));function L(e,a=!1){let n=0;const r=e.length;let i="",s=0,o=S.Unknown,f=E.None;function b(Q){let se=0,le=0;for(;se<Q;){const ue=e.charCodeAt(n);if(ue>=c._0&&ue<=c._9)le=le*16+ue-c._0;else if(ue>=c.A&&ue<=c.F)le=le*16+ue-c.A+10;else if(ue>=c.a&&ue<=c.f)le=le*16+ue-c.a+10;else break;n++,se++}return se<Q&&(le=-1),le}function R(Q){n=Q,i="",s=0,o=S.Unknown,f=E.None}function T(){const Q=n;if(e.charCodeAt(n)===c._0)n++;else for(n++;n<e.length&&l(e.charCodeAt(n));)n++;if(n<e.length&&e.charCodeAt(n)===c.dot)if(n++,n<e.length&&l(e.charCodeAt(n)))for(n++;n<e.length&&l(e.charCodeAt(n));)n++;else return f=E.UnexpectedEndOfNumber,e.substring(Q,n);let se=n;if(n<e.length&&(e.charCodeAt(n)===c.E||e.charCodeAt(n)===c.e))if(n++,(n<e.length&&e.charCodeAt(n)===c.plus||e.charCodeAt(n)===c.minus)&&n++,n<e.length&&l(e.charCodeAt(n))){for(n++;n<e.length&&l(e.charCodeAt(n));)n++;se=n}else f=E.UnexpectedEndOfNumber;return e.substring(Q,se)}function D(){let Q="",se=n;for(;;){if(n>=r){Q+=e.substring(se,n),f=E.UnexpectedEndOfString;break}const le=e.charCodeAt(n);if(le===c.doubleQuote){Q+=e.substring(se,n),n++;break}if(le===c.backslash){if(Q+=e.substring(se,n),n++,n>=r){f=E.UnexpectedEndOfString;break}switch(e.charCodeAt(n++)){case c.doubleQuote:Q+='"';break;case c.backslash:Q+="\\";break;case c.slash:Q+="/";break;case c.b:Q+="\b";break;case c.f:Q+="\f";break;case c.n:Q+=`
`;break;case c.r:Q+="\r";break;case c.t:Q+="	";break;case c.u:{const fe=b(4);fe>=0?Q+=String.fromCharCode(fe):f=E.InvalidUnicode;break}default:f=E.InvalidEscapeCharacter}se=n;continue}if(le>=0&&le<=31)if(m(le)){Q+=e.substring(se,n),f=E.UnexpectedEndOfString;break}else f=E.InvalidCharacter;n++}return Q}function A(){if(i="",f=E.None,s=n,n>=r)return s=r,o=S.EOF;let Q=e.charCodeAt(n);if(I(Q)){do n++,i+=String.fromCharCode(Q),Q=e.charCodeAt(n);while(I(Q));return o=S.Trivia}if(m(Q))return n++,i+=String.fromCharCode(Q),Q===c.carriageReturn&&e.charCodeAt(n)===c.lineFeed&&(n++,i+=`
`),o=S.LineBreakTrivia;switch(Q){case c.openBrace:return n++,o=S.OpenBraceToken;case c.closeBrace:return n++,o=S.CloseBraceToken;case c.openBracket:return n++,o=S.OpenBracketToken;case c.closeBracket:return n++,o=S.CloseBracketToken;case c.colon:return n++,o=S.ColonToken;case c.comma:return n++,o=S.CommaToken;case c.doubleQuote:return n++,i=D(),o=S.StringLiteral;case c.slash:{const se=n-1;if(e.charCodeAt(n+1)===c.slash){for(n+=2;n<r&&!m(e.charCodeAt(n));)n++;return i=e.substring(se,n),o=S.LineCommentTrivia}if(e.charCodeAt(n+1)===c.asterisk){n+=2;const le=r-1;let ue=!1;for(;n<le;){if(e.charCodeAt(n)===c.asterisk&&e.charCodeAt(n+1)===c.slash){n+=2,ue=!0;break}n++}return ue||(n++,f=E.UnexpectedEndOfComment),i=e.substring(se,n),o=S.BlockCommentTrivia}return i+=String.fromCharCode(Q),n++,o=S.Unknown}case c.minus:if(i+=String.fromCharCode(Q),n++,n===r||!l(e.charCodeAt(n)))return o=S.Unknown;case c._0:case c._1:case c._2:case c._3:case c._4:case c._5:case c._6:case c._7:case c._8:case c._9:return i+=T(),o=S.NumericLiteral;default:for(;n<r&&z(Q);)n++,Q=e.charCodeAt(n);if(s!==n){switch(i=e.substring(s,n),i){case"true":return o=S.TrueKeyword;case"false":return o=S.FalseKeyword;case"null":return o=S.NullKeyword}return o=S.Unknown}return i+=String.fromCharCode(Q),n++,o=S.Unknown}}function z(Q){if(I(Q)||m(Q))return!1;switch(Q){case c.closeBrace:case c.closeBracket:case c.openBrace:case c.openBracket:case c.doubleQuote:case c.colon:case c.comma:case c.slash:return!1}return!0}function J(){let Q;do Q=A();while(Q>=S.LineCommentTrivia&&Q<=S.Trivia);return Q}return{setPosition:R,getPosition:()=>n,scan:a?J:A,getToken:()=>o,getTokenValue:()=>i,getTokenOffset:()=>s,getTokenLength:()=>n-s,getTokenError:()=>f}}function I(e){return e===c.space||e===c.tab||e===c.verticalTab||e===c.formFeed||e===c.nonBreakingSpace||e===c.ogham||e>=c.enQuad&&e<=c.zeroWidthSpace||e===c.narrowNoBreakSpace||e===c.mathematicalSpace||e===c.ideographicSpace||e===c.byteOrderMark}function m(e){return e===c.lineFeed||e===c.carriageReturn||e===c.lineSeparator||e===c.paragraphSeparator}function l(e){return e>=c._0&&e<=c._9}var c;(function(e){e[e.nullCharacter=0]="nullCharacter",e[e.maxAsciiCharacter=127]="maxAsciiCharacter",e[e.lineFeed=10]="lineFeed",e[e.carriageReturn=13]="carriageReturn",e[e.lineSeparator=8232]="lineSeparator",e[e.paragraphSeparator=8233]="paragraphSeparator",e[e.nextLine=133]="nextLine",e[e.space=32]="space",e[e.nonBreakingSpace=160]="nonBreakingSpace",e[e.enQuad=8192]="enQuad",e[e.emQuad=8193]="emQuad",e[e.enSpace=8194]="enSpace",e[e.emSpace=8195]="emSpace",e[e.threePerEmSpace=8196]="threePerEmSpace",e[e.fourPerEmSpace=8197]="fourPerEmSpace",e[e.sixPerEmSpace=8198]="sixPerEmSpace",e[e.figureSpace=8199]="figureSpace",e[e.punctuationSpace=8200]="punctuationSpace",e[e.thinSpace=8201]="thinSpace",e[e.hairSpace=8202]="hairSpace",e[e.zeroWidthSpace=8203]="zeroWidthSpace",e[e.narrowNoBreakSpace=8239]="narrowNoBreakSpace",e[e.ideographicSpace=12288]="ideographicSpace",e[e.mathematicalSpace=8287]="mathematicalSpace",e[e.ogham=5760]="ogham",e[e._=95]="_",e[e.$=36]="$",e[e._0=48]="_0",e[e._1=49]="_1",e[e._2=50]="_2",e[e._3=51]="_3",e[e._4=52]="_4",e[e._5=53]="_5",e[e._6=54]="_6",e[e._7=55]="_7",e[e._8=56]="_8",e[e._9=57]="_9",e[e.a=97]="a",e[e.b=98]="b",e[e.c=99]="c",e[e.d=100]="d",e[e.e=101]="e",e[e.f=102]="f",e[e.g=103]="g",e[e.h=104]="h",e[e.i=105]="i",e[e.j=106]="j",e[e.k=107]="k",e[e.l=108]="l",e[e.m=109]="m",e[e.n=110]="n",e[e.o=111]="o",e[e.p=112]="p",e[e.q=113]="q",e[e.r=114]="r",e[e.s=115]="s",e[e.t=116]="t",e[e.u=117]="u",e[e.v=118]="v",e[e.w=119]="w",e[e.x=120]="x",e[e.y=121]="y",e[e.z=122]="z",e[e.A=65]="A",e[e.B=66]="B",e[e.C=67]="C",e[e.D=68]="D",e[e.E=69]="E",e[e.F=70]="F",e[e.G=71]="G",e[e.H=72]="H",e[e.I=73]="I",e[e.J=74]="J",e[e.K=75]="K",e[e.L=76]="L",e[e.M=77]="M",e[e.N=78]="N",e[e.O=79]="O",e[e.P=80]="P",e[e.Q=81]="Q",e[e.R=82]="R",e[e.S=83]="S",e[e.T=84]="T",e[e.U=85]="U",e[e.V=86]="V",e[e.W=87]="W",e[e.X=88]="X",e[e.Y=89]="Y",e[e.Z=90]="Z",e[e.ampersand=38]="ampersand",e[e.asterisk=42]="asterisk",e[e.at=64]="at",e[e.backslash=92]="backslash",e[e.bar=124]="bar",e[e.caret=94]="caret",e[e.closeBrace=125]="closeBrace",e[e.closeBracket=93]="closeBracket",e[e.closeParen=41]="closeParen",e[e.colon=58]="colon",e[e.comma=44]="comma",e[e.dot=46]="dot",e[e.doubleQuote=34]="doubleQuote",e[e.equals=61]="equals",e[e.exclamation=33]="exclamation",e[e.greaterThan=62]="greaterThan",e[e.lessThan=60]="lessThan",e[e.minus=45]="minus",e[e.openBrace=123]="openBrace",e[e.openBracket=91]="openBracket",e[e.openParen=40]="openParen",e[e.percent=37]="percent",e[e.plus=43]="plus",e[e.question=63]="question",e[e.semicolon=59]="semicolon",e[e.singleQuote=39]="singleQuote",e[e.slash=47]="slash",e[e.tilde=126]="tilde",e[e.backspace=8]="backspace",e[e.formFeed=12]="formFeed",e[e.byteOrderMark=65279]="byteOrderMark",e[e.tab=9]="tab",e[e.verticalTab=11]="verticalTab"})(c||(c={}));function h(e,a){const n=[],r=new Object;let i;const s={value:{},offset:0,length:0,type:"object",parent:void 0};let o=!1;function f(b,R,T,D){s.value=b,s.offset=R,s.length=T,s.type=D,s.colonOffset=void 0,i=s}try{k(e,{onObjectBegin:(b,R)=>{if(a<=b)throw r;i=void 0,o=a>b,n.push("")},onObjectProperty:(b,R,T)=>{if(a<R||(f(b,R,T,"property"),n[n.length-1]=b,a<=R+T))throw r},onObjectEnd:(b,R)=>{if(a<=b)throw r;i=void 0,n.pop()},onArrayBegin:(b,R)=>{if(a<=b)throw r;i=void 0,n.push(0)},onArrayEnd:(b,R)=>{if(a<=b)throw r;i=void 0,n.pop()},onLiteralValue:(b,R,T)=>{if(a<R||(f(b,R,T,y(b)),a<=R+T))throw r},onSeparator:(b,R,T)=>{if(a<=R)throw r;if(b===":"&&i&&i.type==="property")i.colonOffset=R,o=!1,i=void 0;else if(b===","){const D=n[n.length-1];typeof D=="number"?n[n.length-1]=D+1:(o=!0,n[n.length-1]=""),i=void 0}}})}catch(b){if(b!==r)throw b}return{path:n,previousNode:i,isAtPropertyKey:o,matches:b=>{let R=0;for(let T=0;R<b.length&&T<n.length;T++)if(b[R]===n[T]||b[R]==="*")R++;else if(b[R]!=="**")return!1;return R===b.length}}}function u(e,a=[],n=O.DEFAULT){let r=null,i=[];const s=[];function o(b){Array.isArray(i)?i.push(b):r!==null&&(i[r]=b)}return k(e,{onObjectBegin:()=>{const b={};o(b),s.push(i),i=b,r=null},onObjectProperty:b=>{r=b},onObjectEnd:()=>{i=s.pop()},onArrayBegin:()=>{const b=[];o(b),s.push(i),i=b,r=null},onArrayEnd:()=>{i=s.pop()},onLiteralValue:o,onError:(b,R,T)=>{a.push({error:b,offset:R,length:T})}},n),i[0]}function $(e,a=[],n=O.DEFAULT){let r={type:"array",offset:-1,length:-1,children:[],parent:void 0};function i(b){r.type==="property"&&(r.length=b-r.offset,r=r.parent)}function s(b){return r.children.push(b),b}k(e,{onObjectBegin:b=>{r=s({type:"object",offset:b,length:-1,parent:r,children:[]})},onObjectProperty:(b,R,T)=>{r=s({type:"property",offset:R,length:-1,parent:r,children:[]}),r.children.push({type:"string",value:b,offset:R,length:T,parent:r})},onObjectEnd:(b,R)=>{r.length=b+R-r.offset,r=r.parent,i(b+R)},onArrayBegin:(b,R)=>{r=s({type:"array",offset:b,length:-1,parent:r,children:[]})},onArrayEnd:(b,R)=>{r.length=b+R-r.offset,r=r.parent,i(b+R)},onLiteralValue:(b,R,T)=>{s({type:y(b),offset:R,length:T,parent:r,value:b}),i(R+T)},onSeparator:(b,R,T)=>{r.type==="property"&&(b===":"?r.colonOffset=R:b===","&&i(R))},onError:(b,R,T)=>{a.push({error:b,offset:R,length:T})}},n);const f=r.children[0];return f&&delete f.parent,f}function g(e,a){if(!e)return;let n=e;for(const r of a)if(typeof r=="string"){if(n.type!=="object"||!Array.isArray(n.children))return;let i=!1;for(const s of n.children)if(Array.isArray(s.children)&&s.children[0].value===r){n=s.children[1],i=!0;break}if(!i)return}else{const i=r;if(n.type!=="array"||i<0||!Array.isArray(n.children)||i>=n.children.length)return;n=n.children[i]}return n}function N(e){if(!e.parent||!e.parent.children)return[];const a=N(e.parent);if(e.parent.type==="property"){const n=e.parent.children[0].value;a.push(n)}else if(e.parent.type==="array"){const n=e.parent.children.indexOf(e);n!==-1&&a.push(n)}return a}function v(e){switch(e.type){case"array":return e.children.map(v);case"object":{const a=Object.create(null);for(const n of e.children){const r=n.children[1];r&&(a[n.children[0].value]=v(r))}return a}case"null":case"string":case"number":case"boolean":return e.value;default:return}}function d(e,a,n=!1){return a>=e.offset&&a<e.offset+e.length||n&&a===e.offset+e.length}function p(e,a,n=!1){if(d(e,a,n)){const r=e.children;if(Array.isArray(r))for(let i=0;i<r.length&&r[i].offset<=a;i++){const s=p(r[i],a,n);if(s)return s}return e}}function k(e,a,n=O.DEFAULT){const r=L(e,!1);function i(Y){return Y?()=>Y(r.getTokenOffset(),r.getTokenLength()):()=>!0}function s(Y){return Y?te=>Y(te,r.getTokenOffset(),r.getTokenLength()):()=>!0}const o=i(a.onObjectBegin),f=s(a.onObjectProperty),b=i(a.onObjectEnd),R=i(a.onArrayBegin),T=i(a.onArrayEnd),D=s(a.onLiteralValue),A=s(a.onSeparator),z=i(a.onComment),J=s(a.onError),Q=n&&n.disallowComments,se=n&&n.allowTrailingComma;function le(){for(;;){const Y=r.scan();switch(r.getTokenError()){case E.InvalidUnicode:ue(w.InvalidUnicode);break;case E.InvalidEscapeCharacter:ue(w.InvalidEscapeCharacter);break;case E.UnexpectedEndOfNumber:ue(w.UnexpectedEndOfNumber);break;case E.UnexpectedEndOfComment:Q||ue(w.UnexpectedEndOfComment);break;case E.UnexpectedEndOfString:ue(w.UnexpectedEndOfString);break;case E.InvalidCharacter:ue(w.InvalidCharacter);break}switch(Y){case S.LineCommentTrivia:case S.BlockCommentTrivia:Q?ue(w.InvalidCommentToken):z();break;case S.Unknown:ue(w.InvalidSymbol);break;case S.Trivia:case S.LineBreakTrivia:break;default:return Y}}}function ue(Y,te=[],F=[]){if(J(Y),te.length+F.length>0){let q=r.getToken();for(;q!==S.EOF;){if(te.indexOf(q)!==-1){le();break}else if(F.indexOf(q)!==-1)break;q=le()}}}function fe(Y){const te=r.getTokenValue();return Y?D(te):f(te),le(),!0}function x(){switch(r.getToken()){case S.NumericLiteral:{let Y=0;try{Y=JSON.parse(r.getTokenValue()),typeof Y!="number"&&(ue(w.InvalidNumberFormat),Y=0)}catch{ue(w.InvalidNumberFormat)}D(Y);break}case S.NullKeyword:D(null);break;case S.TrueKeyword:D(!0);break;case S.FalseKeyword:D(!1);break;default:return!1}return le(),!0}function _(){return r.getToken()!==S.StringLiteral?(ue(w.PropertyNameExpected,[],[S.CloseBraceToken,S.CommaToken]),!1):(fe(!1),r.getToken()===S.ColonToken?(A(":"),le(),G()||ue(w.ValueExpected,[],[S.CloseBraceToken,S.CommaToken])):ue(w.ColonExpected,[],[S.CloseBraceToken,S.CommaToken]),!0)}function B(){o(),le();let Y=!1;for(;r.getToken()!==S.CloseBraceToken&&r.getToken()!==S.EOF;){if(r.getToken()===S.CommaToken){if(Y||ue(w.ValueExpected,[],[]),A(","),le(),r.getToken()===S.CloseBraceToken&&se)break}else Y&&ue(w.CommaExpected,[],[]);_()||ue(w.ValueExpected,[],[S.CloseBraceToken,S.CommaToken]),Y=!0}return b(),r.getToken()!==S.CloseBraceToken?ue(w.CloseBraceExpected,[S.CloseBraceToken],[]):le(),!0}function M(){R(),le();let Y=!1;for(;r.getToken()!==S.CloseBracketToken&&r.getToken()!==S.EOF;){if(r.getToken()===S.CommaToken){if(Y||ue(w.ValueExpected,[],[]),A(","),le(),r.getToken()===S.CloseBracketToken&&se)break}else Y&&ue(w.CommaExpected,[],[]);G()||ue(w.ValueExpected,[],[S.CloseBracketToken,S.CommaToken]),Y=!0}return T(),r.getToken()!==S.CloseBracketToken?ue(w.CloseBracketExpected,[S.CloseBracketToken],[]):le(),!0}function G(){switch(r.getToken()){case S.OpenBracketToken:return M();case S.OpenBraceToken:return B();case S.StringLiteral:return fe(!0);default:return x()}}return le(),r.getToken()===S.EOF?n.allowEmptyContent?!0:(ue(w.ValueExpected,[],[]),!1):G()?(r.getToken()!==S.EOF&&ue(w.EndOfFileExpected,[],[]),!0):(ue(w.ValueExpected,[],[]),!1)}function y(e){switch(typeof e){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(e){if(Array.isArray(e))return"array"}else return"null";return"object"}default:return"null"}}}),define(oe[76],ae([0,1,34]),function(H,t,E){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$8n=S,t.$9n=w,t.$0n=I,t.$$n=m;function S(l,c,h){let u,$,g,N,v;if(c){for(N=c.offset,v=N+c.length,g=N;g>0&&!m(l,g-1);)g--;let f=v;for(;f<l.length&&!m(l,f);)f++;$=l.substring(g,f),u=L($,h)}else $=l,u=0,g=0,N=0,v=l.length;const d=I(h,l);let p=!1,k=0,y;h.insertSpaces?y=O(" ",h.tabSize||4):y="	";const e=(0,E.$Wn)($,!1);let a=!1;function n(){return d+O(y,u+k)}function r(){let f=e.scan();for(p=!1;f===E.SyntaxKind.Trivia||f===E.SyntaxKind.LineBreakTrivia;)p=p||f===E.SyntaxKind.LineBreakTrivia,f=e.scan();return a=f===E.SyntaxKind.Unknown||e.getTokenError()!==E.ScanError.None,f}const i=[];function s(f,b,R){!a&&b<v&&R>N&&l.substring(b,R)!==f&&i.push({offset:b,length:R-b,content:f})}let o=r();if(o!==E.SyntaxKind.EOF){const f=e.getTokenOffset()+g,b=O(y,u);s(b,g,f)}for(;o!==E.SyntaxKind.EOF;){let f=e.getTokenOffset()+e.getTokenLength()+g,b=r(),R="";for(;!p&&(b===E.SyntaxKind.LineCommentTrivia||b===E.SyntaxKind.BlockCommentTrivia);){const D=e.getTokenOffset()+g;s(" ",f,D),f=e.getTokenOffset()+e.getTokenLength()+g,R=b===E.SyntaxKind.LineCommentTrivia?n():"",b=r()}if(b===E.SyntaxKind.CloseBraceToken)o!==E.SyntaxKind.OpenBraceToken&&(k--,R=n());else if(b===E.SyntaxKind.CloseBracketToken)o!==E.SyntaxKind.OpenBracketToken&&(k--,R=n());else{switch(o){case E.SyntaxKind.OpenBracketToken:case E.SyntaxKind.OpenBraceToken:k++,R=n();break;case E.SyntaxKind.CommaToken:case E.SyntaxKind.LineCommentTrivia:R=n();break;case E.SyntaxKind.BlockCommentTrivia:p?R=n():R=" ";break;case E.SyntaxKind.ColonToken:R=" ";break;case E.SyntaxKind.StringLiteral:if(b===E.SyntaxKind.ColonToken){R="";break}case E.SyntaxKind.NullKeyword:case E.SyntaxKind.TrueKeyword:case E.SyntaxKind.FalseKeyword:case E.SyntaxKind.NumericLiteral:case E.SyntaxKind.CloseBraceToken:case E.SyntaxKind.CloseBracketToken:b===E.SyntaxKind.LineCommentTrivia||b===E.SyntaxKind.BlockCommentTrivia?R=" ":b!==E.SyntaxKind.CommaToken&&b!==E.SyntaxKind.EOF&&(a=!0);break;case E.SyntaxKind.Unknown:a=!0;break}p&&(b===E.SyntaxKind.LineCommentTrivia||b===E.SyntaxKind.BlockCommentTrivia)&&(R=n())}const T=e.getTokenOffset()+g;s(R,f,T),o=b}return i}function w(l,c){const h=JSON.stringify(l,void 0,c.insertSpaces?c.tabSize||4:"	");return c.eol!==void 0?h.replace(/\r\n|\r|\n/g,c.eol):h}function O(l,c){let h="";for(let u=0;u<c;u++)h+=l;return h}function L(l,c){let h=0,u=0;const $=c.tabSize||4;for(;h<l.length;){const g=l.charAt(h);if(g===" ")u++;else if(g==="	")u+=$;else break;h++}return Math.floor(u/$)}function I(l,c){for(let h=0;h<c.length;h++){const u=c.charAt(h);if(u==="\r")return h+1<c.length&&c.charAt(h+1)===`
`?`\r
`:"\r";if(u===`
`)return`
`}return l&&l.eol||`
`}function m(l,c){return`\r
`.indexOf(l.charAt(c))!==-1}}),define(oe[77],ae([0,1,34,76]),function(H,t,E,S){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$_n=w,t.$ao=O,t.$bo=L,t.$co=I,t.$do=m;function w(l,c,h){return O(l,c,void 0,h)}function O(l,c,h,u,$){const g=c.slice(),N=[],v=(0,E.$Zn)(l,N);let d,p;for(;g.length>0&&(p=g.pop(),d=(0,E.$1n)(v,g),d===void 0&&h!==void 0);)typeof p=="string"?h={[p]:h}:h=[h];if(d)if(d.type==="object"&&typeof p=="string"&&Array.isArray(d.children)){const k=(0,E.$1n)(d,[p]);if(k!==void 0)if(h===void 0){if(!k.parent)throw new Error("Malformed AST");const y=d.children.indexOf(k.parent);let e,a=k.parent.offset+k.parent.length;if(y>0){const n=d.children[y-1];e=n.offset+n.length}else e=d.offset+1,d.children.length>1&&(a=d.children[1].offset);return L(l,{offset:e,length:a-e,content:""},u)}else return L(l,{offset:k.offset,length:k.length,content:JSON.stringify(h)},u);else{if(h===void 0)return[];const y=`${JSON.stringify(p)}: ${JSON.stringify(h)}`,e=$?$(d.children.map(n=>n.children[0].value)):d.children.length;let a;if(e>0){const n=d.children[e-1];a={offset:n.offset+n.length,length:0,content:","+y}}else d.children.length===0?a={offset:d.offset+1,length:0,content:y}:a={offset:d.offset+1,length:0,content:y+","};return L(l,a,u)}}else if(d.type==="array"&&typeof p=="number"&&Array.isArray(d.children))if(h!==void 0){const k=`${JSON.stringify(h)}`;let y;if(d.children.length===0||p===0)y={offset:d.offset+1,length:0,content:d.children.length===0?k:k+","};else{const e=p===-1||p>d.children.length?d.children.length:p,a=d.children[e-1];y={offset:a.offset+a.length,length:0,content:","+k}}return L(l,y,u)}else{const k=p,y=d.children[k];let e;if(d.children.length===1)e={offset:d.offset+1,length:d.length-2,content:""};else if(d.children.length-1===k){const a=d.children[k-1],n=a.offset+a.length,r=d.offset+d.length;e={offset:n,length:r-2-n,content:""}}else e={offset:y.offset,length:d.children[k+1].offset-y.offset,content:""};return L(l,e,u)}else throw new Error(`Can not add ${typeof p!="number"?"index":"property"} to parent of type ${d.type}`);else return h===void 0?[]:L(l,{offset:v?v.offset:0,length:v?v.length:0,content:JSON.stringify(h)},u)}function L(l,c,h){let u=I(l,c),$=c.offset,g=c.offset+c.content.length;if(c.length===0||c.content.length===0){for(;$>0&&!(0,S.$$n)(u,$-1);)$--;for(;g<u.length&&!(0,S.$$n)(u,g);)g++}const N=(0,S.$8n)(u,{offset:$,length:g-$},h);for(let d=N.length-1;d>=0;d--){const p=N[d];u=I(u,p),$=Math.min($,p.offset),g=Math.max(g,p.offset+p.length),g+=p.content.length-p.length}const v=l.length-(u.length-g)-$;return[{offset:$,length:v,content:u.substring($,g)}]}function I(l,c){return l.substring(0,c.offset)+c.content+l.substring(c.offset+c.length)}function m(l,c){const h=c.slice(0).sort(($,g)=>{const N=$.offset-g.offset;return N===0?$.length-g.length:N});let u=l.length;for(let $=h.length-1;$>=0;$--){const g=h[$];if(g.offset+g.length<=u)l=I(l,g);else throw new Error("Overlapping edit");u=g.offset}return l}}),define(oe[78],ae([0,1]),function(H,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Pm=t.$Om=t.$Nm=void 0,t.$Lm=E,t.rot=S,t.$Qm=I;function E(m,l,c){return Math.min(Math.max(m,l),c)}function S(m,l){return(l+m%l)%l}class w{constructor(){this.a=0}getNext(){return this.a++}}t.$Nm=w;class O{constructor(){this.a=1,this.b=0}update(l){return this.b=this.b+(l-this.b)/this.a,this.a+=1,this.b}get value(){return this.b}}t.$Om=O;class L{constructor(l){this.a=0,this.b=0,this.c=[],this.d=0,this.e=0,this.c=new Array(l),this.c.fill(0,0,l)}update(l){const c=this.c[this.d];return this.c[this.d]=l,this.d=(this.d+1)%this.c.length,this.e-=c,this.e+=l,this.a<this.c.length&&(this.a+=1),this.b=this.e/this.a,this.b}get value(){return this.b}}t.$Pm=L;function I(m,l,c,h,u,$,g,N){const v=g-c,d=N-h,p=u-c,k=$-h,y=m-c,e=l-h,a=v*v+d*d,n=v*p+d*k,r=v*y+d*e,i=p*p+k*k,s=p*y+k*e,o=1/(a*i-n*n),f=(i*r-n*s)*o,b=(a*s-n*r)*o;return f>=0&&b>=0&&f+b<1}}),function(){function H(w){const O=[];typeof w=="number"&&O.push("code/timeOrigin",w);function L(m){O.push(m,Date.now())}function I(){const m=[];for(let l=0;l<O.length;l+=2)m.push({name:O[l],startTime:O[l+1]});return m}return{mark:L,getMarks:I}}function t(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?H():{mark(w){performance.mark(w)},getMarks(){let w=performance.timeOrigin;typeof w!="number"&&(w=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const O=[{name:"code/timeOrigin",startTime:Math.round(w)}];for(const L of performance.getEntriesByType("mark"))O.push({name:L.name,startTime:Math.round(w+L.startTime)});return O}};if(typeof process=="object"){const w=performance?.timeOrigin??Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return H(w)}else return console.trace("perf-util loaded in UNKNOWN environment"),H()}function E(w){return w.MonacoPerformanceMarks||(w.MonacoPerformanceMarks=t()),w.MonacoPerformanceMarks}var S;typeof global=="object"?S=global:typeof self=="object"?S=self:S={},typeof define=="function"?define("vs/base/common/performance",[],function(){return E(S)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=E(S):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),S.perf=E(S))}(),function(H,t){if(typeof exports=="object"&&typeof module=="object")module.exports=t();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],t);else{var E=t();for(var S in E)(typeof exports=="object"?exports:H)[S]=E[S]}}(typeof self<"u"?self:this,function(){return function(H){var t={};function E(S){if(t[S])return t[S].exports;var w=t[S]={i:S,l:!1,exports:{}};return H[S].call(w.exports,w,w.exports,E),w.l=!0,w.exports}return E.m=H,E.c=t,E.d=function(S,w,O){E.o(S,w)||Object.defineProperty(S,w,{enumerable:!0,get:O})},E.r=function(S){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(S,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(S,"__esModule",{value:!0})},E.t=function(S,w){if(1&w&&(S=E(S)),8&w||4&w&&typeof S=="object"&&S&&S.__esModule)return S;var O=Object.create(null);if(E.r(O),Object.defineProperty(O,"default",{enumerable:!0,value:S}),2&w&&typeof S!="string")for(var L in S)E.d(O,L,function(I){return S[I]}.bind(null,L));return O},E.n=function(S){var w=S&&S.__esModule?function(){return S.default}:function(){return S};return E.d(w,"a",w),w},E.o=function(S,w){return Object.prototype.hasOwnProperty.call(S,w)},E.p="",E(E.s=0)}([function(H,t,E){(function(S){var w;t=H.exports=q,w=typeof S=="object"&&S.env&&S.env.NODE_DEBUG&&/\bsemver\b/i.test(S.env.NODE_DEBUG)?function(){var W=Array.prototype.slice.call(arguments,0);W.unshift("SEMVER"),console.log.apply(console,W)}:function(){},t.SEMVER_SPEC_VERSION="2.0.0";var O=256,L=Number.MAX_SAFE_INTEGER||9007199254740991,I=t.re=[],m=t.src=[],l=0,c=l++;m[c]="0|[1-9]\\d*";var h=l++;m[h]="[0-9]+";var u=l++;m[u]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var $=l++;m[$]="("+m[c]+")\\.("+m[c]+")\\.("+m[c]+")";var g=l++;m[g]="("+m[h]+")\\.("+m[h]+")\\.("+m[h]+")";var N=l++;m[N]="(?:"+m[c]+"|"+m[u]+")";var v=l++;m[v]="(?:"+m[h]+"|"+m[u]+")";var d=l++;m[d]="(?:-("+m[N]+"(?:\\."+m[N]+")*))";var p=l++;m[p]="(?:-?("+m[v]+"(?:\\."+m[v]+")*))";var k=l++;m[k]="[0-9A-Za-z-]+";var y=l++;m[y]="(?:\\+("+m[k]+"(?:\\."+m[k]+")*))";var e=l++,a="v?"+m[$]+m[d]+"?"+m[y]+"?";m[e]="^"+a+"$";var n="[v=\\s]*"+m[g]+m[p]+"?"+m[y]+"?",r=l++;m[r]="^"+n+"$";var i=l++;m[i]="((?:<|>)?=?)";var s=l++;m[s]=m[h]+"|x|X|\\*";var o=l++;m[o]=m[c]+"|x|X|\\*";var f=l++;m[f]="[v=\\s]*("+m[o]+")(?:\\.("+m[o]+")(?:\\.("+m[o]+")(?:"+m[d]+")?"+m[y]+"?)?)?";var b=l++;m[b]="[v=\\s]*("+m[s]+")(?:\\.("+m[s]+")(?:\\.("+m[s]+")(?:"+m[p]+")?"+m[y]+"?)?)?";var R=l++;m[R]="^"+m[i]+"\\s*"+m[f]+"$";var T=l++;m[T]="^"+m[i]+"\\s*"+m[b]+"$";var D=l++;m[D]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var A=l++;m[A]="(?:~>?)";var z=l++;m[z]="(\\s*)"+m[A]+"\\s+",I[z]=new RegExp(m[z],"g");var J=l++;m[J]="^"+m[A]+m[f]+"$";var Q=l++;m[Q]="^"+m[A]+m[b]+"$";var se=l++;m[se]="(?:\\^)";var le=l++;m[le]="(\\s*)"+m[se]+"\\s+",I[le]=new RegExp(m[le],"g");var ue=l++;m[ue]="^"+m[se]+m[f]+"$";var fe=l++;m[fe]="^"+m[se]+m[b]+"$";var x=l++;m[x]="^"+m[i]+"\\s*("+n+")$|^$";var _=l++;m[_]="^"+m[i]+"\\s*("+a+")$|^$";var B=l++;m[B]="(\\s*)"+m[i]+"\\s*("+n+"|"+m[f]+")",I[B]=new RegExp(m[B],"g");var M=l++;m[M]="^\\s*("+m[f]+")\\s+-\\s+("+m[f]+")\\s*$";var G=l++;m[G]="^\\s*("+m[b]+")\\s+-\\s+("+m[b]+")\\s*$";var Y=l++;m[Y]="(<|>)?=?\\s*\\*";for(var te=0;te<35;te++)w(te,m[te]),I[te]||(I[te]=new RegExp(m[te]));function F(W,ee){if(W instanceof q)return W;if(typeof W!="string"||W.length>O||!(ee?I[r]:I[e]).test(W))return null;try{return new q(W,ee)}catch{return null}}function q(W,ee){if(W instanceof q){if(W.loose===ee)return W;W=W.version}else if(typeof W!="string")throw new TypeError("Invalid Version: "+W);if(W.length>O)throw new TypeError("version is longer than "+O+" characters");if(!(this instanceof q))return new q(W,ee);w("SemVer",W,ee),this.loose=ee;var ie=W.trim().match(ee?I[r]:I[e]);if(!ie)throw new TypeError("Invalid Version: "+W);if(this.raw=W,this.major=+ie[1],this.minor=+ie[2],this.patch=+ie[3],this.major>L||this.major<0)throw new TypeError("Invalid major version");if(this.minor>L||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>L||this.patch<0)throw new TypeError("Invalid patch version");ie[4]?this.prerelease=ie[4].split(".").map(function($e){if(/^[0-9]+$/.test($e)){var Ee=+$e;if(Ee>=0&&Ee<L)return Ee}return $e}):this.prerelease=[],this.build=ie[5]?ie[5].split("."):[],this.format()}t.parse=F,t.valid=function(W,ee){var ie=F(W,ee);return ie?ie.version:null},t.clean=function(W,ee){var ie=F(W.trim().replace(/^[=v]+/,""),ee);return ie?ie.version:null},t.SemVer=q,q.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},q.prototype.toString=function(){return this.version},q.prototype.compare=function(W){return w("SemVer.compare",this.version,this.loose,W),W instanceof q||(W=new q(W,this.loose)),this.compareMain(W)||this.comparePre(W)},q.prototype.compareMain=function(W){return W instanceof q||(W=new q(W,this.loose)),V(this.major,W.major)||V(this.minor,W.minor)||V(this.patch,W.patch)},q.prototype.comparePre=function(W){if(W instanceof q||(W=new q(W,this.loose)),this.prerelease.length&&!W.prerelease.length)return-1;if(!this.prerelease.length&&W.prerelease.length)return 1;if(!this.prerelease.length&&!W.prerelease.length)return 0;var ee=0;do{var ie=this.prerelease[ee],$e=W.prerelease[ee];if(w("prerelease compare",ee,ie,$e),ie===void 0&&$e===void 0)return 0;if($e===void 0)return 1;if(ie===void 0)return-1;if(ie!==$e)return V(ie,$e)}while(++ee)},q.prototype.inc=function(W,ee){switch(W){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",ee);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",ee);break;case"prepatch":this.prerelease.length=0,this.inc("patch",ee),this.inc("pre",ee);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",ee),this.inc("pre",ee);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var ie=this.prerelease.length;--ie>=0;)typeof this.prerelease[ie]=="number"&&(this.prerelease[ie]++,ie=-2);ie===-1&&this.prerelease.push(0)}ee&&(this.prerelease[0]===ee?isNaN(this.prerelease[1])&&(this.prerelease=[ee,0]):this.prerelease=[ee,0]);break;default:throw new Error("invalid increment argument: "+W)}return this.format(),this.raw=this.version,this},t.inc=function(W,ee,ie,$e){typeof ie=="string"&&($e=ie,ie=void 0);try{return new q(W,ie).inc(ee,$e).version}catch{return null}},t.diff=function(W,ee){if(C(W,ee))return null;var ie=F(W),$e=F(ee);if(ie.prerelease.length||$e.prerelease.length){for(var Ee in ie)if((Ee==="major"||Ee==="minor"||Ee==="patch")&&ie[Ee]!==$e[Ee])return"pre"+Ee;return"prerelease"}for(var Ee in ie)if((Ee==="major"||Ee==="minor"||Ee==="patch")&&ie[Ee]!==$e[Ee])return Ee},t.compareIdentifiers=V;var K=/^[0-9]+$/;function V(W,ee){var ie=K.test(W),$e=K.test(ee);return ie&&$e&&(W=+W,ee=+ee),ie&&!$e?-1:$e&&!ie?1:W<ee?-1:W>ee?1:0}function P(W,ee,ie){return new q(W,ie).compare(new q(ee,ie))}function j(W,ee,ie){return P(W,ee,ie)>0}function U(W,ee,ie){return P(W,ee,ie)<0}function C(W,ee,ie){return P(W,ee,ie)===0}function X(W,ee,ie){return P(W,ee,ie)!==0}function Z(W,ee,ie){return P(W,ee,ie)>=0}function ne(W,ee,ie){return P(W,ee,ie)<=0}function ce(W,ee,ie,$e){var Ee;switch(ee){case"===":typeof W=="object"&&(W=W.version),typeof ie=="object"&&(ie=ie.version),Ee=W===ie;break;case"!==":typeof W=="object"&&(W=W.version),typeof ie=="object"&&(ie=ie.version),Ee=W!==ie;break;case"":case"=":case"==":Ee=C(W,ie,$e);break;case"!=":Ee=X(W,ie,$e);break;case">":Ee=j(W,ie,$e);break;case">=":Ee=Z(W,ie,$e);break;case"<":Ee=U(W,ie,$e);break;case"<=":Ee=ne(W,ie,$e);break;default:throw new TypeError("Invalid operator: "+ee)}return Ee}function pe(W,ee){if(W instanceof pe){if(W.loose===ee)return W;W=W.value}if(!(this instanceof pe))return new pe(W,ee);w("comparator",W,ee),this.loose=ee,this.parse(W),this.semver===me?this.value="":this.value=this.operator+this.semver.version,w("comp",this)}t.rcompareIdentifiers=function(W,ee){return V(ee,W)},t.major=function(W,ee){return new q(W,ee).major},t.minor=function(W,ee){return new q(W,ee).minor},t.patch=function(W,ee){return new q(W,ee).patch},t.compare=P,t.compareLoose=function(W,ee){return P(W,ee,!0)},t.rcompare=function(W,ee,ie){return P(ee,W,ie)},t.sort=function(W,ee){return W.sort(function(ie,$e){return t.compare(ie,$e,ee)})},t.rsort=function(W,ee){return W.sort(function(ie,$e){return t.rcompare(ie,$e,ee)})},t.gt=j,t.lt=U,t.eq=C,t.neq=X,t.gte=Z,t.lte=ne,t.cmp=ce,t.Comparator=pe;var me={};function ge(W,ee){if(W instanceof ge)return W.loose===ee?W:new ge(W.raw,ee);if(W instanceof pe)return new ge(W.value,ee);if(!(this instanceof ge))return new ge(W,ee);if(this.loose=ee,this.raw=W,this.set=W.split(/\s*\|\|\s*/).map(function(ie){return this.parseRange(ie.trim())},this).filter(function(ie){return ie.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+W);this.format()}function we(W){return!W||W.toLowerCase()==="x"||W==="*"}function he(W,ee,ie,$e,Ee,Ae,ke,Ce,Re,Le,Me,Ne,Te){return((ee=we(ie)?"":we($e)?">="+ie+".0.0":we(Ee)?">="+ie+"."+$e+".0":">="+ee)+" "+(Ce=we(Re)?"":we(Le)?"<"+(+Re+1)+".0.0":we(Me)?"<"+Re+"."+(+Le+1)+".0":Ne?"<="+Re+"."+Le+"."+Me+"-"+Ne:"<="+Ce)).trim()}function de(W,ee){for(var ie=0;ie<W.length;ie++)if(!W[ie].test(ee))return!1;if(ee.prerelease.length){for(ie=0;ie<W.length;ie++)if(w(W[ie].semver),W[ie].semver!==me&&W[ie].semver.prerelease.length>0){var $e=W[ie].semver;if($e.major===ee.major&&$e.minor===ee.minor&&$e.patch===ee.patch)return!0}return!1}return!0}function ve(W,ee,ie){try{ee=new ge(ee,ie)}catch{return!1}return ee.test(W)}function Pe(W,ee,ie,$e){var Ee,Ae,ke,Ce,Re;switch(W=new q(W,$e),ee=new ge(ee,$e),ie){case">":Ee=j,Ae=ne,ke=U,Ce=">",Re=">=";break;case"<":Ee=U,Ae=Z,ke=j,Ce="<",Re="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(ve(W,ee,$e))return!1;for(var Le=0;Le<ee.set.length;++Le){var Me=ee.set[Le],Ne=null,Te=null;if(Me.forEach(function(Fe){Fe.semver===me&&(Fe=new pe(">=0.0.0")),Ne=Ne||Fe,Te=Te||Fe,Ee(Fe.semver,Ne.semver,$e)?Ne=Fe:ke(Fe.semver,Te.semver,$e)&&(Te=Fe)}),Ne.operator===Ce||Ne.operator===Re||(!Te.operator||Te.operator===Ce)&&Ae(W,Te.semver)||Te.operator===Re&&ke(W,Te.semver))return!1}return!0}pe.prototype.parse=function(W){var ee=this.loose?I[x]:I[_],ie=W.match(ee);if(!ie)throw new TypeError("Invalid comparator: "+W);this.operator=ie[1],this.operator==="="&&(this.operator=""),ie[2]?this.semver=new q(ie[2],this.loose):this.semver=me},pe.prototype.toString=function(){return this.value},pe.prototype.test=function(W){return w("Comparator.test",W,this.loose),this.semver===me||(typeof W=="string"&&(W=new q(W,this.loose)),ce(W,this.operator,this.semver,this.loose))},pe.prototype.intersects=function(W,ee){if(!(W instanceof pe))throw new TypeError("a Comparator is required");var ie;if(this.operator==="")return ie=new ge(W.value,ee),ve(this.value,ie,ee);if(W.operator==="")return ie=new ge(this.value,ee),ve(W.semver,ie,ee);var $e=!(this.operator!==">="&&this.operator!==">"||W.operator!==">="&&W.operator!==">"),Ee=!(this.operator!=="<="&&this.operator!=="<"||W.operator!=="<="&&W.operator!=="<"),Ae=this.semver.version===W.semver.version,ke=!(this.operator!==">="&&this.operator!=="<="||W.operator!==">="&&W.operator!=="<="),Ce=ce(this.semver,"<",W.semver,ee)&&(this.operator===">="||this.operator===">")&&(W.operator==="<="||W.operator==="<"),Re=ce(this.semver,">",W.semver,ee)&&(this.operator==="<="||this.operator==="<")&&(W.operator===">="||W.operator===">");return $e||Ee||Ae&&ke||Ce||Re},t.Range=ge,ge.prototype.format=function(){return this.range=this.set.map(function(W){return W.join(" ").trim()}).join("||").trim(),this.range},ge.prototype.toString=function(){return this.range},ge.prototype.parseRange=function(W){var ee=this.loose;W=W.trim(),w("range",W,ee);var ie=ee?I[G]:I[M];W=W.replace(ie,he),w("hyphen replace",W),W=W.replace(I[B],"$1$2$3"),w("comparator trim",W,I[B]),W=(W=(W=W.replace(I[z],"$1~")).replace(I[le],"$1^")).split(/\s+/).join(" ");var $e=ee?I[x]:I[_],Ee=W.split(" ").map(function(Ae){return function(ke,Ce){return w("comp",ke),ke=function(Re,Le){return Re.trim().split(/\s+/).map(function(Me){return function(Ne,Te){w("caret",Ne,Te);var Fe=Te?I[fe]:I[ue];return Ne.replace(Fe,function(Ue,Se,Ie,Oe,De){var je;return w("caret",Ne,Ue,Se,Ie,Oe,De),we(Se)?je="":we(Ie)?je=">="+Se+".0.0 <"+(+Se+1)+".0.0":we(Oe)?je=Se==="0"?">="+Se+"."+Ie+".0 <"+Se+"."+(+Ie+1)+".0":">="+Se+"."+Ie+".0 <"+(+Se+1)+".0.0":De?(w("replaceCaret pr",De),De.charAt(0)!=="-"&&(De="-"+De),je=Se==="0"?Ie==="0"?">="+Se+"."+Ie+"."+Oe+De+" <"+Se+"."+Ie+"."+(+Oe+1):">="+Se+"."+Ie+"."+Oe+De+" <"+Se+"."+(+Ie+1)+".0":">="+Se+"."+Ie+"."+Oe+De+" <"+(+Se+1)+".0.0"):(w("no pr"),je=Se==="0"?Ie==="0"?">="+Se+"."+Ie+"."+Oe+" <"+Se+"."+Ie+"."+(+Oe+1):">="+Se+"."+Ie+"."+Oe+" <"+Se+"."+(+Ie+1)+".0":">="+Se+"."+Ie+"."+Oe+" <"+(+Se+1)+".0.0"),w("caret return",je),je})}(Me,Le)}).join(" ")}(ke,Ce),w("caret",ke),ke=function(Re,Le){return Re.trim().split(/\s+/).map(function(Me){return function(Ne,Te){var Fe=Te?I[Q]:I[J];return Ne.replace(Fe,function(Ue,Se,Ie,Oe,De){var je;return w("tilde",Ne,Ue,Se,Ie,Oe,De),we(Se)?je="":we(Ie)?je=">="+Se+".0.0 <"+(+Se+1)+".0.0":we(Oe)?je=">="+Se+"."+Ie+".0 <"+Se+"."+(+Ie+1)+".0":De?(w("replaceTilde pr",De),De.charAt(0)!=="-"&&(De="-"+De),je=">="+Se+"."+Ie+"."+Oe+De+" <"+Se+"."+(+Ie+1)+".0"):je=">="+Se+"."+Ie+"."+Oe+" <"+Se+"."+(+Ie+1)+".0",w("tilde return",je),je})}(Me,Le)}).join(" ")}(ke,Ce),w("tildes",ke),ke=function(Re,Le){return w("replaceXRanges",Re,Le),Re.split(/\s+/).map(function(Me){return function(Ne,Te){Ne=Ne.trim();var Fe=Te?I[T]:I[R];return Ne.replace(Fe,function(Ue,Se,Ie,Oe,De,je){w("xRange",Ne,Ue,Se,Ie,Oe,De,je);var Ve=we(Ie),ze=Ve||we(Oe),Be=ze||we(De);return Se==="="&&Be&&(Se=""),Ve?Ue=Se===">"||Se==="<"?"<0.0.0":"*":Se&&Be?(ze&&(Oe=0),Be&&(De=0),Se===">"?(Se=">=",ze?(Ie=+Ie+1,Oe=0,De=0):Be&&(Oe=+Oe+1,De=0)):Se==="<="&&(Se="<",ze?Ie=+Ie+1:Oe=+Oe+1),Ue=Se+Ie+"."+Oe+"."+De):ze?Ue=">="+Ie+".0.0 <"+(+Ie+1)+".0.0":Be&&(Ue=">="+Ie+"."+Oe+".0 <"+Ie+"."+(+Oe+1)+".0"),w("xRange return",Ue),Ue})}(Me,Le)}).join(" ")}(ke,Ce),w("xrange",ke),ke=function(Re,Le){return w("replaceStars",Re,Le),Re.trim().replace(I[Y],"")}(ke,Ce),w("stars",ke),ke}(Ae,ee)}).join(" ").split(/\s+/);return this.loose&&(Ee=Ee.filter(function(Ae){return!!Ae.match($e)})),Ee=Ee.map(function(Ae){return new pe(Ae,ee)})},ge.prototype.intersects=function(W,ee){if(!(W instanceof ge))throw new TypeError("a Range is required");return this.set.some(function(ie){return ie.every(function($e){return W.set.some(function(Ee){return Ee.every(function(Ae){return $e.intersects(Ae,ee)})})})})},t.toComparators=function(W,ee){return new ge(W,ee).set.map(function(ie){return ie.map(function($e){return $e.value}).join(" ").trim().split(" ")})},ge.prototype.test=function(W){if(!W)return!1;typeof W=="string"&&(W=new q(W,this.loose));for(var ee=0;ee<this.set.length;ee++)if(de(this.set[ee],W))return!0;return!1},t.satisfies=ve,t.maxSatisfying=function(W,ee,ie){var $e=null,Ee=null;try{var Ae=new ge(ee,ie)}catch{return null}return W.forEach(function(ke){Ae.test(ke)&&($e&&Ee.compare(ke)!==-1||(Ee=new q($e=ke,ie)))}),$e},t.minSatisfying=function(W,ee,ie){var $e=null,Ee=null;try{var Ae=new ge(ee,ie)}catch{return null}return W.forEach(function(ke){Ae.test(ke)&&($e&&Ee.compare(ke)!==1||(Ee=new q($e=ke,ie)))}),$e},t.validRange=function(W,ee){try{return new ge(W,ee).range||"*"}catch{return null}},t.ltr=function(W,ee,ie){return Pe(W,ee,"<",ie)},t.gtr=function(W,ee,ie){return Pe(W,ee,">",ie)},t.outside=Pe,t.prerelease=function(W,ee){var ie=F(W,ee);return ie&&ie.prerelease.length?ie.prerelease:null},t.intersects=function(W,ee,ie){return W=new ge(W,ie),ee=new ge(ee,ie),W.intersects(ee)},t.coerce=function(W){if(W instanceof q)return W;if(typeof W!="string")return null;var ee=W.match(I[D]);return ee==null?null:F((ee[1]||"0")+"."+(ee[2]||"0")+"."+(ee[3]||"0"))}}).call(this,E(1))},function(H,t){var E,S,w=H.exports={};function O(){throw new Error("setTimeout has not been defined")}function L(){throw new Error("clearTimeout has not been defined")}function I(v){if(E===setTimeout)return setTimeout(v,0);if((E===O||!E)&&setTimeout)return E=setTimeout,setTimeout(v,0);try{return E(v,0)}catch{try{return E.call(null,v,0)}catch{return E.call(this,v,0)}}}(function(){try{E=typeof setTimeout=="function"?setTimeout:O}catch{E=O}try{S=typeof clearTimeout=="function"?clearTimeout:L}catch{S=L}})();var m,l=[],c=!1,h=-1;function u(){c&&m&&(c=!1,m.length?l=m.concat(l):h=-1,l.length&&$())}function $(){if(!c){var v=I(u);c=!0;for(var d=l.length;d;){for(m=l,l=[];++h<d;)m&&m[h].run();h=-1,d=l.length}m=null,c=!1,function(p){if(S===clearTimeout)return clearTimeout(p);if((S===L||!S)&&clearTimeout)return S=clearTimeout,clearTimeout(p);try{S(p)}catch{try{return S.call(null,p)}catch{return S.call(this,p)}}}(v)}}function g(v,d){this.fun=v,this.array=d}function N(){}w.nextTick=function(v){var d=new Array(arguments.length-1);if(arguments.length>1)for(var p=1;p<arguments.length;p++)d[p-1]=arguments[p];l.push(new g(v,d)),l.length!==1||c||I($)},g.prototype.run=function(){this.fun.apply(null,this.array)},w.title="browser",w.browser=!0,w.env={},w.argv=[],w.version="",w.versions={},w.on=N,w.addListener=N,w.once=N,w.off=N,w.removeListener=N,w.removeAllListeners=N,w.emit=N,w.prependListener=N,w.prependOnceListener=N,w.listeners=function(v){return[]},w.binding=function(v){throw new Error("process.binding is not supported")},w.cwd=function(){return"/"},w.chdir=function(v){throw new Error("process.chdir is not supported")},w.umask=function(){return 0}}])}),define(oe[79],ae([0,1]),function(H,t){"use strict";var E;Object.defineProperty(t,"__esModule",{value:!0}),t.$Rs=void 0;class S{constructor(I,m,l){this.level=I,this.key=m,this.value=l,this.forward=[]}}const w=void 0;class O{constructor(I,m=2**16){this.comparator=I,this[E]="SkipList",this.d=0,this.f=0,this.c=Math.max(1,Math.log2(m)|0),this.e=new S(this.c,w,w)}get size(){return this.f}clear(){this.e=new S(this.c,w,w),this.f=0}has(I){return!!O.g(this,I,this.comparator)}get(I){return O.g(this,I,this.comparator)?.value}set(I,m){return O.h(this,I,m,this.comparator)&&(this.f+=1),this}delete(I){const m=O.k(this,I,this.comparator);return m&&(this.f-=1),m}forEach(I,m){let l=this.e.forward[0];for(;l;)I.call(m,l.value,l.key,this),l=l.forward[0]}[(E=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}*entries(){let I=this.e.forward[0];for(;I;)yield[I.key,I.value],I=I.forward[0]}*keys(){let I=this.e.forward[0];for(;I;)yield I.key,I=I.forward[0]}*values(){let I=this.e.forward[0];for(;I;)yield I.value,I=I.forward[0]}toString(){let I="[SkipList]:",m=this.e.forward[0];for(;m;)I+=`node(${m.key}, ${m.value}, lvl:${m.level})`,m=m.forward[0];return I}static g(I,m,l){let c=I.e;for(let h=I.d-1;h>=0;h--)for(;c.forward[h]&&l(c.forward[h].key,m)<0;)c=c.forward[h];if(c=c.forward[0],c&&l(c.key,m)===0)return c}static h(I,m,l,c){const h=[];let u=I.e;for(let $=I.d-1;$>=0;$--){for(;u.forward[$]&&c(u.forward[$].key,m)<0;)u=u.forward[$];h[$]=u}if(u=u.forward[0],u&&c(u.key,m)===0)return u.value=l,!1;{const $=O.j(I);if($>I.d){for(let g=I.d;g<$;g++)h[g]=I.e;I.d=$}u=new S($,m,l);for(let g=0;g<$;g++)u.forward[g]=h[g].forward[g],h[g].forward[g]=u;return!0}}static j(I,m=.5){let l=1;for(;Math.random()<m&&l<I.c;)l+=1;return l}static k(I,m,l){const c=[];let h=I.e;for(let u=I.d-1;u>=0;u--){for(;h.forward[u]&&l(h.forward[u].key,m)<0;)h=h.forward[u];c[u]=h}if(h=h.forward[0],!h||l(h.key,m)!==0)return!1;for(let u=0;u<I.d&&c[u].forward[u]===h;u++)c[u].forward[u]=h.forward[u];for(;I.d>0&&I.e.forward[I.d-1]===w;)I.d-=1;return!0}}t.$Rs=O}),define(oe[47],ae([0,1,9,2]),function(H,t,E,S){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Ae=w,t.$Be=O,t.$Ce=L,t.$De=I,t.$Ee=l,t.$Fe=c,t.$Ge=h,t.$He=u,t.$Ie=$,t.$Je=g,t.$Ke=N,t.$Le=v,t.$Me=d,t.$Ne=p,t.$Oe=k;function w(y){const e=y;return e?typeof e.read=="function":!1}function O(y){const e=y;return e?[e.on,e.pause,e.resume,e.destroy].every(a=>typeof a=="function"):!1}function L(y){const e=y;return e?O(e.stream)&&Array.isArray(e.buffer)&&typeof e.ended=="boolean":!1}function I(y,e){return new m(y,e)}class m{constructor(e,a){this.e=e,this.f=a,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(e){if(!this.a.destroyed){if(this.a.flowing)this.g(e);else if(this.b.data.push(e),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(a=>this.d.push(a))}}error(e){this.a.destroyed||(this.a.flowing?this.h(e):this.b.error.push(e))}end(e){this.a.destroyed||(typeof e<"u"&&this.write(e),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(e){this.c.data.slice(0).forEach(a=>a(e))}h(e){this.c.error.length===0?(0,E.$3)(e):this.c.error.slice(0).forEach(a=>a(e))}i(){this.c.end.slice(0).forEach(e=>e())}on(e,a){if(!this.a.destroyed)switch(e){case"data":this.c.data.push(a),this.resume();break;case"end":this.c.end.push(a),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(a),this.a.flowing&&this.k();break}}removeListener(e,a){if(this.a.destroyed)return;let n;switch(e){case"data":n=this.c.data;break;case"end":n=this.c.end;break;case"error":n=this.c.error;break}if(n){const r=n.indexOf(a);r>=0&&n.splice(r,1)}}j(){if(this.b.data.length>0){const e=this.e(this.b.data);this.g(e),this.b.data.length=0;const a=[...this.d];this.d.length=0,a.forEach(n=>n())}}k(){if(this.c.error.length>0){for(const e of this.b.error)this.h(e);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function l(y,e){const a=[];let n;for(;(n=y.read())!==null;)a.push(n);return e(a)}function c(y,e,a){const n=[];let r;for(;(r=y.read())!==null&&n.length<a;)n.push(r);return r===null&&n.length>0?e(n):{read:()=>{if(n.length>0)return n.shift();if(typeof r<"u"){const i=r;return r=void 0,i}return y.read()}}}function h(y,e){return new Promise((a,n)=>{const r=[];u(y,{onData:i=>{e&&r.push(i)},onError:i=>{e?n(i):a(void 0)},onEnd:()=>{a(e?e(r):void 0)}})})}function u(y,e,a){y.on("error",n=>{a?.isCancellationRequested||e.onError(n)}),y.on("end",()=>{a?.isCancellationRequested||e.onEnd()}),y.on("data",n=>{a?.isCancellationRequested||e.onData(n)})}function $(y,e){return new Promise((a,n)=>{const r=new S.$Wc,i=[],s=b=>{if(i.push(b),i.length>e)return r.dispose(),y.pause(),a({stream:y,buffer:i,ended:!1})},o=b=>(r.dispose(),n(b)),f=()=>(r.dispose(),a({stream:y,buffer:i,ended:!0}));r.add((0,S.$Vc)(()=>y.removeListener("error",o))),y.on("error",o),r.add((0,S.$Vc)(()=>y.removeListener("end",f))),y.on("end",f),r.add((0,S.$Vc)(()=>y.removeListener("data",s))),y.on("data",s)})}function g(y,e){const a=I(e);return a.end(y),a}function N(){const y=I(()=>{throw new Error("not supported")});return y.end(),y}function v(y){let e=!1;return{read:()=>e?null:(e=!0,y)}}function d(y,e,a){const n=I(a);return u(y,{onData:r=>n.write(e.data(r)),onError:r=>n.error(e.error?e.error(r):r),onEnd:()=>n.end()}),n}function p(y,e,a){let n=!1;return{read:()=>{const r=e.read();return n?r:(n=!0,r!==null?a([y,r]):y)}}}function k(y,e,a){let n=!1;const r=I(a);return u(e,{onData:i=>n?r.write(i):(n=!0,r.write(a([y,i]))),onError:i=>r.error(i),onEnd:()=>{n||(n=!0,r.write(y)),r.end()}}),r}});var We=this&&this.__createBinding||(Object.create?function(H,t,E,S){S===void 0&&(S=E);var w=Object.getOwnPropertyDescriptor(t,E);(!w||("get"in w?!t.__esModule:w.writable||w.configurable))&&(w={enumerable:!0,get:function(){return t[E]}}),Object.defineProperty(H,S,w)}:function(H,t,E,S){S===void 0&&(S=E),H[S]=t[E]}),xe=this&&this.__setModuleDefault||(Object.create?function(H,t){Object.defineProperty(H,"default",{enumerable:!0,value:t})}:function(H,t){H.default=t}),be=this&&this.__importStar||function(H){if(H&&H.__esModule)return H;var t={};if(H!=null)for(var E in H)E!=="default"&&Object.prototype.hasOwnProperty.call(H,E)&&We(t,H,E);return xe(t,H),t};define(oe[14],ae([0,1,171,47]),function(H,t,E,S){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Pe=void 0,t.$Qe=l,t.$Re=c,t.$Se=h,t.$Te=u,t.$Ue=$,t.$Ve=g,t.$We=N,t.$Xe=v,t.$Ye=d,t.$Ze=p,t.$1e=k,t.$2e=y,t.$3e=e,t.$4e=a,t.$5e=n,t.$6e=r,t.$7e=i,t.$8e=s,t.$9e=o,t.$0e=R,S=be(S);const w=typeof Buffer<"u",O=new E.$X(()=>new Uint8Array(256));let L,I;class m{static alloc(D){return w?new m(Buffer.allocUnsafe(D)):new m(new Uint8Array(D))}static wrap(D){return w&&!Buffer.isBuffer(D)&&(D=Buffer.from(D.buffer,D.byteOffset,D.byteLength)),new m(D)}static fromString(D,A){return!(A?.dontUseNodeBuffer||!1)&&w?new m(Buffer.from(D)):(L||(L=new TextEncoder),new m(L.encode(D)))}static fromByteArray(D){const A=m.alloc(D.length);for(let z=0,J=D.length;z<J;z++)A.buffer[z]=D[z];return A}static concat(D,A){if(typeof A>"u"){A=0;for(let Q=0,se=D.length;Q<se;Q++)A+=D[Q].byteLength}const z=m.alloc(A);let J=0;for(let Q=0,se=D.length;Q<se;Q++){const le=D[Q];z.set(le,J),J+=le.byteLength}return z}constructor(D){this.buffer=D,this.byteLength=this.buffer.byteLength}clone(){const D=m.alloc(this.byteLength);return D.set(this),D}toString(){return w?this.buffer.toString():(I||(I=new TextDecoder),I.decode(this.buffer))}slice(D,A){return new m(this.buffer.subarray(D,A))}set(D,A){if(D instanceof m)this.buffer.set(D.buffer,A);else if(D instanceof Uint8Array)this.buffer.set(D,A);else if(D instanceof ArrayBuffer)this.buffer.set(new Uint8Array(D),A);else if(ArrayBuffer.isView(D))this.buffer.set(new Uint8Array(D.buffer,D.byteOffset,D.byteLength),A);else throw new Error("Unknown argument 'array'")}readUInt32BE(D){return u(this.buffer,D)}writeUInt32BE(D,A){$(this.buffer,D,A)}readUInt32LE(D){return g(this.buffer,D)}writeUInt32LE(D,A){N(this.buffer,D,A)}readUInt8(D){return v(this.buffer,D)}writeUInt8(D,A){d(this.buffer,D,A)}indexOf(D,A=0){return l(this.buffer,D instanceof m?D.buffer:D,A)}}t.$Pe=m;function l(T,D,A=0){const z=D.byteLength,J=T.byteLength;if(z===0)return 0;if(z===1)return T.indexOf(D[0]);if(z>J-A)return-1;const Q=O.value;Q.fill(D.length);for(let fe=0;fe<D.length;fe++)Q[D[fe]]=D.length-fe-1;let se=A+D.length-1,le=se,ue=-1;for(;se<J;)if(T[se]===D[le]){if(le===0){ue=se;break}se--,le--}else se+=Math.max(D.length-le,Q[T[se]]),le=D.length-1;return ue}function c(T,D){return T[D+0]<<0>>>0|T[D+1]<<8>>>0}function h(T,D,A){T[A+0]=D&255,D=D>>>8,T[A+1]=D&255}function u(T,D){return T[D]*2**24+T[D+1]*2**16+T[D+2]*2**8+T[D+3]}function $(T,D,A){T[A+3]=D,D=D>>>8,T[A+2]=D,D=D>>>8,T[A+1]=D,D=D>>>8,T[A]=D}function g(T,D){return T[D+0]<<0>>>0|T[D+1]<<8>>>0|T[D+2]<<16>>>0|T[D+3]<<24>>>0}function N(T,D,A){T[A+0]=D&255,D=D>>>8,T[A+1]=D&255,D=D>>>8,T[A+2]=D&255,D=D>>>8,T[A+3]=D&255}function v(T,D){return T[D]}function d(T,D,A){T[A]=D}function p(T){return S.$Ee(T,D=>m.concat(D))}function k(T){return S.$Le(T)}function y(T){return S.$Ge(T,D=>m.concat(D))}async function e(T){return T.ended?m.concat(T.buffer):m.concat([...T.buffer,await y(T.stream)])}function a(T){return S.$Je(T,D=>m.concat(D))}function n(T){return S.$Me(T,{data:D=>typeof D=="string"?m.fromString(D):m.wrap(D)},D=>m.concat(D))}function r(T){return S.$De(D=>m.concat(D),T)}function i(T,D){return S.$Ne(T,D,A=>m.concat(A))}function s(T,D){return S.$Oe(T,D,A=>m.concat(A))}function o(T){let D=0,A=0,z=0;const J=new Uint8Array(Math.floor(T.length/4*3)),Q=le=>{switch(A){case 3:J[z++]=D|le,A=0;break;case 2:J[z++]=D|le>>>2,D=le<<6,A=3;break;case 1:J[z++]=D|le>>>4,D=le<<4,A=2;break;default:D=le<<2,A=1}};for(let le=0;le<T.length;le++){const ue=T.charCodeAt(le);if(ue>=65&&ue<=90)Q(ue-65);else if(ue>=97&&ue<=122)Q(ue-97+26);else if(ue>=48&&ue<=57)Q(ue-48+52);else if(ue===43||ue===45)Q(62);else if(ue===47||ue===95)Q(63);else{if(ue===61)break;throw new SyntaxError(`Unexpected base64 character ${T[le]}`)}}const se=z;for(;A>0;)Q(0);return m.wrap(J).slice(0,se)}const f="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",b="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function R({buffer:T},D=!0,A=!1){const z=A?b:f;let J="";const Q=T.byteLength%3;let se=0;for(;se<T.byteLength-Q;se+=3){const le=T[se+0],ue=T[se+1],fe=T[se+2];J+=z[le>>>2],J+=z[(le<<4|ue>>>4)&63],J+=z[(ue<<2|fe>>>6)&63],J+=z[fe&63]}if(Q===1){const le=T[se+0];J+=z[le>>>2],J+=z[le<<4&63],D&&(J+="==")}else if(Q===2){const le=T[se+0],ue=T[se+1];J+=z[le>>>2],J+=z[(le<<4|ue>>>4)&63],J+=z[ue<<2&63],D&&(J+="=")}return J}}),define(oe[28],ae([0,1,3]),function(H,t,E){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$eo=S,t.$fo=w,t.$go=L,t.$ho=m,t.$io=l,t.$jo=c,t.$ko=h,t.$lo=u,t.$mo=$,t.$no=g,t.$oo=N,t.$po=v,t.$qo=d;function S(p){if(!p||typeof p!="object"||p instanceof RegExp)return p;const k=Array.isArray(p)?[]:{};return Object.entries(p).forEach(([y,e])=>{k[y]=e&&typeof e=="object"?S(e):e}),k}function w(p){if(!p||typeof p!="object")return p;const k=[p];for(;k.length>0;){const y=k.shift();Object.freeze(y);for(const e in y)if(O.call(y,e)){const a=y[e];typeof a=="object"&&!Object.isFrozen(a)&&!(0,E.$jg)(a)&&k.push(a)}}return p}const O=Object.prototype.hasOwnProperty;function L(p,k){return I(p,k,new Set)}function I(p,k,y){if((0,E.$pg)(p))return p;const e=k(p);if(typeof e<"u")return e;if(Array.isArray(p)){const a=[];for(const n of p)a.push(I(n,k,y));return a}if((0,E.$ig)(p)){if(y.has(p))throw new Error("Cannot clone recursive data-structure");y.add(p);const a={};for(const n in p)O.call(p,n)&&(a[n]=I(p[n],k,y));return y.delete(p),a}return p}function m(p,k,y=!0){return(0,E.$ig)(p)?((0,E.$ig)(k)&&Object.keys(k).forEach(e=>{e in p?y&&((0,E.$ig)(p[e])&&(0,E.$ig)(k[e])?m(p[e],k[e],y):p[e]=k[e]):p[e]=k[e]}),p):k}function l(p,k){if(p===k)return!0;if(p==null||k===null||k===void 0||typeof p!=typeof k||typeof p!="object"||Array.isArray(p)!==Array.isArray(k))return!1;let y,e;if(Array.isArray(p)){if(p.length!==k.length)return!1;for(y=0;y<p.length;y++)if(!l(p[y],k[y]))return!1}else{const a=[];for(e in p)a.push(e);a.sort();const n=[];for(e in k)n.push(e);if(n.sort(),!l(a,n))return!1;for(y=0;y<a.length;y++)if(!l(p[a[y]],k[a[y]]))return!1}return!0}function c(p){const k=new Set;return JSON.stringify(p,(y,e)=>{if((0,E.$ig)(e)||Array.isArray(e)){if(k.has(e))return"[Circular]";k.add(e)}return typeof e=="bigint"?`[BigInt ${e.toString()}]`:e})}function h(p,k){const y=Object.create(null);return!p||!k||Object.keys(k).forEach(a=>{const n=p[a],r=k[a];l(n,r)||(y[a]=r)}),y}function u(p,k){const y=k.toLowerCase(),e=Object.keys(p).find(a=>a.toLowerCase()===y);return e?p[e]:p[k]}function $(p,k){const y=Object.create(null);for(const[e,a]of Object.entries(p))k(e,a)&&(y[e]=a);return y}function g(p){let k=[];for(;Object.prototype!==p;)k=k.concat(Object.getOwnPropertyNames(p)),p=Object.getPrototypeOf(p);return k}function N(p){const k=[];for(const y of g(p))typeof p[y]=="function"&&k.push(y);return k}function v(p,k){const y=a=>function(){const n=Array.prototype.slice.call(arguments,0);return k(a,n)},e={};for(const a of p)e[a]=y(a);return e}function d(p,k){const y={};for(const[e,a]of Object.entries(p))y[e]=k(a,e);return y}}),define(oe[43],ae([0,1,32]),function(H,t,E){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Aj=t.$yj=void 0,t.$uj=S,t.$vj=w,t.$wj=O,t.$xj=I,t.$zj=N,E=be(E);function S(d){return w(d,0)}function w(d,p){switch(typeof d){case"object":return d===null?O(349,p):Array.isArray(d)?m(d,p):l(d,p);case"string":return I(d,p);case"boolean":return L(d,p);case"number":return O(d,p);case"undefined":return O(937,p);default:return O(617,p)}}function O(d,p){return(p<<5)-p+d|0}function L(d,p){return O(d?433:863,p)}function I(d,p){p=O(149417,p);for(let k=0,y=d.length;k<y;k++)p=O(d.charCodeAt(k),p);return p}function m(d,p){return p=O(104579,p),d.reduce((k,y)=>w(y,k),p)}function l(d,p){return p=O(181387,p),Object.keys(d).sort().reduce((k,y)=>(k=I(y,k),w(d[y],k)),p)}class c{constructor(){this.g=0}get value(){return this.g}hash(p){return this.g=w(p,this.g),this.g}}t.$yj=c;var h;(function(d){d[d.BLOCK_SIZE=64]="BLOCK_SIZE",d[d.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(h||(h={}));function u(d,p,k=32){const y=k-p,e=~((1<<y)-1);return(d<<p|(e&d)>>>y)>>>0}function $(d,p=0,k=d.byteLength,y=0){for(let e=0;e<k;e++)d[p+e]=y}function g(d,p,k="0"){for(;d.length<p;)d=k+d;return d}function N(d,p=32){return d instanceof ArrayBuffer?Array.from(new Uint8Array(d)).map(k=>k.toString(16).padStart(2,"0")).join(""):g((d>>>0).toString(16),p/4)}class v{static{this.g=new DataView(new ArrayBuffer(320))}constructor(){this.h=1732584193,this.l=4023233417,this.m=2562383102,this.n=271733878,this.o=3285377520,this.p=new Uint8Array(h.BLOCK_SIZE+3),this.q=new DataView(this.p.buffer),this.r=0,this.t=0,this.u=0,this.v=!1}update(p){const k=p.length;if(k===0)return;const y=this.p;let e=this.r,a=this.u,n,r;for(a!==0?(n=a,r=-1,a=0):(n=p.charCodeAt(0),r=0);;){let i=n;if(E.$Lf(n))if(r+1<k){const s=p.charCodeAt(r+1);E.$Mf(s)?(r++,i=E.$Nf(n,s)):i=h.UNICODE_REPLACEMENT}else{a=n;break}else E.$Mf(n)&&(i=h.UNICODE_REPLACEMENT);if(e=this.w(y,e,i),r++,r<k)n=p.charCodeAt(r);else break}this.r=e,this.u=a}w(p,k,y){return y<128?p[k++]=y:y<2048?(p[k++]=192|(y&1984)>>>6,p[k++]=128|(y&63)>>>0):y<65536?(p[k++]=224|(y&61440)>>>12,p[k++]=128|(y&4032)>>>6,p[k++]=128|(y&63)>>>0):(p[k++]=240|(y&1835008)>>>18,p[k++]=128|(y&258048)>>>12,p[k++]=128|(y&4032)>>>6,p[k++]=128|(y&63)>>>0),k>=h.BLOCK_SIZE&&(this.y(),k-=h.BLOCK_SIZE,this.t+=h.BLOCK_SIZE,p[0]=p[h.BLOCK_SIZE+0],p[1]=p[h.BLOCK_SIZE+1],p[2]=p[h.BLOCK_SIZE+2]),k}digest(){return this.v||(this.v=!0,this.u&&(this.u=0,this.r=this.w(this.p,this.r,h.UNICODE_REPLACEMENT)),this.t+=this.r,this.x()),N(this.h)+N(this.l)+N(this.m)+N(this.n)+N(this.o)}x(){this.p[this.r++]=128,$(this.p,this.r),this.r>56&&(this.y(),$(this.p));const p=8*this.t;this.q.setUint32(56,Math.floor(p/4294967296),!1),this.q.setUint32(60,p%4294967296,!1),this.y()}y(){const p=v.g,k=this.q;for(let f=0;f<64;f+=4)p.setUint32(f,k.getUint32(f,!1),!1);for(let f=64;f<320;f+=4)p.setUint32(f,u(p.getUint32(f-12,!1)^p.getUint32(f-32,!1)^p.getUint32(f-56,!1)^p.getUint32(f-64,!1),1),!1);let y=this.h,e=this.l,a=this.m,n=this.n,r=this.o,i,s,o;for(let f=0;f<80;f++)f<20?(i=e&a|~e&n,s=1518500249):f<40?(i=e^a^n,s=1859775393):f<60?(i=e&a|e&n|a&n,s=2400959708):(i=e^a^n,s=3395469782),o=u(y,5)+i+r+s+p.getUint32(f*4,!1)&4294967295,r=n,n=a,a=u(e,30),e=y,y=o;this.h=this.h+y&4294967295,this.l=this.l+e&4294967295,this.m=this.m+a&4294967295,this.n=this.n+n&4294967295,this.o=this.o+r&4294967295}}t.$Aj=v}),define(oe[56],ae([0,1,32]),function(H,t,E){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),E=be(E);var S;(function(w){w[w.Ignore=0]="Ignore",w[w.Info=1]="Info",w[w.Warning=2]="Warning",w[w.Error=3]="Error"})(S||(S={})),function(w){const O="error",L="warning",I="warn",m="info",l="ignore";function c(u){return u?E.$Hf(O,u)?w.Error:E.$Hf(L,u)||E.$Hf(I,u)?w.Warning:E.$Hf(m,u)?w.Info:w.Ignore:w.Ignore}w.fromValue=c;function h(u){switch(u){case w.Error:return O;case w.Warning:return L;case w.Info:return m;default:return l}}w.toString=h}(S||(S={})),t.default=S}),define(oe[29],ae([0,1]),function(H,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$3g=void 0,t.$2g=S;const E=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function S(w){return E.test(w)}t.$3g=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let w;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?w=crypto.getRandomValues.bind(crypto):w=function(I){for(let m=0;m<I.length;m++)I[m]=Math.floor(Math.random()*256);return I};const O=new Uint8Array(16),L=[];for(let I=0;I<256;I++)L.push(I.toString(16).padStart(2,"0"));return function(){w(O),O[6]=O[6]&15|64,O[8]=O[8]&63|128;let m=0,l="";return l+=L[O[m++]],l+=L[O[m++]],l+=L[O[m++]],l+=L[O[m++]],l+="-",l+=L[O[m++]],l+=L[O[m++]],l+="-",l+=L[O[m++]],l+=L[O[m++]],l+="-",l+=L[O[m++]],l+=L[O[m++]],l+="-",l+=L[O[m++]],l+=L[O[m++]],l+=L[O[m++]],l+=L[O[m++]],l+=L[O[m++]],l+=L[O[m++]],l}}()}),define(oe[80],ae([0,1,35]),function(H,t,E){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Rn=O;const S=new Set(["00:00:00:00:00:00","ff:ff:ff:ff:ff:ff","ac:de:48:00:11:22"]);function w(L){const I=L.replace(/\-/g,":").toLowerCase();return!S.has(I)}function O(){const L=(0,E.networkInterfaces)();for(const I in L){const m=L[I];if(m){for(const{mac:l}of m)if(w(l))return l}}throw new Error("Unable to retrieve mac address (unexpected format)")}}),define(oe[81],ae([7,4]),function(H,t){return H.create("vs/base/common/date",t)}),define(oe[82],ae([0,1,81]),function(H,t,E){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$2m=l,t.$3m=c,t.$4m=h;const S=60,w=S*60,O=w*24,L=O*7,I=O*30,m=O*365;function l(u,$,g,N){typeof u!="number"&&(u=u.getTime());const v=Math.round((new Date().getTime()-u)/1e3);if(v<-30)return(0,E.localize)(0,null,l(new Date().getTime()+v*1e3,!1));if(!N&&v<30)return(0,E.localize)(1,null);let d;return v<S?(d=v,$?d===1?g?(0,E.localize)(2,null,d):(0,E.localize)(3,null,d):g?(0,E.localize)(4,null,d):(0,E.localize)(5,null,d):d===1?g?(0,E.localize)(6,null,d):(0,E.localize)(7,null,d):g?(0,E.localize)(8,null,d):(0,E.localize)(9,null,d)):v<w?(d=Math.floor(v/S),$?d===1?g?(0,E.localize)(10,null,d):(0,E.localize)(11,null,d):g?(0,E.localize)(12,null,d):(0,E.localize)(13,null,d):d===1?g?(0,E.localize)(14,null,d):(0,E.localize)(15,null,d):g?(0,E.localize)(16,null,d):(0,E.localize)(17,null,d)):v<O?(d=Math.floor(v/w),$?d===1?g?(0,E.localize)(18,null,d):(0,E.localize)(19,null,d):g?(0,E.localize)(20,null,d):(0,E.localize)(21,null,d):d===1?g?(0,E.localize)(22,null,d):(0,E.localize)(23,null,d):g?(0,E.localize)(24,null,d):(0,E.localize)(25,null,d)):v<L?(d=Math.floor(v/O),$?d===1?(0,E.localize)(26,null,d):(0,E.localize)(27,null,d):d===1?(0,E.localize)(28,null,d):(0,E.localize)(29,null,d)):v<I?(d=Math.floor(v/L),$?d===1?g?(0,E.localize)(30,null,d):(0,E.localize)(31,null,d):g?(0,E.localize)(32,null,d):(0,E.localize)(33,null,d):d===1?g?(0,E.localize)(34,null,d):(0,E.localize)(35,null,d):g?(0,E.localize)(36,null,d):(0,E.localize)(37,null,d)):v<m?(d=Math.floor(v/I),$?d===1?g?(0,E.localize)(38,null,d):(0,E.localize)(39,null,d):g?(0,E.localize)(40,null,d):(0,E.localize)(41,null,d):d===1?g?(0,E.localize)(42,null,d):(0,E.localize)(43,null,d):g?(0,E.localize)(44,null,d):(0,E.localize)(45,null,d)):(d=Math.floor(v/m),$?d===1?g?(0,E.localize)(46,null,d):(0,E.localize)(47,null,d):g?(0,E.localize)(48,null,d):(0,E.localize)(49,null,d):d===1?g?(0,E.localize)(50,null,d):(0,E.localize)(51,null,d):g?(0,E.localize)(52,null,d):(0,E.localize)(53,null,d))}function c(u,$){const g=Math.abs(u/1e3);return g<1?$?(0,E.localize)(54,null,u):(0,E.localize)(55,null,u):g<S?$?(0,E.localize)(56,null,Math.round(u)/1e3):(0,E.localize)(57,null,Math.round(u)/1e3):g<w?$?(0,E.localize)(58,null,Math.round(u/(1e3*S))):(0,E.localize)(59,null,Math.round(u/(1e3*S))):g<O?$?(0,E.localize)(60,null,Math.round(u/(1e3*w))):(0,E.localize)(61,null,Math.round(u/(1e3*w))):(0,E.localize)(62,null,Math.round(u/(1e3*O)))}function h(u){return u.getFullYear()+"-"+String(u.getMonth()+1).padStart(2,"0")+"-"+String(u.getDate()).padStart(2,"0")+"T"+String(u.getHours()).padStart(2,"0")+":"+String(u.getMinutes()).padStart(2,"0")+":"+String(u.getSeconds()).padStart(2,"0")+"."+(u.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}}),define(oe[83],ae([7,4]),function(H,t){return H.create("vs/base/common/errorMessage",t)}),define(oe[38],ae([0,1,20,3,83]),function(H,t,E,S,w){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$rj=m,t.$sj=l,t.$tj=c,E=be(E),S=be(S),w=be(w);function O(h,u){return u&&(h.stack||h.stacktrace)?w.localize(0,null,I(h),L(h.stack)||L(h.stacktrace)):I(h)}function L(h){return Array.isArray(h)?h.join(`
`):h}function I(h){return h.code==="ERR_UNC_HOST_NOT_ALLOWED"?`${h.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`:typeof h.code=="string"&&typeof h.errno=="number"&&typeof h.syscall=="string"?w.localize(1,null,h.message):h.message||w.localize(2,null)}function m(h=null,u=!1){if(!h)return w.localize(3,null);if(Array.isArray(h)){const $=E.$Kb(h),g=m($[0],u);return $.length>1?w.localize(4,null,g,$.length):g}if(S.$gg(h))return h;if(h.detail){const $=h.detail;if($.error)return O($.error,u);if($.exception)return O($.exception,u)}return h.stack?O(h,u):h.message?h.message:w.localize(5,null)}function l(h){const u=h;return u instanceof Error&&Array.isArray(u.actions)}function c(h,u){let $;return typeof h=="string"?$=new Error(h):$=h,$.actions=u,$}}),define(oe[84],ae([7,4]),function(H,t){return H.create("vs/base/common/jsonErrorMessages",t)}),define(oe[85],ae([0,1,84,34]),function(H,t,E,S){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Jq=w;function w(O){switch(O){case S.ParseErrorCode.InvalidSymbol:return(0,E.localize)(0,null);case S.ParseErrorCode.InvalidNumberFormat:return(0,E.localize)(1,null);case S.ParseErrorCode.PropertyNameExpected:return(0,E.localize)(2,null);case S.ParseErrorCode.ValueExpected:return(0,E.localize)(3,null);case S.ParseErrorCode.ColonExpected:return(0,E.localize)(4,null);case S.ParseErrorCode.CommaExpected:return(0,E.localize)(5,null);case S.ParseErrorCode.CloseBraceExpected:return(0,E.localize)(6,null);case S.ParseErrorCode.CloseBracketExpected:return(0,E.localize)(7,null);case S.ParseErrorCode.EndOfFileExpected:return(0,E.localize)(8,null);default:return""}}}),define(oe[57],ae([0,1,13]),function(H,t,E){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.TerminateResponseCode=t.Source=void 0,t.$lm=O,t.$mm=L;var S;(function(I){I[I.stdout=0]="stdout",I[I.stderr=1]="stderr"})(S||(t.Source=S={}));var w;(function(I){I[I.Success=0]="Success",I[I.Unknown=1]="Unknown",I[I.AccessDenied=2]="AccessDenied",I[I.ProcessNotFound=3]="ProcessNotFound"})(w||(t.TerminateResponseCode=w={}));function O(I,...m){const l=m.reduce((u,$)=>(u[$]=!0,u),{}),c=[/^ELECTRON_.+$/,/^VSCODE_(?!(PORTABLE|SHELL_LOGIN|ENV_REPLACE|ENV_APPEND|ENV_PREPEND)).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(I).filter(u=>!l[u]).forEach(u=>{for(let $=0;$<c.length;$++)if(u.search(c[$])!==-1){delete I[u];break}})}function L(I){I&&(delete I.DEBUG,E.$j&&delete I.DYLD_LIBRARY_PATH,E.$k&&delete I.LD_PRELOAD)}}),define(oe[86],ae([0,1,12]),function(H,t,E){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$br=S,t.$cr=w,t.$dr=O,t.log=I;function S(l){const c=l;return c&&typeof c.type=="string"&&typeof c.severity=="string"}function w(l){const c=[];let h;try{const u=JSON.parse(l.arguments),$=u[u.length-1];$&&$.__$stack&&(u.pop(),h=$.__$stack),c.push(...u)}catch{c.push("Unable to log remote console arguments",l.arguments)}return{args:c,stack:h}}function O(l){if(typeof l!="string")return O(w(l).stack);const c=l;if(c){const h=L(c),u=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(h||"");if(u&&u.length===4)return{uri:E.URI.file(u[1]),line:Number(u[2]),column:Number(u[3])}}}function L(l){if(!l)return l;const c=l.indexOf(`
`);return c===-1?l:l.substring(0,c)}function I(l,c){const{args:h,stack:u}=w(l),$=typeof h[0]=="string"&&h.length===1;let g=L(u);g&&(g=`(${g.trim()})`);let N=[];if(typeof h[0]=="string"?g&&$?N=[`%c[${c}] %c${h[0]} %c${g}`,m("blue"),m(""),m("grey")]:N=[`%c[${c}] %c${h[0]}`,m("blue"),m(""),...h.slice(1)]:N=[`%c[${c}]%`,m("blue"),...h],g&&!$&&N.push(g),typeof console[l.severity]!="function")throw new Error("Unknown console method");console[l.severity].apply(console,N)}function m(l){return`color: ${l}`}}),define(oe[48],ae([0,1,14,12,172]),function(H,t,E,S,w){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$bi=O,t.$ci=L,t.$di=m;function O(l){return JSON.stringify(l,I)}function L(l){let c=JSON.parse(l);return c=m(c),c}function I(l,c){return c instanceof RegExp?{$mid:w.MarshalledId.Regexp,source:c.source,flags:c.flags}:c}function m(l,c=0){if(!l||c>200)return l;if(typeof l=="object"){switch(l.$mid){case w.MarshalledId.Uri:return S.URI.revive(l);case w.MarshalledId.Regexp:return new RegExp(l.source,l.flags);case w.MarshalledId.Date:return new Date(l.source)}if(l instanceof E.$Pe||l instanceof Uint8Array)return l;if(Array.isArray(l))for(let h=0;h<l.length;++h)l[h]=m(l[h],c+1);else for(const h in l)Object.hasOwnProperty.call(l,h)&&(l[h]=m(l[h],c+1))}return l}}),define(oe[87],ae([0,1,74,15,13,12]),function(H,t,E,S,w,O){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$sE=c,w=be(w);class L{constructor(u,$,g){this.id=u,this.dependencies=$,this.callback=g}}class I{static{this.INSTANCE=new I}constructor(){this.a=typeof self=="object"&&self.constructor&&self.constructor.name==="DedicatedWorkerGlobalScope",this.b=typeof document=="object",this.c=[],this.d=!1}g(){this.d||(this.d=!0,globalThis.define=(u,$,g)=>{typeof u!="string"&&(g=$,$=u,u=null),(typeof $!="object"||!Array.isArray($))&&(g=$,$=null),this.c.push(new L(u,$,g))},globalThis.define.amd=!0,this.b?this.f=window.trustedTypes?.createPolicy("amdLoader",{createScriptURL(u){if(u.startsWith(window.location.origin)||u.startsWith("vscode-file://vscode-app"))return u;throw new Error(`[trusted_script_src] Invalid script url: ${u}`)}}):this.a&&(this.f=globalThis.trustedTypes?.createPolicy("amdLoader",{createScriptURL(u){return u}})))}async load(u){this.g();const $=await(this.a?this.i(u):this.b?this.h(u):this.j(u));if(!$)throw new Error(`Did not receive a define call from script ${u}`);if(Array.isArray($.dependencies)&&$.dependencies.length>0)throw new Error(`Cannot resolve dependencies for script ${u}. The dependencies are: ${$.dependencies.join(", ")}`);return typeof $.callback=="function"?$.callback([]):$.callback}h(u){return new Promise(($,g)=>{const N=document.createElement("script");N.setAttribute("async","async"),N.setAttribute("type","text/javascript");const v=()=>{N.removeEventListener("load",d),N.removeEventListener("error",p)},d=k=>{v(),$(this.c.pop())},p=k=>{v(),g(k)};N.addEventListener("load",d),N.addEventListener("error",p),this.f&&(u=this.f.createScriptURL(u)),N.setAttribute("src",u),window.document.getElementsByTagName("head")[0].appendChild(N)})}i(u){return new Promise(($,g)=>{try{this.f&&(u=this.f.createScriptURL(u)),importScripts(u),$(this.c.pop())}catch(N){g(N)}})}async j(u){try{const $=globalThis._VSCODE_NODE_MODULES.fs,g=globalThis._VSCODE_NODE_MODULES.vm,N=globalThis._VSCODE_NODE_MODULES.module,v=O.URI.parse(u).fsPath,d=$.readFileSync(v).toString(),p=N.wrap(d.replace(/^#!.*/,""));return new g.Script(p).runInThisContext().apply(),this.c.pop()}catch($){throw $}}}const m=new Map;let l={};typeof globalThis.require=="object"&&(l=globalThis.require.paths??{});async function c(h,u,$){if(E.$V){$===void 0&&($=!!(globalThis._VSCODE_PRODUCT_JSON??globalThis.vscode?.context?.configuration()?.product)?.commit),l[h]&&(h=l[h]);const g=`${h}/${u}`;if(m.has(g))return m.get(g);let N;if(/^\w[\w\d+.-]*:\/\//.test(g))N=g;else{const k=`${$&&!w.$o?S.$Xg:S.$Wg}/${g}`;N=S.$1g.asBrowserUri(k).toString(!0)}const v=I.INSTANCE.load(N);return m.set(g,v),v}else return await new Promise((g,N)=>{H([h],g,N)}).then(be)}}),define(oe[88],ae([0,1,35,49,29,80,13]),function(H,t,E,S,w,O,L){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Sn=void 0,t.$Tn=m,t.$Un=h,t.$Vn=u,w=be(w),t.$Sn=new class{c($){return this.a||(this.a=S.$Mi.forStrings(),this.a.set("00-50-56",!0),this.a.set("00-0C-29",!0),this.a.set("00-05-69",!0),this.a.set("00-03-FF",!0),this.a.set("00-1C-42",!0),this.a.set("00-16-3E",!0),this.a.set("08-00-27",!0),this.a.set("00:50:56",!0),this.a.set("00:0C:29",!0),this.a.set("00:05:69",!0),this.a.set("00:03:FF",!0),this.a.set("00:1C:42",!0),this.a.set("00:16:3E",!0),this.a.set("08:00:27",!0)),!!this.a.findSubstr($)}value(){if(this.b===void 0){let $=0,g=0;const N=(0,E.networkInterfaces)();for(const v in N){const d=N[v];if(d)for(const{mac:p,internal:k}of d)k||(g+=1,this.c(p.toUpperCase())&&($+=1))}this.b=g>0?$/g:0}return this.b}};let I;async function m($){return I||(I=(async()=>await l($)||w.$3g())()),I}async function l($){try{const g=await new Promise((v,d)=>{H(["crypto"],v,d)}).then(be),N=(0,O.$Rn)();return g.createHash("sha256").update(N,"utf8").digest("hex")}catch(g){$(g);return}}const c="Software\\Microsoft\\SQMClient";async function h($){if(L.$i){const g=await new Promise((N,v)=>{H(["@vscode/windows-registry"],N,v)}).then(be);try{return g.GetStringRegKey("HKEY_LOCAL_MACHINE",c,"MachineId")||""}catch(N){return $(N),""}}return""}async function u($){try{return await(await new Promise((v,d)=>{H(["@vscode/deviceid"],v,d)}).then(be)).getDeviceId()}catch(g){return $(g),""}}}),define(oe[89],ae([0,1,35,16,26]),function(H,t,E,S,w){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$wm=p,t.$xm=k,E=be(E),S=be(S),w=be(w);const O=/^\d+$/,L=/^Microsoft.PowerShell_.*/,I=/^Microsoft.PowerShellPreview_.*/;var m;(function(y){y[y.x64=0]="x64",y[y.x86=1]="x86",y[y.ARM=2]="ARM"})(m||(m={}));let l;switch(process.arch){case"ia32":l=m.x86;break;case"arm":case"arm64":l=m.ARM;break;default:l=m.x64;break}let c;process.env.PROCESSOR_ARCHITEW6432?c=process.env.PROCESSOR_ARCHITEW6432==="ARM64"?m.ARM:m.x64:process.env.PROCESSOR_ARCHITECTURE==="ARM64"?c=m.ARM:process.env.PROCESSOR_ARCHITECTURE==="X86"?c=m.x86:c=m.x64;class h{constructor(e,a,n){this.exePath=e,this.displayName=a,this.a=n}async exists(){return this.a===void 0&&(this.a=await w.SymlinkSupport.existsFile(this.exePath)),this.a}}function u({useAlternateBitness:y=!1}={}){return y?l===m.x64?process.env["ProgramFiles(x86)"]||null:c===m.x64&&process.env.ProgramW6432||null:process.env.ProgramFiles||null}async function $({useAlternateBitness:y=!1,findPreview:e=!1}={}){const a=u({useAlternateBitness:y});if(!a)return null;const n=S.$mc(a,"PowerShell");if(!await w.SymlinkSupport.existsDirectory(n))return null;let r=-1,i=null;for(const f of await w.Promises.readdir(n)){let b=-1;if(e){const T=f.indexOf("-");if(T<0)continue;const D=f.substring(0,T);if(!O.test(D)||f.substring(T+1)!=="preview")continue;b=parseInt(D,10)}else{if(!O.test(f))continue;b=parseInt(f,10)}if(b<=r)continue;const R=S.$mc(n,f,"pwsh.exe");await w.SymlinkSupport.existsFile(R)&&(i=R,r=b)}if(!i)return null;const s=a.includes("x86")?" (x86)":"",o=e?" Preview":"";return new h(i,`PowerShell${o}${s}`,!0)}async function g({findPreview:y}={}){if(!process.env.LOCALAPPDATA)return null;const e=S.$mc(process.env.LOCALAPPDATA,"Microsoft","WindowsApps");if(!await w.SymlinkSupport.existsDirectory(e))return null;const{pwshMsixDirRegex:a,pwshMsixName:n}=y?{pwshMsixDirRegex:I,pwshMsixName:"PowerShell Preview (Store)"}:{pwshMsixDirRegex:L,pwshMsixName:"PowerShell (Store)"};for(const r of await w.Promises.readdir(e))if(a.test(r)){const i=S.$mc(e,r,"pwsh.exe");return new h(i,n)}return null}function N(){const y=S.$mc(E.homedir(),".dotnet","tools","pwsh.exe");return new h(y,".NET Core PowerShell Global Tool")}function v(){const y=S.$mc(process.env.windir,l===m.x86&&c!==m.x86?"SysNative":"System32","WindowsPowerShell","v1.0","powershell.exe");return new h(y,"Windows PowerShell",!0)}async function*d(){let y=await $();y&&(yield y),y=await $({useAlternateBitness:!0}),y&&(yield y),y=await g(),y&&(yield y),y=N(),y&&(yield y),y=await $({findPreview:!0}),y&&(yield y),y=await g({findPreview:!0}),y&&(yield y),y=await $({useAlternateBitness:!0,findPreview:!0}),y&&(yield y),y=v(),y&&(yield y)}async function*p(){for await(const y of d())await y.exists()&&(yield y)}async function k(){for await(const y of p())return y;return null}}),define(oe[58],ae([0,1,16,13,36,57,3,26]),function(H,t,E,S,w,O,L,I){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.win32=t.TerminateResponseCode=t.Source=void 0,t.$ym=m,t.$zm=l,E=be(E),S=be(S),w=be(w),L=be(L),I=be(I),Object.defineProperty(t,"Source",{enumerable:!0,get:function(){return O.Source}}),Object.defineProperty(t,"TerminateResponseCode",{enumerable:!0,get:function(){return O.TerminateResponseCode}});function m(h=w.env){return h.comspec||"cmd.exe"}function l(h){let u=[],$=!1;const g=function(N){if($){u.push(N);return}(!h.send(N,d=>{if(d&&console.error(d),$=!1,u.length>0){const p=u.slice(0);u=[],p.forEach(k=>g(k))}})||S.$i)&&($=!0)};return{send:g}}var c;(function(h){async function u($,g,N){if(E.$lc($))return $;if(g===void 0&&(g=w.cwd()),E.$pc($)!=="."||(N===void 0&&L.$gg(w.env.PATH)&&(N=w.env.PATH.split(E.$wc)),N===void 0||N.length===0))return E.$mc(g,$);async function d(p){if(await I.Promises.exists(p)){let k;try{k=await I.Promises.stat(p)}catch(y){y.message.startsWith("EACCES")&&(k=await I.Promises.lstat(p))}return k?!k.isDirectory():!1}return!1}for(const p of N){let k;if(E.$lc(p)?k=E.$mc(p,$):k=E.$mc(g,p,$),await d(k))return k;let y=k+".com";if(await d(y)||(y=k+".exe",await d(y)))return y}return E.$mc(g,$)}h.findExecutable=u})(c||(t.win32=c={}))}),define(oe[90],ae([0,1,35,13,89,58]),function(H,t,E,S,w,O){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Am=L,S=be(S),O=be(O);async function L(h,u){return h===S.OperatingSystem.Windows?S.$i?c():O.$ym(u):m(h,u)}let I=null;function m(h,u){if(S.$k&&h===S.OperatingSystem.Macintosh||S.$j&&h===S.OperatingSystem.Linux)return"/bin/bash";if(!I){let $;if(S.$i)$="/bin/bash";else{if($=u.SHELL,!$)try{$=(0,E.userInfo)().shell}catch{}$||($="sh"),$==="/bin/false"&&($="/bin/bash")}I=$}return I}let l=null;async function c(){return l||(l=(await(0,w.$xm)()).exePath),l}});var ye=this&&this.__decorate||function(H,t,E,S){var w=arguments.length,O=w<3?t:S===null?S=Object.getOwnPropertyDescriptor(t,E):S,L;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")O=Reflect.decorate(H,t,E,S);else for(var I=H.length-1;I>=0;I--)(L=H[I])&&(O=(w<3?L(O):w>3?L(t,E,O):L(t,E))||O);return w>3&&O&&Object.defineProperty(t,E,O),O};define(oe[59],ae([0,1,20,8,14,22,55,9,5,2,48,32,3]),function(H,t,E,S,w,O,L,I,m,l,c,h,u){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$pi=t.ProxyChannel=t.$oi=t.$li=t.$ki=t.$ji=t.RequestInitiator=t.$ii=t.$fi=t.$ei=void 0,t.$gi=o,t.$hi=f,t.$mi=z,t.$ni=J,h=be(h);var $;(function(B){B[B.Promise=100]="Promise",B[B.PromiseCancel=101]="PromiseCancel",B[B.EventListen=102]="EventListen",B[B.EventDispose=103]="EventDispose"})($||($={}));function g(B){switch(B){case $.Promise:return"req";case $.PromiseCancel:return"cancel";case $.EventListen:return"subscribe";case $.EventDispose:return"unsubscribe"}}var N;(function(B){B[B.Initialize=200]="Initialize",B[B.PromiseSuccess=201]="PromiseSuccess",B[B.PromiseError=202]="PromiseError",B[B.PromiseErrorObj=203]="PromiseErrorObj",B[B.EventFire=204]="EventFire"})(N||(N={}));function v(B){switch(B){case N.Initialize:return"init";case N.PromiseSuccess:return"reply:";case N.PromiseError:case N.PromiseErrorObj:return"replyErr:";case N.EventFire:return"event:"}}var d;(function(B){B[B.Uninitialized=0]="Uninitialized",B[B.Idle=1]="Idle"})(d||(d={}));function p(B){let M=0;for(let G=0;;G+=7){const Y=B.read(1);if(M|=(Y.buffer[0]&127)<<G,!(Y.buffer[0]&128))return M}}const k=r(0);function y(B,M){if(M===0){B.write(k);return}let G=0;for(let te=M;te!==0;te=te>>>7)G++;const Y=w.$Pe.alloc(G);for(let te=0;M!==0;te++)Y.buffer[te]=M&127,M=M>>>7,M>0&&(Y.buffer[te]|=128);B.write(Y)}class e{constructor(M){this.b=M,this.a=0}read(M){const G=this.b.slice(this.a,this.a+M);return this.a+=G.byteLength,G}}t.$ei=e;class a{constructor(){this.a=[]}get buffer(){return w.$Pe.concat(this.a)}write(M){this.a.push(M)}}t.$fi=a;var n;(function(B){B[B.Undefined=0]="Undefined",B[B.String=1]="String",B[B.Buffer=2]="Buffer",B[B.VSBuffer=3]="VSBuffer",B[B.Array=4]="Array",B[B.Object=5]="Object",B[B.Int=6]="Int"})(n||(n={}));function r(B){const M=w.$Pe.alloc(1);return M.writeUInt8(B,0),M}const i={Undefined:r(n.Undefined),String:r(n.String),Buffer:r(n.Buffer),VSBuffer:r(n.VSBuffer),Array:r(n.Array),Object:r(n.Object),Uint:r(n.Int)},s=typeof Buffer<"u";function o(B,M){if(typeof M>"u")B.write(i.Undefined);else if(typeof M=="string"){const G=w.$Pe.fromString(M);B.write(i.String),y(B,G.byteLength),B.write(G)}else if(s&&Buffer.isBuffer(M)){const G=w.$Pe.wrap(M);B.write(i.Buffer),y(B,G.byteLength),B.write(G)}else if(M instanceof w.$Pe)B.write(i.VSBuffer),y(B,M.byteLength),B.write(M);else if(Array.isArray(M)){B.write(i.Array),y(B,M.length);for(const G of M)o(B,G)}else if(typeof M=="number"&&(M|0)===M)B.write(i.Uint),y(B,M);else{const G=w.$Pe.fromString(JSON.stringify(M));B.write(i.Object),y(B,G.byteLength),B.write(G)}}function f(B){switch(B.read(1).readUInt8(0)){case n.Undefined:return;case n.String:return B.read(p(B)).toString();case n.Buffer:return B.read(p(B)).buffer;case n.VSBuffer:return B.read(p(B));case n.Array:{const G=p(B),Y=[];for(let te=0;te<G;te++)Y.push(f(B));return Y}case n.Object:return JSON.parse(B.read(p(B)).toString());case n.Int:return p(B)}}class b{constructor(M,G,Y=null,te=1e3){this.h=M,this.j=G,this.k=Y,this.l=te,this.b=new Map,this.d=new Map,this.g=new Map,this.f=this.h.onMessage(F=>this.q(F)),this.m({type:N.Initialize})}registerChannel(M,G){this.b.set(M,G),setTimeout(()=>this.w(M),0)}m(M){switch(M.type){case N.Initialize:{const G=this.o([M.type]);this.k?.logOutgoing(G,0,R.OtherSide,v(M.type));return}case N.PromiseSuccess:case N.PromiseError:case N.EventFire:case N.PromiseErrorObj:{const G=this.o([M.type,M.id],M.data);this.k?.logOutgoing(G,M.id,R.OtherSide,v(M.type),M.data);return}}}o(M,G=void 0){const Y=new a;return o(Y,M),o(Y,G),this.p(Y.buffer)}p(M){try{return this.h.send(M),M.byteLength}catch{return 0}}q(M){const G=new e(M),Y=f(G),te=f(G),F=Y[0];switch(F){case $.Promise:return this.k?.logIncoming(M.byteLength,Y[1],R.OtherSide,`${g(F)}: ${Y[2]}.${Y[3]}`,te),this.s({type:F,id:Y[1],channelName:Y[2],name:Y[3],arg:te});case $.EventListen:return this.k?.logIncoming(M.byteLength,Y[1],R.OtherSide,`${g(F)}: ${Y[2]}.${Y[3]}`,te),this.t({type:F,id:Y[1],channelName:Y[2],name:Y[3],arg:te});case $.PromiseCancel:return this.k?.logIncoming(M.byteLength,Y[1],R.OtherSide,`${g(F)}`),this.u({type:F,id:Y[1]});case $.EventDispose:return this.k?.logIncoming(M.byteLength,Y[1],R.OtherSide,`${g(F)}`),this.u({type:F,id:Y[1]})}}s(M){const G=this.b.get(M.channelName);if(!G){this.v(M);return}const Y=new O.$ye;let te;try{te=G.call(this.j,M.name,M.arg,Y.token)}catch(K){te=Promise.reject(K)}const F=M.id;te.then(K=>{this.m({id:F,data:K,type:N.PromiseSuccess})},K=>{K instanceof Error?this.m({id:F,data:{message:K.message,name:K.name,stack:K.stack?K.stack.split(`
`):void 0},type:N.PromiseError}):this.m({id:F,data:K,type:N.PromiseErrorObj})}).finally(()=>{q.dispose(),this.d.delete(M.id)});const q=(0,l.$Vc)(()=>Y.cancel());this.d.set(M.id,q)}t(M){const G=this.b.get(M.channelName);if(!G){this.v(M);return}const Y=M.id,F=G.listen(this.j,M.name,M.arg)(q=>this.m({id:Y,data:q,type:N.EventFire}));this.d.set(M.id,F)}u(M){const G=this.d.get(M.id);G&&(G.dispose(),this.d.delete(M.id))}v(M){let G=this.g.get(M.channelName);G||(G=[],this.g.set(M.channelName,G));const Y=setTimeout(()=>{console.error(`Unknown channel: ${M.channelName}`),M.type===$.Promise&&this.m({id:M.id,data:{name:"Unknown channel",message:`Channel name '${M.channelName}' timed out after ${this.l}ms`,stack:void 0},type:N.PromiseError})},this.l);G.push({request:M,timeoutTimer:Y})}w(M){const G=this.g.get(M);if(G){for(const Y of G)switch(clearTimeout(Y.timeoutTimer),Y.request.type){case $.Promise:this.s(Y.request);break;case $.EventListen:this.t(Y.request);break}this.g.delete(M)}}dispose(){this.f&&(this.f.dispose(),this.f=null),(0,l.$Sc)(this.d.values()),this.d.clear()}}t.$ii=b;var R;(function(B){B[B.LocalSide=0]="LocalSide",B[B.OtherSide=1]="OtherSide"})(R||(t.RequestInitiator=R={}));class T{constructor(M,G=null){this.l=M,this.a=!1,this.b=d.Uninitialized,this.d=new Set,this.f=new Map,this.g=0,this.k=new m.$ne,this.onDidInitialize=this.k.event,this.h=this.l.onMessage(Y=>this.s(Y)),this.j=G}getChannel(M){const G=this;return{call(Y,te,F){return G.a?Promise.reject(new I.$8):G.m(M,Y,te,F)},listen(Y,te){return G.a?m.Event.None:G.o(M,Y,te)}}}m(M,G,Y,te=O.CancellationToken.None){const F=this.g++,q=$.Promise,K={id:F,type:q,channelName:M,name:G,arg:Y};if(te.isCancellationRequested)return Promise.reject(new I.$8);let V;return new Promise((j,U)=>{if(te.isCancellationRequested)return U(new I.$8);const C=()=>{const ce=pe=>{switch(pe.type){case N.PromiseSuccess:this.f.delete(F),j(pe.data);break;case N.PromiseError:{this.f.delete(F);const me=new Error(pe.data.message);me.stack=Array.isArray(pe.data.stack)?pe.data.stack.join(`
`):pe.data.stack,me.name=pe.data.name,U(me);break}case N.PromiseErrorObj:this.f.delete(F),U(pe.data);break}};this.f.set(F,ce),this.p(K)};let X=null;this.b===d.Idle?C():(X=(0,S.$th)(ce=>this.u()),X.then(()=>{X=null,C()}));const Z=()=>{X?(X.cancel(),X=null):this.p({id:F,type:$.PromiseCancel}),U(new I.$8)},ne=te.onCancellationRequested(Z);V=(0,l.$Uc)((0,l.$Vc)(Z),ne),this.d.add(V)}).finally(()=>{V.dispose(),this.d.delete(V)})}o(M,G,Y){const te=this.g++,F=$.EventListen,q={id:te,type:F,channelName:M,name:G,arg:Y};let K=null;const V=new m.$ne({onWillAddFirstListener:()=>{K=(0,S.$th)(j=>this.u()),K.then(()=>{K=null,this.d.add(V),this.p(q)})},onDidRemoveLastListener:()=>{K?(K.cancel(),K=null):(this.d.delete(V),this.p({id:te,type:$.EventDispose}))}}),P=j=>V.fire(j.data);return this.f.set(te,P),V.event}p(M){switch(M.type){case $.Promise:case $.EventListen:{const G=this.q([M.type,M.id,M.channelName,M.name],M.arg);this.j?.logOutgoing(G,M.id,R.LocalSide,`${g(M.type)}: ${M.channelName}.${M.name}`,M.arg);return}case $.PromiseCancel:case $.EventDispose:{const G=this.q([M.type,M.id]);this.j?.logOutgoing(G,M.id,R.LocalSide,g(M.type));return}}}q(M,G=void 0){const Y=new a;return o(Y,M),o(Y,G),this.r(Y.buffer)}r(M){try{return this.l.send(M),M.byteLength}catch{return 0}}s(M){const G=new e(M),Y=f(G),te=f(G),F=Y[0];switch(F){case N.Initialize:return this.j?.logIncoming(M.byteLength,0,R.LocalSide,v(F)),this.t({type:Y[0]});case N.PromiseSuccess:case N.PromiseError:case N.EventFire:case N.PromiseErrorObj:return this.j?.logIncoming(M.byteLength,Y[1],R.LocalSide,v(F),te),this.t({type:Y[0],id:Y[1],data:te})}}t(M){if(M.type===N.Initialize){this.b=d.Idle,this.k.fire();return}this.f.get(M.id)?.(M)}get onDidInitializePromise(){return m.Event.toPromise(this.onDidInitialize)}u(){return this.b===d.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.a=!0,this.h&&(this.h.dispose(),this.h=null),(0,l.$Sc)(this.d.values()),this.d.clear()}}t.$ji=T,ye([L.$$h],T.prototype,"onDidInitializePromise",null);class D{get connections(){const M=[];return this.f.forEach(G=>M.push(G)),M}constructor(M,G,Y){this.a=new Map,this.f=new Set,this.g=new m.$ne,this.onDidAddConnection=this.g.event,this.h=new m.$ne,this.onDidRemoveConnection=this.h.event,this.j=new l.$Wc,this.j.add(M(({protocol:te,onDidClientDisconnect:F})=>{const q=m.Event.once(te.onMessage);this.j.add(q(K=>{const V=new e(K),P=f(V),j=new b(te,P,G,Y),U=new T(te,G);this.a.forEach((X,Z)=>j.registerChannel(Z,X));const C={channelServer:j,channelClient:U,ctx:P};this.f.add(C),this.g.fire(C),this.j.add(F(()=>{j.dispose(),U.dispose(),this.f.delete(C),this.h.fire(C)}))}))}))}getChannel(M,G){const Y=this;return{call(te,F,q){let K;if((0,u.$ug)(G)){const P=(0,E.$6b)(Y.connections.filter(G));K=P?Promise.resolve(P):m.Event.toPromise(m.Event.filter(Y.onDidAddConnection,G))}else K=G.routeCall(Y,te,F);const V=K.then(P=>P.channelClient.getChannel(M));return z(V).call(te,F,q)},listen(te,F){if((0,u.$ug)(G))return Y.k(M,G,te,F);const q=G.routeEvent(Y,te,F).then(K=>K.channelClient.getChannel(M));return z(q).listen(te,F)}}}k(M,G,Y,te){const F=this;let q;const K=new m.$ne({onWillAddFirstListener:()=>{q=new l.$Wc;const V=new m.$te,P=new Map,j=C=>{const Z=C.channelClient.getChannel(M).listen(Y,te),ne=V.add(Z);P.set(C,ne)},U=C=>{const X=P.get(C);X&&(X.dispose(),P.delete(C))};F.connections.filter(G).forEach(j),m.Event.filter(F.onDidAddConnection,G)(j,void 0,q),F.onDidRemoveConnection(U,void 0,q),V.event(K.fire,K,q),q.add(V)},onDidRemoveLastListener:()=>{q?.dispose(),q=void 0}});return K.event}registerChannel(M,G){this.a.set(M,G);for(const Y of this.f)Y.channelServer.registerChannel(M,G)}dispose(){this.j.dispose();for(const M of this.f)M.channelClient.dispose(),M.channelServer.dispose();this.f.clear(),this.a.clear(),this.g.dispose(),this.h.dispose()}}t.$ki=D;class A{constructor(M,G,Y=null){const te=new a;o(te,G),M.send(te.buffer),this.a=new T(M,Y),this.d=new b(M,G,Y)}getChannel(M){return this.a.getChannel(M)}registerChannel(M,G){this.d.registerChannel(M,G)}dispose(){this.a.dispose(),this.d.dispose()}}t.$li=A;function z(B){return{call(M,G,Y){return B.then(te=>te.call(M,G,Y))},listen(M,G){const Y=new m.$we;return B.then(te=>Y.input=te.listen(M,G)),Y.event}}}function J(B){let M=!1;return{call(G,Y,te){return M?B.call(G,Y,te):(0,S.$Hh)(0).then(()=>M=!0).then(()=>B.call(G,Y,te))},listen(G,Y){if(M)return B.listen(G,Y);const te=new m.$we;return(0,S.$Hh)(0).then(()=>M=!0).then(()=>te.input=B.listen(G,Y)),te.event}}}class Q{constructor(M){this.a=M}routeCall(M){return this.b(M)}routeEvent(M){return this.b(M)}async b(M){for(const G of M.connections)if(await Promise.resolve(this.a(G.ctx)))return Promise.resolve(G);return await m.Event.toPromise(M.onDidAddConnection),await this.b(M)}}t.$oi=Q;var se;(function(B){function M(F,q,K){const V=F,P=K&&K.disableMarshalling,j=new Map;for(const U in V)Y(U)&&j.set(U,m.Event.buffer(V[U],!0,void 0,q));return new class{listen(U,C,X){const Z=j.get(C);if(Z)return Z;const ne=V[C];if(typeof ne=="function"){if(te(C))return ne.call(V,X);if(Y(C))return j.set(C,m.Event.buffer(V[C],!0,void 0,q)),j.get(C)}throw new I.$eb(`Event not found: ${C}`)}call(U,C,X){const Z=V[C];if(typeof Z=="function"){if(!P&&Array.isArray(X))for(let ce=0;ce<X.length;ce++)X[ce]=(0,c.$di)(X[ce]);let ne=Z.apply(V,X);return ne instanceof Promise||(ne=Promise.resolve(ne)),ne}throw new I.$eb(`Method not found: ${C}`)}}}B.fromService=M;function G(F,q){const K=q&&q.disableMarshalling;return new Proxy({},{get(V,P){if(typeof P=="string")return q?.properties?.has(P)?q.properties.get(P):te(P)?function(j){return F.listen(P,j)}:Y(P)?F.listen(P):async function(...j){let U;q&&!(0,u.$pg)(q.context)?U=[q.context,...j]:U=j;const C=await F.call(P,U);return K?C:(0,c.$di)(C)};throw new I.$eb(`Property not found: ${String(P)}`)}})}B.toService=G;function Y(F){return F[0]==="o"&&F[1]==="n"&&h.$Gf(F.charCodeAt(2))}function te(F){return/^onDynamic/.test(F)&&h.$Gf(F.charCodeAt(9))}})(se||(t.ProxyChannel=se={}));const le=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function ue(B){if(Array.isArray(B))return B;if(B&&typeof B=="object"&&typeof B.toString=="function"){const M=B.toString();if(M!=="[object Object]")return M}return B}function fe(B){return Array.isArray(B)?B.map(ue):ue(B)}function x(B,M,G,Y,te,F,q){q=fe(q);const K=le[te],V=K[Y%K.length];let P=[`%c[${B}]%c[${String(M).padStart(7," ")}]%c[len: ${String(G).padStart(5," ")}]%c${String(Y).padStart(5," ")} - ${F}`,"color: darkgreen","color: grey","color: grey",`color: ${V}`];/\($/.test(F)?(P=P.concat(q),P.push(")")):P.push(q),console.log.apply(console,P)}class _{constructor(M,G){this.d=M,this.f=G,this.a=0,this.b=0}logOutgoing(M,G,Y,te,F){this.b+=M,x(this.d,this.b,M,G,Y,te,F)}logIncoming(M,G,Y,te,F){this.a+=M,x(this.f,this.a,M,G,Y,te,F)}}t.$pi=_}),define(oe[91],ae([0,1,60,8,14,22,86,9,5,2,28,58,57,59]),function(H,t,E,S,w,O,L,I,m,l,c,h,u,$){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$gr=t.$fr=void 0,I=be(I);class g extends $.$ii{constructor(d){super({send:p=>{try{process.send?.(p.buffer.toString("base64"))}catch{}},onMessage:m.Event.fromNodeEventEmitter(process,"message",p=>w.$Pe.wrap(Buffer.from(p,"base64")))},d),process.once("disconnect",()=>this.dispose())}}t.$fr=g;class N{constructor(d,p){this.i=d,this.j=p,this.c=new Set,this.g=new Map,this.h=new m.$ne,this.onDidProcessExit=this.h.event;const k=p&&p.timeout?p.timeout:6e4;this.b=new S.$Dh(k),this.d=null,this.f=null}getChannel(d){const p=this;return{call(k,y,e){return p.k(d,k,y,e)},listen(k,y){return p.l(d,k,y)}}}k(d,p,k,y=O.CancellationToken.None){if(!this.b)return Promise.reject(new Error("disposed"));if(y.isCancellationRequested)return Promise.reject(I.$9());this.b.cancel();const e=this.n(d),a=(0,S.$th)(i=>e.call(p,k,i)),n=y.onCancellationRequested(()=>a.cancel()),r=(0,l.$Vc)(()=>a.cancel());return this.c.add(r),a.finally(()=>{n.dispose(),this.c.delete(r),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}),a}l(d,p,k){if(!this.b)return m.Event.None;this.b.cancel();let y;const e=new m.$ne({onWillAddFirstListener:()=>{y=this.n(d).listen(p,k)(e.fire,e),this.c.add(y)},onDidRemoveLastListener:()=>{this.c.delete(y),y.dispose(),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}});return e.event}get m(){if(!this.f){const d=this.j&&this.j.args?this.j.args:[],p=Object.create(null);p.env={...(0,c.$eo)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.j&&this.j.env&&(p.env={...p.env,...this.j.env}),this.j&&this.j.freshExecArgv&&(p.execArgv=[]),this.j&&typeof this.j.debug=="number"&&(p.execArgv=["--nolazy","--inspect="+this.j.debug]),this.j&&typeof this.j.debugBrk=="number"&&(p.execArgv=["--nolazy","--inspect-brk="+this.j.debugBrk]),p.execArgv===void 0&&(p.execArgv=process.execArgv.filter(o=>!/^--inspect(-brk)?=/.test(o)).filter(o=>!o.startsWith("--vscode-"))),(0,u.$mm)(p.env),this.d=(0,E.fork)(this.i,d,p);const k=new m.$ne,e=m.Event.fromNodeEventEmitter(this.d,"message",o=>o)(o=>{if((0,L.$br)(o)){(0,L.log)(o,`IPC Library: ${this.j.serverName}`);return}k.fire(w.$Pe.wrap(Buffer.from(o,"base64")))}),a=this.j.useQueue?(0,h.$zm)(this.d):this.d,n=o=>this.d&&this.d.connected&&a.send(o.buffer.toString("base64")),r=k.event,i={send:n,onMessage:r};this.f=new $.$ji(i);const s=()=>this.o();process.once("exit",s),this.d.on("error",o=>console.warn('IPC "'+this.j.serverName+'" errored with '+o)),this.d.on("exit",(o,f)=>{process.removeListener("exit",s),e.dispose(),this.c.forEach(b=>(0,l.$Sc)(b)),this.c.clear(),o!==0&&f!=="SIGTERM"&&console.warn('IPC "'+this.j.serverName+'" crashed with exit code '+o+" and signal "+f),this.b?.cancel(),this.o(),this.h.fire({code:o,signal:f})})}return this.f}n(d){let p=this.g.get(d);return p||(p=this.m.getChannel(d),this.g.set(d,p)),p}o(){this.f&&(this.d&&(this.d.kill(),this.d=null),this.f=null,this.g.clear())}dispose(){this.h.dispose(),this.b?.cancel(),this.b=void 0,this.o(),this.c.clear()}}t.$gr=N}),define(oe[92],ae([0,1,8,5,2,48,3]),function(H,t,E,S,w,O,L){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$dq=t.$cq=t.StorageState=t.StorageHint=void 0,t.$bq=m;var I;(function(u){u[u.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST",u[u.STORAGE_IN_MEMORY=1]="STORAGE_IN_MEMORY"})(I||(t.StorageHint=I={}));function m(u){const $=u;return $?.changed instanceof Map||$?.deleted instanceof Set}var l;(function(u){u[u.None=0]="None",u[u.Initialized=1]="Initialized",u[u.Closed=2]="Closed"})(l||(t.StorageState=l={}));class c extends w.$Xc{static{this.a=100}constructor($,g=Object.create(null)){super(),this.r=$,this.s=g,this.b=this.B(new S.$qe),this.onDidChangeStorage=this.b.event,this.c=l.None,this.f=new Map,this.g=this.B(new E.$Eh(c.a)),this.h=new Set,this.j=new Map,this.m=void 0,this.n=[],this.t()}t(){this.B(this.r.onDidChangeItemsExternal($=>this.u($)))}u($){this.b.pause();try{$.changed?.forEach((g,N)=>this.w(N,g)),$.deleted?.forEach(g=>this.w(g,void 0))}finally{this.b.resume()}}w($,g){if(this.c===l.Closed)return;let N=!1;(0,L.$pg)(g)?N=this.f.delete($):this.f.get($)!==g&&(this.f.set($,g),N=!0),N&&this.b.fire({key:$,external:!0})}get items(){return this.f}get size(){return this.f.size}async init(){this.c===l.None&&(this.c=l.Initialized,this.s.hint!==I.STORAGE_DOES_NOT_EXIST&&(this.f=await this.r.getItems()))}get($,g){const N=this.f.get($);return(0,L.$pg)(N)?g:N}getBoolean($,g){const N=this.get($);return(0,L.$pg)(N)?g:N==="true"}getNumber($,g){const N=this.get($);return(0,L.$pg)(N)?g:parseInt(N,10)}getObject($,g){const N=this.get($);return(0,L.$pg)(N)?g:(0,O.$ci)(N)}async set($,g,N=!1){if(this.c===l.Closed)return;if((0,L.$pg)(g))return this.delete($,N);const v=(0,L.$ig)(g)||Array.isArray(g)?(0,O.$bi)(g):String(g);if(this.f.get($)!==v)return this.f.set($,v),this.j.set($,v),this.h.delete($),this.b.fire({key:$,external:N}),this.D()}async delete($,g=!1){if(!(this.c===l.Closed||!this.f.delete($)))return this.h.has($)||this.h.add($),this.j.delete($),this.b.fire({key:$,external:g}),this.D()}async optimize(){if(this.c!==l.Closed)return await this.flush(0),this.r.optimize()}async close(){return this.m||(this.m=this.y()),this.m}async y(){this.c=l.Closed;try{await this.D(0)}catch{}await this.r.close(()=>this.f)}get z(){return this.j.size>0||this.h.size>0}async C(){if(!this.z)return;const $={insert:this.j,delete:this.h};return this.h=new Set,this.j=new Map,this.r.updateItems($).finally(()=>{if(!this.z)for(;this.n.length;)this.n.pop()?.()})}async flush($){if(!(this.c===l.Closed||this.m))return this.D($)}async D($){return this.s.hint===I.STORAGE_IN_MEMORY?this.C():this.g.trigger(()=>this.C(),$)}async whenFlushed(){if(this.z)return new Promise($=>this.n.push($))}isInMemory(){return this.s.hint===I.STORAGE_IN_MEMORY}}t.$cq=c;class h{constructor(){this.onDidChangeItemsExternal=S.Event.None,this.a=new Map}async getItems(){return this.a}async updateItems($){$.insert?.forEach((g,N)=>this.a.set(N,g)),$.delete?.forEach(g=>this.a.delete(g))}async optimize(){}async close(){}}t.$dq=h}),define(oe[93],ae([7,4]),function(H,t){return H.create("vs/base/node/zip",t)}),define(oe[50],ae([0,1,94,8,16,3,26,93]),function(H,t,E,S,w,O,L,I){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$zq=t.$yq=void 0,t.zip=v,t.$Bq=d,t.$Cq=k,w=be(w),I=be(I),t.$yq="end of central directory record signature not found";const m=new RegExp(t.$yq);class l extends Error{constructor(e,a){let n=a.message;switch(e){case"CorruptZip":n=`Corrupt ZIP: ${n}`;break}super(n),this.type=e,this.cause=a}}t.$zq=l;function c(y){const e=y.externalFileAttributes>>16||33188;return[448,56,7].map(a=>e&a).reduce((a,n)=>a+n,e&61440)}function h(y){if(y instanceof l)return y;let e;return m.test(y.message)&&(e="CorruptZip"),new l(e,y)}function u(y,e,a,n,r,i){const s=w.$pc(e),o=w.$mc(n,s);if(!o.startsWith(n))return Promise.reject(new Error(I.localize(0,null,e)));const f=w.$mc(n,e);let b;return i.onCancellationRequested(()=>{b?.destroy()}),Promise.resolve(L.Promises.mkdir(o,{recursive:!0})).then(()=>new Promise((R,T)=>{if(!i.isCancellationRequested)try{b=(0,E.createWriteStream)(f,{mode:a}),b.once("close",()=>R()),b.once("error",T),y.once("error",T),y.pipe(b)}catch(D){T(D)}}))}function $(y,e,a,n){let r=(0,S.$th)(()=>Promise.resolve()),i=0;const s=n.onCancellationRequested(()=>{r.cancel(),y.close()});return new Promise((o,f)=>{const b=new S.$Bh,R=T=>{T.isCancellationRequested||(i++,y.readEntry())};y.once("error",f),y.once("close",()=>r.then(()=>{n.isCancellationRequested||y.entryCount===i?o():f(new l("Incomplete",new Error(I.localize(1,null,i,y.entryCount))))},f)),y.readEntry(),y.on("entry",T=>{if(n.isCancellationRequested)return;if(!a.sourcePathRegex.test(T.fileName)){R(n);return}const D=T.fileName.replace(a.sourcePathRegex,"");if(/\/$/.test(D)){const J=w.$mc(e,D);r=(0,S.$th)(Q=>L.Promises.mkdir(J,{recursive:!0}).then(()=>R(Q)).then(void 0,f));return}const A=N(y,T),z=c(T);r=(0,S.$th)(J=>b.queue(()=>A.then(Q=>u(Q,D,z,e,a,J).then(()=>R(J)))).then(null,f))})}).finally(()=>s.dispose())}async function g(y,e=!1){const{open:a}=await new Promise((n,r)=>{H(["yauzl"],n,r)}).then(be);return new Promise((n,r)=>{a(y,e?{lazyEntries:!0}:void 0,(i,s)=>{i?r(h(i)):n((0,O.$rg)(s))})})}function N(y,e){return new Promise((a,n)=>{y.openReadStream(e,(r,i)=>{r?n(h(r)):a((0,O.$rg)(i))})})}async function v(y,e){const{ZipFile:a}=await new Promise((n,r)=>{H(["yazl"],n,r)}).then(be);return new Promise((n,r)=>{const i=new a;e.forEach(o=>{o.contents?i.addBuffer(typeof o.contents=="string"?Buffer.from(o.contents,"utf8"):o.contents,o.path):o.localPath&&i.addFile(o.localPath,o.path)}),i.end();const s=(0,E.createWriteStream)(y);i.outputStream.pipe(s),i.outputStream.once("error",r),s.once("error",r),s.once("finish",()=>n(y))})}function d(y,e,a={},n){const r=new RegExp(a.sourcePath?`^${a.sourcePath}`:"");let i=g(y,!0);return a.overwrite&&(i=i.then(s=>L.Promises.rm(e).then(()=>s))),i.then(s=>$(s,e,{sourcePathRegex:r},n))}function p(y,e){return g(y).then(a=>new Promise((n,r)=>{a.on("entry",i=>{i.fileName===e&&N(a,i).then(s=>n(s),s=>r(s))}),a.once("close",()=>r(new Error(I.localize(2,null,e))))}))}function k(y,e){return p(y,e).then(a=>new Promise((n,r)=>{const i=[];a.once("error",r),a.on("data",s=>i.push(s)),a.on("end",()=>n(Buffer.concat(i)))}))}}),define(oe[95],ae([7,4]),function(H,t){return H.create("vs/platform/configuration/common/configurationRegistry",t)}),define(oe[96],ae([7,4]),function(H,t){return H.create("vs/platform/contextkey/common/contextkey",t)}),define(oe[97],ae([7,4]),function(H,t){return H.create("vs/platform/contextkey/common/scanner",t)}),define(oe[98],ae([7,4]),function(H,t){return H.create("vs/platform/extensionManagement/common/abstractExtensionManagementService",t)}),define(oe[99],ae([7,4]),function(H,t){return H.create("vs/platform/extensionManagement/common/extensionManagement",t)}),define(oe[100],ae([7,4]),function(H,t){return H.create("vs/platform/extensionManagement/common/extensionManagementCLI",t)}),define(oe[101],ae([7,4]),function(H,t){return H.create("vs/platform/extensionManagement/common/extensionNls",t)}),define(oe[102],ae([7,4]),function(H,t){return H.create("vs/platform/extensionManagement/common/extensionsScannerService",t)}),define(oe[103],ae([7,4]),function(H,t){return H.create("vs/platform/extensionManagement/node/extensionManagementService",t)}),define(oe[104],ae([7,4]),function(H,t){return H.create("vs/platform/extensionManagement/node/extensionManagementUtil",t)}),define(oe[105],ae([7,4]),function(H,t){return H.create("vs/platform/extensions/common/extensionValidator",t)}),define(oe[106],ae([7,4]),function(H,t){return H.create("vs/platform/files/common/fileService",t)}),define(oe[107],ae([7,4]),function(H,t){return H.create("vs/platform/files/common/io",t)}),define(oe[108],ae([7,4]),function(H,t){return H.create("vs/platform/files/node/diskFileSystemProvider",t)}),define(oe[109],ae([7,4]),function(H,t){return H.create("vs/platform/languagePacks/common/languagePacks",t)}),define(oe[110],ae([7,4]),function(H,t){return H.create("vs/platform/log/common/log",t)}),define(oe[111],ae([7,4]),function(H,t){return H.create("vs/platform/request/common/request",t)}),define(oe[112],ae([7,4]),function(H,t){return H.create("vs/platform/shell/node/shellEnv",t)}),define(oe[113],ae([7,4]),function(H,t){return H.create("vs/platform/telemetry/common/telemetryService",t)}),define(oe[114],ae([7,4]),function(H,t){return H.create("vs/platform/userDataProfile/common/userDataProfile",t)}),define(oe[115],ae([7,4]),function(H,t){return H.create("vs/platform/workspace/common/workspace",t)}),define(oe[116],ae([0,1,117,9,97]),function(H,t,E,S,w){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Bj=t.TokenType=void 0;var O;(function(c){c[c.LParen=0]="LParen",c[c.RParen=1]="RParen",c[c.Neg=2]="Neg",c[c.Eq=3]="Eq",c[c.NotEq=4]="NotEq",c[c.Lt=5]="Lt",c[c.LtEq=6]="LtEq",c[c.Gt=7]="Gt",c[c.GtEq=8]="GtEq",c[c.RegexOp=9]="RegexOp",c[c.RegexStr=10]="RegexStr",c[c.True=11]="True",c[c.False=12]="False",c[c.In=13]="In",c[c.Not=14]="Not",c[c.And=15]="And",c[c.Or=16]="Or",c[c.Str=17]="Str",c[c.QuotedStr=18]="QuotedStr",c[c.Error=19]="Error",c[c.EOF=20]="EOF"})(O||(t.TokenType=O={}));function L(...c){switch(c.length){case 1:return(0,w.localize)(0,null,c[0]);case 2:return(0,w.localize)(1,null,c[0],c[1]);case 3:return(0,w.localize)(2,null,c[0],c[1],c[2]);default:return}}const I=(0,w.localize)(3,null),m=(0,w.localize)(4,null);class l{constructor(){this.c="",this.d=0,this.e=0,this.f=[],this.g=[],this.m=/[a-zA-Z0-9_<>\-\./\\:\*\?\+\[\]\^,#@;"%\$\p{L}-]+/uy}static getLexeme(h){switch(h.type){case O.LParen:return"(";case O.RParen:return")";case O.Neg:return"!";case O.Eq:return h.isTripleEq?"===":"==";case O.NotEq:return h.isTripleEq?"!==":"!=";case O.Lt:return"<";case O.LtEq:return"<=";case O.Gt:return">=";case O.GtEq:return">=";case O.RegexOp:return"=~";case O.RegexStr:return h.lexeme;case O.True:return"true";case O.False:return"false";case O.In:return"in";case O.Not:return"not";case O.And:return"&&";case O.Or:return"||";case O.Str:return h.lexeme;case O.QuotedStr:return h.lexeme;case O.Error:return h.lexeme;case O.EOF:return"EOF";default:throw(0,S.$$)(`unhandled token type: ${JSON.stringify(h)}; have you forgotten to add a case?`)}}static{this.a=new Set(["i","g","s","m","y","u"].map(h=>h.charCodeAt(0)))}static{this.b=new Map([["not",O.Not],["in",O.In],["false",O.False],["true",O.True]])}get errors(){return this.g}reset(h){return this.c=h,this.d=0,this.e=0,this.f=[],this.g=[],this}scan(){for(;!this.r();)switch(this.d=this.e,this.i()){case E.CharCode.OpenParen:this.k(O.LParen);break;case E.CharCode.CloseParen:this.k(O.RParen);break;case E.CharCode.ExclamationMark:if(this.h(E.CharCode.Equals)){const u=this.h(E.CharCode.Equals);this.f.push({type:O.NotEq,offset:this.d,isTripleEq:u})}else this.k(O.Neg);break;case E.CharCode.SingleQuote:this.o();break;case E.CharCode.Slash:this.q();break;case E.CharCode.Equals:if(this.h(E.CharCode.Equals)){const u=this.h(E.CharCode.Equals);this.f.push({type:O.Eq,offset:this.d,isTripleEq:u})}else this.h(E.CharCode.Tilde)?this.k(O.RegexOp):this.l(L("==","=~"));break;case E.CharCode.LessThan:this.k(this.h(E.CharCode.Equals)?O.LtEq:O.Lt);break;case E.CharCode.GreaterThan:this.k(this.h(E.CharCode.Equals)?O.GtEq:O.Gt);break;case E.CharCode.Ampersand:this.h(E.CharCode.Ampersand)?this.k(O.And):this.l(L("&&"));break;case E.CharCode.Pipe:this.h(E.CharCode.Pipe)?this.k(O.Or):this.l(L("||"));break;case E.CharCode.Space:case E.CharCode.CarriageReturn:case E.CharCode.Tab:case E.CharCode.LineFeed:case E.CharCode.NoBreakSpace:break;default:this.n()}return this.d=this.e,this.k(O.EOF),Array.from(this.f)}h(h){return this.r()||this.c.charCodeAt(this.e)!==h?!1:(this.e++,!0)}i(){return this.c.charCodeAt(this.e++)}j(){return this.r()?E.CharCode.Null:this.c.charCodeAt(this.e)}k(h){this.f.push({type:h,offset:this.d})}l(h){const u=this.d,$=this.c.substring(this.d,this.e),g={type:O.Error,offset:this.d,lexeme:$};this.g.push({offset:u,lexeme:$,additionalInfo:h}),this.f.push(g)}n(){this.m.lastIndex=this.d;const h=this.m.exec(this.c);if(h){this.e=this.d+h[0].length;const u=this.c.substring(this.d,this.e),$=l.b.get(u);$?this.k($):this.f.push({type:O.Str,lexeme:u,offset:this.d})}}o(){for(;this.j()!==E.CharCode.SingleQuote&&!this.r();)this.i();if(this.r()){this.l(I);return}this.i(),this.f.push({type:O.QuotedStr,lexeme:this.c.substring(this.d+1,this.e-1),offset:this.d+1})}q(){let h=this.e,u=!1,$=!1;for(;;){if(h>=this.c.length){this.e=h,this.l(m);return}const N=this.c.charCodeAt(h);if(u)u=!1;else if(N===E.CharCode.Slash&&!$){h++;break}else N===E.CharCode.OpenSquareBracket?$=!0:N===E.CharCode.Backslash?u=!0:N===E.CharCode.CloseSquareBracket&&($=!1);h++}for(;h<this.c.length&&l.a.has(this.c.charCodeAt(h));)h++;this.e=h;const g=this.c.substring(this.d,this.e);this.f.push({type:O.RegexStr,lexeme:g,offset:this.d})}r(){return this.e>=this.c.length}}t.$Bj=l}),define(oe[118],ae([0,1,82,55,15,16,36,17,12]),function(H,t,E,S,w,O,L,I,m){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$6m=t.$5m=void 0,t.$7m=c,t.$8m=h,t.$5m=/^([^.]+\..+)[:=](.+)$/;class l{get appRoot(){return(0,O.$pc)(w.$1g.asFileUri("").fsPath)}get userHome(){return m.URI.file(this.b.homeDir)}get userDataPath(){return this.b.userDataDir}get appSettingsHome(){return m.URI.file((0,O.$mc)(this.userDataPath,"User"))}get tmpDir(){return m.URI.file(this.b.tmpDir)}get cacheHome(){return m.URI.file(this.userDataPath)}get stateResource(){return(0,I.$hh)(this.appSettingsHome,"globalStorage","storage.json")}get userRoamingDataHome(){return this.appSettingsHome.with({scheme:w.Schemas.vscodeUserData})}get userDataSyncHome(){return(0,I.$hh)(this.appSettingsHome,"sync")}get logsHome(){if(!this.args.logsPath){const $=(0,E.$4m)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,O.$mc)(this.userDataPath,"logs",$)}return m.URI.file(this.args.logsPath)}get sync(){return this.args.sync}get machineSettingsResource(){return(0,I.$hh)(m.URI.file((0,O.$mc)(this.userDataPath,"Machine")),"settings.json")}get workspaceStorageHome(){return(0,I.$hh)(this.appSettingsHome,"workspaceStorage")}get localHistoryHome(){return(0,I.$hh)(this.appSettingsHome,"History")}get keyboardLayoutResource(){return(0,I.$hh)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const $=L.env.VSCODE_PORTABLE;return $?m.URI.file((0,O.$mc)($,"argv.json")):(0,I.$hh)(this.userHome,this.c.dataFolderName,"argv.json")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return m.URI.file((0,O.$mc)(this.userDataPath,"Workspaces"))}get builtinExtensionsPath(){const $=this.args["builtin-extensions-dir"];return $?(0,O.$nc)($):(0,O.$kc)((0,O.$mc)(w.$1g.asFileUri("").fsPath,"..","extensions"))}get extensionsDownloadLocation(){const $=this.args["extensions-download-dir"];return $?m.URI.file((0,O.$nc)($)):m.URI.file((0,O.$mc)(this.userDataPath,"CachedExtensionVSIXs"))}get extensionsPath(){const $=this.args["extensions-dir"];if($)return(0,O.$nc)($);const g=L.env.VSCODE_EXTENSIONS;if(g)return g;const N=L.env.VSCODE_PORTABLE;return N?(0,O.$mc)(N,"extensions"):(0,I.$hh)(this.userHome,this.c.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const $=this.args.extensionDevelopmentPath;if(Array.isArray($))return $.map(g=>/^[^:/?#]+?:\/\//.test(g)?m.URI.parse(g):m.URI.file((0,O.$kc)(g)))}get extensionDevelopmentKind(){return this.args.extensionDevelopmentKind?.map($=>$==="ui"||$==="workspace"||$==="web"?$:"workspace")}get extensionTestsLocationURI(){const $=this.args.extensionTestsPath;if($)return/^[^:/?#]+?:\/\//.test($)?m.URI.parse($):m.URI.file((0,O.$kc)($))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const $=this.args["disable-extension"];if($){if(typeof $=="string")return[$];if(Array.isArray($)&&$.length>0)return $}return!1}get debugExtensionHost(){return c(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!L.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log?.find($=>!t.$5m.test($))}get extensionLogLevel(){const $=[];for(const g of this.args.log||[]){const N=t.$5m.exec(g);N&&N[1]&&N[2]&&$.push([N[1],N[2]])}return $.length?$:void 0}get serviceMachineIdResource(){return(0,I.$hh)(m.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get useInMemorySecretStorage(){return!!this.args["use-inmemory-secretstorage"]}get policyFile(){if(this.args["__enable-file-policy"]){const $=L.env.VSCODE_PORTABLE;return $?m.URI.file((0,O.$mc)($,"policy.json")):(0,I.$hh)(this.userHome,this.c.dataFolderName,"policy.json")}}get continueOn(){return this.args.continueOn}set continueOn($){this.args.continueOn=$}get args(){return this.a}constructor($,g,N){this.a=$,this.b=g,this.c=N,this.editSessionId=this.args.editSessionId}}t.$6m=l,ye([S.$$h],l.prototype,"appRoot",null),ye([S.$$h],l.prototype,"userHome",null),ye([S.$$h],l.prototype,"userDataPath",null),ye([S.$$h],l.prototype,"appSettingsHome",null),ye([S.$$h],l.prototype,"tmpDir",null),ye([S.$$h],l.prototype,"cacheHome",null),ye([S.$$h],l.prototype,"stateResource",null),ye([S.$$h],l.prototype,"userRoamingDataHome",null),ye([S.$$h],l.prototype,"userDataSyncHome",null),ye([S.$$h],l.prototype,"sync",null),ye([S.$$h],l.prototype,"machineSettingsResource",null),ye([S.$$h],l.prototype,"workspaceStorageHome",null),ye([S.$$h],l.prototype,"localHistoryHome",null),ye([S.$$h],l.prototype,"keyboardLayoutResource",null),ye([S.$$h],l.prototype,"argvResource",null),ye([S.$$h],l.prototype,"isExtensionDevelopment",null),ye([S.$$h],l.prototype,"untitledWorkspacesHome",null),ye([S.$$h],l.prototype,"builtinExtensionsPath",null),ye([S.$$h],l.prototype,"extensionsPath",null),ye([S.$$h],l.prototype,"extensionDevelopmentLocationURI",null),ye([S.$$h],l.prototype,"extensionDevelopmentKind",null),ye([S.$$h],l.prototype,"extensionTestsLocationURI",null),ye([S.$$h],l.prototype,"debugExtensionHost",null),ye([S.$$h],l.prototype,"logLevel",null),ye([S.$$h],l.prototype,"extensionLogLevel",null),ye([S.$$h],l.prototype,"serviceMachineIdResource",null),ye([S.$$h],l.prototype,"disableTelemetry",null),ye([S.$$h],l.prototype,"disableWorkspaceTrust",null),ye([S.$$h],l.prototype,"useInMemorySecretStorage",null),ye([S.$$h],l.prototype,"policyFile",null);function c(u,$){return h(u["inspect-extensions"],u["inspect-brk-extensions"],5870,$,u.debugId,u.extensionEnvironment)}function h(u,$,g,N,v,d){const k=Number($||u)||(N?null:g),y=k?!!$:!1;let e;if(d)try{e=JSON.parse(d)}catch{}return{port:k,break:y,debugId:v,env:e}}}),function(){"use strict";function H(t,E,S){function w(L,I){const m=O(L,I),l=[m];return t.isAbsolute(m)||l.unshift(S),t.resolve(...l)}function O(L,I){process.env.VSCODE_DEV&&(I="code-oss-dev");const m=process.env.VSCODE_PORTABLE;if(m)return t.join(m,"user-data");let l=process.env.VSCODE_APPDATA;if(l)return t.join(l,I);const c=L["user-data-dir"];if(c)return c;switch(process.platform){case"win32":if(l=process.env.APPDATA,!l){const h=process.env.USERPROFILE;if(typeof h!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");l=t.join(h,"AppData","Roaming")}break;case"darwin":l=t.join(E.homedir(),"Library","Application Support");break;case"linux":l=process.env.XDG_CONFIG_HOME||t.join(E.homedir(),".config");break;default:throw new Error("Platform not supported")}return t.join(l,I)}return{getUserDataPath:w}}if(typeof define=="function")define(oe[119],ae([173,35,36]),function(t,E,S){return H(t,E,S.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const t=require("path"),E=require("os");module.exports=H(t,E,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(oe[120],ae([0,1,35,118,119]),function(H,t,E,S,w){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$9m=void 0,t.$0m=L,t.$$m=I;class O extends S.$6m{constructor(l,c){super(l,{homeDir:(0,E.homedir)(),tmpDir:(0,E.tmpdir)(),userDataDir:(0,w.getUserDataPath)(l,c.nameShort)},c)}}t.$9m=O;function L(m,l){return(0,S.$8m)(m["inspect-ptyhost"],m["inspect-brk-ptyhost"],5877,l,m.extensionEnvironment)}function I(m,l){return(0,S.$8m)(m["inspect-sharedprocess"],m["inspect-brk-sharedprocess"],5879,l,m.extensionEnvironment)}}),define(oe[121],ae([0,1,3,101]),function(H,t,E,S){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Kq=w;function w(L,I,m,l){try{O(L,I,m,l)}catch(c){L.error(c?.message??c)}return I}function O(L,I,m,l){const c=(h,u,$)=>{const g=h[u];if((0,E.$gg)(g)){const N=g,v=N.length;if(v>1&&N[0]==="%"&&N[v-1]==="%"){const d=N.substr(1,v-2);let p=m[d];p===void 0&&l&&(p=l[d]);const k=typeof p=="string"?p:p?.message,y=l?.[d],e=typeof y=="string"?y:y?.message;if(!k){e||L.warn(`[${I.name}]: ${(0,S.localize)(0,null,d)}`);return}if($&&(u==="title"||u==="category")&&e&&e!==k){const a={value:k,original:e};h[u]=a}else h[u]=k}}else if((0,E.$ig)(g))for(const N in g)g.hasOwnProperty(N)&&(N==="commands"?c(g,N,!0):c(g,N,$));else if(Array.isArray(g))for(let N=0;N<g.length;N++)c(g,N,$)};for(const h in I)I.hasOwnProperty(h)&&c(I,h)}}),define(oe[122],ae([0,1]),function(H,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.allApiProposals=void 0;const E={activeComment:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.activeComment.d.ts"},aiRelatedInformation:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.aiRelatedInformation.d.ts"},aiTextSearchProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.aiTextSearchProvider.d.ts"},attributableCoverage:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.attributableCoverage.d.ts"},authGetSessions:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authGetSessions.d.ts"},authLearnMore:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authLearnMore.d.ts"},authSession:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authSession.d.ts"},canonicalUriProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.canonicalUriProvider.d.ts"},chatParticipantAdditions:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatParticipantAdditions.d.ts"},chatParticipantPrivate:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatParticipantPrivate.d.ts"},chatProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatProvider.d.ts"},chatTab:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatTab.d.ts"},chatVariableResolver:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatVariableResolver.d.ts"},codeActionAI:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codeActionAI.d.ts"},codeActionRanges:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codeActionRanges.d.ts"},codiconDecoration:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codiconDecoration.d.ts"},commentReactor:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentReactor.d.ts"},commentReveal:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentReveal.d.ts"},commentThreadApplicability:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentThreadApplicability.d.ts"},commentingRangeHint:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentingRangeHint.d.ts"},commentsDraftState:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentsDraftState.d.ts"},contribAccessibilityHelpContent:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribAccessibilityHelpContent.d.ts"},contribCommentEditorActionsMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentEditorActionsMenu.d.ts"},contribCommentPeekContext:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentPeekContext.d.ts"},contribCommentThreadAdditionalMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentThreadAdditionalMenu.d.ts"},contribCommentsViewThreadMenus:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentsViewThreadMenus.d.ts"},contribDiffEditorGutterToolBarMenus:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribDiffEditorGutterToolBarMenus.d.ts"},contribEditSessions:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditSessions.d.ts"},contribEditorContentMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditorContentMenu.d.ts"},contribIssueReporter:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribIssueReporter.d.ts"},contribLabelFormatterWorkspaceTooltip:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribLabelFormatterWorkspaceTooltip.d.ts"},contribMenuBarHome:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMenuBarHome.d.ts"},contribMergeEditorMenus:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMergeEditorMenus.d.ts"},contribMultiDiffEditorMenus:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMultiDiffEditorMenus.d.ts"},contribNotebookStaticPreloads:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribNotebookStaticPreloads.d.ts"},contribRemoteHelp:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribRemoteHelp.d.ts"},contribShareMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribShareMenu.d.ts"},contribSourceControlHistoryItemGroupMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlHistoryItemGroupMenu.d.ts"},contribSourceControlHistoryItemMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlHistoryItemMenu.d.ts"},contribSourceControlInputBoxMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlInputBoxMenu.d.ts"},contribSourceControlTitleMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlTitleMenu.d.ts"},contribStatusBarItems:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribStatusBarItems.d.ts"},contribViewsRemote:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsRemote.d.ts"},contribViewsWelcome:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsWelcome.d.ts"},createFileSystemWatcher:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.createFileSystemWatcher.d.ts"},customEditorMove:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.customEditorMove.d.ts"},debugVisualization:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.debugVisualization.d.ts"},defaultChatParticipant:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.defaultChatParticipant.d.ts"},diffCommand:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffCommand.d.ts"},diffContentOptions:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffContentOptions.d.ts"},documentFiltersExclusive:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentFiltersExclusive.d.ts"},documentPaste:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentPaste.d.ts"},editSessionIdentityProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editSessionIdentityProvider.d.ts"},editorHoverVerbosityLevel:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editorHoverVerbosityLevel.d.ts"},editorInsets:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editorInsets.d.ts"},embeddings:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.embeddings.d.ts"},extensionRuntime:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionRuntime.d.ts"},extensionsAny:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionsAny.d.ts"},externalUriOpener:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.externalUriOpener.d.ts"},fileComments:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileComments.d.ts"},fileSearchProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileSearchProvider.d.ts"},findFiles2:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findFiles2.d.ts"},findTextInFiles:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findTextInFiles.d.ts"},fsChunks:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fsChunks.d.ts"},idToken:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.idToken.d.ts"},inlineCompletionsAdditions:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.inlineCompletionsAdditions.d.ts"},inlineEdit:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.inlineEdit.d.ts"},interactive:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactive.d.ts"},interactiveWindow:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactiveWindow.d.ts"},ipc:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.ipc.d.ts"},languageModelSystem:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.languageModelSystem.d.ts"},languageStatusText:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.languageStatusText.d.ts"},lmTools:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.lmTools.d.ts",version:2},mappedEditsProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.mappedEditsProvider.d.ts"},multiDocumentHighlightProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.multiDocumentHighlightProvider.d.ts"},newSymbolNamesProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.newSymbolNamesProvider.d.ts"},notebookCellExecution:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookCellExecution.d.ts"},notebookCellExecutionState:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookCellExecutionState.d.ts"},notebookControllerAffinityHidden:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookControllerAffinityHidden.d.ts"},notebookDeprecated:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookDeprecated.d.ts"},notebookExecution:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookExecution.d.ts"},notebookKernelSource:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookKernelSource.d.ts"},notebookLiveShare:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookLiveShare.d.ts"},notebookMessaging:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMessaging.d.ts"},notebookMime:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMime.d.ts"},notebookVariableProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookVariableProvider.d.ts"},portsAttributes:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.portsAttributes.d.ts"},profileContentHandlers:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.profileContentHandlers.d.ts"},quickDiffProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickDiffProvider.d.ts"},quickPickItemTooltip:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickItemTooltip.d.ts"},quickPickSortByLabel:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickSortByLabel.d.ts"},resolvers:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.resolvers.d.ts"},scmActionButton:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmActionButton.d.ts"},scmHistoryProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmHistoryProvider.d.ts"},scmMultiDiffEditor:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmMultiDiffEditor.d.ts"},scmSelectedProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmSelectedProvider.d.ts"},scmTextDocument:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmTextDocument.d.ts"},scmValidation:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmValidation.d.ts"},shareProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.shareProvider.d.ts"},showLocal:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.showLocal.d.ts"},speech:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.speech.d.ts"},tabInputMultiDiff:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tabInputMultiDiff.d.ts"},tabInputTextMerge:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tabInputTextMerge.d.ts"},taskPresentationGroup:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.taskPresentationGroup.d.ts"},telemetry:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.telemetry.d.ts"},terminalDataWriteEvent:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDataWriteEvent.d.ts"},terminalDimensions:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDimensions.d.ts"},terminalExecuteCommandEvent:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalExecuteCommandEvent.d.ts"},terminalQuickFixProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalQuickFixProvider.d.ts"},terminalSelection:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalSelection.d.ts"},terminalShellIntegration:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalShellIntegration.d.ts"},testObserver:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testObserver.d.ts"},textSearchProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.textSearchProvider.d.ts"},timeline:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.timeline.d.ts"},tokenInformation:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tokenInformation.d.ts"},treeViewActiveItem:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewActiveItem.d.ts"},treeViewMarkdownMessage:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewMarkdownMessage.d.ts"},treeViewReveal:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewReveal.d.ts"},tunnelFactory:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnelFactory.d.ts"},tunnels:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnels.d.ts"},workspaceTrust:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.workspaceTrust.d.ts"}};t.allApiProposals=Object.freeze(E)}),define(oe[51],ae([0,1]),function(H,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Di=void 0;class E{constructor(w,O=[],L=!1){this.ctor=w,this.staticArguments=O,this.supportsDelayedInstantiation=L}}t.$Di=E}),define(oe[123],ae([0,1,51]),function(H,t,E){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.InstantiationType=void 0,t.$Ps=O,t.$Qs=L;const S=[];var w;(function(I){I[I.Eager=0]="Eager",I[I.Delayed=1]="Delayed"})(w||(t.InstantiationType=w={}));function O(I,m,l){m instanceof E.$Di||(m=new E.$Di(m,[],!!l)),S.push([I,m])}function L(){return S}}),define(oe[124],ae([0,1]),function(H,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$tr=t.$sr=void 0;class E{constructor(O,L){this.key=O,this.data=L,this.incoming=new Map,this.outgoing=new Map}}t.$sr=E;class S{constructor(O){this.b=O,this.a=new Map}roots(){const O=[];for(const L of this.a.values())L.outgoing.size===0&&O.push(L);return O}insertEdge(O,L){const I=this.lookupOrInsertNode(O),m=this.lookupOrInsertNode(L);I.outgoing.set(m.key,m),m.incoming.set(I.key,I)}removeNode(O){const L=this.b(O);this.a.delete(L);for(const I of this.a.values())I.outgoing.delete(L),I.incoming.delete(L)}lookupOrInsertNode(O){const L=this.b(O);let I=this.a.get(L);return I||(I=new E(L,O),this.a.set(L,I)),I}lookup(O){return this.a.get(this.b(O))}isEmpty(){return this.a.size===0}toString(){const O=[];for(const[L,I]of this.a)O.push(`${L}
	(-> incoming)[${[...I.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...I.outgoing.keys()].join(",")}]
`);return O.join(`
`)}findCycleSlow(){for(const[O,L]of this.a){const I=new Set([O]),m=this.c(L,I);if(m)return m}}c(O,L){for(const[I,m]of O.outgoing){if(L.has(I))return[...L,I].join(" -> ");L.add(I);const l=this.c(m,L);if(l)return l;L.delete(I)}}}t.$tr=S}),define(oe[30],ae([0,1,3,12,11]),function(H,t,E,S,w){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ConfigurationTarget=t.$aj=void 0,t.$bj=O,t.$cj=L,t.$dj=m,t.$ej=l,t.$fj=c,t.$gj=h,t.$hj=u,t.$ij=g,t.$jj=N,t.$kj=v,E=be(E),t.$aj=(0,w.$Gi)("configurationService");function O(d){return d&&typeof d=="object"&&(!d.overrideIdentifier||typeof d.overrideIdentifier=="string")&&(!d.resource||d.resource instanceof S.URI)}function L(d){return d&&typeof d=="object"&&(!d.overrideIdentifiers||Array.isArray(d.overrideIdentifiers))&&!d.overrideIdentifier&&(!d.resource||d.resource instanceof S.URI)}var I;(function(d){d[d.APPLICATION=1]="APPLICATION",d[d.USER=2]="USER",d[d.USER_LOCAL=3]="USER_LOCAL",d[d.USER_REMOTE=4]="USER_REMOTE",d[d.WORKSPACE=5]="WORKSPACE",d[d.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",d[d.DEFAULT=7]="DEFAULT",d[d.MEMORY=8]="MEMORY"})(I||(t.ConfigurationTarget=I={}));function m(d){switch(d){case I.APPLICATION:return"APPLICATION";case I.USER:return"USER";case I.USER_LOCAL:return"USER_LOCAL";case I.USER_REMOTE:return"USER_REMOTE";case I.WORKSPACE:return"WORKSPACE";case I.WORKSPACE_FOLDER:return"WORKSPACE_FOLDER";case I.DEFAULT:return"DEFAULT";case I.MEMORY:return"MEMORY"}}function l(d){return d.applicationValue!==void 0||d.userValue!==void 0||d.userLocalValue!==void 0||d.userRemoteValue!==void 0||d.workspaceValue!==void 0||d.workspaceFolderValue!==void 0}function c(d,p){const k=Object.create(null);for(const y in d)h(k,y,d[y],p);return k}function h(d,p,k,y){const e=p.split("."),a=e.pop();let n=d;for(let r=0;r<e.length;r++){const i=e[r];let s=n[i];switch(typeof s){case"undefined":s=n[i]=Object.create(null);break;case"object":if(s===null){y(`Ignoring ${p} as ${e.slice(0,r+1).join(".")} is null`);return}break;default:y(`Ignoring ${p} as ${e.slice(0,r+1).join(".")} is ${JSON.stringify(s)}`);return}n=s}if(typeof n=="object"&&n!==null)try{n[a]=k}catch{y(`Ignoring ${p} as ${e.join(".")} is ${JSON.stringify(n)}`)}else y(`Ignoring ${p} as ${e.join(".")} is ${JSON.stringify(n)}`)}function u(d,p){const k=p.split(".");$(d,k)}function $(d,p){const k=p.shift();if(p.length===0){delete d[k];return}if(Object.keys(d).indexOf(k)!==-1){const y=d[k];typeof y=="object"&&!Array.isArray(y)&&($(y,p),Object.keys(y).length===0&&delete d[k])}}function g(d,p,k){function y(n,r){let i=n;for(const s of r){if(typeof i!="object"||i===null)return;i=i[s]}return i}const e=p.split("."),a=y(d,e);return typeof a>"u"?k:a}function N(d,p,k){Object.keys(p).forEach(y=>{y!=="__proto__"&&(y in d?E.$ig(d[y])&&E.$ig(p[y])?N(d[y],p[y],k):k&&(d[y]=p[y]):d[y]=p[y])})}function v(d){return d.replace(/[\[\]]/g,"")}}),define(oe[125],ae([0,1,117,13,32,116,11,96,9]),function(H,t,E,S,w,O,L,I,m){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Yj=t.$Xj=t.$Wj=t.$Vj=t.$Uj=t.$Tj=t.$Sj=t.$Rj=t.$Qj=t.$Pj=t.$Oj=t.$Nj=t.$Mj=t.$Lj=t.$Kj=t.$Jj=t.$Ij=t.$Hj=t.$Ej=t.$Dj=t.ContextKeyExprType=void 0,t.$Cj=c,t.$Fj=r,t.$Gj=i,t.$Zj=F;const l=new Map;l.set("false",!1),l.set("true",!0),l.set("isMac",S.$j),l.set("isLinux",S.$k),l.set("isWindows",S.$i),l.set("isWeb",S.$o),l.set("isMacNative",S.$j&&!S.$o),l.set("isEdge",S.$H),l.set("isFirefox",S.$F),l.set("isChrome",S.$E),l.set("isSafari",S.$G);function c(V,P){if(l.get(V)!==void 0)throw(0,m.$0)("contextkey.setConstant(k, v) invoked with already set constant `k`");l.set(V,P)}const h=Object.prototype.hasOwnProperty;var u;(function(V){V[V.False=0]="False",V[V.True=1]="True",V[V.Defined=2]="Defined",V[V.Not=3]="Not",V[V.Equals=4]="Equals",V[V.NotEquals=5]="NotEquals",V[V.And=6]="And",V[V.Regex=7]="Regex",V[V.NotRegex=8]="NotRegex",V[V.Or=9]="Or",V[V.In=10]="In",V[V.NotIn=11]="NotIn",V[V.Greater=12]="Greater",V[V.GreaterEquals=13]="GreaterEquals",V[V.Smaller=14]="Smaller",V[V.SmallerEquals=15]="SmallerEquals"})(u||(t.ContextKeyExprType=u={}));const $={regexParsingWithErrorRecovery:!0},g=(0,I.localize)(0,null),N=(0,I.localize)(1,null),v=(0,I.localize)(2,null),d=(0,I.localize)(3,null),p=(0,I.localize)(4,null),k=(0,I.localize)(5,null),y=(0,I.localize)(6,null),e=(0,I.localize)(7,null);class a{static{this.c=new Error}get lexingErrors(){return this.d.errors}get parsingErrors(){return this.h}constructor(P=$){this.k=P,this.d=new O.$Bj,this.f=[],this.g=0,this.h=[],this.v=/g|y/g}parse(P){if(P===""){this.h.push({message:g,offset:0,lexeme:"",additionalInfo:N});return}this.f=this.d.reset(P).scan(),this.g=0,this.h=[];try{const j=this.l();if(!this.E()){const U=this.D(),C=U.type===O.TokenType.Str?k:void 0;throw this.h.push({message:p,offset:U.offset,lexeme:O.$Bj.getLexeme(U),additionalInfo:C}),a.c}return j}catch(j){if(j!==a.c)throw j;return}}l(){return this.m()}m(){const P=[this.o()];for(;this.y(O.TokenType.Or);){const j=this.o();P.push(j)}return P.length===1?P[0]:n.or(...P)}o(){const P=[this.s()];for(;this.y(O.TokenType.And);){const j=this.s();P.push(j)}return P.length===1?P[0]:n.and(...P)}s(){if(this.y(O.TokenType.Neg)){const P=this.D();switch(P.type){case O.TokenType.True:return this.z(),o.INSTANCE;case O.TokenType.False:return this.z(),f.INSTANCE;case O.TokenType.LParen:{this.z();const j=this.l();return this.A(O.TokenType.RParen,d),j?.negate()}case O.TokenType.Str:return this.z(),z.create(P.lexeme);default:throw this.B("KEY | true | false | '(' expression ')'",P)}}return this.t()}t(){const P=this.D();switch(P.type){case O.TokenType.True:return this.z(),n.true();case O.TokenType.False:return this.z(),n.false();case O.TokenType.LParen:{this.z();const j=this.l();return this.A(O.TokenType.RParen,d),j}case O.TokenType.Str:{const j=P.lexeme;if(this.z(),this.y(O.TokenType.RegexOp)){const C=this.D();if(!this.k.regexParsingWithErrorRecovery){if(this.z(),C.type!==O.TokenType.RegexStr)throw this.B("REGEX",C);const X=C.lexeme,Z=X.lastIndexOf("/"),ne=Z===X.length-1?void 0:this.w(X.substring(Z+1));let ce;try{ce=new RegExp(X.substring(1,Z),ne)}catch{throw this.B("REGEX",C)}return fe.create(j,ce)}switch(C.type){case O.TokenType.RegexStr:case O.TokenType.Error:{const X=[C.lexeme];this.z();let Z=this.D(),ne=0;for(let we=0;we<C.lexeme.length;we++)C.lexeme.charCodeAt(we)===E.CharCode.OpenParen?ne++:C.lexeme.charCodeAt(we)===E.CharCode.CloseParen&&ne--;for(;!this.E()&&Z.type!==O.TokenType.And&&Z.type!==O.TokenType.Or;){switch(Z.type){case O.TokenType.LParen:ne++;break;case O.TokenType.RParen:ne--;break;case O.TokenType.RegexStr:case O.TokenType.QuotedStr:for(let we=0;we<Z.lexeme.length;we++)Z.lexeme.charCodeAt(we)===E.CharCode.OpenParen?ne++:C.lexeme.charCodeAt(we)===E.CharCode.CloseParen&&ne--}if(ne<0)break;X.push(O.$Bj.getLexeme(Z)),this.z(),Z=this.D()}const ce=X.join(""),pe=ce.lastIndexOf("/"),me=pe===ce.length-1?void 0:this.w(ce.substring(pe+1));let ge;try{ge=new RegExp(ce.substring(1,pe),me)}catch{throw this.B("REGEX",C)}return n.regex(j,ge)}case O.TokenType.QuotedStr:{const X=C.lexeme;this.z();let Z=null;if(!(0,w.$ef)(X)){const ne=X.indexOf("/"),ce=X.lastIndexOf("/");if(ne!==ce&&ne>=0){const pe=X.slice(ne+1,ce),me=X[ce+1]==="i"?"i":"";try{Z=new RegExp(pe,me)}catch{throw this.B("REGEX",C)}}}if(Z===null)throw this.B("REGEX",C);return fe.create(j,Z)}default:throw this.B("REGEX",this.D())}}if(this.y(O.TokenType.Not)){this.A(O.TokenType.In,v);const C=this.u();return n.notIn(j,C)}switch(this.D().type){case O.TokenType.Eq:{this.z();const C=this.u();if(this.x().type===O.TokenType.QuotedStr)return n.equals(j,C);switch(C){case"true":return n.has(j);case"false":return n.not(j);default:return n.equals(j,C)}}case O.TokenType.NotEq:{this.z();const C=this.u();if(this.x().type===O.TokenType.QuotedStr)return n.notEquals(j,C);switch(C){case"true":return n.not(j);case"false":return n.has(j);default:return n.notEquals(j,C)}}case O.TokenType.Lt:return this.z(),le.create(j,this.u());case O.TokenType.LtEq:return this.z(),ue.create(j,this.u());case O.TokenType.Gt:return this.z(),Q.create(j,this.u());case O.TokenType.GtEq:return this.z(),se.create(j,this.u());case O.TokenType.In:return this.z(),n.in(j,this.u());default:return n.has(j)}}case O.TokenType.EOF:throw this.h.push({message:y,offset:P.offset,lexeme:"",additionalInfo:e}),a.c;default:throw this.B(`true | false | KEY 
	| KEY '=~' REGEX 
	| KEY ('==' | '!=' | '<' | '<=' | '>' | '>=' | 'in' | 'not' 'in') value`,this.D())}}u(){const P=this.D();switch(P.type){case O.TokenType.Str:case O.TokenType.QuotedStr:return this.z(),P.lexeme;case O.TokenType.True:return this.z(),"true";case O.TokenType.False:return this.z(),"false";case O.TokenType.In:return this.z(),"in";default:return""}}w(P){return P.replaceAll(this.v,"")}x(){return this.f[this.g-1]}y(P){return this.C(P)?(this.z(),!0):!1}z(){return this.E()||this.g++,this.x()}A(P,j){if(this.C(P))return this.z();throw this.B(j,this.D())}B(P,j,U){const C=(0,I.localize)(8,null,P,O.$Bj.getLexeme(j)),X=j.offset,Z=O.$Bj.getLexeme(j);return this.h.push({message:C,offset:X,lexeme:Z,additionalInfo:U}),a.c}C(P){return this.D().type===P}D(){return this.f[this.g]}E(){return this.D().type===O.TokenType.EOF}}t.$Dj=a;class n{static false(){return o.INSTANCE}static true(){return f.INSTANCE}static has(P){return b.create(P)}static equals(P,j){return R.create(P,j)}static notEquals(P,j){return A.create(P,j)}static regex(P,j){return fe.create(P,j)}static in(P,j){return T.create(P,j)}static notIn(P,j){return D.create(P,j)}static not(P){return z.create(P)}static and(...P){return B.create(P,null,!0)}static or(...P){return M.create(P,null,!0)}static greater(P,j){return Q.create(P,j)}static greaterEquals(P,j){return se.create(P,j)}static smaller(P,j){return le.create(P,j)}static smallerEquals(P,j){return ue.create(P,j)}static{this.c=new a({regexParsingWithErrorRecovery:!1})}static deserialize(P){return P==null?void 0:this.c.parse(P)}}t.$Ej=n;function r(V){const P=new a({regexParsingWithErrorRecovery:!1});return V.map(j=>(P.parse(j),P.lexingErrors.length>0?P.lexingErrors.map(U=>({errorMessage:U.additionalInfo?(0,I.localize)(9,null,U.additionalInfo):(0,I.localize)(10,null),offset:U.offset,length:U.lexeme.length})):P.parsingErrors.length>0?P.parsingErrors.map(U=>({errorMessage:U.additionalInfo?`${U.message}. ${U.additionalInfo}`:U.message,offset:U.offset,length:U.lexeme.length})):[]))}function i(V,P){const j=V?V.substituteConstants():void 0,U=P?P.substituteConstants():void 0;return!j&&!U?!0:!j||!U?!1:j.equals(U)}function s(V,P){return V.cmp(P)}class o{static{this.INSTANCE=new o}constructor(){this.type=u.False}cmp(P){return this.type-P.type}equals(P){return P.type===this.type}substituteConstants(){return this}evaluate(P){return!1}serialize(){return"false"}keys(){return[]}map(P){return this}negate(){return f.INSTANCE}}t.$Hj=o;class f{static{this.INSTANCE=new f}constructor(){this.type=u.True}cmp(P){return this.type-P.type}equals(P){return P.type===this.type}substituteConstants(){return this}evaluate(P){return!0}serialize(){return"true"}keys(){return[]}map(P){return this}negate(){return o.INSTANCE}}t.$Ij=f;class b{static create(P,j=null){const U=l.get(P);return typeof U=="boolean"?U?f.INSTANCE:o.INSTANCE:new b(P,j)}constructor(P,j){this.key=P,this.c=j,this.type=u.Defined}cmp(P){return P.type!==this.type?this.type-P.type:Y(this.key,P.key)}equals(P){return P.type===this.type?this.key===P.key:!1}substituteConstants(){const P=l.get(this.key);return typeof P=="boolean"?P?f.INSTANCE:o.INSTANCE:this}evaluate(P){return!!P.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(P){return P.mapDefined(this.key)}negate(){return this.c||(this.c=z.create(this.key,this)),this.c}}t.$Jj=b;class R{static create(P,j,U=null){if(typeof j=="boolean")return j?b.create(P,U):z.create(P,U);const C=l.get(P);return typeof C=="boolean"?j===(C?"true":"false")?f.INSTANCE:o.INSTANCE:new R(P,j,U)}constructor(P,j,U){this.c=P,this.d=j,this.f=U,this.type=u.Equals}cmp(P){return P.type!==this.type?this.type-P.type:te(this.c,this.d,P.c,P.d)}equals(P){return P.type===this.type?this.c===P.c&&this.d===P.d:!1}substituteConstants(){const P=l.get(this.c);if(typeof P=="boolean"){const j=P?"true":"false";return this.d===j?f.INSTANCE:o.INSTANCE}return this}evaluate(P){return P.getValue(this.c)==this.d}serialize(){return`${this.c} == '${this.d}'`}keys(){return[this.c]}map(P){return P.mapEquals(this.c,this.d)}negate(){return this.f||(this.f=A.create(this.c,this.d,this)),this.f}}t.$Kj=R;class T{static create(P,j){return new T(P,j)}constructor(P,j){this.d=P,this.f=j,this.type=u.In,this.c=null}cmp(P){return P.type!==this.type?this.type-P.type:te(this.d,this.f,P.d,P.f)}equals(P){return P.type===this.type?this.d===P.d&&this.f===P.f:!1}substituteConstants(){return this}evaluate(P){const j=P.getValue(this.f),U=P.getValue(this.d);return Array.isArray(j)?j.includes(U):typeof U=="string"&&typeof j=="object"&&j!==null?h.call(j,U):!1}serialize(){return`${this.d} in '${this.f}'`}keys(){return[this.d,this.f]}map(P){return P.mapIn(this.d,this.f)}negate(){return this.c||(this.c=D.create(this.d,this.f)),this.c}}t.$Lj=T;class D{static create(P,j){return new D(P,j)}constructor(P,j){this.d=P,this.f=j,this.type=u.NotIn,this.c=T.create(P,j)}cmp(P){return P.type!==this.type?this.type-P.type:this.c.cmp(P.c)}equals(P){return P.type===this.type?this.c.equals(P.c):!1}substituteConstants(){return this}evaluate(P){return!this.c.evaluate(P)}serialize(){return`${this.d} not in '${this.f}'`}keys(){return this.c.keys()}map(P){return P.mapNotIn(this.d,this.f)}negate(){return this.c}}t.$Mj=D;class A{static create(P,j,U=null){if(typeof j=="boolean")return j?z.create(P,U):b.create(P,U);const C=l.get(P);return typeof C=="boolean"?j===(C?"true":"false")?o.INSTANCE:f.INSTANCE:new A(P,j,U)}constructor(P,j,U){this.c=P,this.d=j,this.f=U,this.type=u.NotEquals}cmp(P){return P.type!==this.type?this.type-P.type:te(this.c,this.d,P.c,P.d)}equals(P){return P.type===this.type?this.c===P.c&&this.d===P.d:!1}substituteConstants(){const P=l.get(this.c);if(typeof P=="boolean"){const j=P?"true":"false";return this.d===j?o.INSTANCE:f.INSTANCE}return this}evaluate(P){return P.getValue(this.c)!=this.d}serialize(){return`${this.c} != '${this.d}'`}keys(){return[this.c]}map(P){return P.mapNotEquals(this.c,this.d)}negate(){return this.f||(this.f=R.create(this.c,this.d,this)),this.f}}t.$Nj=A;class z{static create(P,j=null){const U=l.get(P);return typeof U=="boolean"?U?o.INSTANCE:f.INSTANCE:new z(P,j)}constructor(P,j){this.c=P,this.d=j,this.type=u.Not}cmp(P){return P.type!==this.type?this.type-P.type:Y(this.c,P.c)}equals(P){return P.type===this.type?this.c===P.c:!1}substituteConstants(){const P=l.get(this.c);return typeof P=="boolean"?P?o.INSTANCE:f.INSTANCE:this}evaluate(P){return!P.getValue(this.c)}serialize(){return`!${this.c}`}keys(){return[this.c]}map(P){return P.mapNot(this.c)}negate(){return this.d||(this.d=b.create(this.c,this)),this.d}}t.$Oj=z;function J(V,P){if(typeof V=="string"){const j=parseFloat(V);isNaN(j)||(V=j)}return typeof V=="string"||typeof V=="number"?P(V):o.INSTANCE}class Q{static create(P,j,U=null){return J(j,C=>new Q(P,C,U))}constructor(P,j,U){this.c=P,this.d=j,this.f=U,this.type=u.Greater}cmp(P){return P.type!==this.type?this.type-P.type:te(this.c,this.d,P.c,P.d)}equals(P){return P.type===this.type?this.c===P.c&&this.d===P.d:!1}substituteConstants(){return this}evaluate(P){return typeof this.d=="string"?!1:parseFloat(P.getValue(this.c))>this.d}serialize(){return`${this.c} > ${this.d}`}keys(){return[this.c]}map(P){return P.mapGreater(this.c,this.d)}negate(){return this.f||(this.f=ue.create(this.c,this.d,this)),this.f}}t.$Pj=Q;class se{static create(P,j,U=null){return J(j,C=>new se(P,C,U))}constructor(P,j,U){this.c=P,this.d=j,this.f=U,this.type=u.GreaterEquals}cmp(P){return P.type!==this.type?this.type-P.type:te(this.c,this.d,P.c,P.d)}equals(P){return P.type===this.type?this.c===P.c&&this.d===P.d:!1}substituteConstants(){return this}evaluate(P){return typeof this.d=="string"?!1:parseFloat(P.getValue(this.c))>=this.d}serialize(){return`${this.c} >= ${this.d}`}keys(){return[this.c]}map(P){return P.mapGreaterEquals(this.c,this.d)}negate(){return this.f||(this.f=le.create(this.c,this.d,this)),this.f}}t.$Qj=se;class le{static create(P,j,U=null){return J(j,C=>new le(P,C,U))}constructor(P,j,U){this.c=P,this.d=j,this.f=U,this.type=u.Smaller}cmp(P){return P.type!==this.type?this.type-P.type:te(this.c,this.d,P.c,P.d)}equals(P){return P.type===this.type?this.c===P.c&&this.d===P.d:!1}substituteConstants(){return this}evaluate(P){return typeof this.d=="string"?!1:parseFloat(P.getValue(this.c))<this.d}serialize(){return`${this.c} < ${this.d}`}keys(){return[this.c]}map(P){return P.mapSmaller(this.c,this.d)}negate(){return this.f||(this.f=se.create(this.c,this.d,this)),this.f}}t.$Rj=le;class ue{static create(P,j,U=null){return J(j,C=>new ue(P,C,U))}constructor(P,j,U){this.c=P,this.d=j,this.f=U,this.type=u.SmallerEquals}cmp(P){return P.type!==this.type?this.type-P.type:te(this.c,this.d,P.c,P.d)}equals(P){return P.type===this.type?this.c===P.c&&this.d===P.d:!1}substituteConstants(){return this}evaluate(P){return typeof this.d=="string"?!1:parseFloat(P.getValue(this.c))<=this.d}serialize(){return`${this.c} <= ${this.d}`}keys(){return[this.c]}map(P){return P.mapSmallerEquals(this.c,this.d)}negate(){return this.f||(this.f=Q.create(this.c,this.d,this)),this.f}}t.$Sj=ue;class fe{static create(P,j){return new fe(P,j)}constructor(P,j){this.d=P,this.f=j,this.type=u.Regex,this.c=null}cmp(P){if(P.type!==this.type)return this.type-P.type;if(this.d<P.d)return-1;if(this.d>P.d)return 1;const j=this.f?this.f.source:"",U=P.f?P.f.source:"";return j<U?-1:j>U?1:0}equals(P){if(P.type===this.type){const j=this.f?this.f.source:"",U=P.f?P.f.source:"";return this.d===P.d&&j===U}return!1}substituteConstants(){return this}evaluate(P){const j=P.getValue(this.d);return this.f?this.f.test(j):!1}serialize(){const P=this.f?`/${this.f.source}/${this.f.flags}`:"/invalid/";return`${this.d} =~ ${P}`}keys(){return[this.d]}map(P){return P.mapRegex(this.d,this.f)}negate(){return this.c||(this.c=x.create(this)),this.c}}t.$Tj=fe;class x{static create(P){return new x(P)}constructor(P){this.c=P,this.type=u.NotRegex}cmp(P){return P.type!==this.type?this.type-P.type:this.c.cmp(P.c)}equals(P){return P.type===this.type?this.c.equals(P.c):!1}substituteConstants(){return this}evaluate(P){return!this.c.evaluate(P)}serialize(){return`!(${this.c.serialize()})`}keys(){return this.c.keys()}map(P){return new x(this.c.map(P))}negate(){return this.c}}t.$Uj=x;function _(V){let P=null;for(let j=0,U=V.length;j<U;j++){const C=V[j].substituteConstants();if(V[j]!==C&&P===null){P=[];for(let X=0;X<j;X++)P[X]=V[X]}P!==null&&(P[j]=C)}return P===null?V:P}class B{static create(P,j,U){return B.d(P,j,U)}constructor(P,j){this.expr=P,this.c=j,this.type=u.And}cmp(P){if(P.type!==this.type)return this.type-P.type;if(this.expr.length<P.expr.length)return-1;if(this.expr.length>P.expr.length)return 1;for(let j=0,U=this.expr.length;j<U;j++){const C=s(this.expr[j],P.expr[j]);if(C!==0)return C}return 0}equals(P){if(P.type===this.type){if(this.expr.length!==P.expr.length)return!1;for(let j=0,U=this.expr.length;j<U;j++)if(!this.expr[j].equals(P.expr[j]))return!1;return!0}return!1}substituteConstants(){const P=_(this.expr);return P===this.expr?this:B.create(P,this.c,!1)}evaluate(P){for(let j=0,U=this.expr.length;j<U;j++)if(!this.expr[j].evaluate(P))return!1;return!0}static d(P,j,U){const C=[];let X=!1;for(const Z of P)if(Z){if(Z.type===u.True){X=!0;continue}if(Z.type===u.False)return o.INSTANCE;if(Z.type===u.And){C.push(...Z.expr);continue}C.push(Z)}if(C.length===0&&X)return f.INSTANCE;if(C.length!==0){if(C.length===1)return C[0];C.sort(s);for(let Z=1;Z<C.length;Z++)C[Z-1].equals(C[Z])&&(C.splice(Z,1),Z--);if(C.length===1)return C[0];for(;C.length>1;){const Z=C[C.length-1];if(Z.type!==u.Or)break;C.pop();const ne=C.pop(),ce=C.length===0,pe=M.create(Z.expr.map(me=>B.create([me,ne],null,U)),null,ce);pe&&(C.push(pe),C.sort(s))}if(C.length===1)return C[0];if(U){for(let Z=0;Z<C.length;Z++)for(let ne=Z+1;ne<C.length;ne++)if(C[Z].negate().equals(C[ne]))return o.INSTANCE;if(C.length===1)return C[0]}return new B(C,j)}}serialize(){return this.expr.map(P=>P.serialize()).join(" && ")}keys(){const P=[];for(const j of this.expr)P.push(...j.keys());return P}map(P){return new B(this.expr.map(j=>j.map(P)),null)}negate(){if(!this.c){const P=[];for(const j of this.expr)P.push(j.negate());this.c=M.create(P,this,!0)}return this.c}}t.$Vj=B;class M{static create(P,j,U){return M.d(P,j,U)}constructor(P,j){this.expr=P,this.c=j,this.type=u.Or}cmp(P){if(P.type!==this.type)return this.type-P.type;if(this.expr.length<P.expr.length)return-1;if(this.expr.length>P.expr.length)return 1;for(let j=0,U=this.expr.length;j<U;j++){const C=s(this.expr[j],P.expr[j]);if(C!==0)return C}return 0}equals(P){if(P.type===this.type){if(this.expr.length!==P.expr.length)return!1;for(let j=0,U=this.expr.length;j<U;j++)if(!this.expr[j].equals(P.expr[j]))return!1;return!0}return!1}substituteConstants(){const P=_(this.expr);return P===this.expr?this:M.create(P,this.c,!1)}evaluate(P){for(let j=0,U=this.expr.length;j<U;j++)if(this.expr[j].evaluate(P))return!0;return!1}static d(P,j,U){let C=[],X=!1;if(P){for(let Z=0,ne=P.length;Z<ne;Z++){const ce=P[Z];if(ce){if(ce.type===u.False){X=!0;continue}if(ce.type===u.True)return f.INSTANCE;if(ce.type===u.Or){C=C.concat(ce.expr);continue}C.push(ce)}}if(C.length===0&&X)return o.INSTANCE;C.sort(s)}if(C.length!==0){if(C.length===1)return C[0];for(let Z=1;Z<C.length;Z++)C[Z-1].equals(C[Z])&&(C.splice(Z,1),Z--);if(C.length===1)return C[0];if(U){for(let Z=0;Z<C.length;Z++)for(let ne=Z+1;ne<C.length;ne++)if(C[Z].negate().equals(C[ne]))return f.INSTANCE;if(C.length===1)return C[0]}return new M(C,j)}}serialize(){return this.expr.map(P=>P.serialize()).join(" || ")}keys(){const P=[];for(const j of this.expr)P.push(...j.keys());return P}map(P){return new M(this.expr.map(j=>j.map(P)),null)}negate(){if(!this.c){const P=[];for(const j of this.expr)P.push(j.negate());for(;P.length>1;){const j=P.shift(),U=P.shift(),C=[];for(const X of K(j))for(const Z of K(U))C.push(B.create([X,Z],null,!1));P.unshift(M.create(C,null,!1))}this.c=M.create(P,this,!0)}return this.c}}t.$Wj=M;class G extends b{static{this.d=[]}static all(){return G.d.values()}constructor(P,j,U){super(P,null),this.f=j,typeof U=="object"?G.d.push({...U,key:P}):U!==!0&&G.d.push({key:P,description:U,type:j!=null?typeof j:void 0})}bindTo(P){return P.createKey(this.key,this.f)}getValue(P){return P.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(P){return R.create(this.key,P)}notEqualsTo(P){return A.create(this.key,P)}}t.$Xj=G,t.$Yj=(0,L.$Gi)("contextKeyService");function Y(V,P){return V<P?-1:V>P?1:0}function te(V,P,j,U){return V<j?-1:V>j?1:P<U?-1:P>U?1:0}function F(V,P){if(V.type===u.False||P.type===u.True)return!0;if(V.type===u.Or)return P.type===u.Or?q(V.expr,P.expr):!1;if(P.type===u.Or){for(const j of P.expr)if(F(V,j))return!0;return!1}if(V.type===u.And){if(P.type===u.And)return q(P.expr,V.expr);for(const j of V.expr)if(F(j,P))return!0;return!1}return V.equals(P)}function q(V,P){let j=0,U=0;for(;j<V.length&&U<P.length;){const C=V[j].cmp(P[U]);if(C<0)return!1;C===0&&j++,U++}return j===V.length}function K(V){return V.type===u.Or?V.expr:[V]}}),define(oe[61],ae([0,1,11]),function(H,t,E){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Zo=void 0,t.$Zo=(0,E.$Gi)("downloadService")}),define(oe[18],ae([0,1,11]),function(H,t,E){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Oi=t.$Ni=void 0,t.$Ni=(0,E.$Gi)("environmentService"),t.$Oi=(0,E.$Hi)(t.$Ni)}),define(oe[62],ae([0,1,14,9,107,10]),function(H,t,E,S,w,O){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Zq=L;async function L(c,h,u,$,g,N){let v;try{await I(c,h,u,$,g,N)}catch(d){v=d}finally{v&&g.errorTransformer&&(v=g.errorTransformer(v)),typeof v<"u"&&u.error(v),u.end()}}async function I(c,h,u,$,g,N){m(N);const v=await c.open(h,{create:!1});try{m(N);let d=0,p=0,k=g&&typeof g.length=="number"?g.length:void 0,y=E.$Pe.alloc(Math.min(g.bufferSize,typeof k=="number"?k:g.bufferSize)),e=g&&typeof g.position=="number"?g.position:0,a=0;do p=await c.read(v,e,y.buffer,a,y.byteLength-a),e+=p,a+=p,d+=p,typeof k=="number"&&(k-=p),a===y.byteLength&&(await u.write($(y)),y=E.$Pe.alloc(Math.min(g.bufferSize,typeof k=="number"?k:g.bufferSize)),a=0);while(p>0&&(typeof k!="number"||k>0)&&m(N)&&l(d,g));if(a>0){let n=a;typeof k=="number"&&(n=Math.min(a,k)),u.write($(y.slice(0,n)))}}catch(d){throw(0,O.$ol)(d)}finally{await c.close(v)}}function m(c){if(c.isCancellationRequested)throw(0,S.$9)();return!0}function l(c,h){if(typeof h?.limits?.size=="number"&&c>h.limits.size)throw(0,O.$nl)((0,w.localize)(0,null),O.FileSystemProviderErrorCode.FileTooLarge);return!0}}),define(oe[126],ae([0,1,94,2,52,5,10,12,8]),function(H,t,E,S,w,O,L,I,m){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$ir=void 0;class l extends S.$Xc{constructor(){super(),this.a=this.B(new O.$ne),this.onDidChangeFile=this.a.event,this.b=this.B(new O.$ne),this.onDidLogMessage=this.b.event,this.c=this.B(new O.$ne),this.f=this.c.event,this.g=new Set,this.h=new Map,this.j=this.B(new S.$7c),this.m=new Set,this.n=this.B(new m.$Eh(this.y())),this.r=5007,this.s=new m.$4h,this.R=!1,this.B(this.f(h=>this.t(h)))}t(h){this.u(h)&&this.z(h)}u(h){return(0,w.$2q)(h)}async watch(h){this.s.isSettled||this.s.complete(),this.s=new m.$4h;try{this.h.clear(),this.g.clear();for(const u of h)this.u(u)?this.h.set(u.correlationId,u):this.g.add(u);for(const[u]of this.j)this.h.has(u)||(this.j.deleteAndDispose(u),this.m.delete(u));return await this.w(!1)}finally{this.s.complete()}}w(h){return this.n.trigger(()=>this.N([...this.g,...Array.from(this.h.values()).filter(u=>!this.j.has(u.correlationId))]),h?this.y():0)}y(){return 800}isSuspended(h){return typeof h.correlationId!="number"?!1:this.m.has(h.correlationId)?"polling":this.j.has(h.correlationId)}async z(h){if(this.j.has(h.correlationId))return;const u=new S.$Wc;this.j.set(h.correlationId,u),await this.s.p,!u.isDisposed&&(this.D(h,u),this.w(!0))}C(h){this.j.deleteAndDispose(h.correlationId),this.m.delete(h.correlationId),this.w(!1)}D(h,u){this.F(h,u)?(this.P(`reusing an existing recursive watcher to monitor ${h.path}`),this.m.delete(h.correlationId)):(this.G(h,u),this.m.add(h.correlationId))}F(h,u){const $=this.O?.subscribe(h.path,(g,N)=>{u.isDisposed||(g?this.D(h,u):N?.type===L.FileChangeType.ADDED&&this.H(h))});return $?(u.add($),!0):!1}G(h,u){let $=!1;const g=(N,v)=>{if(u.isDisposed)return;const d=this.I(N),p=this.I(v),k=$;$=d,!d&&(p||k)&&this.H(h)};this.P(`starting fs.watchFile() on ${h.path} (correlationId: ${h.correlationId})`);try{(0,E.watchFile)(h.path,{persistent:!1,interval:this.r},g)}catch(N){this.Q(`fs.watchFile() failed with error ${N} on path ${h.path} (correlationId: ${h.correlationId})`)}u.add((0,S.$Vc)(()=>{this.P(`stopping fs.watchFile() on ${h.path} (correlationId: ${h.correlationId})`);try{(0,E.unwatchFile)(h.path,g)}catch(N){this.Q(`fs.unwatchFile() failed with error ${N} on path ${h.path} (correlationId: ${h.correlationId})`)}}))}H(h){this.P(`detected ${h.path} exists again, resuming watcher (correlationId: ${h.correlationId})`);const u={resource:I.URI.file(h.path),type:L.FileChangeType.ADDED,cId:h.correlationId};this.a.fire([u]),this.J(u,h),this.C(h)}I(h){return h.ctimeMs===0&&h.ino===0}async stop(){this.j.clearAndDisposeAll(),this.m.clear()}J(h,u){if(this.R){const $=` >> normalized ${h.type===L.FileChangeType.ADDED?"[ADDED]":h.type===L.FileChangeType.DELETED?"[DELETED]":"[CHANGED]"} ${h.resource.fsPath}`;this.L($,u)}}L(h,u){this.R&&this.P(`${h}${typeof u.correlationId=="number"?` <${u.correlationId}> `:""}`)}M(h){return`${h.path} (excludes: ${h.excludes.length>0?h.excludes:"<none>"}, includes: ${h.includes&&h.includes.length>0?JSON.stringify(h.includes):"<all>"}, filter: ${(0,w.$_q)(h.filter)}, correlationId: ${typeof h.correlationId=="number"?h.correlationId:"<none>"})`}async setVerboseLogging(h){this.R=h}}t.$ir=l}),define(oe[127],ae([0,1,5,174,126,13,175,63]),function(H,t,E,S,w,O,L,I){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$pr=void 0;class m extends w.$ir{constructor(c){super(),this.O=c,this.onDidError=E.Event.None,this.watchers=new Set}async N(c){c=this.Z(c);const h=[],u=new Set(Array.from(this.watchers));for(const $ of c){const g=this.W($);g&&(0,S.$Ek)(g.request.excludes,$.excludes)&&(0,S.$Ek)(g.request.includes,$.includes)?u.delete(g):h.push($)}h.length&&this.P(`Request to start watching: ${h.map($=>this.M($)).join(",")}`),u.size&&this.P(`Request to stop watching: ${Array.from(u).map($=>this.M($.request)).join(",")}`);for(const $ of u)this.Y($);for(const $ of h)this.X($)}W(c){for(const h of this.watchers)if(typeof c.correlationId=="number"||typeof h.request.correlationId=="number"){if(h.request.correlationId===c.correlationId)return h}else if((0,I.$Eg)(h.request.path,c.path,!O.$k))return h}X(c){const h=new L.$nr(c,this.O,$=>this.a.fire($),()=>this.c.fire(c),$=>this.b.fire($),this.R),u={request:c,instance:h};this.watchers.add(u)}async stop(){await super.stop();for(const c of this.watchers)this.Y(c)}Y(c){this.P("stopping file watcher",c),this.watchers.delete(c),c.instance.dispose()}Z(c){const h=new Map;for(const u of c){const $=O.$k?u.path:u.path.toLowerCase();let g=h.get(u.correlationId);g||(g=new Map,h.set(u.correlationId,g)),g.has($)&&this.P(`ignoring a request for watching who's path is already watched: ${this.M(u)}`),g.set($,u)}return Array.from(h.values()).map(u=>Array.from(u.values())).flat()}async setVerboseLogging(c){super.setVerboseLogging(c);for(const h of this.watchers)h.instance.setVerboseLogging(c)}P(c,h){this.R&&this.b.fire({type:"trace",message:this.bb(c,h)})}Q(c){this.b.fire({type:"warn",message:this.bb(c)})}bb(c,h){return h?`[File Watcher (node.js)] ${c} (${this.M(h.request)})`:`[File Watcher (node.js)] ${c}`}}t.$pr=m}),define(oe[128],ae([0,1,52,127]),function(H,t,E,S){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$qr=void 0;class w extends E.$5q{constructor(L,I,m){super(L,I,m),this.s()}r(L){return L.add(new S.$pr(void 0))}}t.$qr=w}),define(oe[129],ae([0,1,15,59,91,52]),function(H,t,E,S,w,O){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$hr=void 0;class L extends O.$6q{constructor(m,l,c){super(m,l,c),this.s()}r(m){const l=m.add(new w.$gr(E.$1g.asFileUri("bootstrap-fork").fsPath,{serverName:"File Watcher",args:["--type=fileWatcher"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/watcherMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return m.add(l.onDidProcessExit(({code:c,signal:h})=>this.t(`terminated by itself with code ${c}, signal: ${h} (ETERM)`))),S.ProxyChannel.toService((0,S.$ni)(l.getChannel("watcher")))}}t.$hr=L}),define(oe[64],ae([0,1]),function(H,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Ei=void 0;class E{constructor(...w){this.a=new Map;for(const[O,L]of w)this.set(O,L)}set(w,O){const L=this.a.get(w);return this.a.set(w,O),L}has(w){return this.a.has(w)}get(w){return this.a.get(w)}}t.$Ei=E}),define(oe[130],ae([0,1,8,9,2,51,124,11,64,176]),function(H,t,E,S,w,O,L,I,m,l){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$vr=t.$ur=void 0;const c=!1;class h extends Error{constructor(v){super("cyclic dependency between services"),this.message=v.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${v.toString()}`}}class u{constructor(v=new m.$Ei,d=!1,p,k=c){this.i=v,this.j=d,this.k=p,this.l=k,this.f=!1,this.g=new Set,this.h=new Set,this.t=new Set,this.i.set(I.$Fi,this),this._globalGraph=k?p?._globalGraph??new L.$tr(y=>y):void 0}dispose(){if(!this.f){this.f=!0,(0,w.$Sc)(this.h),this.h.clear();for(const v of this.g)(0,w.$Rc)(v)&&v.dispose();this.g.clear()}}m(){if(this.f)throw new Error("InstantiationService has been disposed")}createChild(v,d){this.m();const p=this,k=new class extends u{dispose(){p.h.delete(k),super.dispose()}}(v,this.j,this,this.l);return this.h.add(k),d?.add(k),k}invokeFunction(v,...d){this.m();const p=g.traceInvocation(this.l,v);let k=!1;try{return v({get:e=>{if(k)throw(0,S.$$)("service accessor is only valid during the invocation of its target method");const a=this.s(e,p);if(!a)throw new Error(`[invokeFunction] unknown service '${e}'`);return a}},...d)}finally{k=!0,p.stop()}}createInstance(v,...d){this.m();let p,k;return v instanceof O.$Di?(p=g.traceCreation(this.l,v.ctor),k=this.o(v.ctor,v.staticArguments.concat(d),p)):(p=g.traceCreation(this.l,v),k=this.o(v,d,p)),p.stop(),k}o(v,d=[],p){const k=I._util.getServiceDependencies(v).sort((a,n)=>a.index-n.index),y=[];for(const a of k){const n=this.s(a.id,p);n||this.y(`[createInstance] ${v.name} depends on UNKNOWN service ${a.id}.`,!1),y.push(n)}const e=k.length>0?k[0].index:d.length;if(d.length!==e){console.trace(`[createInstance] First service dependency of ${v.name} at position ${e+1} conflicts with ${d.length} static arguments`);const a=e-d.length;a>0?d=d.concat(new Array(a)):d=d.slice(0,e)}return Reflect.construct(v,d.concat(y))}q(v,d){if(this.i.get(v)instanceof O.$Di)this.i.set(v,d);else if(this.k)this.k.q(v,d);else throw new Error("illegalState - setting UNKNOWN service instance")}r(v){const d=this.i.get(v);return!d&&this.k?this.k.r(v):d}s(v,d){this._globalGraph&&this.c&&this._globalGraph.insertEdge(this.c,String(v));const p=this.r(v);return p instanceof O.$Di?this.u(v,p,d.branch(v,!0)):(d.branch(v,!1),p)}u(v,d,p){if(this.t.has(v))throw new Error(`illegal state - RECURSIVELY instantiating service '${v}'`);this.t.add(v);try{return this.v(v,d,p)}finally{this.t.delete(v)}}v(v,d,p){const k=new L.$tr(a=>a.id.toString());let y=0;const e=[{id:v,desc:d,_trace:p}];for(;e.length;){const a=e.pop();if(k.lookupOrInsertNode(a),y++>1e3)throw new h(k);for(const n of I._util.getServiceDependencies(a.desc.ctor)){const r=this.r(n.id);if(r||this.y(`[createInstance] ${v} depends on ${n.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(a.id),String(n.id)),r instanceof O.$Di){const i={id:n.id,desc:r,_trace:a._trace.branch(n.id,!0)};k.insertEdge(a,i),e.push(i)}}}for(;;){const a=k.roots();if(a.length===0){if(!k.isEmpty())throw new h(k);break}for(const{data:n}of a){if(this.r(n.id)instanceof O.$Di){const i=this.w(n.id,n.desc.ctor,n.desc.staticArguments,n.desc.supportsDelayedInstantiation,n._trace);this.q(n.id,i)}k.removeNode(n)}}return this.r(v)}w(v,d,p=[],k,y){if(this.i.get(v)instanceof O.$Di)return this.x(v,d,p,k,y,this.g);if(this.k)return this.k.w(v,d,p,k,y);throw new Error(`illegalState - creating UNKNOWN service instance ${d.name}`)}x(v,d,p=[],k,y,e){if(k){const a=new u(void 0,this.j,this,this.l);a.c=String(v);const n=new Map,r=new E.$Zh(()=>{const i=a.o(d,p,y);for(const[s,o]of n){const f=i[s];if(typeof f=="function")for(const b of o)b.disposable=f.apply(i,b.listener)}return n.clear(),e.add(i),i});return new Proxy(Object.create(null),{get(i,s){if(!r.isInitialized&&typeof s=="string"&&(s.startsWith("onDid")||s.startsWith("onWill"))){let b=n.get(s);return b||(b=new l.$8c,n.set(s,b)),(T,D,A)=>{if(r.isInitialized)return r.value[s](T,D,A);{const z={listener:[T,D,A],disposable:void 0},J=b.push(z);return(0,w.$Vc)(()=>{J(),z.disposable?.dispose()})}}}if(s in i)return i[s];const o=r.value;let f=o[s];return typeof f!="function"||(f=f.bind(o),i[s]=f),f},set(i,s,o){return r.value[s]=o,!0},getPrototypeOf(i){return d.prototype}})}else{const a=this.o(d,p,y);return e.add(a),a}}y(v,d){if(d&&console.warn(v),this.j)throw new Error(v)}}t.$ur=u;var $;(function(N){N[N.None=0]="None",N[N.Creation=1]="Creation",N[N.Invocation=2]="Invocation",N[N.Branch=3]="Branch"})($||($={}));class g{static{this.all=new Set}static{this.c=new class extends g{constructor(){super($.None,null)}stop(){}branch(){return this}}}static traceInvocation(v,d){return v?new g($.Invocation,d.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):g.c}static traceCreation(v,d){return v?new g($.Creation,d.name):g.c}static{this.f=0}constructor(v,d){this.type=v,this.name=d,this.g=Date.now(),this.h=[]}branch(v,d){const p=new g($.Branch,v.toString());return this.h.push([v,d,p]),p}stop(){const v=Date.now()-this.g;g.f+=v;let d=!1;function p(y,e){const a=[],n=new Array(y+1).join("	");for(const[r,i,s]of e.h)if(i&&s){d=!0,a.push(`${n}CREATES -> ${r}`);const o=p(y+1,s);o&&a.push(o)}else a.push(`${n}uses -> ${r}`);return a.join(`
`)}const k=[`${this.type===$.Creation?"CREATE":"CALL"} ${this.name}`,`${p(1,this)}`,`DONE, took ${v.toFixed(2)}ms (grand total ${g.f.toFixed(2)}ms)`];(v>2||d)&&g.all.add(k.join(`
`))}}t.$vr=g}),define(oe[6],ae([0,1,110,38,5,43,2,31,13,17,3,12,125,11]),function(H,t,E,S,w,O,L,I,m,l,c,h,u,$){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$sk=t.$nk=t.$mk=t.$lk=t.$kk=t.$jk=t.$ik=t.$hk=t.$gk=t.$fk=t.$dk=t.LogLevel=t.$bk=t.$ak=void 0,t.$ck=N,t.log=d,t.$ok=f,t.$pk=b,t.$qk=R,t.$rk=T,E=be(E),t.$ak=(0,$.$Gi)("logService"),t.$bk=(0,$.$Gi)("loggerService");function g(){return new Date().toISOString()}function N(D){return(0,c.$kg)(D)}var v;(function(D){D[D.Off=0]="Off",D[D.Trace=1]="Trace",D[D.Debug=2]="Debug",D[D.Info=3]="Info",D[D.Warning=4]="Warning",D[D.Error=5]="Error"})(v||(t.LogLevel=v={})),t.$dk=v.Info;function d(D,A,z){switch(A){case v.Trace:D.trace(z);break;case v.Debug:D.debug(z);break;case v.Info:D.info(z);break;case v.Warning:D.warn(z);break;case v.Error:D.error(z);break;case v.Off:break;default:throw new Error(`Invalid log level ${A}`)}}function p(D,A=!1){let z="";for(let J=0;J<D.length;J++){let Q=D[J];if(Q instanceof Error&&(Q=(0,S.$rj)(Q,A)),typeof Q=="object")try{Q=JSON.stringify(Q)}catch{}z+=(J>0?" ":"")+Q}return z}class k extends L.$Xc{constructor(){super(...arguments),this.b=t.$dk,this.c=this.B(new w.$ne),this.onDidChangeLogLevel=this.c.event}setLevel(A){this.b!==A&&(this.b=A,this.c.fire(this.b))}getLevel(){return this.b}f(A){return this.b!==v.Off&&this.b<=A}}t.$fk=k;class y extends k{constructor(A){super(),this.h=A}f(A){return this.h||super.f(A)}trace(A,...z){this.f(v.Trace)&&this.g(v.Trace,p([A,...z],!0))}debug(A,...z){this.f(v.Debug)&&this.g(v.Debug,p([A,...z]))}info(A,...z){this.f(v.Info)&&this.g(v.Info,p([A,...z]))}warn(A,...z){this.f(v.Warning)&&this.g(v.Warning,p([A,...z]))}error(A,...z){if(this.f(v.Error))if(A instanceof Error){const J=Array.prototype.slice.call(arguments);J[0]=A.stack,this.g(v.Error,p(J))}else this.g(v.Error,p([A,...z]))}flush(){}}t.$gk=y;class e extends k{constructor(A=t.$dk){super(),this.setLevel(A),this.g=!m.$i}trace(A,...z){this.f(v.Trace)&&(this.g?console.log(`\x1B[90m[main ${g()}]\x1B[0m`,A,...z):console.log(`[main ${g()}]`,A,...z))}debug(A,...z){this.f(v.Debug)&&(this.g?console.log(`\x1B[90m[main ${g()}]\x1B[0m`,A,...z):console.log(`[main ${g()}]`,A,...z))}info(A,...z){this.f(v.Info)&&(this.g?console.log(`\x1B[90m[main ${g()}]\x1B[0m`,A,...z):console.log(`[main ${g()}]`,A,...z))}warn(A,...z){this.f(v.Warning)&&(this.g?console.warn(`\x1B[93m[main ${g()}]\x1B[0m`,A,...z):console.warn(`[main ${g()}]`,A,...z))}error(A,...z){this.f(v.Error)&&(this.g?console.error(`\x1B[91m[main ${g()}]\x1B[0m`,A,...z):console.error(`[main ${g()}]`,A,...z))}flush(){}}t.$hk=e;class a extends k{constructor(A=t.$dk,z=!0){super(),this.g=z,this.setLevel(A)}trace(A,...z){this.f(v.Trace)&&(this.g?console.log("%cTRACE","color: #888",A,...z):console.log(A,...z))}debug(A,...z){this.f(v.Debug)&&(this.g?console.log("%cDEBUG","background: #eee; color: #888",A,...z):console.log(A,...z))}info(A,...z){this.f(v.Info)&&(this.g?console.log("%c INFO","color: #33f",A,...z):console.log(A,...z))}warn(A,...z){this.f(v.Warning)&&(this.g?console.log("%c WARN","color: #993",A,...z):console.log(A,...z))}error(A,...z){this.f(v.Error)&&(this.g?console.log("%c  ERR","color: #f33",A,...z):console.error(A,...z))}flush(){}}t.$ik=a;class n extends k{constructor(A,z=t.$dk){super(),this.g=A,this.setLevel(z)}trace(A,...z){this.f(v.Trace)&&this.g.log(v.Trace,[this.h(A),...z])}debug(A,...z){this.f(v.Debug)&&this.g.log(v.Debug,[this.h(A),...z])}info(A,...z){this.f(v.Info)&&this.g.log(v.Info,[this.h(A),...z])}warn(A,...z){this.f(v.Warning)&&this.g.log(v.Warning,[this.h(A),...z])}error(A,...z){this.f(v.Error)&&this.g.log(v.Error,[this.h(A),...z])}h(A){return typeof A=="string"?A:(0,S.$rj)(A,this.f(v.Trace))}flush(){}}t.$jk=n;class r extends k{constructor(A){super(),this.g=A,A.length&&this.setLevel(A[0].getLevel())}setLevel(A){for(const z of this.g)z.setLevel(A);super.setLevel(A)}trace(A,...z){for(const J of this.g)J.trace(A,...z)}debug(A,...z){for(const J of this.g)J.debug(A,...z)}info(A,...z){for(const J of this.g)J.info(A,...z)}warn(A,...z){for(const J of this.g)J.warn(A,...z)}error(A,...z){for(const J of this.g)J.error(A,...z)}flush(){for(const A of this.g)A.flush()}dispose(){for(const A of this.g)A.dispose();super.dispose()}}t.$kk=r;class i extends L.$Xc{constructor(A,z,J){if(super(),this.h=A,this.j=z,this.b=new I.$Dc,this.c=this.B(new w.$ne),this.onDidChangeLoggers=this.c.event,this.f=this.B(new w.$ne),this.onDidChangeLogLevel=this.f.event,this.g=this.B(new w.$ne),this.onDidChangeVisibility=this.g.event,J)for(const Q of J)this.b.set(Q.resource,{logger:void 0,info:Q})}m(A){return(0,c.$gg)(A)?[...this.b.values()].find(z=>z.info.id===A):this.b.get(A)}getLogger(A){return this.m(A)?.logger}createLogger(A,z){const J=this.n(A),Q=(0,c.$gg)(A)?A:z?.id??(0,O.$uj)(J.toString()).toString(16);let se=this.b.get(J)?.logger;const le=z?.logLevel==="always"?v.Trace:z?.logLevel;se||(se=this.s(J,le??this.getLogLevel(J)??this.h,{...z,id:Q}));const ue={logger:se,info:{resource:J,id:Q,logLevel:le,name:z?.name,hidden:z?.hidden,extensionId:z?.extensionId,when:z?.when}};return this.registerLogger(ue.info),this.b.set(J,ue),se}n(A){return(0,c.$gg)(A)?(0,l.$hh)(this.j,`${A}.log`):A}setLogLevel(A,z){if(h.URI.isUri(A)){const J=A,Q=z,se=this.b.get(J);se&&Q!==se.info.logLevel&&(se.info.logLevel=Q===this.h?void 0:Q,se.logger?.setLevel(Q),this.b.set(se.info.resource,se),this.f.fire([J,Q]))}else{this.h=A;for(const[J,Q]of this.b.entries())this.b.get(J)?.info.logLevel===void 0&&Q.logger?.setLevel(this.h);this.f.fire(this.h)}}setVisibility(A,z){const J=this.m(A);J&&z!==!J.info.hidden&&(J.info.hidden=!z,this.b.set(J.info.resource,J),this.g.fire([J.info.resource,z]))}getLogLevel(A){let z;return A&&(z=this.b.get(A)?.info.logLevel),z??this.h}registerLogger(A){const z=this.b.get(A.resource);z?z.info.hidden!==A.hidden&&this.setVisibility(A.resource,!A.hidden):(this.b.set(A.resource,{info:A,logger:void 0}),this.c.fire({added:[A],removed:[]}))}deregisterLogger(A){const z=this.b.get(A);z&&(z.logger&&z.logger.dispose(),this.b.delete(A),this.c.fire({added:[],removed:[z.info]}))}*getRegisteredLoggers(){for(const A of this.b.values())yield A.info}getRegisteredLogger(A){return this.b.get(A)?.info}dispose(){this.b.forEach(A=>A.logger?.dispose()),this.b.clear(),super.dispose()}}t.$lk=i;class s{constructor(){this.onDidChangeLogLevel=new w.$ne().event}setLevel(A){}getLevel(){return v.Info}trace(A,...z){}debug(A,...z){}info(A,...z){}warn(A,...z){}error(A,...z){}critical(A,...z){}dispose(){}flush(){}}t.$mk=s;class o extends s{}t.$nk=o;function f(D){if(D.verbose)return v.Trace;if(typeof D.logLevel=="string"){const A=T(D.logLevel.toLowerCase());if(A!==void 0)return A}return t.$dk}function b(D){switch(D){case v.Trace:return"trace";case v.Debug:return"debug";case v.Info:return"info";case v.Warning:return"warn";case v.Error:return"error";case v.Off:return"off"}}function R(D){switch(D){case v.Trace:return{original:"Trace",value:E.localize(0,null)};case v.Debug:return{original:"Debug",value:E.localize(1,null)};case v.Info:return{original:"Info",value:E.localize(2,null)};case v.Warning:return{original:"Warning",value:E.localize(3,null)};case v.Error:return{original:"Error",value:E.localize(4,null)};case v.Off:return{original:"Off",value:E.localize(5,null)}}}function T(D){switch(D){case"trace":return v.Trace;case"debug":return v.Debug;case"info":return v.Info;case"warn":return v.Warning;case"error":return v.Error;case"critical":return v.Error;case"off":return v.Off}}t.$sk=new u.$Xj("logLevel",b(v.Info))}),define(oe[131],ae([0,1,20,8,9,5,63,2,16,52,6]),function(H,t,E,S,w,O,L,I,m,l,c){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$ar=void 0;class h extends I.$Xc{constructor($,g){super(),this.a=$,this.b=g,this.c=this.B(new O.$ne),this.onDidChangeFile=this.c.event,this.g=this.B(new O.$ne),this.onDidWatchError=this.g.event,this.j=[],this.m=this.B(new S.$Eh(0)),this.w=[],this.y=this.B(new S.$Eh(0))}watch($,g){return g.recursive||this.b?.watcher?.forceUniversal?this.n($,g):this.z($,g)}n($,g){const N={path:this.J($),excludes:g.excludes,includes:g.includes,recursive:g.recursive,filter:g.filter,correlationId:g.correlationId},v=(0,E.$Wb)(this.j,N);return this.r(),(0,I.$Vc)(()=>{v(),this.r()})}r(){this.m.trigger(()=>this.s()).catch($=>(0,w.$3)($))}s(){this.h||(this.h=this.B(this.t(g=>this.c.fire((0,l.$7q)(g)),g=>this.G(g),this.a.getLevel()===c.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.h?.setVerboseLogging(this.a.getLevel()===c.LogLevel.Trace)})));const $=this.b?.watcher?.recursive?.usePolling;if($===!0)for(const g of this.j)(0,l.$3q)(g)&&(g.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);else if(Array.isArray($))for(const g of this.j)(0,l.$3q)(g)&&$.includes(g.path)&&(g.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);return this.h.watch(this.j)}z($,g){const N={path:this.J($),excludes:g.excludes,includes:g.includes,recursive:!1,filter:g.filter,correlationId:g.correlationId},v=(0,E.$Wb)(this.w,N);return this.C(),(0,I.$Vc)(()=>{v(),this.C()})}C(){this.y.trigger(()=>this.D()).catch($=>(0,w.$3)($))}D(){return this.u||(this.u=this.B(this.F($=>this.c.fire((0,l.$7q)($)),$=>this.G($),this.a.getLevel()===c.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.u?.setVerboseLogging(this.a.getLevel()===c.LogLevel.Trace)}))),this.u.watch(this.w)}G($){$.type==="error"&&this.g.fire($.message),this.H($)}H($){this.a[$.type]($.message)}I($){return(0,m.$kc)($.fsPath)}J($){const g=this.I($);return(0,L.$Ig)(g)}}t.$ar=h});var re=this&&this.__param||function(H,t){return function(E,S){t(E,S,H)}};define(oe[132],ae([0,1,20,8,14,22,5,43,65,2,49,15,133,17,47,106,10,62,6,9]),function(H,t,E,S,w,O,L,I,m,l,c,h,u,$,g,N,v,d,p,k){"use strict";var y;Object.defineProperty(t,"__esModule",{value:!0}),t.$1q=void 0;let e=class extends l.$Xc{static{y=this}constructor(n){super(),this.b=n,this.a=256*1024,this.c=this.B(new L.$ne),this.onDidChangeFileSystemProviderRegistrations=this.c.event,this.f=this.B(new L.$ne),this.onWillActivateFileSystemProvider=this.f.event,this.g=this.B(new L.$ne),this.onDidChangeFileSystemProviderCapabilities=this.g.event,this.h=new Map,this.r=this.B(new L.$ne),this.onDidRunOperation=this.r.event,this.X=this.B(new L.$ne),this.Y=this.B(new L.$ne),this.onDidFilesChange=this.Y.event,this.Z=this.B(new L.$ne),this.onDidWatchError=this.Z.event,this.$=new Map,this.cb=this.B(new S.$Ph)}registerProvider(n,r){if(this.h.has(n))throw new Error(`A filesystem provider for the scheme '${n}' is already registered.`);(0,u.mark)(`code/registerFilesystem/${n}`);const i=new l.$Wc;return this.h.set(n,r),this.c.fire({added:!0,scheme:n,provider:r}),i.add(r.onDidChangeFile(s=>{const o=new v.$tl(s,!this.S(r));this.X.fire(o),o.hasCorrelation()||this.Y.fire(o)})),typeof r.onDidWatchError=="function"&&i.add(r.onDidWatchError(s=>this.Z.fire(new Error(s)))),i.add(r.onDidChangeCapabilities(()=>this.g.fire({provider:r,scheme:n}))),(0,l.$Vc)(()=>{this.c.fire({added:!1,scheme:n,provider:r}),this.h.delete(n),(0,l.$Sc)(i)})}getProvider(n){return this.h.get(n)}async activateProvider(n){const r=[];this.f.fire({scheme:n,join(i){r.push(i)}}),!this.h.has(n)&&await S.Promises.settled(r)}async canHandleResource(n){return await this.activateProvider(n.scheme),this.hasProvider(n)}hasProvider(n){return this.h.has(n.scheme)}hasCapability(n,r){const i=this.h.get(n.scheme);return!!(i&&i.capabilities&r)}listCapabilities(){return m.Iterable.map(this.h,([n,r])=>({scheme:n,capabilities:r.capabilities}))}async j(n){if(!(0,$.$lh)(n))throw new v.$vl((0,N.localize)(0,null,this.sb(n)),v.FileOperationResult.FILE_INVALID_PATH);await this.activateProvider(n.scheme);const r=this.h.get(n.scheme);if(!r){const i=new k.$eb;throw i.message=(0,N.localize)(1,null,n.toString()),i}return r}async m(n){const r=await this.j(n);if((0,v.$gl)(r)||(0,v.$dl)(r)||(0,v.$hl)(r))return r;throw new Error(`Filesystem provider for scheme '${n.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async n(n){const r=await this.j(n);if((0,v.$gl)(r)||(0,v.$dl)(r))return r;throw new Error(`Filesystem provider for scheme '${n.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(n,r){try{return await this.s(n,r)}catch(i){throw(0,v.$ql)(i)===v.FileSystemProviderErrorCode.FileNotFound?new v.$vl((0,N.localize)(2,null,this.sb(n)),v.FileOperationResult.FILE_NOT_FOUND):(0,v.$ol)(i)}}async s(n,r){const i=await this.j(n),s=this.S(i),o=r?.resolveTo,f=r?.resolveSingleChildDescendants,b=r?.resolveMetadata,R=await i.stat(n);let T;return this.t(i,n,R,void 0,!!b,(D,A)=>(T||(T=c.$Mi.forUris(()=>!s),T.set(n,!0),o&&T.fill(!0,o)),T.get(D.resource)||T.findSuperstr(D.resource.with({query:null,fragment:null}))?!0:D.isDirectory&&f?A===1:!1))}async t(n,r,i,s,o,f){const{providerExtUri:b}=this.R(n),R={resource:r,name:b.basename(r),isFile:(i.type&v.FileType.File)!==0,isDirectory:(i.type&v.FileType.Directory)!==0,isSymbolicLink:(i.type&v.FileType.SymbolicLink)!==0,mtime:i.mtime,ctime:i.ctime,size:i.size,readonly:!!((i.permissions??0)&v.FilePermission.Readonly)||!!(n.capabilities&v.FileSystemProviderCapabilities.Readonly),locked:!!((i.permissions??0)&v.FilePermission.Locked),etag:(0,v.$Gl)({mtime:i.mtime,size:i.size}),children:void 0};if(R.isDirectory&&f(R,s)){try{const T=await n.readdir(r),D=await S.Promises.settled(T.map(async([A,z])=>{try{const J=b.joinPath(r,A),Q=o?await n.stat(J):{type:z};return await this.t(n,J,Q,T.length,o,f)}catch(J){return this.b.trace(J),null}}));R.children=(0,E.$Kb)(D)}catch(T){this.b.trace(T),R.children=[]}return R}return R}async resolveAll(n){return S.Promises.settled(n.map(async r=>{try{return{stat:await this.s(r.resource,r.options),success:!0}}catch(i){return this.b.trace(i),{stat:void 0,success:!1}}}))}async stat(n){const r=await this.j(n),i=await r.stat(n);return this.t(r,n,i,void 0,!0,()=>!1)}async exists(n){const r=await this.j(n);try{return!!await r.stat(n)}catch{return!1}}async canCreateFile(n,r){try{await this.u(n,r)}catch(i){return i}return!0}async u(n,r){if(!r?.overwrite&&await this.exists(n))throw new v.$vl((0,N.localize)(3,null,this.sb(n)),v.FileOperationResult.FILE_MODIFIED_SINCE,r)}async createFile(n,r=w.$Pe.fromString(""),i){await this.u(n,i);const s=await this.writeFile(n,r);return this.r.fire(new v.$sl(n,v.FileOperation.CREATE,s)),s}async writeFile(n,r,i){const s=this.qb(await this.n(n),n),{providerExtUri:o}=this.R(s);let f=i;if((0,v.$jl)(s)&&!f?.atomic){const b=s.enforceAtomicWriteFile?.(n);b&&(f={...i,atomic:b})}try{await this.w(s,n,f)||await this.U(s,o.dirname(n));let R;if((0,v.$dl)(s)&&!(r instanceof w.$Pe))if((0,g.$Be)(r)){const T=await(0,g.$Ie)(r,3);T.ended?R=w.$Pe.concat(T.buffer):R=T}else R=(0,g.$Fe)(r,T=>w.$Pe.concat(T),3);else R=r;!(0,v.$gl)(s)||(0,v.$dl)(s)&&R instanceof w.$Pe||(0,v.$dl)(s)&&(0,v.$jl)(s)&&f?.atomic?await this.hb(s,n,f,R):await this.db(s,n,f,R instanceof w.$Pe?(0,w.$1e)(R):R),this.r.fire(new v.$sl(n,v.FileOperation.WRITE))}catch(b){throw new v.$vl((0,N.localize)(4,null,this.sb(n),(0,v.$ol)(b).toString()),(0,v.$rl)(b),f)}return this.resolve(n,{resolveMetadata:!0})}async w(n,r,i){const s=!!i?.unlock;if(s&&!(n.capabilities&v.FileSystemProviderCapabilities.FileWriteUnlock))throw new Error((0,N.localize)(5,null,this.sb(r)));if(!!i?.atomic){if(!(n.capabilities&v.FileSystemProviderCapabilities.FileAtomicWrite))throw new Error((0,N.localize)(6,null,this.sb(r)));if(!(n.capabilities&v.FileSystemProviderCapabilities.FileReadWrite))throw new Error((0,N.localize)(7,null,this.sb(r)));if(s)throw new Error((0,N.localize)(8,null,this.sb(r)))}let f;try{f=await n.stat(r)}catch{return}if(f.type&v.FileType.Directory)throw new v.$vl((0,N.localize)(9,null,this.sb(r)),v.FileOperationResult.FILE_IS_DIRECTORY,i);if(this.rb(r,f),typeof i?.mtime=="number"&&typeof i.etag=="string"&&i.etag!==v.$Fl&&typeof f.mtime=="number"&&typeof f.size=="number"&&i.mtime<f.mtime&&i.etag!==(0,v.$Gl)({mtime:i.mtime,size:f.size}))throw new v.$vl((0,N.localize)(10,null),v.FileOperationResult.FILE_MODIFIED_SINCE,i);return f}async readFile(n,r,i){const s=await this.m(n);return r?.atomic?this.z(s,n,r,i):this.C(s,n,r,i)}async z(n,r,i,s){return new Promise((o,f)=>{this.cb.queueFor(r,async()=>{try{const b=await this.C(n,r,i,s);o(b)}catch(b){f(b)}},this.R(n).providerExtUri)})}async C(n,r,i,s){const o=await this.D(n,r,{...i,preferUnbuffered:!0},s);return{...o,value:await(0,w.$2e)(o.value)}}async readFileStream(n,r,i){const s=await this.m(n);return this.D(s,n,r,i)}async D(n,r,i,s){const o=new O.$ye(s);let f=i;(0,v.$il)(n)&&n.enforceAtomicReadFile?.(r)&&(f={...i,atomic:!0});const b=this.J(r,f).then(T=>T,T=>{throw o.dispose(!0),T});let R;try{return typeof f?.etag=="string"&&f.etag!==v.$Fl&&await b,f?.atomic&&(0,v.$il)(n)||!((0,v.$gl)(n)||(0,v.$hl)(n))||(0,v.$dl)(n)&&f?.preferUnbuffered?R=this.I(n,r,f):(0,v.$hl)(n)?R=this.G(n,r,o.token,f):R=this.H(n,r,o.token,f),R.on("end",()=>o.dispose()),R.on("error",()=>o.dispose()),{...await b,value:R}}catch(T){throw R&&await(0,g.$Ge)(R),this.F(T,r,f)}}F(n,r,i){const s=(0,N.localize)(11,null,this.sb(r),(0,v.$ol)(n).toString());return n instanceof v.$xl?new v.$xl(s,n.stat,i):n instanceof v.$wl?new v.$wl(s,n.fileOperationResult,n.size,n.options):new v.$vl(s,(0,v.$rl)(n),i)}G(n,r,i,s=Object.create(null)){const o=n.readFileStream(r,s,i);return(0,g.$Me)(o,{data:f=>f instanceof w.$Pe?f:w.$Pe.wrap(f),error:f=>this.F(f,r,s)},f=>w.$Pe.concat(f))}H(n,r,i,s=Object.create(null)){const o=(0,w.$6e)();return(0,d.$Zq)(n,r,o,f=>f,{...s,bufferSize:this.a,errorTransformer:f=>this.F(f,r,s)},i),o}I(n,r,i){const s=(0,g.$De)(o=>w.$Pe.concat(o));return(async()=>{try{let o;i?.atomic&&(0,v.$il)(n)?o=await n.readFile(r,{atomic:!0}):o=await n.readFile(r),typeof i?.position=="number"&&(o=o.slice(i.position)),typeof i?.length=="number"&&(o=o.slice(0,i.length)),this.L(r,o.byteLength,i),s.end(w.$Pe.wrap(o))}catch(o){s.error(o),s.end()}})(),s}async J(n,r){const i=await this.resolve(n,{resolveMetadata:!0});if(i.isDirectory)throw new v.$vl((0,N.localize)(12,null,this.sb(n)),v.FileOperationResult.FILE_IS_DIRECTORY,r);if(typeof r?.etag=="string"&&r.etag!==v.$Fl&&r.etag===i.etag)throw new v.$xl((0,N.localize)(13,null),i,r);return this.L(n,i.size,r),i}L(n,r,i){if(typeof i?.limits?.size=="number"&&r>i.limits.size)throw new v.$wl((0,N.localize)(14,null,this.sb(n)),v.FileOperationResult.FILE_TOO_LARGE,r,i)}async canMove(n,r,i){return this.M(n,r,"move",i)}async canCopy(n,r,i){return this.M(n,r,"copy",i)}async M(n,r,i,s){if(n.toString()!==r.toString())try{const o=i==="move"?this.qb(await this.n(n),n):await this.m(n),f=this.qb(await this.n(r),r);await this.Q(o,n,f,r,i,s)}catch(o){return o}return!0}async move(n,r,i){const s=this.qb(await this.n(n),n),o=this.qb(await this.n(r),r),f=await this.N(s,n,o,r,"move",!!i),b=await this.resolve(r,{resolveMetadata:!0});return this.r.fire(new v.$sl(n,f==="move"?v.FileOperation.MOVE:v.FileOperation.COPY,b)),b}async copy(n,r,i){const s=await this.m(n),o=this.qb(await this.n(r),r),f=await this.N(s,n,o,r,"copy",!!i),b=await this.resolve(r,{resolveMetadata:!0});return this.r.fire(new v.$sl(n,f==="copy"?v.FileOperation.COPY:v.FileOperation.MOVE,b)),b}async N(n,r,i,s,o,f){if(r.toString()===s.toString())return o;const{exists:b,isSameResourceWithDifferentPathCase:R}=await this.Q(n,r,i,s,o,f);if(b&&!R&&f&&await this.del(s,{recursive:!0}),await this.U(i,this.R(i).providerExtUri.dirname(s)),o==="copy"){if(n===i&&(0,v.$el)(n))await n.copy(r,s,{overwrite:f});else{const T=await this.resolve(r);T.isDirectory?await this.P(n,T,i,s):await this.O(n,r,i,s)}return o}else return n===i?(await n.rename(r,s,{overwrite:f}),o):(await this.N(n,r,i,s,"copy",f),await this.del(r,{recursive:!0}),"copy")}async O(n,r,i,s){if((0,v.$gl)(n)&&(0,v.$gl)(i))return this.jb(n,r,i,s);if((0,v.$gl)(n)&&(0,v.$dl)(i))return this.pb(n,r,i,s);if((0,v.$dl)(n)&&(0,v.$gl)(i))return this.nb(n,r,i,s);if((0,v.$dl)(n)&&(0,v.$dl)(i))return this.lb(n,r,i,s)}async P(n,r,i,s){await i.mkdir(s),Array.isArray(r.children)&&await S.Promises.settled(r.children.map(async o=>{const f=this.R(i).providerExtUri.joinPath(s,o.name);return o.isDirectory?this.P(n,await this.resolve(o.resource),i,f):this.O(n,o.resource,i,f)}))}async Q(n,r,i,s,o,f){let b=!1;if(n===i){const{providerExtUri:T,isPathCaseSensitive:D}=this.R(n);if(D||(b=T.isEqual(r,s)),b&&o==="copy")throw new Error((0,N.localize)(15,null,this.sb(r),this.sb(s)));if(!b&&T.isEqualOrParent(s,r))throw new Error((0,N.localize)(16,null,this.sb(r),this.sb(s)))}const R=await this.exists(s);if(R&&!b){if(!f)throw new v.$vl((0,N.localize)(17,null,this.sb(r),this.sb(s)),v.FileOperationResult.FILE_MOVE_CONFLICT);if(n===i){const{providerExtUri:T}=this.R(n);if(T.isEqualOrParent(r,s))throw new Error((0,N.localize)(18,null,this.sb(r),this.sb(s)))}}return{exists:R,isSameResourceWithDifferentPathCase:b}}R(n){const r=this.S(n);return{providerExtUri:r?$.$0g:$.$_g,isPathCaseSensitive:r}}S(n){return!!(n.capabilities&v.FileSystemProviderCapabilities.PathCaseSensitive)}async createFolder(n){const r=this.qb(await this.j(n),n);await this.U(r,n);const i=await this.resolve(n,{resolveMetadata:!0});return this.r.fire(new v.$sl(n,v.FileOperation.CREATE,i)),i}async U(n,r){const i=[],{providerExtUri:s}=this.R(n);for(;!s.isEqual(r,s.dirname(r));)try{if(!((await n.stat(r)).type&v.FileType.Directory))throw new Error((0,N.localize)(19,null,this.sb(r)));break}catch(o){if((0,v.$ql)(o)!==v.FileSystemProviderErrorCode.FileNotFound)throw o;i.push(s.basename(r)),r=s.dirname(r)}for(let o=i.length-1;o>=0;o--){r=s.joinPath(r,i[o]);try{await n.mkdir(r)}catch(f){if((0,v.$ql)(f)!==v.FileSystemProviderErrorCode.FileExists)throw f}}}async canDelete(n,r){try{await this.W(n,r)}catch(i){return i}return!0}async W(n,r){const i=this.qb(await this.j(n),n),s=!!r?.useTrash;if(s&&!(i.capabilities&v.FileSystemProviderCapabilities.Trash))throw new Error((0,N.localize)(20,null,this.sb(n)));const o=r?.atomic;if(o&&!(i.capabilities&v.FileSystemProviderCapabilities.FileAtomicDelete))throw new Error((0,N.localize)(21,null,this.sb(n)));if(s&&o)throw new Error((0,N.localize)(22,null,this.sb(n)));let f;try{f=await i.stat(n)}catch{}if(f)this.rb(n,f);else throw new v.$vl((0,N.localize)(23,null,this.sb(n)),v.FileOperationResult.FILE_NOT_FOUND);if(!!!r?.recursive){const R=await this.resolve(n);if(R.isDirectory&&Array.isArray(R.children)&&R.children.length>0)throw new Error((0,N.localize)(24,null,this.sb(n)))}return i}async del(n,r){const i=await this.W(n,r);let s=r;if((0,v.$kl)(i)&&!s?.atomic){const R=i.enforceAtomicDelete?.(n);R&&(s={...r,atomic:R})}const o=!!s?.useTrash,f=!!s?.recursive,b=s?.atomic??!1;await i.delete(n,{recursive:f,useTrash:o,atomic:b}),this.r.fire(new v.$sl(n,v.FileOperation.DELETE))}async cloneFile(n,r){const i=await this.j(n),s=this.qb(await this.n(r),r);if(!(i===s&&this.R(i).providerExtUri.isEqual(n,r)))return i===s&&(0,v.$fl)(i)?i.cloneFile(n,r):(await this.U(s,this.R(s).providerExtUri.dirname(r)),i===s&&(0,v.$el)(i)?this.cb.queueFor(n,()=>i.copy(n,r,{overwrite:!0}),this.R(i).providerExtUri):this.cb.queueFor(n,()=>this.O(i,n,s,r),this.R(i).providerExtUri))}static{this.ab=0}createWatcher(n,r){return this.watch(n,{...r,correlationId:y.ab++})}watch(n,r={recursive:!1,excludes:[]}){const i=new l.$Wc;let s=!1,o=()=>{s=!0};i.add((0,l.$Vc)(()=>o())),(async()=>{try{const b=await this.bb(n,r);s?(0,l.$Sc)(b):o=()=>(0,l.$Sc)(b)}catch(b){this.b.error(b)}})();const f=r.correlationId;if(typeof f=="number"){const b=i.add(new L.$ne);return i.add(this.X.event(T=>{T.correlates(f)&&b.fire(T)})),{onDidChange:b.event,dispose:()=>i.dispose()}}return i}async bb(n,r){const i=await this.j(n),s=(0,I.$uj)([this.R(i).providerExtUri.getComparisonKey(n),r]);let o=this.$.get(s);return o||(o={count:0,disposable:i.watch(n,r)},this.$.set(s,o)),o.count+=1,(0,l.$Vc)(()=>{o&&(o.count--,o.count===0&&((0,l.$Sc)(o.disposable),this.$.delete(s)))})}dispose(){super.dispose();for(const[,n]of this.$)(0,l.$Sc)(n.disposable);this.$.clear()}async db(n,r,i,s){return this.cb.queueFor(r,async()=>{const o=await n.open(r,{create:!0,unlock:i?.unlock??!1});try{(0,g.$Be)(s)||(0,g.$Ce)(s)?await this.eb(n,o,s):await this.fb(n,o,s)}catch(f){throw(0,v.$ol)(f)}finally{await n.close(o)}},this.R(n).providerExtUri)}async eb(n,r,i){let s=0,o;if((0,g.$Ce)(i)){if(i.buffer.length>0){const f=w.$Pe.concat(i.buffer);await this.gb(n,r,f,f.byteLength,s,0),s+=f.byteLength}if(i.ended)return;o=i.stream}else o=i;return new Promise((f,b)=>{(0,g.$He)(o,{onData:async R=>{o.pause();try{await this.gb(n,r,R,R.byteLength,s,0)}catch(T){return b(T)}s+=R.byteLength,setTimeout(()=>o.resume())},onError:R=>b(R),onEnd:()=>f()})})}async fb(n,r,i){let s=0,o;for(;(o=i.read())!==null;)await this.gb(n,r,o,o.byteLength,s,0),s+=o.byteLength}async gb(n,r,i,s,o,f){let b=0;for(;b<s;){const R=await n.write(r,o+b,i.buffer,f+b,s-b);b+=R}}async hb(n,r,i,s){return this.cb.queueFor(r,()=>this.ib(n,r,i,s),this.R(n).providerExtUri)}async ib(n,r,i,s){let o;s instanceof w.$Pe?o=s:(0,g.$Be)(s)?o=await(0,w.$2e)(s):(0,g.$Ce)(s)?o=await(0,w.$3e)(s):o=(0,w.$Ze)(s),await n.writeFile(r,o.buffer,{create:!0,overwrite:!0,unlock:i?.unlock??!1,atomic:i?.atomic??!1})}async jb(n,r,i,s){return this.cb.queueFor(s,()=>this.kb(n,r,i,s),this.R(i).providerExtUri)}async kb(n,r,i,s){let o,f;try{o=await n.open(r,{create:!1}),f=await i.open(s,{create:!0,unlock:!1});const b=w.$Pe.alloc(this.a);let R=0,T=0,D=0;do D=await n.read(o,R,b.buffer,T,b.byteLength-T),await this.gb(i,f,b,D,R,T),R+=D,T+=D,T===b.byteLength&&(T=0);while(D>0)}catch(b){throw(0,v.$ol)(b)}finally{await S.Promises.settled([typeof o=="number"?n.close(o):Promise.resolve(),typeof f=="number"?i.close(f):Promise.resolve()])}}async lb(n,r,i,s){return this.cb.queueFor(s,()=>this.mb(n,r,i,s),this.R(i).providerExtUri)}async mb(n,r,i,s){return i.writeFile(s,await n.readFile(r),{create:!0,overwrite:!0,unlock:!1,atomic:!1})}async nb(n,r,i,s){return this.cb.queueFor(s,()=>this.ob(n,r,i,s),this.R(i).providerExtUri)}async ob(n,r,i,s){const o=await i.open(s,{create:!0,unlock:!1});try{const f=await n.readFile(r);await this.gb(i,o,w.$Pe.wrap(f),f.byteLength,0,0)}catch(f){throw(0,v.$ol)(f)}finally{await i.close(o)}}async pb(n,r,i,s){const o=await(0,w.$2e)(this.H(n,r,O.CancellationToken.None));await this.hb(i,s,void 0,o)}qb(n,r){if(n.capabilities&v.FileSystemProviderCapabilities.Readonly)throw new v.$vl((0,N.localize)(25,null,this.sb(r)),v.FileOperationResult.FILE_PERMISSION_DENIED);return n}rb(n,r){if((r.permissions??0)&v.FilePermission.Readonly)throw new v.$vl((0,N.localize)(26,null,this.sb(n)),v.FileOperationResult.FILE_PERMISSION_DENIED)}sb(n){return n.scheme===h.Schemas.file?n.fsPath:n.toString(!0)}};t.$1q=e,t.$1q=e=y=ye([re(0,p.$ak)],e)}),define(oe[134],ae([0,1,8,31,14,5,63,2,16,13,17,47,26,108,10,62,131,129,128]),function(H,t,E,S,w,O,L,I,m,l,c,h,u,$,g,N,v,d,p){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$rr=void 0;class k extends v.$ar{static{this.L=!1}constructor(e,a){super(e,a),this.onDidChangeCapabilities=O.Event.None,this.P=new S.$Dc(n=>c.$$g.getComparisonKey(n)),this.X=new Map,this.Y=new Map,this.Z=new Map}get capabilities(){return this.M||(this.M=g.FileSystemProviderCapabilities.FileReadWrite|g.FileSystemProviderCapabilities.FileOpenReadWriteClose|g.FileSystemProviderCapabilities.FileReadStream|g.FileSystemProviderCapabilities.FileFolderCopy|g.FileSystemProviderCapabilities.FileWriteUnlock|g.FileSystemProviderCapabilities.FileAtomicRead|g.FileSystemProviderCapabilities.FileAtomicWrite|g.FileSystemProviderCapabilities.FileAtomicDelete|g.FileSystemProviderCapabilities.FileClone,l.$k&&(this.M|=g.FileSystemProviderCapabilities.PathCaseSensitive)),this.M}async stat(e){try{const{stat:a,symbolicLink:n}=await u.SymlinkSupport.stat(this.I(e));return{type:this.O(a,n),ctime:a.birthtime.getTime(),mtime:a.mtime.getTime(),size:a.size,permissions:a.mode&128?void 0:g.FilePermission.Locked}}catch(a){throw this.hb(a)}}async N(e){try{return await this.stat(e)}catch{return}}async readdir(e){try{const a=await u.Promises.readdir(this.I(e),{withFileTypes:!0}),n=[];return await Promise.all(a.map(async r=>{try{let i;r.isSymbolicLink()?i=(await this.stat((0,c.$hh)(e,r.name))).type:i=this.O(r),n.push([r.name,i])}catch(i){this.a.trace(i)}})),n}catch(a){throw this.hb(a)}}O(e,a){let n;return a?.dangling?n=g.FileType.Unknown:e.isFile()?n=g.FileType.File:e.isDirectory()?n=g.FileType.Directory:n=g.FileType.Unknown,a&&(n|=g.FileType.SymbolicLink),n}async Q(e){const a=this.I(e);this.R(`[Disk FileSystemProvider]: createResourceLock() - request to acquire resource lock (${a})`);let n;for(;n=this.P.get(e);)this.R(`[Disk FileSystemProvider]: createResourceLock() - waiting for resource lock to be released (${a})`),await n.wait();const r=new E.$Fh;return this.P.set(e,r),this.R(`[Disk FileSystemProvider]: createResourceLock() - new resource lock created (${a})`),(0,I.$Vc)(()=>{this.R(`[Disk FileSystemProvider]: createResourceLock() - resource lock dispose() (${a})`),this.P.get(e)===r&&(this.R(`[Disk FileSystemProvider]: createResourceLock() - resource lock removed from resource-lock map (${a})`),this.P.delete(e)),this.R(`[Disk FileSystemProvider]: createResourceLock() - resource lock barrier open() (${a})`),r.open()})}async readFile(e,a){let n;try{a?.atomic&&(this.R(`[Disk FileSystemProvider]: atomic read operation started (${this.I(e)})`),n=await this.Q(e));const r=this.I(e);return await u.Promises.readFile(r)}catch(r){throw this.hb(r)}finally{n?.dispose()}}R(e){k.L&&this.a.trace(e)}readFileStream(e,a,n){const r=(0,h.$De)(i=>w.$Pe.concat(i.map(s=>w.$Pe.wrap(s))).buffer);return(0,N.$Zq)(this,e,r,i=>i.buffer,{...a,bufferSize:256*1024},n),r}async writeFile(e,a,n){return n?.atomic!==!1&&n?.atomic?.postfix&&await this.S(e)?this.U(e,(0,c.$hh)((0,c.$gh)(e),`${(0,c.$eh)(e)}${n.atomic.postfix}`),a,n):this.W(e,a,n)}async S(e){try{const a=this.I(e),{symbolicLink:n}=await u.SymlinkSupport.stat(a);if(n)return!1}catch{}return!0}async U(e,a,n,r){const i=new I.$Wc;try{i.add(await this.Q(e)),i.add(await this.Q(a)),await this.W(a,n,r,!0);try{await this.rename(a,e,{overwrite:!0})}catch(s){try{await this.delete(a,{recursive:!1,useTrash:!1,atomic:!1})}catch{}throw s}}finally{i.dispose()}}async W(e,a,n,r){let i;try{const s=this.I(e);if(!n.create||!n.overwrite){if(await u.Promises.exists(s)){if(!n.overwrite)throw(0,g.$nl)((0,$.localize)(0,null),g.FileSystemProviderErrorCode.FileExists)}else if(!n.create)throw(0,g.$nl)((0,$.localize)(1,null),g.FileSystemProviderErrorCode.FileNotFound)}i=await this.open(e,{create:!0,unlock:n.unlock},r),await this.write(i,0,a,0,a.byteLength)}catch(s){throw await this.ib(e,s)}finally{typeof i=="number"&&await this.close(i)}}static{this.$=!0}static configureFlushOnWrite(e){k.$=e}async open(e,a,n){const r=this.I(e);let i;(0,g.$bl)(a)&&!n&&(i=await this.Q(e));let s;try{if((0,g.$bl)(a)&&a.unlock)try{const{stat:f}=await u.SymlinkSupport.stat(r);f.mode&128||await u.Promises.chmod(r,f.mode|128)}catch(f){f.code!=="ENOENT"&&this.a.trace(f)}let o;if((0,g.$bl)(a)){if(l.$i)try{await u.Promises.truncate(r,0),o="r+"}catch(f){f.code!=="ENOENT"&&this.a.trace(f)}o||(o="w")}else o="r";s=await u.Promises.open(r,o)}catch(o){throw i?.dispose(),(0,g.$bl)(a)?await this.ib(e,o):this.hb(o)}if(this.X.set(s,0),(0,g.$bl)(a)&&this.Z.set(s,e),i){const o=this.Y.get(s);this.R(`[Disk FileSystemProvider]: open() - storing lock for handle ${s} (${r})`),this.Y.set(s,i),o&&(this.R(`[Disk FileSystemProvider]: open() - disposing a previous lock that was still stored on same handle ${s} (${r})`),o.dispose())}return s}async close(e){const a=this.Y.get(e);try{if(this.X.delete(e),this.Z.delete(e)&&k.$)try{await u.Promises.fdatasync(e)}catch(n){k.configureFlushOnWrite(!1),this.a.error(n)}return await u.Promises.close(e)}catch(n){throw this.hb(n)}finally{a&&(this.Y.get(e)===a&&(this.R(`[Disk FileSystemProvider]: close() - resource lock removed from handle-lock map ${e}`),this.Y.delete(e)),this.R(`[Disk FileSystemProvider]: close() - disposing lock for handle ${e}`),a.dispose())}}async read(e,a,n,r,i){const s=this.ab(e,a);let o=null;try{o=(await u.Promises.read(e,n,r,i,s)).bytesRead}catch(f){throw this.hb(f)}finally{this.bb(e,s,o)}return o}ab(e,a){return a===this.X.get(e)?null:a}bb(e,a,n){const r=this.X.get(e);typeof r=="number"&&(typeof a=="number"||(typeof n=="number"?this.X.set(e,r+n):this.X.delete(e)))}async write(e,a,n,r,i){return(0,E.$1h)(()=>this.cb(e,a,n,r,i),100,3)}async cb(e,a,n,r,i){const s=this.ab(e,a);let o=null;try{o=(await u.Promises.write(e,n,r,i,s)).bytesWritten}catch(f){throw await this.ib(this.Z.get(e),f)}finally{this.bb(e,s,o)}return o}async mkdir(e){try{await u.Promises.mkdir(this.I(e))}catch(a){throw this.hb(a)}}async delete(e,a){try{const n=this.I(e);if(a.recursive){let r;a?.atomic!==!1&&a.atomic.postfix&&(r=(0,m.$mc)((0,m.$pc)(n),`${(0,m.$qc)(n)}${a.atomic.postfix}`)),await u.Promises.rm(n,u.RimRafMode.MOVE,r)}else try{await u.Promises.unlink(n)}catch(r){if(r.code==="EPERM"||r.code==="EISDIR"){let i=!1;try{const{stat:s,symbolicLink:o}=await u.SymlinkSupport.stat(n);i=s.isDirectory()&&!o}catch{}if(i)await u.Promises.rmdir(n);else throw r}else throw r}}catch(n){throw this.hb(n)}}async rename(e,a,n){const r=this.I(e),i=this.I(a);if(r!==i)try{await this.db(e,a,"move",n.overwrite),await u.Promises.rename(r,i)}catch(s){throw(s.code==="EINVAL"||s.code==="EBUSY"||s.code==="ENAMETOOLONG")&&(s=new Error((0,$.localize)(2,null,(0,m.$qc)(r),(0,m.$qc)((0,m.$pc)(i)),s.toString()))),this.hb(s)}}async copy(e,a,n){const r=this.I(e),i=this.I(a);if(r!==i)try{await this.db(e,a,"copy",n.overwrite),await u.Promises.copy(r,i,{preserveSymlinks:!0})}catch(s){throw(s.code==="EINVAL"||s.code==="EBUSY"||s.code==="ENAMETOOLONG")&&(s=new Error((0,$.localize)(3,null,(0,m.$qc)(r),(0,m.$qc)((0,m.$pc)(i)),s.toString()))),this.hb(s)}}async db(e,a,n,r){const i=this.I(e),s=this.I(a);let o=!1;if(!!(this.capabilities&g.FileSystemProviderCapabilities.PathCaseSensitive)||(o=(0,L.$Eg)(i,s,!0)),o){if(n==="copy")throw(0,g.$nl)((0,$.localize)(4,null),g.FileSystemProviderErrorCode.FileExists);if(n==="move")return}const b=await this.N(e);if(!b)throw(0,g.$nl)((0,$.localize)(5,null),g.FileSystemProviderErrorCode.FileNotFound);const R=await this.N(a);if(R){if(!r)throw(0,g.$nl)((0,$.localize)(6,null),g.FileSystemProviderErrorCode.FileExists);b.type&g.FileType.File&&R.type&g.FileType.File||await this.delete(a,{recursive:!0,useTrash:!1,atomic:!1})}}async cloneFile(e,a){return this.eb(e,a,!1)}async eb(e,a,n){const r=this.I(e),i=this.I(a),s=!!(this.capabilities&g.FileSystemProviderCapabilities.PathCaseSensitive);if((0,L.$Eg)(r,i,!s))return;const o=new I.$Wc;try{o.add(await this.Q(e)),o.add(await this.Q(a)),n&&await u.Promises.mkdir((0,m.$pc)(i),{recursive:!0}),await u.Promises.copyFile(r,i)}catch(f){if(f.code==="ENOENT"&&!n)return this.eb(e,a,!0);throw this.hb(f)}finally{o.dispose()}}t(e,a,n){return new d.$hr(r=>e(r),r=>a(r),n)}F(e,a,n){return new p.$qr(r=>e(r),r=>a(r),n)}hb(e){if(e instanceof g.$ml)return e;let a=e,n;switch(e.code){case"ENOENT":n=g.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":n=g.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":n=g.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":n=g.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":n=g.FileSystemProviderErrorCode.NoPermissions;break;case"ERR_UNC_HOST_NOT_ALLOWED":a=`${e.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`,n=g.FileSystemProviderErrorCode.Unknown;break;default:n=g.FileSystemProviderErrorCode.Unknown}return(0,g.$nl)(a,n)}async ib(e,a){let n=this.hb(a);if(e&&n.code===g.FileSystemProviderErrorCode.NoPermissions)try{const{stat:r}=await u.SymlinkSupport.stat(this.I(e));r.mode&128||(n=(0,g.$nl)(a,g.FileSystemProviderErrorCode.FileWriteLocked))}catch(r){this.a.trace(r)}return n}}t.$rr=k}),define(oe[135],ae([0,1,2,6]),function(H,t,E,S){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$oR=void 0;class w extends E.$Xc{constructor(L,I=[]){super(),this.a=new S.$kk([L,...I]),this.B(L.onDidChangeLogLevel(m=>this.setLevel(m)))}get onDidChangeLogLevel(){return this.a.onDidChangeLogLevel}setLevel(L){this.a.setLevel(L)}getLevel(){return this.a.getLevel()}trace(L,...I){this.a.trace(L,...I)}debug(L,...I){this.a.debug(L,...I)}info(L,...I){this.a.info(L,...I)}warn(L,...I){this.a.warn(L,...I)}error(L,...I){this.a.error(L,...I)}flush(){this.a.flush()}}t.$oR=w}),define(oe[136],ae([0,1,10,6]),function(H,t,E,S){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$dR=void 0;var w;(function(l){l[l.Trace=0]="Trace",l[l.Debug=1]="Debug",l[l.Info=2]="Info",l[l.Warning=3]="Warning",l[l.Error=4]="Error",l[l.Critical=5]="Critical",l[l.Off=6]="Off"})(w||(w={}));async function O(l,c,h,u,$){try{const g=await new Promise((v,d)=>{H(["@vscode/spdlog"],v,d)}).then(be);g.setFlushOn(w.Trace);const N=await g.createAsyncRotatingLogger(l,c,h,u);return $?N.clearFormatters():N.setPattern("%Y-%m-%d %H:%M:%S.%e [%l] %v"),N}catch(g){console.error(g)}return null}function L(l,c,h){switch(c){case S.LogLevel.Trace:l.trace(h);break;case S.LogLevel.Debug:l.debug(h);break;case S.LogLevel.Info:l.info(h);break;case S.LogLevel.Warning:l.warn(h);break;case S.LogLevel.Error:l.error(h);break;case S.LogLevel.Off:break;default:throw new Error(`Invalid log level ${c}`)}}function I(l,c){switch(c){case S.LogLevel.Trace:l.setLevel(w.Trace);break;case S.LogLevel.Debug:l.setLevel(w.Debug);break;case S.LogLevel.Info:l.setLevel(w.Info);break;case S.LogLevel.Warning:l.setLevel(w.Warning);break;case S.LogLevel.Error:l.setLevel(w.Error);break;case S.LogLevel.Off:l.setLevel(w.Off);break;default:throw new Error(`Invalid log level ${c}`)}}class m extends S.$gk{constructor(c,h,u,$,g){super(),this.m=[],this.setLevel(g),this.n=this.s(c,h,u,$),this.B(this.onDidChangeLogLevel(N=>{this.r&&I(this.r,N)}))}async s(c,h,u,$){const g=u?6:1,N=30/g*E.$Il.MB,v=await O(c,h,N,g,$);if(v){this.r=v,I(this.r,this.getLevel());for(const{level:d,message:p}of this.m)L(this.r,d,p);this.m=[]}}g(c,h){this.r?L(this.r,c,h):this.getLevel()<=c&&this.m.push({level:c,message:h})}flush(){this.r?this.r.flush():this.n.then(()=>this.flush())}dispose(){this.r?this.u():this.n.then(()=>this.u()),super.dispose()}u(){this.r&&(this.r.drop(),this.r=void 0)}}t.$dR=m}),define(oe[137],ae([0,1,29,6,136]),function(H,t,E,S,w){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$eR=void 0;class O extends S.$lk{s(I,m,l){return new w.$dR((0,E.$3g)(),I.fsPath,!l?.donotRotate,!!l?.donotUseFormatters,m)}}t.$eR=O}),define(oe[39],ae([0,1,5,65,2,11]),function(H,t,E,S,w,O){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$vo=t.$uo=t.$to=void 0,t.$to=(0,O.$Gi)("policy");class L extends w.$Xc{constructor(){super(...arguments),this.f={},this.g=new Map,this.h=this.B(new E.$ne),this.onDidChange=this.h.event}async updatePolicyDefinitions(l){const c=Object.keys(this.f).length;return this.f={...l,...this.f},c!==Object.keys(this.f).length&&await this.j(l),S.Iterable.reduce(this.g.entries(),(h,[u,$])=>({...h,[u]:$}),{})}getPolicyValue(l){return this.g.get(l)}serialize(){return S.Iterable.reduce(Object.entries(this.f),(l,[c,h])=>({...l,[c]:{definition:h,value:this.g.get(c)}}),{})}}t.$uo=L;class I{constructor(){this.onDidChange=E.Event.None}async updatePolicyDefinitions(){return{}}getPolicyValue(){}serialize(){}}t.$vo=I}),define(oe[138],ae([0,1,8,5,65,3,10,6,39]),function(H,t,E,S,w,O,L,I,m){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Ygc=void 0;function l(h,u){const $=[];for(const g of new Set(w.Iterable.concat(h.keys(),u.keys())))h.get(g)!==u.get(g)&&$.push(g);return $}let c=class extends m.$uo{constructor(u,$,g){super(),this.m=u,this.n=$,this.s=g,this.c=this.B(new E.$Eh(500));const N=S.Event.filter($.onDidFilesChange,v=>v.affects(u));this.B($.watch(u)),this.B(N(()=>this.c.trigger(()=>this.w())))}async j(){await this.w()}async u(){const u=new Map;try{const $=await this.n.readFile(this.m),g=JSON.parse($.value.toString());if(!(0,O.$ig)(g))throw new Error("Policy file isn't a JSON object");for(const N of Object.keys(g))this.f[N]&&u.set(N,g[N])}catch($){$.fileOperationResult!==L.FileOperationResult.FILE_NOT_FOUND&&this.s.error("[FilePolicyService] Failed to read policies",$)}return u}async w(){const u=await this.u(),$=l(this.g,u);this.g=u,$.length>0&&this.h.fire($)}};t.$Ygc=c,t.$Ygc=c=ye([re(1,L.$al),re(2,I.$ak)],c)}),define(oe[139],ae([0,1,39,8,2,6]),function(H,t,E,S,w,O){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Xgc=void 0;let L=class extends E.$uo{constructor(m,l){super(),this.m=m,this.n=l,this.a=new S.$Ah,this.b=this.B(new w.$Yc)}async j(m){this.m.trace(`NativePolicyService#_updatePolicyDefinitions - Found ${Object.keys(m).length} policy definitions`);const{createWatcher:l}=await new Promise((c,h)=>{H(["@vscode/policy-watcher"],c,h)}).then(be);await this.a.queue(()=>new Promise((c,h)=>{try{this.b.value=l(this.n,m,u=>{this.t(u),c()})}catch(u){this.m.error("NativePolicyService#_updatePolicyDefinitions - Error creating watcher:",u),h(u)}}))}t(m){this.m.trace(`NativePolicyService#_onDidPolicyChange - Updated policy values: ${JSON.stringify(m)}`);for(const l in m){const c=m[l];c===void 0?this.g.delete(l):this.g.set(l,c)}this.h.fire(Object.keys(m))}};t.$Xgc=L,t.$Xgc=L=ye([re(0,O.$ak)],L)}),define(oe[33],ae([0,1,11]),function(H,t,E){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$uk=t.$tk=void 0,t.$tk=(0,E.$Gi)("productService"),t.$uk="vscode://schemas/vscode-product"}),define(oe[37],ae([0,1,75,3]),function(H,t,E,S){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$ro=void 0,E=be(E),S=be(S);class w{constructor(){this.a=new Map}add(L,I){E.ok(S.$gg(L)),E.ok(S.$ig(I)),E.ok(!this.a.has(L),"There is already an extension with this id"),this.a.set(L,I)}knows(L){return this.a.has(L)}as(L){return this.a.get(L)||null}}t.$ro=new w}),define(oe[140],ae([0,1,5,37]),function(H,t,E,S){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$so=void 0,S=be(S),t.$so={JSONContribution:"base.contributions.json"};function w(I){return I.length>0&&I.charAt(I.length-1)==="#"?I.substring(0,I.length-1):I}class O{constructor(){this.b=new E.$ne,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema(m,l){this.a[w(m)]=l,this.b.fire(m)}notifySchemaChanged(m){this.b.fire(m)}getSchemaContributions(){return{schemas:this.a}}}const L=new O;S.$ro.add(t.$so.JSONContribution,L)}),define(oe[40],ae([0,1,20,5,3,95,30,140,37]),function(H,t,E,S,w,O,L,I,m){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Go=t.$Fo=t.$Eo=t.$Do=t.$Co=t.$Bo=t.$Ao=t.$zo=t.$yo=t.$xo=t.ConfigurationScope=t.$wo=t.EditPresentationTypes=void 0,t.$Ho=N,t.$Io=v,t.$Jo=d,t.$Ko=k,t.$Lo=y,w=be(w),O=be(O);var l;(function(e){e.Multiline="multilineText",e.Singleline="singlelineText"})(l||(t.EditPresentationTypes=l={})),t.$wo={Configuration:"base.contributions.configuration"};var c;(function(e){e[e.APPLICATION=1]="APPLICATION",e[e.MACHINE=2]="MACHINE",e[e.WINDOW=3]="WINDOW",e[e.RESOURCE=4]="RESOURCE",e[e.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",e[e.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(c||(t.ConfigurationScope=c={})),t.$xo={properties:{},patternProperties:{}},t.$yo={properties:{},patternProperties:{}},t.$zo={properties:{},patternProperties:{}},t.$Ao={properties:{},patternProperties:{}},t.$Bo={properties:{},patternProperties:{}},t.$Co={properties:{},patternProperties:{}},t.$Do="vscode://schemas/settings/resourceLanguage",t.$Eo="vscode://schemas/settings/configurationDefaults";const h=m.$ro.as(I.$so.JSONContribution);class u{constructor(){this.h=new Set,this.i=new S.$ne,this.onDidSchemaChange=this.i.event,this.j=new S.$ne,this.onDidUpdateConfiguration=this.j.event,this.a=new Map,this.b={id:"defaultOverrides",title:O.localize(0,null),properties:{}},this.c=[this.b],this.g={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.d={},this.e=new Map,this.f={},h.registerSchema(t.$Do,this.g),this.v()}registerConfiguration(a,n=!0){this.registerConfigurations([a],n)}registerConfigurations(a,n=!0){const r=new Set;this.n(a,n,r),h.registerSchema(t.$Do,this.g),this.i.fire(),this.j.fire({properties:r})}deregisterConfigurations(a){const n=new Set;this.o(a,n),h.registerSchema(t.$Do,this.g),this.i.fire(),this.j.fire({properties:n})}updateConfigurations({add:a,remove:n}){const r=new Set;this.o(n,r),this.n(a,!1,r),h.registerSchema(t.$Do,this.g),this.i.fire(),this.j.fire({properties:r})}registerDefaultConfigurations(a){const n=new Set;this.k(a,n),this.i.fire(),this.j.fire({properties:n,defaultsOverrides:!0})}k(a,n){const r=[];for(const{overrides:i,source:s}of a)for(const o in i)if(n.add(o),t.$Go.test(o)){const f=this.a.get(o),b=f?.valuesSources??new Map,R=f?.value||{};for(const A of Object.keys(i[o])){const z=i[o][A];if(w.$ig(z)&&(w.$ng(R[A])||w.$ig(R[A]))){if(R[A]={...R[A]??{},...z},s){let Q=b.get(A);if(Q||(Q=new Map,b.set(A,Q)),!(Q instanceof Map)){console.error("objectConfigurationSources is not a Map");continue}for(const se in z)Q.set(se,s)}}else R[A]=z,s&&b.set(A,s)}this.a.set(o,{source:s,value:R,valuesSources:b});const T=(0,L.$kj)(o),D={type:"object",default:R,description:O.localize(1,null,T),$ref:t.$Do,defaultDefaultValue:R,source:w.$gg(s)?void 0:s,defaultValueSource:s};r.push(...N(o)),this.d[o]=D,this.b.properties[o]=D}else{const f=this.d[o],b=this.a.get(o);let R=b?.value??f?.defaultDefaultValue,T=i[o],D=s;if(w.$ig(T)&&(f!==void 0&&f.type==="object"||f===void 0&&(w.$ng(R)||w.$ig(R)))){if(w.$ig(R)||(R={}),T={...R,...T},D=b?.source??new Map,!(D instanceof Map)){console.error("defaultValueSource is not a Map");continue}for(const z in i[o])s?D.set(z,s):D.delete(z)}this.a.set(o,{value:T,source:D}),f&&(this.w(o,f),this.r(o,f))}this.m(r)}deregisterDefaultConfigurations(a){const n=new Set;this.l(a,n),this.i.fire(),this.j.fire({properties:n,defaultsOverrides:!0})}l(a,n){for(const{overrides:r,source:i}of a)for(const s in r){const o=w.$gg(i)?i:i?.id,f=this.a.get(s);if(f){if(t.$Go.test(s)){for(const R of Object.keys(r[s])){const T=r[s][R];if(w.$ig(T)){const D=f.valuesSources?.get(R);for(const A of Object.keys(T)){const z=D?.get(A);(w.$gg(z)?z:z?.id)===o&&(D?.delete(A),delete f.value[R][A])}Object.keys(f.value[R]).length===0&&(delete f.value[R],f.valuesSources?.delete(R))}else{const D=f.valuesSources?.get(R);(w.$gg(D)?D:D?.id)===o&&(f.valuesSources?.delete(R),delete f.value[R])}}const b=this.a.get(s);b&&Object.keys(b.value).length===0&&(this.a.delete(s),delete this.d[s],delete this.b.properties[s])}else{if(f.source instanceof Map){const R=f.source;for(const T in r[s]){const D=R.get(T);(w.$gg(D)?D:D?.id)===o&&(R.delete(T),delete f.value[T])}R.size===0&&this.a.delete(s)}else{const R=w.$gg(f.source)?f.source:f.source?.id;if(o!==R)continue;this.a.delete(s)}const b=this.d[s];b&&(this.w(s,b),this.r(s,b))}n.add(s)}}this.u()}deltaConfiguration(a){let n=!1;const r=new Set;a.removedDefaults&&(this.l(a.removedDefaults,r),n=!0),a.addedDefaults&&(this.k(a.addedDefaults,r),n=!0),a.removedConfigurations&&this.o(a.removedConfigurations,r),a.addedConfigurations&&this.n(a.addedConfigurations,!1,r),this.i.fire(),this.j.fire({properties:r,defaultsOverrides:n})}notifyConfigurationSchemaUpdated(...a){this.i.fire()}registerOverrideIdentifiers(a){this.m(a),this.i.fire()}m(a){for(const n of a)this.h.add(n);this.u()}n(a,n,r){a.forEach(i=>{this.p(i,n,i.extensionInfo,i.restrictedProperties,void 0,r),this.c.push(i),this.q(i)})}o(a,n){const r=i=>{if(i.properties)for(const s in i.properties){n.add(s);const o=this.d[s];o?.policy?.name&&this.e.delete(o.policy.name),delete this.d[s],this.s(s,i.properties[s])}i.allOf?.forEach(s=>r(s))};for(const i of a){r(i);const s=this.c.indexOf(i);s!==-1&&this.c.splice(s,1)}}p(a,n=!0,r,i,s=c.WINDOW,o){s=w.$pg(a.scope)?s:a.scope;const f=a.properties;if(f)for(const R in f){const T=f[R];if(n&&k(R,T)){delete f[R];continue}if(T.source=r,T.defaultDefaultValue=f[R].default,this.w(R,T),t.$Go.test(R)?T.scope=void 0:(T.scope=w.$pg(T.scope)?s:T.scope,T.restricted=w.$pg(T.restricted)?!!i?.includes(R):T.restricted),f[R].hasOwnProperty("included")&&!f[R].included){this.f[R]=f[R],delete f[R];continue}else this.d[R]=f[R],f[R].policy?.name&&this.e.set(f[R].policy.name,R);!f[R].deprecationMessage&&f[R].markdownDeprecationMessage&&(f[R].deprecationMessage=f[R].markdownDeprecationMessage),o.add(R)}const b=a.allOf;if(b)for(const R of b)this.p(R,n,r,i,s,o)}getConfigurations(){return this.c}getConfigurationProperties(){return this.d}getPolicyConfigurations(){return this.e}getExcludedConfigurationProperties(){return this.f}getConfigurationDefaultsOverrides(){return this.a}q(a){const n=r=>{const i=r.properties;if(i)for(const o in i)this.r(o,i[o]);r.allOf?.forEach(n)};n(a)}r(a,n){switch(t.$xo.properties[a]=n,n.scope){case c.APPLICATION:t.$yo.properties[a]=n;break;case c.MACHINE:t.$zo.properties[a]=n;break;case c.MACHINE_OVERRIDABLE:t.$Ao.properties[a]=n;break;case c.WINDOW:t.$Bo.properties[a]=n;break;case c.RESOURCE:t.$Co.properties[a]=n;break;case c.LANGUAGE_OVERRIDABLE:t.$Co.properties[a]=n,this.g.properties[a]=n;break}}s(a,n){switch(delete t.$xo.properties[a],n.scope){case c.APPLICATION:delete t.$yo.properties[a];break;case c.MACHINE:delete t.$zo.properties[a];break;case c.MACHINE_OVERRIDABLE:delete t.$Ao.properties[a];break;case c.WINDOW:delete t.$Bo.properties[a];break;case c.RESOURCE:case c.LANGUAGE_OVERRIDABLE:delete t.$Co.properties[a],delete this.g.properties[a];break}}u(){for(const a of this.h.values()){const n=`[${a}]`,r={type:"object",description:O.localize(2,null),errorMessage:O.localize(3,null),$ref:t.$Do};this.w(n,r),t.$xo.properties[n]=r,t.$yo.properties[n]=r,t.$zo.properties[n]=r,t.$Ao.properties[n]=r,t.$Bo.properties[n]=r,t.$Co.properties[n]=r}}v(){const a={type:"object",description:O.localize(4,null),errorMessage:O.localize(5,null),$ref:t.$Do};t.$xo.patternProperties[t.$Fo]=a,t.$yo.patternProperties[t.$Fo]=a,t.$zo.patternProperties[t.$Fo]=a,t.$Ao.patternProperties[t.$Fo]=a,t.$Bo.patternProperties[t.$Fo]=a,t.$Co.patternProperties[t.$Fo]=a,this.i.fire()}w(a,n){const r=this.a.get(a);let i=r?.value,s=r?.source;w.$ng(i)&&(i=n.defaultDefaultValue,s=void 0),w.$ng(i)&&(i=d(n.type)),n.default=i,n.defaultValueSource=s}}const $="\\[([^\\]]+)\\]",g=new RegExp($,"g");t.$Fo=`^(${$})+$`,t.$Go=new RegExp(t.$Fo);function N(e){const a=[];if(t.$Go.test(e)){let n=g.exec(e);for(;n?.length;){const r=n[1].trim();r&&a.push(r),n=g.exec(e)}}return(0,E.$Pb)(a)}function v(e){return e.reduce((a,n)=>`${a}[${n}]`,"")}function d(e){switch(Array.isArray(e)?e[0]:e){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}const p=new u;m.$ro.add(t.$wo.Configuration,p);function k(e,a){return e.trim()?t.$Go.test(e)?O.localize(7,null,e):p.getConfigurationProperties()[e]!==void 0?O.localize(8,null,e):a.policy?.name&&p.getPolicyConfigurations().get(a.policy?.name)!==void 0?O.localize(9,null,e,a.policy?.name,p.getPolicyConfigurations().get(a.policy?.name)):null:O.localize(6,null)}function y(){const e=[],a=p.getConfigurationProperties();for(const n of Object.keys(a))e.push([n,a[n].scope]);return e.push(["launch",c.RESOURCE]),e.push(["task",c.RESOURCE]),e}}),define(oe[66],ae([0,1,20,5,34,2,31,28,3,12,30,40,10,37]),function(H,t,E,S,w,O,L,I,m,l,c,h,u,$){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Ro=t.$Po=t.$Oo=t.$No=t.$Mo=void 0,t.$Qo=y,E=be(E),w=be(w),I=be(I),m=be(m);function g(r){return Object.isFrozen(r)?r:I.$fo(r)}class N{static createEmptyModel(i){return new N({},[],[],void 0,i)}constructor(i,s,o,f,b){this.b=i,this.c=s,this.d=o,this.raw=f,this.f=b,this.a=new Map}get rawConfiguration(){if(!this.g)if(this.raw?.length){const i=this.raw.map(s=>{if(s instanceof N)return s;const o=new v("",this.f);return o.parseRaw(s),o.configurationModel});this.g=i.reduce((s,o)=>o===s?o:s.merge(o),i[0])}else this.g=this;return this.g}get contents(){return this.b}get overrides(){return this.d}get keys(){return this.c}isEmpty(){return this.c.length===0&&Object.keys(this.b).length===0&&this.d.length===0}getValue(i){return i?(0,c.$ij)(this.contents,i):this.contents}inspect(i,s){const o=this;return{get value(){return g(o.rawConfiguration.getValue(i))},get override(){return s?g(o.rawConfiguration.getOverrideValue(i,s)):void 0},get merged(){return g(s?o.rawConfiguration.override(s).getValue(i):o.rawConfiguration.getValue(i))},get overrides(){const f=[];for(const{contents:b,identifiers:R,keys:T}of o.rawConfiguration.overrides){const D=new N(b,T,[],void 0,o.f).getValue(i);D!==void 0&&f.push({identifiers:R,value:D})}return f.length?g(f):void 0}}}getOverrideValue(i,s){const o=this.j(s);return o?i?(0,c.$ij)(o,i):o:void 0}getKeysForOverrideIdentifier(i){const s=[];for(const o of this.overrides)o.identifiers.includes(i)&&s.push(...o.keys);return E.$Pb(s)}getAllOverrideIdentifiers(){const i=[];for(const s of this.overrides)i.push(...s.identifiers);return E.$Pb(i)}override(i){let s=this.a.get(i);return s||(s=this.h(i),this.a.set(i,s)),s}merge(...i){const s=I.$eo(this.contents),o=I.$eo(this.overrides),f=[...this.keys],b=this.raw?.length?[...this.raw]:[this];for(const R of i)if(b.push(...R.raw?.length?R.raw:[R]),!R.isEmpty()){this.i(s,R.contents);for(const T of R.overrides){const[D]=o.filter(A=>E.$xb(A.identifiers,T.identifiers));D?(this.i(D.contents,T.contents),D.keys.push(...T.keys),D.keys=E.$Pb(D.keys)):o.push(I.$eo(T))}for(const T of R.keys)f.indexOf(T)===-1&&f.push(T)}return new N(s,f,o,b.every(R=>R instanceof N)?void 0:b,this.f)}h(i){const s=this.j(i);if(!s||typeof s!="object"||!Object.keys(s).length)return this;const o={};for(const f of E.$Pb([...Object.keys(this.contents),...Object.keys(s)])){let b=this.contents[f];const R=s[f];R&&(typeof b=="object"&&typeof R=="object"?(b=I.$eo(b),this.i(b,R)):b=R),o[f]=b}return new N(o,this.keys,this.overrides,void 0,this.f)}i(i,s){for(const o of Object.keys(s)){if(o in i&&m.$ig(i[o])&&m.$ig(s[o])){this.i(i[o],s[o]);continue}i[o]=I.$eo(s[o])}}j(i){let s=null,o=null;const f=b=>{b&&(o?this.i(o,b):o=I.$eo(b))};for(const b of this.overrides)b.identifiers.length===1&&b.identifiers[0]===i?s=b.contents:b.identifiers.includes(i)&&f(b.contents);return f(s),o}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}addValue(i,s){this.k(i,s,!0)}setValue(i,s){this.k(i,s,!1)}removeValue(i){const s=this.keys.indexOf(i);s!==-1&&(this.keys.splice(s,1),(0,c.$hj)(this.contents,i),h.$Go.test(i)&&this.overrides.splice(this.overrides.findIndex(o=>E.$xb(o.identifiers,(0,h.$Ho)(i))),1))}k(i,s,o){(0,c.$gj)(this.contents,i,s,f=>this.f.error(f)),o=o||this.keys.indexOf(i)===-1,o&&this.keys.push(i),h.$Go.test(i)&&this.overrides.push({identifiers:(0,h.$Ho)(i),keys:Object.keys(this.contents[i]),contents:(0,c.$fj)(this.contents[i],f=>this.f.error(f))})}}t.$Mo=N;class v{constructor(i,s){this.f=i,this.g=s,this.a=null,this.b=null,this.c=[],this.d=[]}get configurationModel(){return this.b||N.createEmptyModel(this.g)}get restrictedConfigurations(){return this.c}get errors(){return this.d}parse(i,s){if(!m.$pg(i)){const o=this.h(i);this.parseRaw(o,s)}}reparse(i){this.a&&this.parseRaw(this.a,i)}parseRaw(i,s){this.a=i;const{contents:o,keys:f,overrides:b,restricted:R,hasExcludedProperties:T}=this.i(i,s);this.b=new N(o,f,b,T?[i]:void 0,this.g),this.c=R||[]}h(i){let s={},o=null,f=[];const b=[],R=[];function T(A){Array.isArray(f)?f.push(A):o!==null&&(f[o]=A)}const D={onObjectBegin:()=>{const A={};T(A),b.push(f),f=A,o=null},onObjectProperty:A=>{o=A},onObjectEnd:()=>{f=b.pop()},onArrayBegin:()=>{const A=[];T(A),b.push(f),f=A,o=null},onArrayEnd:()=>{f=b.pop()},onLiteralValue:T,onError:(A,z,J)=>{R.push({error:A,offset:z,length:J})}};if(i)try{w.$6n(i,D),s=f[0]||{}}catch(A){this.g.error(`Error while parsing settings file ${this.f}: ${A}`),this.d=[A]}return s}i(i,s){const o=$.$ro.as(h.$wo.Configuration).getConfigurationProperties(),f=this.j(i,o,!0,s);i=f.raw;const b=(0,c.$fj)(i,D=>this.g.error(`Conflict in settings file ${this.f}: ${D}`)),R=Object.keys(i),T=this.l(i,D=>this.g.error(`Conflict in settings file ${this.f}: ${D}`));return{contents:b,keys:R,overrides:T,restricted:f.restricted,hasExcludedProperties:f.hasExcludedProperties}}j(i,s,o,f){let b=!1;if(!f?.scopes&&!f?.skipRestricted&&!f?.exclude?.length)return{raw:i,restricted:[],hasExcludedProperties:b};const R={},T=[];for(const D in i)if(h.$Go.test(D)&&o){const A=this.j(i[D],s,!1,f);R[D]=A.raw,b=b||A.hasExcludedProperties,T.push(...A.restricted)}else{const A=s[D],z=A?typeof A.scope<"u"?A.scope:h.ConfigurationScope.WINDOW:void 0;A?.restricted&&T.push(D),!f.exclude?.includes(D)&&(f.include?.includes(D)||(z===void 0||f.scopes===void 0||f.scopes.includes(z))&&!(f.skipRestricted&&A?.restricted))?R[D]=i[D]:b=!0}return{raw:R,restricted:T,hasExcludedProperties:b}}l(i,s){const o=[];for(const f of Object.keys(i))if(h.$Go.test(f)){const b={};for(const R in i[f])b[R]=i[f][R];o.push({identifiers:(0,h.$Ho)(f),keys:Object.keys(b),contents:(0,c.$fj)(b,s)})}return o}}t.$No=v;class d extends O.$Xc{constructor(i,s,o,f,b){super(),this.c=i,this.f=s,this.g=f,this.h=b,this.b=this.B(new S.$ne),this.onDidChange=this.b.event,this.a=new v(this.c.toString(),b),this.B(this.g.watch(o.dirname(this.c))),this.B(this.g.watch(this.c)),this.B(S.Event.any(S.Event.filter(this.g.onDidFilesChange,R=>R.contains(this.c)),S.Event.filter(this.g.onDidRunOperation,R=>(R.isOperation(u.FileOperation.CREATE)||R.isOperation(u.FileOperation.COPY)||R.isOperation(u.FileOperation.DELETE)||R.isOperation(u.FileOperation.WRITE))&&o.isEqual(R.resource,i)))(()=>this.b.fire()))}async loadConfiguration(){try{const i=await this.g.readFile(this.c);return this.a.parse(i.value.toString()||"{}",this.f),this.a.configurationModel}catch{return N.createEmptyModel(this.h)}}reparse(i){return i&&(this.f=i),this.a.reparse(this.f),this.a.configurationModel}getRestrictedSettings(){return this.a.restrictedConfigurations}}t.$Oo=d;class p{constructor(i,s,o,f,b,R,T,D,A,z,J,Q,se){this.a=i,this.b=s,this.c=o,this.overrideIdentifiers=f,this.d=b,this.f=R,this.g=T,this.h=D,this.i=A,this.j=z,this.k=J,this.l=Q,this.m=se}get value(){return g(this.c)}n(i){return i?.value!==void 0||i?.override!==void 0||i?.overrides!==void 0?i:void 0}get q(){return this.p||(this.p=this.d.inspect(this.a,this.b.overrideIdentifier)),this.p}get defaultValue(){return this.q.merged}get default(){return this.n(this.q)}get s(){return this.r===void 0&&(this.r=this.f?this.f.inspect(this.a):null),this.r}get policyValue(){return this.s?.merged}get policy(){return this.s?.value!==void 0?{value:this.s.value}:void 0}get u(){return this.t===void 0&&(this.t=this.g?this.g.inspect(this.a):null),this.t}get applicationValue(){return this.u?.merged}get application(){return this.n(this.u)}get w(){return this.v||(this.v=this.h.inspect(this.a,this.b.overrideIdentifier)),this.v}get userValue(){return this.w.merged}get user(){return this.n(this.w)}get y(){return this.x||(this.x=this.i.inspect(this.a,this.b.overrideIdentifier)),this.x}get userLocalValue(){return this.y.merged}get userLocal(){return this.n(this.y)}get A(){return this.z||(this.z=this.j.inspect(this.a,this.b.overrideIdentifier)),this.z}get userRemoteValue(){return this.A.merged}get userRemote(){return this.n(this.A)}get D(){return this.B===void 0&&(this.B=this.k?this.k.inspect(this.a,this.b.overrideIdentifier):null),this.B}get workspaceValue(){return this.D?.merged}get workspace(){return this.n(this.D)}get F(){return this.E===void 0&&(this.E=this.l?this.l.inspect(this.a,this.b.overrideIdentifier):null),this.E}get workspaceFolderValue(){return this.F?.merged}get workspaceFolder(){return this.n(this.F)}get H(){return this.G===void 0&&(this.G=this.m.inspect(this.a,this.b.overrideIdentifier)),this.G}get memoryValue(){return this.H.merged}get memory(){return this.n(this.H)}}class k{constructor(i,s,o,f,b,R,T,D,A,z){this.j=i,this.l=s,this.m=o,this.n=f,this.p=b,this.q=R,this.r=T,this.s=D,this.t=A,this.u=z,this.h=null,this.i=new L.$Dc,this.v=null}getValue(i,s,o){return this.w(i,s,o).getValue(i)}updateValue(i,s,o={}){let f;o.resource?(f=this.t.get(o.resource),f||(f=N.createEmptyModel(this.u),this.t.set(o.resource,f))):f=this.s,s===void 0?f.removeValue(i):f.setValue(i,s),o.resource||(this.h=null)}inspect(i,s,o){const f=this.w(i,s,o),b=this.A(s.resource,o),R=s.resource?this.t.get(s.resource)||this.s:this.s,T=new Set;for(const D of f.overrides)for(const A of D.identifiers)f.getOverrideValue(i,A)!==void 0&&T.add(A);return new p(i,s,f.getValue(i),T.size?[...T]:void 0,this.j,this.l.isEmpty()?void 0:this.l,this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration,this.userConfiguration,this.localUserConfiguration,this.remoteUserConfiguration,o?this.q:void 0,b||void 0,R)}keys(i){const s=this.A(void 0,i);return{default:this.j.keys.slice(0),user:this.userConfiguration.keys.slice(0),workspace:this.q.keys.slice(0),workspaceFolder:s?s.keys.slice(0):[]}}updateDefaultConfiguration(i){this.j=i,this.h=null,this.i.clear()}updatePolicyConfiguration(i){this.l=i}updateApplicationConfiguration(i){this.m=i,this.h=null,this.i.clear()}updateLocalUserConfiguration(i){this.n=i,this.v=null,this.h=null,this.i.clear()}updateRemoteUserConfiguration(i){this.p=i,this.v=null,this.h=null,this.i.clear()}updateWorkspaceConfiguration(i){this.q=i,this.h=null,this.i.clear()}updateFolderConfiguration(i,s){this.r.set(i,s),this.i.delete(i)}deleteFolderConfiguration(i){this.folderConfigurations.delete(i),this.i.delete(i)}compareAndUpdateDefaultConfiguration(i,s){const o=[];if(!s){const{added:f,updated:b,removed:R}=a(this.j,i);s=[...f,...b,...R]}for(const f of s)for(const b of(0,h.$Ho)(f)){const R=this.j.getKeysForOverrideIdentifier(b),T=i.getKeysForOverrideIdentifier(b),D=[...T.filter(A=>R.indexOf(A)===-1),...R.filter(A=>T.indexOf(A)===-1),...R.filter(A=>!I.$io(this.j.override(b).getValue(A),i.override(b).getValue(A)))];o.push([b,D])}return this.updateDefaultConfiguration(i),{keys:s,overrides:o}}compareAndUpdatePolicyConfiguration(i){const{added:s,updated:o,removed:f}=a(this.l,i),b=[...s,...o,...f];return b.length&&this.updatePolicyConfiguration(i),{keys:b,overrides:[]}}compareAndUpdateApplicationConfiguration(i){const{added:s,updated:o,removed:f,overrides:b}=a(this.applicationConfiguration,i),R=[...s,...o,...f];return R.length&&this.updateApplicationConfiguration(i),{keys:R,overrides:b}}compareAndUpdateLocalUserConfiguration(i){const{added:s,updated:o,removed:f,overrides:b}=a(this.localUserConfiguration,i),R=[...s,...o,...f];return R.length&&this.updateLocalUserConfiguration(i),{keys:R,overrides:b}}compareAndUpdateRemoteUserConfiguration(i){const{added:s,updated:o,removed:f,overrides:b}=a(this.remoteUserConfiguration,i),R=[...s,...o,...f];return R.length&&this.updateRemoteUserConfiguration(i),{keys:R,overrides:b}}compareAndUpdateWorkspaceConfiguration(i){const{added:s,updated:o,removed:f,overrides:b}=a(this.workspaceConfiguration,i),R=[...s,...o,...f];return R.length&&this.updateWorkspaceConfiguration(i),{keys:R,overrides:b}}compareAndUpdateFolderConfiguration(i,s){const o=this.folderConfigurations.get(i),{added:f,updated:b,removed:R,overrides:T}=a(o,s),D=[...f,...b,...R];return(D.length||!o)&&this.updateFolderConfiguration(i,s),{keys:D,overrides:T}}compareAndDeleteFolderConfiguration(i){const s=this.folderConfigurations.get(i);if(!s)throw new Error("Unknown folder");this.deleteFolderConfiguration(i);const{added:o,updated:f,removed:b,overrides:R}=a(s,void 0);return{keys:[...o,...f,...b],overrides:R}}get defaults(){return this.j}get applicationConfiguration(){return this.m}get userConfiguration(){return this.v||(this.v=this.p.isEmpty()?this.n:this.n.merge(this.p)),this.v}get localUserConfiguration(){return this.n}get remoteUserConfiguration(){return this.p}get workspaceConfiguration(){return this.q}get folderConfigurations(){return this.r}w(i,s,o){let f=this.x(s,o);return s.overrideIdentifier&&(f=f.override(s.overrideIdentifier)),!this.l.isEmpty()&&this.l.getValue(i)!==void 0&&(f=f.merge(this.l)),f}x({resource:i},s){let o=this.y();if(s&&i){const f=s.getFolder(i);f&&(o=this.z(f.uri)||o);const b=this.t.get(i);b&&(o=o.merge(b))}return o}y(){return this.h||(this.h=this.j.merge(this.applicationConfiguration,this.userConfiguration,this.q,this.s)),this.h}z(i){let s=this.i.get(i);if(!s){const o=this.y(),f=this.r.get(i);f?(s=o.merge(f),this.i.set(i,s)):s=o}return s}A(i,s){if(s&&i){const o=s.getFolder(i);if(o)return this.r.get(o.uri)}}toData(){return{defaults:{contents:this.j.contents,overrides:this.j.overrides,keys:this.j.keys},policy:{contents:this.l.contents,overrides:this.l.overrides,keys:this.l.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this.q.contents,overrides:this.q.overrides,keys:this.q.keys},folders:[...this.r.keys()].reduce((i,s)=>{const{contents:o,overrides:f,keys:b}=this.r.get(s);return i.push([s,{contents:o,overrides:f,keys:b}]),i},[])}}allKeys(){const i=new Set;return this.j.keys.forEach(s=>i.add(s)),this.userConfiguration.keys.forEach(s=>i.add(s)),this.q.keys.forEach(s=>i.add(s)),this.r.forEach(s=>s.keys.forEach(o=>i.add(o))),[...i.values()]}B(){const i=new Set;return this.j.getAllOverrideIdentifiers().forEach(s=>i.add(s)),this.userConfiguration.getAllOverrideIdentifiers().forEach(s=>i.add(s)),this.q.getAllOverrideIdentifiers().forEach(s=>i.add(s)),this.r.forEach(s=>s.getAllOverrideIdentifiers().forEach(o=>i.add(o))),[...i.values()]}D(i){const s=new Set;return this.j.getKeysForOverrideIdentifier(i).forEach(o=>s.add(o)),this.userConfiguration.getKeysForOverrideIdentifier(i).forEach(o=>s.add(o)),this.q.getKeysForOverrideIdentifier(i).forEach(o=>s.add(o)),this.r.forEach(o=>o.getKeysForOverrideIdentifier(i).forEach(f=>s.add(f))),[...s.values()]}static parse(i,s){const o=this.E(i.defaults,s),f=this.E(i.policy,s),b=this.E(i.application,s),R=this.E(i.user,s),T=this.E(i.workspace,s),D=i.folders.reduce((A,z)=>(A.set(l.URI.revive(z[0]),this.E(z[1],s)),A),new L.$Dc);return new k(o,f,b,R,N.createEmptyModel(s),T,D,N.createEmptyModel(s),new L.$Dc,s)}static E(i,s){return new N(i.contents,i.keys,i.overrides,void 0,s)}}t.$Po=k;function y(...r){if(r.length===0)return{keys:[],overrides:[]};if(r.length===1)return r[0];const i=new Set,s=new Map;for(const f of r)f.keys.forEach(b=>i.add(b)),f.overrides.forEach(([b,R])=>{const T=(0,L.$Ac)(s,b,new Set);R.forEach(D=>T.add(D))});const o=[];return s.forEach((f,b)=>o.push([b,[...f.values()]])),{keys:[...i.values()],overrides:o}}class e{constructor(i,s,o,f,b){this.change=i,this.f=s,this.g=o,this.h=f,this.i=b,this.a=`
`,this.b=this.a.charCodeAt(0),this.c=46,this.affectedKeys=new Set,this.j=void 0;for(const R of i.keys)this.affectedKeys.add(R);for(const[,R]of i.overrides)for(const T of R)this.affectedKeys.add(T);this.d=this.a;for(const R of this.affectedKeys)this.d+=R+this.a}get previousConfiguration(){return!this.j&&this.f&&(this.j=k.parse(this.f.data,this.i)),this.j}affectsConfiguration(i,s){const o=this.a+i,f=this.d.indexOf(o);if(f<0)return!1;const b=f+o.length;if(b>=this.d.length)return!1;const R=this.d.charCodeAt(b);if(R!==this.b&&R!==this.c)return!1;if(s){const T=this.previousConfiguration?this.previousConfiguration.getValue(i,s,this.f?.workspace):void 0,D=this.g.getValue(i,s,this.h);return!I.$io(T,D)}return!0}}t.$Ro=e;function a(r,i){const{added:s,removed:o,updated:f}=n(i?.rawConfiguration,r?.rawConfiguration),b=[],R=r?.getAllOverrideIdentifiers()||[],T=i?.getAllOverrideIdentifiers()||[];if(i){const D=T.filter(A=>!R.includes(A));for(const A of D)b.push([A,i.getKeysForOverrideIdentifier(A)])}if(r){const D=R.filter(A=>!T.includes(A));for(const A of D)b.push([A,r.getKeysForOverrideIdentifier(A)])}if(i&&r){for(const D of R)if(T.includes(D)){const A=n({contents:r.getOverrideValue(void 0,D)||{},keys:r.getKeysForOverrideIdentifier(D)},{contents:i.getOverrideValue(void 0,D)||{},keys:i.getKeysForOverrideIdentifier(D)});b.push([D,[...A.added,...A.removed,...A.updated]])}}return{added:s,removed:o,updated:f,overrides:b}}function n(r,i){const s=r?i?r.keys.filter(b=>i.keys.indexOf(b)===-1):[...r.keys]:[],o=i?r?i.keys.filter(b=>r.keys.indexOf(b)===-1):[...i.keys]:[],f=[];if(r&&i){for(const b of i.keys)if(r.keys.indexOf(b)!==-1){const R=(0,c.$ij)(i.contents,b),T=(0,c.$ij)(r.contents,b);I.$io(R,T)||f.push(b)}}return{added:s,removed:o,updated:f}}}),define(oe[141],ae([0,1,20,5,2,28,3,66,40,6,39,37]),function(H,t,E,S,w,O,L,I,m,l,c,h){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Uo=t.$To=t.$So=void 0;class u extends w.$Xc{get configurationModel(){return this.b}constructor(v){super(),this.c=v,this.a=this.B(new S.$ne),this.onDidChangeConfiguration=this.a.event,this.b=I.$Mo.createEmptyModel(this.c)}async initialize(){return this.h(),this.B(h.$ro.as(m.$wo.Configuration).onDidUpdateConfiguration(({properties:v,defaultsOverrides:d})=>this.f(Array.from(v),d))),this.configurationModel}reload(){return this.h(),this.configurationModel}f(v,d){this.j(v,h.$ro.as(m.$wo.Configuration).getConfigurationProperties()),this.a.fire({defaults:this.configurationModel,properties:v})}g(){return{}}h(){this.b=I.$Mo.createEmptyModel(this.c);const v=h.$ro.as(m.$wo.Configuration).getConfigurationProperties();this.j(Object.keys(v),v)}j(v,d){const p=this.g();for(const k of v){const y=p[k],e=d[k];y!==void 0?this.b.addValue(k,y):e?this.b.addValue(k,e.default):this.b.removeValue(k)}}}t.$So=u;class ${constructor(){this.onDidChangeConfiguration=S.Event.None,this.configurationModel=I.$Mo.createEmptyModel(new l.$nk)}async initialize(){return this.configurationModel}}t.$To=$;let g=class extends w.$Xc{get configurationModel(){return this.b}constructor(v,d,p){super(),this.c=v,this.f=d,this.g=p,this.a=this.B(new S.$ne),this.onDidChangeConfiguration=this.a.event,this.b=I.$Mo.createEmptyModel(this.g)}async initialize(){return this.g.trace("PolicyConfiguration#initialize"),this.m(await this.h(this.c.configurationModel.keys),!1),this.B(this.f.onDidChange(v=>this.j(v))),this.B(this.c.onDidChangeConfiguration(async({properties:v})=>this.m(await this.h(v),!0))),this.b}async h(v){this.g.trace("PolicyConfiguration#updatePolicyDefinitions",v);const d={},p=[],k=h.$ro.as(m.$wo.Configuration).getConfigurationProperties();for(const y of v){const e=k[y];if(!e){p.push(y);continue}if(e.policy){if(e.type!=="string"&&e.type!=="number"){this.g.warn(`Policy ${e.policy.name} has unsupported type ${e.type}`);continue}p.push(y),d[e.policy.name]={type:e.type}}}return(0,L.$tg)(d)||await this.f.updatePolicyDefinitions(d),p}j(v){this.g.trace("PolicyConfiguration#onDidChangePolicies",v);const d=h.$ro.as(m.$wo.Configuration).getPolicyConfigurations(),p=(0,E.$Kb)(v.map(k=>d.get(k)));this.m(p,!0)}m(v,d){this.g.trace("PolicyConfiguration#update",v);const p=h.$ro.as(m.$wo.Configuration).getConfigurationProperties(),k=[],y=this.b.isEmpty();for(const e of v){const a=p[e]?.policy?.name;if(a){const n=this.f.getPolicyValue(a);(y?n!==void 0:!(0,O.$io)(this.b.getValue(e),n))&&k.push([e,n])}else this.b.getValue(e)!==void 0&&k.push([e,void 0])}if(k.length){this.g.trace("PolicyConfiguration#changed",k);const e=this.b;this.b=I.$Mo.createEmptyModel(this.g);for(const a of e.keys)this.b.setValue(a,e.getValue(a));for(const[a,n]of k)n===void 0?this.b.removeValue(a):this.b.setValue(a,n);d&&this.a.fire(this.b)}}};t.$Uo=g,t.$Uo=g=ye([re(1,c.$to),re(2,l.$ak)],g)}),define(oe[142],ae([0,1,20,8,14,5,34,77,2,31,28,13,17,30,66,40,141,10,39]),function(H,t,E,S,w,O,L,I,m,l,c,h,u,$,g,N,v,d,p){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Vo=void 0;class k extends m.$Xc{constructor(a,n,r,i){super(),this.m=a,this.n=i,this.h=this.B(new O.$ne),this.onDidChangeConfiguration=this.h.event,this.b=this.B(new v.$So(i)),this.c=r instanceof p.$vo?new v.$To:this.B(new v.$Uo(this.b,r,i)),this.f=this.B(new g.$Oo(this.m,{},u.$$g,n,i)),this.a=new g.$Po(this.b.configurationModel,this.c.configurationModel,g.$Mo.createEmptyModel(i),g.$Mo.createEmptyModel(i),g.$Mo.createEmptyModel(i),g.$Mo.createEmptyModel(i),new l.$Dc,g.$Mo.createEmptyModel(i),new l.$Dc,i),this.j=new y(a,n,this),this.g=this.B(new S.$Sh(()=>this.reloadConfiguration(),50)),this.B(this.b.onDidChangeConfiguration(({defaults:s,properties:o})=>this.s(s,o))),this.B(this.c.onDidChangeConfiguration(s=>this.t(s))),this.B(this.f.onDidChange(()=>this.g.schedule()))}async initialize(){const[a,n,r]=await Promise.all([this.b.initialize(),this.c.initialize(),this.f.loadConfiguration()]);this.a=new g.$Po(a,n,g.$Mo.createEmptyModel(this.n),r,g.$Mo.createEmptyModel(this.n),g.$Mo.createEmptyModel(this.n),new l.$Dc,g.$Mo.createEmptyModel(this.n),new l.$Dc,this.n)}getConfigurationData(){return this.a.toData()}getValue(a,n){const r=typeof a=="string"?a:void 0,i=(0,$.$bj)(a)?a:(0,$.$bj)(n)?n:{};return this.a.getValue(r,i,void 0)}async updateValue(a,n,r,i,s){const o=(0,$.$cj)(r)?r:(0,$.$bj)(r)?{resource:r.resource,overrideIdentifiers:r.overrideIdentifier?[r.overrideIdentifier]:void 0}:void 0,f=o?i:r;if(f!==void 0&&f!==$.ConfigurationTarget.USER_LOCAL&&f!==$.ConfigurationTarget.USER)throw new Error(`Unable to write ${a} to target ${f}.`);o?.overrideIdentifiers&&(o.overrideIdentifiers=(0,E.$Pb)(o.overrideIdentifiers),o.overrideIdentifiers=o.overrideIdentifiers.length?o.overrideIdentifiers:void 0);const b=this.inspect(a,{resource:o?.resource,overrideIdentifier:o?.overrideIdentifiers?o.overrideIdentifiers[0]:void 0});if(b.policyValue!==void 0)throw new Error(`Unable to write ${a} because it is configured in system policy.`);if((0,c.$io)(n,b.defaultValue)&&(n=void 0),o?.overrideIdentifiers?.length&&o.overrideIdentifiers.length>1){const T=o.overrideIdentifiers.sort(),D=this.a.localUserConfiguration.overrides.find(A=>(0,E.$xb)([...A.identifiers].sort(),T));D&&(o.overrideIdentifiers=D.identifiers)}const R=o?.overrideIdentifiers?.length?[(0,N.$Io)(o.overrideIdentifiers),a]:[a];await this.j.write(R,n),await this.reloadConfiguration()}inspect(a,n={}){return this.a.inspect(a,n,void 0)}keys(){return this.a.keys(void 0)}async reloadConfiguration(){const a=await this.f.loadConfiguration();this.r(a)}r(a){const n=this.a.toData(),r=this.a.compareAndUpdateLocalUserConfiguration(a);this.u(r,n,$.ConfigurationTarget.USER)}s(a,n){const r=this.a.toData(),i=this.a.compareAndUpdateDefaultConfiguration(a,n);this.u(i,r,$.ConfigurationTarget.DEFAULT)}t(a){const n=this.a.toData(),r=this.a.compareAndUpdatePolicyConfiguration(a);this.u(r,n,$.ConfigurationTarget.DEFAULT)}u(a,n,r){const i=new g.$Ro(a,{data:n},this.a,void 0,this.n);i.source=r,this.h.fire(i)}}t.$Vo=k;class y{constructor(a,n,r){this.b=a,this.c=n,this.d=r,this.a=new S.$Nh}write(a,n){return this.a.queue(()=>this.e(a,n))}async e(a,n){let r;try{r=(await this.c.readFile(this.b)).value.toString()}catch(o){if(o.fileOperationResult===d.FileOperationResult.FILE_NOT_FOUND)r="{}";else throw o}const i=[];if((0,L.$Yn)(r,i,{allowTrailingComma:!0,allowEmptyContent:!0}),i.length>0)throw new Error("Unable to write into the settings file. Please open the file to correct errors/warnings in the file and try again.");const s=this.f(r,a,n);r=(0,I.$do)(r,s),await this.c.writeFile(this.b,w.$Pe.fromString(r))}f(a,n,r){const{tabSize:i,insertSpaces:s,eol:o}=this.h;if(!n.length){const f=JSON.stringify(r,null,s?" ".repeat(i):"	");return[{content:f,length:f.length,offset:0}]}return(0,I.$ao)(a,n,r,{tabSize:i,insertSpaces:s,eol:o})}get h(){if(!this.g){let a=h.OS===h.OperatingSystem.Linux||h.OS===h.OperatingSystem.Macintosh?`
`:`\r
`;const n=this.d.getValue("files.eol",{overrideIdentifier:"jsonc"});n&&typeof n=="string"&&n!=="auto"&&(a=n),this.g={eol:a,insertSpaces:!!this.d.getValue("editor.insertSpaces",{overrideIdentifier:"jsonc"}),tabSize:this.d.getValue("editor.tabSize",{overrideIdentifier:"jsonc"})}}return this.g}}}),define(oe[67],ae([0,1,15]),function(H,t,E){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$hn=S,t.$in=w,t.$jn=O,t.$kn=L;function S(m){return m.scheme===E.Schemas.vscodeRemote?m.authority:void 0}function w(m){if(!m)return;const l=m.indexOf("+");return l<0?m:m.substr(0,l)}function O(m){const{host:l,port:c}=I(m);if(typeof c>"u")throw new Error(`Invalid remote authority: ${m}. It must either be a remote of form <remoteName>+<arg> or a remote host of form <host>:<port>.`);return{host:l,port:c}}function L(m,l){let{host:c,port:h}=I(m);return typeof h>"u"&&(h=l),{host:c,port:h}}function I(m){const l=m.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(l)return{host:l[1],port:parseInt(l[2],10)};const c=m.match(/^(\[[0-9a-z:]+\])$/);if(c)return{host:c[1],port:void 0};const h=m.match(/(.*):(\d+)$/);return h?{host:h[1],port:parseInt(h[2],10)}:{host:m,port:void 0}}}),define(oe[23],ae([0,1,32,11,67]),function(H,t,E,S,w){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$An=t.$tn=t.$sn=t.$rn=t.TargetPlatform=t.ExtensionType=t.$qn=t.$on=t.$nn=t.$mn=t.$ln=void 0,t.$pn=O,t.$un=h,t.$vn=u,t.$wn=$,t.$xn=g,t.$yn=N,t.$zn=v,E=be(E),t.$ln="extensions.user.cache",t.$mn="extensions.builtin.cache",t.$nn="undefined_publisher",t.$on=["ui","workspace","web"];function O(d){if(typeof d=="object"&&d!==null&&d.supported!==!0)return d.description}t.$qn=["AI","Azure","Chat","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var L;(function(d){d[d.System=0]="System",d[d.User=1]="User"})(L||(t.ExtensionType=L={}));var I;(function(d){d.WIN32_X64="win32-x64",d.WIN32_ARM64="win32-arm64",d.LINUX_X64="linux-x64",d.LINUX_ARM64="linux-arm64",d.LINUX_ARMHF="linux-armhf",d.ALPINE_X64="alpine-x64",d.ALPINE_ARM64="alpine-arm64",d.DARWIN_X64="darwin-x64",d.DARWIN_ARM64="darwin-arm64",d.WEB="web",d.UNIVERSAL="universal",d.UNKNOWN="unknown",d.UNDEFINED="undefined"})(I||(t.TargetPlatform=I={}));class m{constructor(p){this.value=p,this._lower=p.toLowerCase()}static equals(p,k){if(typeof p>"u"||p===null)return typeof k>"u"||k===null;if(typeof k>"u"||k===null)return!1;if(typeof p=="string"||typeof k=="string"){const y=typeof p=="string"?p:p.value,e=typeof k=="string"?k:k.value;return E.$Hf(y,e)}return p._lower===k._lower}static toKey(p){return typeof p=="string"?p.toLowerCase():p._lower}}t.$rn=m;class l{get size(){return this.c.size}constructor(p){if(this.c=new Set,p)for(const k of p)this.add(k)}add(p){this.c.add(m.toKey(p))}delete(p){return this.c.delete(m.toKey(p))}has(p){return this.c.has(m.toKey(p))}}t.$sn=l;class c{constructor(){this.c=new Map}clear(){this.c.clear()}delete(p){this.c.delete(m.toKey(p))}get(p){return this.c.get(m.toKey(p))}has(p){return this.c.has(m.toKey(p))}set(p,k){this.c.set(m.toKey(p),k)}values(){return this.c.values()}forEach(p){this.c.forEach(p)}[Symbol.iterator](){return this.c[Symbol.iterator]()}}t.$tn=c;function h(d){return u(d)}function u(d){return d.contributes&&d.contributes.localizations?d.contributes.localizations.length>0:!1}function $(d){return d.contributes&&d.contributes.authentication?d.contributes.authentication.length>0:!1}function g(d,p){if(p){const k=`onResolveRemoteAuthority:${(0,w.$in)(p)}`;return!!d.activationEvents?.includes(k)}return!1}function N(d){return d.map(p=>{const[k,y]=p.split("@");return{proposalName:k,version:y?parseInt(y):void 0}})}function v(d){return d.map(p=>p.split("@")[0])}t.$An=(0,S.$Gi)("IBuiltinExtensionsScannerService")}),define(oe[21],ae([0,1,13,99,23,11]),function(H,t,E,S,w,O){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$sp=t.$rp=t.$qp=t.$pp=t.$op=t.$np=t.$mp=t.$lp=t.ExtensionManagementErrorCode=t.$kp=t.ExtensionGalleryErrorCode=t.$jp=t.InstallOperation=t.StatisticType=t.SortOrder=t.SortBy=t.ExtensionInstallSource=t.$cp=t.$bp=t.$ap=t.$_o=t.$$o=t.$0o=t.$9o=void 0,t.$dp=I,t.$ep=m,t.$fp=l,t.$gp=c,t.$hp=h,t.$ip=u,t.$9o="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",t.$0o=new RegExp(t.$9o),t.$$o="__web_extension",t.$_o="skipWalkthrough",t.$ap="extensionInstallSource",t.$bp="dependecyOrPackExtensionInstall",t.$cp="clientTargetPlatform";var L;(function(e){e.COMMAND="command",e.SETTINGS_SYNC="settingsSync"})(L||(t.ExtensionInstallSource=L={}));function I(e){switch(e){case w.TargetPlatform.WIN32_X64:return"Windows 64 bit";case w.TargetPlatform.WIN32_ARM64:return"Windows ARM";case w.TargetPlatform.LINUX_X64:return"Linux 64 bit";case w.TargetPlatform.LINUX_ARM64:return"Linux ARM 64";case w.TargetPlatform.LINUX_ARMHF:return"Linux ARM";case w.TargetPlatform.ALPINE_X64:return"Alpine Linux 64 bit";case w.TargetPlatform.ALPINE_ARM64:return"Alpine ARM 64";case w.TargetPlatform.DARWIN_X64:return"Mac";case w.TargetPlatform.DARWIN_ARM64:return"Mac Silicon";case w.TargetPlatform.WEB:return"Web";case w.TargetPlatform.UNIVERSAL:return w.TargetPlatform.UNIVERSAL;case w.TargetPlatform.UNKNOWN:return w.TargetPlatform.UNKNOWN;case w.TargetPlatform.UNDEFINED:return w.TargetPlatform.UNDEFINED}}function m(e){switch(e){case w.TargetPlatform.WIN32_X64:return w.TargetPlatform.WIN32_X64;case w.TargetPlatform.WIN32_ARM64:return w.TargetPlatform.WIN32_ARM64;case w.TargetPlatform.LINUX_X64:return w.TargetPlatform.LINUX_X64;case w.TargetPlatform.LINUX_ARM64:return w.TargetPlatform.LINUX_ARM64;case w.TargetPlatform.LINUX_ARMHF:return w.TargetPlatform.LINUX_ARMHF;case w.TargetPlatform.ALPINE_X64:return w.TargetPlatform.ALPINE_X64;case w.TargetPlatform.ALPINE_ARM64:return w.TargetPlatform.ALPINE_ARM64;case w.TargetPlatform.DARWIN_X64:return w.TargetPlatform.DARWIN_X64;case w.TargetPlatform.DARWIN_ARM64:return w.TargetPlatform.DARWIN_ARM64;case w.TargetPlatform.WEB:return w.TargetPlatform.WEB;case w.TargetPlatform.UNIVERSAL:return w.TargetPlatform.UNIVERSAL;default:return w.TargetPlatform.UNKNOWN}}function l(e,a){switch(e){case E.Platform.Windows:return a==="x64"?w.TargetPlatform.WIN32_X64:a==="arm64"?w.TargetPlatform.WIN32_ARM64:w.TargetPlatform.UNKNOWN;case E.Platform.Linux:return a==="x64"?w.TargetPlatform.LINUX_X64:a==="arm64"?w.TargetPlatform.LINUX_ARM64:a==="arm"?w.TargetPlatform.LINUX_ARMHF:w.TargetPlatform.UNKNOWN;case"alpine":return a==="x64"?w.TargetPlatform.ALPINE_X64:a==="arm64"?w.TargetPlatform.ALPINE_ARM64:w.TargetPlatform.UNKNOWN;case E.Platform.Mac:return a==="x64"?w.TargetPlatform.DARWIN_X64:a==="arm64"?w.TargetPlatform.DARWIN_ARM64:w.TargetPlatform.UNKNOWN;case E.Platform.Web:return w.TargetPlatform.WEB}}function c(e,a){return a===w.TargetPlatform.WEB&&!e.includes(w.TargetPlatform.WEB)}function h(e,a,n){return c(a,n)?!1:e===w.TargetPlatform.UNDEFINED||e===w.TargetPlatform.UNIVERSAL?!0:e===w.TargetPlatform.UNKNOWN?!1:e===n}function u(e){return e&&typeof e=="object"&&typeof e.id=="string"&&(!e.uuid||typeof e.uuid=="string")}var $;(function(e){e[e.NoneOrRelevance=0]="NoneOrRelevance",e[e.LastUpdatedDate=1]="LastUpdatedDate",e[e.Title=2]="Title",e[e.PublisherName=3]="PublisherName",e[e.InstallCount=4]="InstallCount",e[e.PublishedDate=10]="PublishedDate",e[e.AverageRating=6]="AverageRating",e[e.WeightedRating=12]="WeightedRating"})($||(t.SortBy=$={}));var g;(function(e){e[e.Default=0]="Default",e[e.Ascending=1]="Ascending",e[e.Descending=2]="Descending"})(g||(t.SortOrder=g={}));var N;(function(e){e.Install="install",e.Uninstall="uninstall"})(N||(t.StatisticType=N={}));var v;(function(e){e[e.None=1]="None",e[e.Install=2]="Install",e[e.Update=3]="Update",e[e.Migrate=4]="Migrate"})(v||(t.InstallOperation=v={})),t.$jp=(0,O.$Gi)("extensionGalleryService");var d;(function(e){e.Timeout="Timeout",e.Cancelled="Cancelled",e.Failed="Failed",e.DownloadFailedWriting="DownloadFailedWriting"})(d||(t.ExtensionGalleryErrorCode=d={}));class p extends Error{constructor(a,n){super(a),this.code=n,this.name=n}}t.$kp=p;var k;(function(e){e.Unsupported="Unsupported",e.Deprecated="Deprecated",e.Malicious="Malicious",e.Incompatible="Incompatible",e.IncompatibleApi="IncompatibleApi",e.IncompatibleTargetPlatform="IncompatibleTargetPlatform",e.ReleaseVersionNotFound="ReleaseVersionNotFound",e.Invalid="Invalid",e.Download="Download",e.DownloadSignature="DownloadSignature",e.DownloadFailedWriting="DownloadFailedWriting",e.UpdateExistingMetadata="UpdateExistingMetadata",e.UpdateMetadata="UpdateMetadata",e.Extract="Extract",e.Scanning="Scanning",e.ScanningExtension="ScanningExtension",e.ReadUninstalled="ReadUninstalled",e.UnsetUninstalled="UnsetUninstalled",e.Delete="Delete",e.Rename="Rename",e.IntializeDefaultProfile="IntializeDefaultProfile",e.AddToProfile="AddToProfile",e.InstalledExtensionNotFound="InstalledExtensionNotFound",e.PostInstall="PostInstall",e.CorruptZip="CorruptZip",e.IncompleteZip="IncompleteZip",e.Signature="Signature",e.NotAllowed="NotAllowed",e.Gallery="Gallery",e.Cancelled="Cancelled",e.Unknown="Unknown",e.Internal="Internal"})(k||(t.ExtensionManagementErrorCode=k={}));class y extends Error{constructor(a,n){super(a),this.code=n,this.name=n}}t.$lp=y,t.$mp=(0,O.$Gi)("extensionManagementService"),t.$np="extensionsIdentifiers/disabled",t.$op="extensionsIdentifiers/enabled",t.$pp=(0,O.$Gi)("IGlobalExtensionEnablementService"),t.$qp=(0,O.$Gi)("IExtensionTipsService"),t.$rp=(0,S.localize2)(0,"Extensions"),t.$sp=(0,S.localize2)(1,"Preferences")}),define(oe[143],ae([0,1,2,23,10]),function(H,t,E,S,w){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Uq=void 0;class O extends E.$Xc{constructor(I,m,l,c,h){super(),this.a=I,this.b=m,this.c=l,this.f=h,this.B(c.onDidInstallExtensions(u=>this.g(u))),this.B(c.onDidUninstallExtension(u=>this.h(u)))}g(I){for(const m of I)m.local&&this.invalidate(m.profileLocation)}h(I){I.error||this.invalidate(I.profileLocation)}async invalidate(I){if(I)for(const m of this.a.profiles)this.c.extUri.isEqual(m.extensionsResource,I)&&await this.j(m);else await this.j(this.a.defaultProfile)}async j(I){try{await this.b.del(this.c.extUri.joinPath(I.cacheHome,S.$ln))}catch(m){(0,w.$rl)(m)!==w.FileOperationResult.FILE_NOT_FOUND&&this.f.error(m)}}}t.$Uq=O});var qe=this&&this.__importDefault||function(H){return H&&H.__esModule?H:{default:H}};define(oe[44],ae([0,1,17,56,105,45,23,122]),function(H,t,E,S,w,O,L,I){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Xp=c,t.$Yp=h,t.$Zp=u,t.$1p=$,t.$2p=g,t.$3p=N,t.$4p=v,t.$5p=d,S=qe(S),w=be(w),O=be(O);const m=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,l=/^-(\d{4})(\d{2})(\d{2})$/;function c(y){return y=y.trim(),y==="*"||m.test(y)}function h(y){if(!c(y))return null;if(y=y.trim(),y==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const e=y.match(m);return e?{hasCaret:e[1]==="^",hasGreaterEquals:e[1]===">=",majorBase:e[2]==="x"?0:parseInt(e[2],10),majorMustEqual:e[2]!=="x",minorBase:e[4]==="x"?0:parseInt(e[4],10),minorMustEqual:e[4]!=="x",patchBase:e[6]==="x"?0:parseInt(e[6],10),patchMustEqual:e[6]!=="x",preRelease:e[8]||null}:null}function u(y){if(!y)return null;const e=y.majorBase,a=y.majorMustEqual,n=y.minorBase;let r=y.minorMustEqual;const i=y.patchBase;let s=y.patchMustEqual;y.hasCaret&&(e===0||(r=!1),s=!1);let o=0;if(y.preRelease){const f=l.exec(y.preRelease);if(f){const[,b,R,T]=f;o=Date.UTC(Number(b),Number(R)-1,Number(T))}}return{majorBase:e,majorMustEqual:a,minorBase:n,minorMustEqual:r,patchBase:i,patchMustEqual:s,isMinimum:y.hasGreaterEquals,notBefore:o}}function $(y,e,a){let n;typeof y=="string"?n=u(h(y)):n=y;let r;e instanceof Date?r=e.getTime():typeof e=="string"&&(r=new Date(e).getTime());let i;if(typeof a=="string"?i=u(h(a)):i=a,!n||!i)return!1;const s=n.majorBase,o=n.minorBase,f=n.patchBase;let b=i.majorBase,R=i.minorBase,T=i.patchBase;const D=i.notBefore;let A=i.majorMustEqual,z=i.minorMustEqual,J=i.patchMustEqual;return i.isMinimum?s>b?!0:s<b?!1:o>R?!0:o<R||r&&r<D?!1:f>=T:(s===1&&b===0&&(!A||!z||!J)&&(b=1,R=0,T=0,A=!0,z=!1,J=!1),s<b?!1:s>b?!A:o<R?!1:o>R?!z:f<T?!1:f>T?!J:!(r&&r<D))}function g(y,e,a,n,r,i){const s=[];if(typeof n.publisher<"u"&&typeof n.publisher!="string")return s.push([S.default.Error,w.localize(0,null)]),s;if(typeof n.name!="string")return s.push([S.default.Error,w.localize(1,null,"name")]),s;if(typeof n.version!="string")return s.push([S.default.Error,w.localize(2,null,"version")]),s;if(!n.engines)return s.push([S.default.Error,w.localize(3,null,"engines")]),s;if(typeof n.engines.vscode!="string")return s.push([S.default.Error,w.localize(4,null,"engines.vscode")]),s;if(typeof n.extensionDependencies<"u"&&!k(n.extensionDependencies))return s.push([S.default.Error,w.localize(5,null,"extensionDependencies")]),s;if(typeof n.activationEvents<"u"){if(!k(n.activationEvents))return s.push([S.default.Error,w.localize(6,null,"activationEvents")]),s;if(typeof n.main>"u"&&typeof n.browser>"u")return s.push([S.default.Error,w.localize(7,null,"activationEvents","main","browser")]),s}if(typeof n.extensionKind<"u"&&typeof n.main>"u"&&s.push([S.default.Warning,w.localize(8,null,"extensionKind")]),typeof n.main<"u"){if(typeof n.main!="string")return s.push([S.default.Error,w.localize(9,null,"main")]),s;{const b=(0,E.$hh)(a,n.main);(0,E.$bh)(b,a)||s.push([S.default.Warning,w.localize(10,null,b.path,a.path)])}}if(typeof n.browser<"u"){if(typeof n.browser!="string")return s.push([S.default.Error,w.localize(11,null,"browser")]),s;{const b=(0,E.$hh)(a,n.browser);(0,E.$bh)(b,a)||s.push([S.default.Warning,w.localize(12,null,b.path,a.path)])}}if(!O.valid(n.version))return s.push([S.default.Error,w.localize(13,null)]),s;const o=[];if(!N(y,e,n,r,o))for(const b of o)s.push([S.default.Error,b]);if(i&&n.enabledApiProposals?.length){const b=[];if(!d([...n.enabledApiProposals],b))for(const R of b)s.push([S.default.Error,R])}return s}function N(y,e,a,n,r){return n||typeof a.main>"u"&&typeof a.browser>"u"?!0:p(y,e,a.engines.vscode,r)}function v(y,e,a){return y==="*"||p(e,a,y)}function d(y,e){if(y.length===0)return!0;const a=Array.isArray(e)?e:void 0,n=(a?void 0:e)??I.allApiProposals,r=[],i=(0,L.$yn)(y);for(const{proposalName:s,version:o}of i){const f=n[s];f&&o&&f.version!==o&&r.push(w.localize(14,null,s))}return a?.push(...r),r.length===0}function p(y,e,a,n=[]){const r=u(h(a));if(!r)return n.push(w.localize(15,null,a)),!1;if(r.majorBase===0){if(!r.majorMustEqual||!r.minorMustEqual)return n.push(w.localize(16,null,a)),!1}else if(!r.majorMustEqual)return n.push(w.localize(17,null,a)),!1;return $(y,e,r)?!0:(n.push(w.localize(18,null,y,a)),!1)}function k(y){if(!Array.isArray(y))return!1;for(let e=0,a=y.length;e<a;e++)if(typeof y[e]!="string")return!1;return!0}}),define(oe[68],ae([0,1,22,2,13,109,21,11]),function(H,t,E,S,w,O,L,I){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$$r=t.$0r=void 0,t.$9r=m;function m(c){return c.tags.find(h=>h.startsWith("lp-"))?.split("lp-")[1]}t.$0r=(0,I.$Gi)("languagePackService");let l=class extends S.$Xc{constructor(h){super(),this.c=h}async getAvailableLanguages(){const h=new E.$ye;setTimeout(()=>h.cancel(),1e3);let u;try{u=await this.c.query({text:'category:"language packs"',pageSize:20},h.token)}catch{return[]}const g=u.firstPage.filter(N=>N.properties.localizedLanguages?.length&&N.tags.some(v=>v.startsWith("lp-"))).map(N=>{const v=N.properties.localizedLanguages?.[0],d=m(N);return{...this.f(d,v,N),extensionId:N.identifier.id,galleryExtension:N}});return g.push(this.f("en","English")),g}f(h,u,$){const g=u??h;let N;if(g!==h&&(N=`(${h})`),h.toLowerCase()===w.$w.toLowerCase()&&(N??="",N+=(0,O.localize)(0,null)),$?.installCount){N??="";const v=$.installCount;let d;v>1e6?d=`${Math.floor(v/1e5)/10}M`:v>1e3?d=`${Math.floor(v/1e3)}K`:d=String(v),N+=` $(cloud-download) ${d}`}return{id:h,label:g,description:N}}};t.$$r=l,t.$$r=l=ye([re(0,L.$jp)],l)}),define(oe[46],ae([0,1,14,9,2,111,40,11,6,37]),function(H,t,E,S,w,O,L,I,m,l){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$7p=t.$6p=void 0,t.$8p=u,t.$9p=$,t.$0p=g,t.$$p=N,t.$_p=v,t.$aq=d,t.$6p=(0,I.$Gi)("requestService");class c{constructor(e){this.b=e}toJSON(){if(!this.a){const e=Object.create(null);for(const a in this.b)a.toLowerCase()==="authorization"||a.toLowerCase()==="proxy-authorization"?e[a]="*****":e[a]=this.b[a];this.a=e}return this.a}}class h extends w.$Xc{constructor(e){super(),this.b=0,this.a=e.createLogger("network",{name:(0,O.localize)(0,null),when:m.$sk.isEqualTo((0,m.$pk)(m.LogLevel.Trace)).serialize()})}async c(e,a,n){const r=`${e} #${++this.b}: ${a.url}`;this.a.trace(`${r} - begin`,a.type,new c(a.headers??{}));try{const i=await n();return this.a.trace(`${r} - end`,a.type,i.res.statusCode,i.res.headers),i}catch(i){throw this.a.error(`${r} - error`,a.type,(0,S.$ab)(i)),i}}}t.$7p=h;function u(y){return y.res.statusCode&&y.res.statusCode>=200&&y.res.statusCode<300||y.res.statusCode===1223}function $(y){return y.res.statusCode===204}async function g(y){return $(y)?null:(await(0,E.$2e)(y.stream)).toString()}async function N(y){if(!u(y))throw new Error("Server returned "+y.res.statusCode);return g(y)}async function v(y){if(!u(y))throw new Error("Server returned "+y.res.statusCode);if($(y))return null;const a=(await(0,E.$2e)(y.stream)).toString();try{return JSON.parse(a)}catch(n){throw n.message+=`:
`+a,n}}function d(y){k(y)}let p;function k(y){const e=l.$ro.as(L.$wo.Configuration),a=p;p={id:"http",order:15,title:(0,O.localize)(1,null),type:"object",scope:y,properties:{"http.proxy":{type:"string",pattern:"^(https?|socks|socks4a?|socks5h?)://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,O.localize)(2,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,O.localize)(3,null),restricted:!0},"http.proxyKerberosServicePrincipal":{type:"string",markdownDescription:(0,O.localize)(4,null),restricted:!0},"http.noProxy":{type:"array",items:{type:"string"},markdownDescription:(0,O.localize)(5,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,O.localize)(6,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,O.localize)(7,null),(0,O.localize)(8,null),(0,O.localize)(9,null),(0,O.localize)(10,null)],default:"override",description:(0,O.localize)(11,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,O.localize)(12,null),restricted:!0},"http.experimental.systemCertificatesV2":{type:"boolean",tags:["experimental"],default:!1,description:(0,O.localize)(13,null),restricted:!0}}},e.updateConfigurations({add:[p],remove:a?[a]:[]})}k(L.ConfigurationScope.APPLICATION)}),define(oe[144],ae([0,1,22,15,10,46]),function(H,t,E,S,w,O){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$DR=void 0;let L=class{constructor(m,l){this.a=m,this.b=l}async download(m,l,c=E.CancellationToken.None){if(m.scheme===S.Schemas.file||m.scheme===S.Schemas.vscodeRemote){await this.b.copy(m,l);return}const h={type:"GET",url:m.toString(!0)},u=await this.a.request(h,c);if(u.res.statusCode===200)await this.b.writeFile(l,u.stream);else{const $=await(0,O.$$p)(u);throw new Error(`Expected 200, got back ${u.res.statusCode} instead.

${$}`)}}};t.$DR=L,t.$DR=L=ye([re(0,O.$6p),re(1,w.$al)],L)}),define(oe[145],ae([0,1,146,3]),function(H,t,E,S){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$cs=O;function w(L,I){return L.protocol==="http:"?I.HTTP_PROXY||I.http_proxy||null:L.protocol==="https:"&&(I.HTTPS_PROXY||I.https_proxy||I.HTTP_PROXY||I.http_proxy)||null}async function O(L,I,m={}){const l=(0,E.parse)(L),c=m.proxyUrl||w(l,I);if(!c)return null;const h=(0,E.parse)(c);if(!/^https?:$/.test(h.protocol||""))return null;const u={host:h.hostname||"",port:(h.port?+h.port:0)||(h.protocol==="https"?443:80),auth:h.auth,rejectUnauthorized:(0,S.$mg)(m.strictSSL)?m.strictSSL:!0};return l.protocol==="http:"?new(await new Promise(($,g)=>{H(["http-proxy-agent"],$,g)}).then(be)).HttpProxyAgent(c,u):new(await new Promise(($,g)=>{H(["https-proxy-agent"],$,g)}).then(be)).HttpsProxyAgent(c,u)}}),define(oe[147],ae([0,1,60,16,112,22,38,9,13,29,90,177,8,78]),function(H,t,E,S,w,O,L,I,m,l,c,h,u,$){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Rm=N;let g;async function N(d,p,k,y){return k["force-disable-user-env"]?(p.trace("resolveShellEnv(): skipped (--force-disable-user-env)"),{}):m.$i?(p.trace("resolveShellEnv(): skipped (Windows)"),{}):(0,h.$Km)(y)&&!k["force-user-env"]?(p.trace("resolveShellEnv(): skipped (VSCODE_CLI is set)"),{}):((0,h.$Km)(y)?p.trace("resolveShellEnv(): running (--force-user-env)"):p.trace("resolveShellEnv(): running (macOS/Linux)"),g||(g=u.Promises.withAsyncBody(async(e,a)=>{const n=new O.$ye;let r=1e4;const i=d.getValue("application.shellEnvironmentResolutionTimeout");typeof i=="number"&&(r=(0,$.$Lm)(i,1,120)*1e3);const s=setTimeout(()=>{n.dispose(!0),a(new Error((0,w.localize)(0,null)))},r);try{e(await v(p,n.token))}catch(o){!(0,I.$7)(o)&&!n.token.isCancellationRequested?a(new Error((0,w.localize)(1,null,(0,L.$rj)(o)))):e({})}finally{clearTimeout(s),n.dispose()}})),g)}async function v(d,p){const k=process.env.ELECTRON_RUN_AS_NODE;d.trace("getUnixShellEnvironment#runAsNode",k);const y=process.env.ELECTRON_NO_ATTACH_CONSOLE;d.trace("getUnixShellEnvironment#noAttach",y);const e=(0,l.$3g)().replace(/-/g,"").substr(0,12),a=new RegExp(e+"({.*})"+e),n={...process.env,ELECTRON_RUN_AS_NODE:"1",ELECTRON_NO_ATTACH_CONSOLE:"1",VSCODE_RESOLVING_ENVIRONMENT:"1"};d.trace("getUnixShellEnvironment#env",n);const r=await(0,c.$Am)(m.OS,n);return d.trace("getUnixShellEnvironment#shell",r),new Promise((i,s)=>{if(p.isCancellationRequested)return s(new I.$8);const o=(0,S.$qc)(r);let f,b;const R="";/^pwsh(-preview)?$/.test(o)?(f=`& '${process.execPath}' ${R} -p '''${e}'' + JSON.stringify(process.env) + ''${e}'''`,b=["-Login","-Command"]):o==="nu"?(f=`^'${process.execPath}' ${R} -p '"${e}" + JSON.stringify(process.env) + "${e}"'`,b=["-i","-l","-c"]):o==="xonsh"?(f=`import os, json; print("${e}", json.dumps(dict(os.environ)), "${e}")`,b=["-i","-l","-c"]):(f=`'${process.execPath}' ${R} -p '"${e}" + JSON.stringify(process.env) + "${e}"'`,o==="tcsh"||o==="csh"?b=["-ic"]:b=["-i","-l","-c"]),d.trace("getUnixShellEnvironment#spawn",JSON.stringify(b),f);const T=(0,E.spawn)(r,[...b,f],{detached:!0,stdio:["ignore","pipe","pipe"],env:n});p.onCancellationRequested(()=>(T.kill(),s(new I.$8))),T.on("error",z=>{d.error("getUnixShellEnvironment#errorChildProcess",(0,L.$rj)(z)),s(z)});const D=[];T.stdout.on("data",z=>D.push(z));const A=[];T.stderr.on("data",z=>A.push(z)),T.on("close",(z,J)=>{const Q=Buffer.concat(D).toString("utf8");d.trace("getUnixShellEnvironment#raw",Q);const se=Buffer.concat(A).toString("utf8");if(se.trim()&&d.trace("getUnixShellEnvironment#stderr",se),z||J)return s(new Error((0,w.localize)(2,null,z,J)));const le=a.exec(Q),ue=le?le[1]:"{}";try{const fe=JSON.parse(ue);k?fe.ELECTRON_RUN_AS_NODE=k:delete fe.ELECTRON_RUN_AS_NODE,y?fe.ELECTRON_NO_ATTACH_CONSOLE=y:delete fe.ELECTRON_NO_ATTACH_CONSOLE,delete fe.VSCODE_RESOLVING_ENVIRONMENT,delete fe.XDG_RUNTIME_DIR,d.trace("getUnixShellEnvironment#result",fe),i(fe)}catch(fe){d.error("getUnixShellEnvironment#errorCaught",(0,L.$rj)(fe)),s(fe)}})})}}),define(oe[148],ae([0,1,11]),function(H,t,E){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$gR=t.$fR=void 0,t.$fR=(0,E.$Gi)("stateReadService"),t.$gR=(0,E.$Gi)("stateService")}),define(oe[69],ae([0,1,8,14,2,3,18,10,6]),function(H,t,E,S,w,O,L,I,m){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$jR=t.$iR=t.$hR=t.SaveStrategy=void 0;var l;(function($){$[$.IMMEDIATE=0]="IMMEDIATE",$[$.DELAYED=1]="DELAYED"})(l||(t.SaveStrategy=l={}));class c extends w.$Xc{constructor(g,N,v,d){super(),this.h=g,this.j=N,this.m=v,this.n=d,this.a=Object.create(null),this.b="",this.c=this.B(new E.$Eh(this.j===l.IMMEDIATE?0:100)),this.f=void 0,this.g=void 0}init(){return this.f||(this.f=this.r()),this.f}async r(){try{this.b=(await this.n.readFile(this.h)).value.toString(),this.a=JSON.parse(this.b)}catch(g){g.fileOperationResult!==I.FileOperationResult.FILE_NOT_FOUND&&this.m.error(g)}}getItem(g,N){const v=this.a[g];return(0,O.$pg)(v)?N:v}setItem(g,N){this.setItems([{key:g,data:N}])}setItems(g){let N=!1;for(const{key:v,data:d}of g)this.a[v]!==d&&((0,O.$pg)(d)?(0,O.$ng)(this.a[v])||(this.a[v]=void 0,N=!0):(this.a[v]=d,N=!0));N&&this.s()}removeItem(g){(0,O.$ng)(this.a[g])||(this.a[g]=void 0,this.s())}async s(){if(!this.g)return this.c.trigger(()=>this.t())}async t(){if(!this.f)return;await this.f;const g=JSON.stringify(this.a,null,4);if(g!==this.b)try{await this.n.writeFile(this.h,S.$Pe.fromString(g),{atomic:{postfix:".vsctmp"}}),this.b=g}catch(N){this.m.error(N)}}async close(){return this.g||(this.g=this.c.trigger(()=>this.t(),0)),this.g}}t.$hR=c;let h=class extends w.$Xc{constructor(g,N,v,d){super(),this.a=this.B(new c(N.stateResource,g,v,d))}async init(){await this.a.init()}getItem(g,N){return this.a.getItem(g,N)}};t.$iR=h,t.$iR=h=ye([re(1,L.$Ni),re(2,m.$ak),re(3,I.$al)],h);class u extends h{setItem(g,N){this.a.setItem(g,N)}setItems(g){this.a.setItems(g)}removeItem(g){this.a.removeItem(g)}close(){return this.a.close()}}t.$jR=u}),define(oe[70],ae([0,1,13,36,29]),function(H,t,E,S,w){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$tp=L,t.$up=I;function O(m){if(E.$u===E.Platform.Linux&&/^penguin(\.|$)/i.test(m))return"chromebook"}function L(m,l,c,h,u,$,g,N,v,d){const p=Object.create(null);p["common.machineId"]=$,p["common.sqmId"]=g,p["common.devDeviceId"]=N,p.sessionID=(0,w.$3g)()+Date.now(),p.commitHash=h,p.version=u,p["common.platformVersion"]=(m||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),p["common.platform"]=(0,E.$h)(E.$u),p["common.nodePlatform"]=S.$gc,p["common.nodeArch"]=c,p["common.product"]=d||"desktop",v&&(p["common.msftInternal"]=v);let k=0;const y=Date.now();Object.defineProperties(p,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-y,enumerable:!0},"common.sequence":{get:()=>k++,enumerable:!0}}),E.$l&&(p["common.snap"]="true");const e=O(l);return e&&(p["common.platformDetail"]=e),p}function I(m){const l=S.env.USERDNSDOMAIN;if(!l)return!1;const c=l.toLowerCase();return m.some(h=>c===h)}}),define(oe[19],ae([0,1,11]),function(H,t,E){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.TelemetryConfiguration=t.TelemetryLevel=t.$km=t.$jm=t.$im=t.$hm=t.$gm=t.$fm=t.$em=t.$dm=t.$cm=t.$bm=t.$am=t.$_l=void 0,t.$_l=(0,E.$Gi)("telemetryService"),t.$am=(0,E.$Gi)("customEndpointTelemetryService"),t.$bm="telemetry.currentSessionDate",t.$cm="telemetry.firstSessionDate",t.$dm="telemetry.lastSessionDate",t.$em="telemetry.machineId",t.$fm="telemetry.sqmId",t.$gm="telemetry.devDeviceId",t.$hm="telemetry",t.$im="telemetry.telemetryLevel",t.$jm="telemetry.enableCrashReporter",t.$km="telemetry.enableTelemetry";var S;(function(O){O[O.NONE=0]="NONE",O[O.CRASH=1]="CRASH",O[O.ERROR=2]="ERROR",O[O.USAGE=3]="USAGE"})(S||(t.TelemetryLevel=S={}));var w;(function(O){O.OFF="off",O.CRASH="crash",O.ERROR="error",O.ON="all"})(w||(t.TelemetryConfiguration=w={}))}),define(oe[71],ae([0,1,9,11,6,19]),function(H,t,E,S,w,O){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$tq=t.$sq=t.ExtensionSignatureVerificationCode=t.$rq=void 0,t.$rq=(0,S.$Gi)("IExtensionSignatureVerificationService");var L;(function(l){l.Success="Success",l.RequiredArgumentMissing="RequiredArgumentMissing",l.InvalidArgument="InvalidArgument",l.PackageIsUnreadable="PackageIsUnreadable",l.UnhandledException="UnhandledException",l.SignatureManifestIsMissing="SignatureManifestIsMissing",l.SignatureManifestIsUnreadable="SignatureManifestIsUnreadable",l.SignatureIsMissing="SignatureIsMissing",l.SignatureIsUnreadable="SignatureIsUnreadable",l.CertificateIsUnreadable="CertificateIsUnreadable",l.SignatureArchiveIsUnreadable="SignatureArchiveIsUnreadable",l.FileAlreadyExists="FileAlreadyExists",l.SignatureArchiveIsInvalidZip="SignatureArchiveIsInvalidZip",l.SignatureArchiveHasSameSignatureFile="SignatureArchiveHasSameSignatureFile",l.PackageIntegrityCheckFailed="PackageIntegrityCheckFailed",l.SignatureIsInvalid="SignatureIsInvalid",l.SignatureManifestIsInvalid="SignatureManifestIsInvalid",l.SignatureIntegrityCheckFailed="SignatureIntegrityCheckFailed",l.EntryIsMissing="EntryIsMissing",l.EntryIsTampered="EntryIsTampered",l.Untrusted="Untrusted",l.CertificateRevoked="CertificateRevoked",l.SignatureIsNotValid="SignatureIsNotValid",l.UnknownError="UnknownError",l.PackageIsInvalidZip="PackageIsInvalidZip",l.SignatureArchiveHasTooManyEntries="SignatureArchiveHasTooManyEntries"})(L||(t.ExtensionSignatureVerificationCode=L={}));class I extends Error{constructor(c){super(c),this.code=c}}t.$sq=I;let m=class{constructor(c,h){this.b=c,this.c=h}d(){return this.a||(this.a=new Promise((c,h)=>H(["@vscode/vsce-sign"],async u=>c(u),h))),this.a}async verify(c,h,u,$){let g;const N=c.identifier.id;try{g=await this.d()}catch(k){return this.b.error("Could not load vsce-sign module",(0,E.$ab)(k)),this.b.info(`Extension signature verification is not done: ${N}`),!1}const v=new Date().getTime();let d;try{this.b.trace(`Verifying extension signature for ${N}...`),d=await g.verify(h,u,this.b.getLevel()===w.LogLevel.Trace)}catch(k){d={code:L.UnknownError,didExecute:!1,output:(0,E.$ab)(k)}}const p=new Date().getTime()-v;if(this.b.info(`Extension signature verification result for ${N}: ${d.code}. Executed: ${d.didExecute}. Duration: ${p}ms.`),this.b.trace(`Extension signature verification output for ${N}:
${d.output}`),this.c.publicLog2("extensionsignature:verification",{extensionId:N,extensionVersion:c.version,code:d.code,internalCode:d.internalCode,duration:p,didExecute:d.didExecute,clientTargetPlatform:$}),d.code===L.Success)return!0;throw new I(d.code)}};t.$tq=m,t.$tq=m=ye([re(0,w.$ak),re(1,O.$_l)],m)}),define(oe[41],ae([0,1,28,3,67,70,19]),function(H,t,E,S,w,O,L){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Bp=t.$Ap=t.$zp=t.$yp=t.$xp=t.$wp=t.$vp=void 0,t.$Cp=c,t.$Dp=h,t.$Ep=u,t.$Fp=$,t.$Gp=N,t.$Hp=d,t.$Ip=p,t.$Jp=e;class I{constructor(n){this.value=n,this.isTrustedTelemetryValue=!0}}t.$vp=I;class m{constructor(){this.telemetryLevel=L.TelemetryLevel.NONE,this.sessionId="someValue.sessionId",this.machineId="someValue.machineId",this.sqmId="someValue.sqmId",this.devDeviceId="someValue.devDeviceId",this.firstSessionDate="someValue.firstSessionDate",this.sendErrorTelemetry=!1}publicLog(){}publicLog2(){}publicLogError(){}publicLogError2(){}setExperimentProperty(){}}t.$wp=m,t.$xp=new m;class l{async publicLog(n,r,i){}async publicLogError(n,r,i){}}t.$yp=l,t.$zp="telemetry",t.$Ap="extensionTelemetryLog",t.$Bp={log:()=>null,flush:()=>Promise.resolve(null)};function c(a,n){return!n.isBuilt&&!n.disableTelemetry?!0:!(n.disableTelemetry||!a.enableTelemetry)}function h(a,n){return n.extensionTestsLocationURI?!0:!(n.isBuilt||n.disableTelemetry||a.enableTelemetry&&a.aiConfig?.ariaKey)}function u(a){const n=a.getValue(L.$im),r=a.getValue(L.$jm);if(a.getValue(L.$km)===!1||r===!1)return L.TelemetryLevel.NONE;switch(n??L.TelemetryConfiguration.ON){case L.TelemetryConfiguration.ON:return L.TelemetryLevel.USAGE;case L.TelemetryConfiguration.ERROR:return L.TelemetryLevel.ERROR;case L.TelemetryConfiguration.CRASH:return L.TelemetryLevel.CRASH;case L.TelemetryConfiguration.OFF:return L.TelemetryLevel.NONE}}function $(a){const n={},r={},i={};v(a,i);for(let s in i){s=s.length>150?s.substr(s.length-149):s;const o=i[s];typeof o=="number"?r[s]=o:typeof o=="boolean"?r[s]=o?1:0:typeof o=="string"?(o.length>8192&&console.warn(`Telemetry property: ${s} has been trimmed to 8192, the original length is ${o.length}`),n[s]=o.substring(0,8191)):typeof o<"u"&&o!==null&&(n[s]=o)}return{properties:n,measurements:r}}const g=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces","amlext"]);function N(a){if(!a)return"none";const n=(0,w.$in)(a);return g.has(n)?n:"other"}function v(a,n,r=0,i){if(a)for(const s of Object.getOwnPropertyNames(a)){const o=a[s],f=i?i+s:s;Array.isArray(o)?n[f]=(0,E.$jo)(o):o instanceof Date?n[f]=o.toISOString():(0,S.$ig)(o)?r<2?v(o,n,r+1,f+"."):n[f]=(0,E.$jo)(o):n[f]=o}}function d(a,n){const r=a.msftInternalDomains||[],i=n.getValue("telemetry.internalTesting");return(0,O.$up)(r)||i}function p(a){return[a.appRoot,a.extensionsPath,a.userHome.fsPath,a.tmpDir.fsPath,a.userDataPath]}function k(a,n){if(!a||!a.includes("/")&&!a.includes("\\"))return a;let r=a;const i=[];for(const b of n)for(;;){const R=b.exec(a);if(!R)break;i.push([R.index,b.lastIndex])}const s=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,o=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let f=0;for(r="";;){const b=o.exec(a);if(!b)break;const R=i.some(([T,D])=>b.index<D&&T<o.lastIndex);!s.test(b[0])&&!R&&(r+=a.substring(f,b.index)+"<REDACTED: user-file-path>",f=o.lastIndex)}return f<a.length&&(r+=a.substr(f)),r}function y(a){if(!a)return a;const n=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"GitHub Token",regex:/(gh[psuro]_[a-zA-Z0-9]{36}|github_pat_[a-zA-Z0-9]{22}_[a-zA-Z0-9]{59})/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/i},{label:"CLI Credentials",regex:/((login|psexec|(certutil|psexec)\.exe).{1,50}(\s-u(ser(name)?)?\s+.{3,100})?\s-(admin|user|vm|root)?p(ass(word)?)?\s+["']?[^$\-\/\s]|(^|[\s\r\n\\])net(\.exe)?.{1,5}(user\s+|share\s+\/user:| user -? secrets ? set) \s + [^ $\s \/])/},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const r of n)if(r.regex.test(a))return`<REDACTED: ${r.label}>`;return a}function e(a,n){return(0,E.$go)(a,r=>{if(r instanceof I||Object.hasOwnProperty.call(r,"isTrustedTelemetryValue"))return r.value;if(typeof r=="string"){let i=r.replaceAll("%20"," ");i=k(i,n);for(const s of n)i=i.replace(s,"");return i=y(i),i}})}}),define(oe[27],ae([0,1,32,21,23,13,12,9,36,41]),function(H,t,E,S,w,O,L,I,m,l){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Tp=t.$Lp=void 0,t.$Kp=c,t.$Mp=g,t.$Np=N,t.$Op=v,t.$Pp=d,t.$Qp=p,t.$Rp=k,t.$Sp=y,t.$Up=e,t.$Vp=n;function c(r,i){return r.uuid&&i.uuid?r.uuid===i.uuid:r.id===i.id?!0:(0,E.$Cf)(r.id,i.id)===0}const h=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class u{static create(i){const s=i.manifest?i.manifest.version:i.version,o=i.manifest?i.targetPlatform:i.properties.targetPlatform;return new u(i.identifier,s,o)}static parse(i){const s=h.exec(i);return s&&s[1]&&s[2]?new u({id:s[1]},s[2],s[4]||void 0):null}constructor(i,s,o=w.TargetPlatform.UNDEFINED){this.identifier=i,this.version=s,this.targetPlatform=o,this.id=i.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!==w.TargetPlatform.UNDEFINED?`-${this.targetPlatform}`:""}`}equals(i){return i instanceof u?c(this,i)&&this.version===i.version&&this.targetPlatform===i.targetPlatform:!1}}t.$Lp=u;const $=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function g(r){const i=$.exec(r);return i&&i[1]?[v(i[1]),i[2]]:[v(r),void 0]}function N(r,i){return`${r}.${i}`}function v(r){return r.toLowerCase()}function d(r,i){return v(N(r??w.$nn,i))}function p(r,i){const s=[],o=f=>{for(const b of s)if(b.some(R=>c(i(R),i(f))))return b;return null};for(const f of r){const b=o(f);b?b.push(f):s.push([f])}return s}function k(r){return{id:r.identifier.id,name:r.manifest.name,galleryId:null,publisherId:r.publisherId,publisherName:r.manifest.publisher,publisherDisplayName:r.publisherDisplayName,dependencies:r.manifest.extensionDependencies&&r.manifest.extensionDependencies.length>0}}function y(r){return{id:new l.$vp(r.identifier.id),name:new l.$vp(r.name),version:r.version,galleryId:r.identifier.uuid,publisherId:r.publisherId,publisherName:r.publisher,publisherDisplayName:r.publisherDisplayName,isPreReleaseVersion:r.properties.isPreReleaseVersion,dependencies:!!(r.properties.dependencies&&r.properties.dependencies.length>0),isSigned:r.isSigned,...r.telemetryData}}t.$Tp=new w.$rn("pprice.better-merge");function e(r,i){const s=[],o=i.manifest.extensionDependencies?.slice(0)??[];for(;o.length;){const f=o.shift();if(f&&s.every(b=>!c(b.identifier,{id:f}))){const b=r.filter(R=>c(R.identifier,{id:f}));b.length===1&&(s.push(b[0]),o.push(...b[0].manifest.extensionDependencies?.slice(0)??[]))}}return s}async function a(r,i){if(!O.$k)return!1;let s;try{s=(await r.readFile(L.URI.file("/etc/os-release"))).value.toString()}catch{try{s=(await r.readFile(L.URI.file("/usr/lib/os-release"))).value.toString()}catch(f){i.debug("Error while getting the os-release file.",(0,I.$ab)(f))}}return!!s&&(s.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async function n(r,i){const s=await a(r,i),o=(0,S.$fp)(s?"alpine":O.$u,m.$hc);return i.debug("ComputeTargetPlatform:",o),o}}),define(oe[149],ae([0,1,22,9,15,17,45,12,100,21,27,23]),function(H,t,E,S,w,O,L,I,m,l,c,h){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$uq=void 0;const u=N=>(0,m.localize)(0,null,N),$=(0,m.localize)(1,null,"ms-dotnettools.csharp");let g=class{constructor(v,d,p){this.a=v,this.b=d,this.d=p}get f(){}async listExtensions(v,d,p){let k=await this.b.getInstalled(h.ExtensionType.User,p);const y=h.$qn.map(a=>a.toLowerCase());if(d&&d!==""){if(y.indexOf(d.toLowerCase())<0){this.a.info("Invalid category please enter a valid category. To list valid categories run --category without a category specified");return}k=k.filter(a=>a.manifest.categories?a.manifest.categories.map(r=>r.toLowerCase()).indexOf(d.toLowerCase())>-1:!1)}else if(d===""){this.a.info("Possible Categories: "),y.forEach(a=>{this.a.info(a)});return}this.f&&this.a.info((0,m.localize)(2,null,this.f)),k=k.sort((a,n)=>a.identifier.id.localeCompare(n.identifier.id));let e;for(const a of k)e!==a.identifier.id&&(e=a.identifier.id,this.a.info(v?`${e}@${a.manifest.version}`:e))}async installExtensions(v,d,p,k){const y=[];try{v.length&&this.a.info(this.f?(0,m.localize)(3,null,this.f):(0,m.localize)(4,null));const e=[],a=[],n=(i,s,o)=>{a.push({id:i,version:s!=="prerelease"?s:void 0,installOptions:{...p,isBuiltin:o,installPreReleaseVersion:s==="prerelease"||p.installPreReleaseVersion}})};for(const i of v)if(i instanceof I.URI)e.push({vsix:i,installOptions:p});else{const[s,o]=(0,c.$Mp)(i);n(s,o,!1)}for(const i of d)if(i instanceof I.URI)e.push({vsix:i,installOptions:{...p,isBuiltin:!0,donotIncludePackAndDependencies:!0}});else{const[s,o]=(0,c.$Mp)(i);n(s,o,!0)}const r=await this.b.getInstalled(void 0,p.profileLocation);if(e.length&&await Promise.all(e.map(async({vsix:i,installOptions:s})=>{try{await this.h(i,s,k,r)}catch(o){this.a.error(o),y.push(i.toString())}})),a.length){const i=await this.g(a,r,k);y.push(...i)}}catch(e){throw this.a.error((0,m.localize)(5,null,(0,S.$ab)(e))),e}if(y.length)throw new Error((0,m.localize)(6,null,y.join(", ")))}async updateExtensions(v){const d=await this.b.getInstalled(h.ExtensionType.User,v),p=[];for(const a of d)a.identifier.uuid&&p.push({...a.identifier,preRelease:a.preRelease});this.a.trace((0,m.localize)(7,null,p.length));const k=await this.d.getExtensions(p,{compatible:!0},E.CancellationToken.None),y=[];for(const a of k)for(const n of d)(0,c.$Kp)(n.identifier,a.identifier)&&(0,L.gt)(a.version,n.manifest.version)&&y.push({extension:a,options:{operation:l.InstallOperation.Update,installPreReleaseVersion:n.preRelease,profileLocation:v,isApplicationScoped:n.isApplicationScoped}});if(!y.length){this.a.info((0,m.localize)(8,null));return}this.a.info((0,m.localize)(9,null,y.map(a=>a.extension.identifier.id).join(", ")));const e=await this.b.installGalleryExtensions(y);for(const a of e)a.error?this.a.error((0,m.localize)(10,null,a.identifier.id,(0,S.$ab)(a.error))):this.a.info((0,m.localize)(11,null,a.identifier.id,a.local?.manifest.version))}async g(v,d,p){if(v=v.filter(({id:a,version:n})=>{const r=d.find(i=>(0,c.$Kp)(i.identifier,{id:a}));if(r){if(!p&&(!n||n==="prerelease"&&r.preRelease))return this.a.info((0,m.localize)(12,null,a,r.manifest.version,a)),!1;if(n&&r.manifest.version===n)return this.a.info((0,m.localize)(13,null,`${a}@${n}`)),!1}return!0}),!v.length)return[];const k=[],y=[],e=await this.j(v);if(await Promise.all(v.map(async({id:a,version:n,installOptions:r})=>{const i=e.get(a.toLowerCase());if(!i){this.a.error(`${u(n?`${a}@${n}`:a)}
${$}`),k.push(a);return}try{const o=await this.d.getManifest(i,E.CancellationToken.None);if(o&&!this.k(o))return}catch(o){this.a.error(o.message||o.stack||o),k.push(a);return}const s=d.find(o=>(0,c.$Kp)(o.identifier,i.identifier));if(s){if(i.version===s.manifest.version){this.a.info((0,m.localize)(14,null,n?`${a}@${n}`:a));return}this.a.info((0,m.localize)(15,null,a,i.version))}r.isBuiltin?this.a.info(n?(0,m.localize)(16,null,a,n):(0,m.localize)(17,null,a)):this.a.info(n?(0,m.localize)(18,null,a,n):(0,m.localize)(19,null,a)),y.push({extension:i,options:{...r,installGivenVersion:!!n,isApplicationScoped:r.isApplicationScoped||s?.isApplicationScoped}})})),y.length){const a=await this.b.installGalleryExtensions(y);for(const n of a)n.error?(this.a.error((0,m.localize)(20,null,n.identifier.id,(0,S.$ab)(n.error))),k.push(n.identifier.id)):this.a.info((0,m.localize)(21,null,n.identifier.id,n.local?.manifest.version))}return k}async h(v,d,p,k){const y=await this.b.getManifest(v);if(!y)throw new Error("Invalid vsix");if(await this.l(y,p,d.profileLocation,k))try{await this.b.install(v,d),this.a.info((0,m.localize)(22,null,(0,O.$eh)(v)))}catch(a){if((0,S.$7)(a))this.a.info((0,m.localize)(23,null,(0,O.$eh)(v)));else throw a}}async j(v){const d=new Map,p=v.some(e=>e.installOptions.installPreReleaseVersion),k=await this.b.getTargetPlatform(),y=[];for(const e of v)l.$0o.test(e.id)&&y.push({...e,preRelease:p});if(y.length){const e=await this.d.getExtensions(y,{targetPlatform:k},E.CancellationToken.None);for(const a of e)d.set(a.identifier.id.toLowerCase(),a)}return d}k(v){return!0}async l(v,d,p,k){if(!d){const y={id:(0,c.$Pp)(v.publisher,v.name)},e=k.find(a=>(0,c.$Kp)(y,a.identifier)&&(0,L.gt)(a.manifest.version,v.version));if(e)return this.a.info((0,m.localize)(24,null,e.identifier.id,e.manifest.version,v.version)),!1}return this.k(v)}async uninstallExtensions(v,d,p){const k=async e=>{if(e instanceof I.URI){const a=await this.b.getManifest(e);return(0,c.$Np)(a.publisher,a.name)}return e},y=[];for(const e of v){const a=await k(e),r=(await this.b.getInstalled(void 0,p)).filter(i=>(0,c.$Kp)(i.identifier,{id:a}));if(!r.length)throw new Error(`${this.m(a)}
${$}`);if(r.some(i=>i.type===h.ExtensionType.System)){this.a.info((0,m.localize)(25,null,a));return}if(!d&&r.some(i=>i.isBuiltin)){this.a.info((0,m.localize)(26,null,a));return}this.a.info((0,m.localize)(27,null,a));for(const i of r)await this.b.uninstall(i,{profileLocation:p}),y.push(i);this.f?this.a.info((0,m.localize)(28,null,a,this.f)):this.a.info((0,m.localize)(29,null,a))}}async locateExtension(v){const d=await this.b.getInstalled();v.forEach(p=>{d.forEach(k=>{if(k.identifier.id===p&&k.location.scheme===w.Schemas.file){this.a.info(k.location.fsPath);return}})})}m(v){return this.f?(0,m.localize)(30,null,v,this.f):(0,m.localize)(31,null,v)}};t.$uq=g,t.$uq=g=ye([re(1,l.$mp),re(2,l.$jp)],g)}),define(oe[150],ae([0,1,5,2,31,27,23,10]),function(H,t,E,S,w,O,L,I){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Vq=void 0;class m extends S.$Xc{constructor(c,h,u,$,g,N,v){super(),this.f=c,this.g=h,this.h=u,this.j=$,this.m=g,this.n=N,this.r=v,this.a=this.B(new E.$ne),this.onDidChangeExtensionsByAnotherSource=this.a.event,this.b=new Map,this.c=this.B(new S.$7c),this.s().then(null,d=>v.error(d))}async s(){await this.g.initializeDefaultProfileExtensions(),await this.u(this.h.profiles),this.t(),await this.H()}t(){this.B(this.h.onDidChangeProfiles(c=>this.u(c.added))),this.B(this.j.onAddExtensions(c=>this.w(c))),this.B(this.j.onDidAddExtensions(c=>this.y(c))),this.B(this.j.onRemoveExtensions(c=>this.z(c))),this.B(this.j.onDidRemoveExtensions(c=>this.C(c))),this.B(this.n.onDidFilesChange(c=>this.D(c)))}async u(c){try{c.length&&await Promise.all(c.map(h=>(this.c.set(h.id,(0,S.$Uc)(this.n.watch(this.m.extUri.dirname(h.extensionsResource)),this.n.watch(h.extensionsResource))),this.G(h.extensionsResource))))}catch(h){throw this.r.error(h),h}}async w(c){for(const h of c.extensions)this.I(this.L(h.identifier,h.version),c.profileLocation)}async y(c){for(const h of c.extensions){const u=this.L(h.identifier,h.version);c.error?this.J(u,c.profileLocation):this.I(u,c.profileLocation)}}async z(c){for(const h of c.extensions)this.J(this.L(h.identifier,h.version),c.profileLocation)}async C(c){const h=[],u=[];for(const $ of c.extensions){const g=this.L($.identifier,$.version);c.error?this.I(g,c.profileLocation):(this.J(g,c.profileLocation),this.b.has(g)||(this.r.debug("Extension is removed from all profiles",$.identifier.id,$.version),u.push(this.f.scanInstalledExtensionAtLocation($.location).then(N=>{N?h.push(N):this.r.info("Extension not found at the location",$.location.toString())},N=>this.r.error(N)))))}try{await Promise.all(u),h.length&&await this.H(h)}catch($){this.r.error($)}}D(c){for(const h of this.h.profiles)c.contains(h.extensionsResource,I.FileChangeType.UPDATED,I.FileChangeType.ADDED)&&this.F(h.extensionsResource)}async F(c){const h=[],u=[],$=await this.j.scanProfileExtensions(c),g=new Set,N=new Set;for(const[v,d]of this.b)d.has(c)&&N.add(v);for(const v of $){const d=this.L(v.identifier,v.version);g.add(d),N.has(d)||(h.push(v.identifier),this.I(d,c))}for(const v of N)if(!g.has(v)){const d=this.M(v);d&&(u.push(d.identifier),this.J(v,c))}(h.length||u.length)&&this.a.fire({added:h.length?{extensions:h,profileLocation:c}:void 0,removed:u.length?{extensions:u,profileLocation:c}:void 0})}async G(c){const h=await this.j.scanProfileExtensions(c);for(const u of h)this.I(this.L(u.identifier,u.version),c)}async H(c){c||(c=(await this.f.scanAllUserInstalledExtensions()).filter(u=>!this.b.has(this.L(u.identifier,u.manifest.version)))),c.length&&await this.f.markAsUninstalled(...c)}I(c,h){let u=this.b.get(c);u||this.b.set(c,u=new w.$Ec($=>this.m.extUri.getComparisonKey($))),u.add(h)}J(c,h){const u=this.b.get(c);u&&u.delete(h),u?.size||this.b.delete(c)}L(c,h){return`${L.$rn.toKey(c.id)}@${h}`}M(c){const[h,u]=(0,O.$Mp)(c);return u?{identifier:{id:h},version:u}:void 0}}t.$Vq=m}),define(oe[151],ae([0,1,178,20,8,2,15,16,26,18,21,27,6,68,12]),function(H,t,E,S,w,O,L,I,m,l,c,h,u,$,g){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$_r=void 0;let N=class extends $.$$r{constructor(k,y,e,a){super(e),this.h=k,this.j=a,this.g=this.B(new v(y,a)),this.h.registerParticipant({postInstall:async n=>this.m(n),postUninstall:async n=>this.n(n)})}async getBuiltInExtensionTranslationsUri(k,y){const a=(await this.g.getLanguagePacks())[y];if(!a){this.j.warn(`No language pack found for ${y}`);return}const n=a.translations[k];return n?g.URI.file(n):void 0}async getInstalledLanguages(){const k=await this.g.getLanguagePacks(),y=Object.keys(k).map(e=>{const a=k[e];return{...this.f(e,a.label),extensionId:a.extensions[0].extensionIdentifier.id}});return y.push(this.f("en","English")),y.sort((e,a)=>e.label.localeCompare(a.label)),y}async m(k){k&&k.manifest&&k.manifest.contributes&&k.manifest.contributes.localizations&&k.manifest.contributes.localizations.length&&(this.j.info("Adding language packs from the extension",k.identifier.id),await this.update())}async n(k){const y=await this.g.getLanguagePacks();Object.keys(y).some(e=>y[e]&&y[e].extensions.some(a=>(0,h.$Kp)(a.extensionIdentifier,k.identifier)))&&(this.j.info("Removing language packs from the extension",k.identifier.id),await this.update())}async update(){const[k,y]=await Promise.all([this.g.getLanguagePacks(),this.h.getInstalled()]),e=await this.g.update(y);return!(0,S.$xb)(Object.keys(k),Object.keys(e))}};t.$_r=N,t.$_r=N=ye([re(0,c.$mp),re(1,l.$Oi),re(2,c.$jp),re(3,u.$ak)],N);let v=class extends O.$Xc{constructor(k,y){super(),this.j=y,this.c={},this.f=(0,I.$mc)(k.userDataPath,"languagepacks.json"),this.g=new w.$Nh}getLanguagePacks(){return this.g.size||!this.h?this.s().then(()=>this.c):Promise.resolve(this.c)}update(k){return this.s(y=>{Object.keys(y).forEach(e=>delete y[e]),this.m(y,...k)}).then(()=>this.c)}m(k,...y){for(const e of y)e&&e.manifest&&e.manifest.contributes&&e.manifest.contributes.localizations&&e.manifest.contributes.localizations.length&&this.n(k,e);Object.keys(k).forEach(e=>this.r(k[e]))}n(k,y){const e=y.identifier,a=y.manifest.contributes&&y.manifest.contributes.localizations?y.manifest.contributes.localizations:[];for(const n of a)if(y.location.scheme===L.Schemas.file&&d(n)){let r=k[n.languageId];r||(r={hash:"",extensions:[],translations:{},label:n.localizedLanguageName??n.languageName},k[n.languageId]=r);const i=r.extensions.filter(s=>(0,h.$Kp)(s.extensionIdentifier,e))[0];i?i.version=y.manifest.version:r.extensions.push({extensionIdentifier:e,version:y.manifest.version});for(const s of n.translations)r.translations[s.id]=(0,I.$mc)(y.location.fsPath,s.path)}}r(k){if(k){const y=(0,E.createHash)("md5");for(const e of k.extensions)y.update(e.extensionIdentifier.uuid||e.extensionIdentifier.id).update(e.version);k.hash=y.digest("hex")}}s(k=()=>null){return this.g.queue(()=>{let y=null;return m.Promises.readFile(this.f,"utf8").then(void 0,e=>e.code==="ENOENT"?Promise.resolve("{}"):Promise.reject(e)).then(e=>{try{return JSON.parse(e)}catch{return{}}}).then(e=>(y=k(e),e)).then(e=>{for(const n of Object.keys(e))e[n]||delete e[n];this.c=e,this.h=!0;const a=JSON.stringify(this.c);return this.j.debug("Writing language packs",a),m.Promises.writeFile(this.f,a)}).then(()=>y,e=>this.j.error(e))})}};v=ye([re(0,l.$Oi),re(1,u.$ak)],v);function d(p){if(typeof p.languageId!="string"||!Array.isArray(p.translations)||p.translations.length===0)return!1;for(const k of p.translations)if(typeof k.id!="string"||typeof k.path!="string")return!1;return!(p.languageName&&typeof p.languageName!="string"||p.localizedLanguageName&&typeof p.localizedLanguageName!="string")}}),define(oe[152],ae([0,1,87,9,28,41]),function(H,t,E,S,w,O){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$bR=void 0;const L="https://0.0.0.0/OneCollector/1.0",I="https://0.0.0.0/ping";async function m(c,h,u){const $=await(0,E.$sE)("@microsoft/1ds-core-js","dist/ms.core.js"),g=await(0,E.$sE)("@microsoft/1ds-post-js","dist/ms.post.js"),N=new $.AppInsightsCore,v=new g.PostChannel,d={instrumentationKey:c,endpointUrl:L,loggingLevelTelemetry:0,loggingLevelConsole:0,disableCookiesUsage:!0,disableDbgExt:!0,disableInstrumentationKeyValidation:!0,channels:[[v]]};if(u){d.extensionConfig={};const p={alwaysUseXhrOverride:!0,ignoreMc1Ms0CookieProcessing:!0,httpXHROverride:u};d.extensionConfig[v.identifier]=p}return N.initialize(d,[]),N.addTelemetryInitializer(p=>{p.ext=p.ext??{},p.ext.web=p.ext.web??{},p.ext.web.consentDetails='{"GPC_DataSharingOptIn":false}',h&&(p.ext.utc=p.ext.utc??{},p.ext.utc.flags=8462029)}),N}class l{constructor(h,u,$,g,N){this.e=h,this.f=u,this.g=$,this.h=N,this.c=L,this.d=I,this.g||(this.g={}),typeof g=="function"?this.a=g():this.a=g,this.b=null}i(h){if(this.a){if(typeof this.a!="string"){h(this.a);return}this.b||(this.b=m(this.a,this.e,this.h)),this.b.then(u=>{h(u)},u=>{(0,S.$3)(u),console.error(u)})}}log(h,u){if(!this.a)return;u=(0,w.$ho)(u,this.g),u=(0,O.$Fp)(u);const $=this.f+"/"+h;try{this.i(g=>{g.pluginVersionString=u?.properties.version??"Unknown",g.track({name:$,baseData:{name:$,properties:u?.properties,measurements:u?.measurements}})})}catch{}}flush(){return this.a?new Promise(h=>{this.i(u=>{u.unload(!0,()=>{this.a=void 0,h(void 0)})})}):Promise.resolve(void 0)}}t.$bR=l});var qe=this&&this.__importDefault||function(H){return H&&H.__esModule?H:{default:H}};define(oe[153],ae([0,1,2,28,13,32,113,30,40,154,33,37,19,41]),function(H,t,E,S,w,O,L,I,m,l,c,h,u,$){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$fs=void 0,l=qe(l);let g=class{static{this.IDLE_START_EVENT_NAME="UserIdleStart"}static{this.IDLE_STOP_EVENT_NAME="UserIdleStop"}constructor(d,p,k){this.k=p,this.l=k,this.d={},this.i=new E.$Wc,this.j=[],this.b=d.appenders,this.c=d.commonProperties??Object.create(null),this.sessionId=this.c.sessionID,this.machineId=this.c["common.machineId"],this.sqmId=this.c["common.sqmId"],this.devDeviceId=this.c["common.devDeviceId"],this.firstSessionDate=this.c["common.firstSessionDate"],this.msftInternal=this.c["common.msftInternal"],this.f=d.piiPaths||[],this.g=u.TelemetryLevel.USAGE,this.h=!!d.sendErrorTelemetry,this.j=[/(vscode-)?file:\/\/\/.*?\/resources\/app\//gi];for(const y of this.f)this.j.push(new RegExp((0,O.$jf)(y),"gi")),y.indexOf("\\")>=0&&this.j.push(new RegExp((0,O.$jf)(y.replace(/\\/g,"/")),"gi"));this.m(),this.i.add(this.k.onDidChangeConfiguration(y=>{(y.affectsConfiguration(u.$im)||y.affectsConfiguration(u.$km)||y.affectsConfiguration(u.$jm))&&this.m()}))}setExperimentProperty(d,p){this.d[d]=p}m(){let d=(0,$.$Ep)(this.k);const p=this.l.enabledTelemetryLevels;if(p){this.h=this.sendErrorTelemetry?p.error:!1;const k=p.usage?u.TelemetryLevel.USAGE:p.error?u.TelemetryLevel.ERROR:u.TelemetryLevel.NONE;d=Math.min(d,k)}this.g=d}get sendErrorTelemetry(){return this.h}get telemetryLevel(){return this.g}dispose(){this.i.dispose()}n(d,p,k){this.g<p||(k=(0,S.$ho)(k,this.d),k=(0,$.$Jp)(k,this.j),k=(0,S.$ho)(k,this.c),this.b.forEach(y=>y.log(d,k)))}publicLog(d,p){this.n(d,u.TelemetryLevel.USAGE,p)}publicLog2(d,p){this.publicLog(d,p)}publicLogError(d,p){this.h&&this.n(d,u.TelemetryLevel.ERROR,p)}publicLogError2(d,p){this.publicLogError(d,p)}};t.$fs=g,t.$fs=g=ye([re(1,I.$aj),re(2,c.$tk)],g);function N(){const v=(0,L.localize)(0,null,l.default.nameLong),d=l.default.privacyStatementUrl?(0,L.localize)(2,null,"https://aka.ms/vscode-telemetry",l.default.privacyStatementUrl):(0,L.localize)(1,null,"https://aka.ms/vscode-telemetry"),p=w.$o?"":(0,L.localize)(3,null),k=(0,L.localize)(4,null),y=(0,L.localize)(5,null),e=(0,L.localize)(6,null),a=(0,L.localize)(7,null),n=`
|       | ${k} | ${y} | ${e} |
|:------|:---------------------:|:---------------:|:--------------:|
| all   |            \u2713          |        \u2713        |        \u2713       |
| error |            \u2713          |        \u2713        |        -       |
| crash |            \u2713          |        -        |        -       |
| off   |            -          |        -        |        -       |
`,r=(0,L.localize)(8,null);return`
${v} ${d} ${p}

&nbsp;

${a}
${n}

&nbsp;

${r}
`}h.$ro.as(m.$wo.Configuration).registerConfiguration({id:u.$hm,order:1,type:"object",title:(0,L.localize)(9,null),properties:{[u.$im]:{type:"string",enum:[u.TelemetryConfiguration.ON,u.TelemetryConfiguration.ERROR,u.TelemetryConfiguration.CRASH,u.TelemetryConfiguration.OFF],enumDescriptions:[(0,L.localize)(10,null),(0,L.localize)(11,null),(0,L.localize)(12,null),(0,L.localize)(13,null)],markdownDescription:N(),default:u.TelemetryConfiguration.ON,restricted:!0,scope:m.ConfigurationScope.APPLICATION,tags:["usesOnlineServices","telemetry"]}}}),h.$ro.as(m.$wo.Configuration).registerConfiguration({id:u.$hm,order:110,type:"object",title:(0,L.localize)(14,null),properties:{[u.$km]:{type:"boolean",markdownDescription:l.default.privacyStatementUrl?(0,L.localize)(16,null,l.default.nameLong,l.default.privacyStatementUrl):(0,L.localize)(15,null,l.default.nameLong),default:!0,restricted:!0,markdownDeprecationMessage:(0,L.localize)(17,null,`\`#${u.$im}#\``),scope:m.ConfigurationScope.APPLICATION,tags:["usesOnlineServices","telemetry"]}}})}),define(oe[155],ae([0,1,14,22,179,152]),function(H,t,E,S,w,O){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$cR=void 0,w=be(w);async function L(c,h){const u=await h.request(c,S.CancellationToken.None),$=(await(0,E.$2e)(u.stream)).toString(),g=u.res.statusCode??200;return{headers:u.res.headers,statusCode:g,responseData:$}}async function I(c){const h={method:c.type,headers:c.headers};return new Promise(($,g)=>{const N=w.request(c.url??"",h,v=>{v.on("data",function(d){$({headers:v.headers,statusCode:v.statusCode??200,responseData:d.toString()})}),v.on("error",function(d){g(d)})});N.write(c.data,v=>{v&&g(v)}),N.end()})}async function m(c,h,u){const $=typeof h.data=="string"?h.data:new TextDecoder().decode(h.data),g={type:"POST",headers:{...h.headers,"Content-Type":"application/json","Content-Length":Buffer.byteLength(h.data).toString()},url:h.urlString,data:$};try{const N=c?await L(g,c):await I(g);u(N.statusCode,N.headers,N.responseData)}catch{u(0,{})}}class l extends O.$bR{constructor(h,u,$,g,N){const v={sendPOST:(d,p)=>{m(h,d,p)}};super(u,$,g,N,v)}}t.$cR=l}),define(oe[156],ae([0,1,16,26]),function(H,t,E,S){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$dhc=w;async function w(O,L){const I=Object.create(null),m=(c,h)=>{const u=JSON.parse(c);I[h]=u};if(L){const c=[],h=await S.Promises.readdir(L);for(const $ of h)try{(await S.Promises.stat((0,E.$mc)(L,$))).isDirectory()&&c.push($)}catch{}const u=[];for(const $ of c)(await S.Promises.readdir((0,E.$mc)(L,$))).filter(N=>N==="telemetry.json").length===1&&u.push($);for(const $ of u){const g=(await S.Promises.readFile((0,E.$mc)(L,$,"telemetry.json"))).toString();m(g,$)}}let l=(await S.Promises.readFile((0,E.$mc)(O,"telemetry-core.json"))).toString();return m(l,"vscode-core"),l=(await S.Promises.readFile((0,E.$mc)(O,"telemetry-extensions.json"))).toString(),m(l,"vscode-extensions"),JSON.stringify(I,null,4)}}),define(oe[157],ae([0,1,13,88,19]),function(H,t,E,S,w){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$zgc=O,t.$Agc=L,t.$Bgc=I;async function O(m,l){let c=m.getItem(w.$em);return(typeof c!="string"||E.$j&&c==="6c9d2bc8f91b89624add29c0abeae7fb42bf539fa1cdb2e3e57cd668fa9bcead")&&(c=await(0,S.$Tn)(l.error.bind(l))),c}async function L(m,l){let c=m.getItem(w.$fm);return typeof c!="string"&&(c=await(0,S.$Un)(l.error.bind(l))),c}async function I(m,l){let c=m.getItem(w.$gm);return typeof c!="string"&&(c=await(0,S.$Vn)(l.error.bind(l))),c}}),define(oe[24],ae([0,1,11]),function(H,t,E){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Kl=void 0,t.$Kl=(0,E.$Gi)("IUriIdentityService")}),define(oe[158],ae([0,1,24,123,10,17,79,5,2]),function(H,t,E,S,w,O,L,I,m){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Ss=void 0;class l{static{this._clock=0}constructor(u){this.uri=u,this.time=l._clock++}touch(){return this.time=l._clock++,this}}let c=class{constructor(u){this.g=u,this.c=new m.$Wc,this.f=2**16;const $=new Map,g=N=>{let v=$.get(N.scheme);return v===void 0&&(v=u.hasProvider(N)&&!this.g.hasCapability(N,w.FileSystemProviderCapabilities.PathCaseSensitive),$.set(N.scheme,v)),v};this.c.add(I.Event.any(u.onDidChangeFileSystemProviderRegistrations,u.onDidChangeFileSystemProviderCapabilities)(N=>{$.delete(N.scheme)})),this.extUri=new O.$9g(g),this.d=new L.$Rs((N,v)=>this.extUri.compare(N,v,!0),this.f)}dispose(){this.c.dispose(),this.d.clear()}asCanonicalUri(u){this.g.hasProvider(u)&&(u=(0,O.$ih)(u));const $=this.d.get(u);return $?$.touch().uri.with({fragment:u.fragment}):(this.d.set(u,new l(u)),this.h(),u)}h(){if(this.d.size<this.f)return;const u=[...this.d.entries()].sort((g,N)=>g[1].time<N[1].time?1:g[1].time>N[1].time?-1:0);l._clock=0,this.d.clear();const $=this.f*.5;for(let g=0;g<$;g++)this.d.set(u[g][0],u[g][1].touch())}};t.$Ss=c,t.$Ss=c=ye([re(0,w.$al)],c),(0,S.$Ps)(E.$Kl,c,S.InstantiationType.Delayed)}),define(oe[159],ae([0,1,5,2,10,49,31]),function(H,t,E,S,w,O,L){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Zgc=void 0;class I extends S.$Xc{constructor(l,c,h,u,$,g){super(),this.f=l,this.g=c,this.h=h,this.j=u,this.m=$,this.n=g,this.capabilities=this.g.capabilities,this.onDidChangeCapabilities=this.g.onDidChangeCapabilities,this.a=this.B(new E.$ne),this.onDidChangeFile=this.a.event,this.b=O.$Mi.forUris(()=>!(this.capabilities&w.FileSystemProviderCapabilities.PathCaseSensitive)),this.c=new L.$Ec(N=>this.m.extUri.getComparisonKey(this.t(N))),this.r(),this.B(u.onDidChangeProfiles(()=>this.r())),this.B(this.g.onDidChangeFile(N=>this.s(N)))}r(){this.c.clear();for(const l of this.j.profiles)this.c.add(l.settingsResource),this.c.add(l.keybindingsResource),this.c.add(l.tasksResource),this.c.add(l.extensionsResource)}open(l,c){return this.g.open(this.t(l),c)}close(l){return this.g.close(l)}read(l,c,h,u,$){return this.g.read(l,c,h,u,$)}write(l,c,h,u,$){return this.g.write(l,c,h,u,$)}watch(l,c){this.b.set(l,l);const h=this.g.watch(this.t(l),c);return(0,S.$Vc)(()=>{this.b.delete(l),h.dispose()})}stat(l){return this.g.stat(this.t(l))}mkdir(l){return this.g.mkdir(this.t(l))}rename(l,c,h){return this.g.rename(this.t(l),this.t(c),h)}readFile(l,c){return this.g.readFile(this.t(l),c)}readFileStream(l,c,h){return this.g.readFileStream(this.t(l),c,h)}readdir(l){return this.g.readdir(this.t(l))}enforceAtomicReadFile(l){return this.c.has(l)}writeFile(l,c,h){return this.g.writeFile(this.t(l),c,h)}enforceAtomicWriteFile(l){return this.c.has(l)?{postfix:".vsctmp"}:!1}delete(l,c){return this.g.delete(this.t(l),c)}copy(l,c,h){if((0,w.$el)(this.g))return this.g.copy(this.t(l),this.t(c),h);throw new Error("copy not supported")}cloneFile(l,c){if((0,w.$fl)(this.g))return this.g.cloneFile(this.t(l),this.t(c));throw new Error("clone not supported")}s(l){const c=[];for(const h of l){if(h.resource.scheme!==this.f)continue;const u=this.u(h.resource);this.b.findSubstr(u)&&c.push({resource:u,type:h.type,cId:h.cId})}c.length&&(this.n.debug("User data changed"),this.a.fire(c))}t(l){return l.with({scheme:this.f})}u(l){return l.with({scheme:this.h})}}t.$Zgc=I}),define(oe[160],ae([0,1,115,16,49,17,12,11,15]),function(H,t,E,S,w,O,L,I,m){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$9i=t.$6i=t.$5i=t.$4i=t.$3i=t.$1i=t.$Zi=t.WorkbenchState=t.$Ti=t.$Si=t.$Pi=void 0,t.$Qi=l,t.$Ri=c,t.$Ui=h,t.$Vi=u,t.$Wi=$,t.$Xi=N,t.$Yi=v,t.$2i=k,t.$7i=y,t.$8i=e,t.$0i=a,t.$$i=n,t.$_i=r,t.$Pi=(0,I.$Gi)("contextService");function l(i){const s=i;return typeof s?.id=="string"&&L.URI.isUri(s.uri)}function c(i){return typeof i?.id=="string"&&!l(i)&&!u(i)}t.$Si={id:"ext-dev"},t.$Ti={id:"empty-window"};function h(i,s){if(typeof i=="string"||typeof i>"u")return typeof i=="string"?{id:(0,S.$qc)(i)}:s?t.$Si:t.$Ti;const o=i;return o.configuration?{id:o.id,configPath:o.configuration}:o.folders.length===1?{id:o.id,uri:o.folders[0].uri}:{id:o.id}}function u(i){const s=i;return typeof s?.id=="string"&&L.URI.isUri(s.configPath)}function $(i){const s=i;if(s?.uri)return{id:s.id,uri:L.URI.revive(s.uri)};const o=i;if(o?.configPath)return{id:o.id,configPath:L.URI.revive(o.configPath)};if(i?.id)return{id:i.id}}var g;(function(i){i[i.EMPTY=1]="EMPTY",i[i.FOLDER=2]="FOLDER",i[i.WORKSPACE=3]="WORKSPACE"})(g||(t.WorkbenchState=g={}));function N(i){const s=i;return!!(s&&typeof s=="object"&&typeof s.id=="string"&&Array.isArray(s.folders))}function v(i){const s=i;return!!(s&&typeof s=="object"&&L.URI.isUri(s.uri)&&typeof s.name=="string"&&typeof s.toResource=="function")}class d{constructor(s,o,f,b,R){this.h=s,this.j=f,this.k=b,this.l=R,this.c=w.$Mi.forUris(this.l,()=>!0),this.folders=o}update(s){this.h=s.id,this.k=s.configuration,this.j=s.transient,this.l=s.l,this.folders=s.folders}get folders(){return this.g}set folders(s){this.g=s,this.n()}get id(){return this.h}get transient(){return this.j}get configuration(){return this.k}set configuration(s){this.k=s}getFolder(s){return s&&this.c.findSubstr(s)||null}n(){this.c=w.$Mi.forUris(this.l,()=>!0);for(const s of this.folders)this.c.set(s.uri,s)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}t.$Zi=d;class p{constructor(s,o){this.raw=o,this.uri=s.uri,this.index=s.index,this.name=s.name}toResource(s){return(0,O.$hh)(this.uri,s)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}t.$1i=p;function k(i){return new p({uri:i,index:0,name:(0,O.$dh)(i)},{uri:i.toString()})}t.$3i="code-workspace",t.$4i=`.${t.$3i}`,t.$5i=[{name:(0,E.localize)(0,null),extensions:[t.$3i]}],t.$6i="workspace.json";function y(i,s){return O.$$g.isEqualOrParent(i,s.untitledWorkspacesHome)}function e(i){let s;return L.URI.isUri(i)?s=i:s=i.configuration,s?.scheme===m.Schemas.tmp}t.$9i="4064f6ec-cb38-4ad0-af64-ee6467e63c82";function a(i){return i.id===t.$9i}function n(i,s){return!y(i,s)&&!e(i)}function r(i){return(typeof i=="string"?(0,S.$rc)(i):(0,O.$fh)(i))===t.$4i}}),define(oe[25],ae([0,1,43,5,2,17,12,114,18,10,11,6,160,31,24,8,29,32,3]),function(H,t,E,S,w,O,L,I,m,l,c,h,u,$,g,N,v,d,p){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Ql=t.$Pl=t.$Ml=t.ProfileResourceType=void 0,t.$Ll=y,t.$Nl=e,t.$Ol=a;var k;(function(i){i.Settings="settings",i.Keybindings="keybindings",i.Snippets="snippets",i.Tasks="tasks",i.Extensions="extensions",i.GlobalState="globalState"})(k||(t.ProfileResourceType=k={}));function y(i){const s=i;return!!(s&&typeof s=="object"&&typeof s.id=="string"&&typeof s.isDefault=="boolean"&&typeof s.name=="string"&&L.URI.isUri(s.location)&&L.URI.isUri(s.globalStorageHome)&&L.URI.isUri(s.settingsResource)&&L.URI.isUri(s.keybindingsResource)&&L.URI.isUri(s.tasksResource)&&L.URI.isUri(s.snippetsHome)&&L.URI.isUri(s.extensionsResource))}t.$Ml=(0,c.$Gi)("IUserDataProfilesService");function e(i,s){return{id:i.id,isDefault:i.isDefault,name:i.name,shortName:i.shortName,icon:i.icon,location:L.URI.revive(i.location).with({scheme:s}),globalStorageHome:L.URI.revive(i.globalStorageHome).with({scheme:s}),settingsResource:L.URI.revive(i.settingsResource).with({scheme:s}),keybindingsResource:L.URI.revive(i.keybindingsResource).with({scheme:s}),tasksResource:L.URI.revive(i.tasksResource).with({scheme:s}),snippetsHome:L.URI.revive(i.snippetsHome).with({scheme:s}),extensionsResource:L.URI.revive(i.extensionsResource).with({scheme:s}),cacheHome:L.URI.revive(i.cacheHome).with({scheme:s}),useDefaultFlags:i.useDefaultFlags,isTransient:i.isTransient}}function a(i,s,o,f,b,R){return{id:i,name:s,location:o,isDefault:!1,shortName:b?.shortName,icon:b?.icon,globalStorageHome:R&&b?.useDefaultFlags?.globalState?R.globalStorageHome:(0,O.$hh)(o,"globalStorage"),settingsResource:R&&b?.useDefaultFlags?.settings?R.settingsResource:(0,O.$hh)(o,"settings.json"),keybindingsResource:R&&b?.useDefaultFlags?.keybindings?R.keybindingsResource:(0,O.$hh)(o,"keybindings.json"),tasksResource:R&&b?.useDefaultFlags?.tasks?R.tasksResource:(0,O.$hh)(o,"tasks.json"),snippetsHome:R&&b?.useDefaultFlags?.snippets?R.snippetsHome:(0,O.$hh)(o,"snippets"),extensionsResource:R&&b?.useDefaultFlags?.extensions?R.extensionsResource:(0,O.$hh)(o,"extensions.json"),cacheHome:(0,O.$hh)(f,i),useDefaultFlags:b?.useDefaultFlags,isTransient:b?.transient}}let n=class extends w.$Xc{static{this.b="userDataProfiles"}static{this.c="profileAssociations"}get defaultProfile(){return this.profiles[0]}get profiles(){return[...this.C.profiles,...this.s.profiles]}constructor(s,o,f,b){super(),this.t=s,this.u=o,this.w=f,this.y=b,this.f=!0,this.h=this.B(new S.$ne),this.onDidChangeProfiles=this.h.event,this.j=this.B(new S.$ne),this.onWillCreateProfile=this.j.event,this.m=this.B(new S.$ne),this.onWillRemoveProfile=this.m.event,this.n=this.B(new S.$ne),this.onDidResetWorkspaces=this.n.event,this.r=new Map,this.s={profiles:[],folders:new $.$Dc,workspaces:new $.$Dc,emptyWindows:new Map},this.profilesHome=(0,O.$hh)(this.t.userRoamingDataHome,"profiles"),this.g=(0,O.$hh)(this.t.cacheHome,"CachedProfilesData")}init(){this.z=void 0}setEnablement(s){this.f!==s&&(this.z=void 0,this.f=s)}isEnabled(){return this.f}get C(){if(!this.z){const s=this.D(),o=[s];if(this.f)try{for(const R of this.O()){if(!R.name||!(0,p.$gg)(R.name)||!R.location){this.y.warn("Skipping the invalid stored profile",R.location||R.name);continue}o.push(a((0,O.$eh)(R.location),R.name,R.location,this.g,{shortName:R.shortName,icon:R.icon,useDefaultFlags:R.useDefaultFlags},s))}}catch(R){this.y.error(R)}const f=new $.$Dc,b=new Map;if(o.length)try{const R=this.Q();if(R.workspaces)for(const[T,D]of Object.entries(R.workspaces)){const A=L.URI.parse(T),z=o.find(J=>J.id===D);z&&f.set(A,z)}if(R.emptyWindows)for(const[T,D]of Object.entries(R.emptyWindows)){const A=o.find(z=>z.id===D);A&&b.set(T,A)}}catch(R){this.y.error(R)}this.z={profiles:o,workspaces:f,emptyWindows:b}}return this.z}D(){const s=a("__default__profile__",(0,I.localize)(0,null),this.t.userRoamingDataHome,this.g);return{...s,extensionsResource:this.S()??s.extensionsResource,isDefault:!0}}async createTransientProfile(s){const o="Temp",f=new RegExp(`${(0,d.$jf)(o)}\\s(\\d+)`);let b=0;for(const T of this.profiles){const D=f.exec(T.name),A=D?parseInt(D[1]):0;b=A>b?A:b}const R=`${o} ${b+1}`;return this.createProfile((0,E.$uj)((0,v.$3g)()).toString(16),R,{transient:!0},s)}async createNamedProfile(s,o,f){return this.createProfile((0,E.$uj)((0,v.$3g)()).toString(16),s,o,f)}async createProfile(s,o,f,b){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const R=await this.F(s,o,f);return b&&await this.setProfileForWorkspace(b,R),R}async F(s,o,f){if(!(0,p.$gg)(o)||!o)throw new Error("Name of the profile is mandatory and must be of type `string`");let b=this.r.get(o);return b||(b=(async()=>{try{if(this.profiles.find(A=>A.name===o||A.id===s))throw new Error(`Profile with ${o} name already exists`);const T=a(s,o,(0,O.$hh)(this.profilesHome,s),this.g,f,this.defaultProfile);await this.u.createFolder(T.location);const D=[];return this.j.fire({profile:T,join(A){D.push(A)}}),await N.Promises.settled(D),this.I([T],[],[]),T}finally{this.r.delete(o)}})(),this.r.set(o,b)),b}async updateProfile(s,o){if(!this.f)throw new Error("Profiles are disabled in the current environment.");let f=this.profiles.find(b=>b.id===s.id);if(!f)throw new Error(`Profile '${s.name}' does not exist`);return f=a(f.id,o.name??f.name,f.location,this.g,{shortName:o.shortName??f.shortName,icon:o.icon===null?void 0:o.icon??f.icon,transient:o.transient??f.isTransient,useDefaultFlags:o.useDefaultFlags??f.useDefaultFlags},this.defaultProfile),this.I([],[],[f]),f}async removeProfile(s){if(!this.f)throw new Error("Profiles are disabled in the current environment.");if(s.isDefault)throw new Error("Cannot remove default profile");const o=this.profiles.find(b=>b.id===s.id);if(!o)throw new Error(`Profile '${s.name}' does not exist`);const f=[];this.m.fire({profile:o,join(b){f.push(b)}});try{await Promise.allSettled(f)}catch(b){this.y.error(b)}for(const b of[...this.C.emptyWindows.keys()])o.id===this.C.emptyWindows.get(b)?.id&&this.C.emptyWindows.delete(b);for(const b of[...this.C.workspaces.keys()])o.id===this.C.workspaces.get(b)?.id&&this.C.workspaces.delete(b);this.M(),this.I([],[o],[]);try{await this.u.del(o.cacheHome,{recursive:!0})}catch(b){(0,l.$rl)(b)!==l.FileOperationResult.FILE_NOT_FOUND&&this.y.error(b)}}async setProfileForWorkspace(s,o){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const f=this.profiles.find(b=>b.id===o.id);if(!f)throw new Error(`Profile '${o.name}' does not exist`);this.L(s,f)}unsetWorkspace(s,o){if(!this.f)throw new Error("Profiles are disabled in the current environment.");this.L(s,void 0,o)}async resetWorkspaces(){this.s.folders.clear(),this.s.workspaces.clear(),this.s.emptyWindows.clear(),this.C.workspaces.clear(),this.C.emptyWindows.clear(),this.M(),this.n.fire()}async cleanUp(){if(this.f&&await this.u.exists(this.profilesHome)){const s=await this.u.resolve(this.profilesHome);await Promise.all((s.children||[]).filter(o=>o.isDirectory&&this.profiles.every(f=>!this.w.extUri.isEqual(f.location,o.resource))).map(o=>this.u.del(o.resource,{recursive:!0})))}}async cleanUpTransientProfiles(){if(!this.f)return;const s=this.s.profiles.filter(o=>!this.H(o));await Promise.allSettled(s.map(o=>this.removeProfile(o)))}getProfileForWorkspace(s){const o=this.G(s),f=L.URI.isUri(o)?this.C.workspaces.get(o):this.C.emptyWindows.get(o);return f||((0,u.$Qi)(s)?this.s.folders.get(s.uri):(0,u.$Vi)(s)?this.s.workspaces.get(s.configPath):this.s.emptyWindows.get(s.id))}G(s){return(0,u.$Qi)(s)?s.uri:(0,u.$Vi)(s)?s.configPath:s.id}H(s){return!!([...this.C.emptyWindows.values()].some(o=>this.w.extUri.isEqual(o.location,s.location))||[...this.C.workspaces.values()].some(o=>this.w.extUri.isEqual(o.location,s.location))||[...this.s.emptyWindows.values()].some(o=>this.w.extUri.isEqual(o.location,s.location))||[...this.s.workspaces.values()].some(o=>this.w.extUri.isEqual(o.location,s.location))||[...this.s.folders.values()].some(o=>this.w.extUri.isEqual(o.location,s.location)))}I(s,o,f){const b=[...this.profiles,...s],R=[],T=this.s.profiles;this.s.profiles=[];for(let D of b){if(D.isDefault||o.some(z=>D.id===z.id))continue;D=f.find(z=>D.id===z.id)??D;const A=T.find(z=>D.id===z.id);if(D.isTransient)this.s.profiles.push(D);else{if(A){for(const[z,J]of this.s.emptyWindows.entries())if(D.id===J.id){this.L({id:z},D);break}for(const[z,J]of this.s.workspaces.entries())if(D.id===J.id){this.L({id:"",configPath:z},D);break}for(const[z,J]of this.s.folders.entries())if(D.id===J.id){this.L({id:"",uri:z},D);break}}R.push({location:D.location,name:D.name,shortName:D.shortName,icon:D.icon,useDefaultFlags:D.useDefaultFlags})}}this.P(R),this.z=void 0,this.J(s,o,f)}J(s,o,f){this.h.fire({added:s,removed:o,updated:f,all:this.profiles})}L(s,o,f){if(f=o?.isTransient?!0:f,f)(0,u.$Qi)(s)?(this.s.folders.delete(s.uri),o&&this.s.folders.set(s.uri,o)):(0,u.$Vi)(s)?(this.s.workspaces.delete(s.configPath),o&&this.s.workspaces.set(s.configPath,o)):(this.s.emptyWindows.delete(s.id),o&&this.s.emptyWindows.set(s.id,o));else{this.L(s,void 0,!0);const b=this.G(s);L.URI.isUri(b)?(this.C.workspaces.delete(b),o&&this.C.workspaces.set(b,o)):(this.C.emptyWindows.delete(b),o&&this.C.emptyWindows.set(b,o)),this.M()}}M(){const s={};for(const[f,b]of this.C.workspaces.entries())s[f.toString()]=b.id;const o={};for(const[f,b]of this.C.emptyWindows.entries())o[f.toString()]=b.id;this.R({workspaces:s,emptyWindows:o}),this.z=void 0}N(s){const o={},f=this.D();if(s.workspaces)for(const[R,T]of Object.entries(s.workspaces)){const D=L.URI.parse(T);o[R]=this.w.extUri.isEqual(D,f.location)?f.id:this.w.extUri.basename(D)}const b={};if(s.emptyWindows)for(const[R,T]of Object.entries(s.emptyWindows)){const D=L.URI.parse(T);b[R]=this.w.extUri.isEqual(D,f.location)?f.id:this.w.extUri.basename(D)}return{workspaces:o,emptyWindows:b}}O(){return[]}P(s){throw new Error("not implemented")}Q(){return{}}R(s){throw new Error("not implemented")}S(){}};t.$Pl=n,t.$Pl=n=ye([re(0,m.$Ni),re(1,l.$al),re(2,g.$Kl),re(3,h.$ak)],n);class r extends n{constructor(){super(...arguments),this.a=[],this.X={}}O(){return this.a}P(s){this.a=s}Q(){return this.X}R(s){this.X=s}}t.$Ql=r}),define(oe[53],ae([0,1,20,8,22,9,5,2,13,3,12,98,21,27,23,44,6,33,19,24,25]),function(H,t,E,S,w,O,L,I,m,l,c,h,u,$,g,N,v,d,p,k,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Fq=t.$Dq=void 0,t.$Eq=a,h=be(h);let e=class extends I.$Xc{get onInstallExtension(){return this.n.event}get onDidInstallExtensions(){return this.s.event}get onUninstallExtension(){return this.t.event}get onDidUninstallExtension(){return this.u.event}get onDidUpdateExtensionMetadata(){return this.w.event}constructor(s,o,f,b,R,T){super(),this.z=s,this.C=o,this.D=f,this.F=b,this.G=R,this.H=T,this.h=0,this.j=new Map,this.m=new Map,this.n=this.B(new L.$ne),this.s=this.B(new L.$ne),this.t=this.B(new L.$ne),this.u=this.B(new L.$ne),this.w=this.B(new L.$ne),this.y=[],this.B((0,I.$Vc)(()=>{this.j.forEach(({task:D})=>D.cancel()),this.m.forEach(D=>D.cancel()),this.j.clear(),this.m.clear()}))}async canInstall(s){const o=await this.getTargetPlatform();return s.allTargetPlatforms.some(f=>(0,u.$hp)(f,s.allTargetPlatforms,o))}async installFromGallery(s,o={}){try{const b=(await this.installGalleryExtensions([{extension:s,options:o}])).find(({identifier:R})=>(0,$.$Kp)(R,s.identifier));if(b?.local)return b?.local;throw b?.error?b.error:new u.$lp(`Unknown error while installing extension ${s.identifier.id}`,u.ExtensionManagementErrorCode.Unknown)}catch(f){throw a(f)}}async installGalleryExtensions(s){if(!this.z.isEnabled())throw new u.$lp(h.localize(0,null),u.ExtensionManagementErrorCode.NotAllowed);const o=[],f=[];return await Promise.allSettled(s.map(async({extension:b,options:R})=>{try{const T=await this.N(b,!!R?.installGivenVersion,!!R?.installPreReleaseVersion,R.productVersion??{version:this.G.version,date:this.G.date});f.push({...T,options:R})}catch(T){o.push({identifier:b.identifier,operation:u.InstallOperation.Install,source:b,error:T,profileLocation:R.profileLocation??this.X()})}})),f.length&&o.push(...await this.I(f)),o}async uninstall(s,o={}){return this.F.trace("ExtensionManagementService#uninstall",s.identifier.id),this.P(s,o)}async toggleAppliationScope(s,o){if((0,g.$un)(s.manifest)||s.isBuiltin)return s;if(s.isApplicationScoped){let f=await this.updateMetadata(s,{isApplicationScoped:!1},this.H.defaultProfile.extensionsResource);this.D.extUri.isEqual(o,this.H.defaultProfile.extensionsResource)||(f=await this.$(s,this.H.defaultProfile.extensionsResource,o));for(const b of this.H.profiles){const R=(await this.getInstalled(g.ExtensionType.User,b.extensionsResource)).find(T=>(0,$.$Kp)(T.identifier,s.identifier));R?this.w.fire({local:R,profileLocation:b.extensionsResource}):this.u.fire({identifier:s.identifier,profileLocation:b.extensionsResource})}return f}else{const f=this.D.extUri.isEqual(o,this.H.defaultProfile.extensionsResource)?await this.updateMetadata(s,{isApplicationScoped:!0},this.H.defaultProfile.extensionsResource):await this.$(s,o,this.H.defaultProfile.extensionsResource,{isApplicationScoped:!0});return this.s.fire([{identifier:f.identifier,operation:u.InstallOperation.Install,local:f,profileLocation:this.H.defaultProfile.extensionsResource,applicationScoped:!0}]),f}}getExtensionsControlManifest(){const s=new Date().getTime();return(!this.g||s-this.h>1e3*60*5)&&(this.g=this.W(),this.h=s),this.g}registerParticipant(s){this.y.push(s)}async I(s){const o=new Map,f=new Map,b=[],R=(D,A)=>`${$.$Lp.create(D).toString()}-${A.toString()}`,T=(D,A,z,J)=>{const Q=this.Y(D,A,z),se=`${(0,$.$Pp)(D.publisher,D.name)}-${z.profileLocation.toString()}`;f.set(se,{task:Q,root:J}),this.n.fire({identifier:Q.identifier,source:A,profileLocation:z.profileLocation}),this.F.info("Installing extension:",Q.identifier.id,z),c.URI.isUri(A)||this.j.set(R(A,z.profileLocation),{task:Q,waitingTasks:[]})};try{for(const{manifest:D,extension:A,options:z}of s){const J=z.isApplicationScoped||z.isBuiltin||(0,g.$un)(D),Q={...z,installOnlyNewlyAddedFromExtensionPack:z.installOnlyNewlyAddedFromExtensionPack??!c.URI.isUri(A),isApplicationScoped:J,profileLocation:J?this.H.defaultProfile.extensionsResource:z.profileLocation??this.X(),productVersion:z.productVersion??{version:this.G.version,date:this.G.date}},se=c.URI.isUri(A)?void 0:this.j.get(R(A,Q.profileLocation));se?(this.F.info("Extension is already requested to install",se.task.identifier.id,Q.profileLocation.toString()),b.push(se.task.waitUntilTaskIsFinished())):T(D,A,Q,void 0)}return await Promise.all([...f.values()].map(async({task:D})=>{if(D.options.donotIncludePackAndDependencies)this.F.info("Installing the extension without checking dependencies and pack",D.identifier.id);else try{const A=await this.M(D.identifier,D.manifest,!!D.options.installOnlyNewlyAddedFromExtensionPack,!!D.options.installPreReleaseVersion,D.options.profileLocation,D.options.productVersion),z=await this.getInstalled(void 0,D.options.profileLocation,D.options.productVersion),J={...D.options,context:{...D.options.context,[u.$bp]:!0}};for(const{gallery:Q,manifest:se}of(0,E.$Pb)(A,({gallery:le})=>le.identifier.id)){if(f.has(`${Q.identifier.id.toLowerCase()}-${J.profileLocation.toString()}`))continue;const le=this.j.get(R(Q,J.profileLocation));if(le){if(this.J(D,le.task)){const ue=le.task.identifier;this.F.info("Waiting for already requested installing extension",ue.id,D.identifier.id,J.profileLocation.toString()),le.waitingTasks.push(D),b.push(L.Event.toPromise(L.Event.filter(this.onDidInstallExtensions,fe=>fe.some(x=>(0,$.$Kp)(x.identifier,ue)))).then(fe=>{if(this.F.info("Finished waiting for already requested installing extension",ue.id,D.identifier.id,J.profileLocation.toString()),!fe.find(_=>(0,$.$Kp)(_.identifier,ue))?.local)throw new Error(`Extension ${ue.id} is not installed`)}))}}else z.some(({identifier:ue})=>(0,$.$Kp)(ue,Q.identifier))||T(se,Q,J,D)}}catch(A){if(c.URI.isUri(D.source))(0,E.$Ob)(D.manifest.extensionDependencies)&&this.F.warn("Cannot install dependencies of extension:",D.identifier.id,A.message),(0,E.$Ob)(D.manifest.extensionPack)&&this.F.warn("Cannot install packed extensions of extension:",D.identifier.id,A.message);else throw this.F.error("Error while preparing to install dependencies and extension packs of the extension:",D.identifier.id),A}})),await this.L([...f.entries()].map(async([D,{task:A}])=>{const z=new Date().getTime();let J;try{J=await A.run(),await this.L(this.y.map(Q=>Q.postInstall(J,A.source,A.options,w.CancellationToken.None)),u.ExtensionManagementErrorCode.PostInstall)}catch(Q){const se=a(Q);throw c.URI.isUri(A.source)||n(this.C,A.operation===u.InstallOperation.Update?"extensionGallery:update":"extensionGallery:install",{extensionData:(0,$.$Sp)(A.source),error:se,source:A.options.context?.[u.$ap]}),o.set(D,{error:se,identifier:A.identifier,operation:A.operation,source:A.source,context:A.options.context,profileLocation:A.options.profileLocation,applicationScoped:A.options.isApplicationScoped}),this.F.error("Error while installing the extension",A.identifier.id,(0,O.$ab)(se),A.options.profileLocation.toString()),se}if(!c.URI.isUri(A.source)){const Q=A.operation===u.InstallOperation.Update,se=Q?void 0:(new Date().getTime()-A.source.lastUpdated)/1e3;if(n(this.C,Q?"extensionGallery:update":"extensionGallery:install",{extensionData:(0,$.$Sp)(A.source),verificationStatus:A.verificationStatus,duration:new Date().getTime()-z,durationSinceUpdate:se,source:A.options.context?.[u.$ap]}),m.$o&&A.operation!==u.InstallOperation.Update)try{await this.z.reportStatistic(J.manifest.publisher,J.manifest.name,J.manifest.version,u.StatisticType.Install)}catch{}}o.set(D,{local:J,identifier:A.identifier,operation:A.operation,source:A.source,context:A.options.context,profileLocation:A.options.profileLocation,applicationScoped:J.isApplicationScoped})})),b.length&&await this.L(b),[...o.values()]}catch(D){const A=(Q,se,le)=>{const ue=[];Q.manifest.extensionDependencies?.length&&ue.push(...Q.manifest.extensionDependencies),Q.manifest.extensionPack?.length&&ue.push(...Q.manifest.extensionPack);for(const fe of ue){if(le.includes(fe.toLowerCase()))continue;le.push(fe.toLowerCase());const x=o.get(`${fe.toLowerCase()}-${se.toString()}`);x?.local&&(le=A(x.local,se,le))}return le},z=Q=>({identifier:Q.identifier,operation:u.InstallOperation.Install,source:Q.source,context:Q.options.context,profileLocation:Q.options.profileLocation,error:D}),J=[];for(const[Q,{task:se,root:le}]of f){const ue=o.get(Q);ue?ue.local&&le&&!o.get(`${le.identifier.id.toLowerCase()}-${se.options.profileLocation.toString()}`)?.local&&(J.push(this.Z(ue.local,{versionOnly:!0,profileLocation:se.options.profileLocation})),o.set(Q,z(se))):(se.cancel(),o.set(Q,z(se)))}for(const[Q,{task:se}]of f){const le=o.get(Q);if(!le?.local||se.options.donotIncludePackAndDependencies)continue;A(le.local,se.options.profileLocation,[le.local.identifier.id.toLowerCase()]).slice(1).some(fe=>f.has(`${fe.toLowerCase()}-${se.options.profileLocation.toString()}`)&&!o.get(`${fe.toLowerCase()}-${se.options.profileLocation.toString()}`)?.local)&&(J.push(this.Z(le.local,{versionOnly:!0,profileLocation:se.options.profileLocation})),o.set(Q,z(se)))}throw J.length&&await Promise.allSettled(J.map(async Q=>{try{await Q.run(),this.F.info("Rollback: Uninstalled extension",Q.extension.identifier.id)}catch(se){this.F.warn("Rollback: Error while uninstalling extension",Q.extension.identifier.id,(0,O.$ab)(se))}})),D}finally{for(const{task:D}of f.values())D.source&&!c.URI.isUri(D.source)&&this.j.delete(R(D.source,D.options.profileLocation));if(o.size){const D=[...o.values()];for(const A of D)A.local&&this.F.info("Extension installed successfully:",A.identifier.id,A.profileLocation.toString());this.s.fire(D)}}}J(s,o){for(const[,{task:f,waitingTasks:b}]of this.j.entries())if(f===s&&(b.includes(o)||b.some(R=>this.J(R,o)))||f===o&&b[0]&&!this.J(s,b[0]))return!1;return!0}async L(s,o){const f=[],b=[],R=await Promise.allSettled(s);for(const D of R)D.status==="fulfilled"?f.push(D.value):b.push(a(D.reason,o));if(!b.length)return f;if(b.length===1)throw b[0];let T=new u.$lp("",u.ExtensionManagementErrorCode.Unknown);for(const D of b)T=new u.$lp(T.message?`${T.message}, ${D.message}`:D.message,D.code!==u.ExtensionManagementErrorCode.Unknown&&D.code!==u.ExtensionManagementErrorCode.Internal?D.code:T.code);throw T}async M(s,o,f,b,R,T){if(!this.z.isEnabled())return[];const D=await this.getInstalled(void 0,R,T),A=[],z=[],J=async(Q,se)=>{A.push(Q);const le=se.extensionDependencies||[],ue=[...le];if(se.extensionPack){const fe=f?D.find(x=>(0,$.$Kp)(x.identifier,Q)):void 0;for(const x of se.extensionPack)fe&&fe.manifest.extensionPack&&fe.manifest.extensionPack.some(_=>(0,$.$Kp)({id:_},{id:x}))||ue.every(_=>!(0,$.$Kp)({id:_},{id:x}))&&ue.push(x)}if(ue.length){const fe=ue.filter(x=>A.every(_=>!(0,$.$Kp)(_,{id:x})));if(fe.length){const x=await this.z.getExtensions(fe.map(_=>({id:_,preRelease:b})),w.CancellationToken.None);for(const _ of x){if(A.find(G=>(0,$.$Kp)(G,_.identifier)))continue;const B=le.some(G=>(0,$.$Kp)({id:G},_.identifier));let M;try{M=await this.N(_,!1,b,T)}catch(G){if(B)throw G;this.F.info("Skipping the packed extension as it cannot be installed",_.identifier.id,(0,O.$ab)(G));continue}z.push({gallery:M.extension,manifest:M.manifest}),await J(M.extension.identifier,M.manifest)}}}};return await J(s,o),z}async N(s,o,f,b){let R;const T=await this.getExtensionsControlManifest();if(T.malicious.some(z=>(0,$.$Kp)(s.identifier,z)))throw new u.$lp(h.localize(1,null,s.identifier.id),u.ExtensionManagementErrorCode.Malicious);const D=T.deprecated[s.identifier.id.toLowerCase()];if(D?.extension?.autoMigrate){if(this.F.info(`The '${s.identifier.id}' extension is deprecated, fetching the compatible '${D.extension.id}' extension instead.`),R=(await this.z.getExtensions([{id:D.extension.id,preRelease:D.extension.preRelease}],{targetPlatform:await this.getTargetPlatform(),compatible:!0,productVersion:b},w.CancellationToken.None))[0],!R)throw new u.$lp(h.localize(2,null,s.identifier.id,D.extension.id),u.ExtensionManagementErrorCode.Deprecated)}else{if(!await this.canInstall(s)){const z=await this.getTargetPlatform();throw new u.$lp(h.localize(3,null,s.identifier.id,this.G.nameLong,(0,u.$dp)(z)),u.ExtensionManagementErrorCode.IncompatibleTargetPlatform)}if(R=await this.O(s,o,f,b),!R){const z=[];throw(0,N.$5p)(s.properties.enabledApiProposals??[],z)?!f&&s.properties.isPreReleaseVersion&&(await this.z.getExtensions([s.identifier],w.CancellationToken.None))[0]?new u.$lp(h.localize(5,null,s.displayName??s.identifier.id),u.ExtensionManagementErrorCode.ReleaseVersionNotFound):new u.$lp(h.localize(6,null,s.identifier.id,this.G.nameLong,this.G.version),u.ExtensionManagementErrorCode.Incompatible):new u.$lp(h.localize(4,null,s.displayName??s.identifier.id,z[0]),u.ExtensionManagementErrorCode.IncompatibleApi)}}this.F.info("Getting Manifest...",R.identifier.id);const A=await this.z.getManifest(R,w.CancellationToken.None);if(A===null)throw new u.$lp(`Missing manifest for extension ${R.identifier.id}`,u.ExtensionManagementErrorCode.Invalid);if(A.version!==R.version)throw new u.$lp(`Cannot install '${R.identifier.id}' extension because of version mismatch in Marketplace`,u.ExtensionManagementErrorCode.Invalid);return{extension:R,manifest:A}}async O(s,o,f,b){const R=await this.getTargetPlatform();let T=null;return!o&&s.hasPreReleaseVersion&&s.properties.isPreReleaseVersion!==f&&(T=(await this.z.getExtensions([{...s.identifier,preRelease:f}],{targetPlatform:R,compatible:!0,productVersion:b},w.CancellationToken.None))[0]||null),!T&&await this.z.isExtensionCompatible(s,f,R,b)&&(T=s),T||(o?T=(await this.z.getExtensions([{...s.identifier,version:s.version}],{targetPlatform:R,compatible:!0,productVersion:b},w.CancellationToken.None))[0]||null:T=await this.z.getCompatibleExtension(s,f,R,b)),T}async P(s,o){const f={...o,profileLocation:s.isApplicationScoped?this.H.defaultProfile.extensionsResource:o.profileLocation??this.X()},b=J=>`${J.id.toLowerCase()}${f.versionOnly?`-${s.manifest.version}`:""}${f.profileLocation?`@${f.profileLocation.toString()}`:""}`,R=this.m.get(b(s.identifier));if(R)return this.F.info("Extensions is already requested to uninstall",s.identifier.id),R.waitUntilTaskIsFinished();const T=J=>{const Q=this.Z(J,f);return this.m.set(b(Q.extension.identifier),Q),f.profileLocation?this.F.info("Uninstalling extension from the profile:",`${J.identifier.id}@${J.manifest.version}`,f.profileLocation.toString()):this.F.info("Uninstalling extension:",`${J.identifier.id}@${J.manifest.version}`),this.t.fire({identifier:J.identifier,profileLocation:f.profileLocation,applicationScoped:J.isApplicationScoped}),Q},D=(J,Q)=>{Q?f.profileLocation?this.F.error("Failed to uninstall extension from the profile:",`${J.identifier.id}@${J.manifest.version}`,f.profileLocation.toString(),Q.message):this.F.error("Failed to uninstall extension:",`${J.identifier.id}@${J.manifest.version}`,Q.message):f.profileLocation?this.F.info("Successfully uninstalled extension from the profile",`${J.identifier.id}@${J.manifest.version}`,f.profileLocation.toString()):this.F.info("Successfully uninstalled extension:",`${J.identifier.id}@${J.manifest.version}`),n(this.C,"extensionGallery:uninstall",{extensionData:(0,$.$Rp)(J),error:Q}),this.u.fire({identifier:J.identifier,error:Q?.code,profileLocation:f.profileLocation,applicationScoped:J.isApplicationScoped})},A=[],z=[];try{A.push(T(s));const J=await this.getInstalled(g.ExtensionType.User,f.profileLocation);if(f.donotIncludePack)this.F.info("Uninstalling the extension without including packed extension",`${s.identifier.id}@${s.manifest.version}`);else{const Q=this.S(s,J);for(const se of Q)this.m.has(b(se.identifier))?this.F.info("Extensions is already requested to uninstall",se.identifier.id):A.push(T(se))}f.donotCheckDependents?this.F.info("Uninstalling the extension without checking dependents",`${s.identifier.id}@${s.manifest.version}`):this.Q(A.map(Q=>Q.extension),J,s),await this.L(A.map(async Q=>{try{if(await Q.run(),await this.L(this.y.map(se=>se.postUninstall(Q.extension,f,w.CancellationToken.None))),Q.extension.identifier.uuid)try{await this.z.reportStatistic(Q.extension.manifest.publisher,Q.extension.manifest.name,Q.extension.manifest.version,u.StatisticType.Uninstall)}catch{}D(Q.extension)}catch(se){const le=a(se);throw D(Q.extension,le),le}finally{z.push(Q)}}))}catch(J){const Q=a(J);for(const se of A){try{se.cancel()}catch{}z.includes(se)||D(se.extension,Q)}throw Q}finally{for(const J of A)this.m.delete(b(J.extension.identifier))||this.F.warn("Uninstallation task is not found in the cache",J.extension.identifier.id)}}Q(s,o,f){for(const b of s){const R=this.U(b,o);if(R.length){const T=R.filter(D=>!s.some(A=>(0,$.$Kp)(A.identifier,D.identifier)));if(T.length)throw new Error(this.R(b,T,f))}}}R(s,o,f){return f===s?o.length===1?h.localize(7,null,f.manifest.displayName||f.manifest.name,o[0].manifest.displayName||o[0].manifest.name):o.length===2?h.localize(8,null,f.manifest.displayName||f.manifest.name,o[0].manifest.displayName||o[0].manifest.name,o[1].manifest.displayName||o[1].manifest.name):h.localize(9,null,f.manifest.displayName||f.manifest.name,o[0].manifest.displayName||o[0].manifest.name,o[1].manifest.displayName||o[1].manifest.name):o.length===1?h.localize(10,null,f.manifest.displayName||f.manifest.name,s.manifest.displayName||s.manifest.name,o[0].manifest.displayName||o[0].manifest.name):o.length===2?h.localize(11,null,f.manifest.displayName||f.manifest.name,s.manifest.displayName||s.manifest.name,o[0].manifest.displayName||o[0].manifest.name,o[1].manifest.displayName||o[1].manifest.name):h.localize(12,null,f.manifest.displayName||f.manifest.name,s.manifest.displayName||s.manifest.name,o[0].manifest.displayName||o[0].manifest.name,o[1].manifest.displayName||o[1].manifest.name)}S(s,o,f=[]){if(f.indexOf(s)!==-1)return[];f.push(s);const b=s.manifest.extensionPack?s.manifest.extensionPack:[];if(b.length){const R=o.filter(D=>!D.isBuiltin&&b.some(A=>(0,$.$Kp)({id:A},D.identifier))),T=[];for(const D of R)T.push(...this.S(D,o,f));return[...R,...T]}return[]}U(s,o){return o.filter(f=>f.manifest.extensionDependencies&&f.manifest.extensionDependencies.some(b=>(0,$.$Kp)({id:b},s.identifier)))}async W(){try{return this.F.trace("ExtensionManagementService.updateControlCache"),await this.z.getExtensionsControlManifest()}catch(s){return this.F.trace("ExtensionManagementService.refreshControlCache - failed to get extension control manifest",(0,O.$ab)(s)),{malicious:[],deprecated:{},search:[]}}}};t.$Dq=e,t.$Dq=e=ye([re(0,u.$jp),re(1,p.$_l),re(2,k.$Kl),re(3,v.$ak),re(4,d.$tk),re(5,y.$Ml)],e);function a(i,s){if(i instanceof u.$lp)return i;let o;return i instanceof u.$kp?o=new u.$lp(i.message,i.code===u.ExtensionGalleryErrorCode.DownloadFailedWriting?u.ExtensionManagementErrorCode.DownloadFailedWriting:u.ExtensionManagementErrorCode.Gallery):o=new u.$lp(i.message,(0,O.$7)(i)?u.ExtensionManagementErrorCode.Cancelled:s??u.ExtensionManagementErrorCode.Internal),o.stack=i.stack,o}function n(i,s,{extensionData:o,verificationStatus:f,duration:b,error:R,source:T,durationSinceUpdate:D}){let A,z;(0,l.$og)(f)&&(f===!0?f="Verified":(f===!1||(A=u.ExtensionManagementErrorCode.Signature,z=f),f="Unverified")),R&&(A=R.code,R.code===u.ExtensionManagementErrorCode.Signature&&(z=R.message)),i.publicLog(s,{...o,verificationStatus:f,success:!R,duration:b,errorcode:A,errorcodeDetail:z,durationSinceUpdate:D,source:T})}class r{constructor(){this.d=new S.$Fh}async waitUntilTaskIsFinished(){return await this.d.wait(),this.g}run(){return this.g||(this.g=(0,S.$th)(s=>this.h(s))),this.d.open(),this.g}cancel(){this.g||(this.g=(0,S.$th)(s=>new Promise((o,f)=>{const b=s.onCancellationRequested(()=>{b.dispose(),f(new O.$8)})})),this.d.open()),this.g.cancel()}}t.$Fq=r}),define(oe[42],ae([0,1,8,14,2,5,31,12,21,27,10,11,6,25,24,3,9,19]),function(H,t,E,S,w,O,L,I,m,l,c,h,u,$,g,N,v,d){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Iq=t.$Hq=t.$Gq=t.ExtensionsProfileScanningErrorCode=void 0;var p;(function(n){n.ERROR_PROFILE_NOT_FOUND="ERROR_PROFILE_NOT_FOUND",n.ERROR_INVALID_CONTENT="ERROR_INVALID_CONTENT"})(p||(t.ExtensionsProfileScanningErrorCode=p={}));class k extends Error{constructor(r,i){super(r),this.code=i}}t.$Gq=k,t.$Hq=(0,h.$Gi)("IExtensionsProfileScannerService");let y=class extends w.$Xc{constructor(r,i,s,o,f,b){super(),this.j=r,this.m=i,this.n=s,this.r=o,this.s=f,this.t=b,this.b=this.B(new O.$ne),this.onAddExtensions=this.b.event,this.c=this.B(new O.$ne),this.onDidAddExtensions=this.c.event,this.f=this.B(new O.$ne),this.onRemoveExtensions=this.f.event,this.g=this.B(new O.$ne),this.onDidRemoveExtensions=this.g.event,this.h=new L.$Dc}scanProfileExtensions(r,i){return this.u(r,void 0,i)}async addExtensionsToProfile(r,i,s){const o=[],f=[];try{return await this.u(i,b=>{const R=[];if(s)R.push(...b);else for(const T of b)r.some(([D])=>(0,l.$Kp)(D.identifier,T.identifier)&&D.manifest.version!==T.version)?o.push(T):R.push(T);for(const[T,D]of r){const A=R.findIndex(J=>(0,l.$Kp)(J.identifier,T.identifier)&&J.version===T.manifest.version),z={identifier:T.identifier,version:T.manifest.version,location:T.location,metadata:D};A===-1?(f.push(z),R.push(z)):R.splice(A,1,z)}return f.length&&this.b.fire({extensions:f,profileLocation:i}),o.length&&this.f.fire({extensions:o,profileLocation:i}),R}),f.length&&this.c.fire({extensions:f,profileLocation:i}),o.length&&this.g.fire({extensions:o,profileLocation:i}),f}catch(b){throw f.length&&this.c.fire({extensions:f,error:b,profileLocation:i}),o.length&&this.g.fire({extensions:o,error:b,profileLocation:i}),b}}async updateMetadata(r,i){const s=[];return await this.u(i,o=>{const f=[];for(const b of o){const R=r.find(([T])=>(0,l.$Kp)(T.identifier,b.identifier)&&T.manifest.version===b.version);R&&(b.metadata={...b.metadata,...R[1]},s.push(b)),f.push(b)}return f}),s}async removeExtensionFromProfile(r,i){const s=[];try{await this.u(i,o=>{const f=[];for(const b of o)(0,l.$Kp)(b.identifier,r.identifier)?s.push(b):f.push(b);return s.length&&this.f.fire({extensions:s,profileLocation:i}),f}),s.length&&this.g.fire({extensions:s,profileLocation:i})}catch(o){throw s.length&&this.g.fire({extensions:s,error:o,profileLocation:i}),o}}async u(r,i,s){return this.F(r).queue(async()=>{let o=[],f;try{const b=await this.m.readFile(r);f=JSON.parse(b.value.toString().trim()||"[]")}catch(b){if((0,c.$rl)(b)!==c.FileOperationResult.FILE_NOT_FOUND)throw b;if(this.r.extUri.isEqual(r,this.n.defaultProfile.extensionsResource)&&(f=await this.D()),!f&&s?.bailOutWhenFileNotFound)throw new k((0,v.$ab)(b),p.ERROR_PROFILE_NOT_FOUND)}if(f){Array.isArray(f)||this.w(r);let b=!1;for(const R of f){e(R)||this.w(r);let T;if((0,N.$gg)(R.relativeLocation)&&R.relativeLocation)T=this.z(R.relativeLocation);else if((0,N.$gg)(R.location)){this.t.warn(`Extensions profile: Ignoring extension with invalid location: ${R.location}`);continue}else{T=I.URI.revive(R.location);const D=this.y(T);D&&(b=!0,R.relativeLocation=D)}(0,N.$ng)(R.metadata?.hasPreReleaseVersion)&&R.metadata?.preRelease&&(b=!0,R.metadata.hasPreReleaseVersion=!0),o.push({identifier:R.identifier,location:T,version:R.version,metadata:R.metadata})}b&&await this.m.writeFile(r,S.$Pe.fromString(JSON.stringify(f)))}if(i){o=i(o);const b=o.map(R=>({identifier:R.identifier,version:R.version,location:R.location.toJSON(),relativeLocation:this.y(R.location),metadata:R.metadata}));await this.m.writeFile(r,S.$Pe.fromString(JSON.stringify(b)))}return o})}w(r){const i=new k(`Invalid extensions content in ${r.toString()}`,p.ERROR_INVALID_CONTENT);throw this.s.publicLogError2("extensionsProfileScanningError",{code:i.code}),i}y(r){return this.r.extUri.isEqual(this.r.extUri.dirname(r),this.j)?this.r.extUri.basename(r):void 0}z(r){return this.r.extUri.joinPath(this.j,r)}async D(){return this.C||(this.C=(async()=>{const r=this.r.extUri.joinPath(this.n.defaultProfile.location,"extensions.json"),i=this.r.extUri.joinPath(this.j,".init-default-profile-extensions");let s;try{s=(await this.m.readFile(r)).value.toString()}catch(f){if((0,c.$rl)(f)===c.FileOperationResult.FILE_NOT_FOUND)return;throw f}this.t.info("Migrating extensions from old default profile location",r.toString());let o;try{const f=JSON.parse(s);Array.isArray(f)&&f.every(b=>e(b))?o=f:this.t.warn("Skipping migrating from old default profile locaiton: Found invalid data",f)}catch(f){this.t.error(f)}if(o)try{await this.m.createFile(this.n.defaultProfile.extensionsResource,S.$Pe.fromString(JSON.stringify(o)),{overwrite:!1}),this.t.info("Migrated extensions from old default profile location to new location",r.toString(),this.n.defaultProfile.extensionsResource.toString())}catch(f){if((0,c.$rl)(f)===c.FileOperationResult.FILE_MODIFIED_SINCE)this.t.info("Migration from old default profile location to new location is done by another window",r.toString(),this.n.defaultProfile.extensionsResource.toString());else throw f}try{await this.m.del(r)}catch(f){(0,c.$rl)(f)!==c.FileOperationResult.FILE_NOT_FOUND&&this.t.error(f)}try{await this.m.del(i)}catch(f){(0,c.$rl)(f)!==c.FileOperationResult.FILE_NOT_FOUND&&this.t.error(f)}return o})()),this.C}F(r){let i=this.h.get(r);return i||(i=new E.$Nh,this.h.set(r,i)),i}};t.$Iq=y,t.$Iq=y=ye([re(1,c.$al),re(2,$.$Ml),re(3,g.$Kl),re(4,d.$_l),re(5,u.$ak)],y);function e(n){return(0,N.$ig)(n)&&(0,m.$ip)(n.identifier)&&(a(n.location)||(0,N.$gg)(n.location)&&n.location)&&((0,N.$ng)(n.relativeLocation)||(0,N.$gg)(n.relativeLocation))&&n.version&&(0,N.$gg)(n.version)}function a(n){return n?(0,N.$gg)(n.path)&&(0,N.$gg)(n.scheme):!1}});var qe=this&&this.__importDefault||function(H){return H&&H.__esModule?H:{default:H}};define(oe[54],ae([0,1,20,8,28,14,9,34,85,2,15,16,13,17,45,56,3,12,102,18,27,23,44,10,11,6,33,5,48,42,25,24,121]),function(H,t,E,S,w,O,L,I,m,l,c,h,u,$,g,N,v,d,p,k,y,e,a,n,r,i,s,o,f,b,R,T,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Pq=t.$Nq=t.$Mq=t.$Lq=t.Translations=void 0,t.$Oq=le,w=be(w),h=be(h),u=be(u),g=be(g),N=qe(N);var A;(function(fe){function x(_,B){if(_===B)return!0;const M=Object.keys(_),G=new Set;for(const Y of Object.keys(B))G.add(Y);if(M.length!==G.size)return!1;for(const Y of M){if(_[Y]!==B[Y])return!1;G.delete(Y)}return G.size===0}fe.equals=x})(A||(t.Translations=A={})),t.$Lq=(0,r.$Gi)("IExtensionsScannerService");let z=class extends l.$Xc{constructor(x,_,B,M,G,Y,te,F,q,K,V,P){super(),this.systemExtensionsLocation=x,this.userExtensionsLocation=_,this.r=B,this.s=M,this.t=G,this.u=Y,this.w=te,this.y=F,this.z=q,this.C=K,this.D=V,this.F=P,this.g=this.B(new o.$ne),this.onDidChangeCache=this.g.event,this.h=(0,$.$hh)(this.userExtensionsLocation,".obsolete"),this.j=this.B(this.F.createInstance(se,this.s,this.h)),this.m=this.B(this.F.createInstance(se,this.s,this.h)),this.n=this.B(this.F.createInstance(Q,this.h)),this.H=void 0,this.B(this.j.onDidChangeCache(()=>this.g.fire(e.ExtensionType.System))),this.B(this.m.onDidChangeCache(()=>this.g.fire(e.ExtensionType.User)))}getTargetPlatform(){return this.G||(this.G=(0,y.$Vp)(this.w,this.y)),this.G}async scanAllExtensions(x,_,B){const[M,G]=await Promise.all([this.scanSystemExtensions(x),this.scanUserExtensions(_)]),Y=B?await this.scanExtensionsUnderDevelopment(x,[...M,...G]):[];return this.L(M,G,Y,await this.getTargetPlatform(),!0)}async scanSystemExtensions(x){const _=[];_.push(this.M(!!x.useCache,x.language)),_.push(this.N(x.language,!!x.checkControlFile));const[B,M]=await Promise.all(_);return this.J([...B,...M],e.ExtensionType.System,x,!1)}async scanUserExtensions(x){const _=x.profileLocation??this.userExtensionsLocation;this.y.trace("Started scanning user extensions",_);const B=this.D.extUri.isEqual(x.profileLocation,this.t.defaultProfile.extensionsResource)?{bailOutWhenFileNotFound:!0}:void 0,M=await this.P(_,!!x.profileLocation,e.ExtensionType.User,!x.includeUninstalled,x.language,!0,B,x.productVersion??this.R()),G=x.useCache&&!M.devMode&&M.excludeObsolete?this.m:this.n;let Y;try{Y=await G.scanExtensions(M)}catch(te){if(te instanceof b.$Gq&&te.code===b.ExtensionsProfileScanningErrorCode.ERROR_PROFILE_NOT_FOUND)await this.I(),Y=await G.scanExtensions(M);else throw te}return Y=await this.J(Y,e.ExtensionType.User,x,!0),this.y.trace("Scanned user extensions:",Y.length),Y}async scanExtensionsUnderDevelopment(x,_){if(this.z.isExtensionDevelopment&&this.z.extensionDevelopmentLocationURI){const B=(await Promise.all(this.z.extensionDevelopmentLocationURI.filter(M=>M.scheme===c.Schemas.file).map(async M=>{const G=await this.P(M,!1,e.ExtensionType.User,!0,x.language,!1,void 0,x.productVersion??this.R());return(await this.n.scanOneOrMultipleExtensions(G)).map(te=>(te.type=_.find(F=>(0,y.$Kp)(F.identifier,te.identifier))?.type??te.type,this.n.validate(te,G)))}))).flat();return this.J(B,"development",x,!0)}return[]}async scanExistingExtension(x,_,B){const M=await this.P(x,!1,_,!0,B.language,!0,void 0,B.productVersion??this.R()),G=await this.n.scanExtension(M);return!G||!B.includeInvalid&&!G.isValid?null:G}async scanOneOrMultipleExtensions(x,_,B){const M=await this.P(x,!1,_,!0,B.language,!0,void 0,B.productVersion??this.R()),G=await this.n.scanOneOrMultipleExtensions(M);return this.J(G,_,B,!0)}async scanMultipleExtensions(x,_,B){const M=[];return await Promise.all(x.map(async G=>{const Y=await this.scanOneOrMultipleExtensions(G,_,B);M.push(...Y)})),this.J(M,_,B,!0)}async scanMetadata(x){const _=(0,$.$hh)(x,"package.json"),B=(await this.w.readFile(_)).value.toString();return JSON.parse(B).__metadata}async updateMetadata(x,_){const B=(0,$.$hh)(x,"package.json"),M=(await this.w.readFile(B)).value.toString(),G=JSON.parse(M);_.isMachineScoped===!1&&delete _.isMachineScoped,_.isBuiltin===!1&&delete _.isBuiltin,G.__metadata={...G.__metadata,..._},await this.w.writeFile((0,$.$hh)(x,"package.json"),O.$Pe.fromString(JSON.stringify(G,null,"	")))}async initializeDefaultProfileExtensions(){try{await this.u.scanProfileExtensions(this.t.defaultProfile.extensionsResource,{bailOutWhenFileNotFound:!0})}catch(x){if(x instanceof b.$Gq&&x.code===b.ExtensionsProfileScanningErrorCode.ERROR_PROFILE_NOT_FOUND)await this.I();else throw x}}async I(){return this.H||(this.H=(async()=>{try{this.y.info("Started initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString());const x=await this.scanUserExtensions({includeInvalid:!0});if(x.length)await this.u.addExtensionsToProfile(x.map(_=>[_,_.metadata]),this.t.defaultProfile.extensionsResource);else try{await this.w.createFile(this.t.defaultProfile.extensionsResource,O.$Pe.fromString(JSON.stringify([])))}catch(_){(0,n.$rl)(_)!==n.FileOperationResult.FILE_NOT_FOUND&&this.y.warn("Failed to create default profile extensions manifest in extensions installation folder.",this.userExtensionsLocation.toString(),(0,L.$ab)(_))}this.y.info("Completed initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString())}catch(x){this.y.error(x)}finally{this.H=void 0}})()),this.H}async J(x,_,B,M){return B.includeAllVersions||(x=this.L(_===e.ExtensionType.System?x:void 0,_===e.ExtensionType.User?x:void 0,_==="development"?x:void 0,await this.getTargetPlatform(),M)),B.includeInvalid||(x=x.filter(G=>G.isValid)),x.sort((G,Y)=>{const te=h.$qc(G.location.fsPath),F=h.$qc(Y.location.fsPath);return te<F?-1:te>F?1:0})}L(x,_,B,M,G){const Y=(F,q,K)=>{if(F.isValid&&!q.isValid)return!1;if(F.isValid===q.isValid){if(G&&g.gt(F.manifest.version,q.manifest.version))return this.y.debug(`Skipping extension ${q.location.path} with lower version ${q.manifest.version} in favour of ${F.location.path} with version ${F.manifest.version}`),!1;if(g.eq(F.manifest.version,q.manifest.version)){if(F.type===e.ExtensionType.System)return this.y.debug(`Skipping extension ${q.location.path} in favour of system extension ${F.location.path} with same version`),!1;if(F.targetPlatform===M)return this.y.debug(`Skipping extension ${q.location.path} from different target platform ${q.targetPlatform}`),!1}}return K?this.y.warn(`Overwriting user extension ${F.location.path} with ${q.location.path}.`):this.y.debug(`Overwriting user extension ${F.location.path} with ${q.location.path}.`),!0},te=new e.$tn;return x?.forEach(F=>{const q=te.get(F.identifier.id);(!q||Y(q,F,!1))&&te.set(F.identifier.id,F)}),_?.forEach(F=>{const q=te.get(F.identifier.id);if(!q&&x&&F.type===e.ExtensionType.System){this.y.debug(`Skipping obsolete system extension ${F.location.path}.`);return}(!q||Y(q,F,!1))&&te.set(F.identifier.id,F)}),B?.forEach(F=>{const q=te.get(F.identifier.id);(!q||Y(q,F,!0))&&te.set(F.identifier.id,F),te.set(F.identifier.id,F)}),[...te.values()]}async M(x,_){this.y.trace("Started scanning system extensions");const B=await this.P(this.systemExtensionsLocation,!1,e.ExtensionType.System,!0,_,!0,void 0,this.R()),G=await(x&&!B.devMode?this.j:this.n).scanExtensions(B);return this.y.trace("Scanned system extensions:",G.length),G}async N(x,_){const B=this.z.isBuilt?[]:this.C.builtInExtensions;if(!B?.length)return[];this.y.trace("Started scanning dev system extensions");const M=_?await this.O():{},G=[],Y=d.URI.file(h.$kc(h.$mc(c.$1g.asFileUri("").fsPath,"..",".build","builtInExtensions")));for(const F of B){const q=M[F.name]||"marketplace";switch(q){case"disabled":break;case"marketplace":G.push((0,$.$hh)(Y,F.name));break;default:G.push(d.URI.file(q));break}}const te=await Promise.all(G.map(async F=>this.n.scanExtension(await this.P(F,!1,e.ExtensionType.System,!0,x,!0,void 0,this.R()))));return this.y.trace("Scanned dev system extensions:",te.length),(0,E.$Kb)(te)}async O(){try{const x=await this.w.readFile(this.r);return JSON.parse(x.value.toString())}catch{return{}}}async P(x,_,B,M,G,Y,te,F){const q=await this.f(G??u.$w),K=await this.Q(x),V=_&&!this.D.extUri.isEqual(x,this.t.defaultProfile.extensionsResource)?this.t.defaultProfile.extensionsResource:void 0,P=V?await this.Q(V):void 0;return new J(x,K,V,P,_,te,B,M,Y,F.version,F.date,this.C.commit,!this.z.isBuilt,G,q)}async Q(x){try{const _=await this.w.stat(x);if(typeof _.mtime=="number")return _.mtime}catch{}}R(){return{version:this.C.version,date:this.C.date}}};t.$Mq=z,t.$Mq=z=ye([re(4,R.$Ml),re(5,b.$Hq),re(6,n.$al),re(7,i.$ak),re(8,k.$Ni),re(9,s.$tk),re(10,T.$Kl),re(11,r.$Fi)],z);class J{constructor(x,_,B,M,G,Y,te,F,q,K,V,P,j,U,C){this.location=x,this.mtime=_,this.applicationExtensionslocation=B,this.applicationExtensionslocationMtime=M,this.profile=G,this.profileScanOptions=Y,this.type=te,this.excludeObsolete=F,this.validate=q,this.productVersion=K,this.productDate=V,this.productCommit=P,this.devMode=j,this.language=U,this.translations=C}static createNlsConfiguration(x){return{language:x.language,pseudo:x.language==="pseudo",devMode:x.devMode,translations:x.translations}}static equals(x,_){return(0,$.$ah)(x.location,_.location)&&x.mtime===_.mtime&&(0,$.$ah)(x.applicationExtensionslocation,_.applicationExtensionslocation)&&x.applicationExtensionslocationMtime===_.applicationExtensionslocationMtime&&x.profile===_.profile&&w.$io(x.profileScanOptions,_.profileScanOptions)&&x.type===_.type&&x.excludeObsolete===_.excludeObsolete&&x.validate===_.validate&&x.productVersion===_.productVersion&&x.productDate===_.productDate&&x.productCommit===_.productCommit&&x.devMode===_.devMode&&x.language===_.language&&A.equals(x.translations,_.translations)}}t.$Nq=J;let Q=class extends l.$Xc{constructor(x,_,B,M,G,Y){super(),this.g=x,this.h=_,this.j=B,this.m=M,this.n=Y,this.f=G.extensionsEnabledWithApiProposalVersion?.map(te=>te.toLowerCase())??[]}async scanExtensions(x){const _=x.profile?await this.s(x):await this.r(x);let B={};if(x.excludeObsolete&&x.type===e.ExtensionType.User)try{const M=(await this.m.readFile(this.g)).value.toString();B=JSON.parse(M)}catch{}return(0,v.$tg)(B)?_:_.filter(M=>!B[y.$Lp.create(M).toString()])}async r(x){const _=await this.m.resolve(x.location);if(!_.children?.length)return[];const B=await Promise.all(_.children.map(async M=>{if(!M.isDirectory||x.type===e.ExtensionType.User&&(0,$.$eh)(M.resource).indexOf(".")===0)return null;const G=new J(M.resource,x.mtime,x.applicationExtensionslocation,x.applicationExtensionslocationMtime,x.profile,x.profileScanOptions,x.type,x.excludeObsolete,x.validate,x.productVersion,x.productDate,x.productCommit,x.devMode,x.language,x.translations);return this.scanExtension(G)}));return(0,E.$Kb)(B).sort((M,G)=>M.location.path<G.location.path?-1:1)}async s(x){let _=await this.t(x.location,()=>!0,x);if(x.applicationExtensionslocation&&!this.j.extUri.isEqual(x.location,x.applicationExtensionslocation)){_=_.filter(M=>!M.metadata?.isApplicationScoped);const B=await this.t(x.applicationExtensionslocation,M=>!!M.metadata?.isBuiltin||!!M.metadata?.isApplicationScoped,x);_.push(...B)}return _}async t(x,_,B){const M=await this.h.scanProfileExtensions(x,B.profileScanOptions);if(!M.length)return[];const G=await Promise.all(M.map(async Y=>{if(_(Y)){const te=new J(Y.location,B.mtime,B.applicationExtensionslocation,B.applicationExtensionslocationMtime,B.profile,B.profileScanOptions,B.type,B.excludeObsolete,B.validate,B.productVersion,B.productDate,B.productCommit,B.devMode,B.language,B.translations);return this.scanExtension(te,Y.metadata)}return null}));return(0,E.$Kb)(G)}async scanOneOrMultipleExtensions(x){try{if(await this.m.exists((0,$.$hh)(x.location,"package.json"))){const _=await this.scanExtension(x);return _?[_]:[]}else return await this.scanExtensions(x)}catch(_){return this.n.error(`Error scanning extensions at ${x.location.path}:`,(0,L.$ab)(_)),[]}}async scanExtension(x,_){try{let B=await this.u(x.location);if(B){B.publisher||(B.publisher=e.$nn),_=_??B.__metadata,delete B.__metadata;const M=(0,y.$Pp)(B.publisher,B.name),G=_?.id?{id:M,uuid:_.id}:{id:M},Y=_?.isSystem?e.ExtensionType.System:x.type,te=Y===e.ExtensionType.System||!!_?.isBuiltin;B=await this.w(x.location,B,J.createNlsConfiguration(x));let F={type:Y,identifier:G,manifest:B,location:x.location,isBuiltin:te,targetPlatform:_?.targetPlatform??e.TargetPlatform.UNDEFINED,publisherDisplayName:_?.publisherDisplayName,metadata:_,isValid:!0,validations:[]};return x.validate&&(F=this.validate(F,x)),B.enabledApiProposals&&this.f.includes(M.toLowerCase())&&(B.enabledApiProposals=(0,e.$zn)([...B.enabledApiProposals])),F}}catch(B){x.type!==e.ExtensionType.System&&this.n.error(B)}return null}validate(x,_){let B=!0;const M=this.f.includes(x.identifier.id.toLowerCase()),G=(0,a.$2p)(_.productVersion,_.productDate,_.location,x.manifest,x.isBuiltin,M);for(const[Y,te]of G)Y===N.default.Error&&(B=!1,this.n.error(this.D(_.location,te)));return x.isValid=B,x.validations=G,x}async u(x){const _=(0,$.$hh)(x,"package.json");let B;try{B=(await this.m.readFile(_)).value.toString()}catch(G){return(0,n.$rl)(G)!==n.FileOperationResult.FILE_NOT_FOUND&&this.n.error(this.D(x,(0,p.localize)(0,null,_.path,G.message))),null}let M;try{M=JSON.parse(B)}catch{const Y=[];(0,I.$Yn)(B,Y);for(const te of Y)this.n.error(this.D(x,(0,p.localize)(1,null,_.path,te.offset,te.length,(0,m.$Jq)(te.error))));return null}return(0,I.$7n)(M)!=="object"?(this.n.error(this.D(x,(0,p.localize)(2,null,_.path))),null):M}async w(x,_,B){const M=await this.y(x,_,B);if(M)try{const G=[],Y=await this.z(M.default,G);if(G.length>0)return G.forEach(F=>{this.n.error(this.D(x,(0,p.localize)(3,null,M.default?.path,(0,m.$Jq)(F.error))))}),_;if((0,I.$7n)(M)!=="object")return this.n.error(this.D(x,(0,p.localize)(4,null,M.default?.path))),_;const te=M.values||Object.create(null);return(0,D.$Kq)(this.n,_,te,Y)}catch{}return _}async y(x,_,B){const M=(0,$.$hh)(x,"package.nls.json"),G=(q,K)=>{K.forEach(V=>{this.n.error(this.D(x,(0,p.localize)(5,null,q?.path,(0,m.$Jq)(V.error))))})},Y=q=>{this.n.error(this.D(x,(0,p.localize)(6,null,q?.path)))},te=`${_.publisher}.${_.name}`,F=B.translations[te];if(F)try{const q=d.URI.file(F),K=(await this.m.readFile(q)).value.toString(),V=[],P=(0,I.$Yn)(K,V);return V.length>0?(G(q,V),{values:void 0,default:M}):(0,I.$7n)(P)!=="object"?(Y(q),{values:void 0,default:M}):{values:P.contents?P.contents.package:void 0,default:M}}catch{return{values:void 0,default:M}}else{if(!await this.m.exists(M))return;let K;try{K=await this.C(x,B)}catch{return}if(!K.localized)return{values:void 0,default:K.original};try{const V=(await this.m.readFile(K.localized)).value.toString(),P=[],j=(0,I.$Yn)(V,P);return P.length>0?(G(K.localized,P),{values:void 0,default:K.original}):(0,I.$7n)(j)!=="object"?(Y(K.localized),{values:void 0,default:K.original}):{values:j,default:K.original}}catch{return{values:void 0,default:K.original}}}}async z(x,_){if(x)try{const B=(await this.m.readFile(x)).value.toString();return(0,I.$Yn)(B,_)}catch{}}C(x,_){return new Promise((B,M)=>{const G=Y=>{const te=(0,$.$hh)(x,`package.nls.${Y}.json`);this.m.exists(te).then(F=>{F&&B({localized:te,original:(0,$.$hh)(x,"package.nls.json")});const q=Y.lastIndexOf("-");q===-1?B({localized:(0,$.$hh)(x,"package.nls.json"),original:null}):(Y=Y.substring(0,q),G(Y))})};if(_.devMode||_.pseudo||!_.language)return B({localized:(0,$.$hh)(x,"package.nls.json"),original:null});G(_.language)})}D(x,_){return`[${x.path}]: ${_}`}};Q=ye([re(1,b.$Hq),re(2,T.$Kl),re(3,n.$al),re(4,s.$tk),re(5,i.$ak)],Q);let se=class extends Q{constructor(x,_,B,M,G,Y,te,F){super(_,M,G,Y,te,F),this.I=x,this.J=B,this.G=this.B(new S.$Eh(3e3)),this.H=this.B(new o.$ne),this.onDidChangeCache=this.H.event}async scanExtensions(x){const _=this.O(x),B=await this.L(_);if(this.F=x,B&&B.input&&J.equals(B.input,this.F))return this.n.debug("Using cached extensions scan result",x.type===e.ExtensionType.System?"system":"user",x.location.toString()),this.G.trigger(()=>this.N()),B.result.map(G=>(G.location=d.URI.revive(G.location),G));const M=await super.scanExtensions(x);return await this.M(_,{input:x,result:M}),M}async L(x){try{const _=await this.m.readFile(x),B=JSON.parse(_.value.toString());return{result:B.result,input:(0,f.$di)(B.input)}}catch(_){this.n.debug("Error while reading the extension cache file:",x.path,(0,L.$ab)(_))}return null}async M(x,_){try{await this.m.writeFile(x,O.$Pe.fromString(JSON.stringify(_)))}catch(B){this.n.debug("Error while writing the extension cache file:",x.path,(0,L.$ab)(B))}}async N(){if(!this.F)return;const x=this.O(this.F),_=await this.L(x);if(!_)return;const B=_.result,M=JSON.parse(JSON.stringify(await super.scanExtensions(this.F)));if(!w.$io(M,B))try{this.n.info("Invalidating Cache",B,M),await this.m.del(x),this.H.fire()}catch(G){this.n.error(G)}}O(x){const _=this.P(x);return this.j.extUri.joinPath(_.cacheHome,x.type===e.ExtensionType.System?e.$mn:e.$ln)}P(x){return x.type===e.ExtensionType.System?this.J.defaultProfile:x.profile?this.j.extUri.isEqual(x.location,this.I.extensionsResource)?this.I:this.J.profiles.find(_=>this.j.extUri.isEqual(x.location,_.extensionsResource))??this.I:this.J.defaultProfile}};se=ye([re(2,R.$Ml),re(3,b.$Hq),re(4,T.$Kl),re(5,n.$al),re(6,s.$tk),re(7,i.$ak)],se);function le(fe,x){const _=(0,y.$Np)(fe.manifest.publisher,fe.manifest.name);return{id:_,identifier:new e.$rn(_),isBuiltin:fe.type===e.ExtensionType.System,isUserBuiltin:fe.type===e.ExtensionType.User&&fe.isBuiltin,isUnderDevelopment:x,extensionLocation:fe.location,uuid:fe.identifier.uuid,targetPlatform:fe.targetPlatform,publisherDisplayName:fe.publisherDisplayName,...fe.manifest}}class ue extends z{constructor(x,_,B,M,G,Y,te,F,q,K,V,P){super(x,_,(0,$.$hh)(B,".vscode-oss-dev","extensions","control.json"),M,G,Y,te,F,q,K,V,P),this.S=(async()=>{if(u.$z)try{const j=await this.w.readFile(d.URI.file(u.$z));return JSON.parse(j.value.toString())}catch{}return Object.create(null)})()}f(x){return this.S}}t.$Pq=ue}),define(oe[161],ae([0,1,60,8,38,5,2,15,16,26,6,25]),function(H,t,E,S,w,O,L,I,m,l,c,h){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Tq=void 0;let u=class extends L.$Xc{constructor(g,N){super(),this.b=g,this.f=N,this.a=new S.$Mh(5)}async postUninstall(g){const N=this.g(g,"uninstall");N&&(this.f.info(g.identifier.id,g.manifest.version,"Running post uninstall script"),await this.a.queue(async()=>{try{await this.h(N.script,"uninstall",N.args,!0,g),this.f.info("Finished running post uninstall script",g.identifier.id,g.manifest.version)}catch(v){this.f.error("Failed to run post uninstall script",g.identifier.id,g.manifest.version),this.f.error(v)}}));try{await l.Promises.rm(this.m(g))}catch(v){this.f.error("Error while removing extension storage path",g.identifier.id),this.f.error(v)}}g(g,N){const v=`vscode:${N}`;if(g.location.scheme===I.Schemas.file&&g.manifest&&g.manifest.scripts&&typeof g.manifest.scripts[v]=="string"){const d=g.manifest.scripts[v].split(" ");return d.length<2||d[0]!=="node"||!d[1]?(this.f.warn(g.identifier.id,g.manifest.version,`${v} should be a node script`),null):{script:(0,m.$mc)(g.location.fsPath,d[1]),args:d.slice(2)||[]}}return null}h(g,N,v,d,p){return new Promise((k,y)=>{const e=this.j(g,N,v,p);let a;const n=r=>{a&&(clearTimeout(a),a=null),r?y(r):k(void 0)};e.on("error",r=>{n((0,w.$rj)(r)||"Unknown")}),e.on("exit",(r,i)=>{n(r?`post-${N} process exited with code ${r}`:void 0)}),d&&(a=setTimeout(()=>{a=null,e.kill(),y("timed out")},5e3))})}j(g,N,v,d){const p={silent:!0,execArgv:void 0},k=(0,E.fork)(g,[`--type=extension-post-${N}`,...v],p);k.stdout.setEncoding("utf8"),k.stderr.setEncoding("utf8");const y=O.Event.fromNodeEventEmitter(k.stdout,"data"),e=O.Event.fromNodeEventEmitter(k.stderr,"data");this.B(y(r=>this.f.info(d.identifier.id,d.manifest.version,`post-${N}`,r))),this.B(e(r=>this.f.error(d.identifier.id,d.manifest.version,`post-${N}`,r)));const a=O.Event.any(O.Event.map(y,r=>({data:`%c${r}`,format:[""]}),this.q),O.Event.map(e,r=>({data:`%c${r}`,format:["color: red"]}),this.q));return O.Event.debounce(a,(r,i)=>r?{data:r.data+i.data,format:[...r.format,...i.format]}:{data:i.data,format:i.format},100,void 0,void 0,void 0,this.q)(r=>{console.group(d.identifier.id),console.log(r.data,...r.format),console.groupEnd()}),k}m(g){return(0,m.$mc)(this.b.defaultProfile.globalStorageHome.fsPath,g.identifier.id.toLowerCase())}};t.$Tq=u,t.$Tq=u=ye([re(0,h.$Ml),re(1,c.$ak)],u)}),define(oe[72],ae([0,1,50,104,53,21]),function(H,t,E,S,w,O){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Qq=L,t.$Rq=I;function L(m){let l=O.ExtensionManagementErrorCode.Extract;return m instanceof E.$zq&&(m.type==="CorruptZip"?l=O.ExtensionManagementErrorCode.CorruptZip:m.type==="Incomplete"&&(l=O.ExtensionManagementErrorCode.IncompleteZip)),(0,w.$Eq)(m,l)}async function I(m){let l;try{l=await(0,E.$Cq)(m,"extension/package.json")}catch(c){throw L(c)}try{return JSON.parse(l.toString("utf8"))}catch{throw new O.$lp((0,S.localize)(0,null),O.ExtensionManagementErrorCode.Invalid)}}}),define(oe[162],ae([0,1,8,9,2,15,17,45,3,29,26,50,30,18,53,21,27,72,71,10,6,19]),function(H,t,E,S,w,O,L,I,m,l,c,h,u,$,g,N,v,d,p,k,y,e){"use strict";var a;Object.defineProperty(t,"__esModule",{value:!0}),t.$Sq=void 0,I=be(I);let n=class extends w.$Xc{static{a=this}static{this.c=".sigzip"}constructor(i,s,o,f,b,R,T){super(),this.h=s,this.j=o,this.m=f,this.n=b,this.r=R,this.t=T,this.extensionsDownloadDir=i.extensionsDownloadLocation,this.f=20,this.g=this.F()}async download(i,s,o,f){await this.g;const b=await this.w(i,s);let R=!1;if(o&&this.u(i)){let T;try{T=await this.y(i)}catch(D){try{await this.delete(b)}catch(A){this.t.error(A)}throw D}try{R=await this.n.verify(i,b.fsPath,T.fsPath,f)}catch(D){if(R=D.code,R===p.ExtensionSignatureVerificationCode.PackageIsInvalidZip||R===p.ExtensionSignatureVerificationCode.SignatureArchiveIsInvalidZip){try{await this.delete(b)}catch(A){this.t.error(A)}throw new N.$lp(h.$yq,N.ExtensionManagementErrorCode.CorruptZip)}}finally{try{await this.delete(T)}catch(D){this.t.error(D)}}}return{location:b,verificationStatus:R}}u(i){if(!i.isSigned)return this.t.info(`Extension is not signed: ${i.identifier.id}`),!1;const s=this.m.getValue("extensions.verifySignature");return(0,m.$mg)(s)?s:!0}async w(i,s){try{const o=(0,L.$hh)(this.extensionsDownloadDir,this.G(i)),f=await this.C(i,"vsix",async()=>{await this.z(i,o,b=>this.j.download(i,b,s));try{await this.D(o.fsPath,"extension/package.json")}catch(b){try{await this.h.del(o)}catch(R){this.t.warn(`Error while deleting: ${o.path}`,(0,S.$ab)(R))}throw b}},2);return f>1&&this.r.publicLog2("extensiongallery:downloadvsix:retry",{extensionId:i.identifier.id,attempts:f}),o}catch(o){throw(0,g.$Eq)(o,N.ExtensionManagementErrorCode.Download)}}async y(i){try{const s=(0,L.$hh)(this.extensionsDownloadDir,`.${(0,l.$3g)()}`),o=await this.C(i,"sigzip",async()=>{await this.j.downloadSignatureArchive(i,s);try{await this.D(s.fsPath,".signature.p7s")}catch(f){try{await this.h.del(s)}catch(b){this.t.warn(`Error while deleting: ${s.path}`,(0,S.$ab)(b))}throw f}},2);return o>1&&this.r.publicLog2("extensiongallery:downloadsigzip:retry",{extensionId:i.identifier.id,attempts:o}),s}catch(s){throw(0,g.$Eq)(s,N.ExtensionManagementErrorCode.DownloadSignature)}}async z(i,s,o){if(await this.h.exists(s))return;if(s.scheme!==O.Schemas.file){await o(s);return}const f=(0,L.$hh)(this.extensionsDownloadDir,`.${(0,l.$3g)()}`);try{await o(f)}catch(b){try{await this.h.del(f)}catch{}throw b}try{await c.Promises.rename(f.fsPath,s.fsPath,2*60*1e3)}catch(b){try{await this.h.del(f)}catch{}let R=!1;try{R=await this.h.exists(s)}catch{}if(R)this.t.info("Rename failed because the file was downloaded by another source. So ignoring renaming.",i.identifier.id,s.path);else throw this.t.info(`Rename failed because of ${(0,S.$ab)(b)}. Deleted the file from downloaded location`,f.path),b}}async C(i,s,o,f){let b=1;for(;;)try{return await o(),b}catch(R){if(b++>f)throw R;this.t.warn(`Failed downloading ${s}. ${(0,S.$ab)(R)}. Retry again...`,i.identifier.id)}}async D(i,s){try{await(0,h.$Cq)(i,s)}catch(o){throw(0,d.$Qq)(o)}}async delete(i){await this.g,await this.h.del(i)}async F(){try{if(!await this.h.exists(this.extensionsDownloadDir)){this.t.trace("Extension VSIX downloads cache dir does not exist");return}const i=await this.h.resolve(this.extensionsDownloadDir,{resolveMetadata:!0});if(i.children){const s=[],o=[],f=[];for(const T of i.children)if(T.name.endsWith(a.c))f.push(T.resource);else{const D=v.$Lp.parse(T.name);D&&o.push([D,T])}const b=(0,v.$Qp)(o,([T])=>T),R=[];for(const T of b)T.sort((D,A)=>I.rcompare(D[0].version,A[0].version)),s.push(...T.slice(1).map(D=>D[1].resource)),R.push(T[0][1]);R.sort((T,D)=>T.mtime-D.mtime),s.push(...R.slice(0,Math.max(0,R.length-this.f)).map(T=>T.resource)),s.push(...f),await E.Promises.settled(s.map(T=>(this.t.trace("Deleting from cache",T.path),this.h.del(T))))}}catch(i){this.t.error(i)}}G(i){return this.f?v.$Lp.create(i).toString().toLowerCase():(0,l.$3g)()}};t.$Sq=n,t.$Sq=n=a=ye([re(0,$.$Oi),re(1,k.$al),re(2,N.$jp),re(3,u.$aj),re(4,p.$rq),re(5,e.$_l),re(6,y.$ak)],n)}),define(oe[163],ae([0,1,8,14,22,38,9,5,43,2,31,15,16,17,45,3,12,29,26,50,103,61,18,53,21,27,42,54,162,161,72,143,150,23,44,10,11,6,33,19,24,25]),function(H,t,E,S,w,O,L,I,m,l,c,h,u,$,g,N,v,d,p,k,y,e,a,n,r,i,s,o,f,b,R,T,D,A,z,J,Q,se,le,ue,fe,x){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Yq=t.$Xq=t.$Wq=void 0,u=be(u),g=be(g),p=be(p),y=be(y),t.$Wq=(0,Q.$Hi)(r.$mp);const _=".vsctmp";let B=class extends n.$Dq{constructor(F,q,K,V,P,j,U,C,X,Z,ne,ce){super(F,q,ne,K,Z,ce),this.eb=P,this.fb=j,this.gb=U,this.hb=C,this.ib=X,this.db=new Map,this.tb=new c.$Ec;const pe=this.B(C.createInstance(b.$Tq));this.ab=this.B(C.createInstance(M,ge=>pe.postUninstall(ge))),this.bb=this.B(new T.$Uq(ce,X,ne,this,this.F)),this.cb=this.B(C.createInstance(f.$Sq));const me=this.B(new D.$Vq(this,this.eb,ce,j,ne,X,K));this.B(me.onDidChangeExtensionsByAnotherSource(ge=>this.sb(ge))),this.ub()}getTargetPlatform(){return this.jb||(this.jb=(0,i.$Vp)(this.ib,this.F)),this.jb}async zip(F){this.F.trace("ExtensionManagementService#zip",F.identifier.id);const q=await this.rb(F),K=await(0,k.zip)((0,$.$hh)(this.cb.extensionsDownloadDir,(0,d.$3g)()).fsPath,q);return v.URI.file(K)}async unzip(F){return this.F.trace("ExtensionManagementService#unzip",F.toString()),(await this.install(F)).identifier}async getManifest(F){const{location:q,cleanup:K}=await this.lb(F),V=u.$nc(q.fsPath);try{return await(0,R.$Rq)(V)}finally{await K()}}getInstalled(F,q=this.H.defaultProfile.extensionsResource,K={version:this.G.version,date:this.G.date}){return this.ab.scanExtensions(F??null,q,K)}scanAllUserInstalledExtensions(){return this.ab.scanAllUserExtensions(!1)}scanInstalledExtensionAtLocation(F){return this.ab.scanUserExtensionAtLocation(F)}async install(F,q={}){this.F.trace("ExtensionManagementService#install",F.toString());const{location:K,cleanup:V}=await this.lb(F);try{const P=await(0,R.$Rq)(u.$nc(K.fsPath)),j=(0,i.$Pp)(P.publisher,P.name);if(P.engines&&P.engines.vscode&&!(0,z.$4p)(P.engines.vscode,this.G.version,this.G.date))throw new Error(y.localize(0,null,j,this.G.version));const C=(await this.I([{manifest:P,extension:K,options:q}])).find(({identifier:X})=>(0,i.$Kp)(X,{id:j}));if(C?.local)return C.local;throw C?.error?C.error:(0,n.$Eq)(new Error(`Unknown error while installing extension ${j}`))}finally{await V()}}async installFromLocation(F,q){this.F.trace("ExtensionManagementService#installFromLocation",F.toString());const K=await this.ab.scanUserExtensionAtLocation(F);if(!K||!K.manifest.name||!K.manifest.version)throw new Error(`Cannot find a valid extension from the location ${F.toString()}`);return await this.wb([[K,{source:"resource"}]],q),this.F.info("Successfully installed extension",K.identifier.id,q.toString()),K}async installExtensionsFromProfile(F,q,K){this.F.trace("ExtensionManagementService#installExtensionsFromProfile",F,q.toString(),K.toString());const V=(await this.getInstalled(A.ExtensionType.User,q)).filter(P=>F.some(j=>(0,i.$Kp)(j,P.identifier)));if(V.length){const P=await Promise.all(V.map(j=>this.ab.scanMetadata(j,q)));await this.wb(V.map((j,U)=>[j,P[U]]),K),this.F.info("Successfully installed extensions",V.map(j=>j.identifier.id),K.toString())}return V}async updateMetadata(F,q,K){return this.F.trace("ExtensionManagementService#updateMetadata",F.identifier.id),q.isPreReleaseVersion&&(q.preRelease=!0,q.hasPreReleaseVersion=!0),q.isMachineScoped===!1&&(q.isMachineScoped=void 0),q.isBuiltin===!1&&(q.isBuiltin=void 0),q.pinned===!1&&(q.pinned=void 0),F=await this.ab.updateMetadata(F,q,K),this.bb.invalidate(K),this.w.fire({local:F,profileLocation:K}),F}async reinstallFromGallery(F){if(this.F.trace("ExtensionManagementService#reinstallFromGallery",F.identifier.id),!this.z.isEnabled())throw new Error(y.localize(1,null));const q=await this.getTargetPlatform(),[K]=await this.z.getExtensions([{...F.identifier,preRelease:F.preRelease}],{targetPlatform:q,compatible:!0},w.CancellationToken.None);if(!K)throw new Error(y.localize(2,null));await this.ab.setUninstalled(F);try{await this.ab.removeUninstalledExtension(F)}catch(V){throw new Error(y.localize(3,null,(0,O.$rj)(V)))}return this.installFromGallery(K)}$(F,q,K,V){return this.ab.copyExtension(F,q,K,V)}copyExtensions(F,q){return this.ab.copyExtensions(F,q,{version:this.G.version,date:this.G.date})}markAsUninstalled(...F){return this.ab.setUninstalled(...F)}async cleanUp(){this.F.trace("ExtensionManagementService#cleanUp");try{await this.ab.cleanUp()}catch(F){this.F.error(F)}}async download(F,q,K){const{location:V}=await this.cb.download(F,q,!K);return V}async lb(F){if(F.scheme===h.Schemas.file)return{location:F,async cleanup(){}};this.F.trace("Downloading extension from",F.toString());const q=(0,$.$hh)(this.cb.extensionsDownloadDir,(0,d.$3g)());return await this.gb.download(F,q),this.F.info("Downloaded extension to",q.toString()),{location:q,cleanup:async()=>{try{await this.ib.del(q)}catch(V){this.F.error(V)}}}}X(){return this.H.defaultProfile.extensionsResource}Y(F,q,K){const V=q instanceof v.URI?new i.$Lp({id:(0,i.$Pp)(F.publisher,F.name)},F.version):i.$Lp.create(q);return this.hb.createInstance(G,V,F,q,K,(P,j)=>{if(q instanceof v.URI)return this.qb(V,q,K,j);let U=this.db.get(V.toString());return U||(this.db.set(V.toString(),U=this.pb(V,q,P,K,j)),U.finally(()=>this.db.delete(V.toString()))),U},this.ab)}Z(F,q){return new Y(F,q.profileLocation,this.fb)}async pb(F,q,K,V,P){const{verificationStatus:j,location:U}=await this.cb.download(q,K,!V.donotVerifySignature,V.context?.[r.$cp]);try{if(P.isCancellationRequested)throw new L.$8;return await(0,R.$Rq)(U.fsPath),{local:await this.ab.extractUserExtension(F,U.fsPath,{id:q.identifier.uuid,publisherId:q.publisherId,publisherDisplayName:q.publisherDisplayName,targetPlatform:q.properties.targetPlatform,isApplicationScoped:V.isApplicationScoped,isMachineScoped:V.isMachineScoped,isBuiltin:V.isBuiltin,isPreReleaseVersion:q.properties.isPreReleaseVersion,hasPreReleaseVersion:q.properties.isPreReleaseVersion,installedTimestamp:Date.now(),pinned:V.installGivenVersion?!0:!!V.pinned,preRelease:(0,N.$mg)(V.preRelease)?V.preRelease:V.installPreReleaseVersion||q.properties.isPreReleaseVersion,source:"gallery"},!1,P),verificationStatus:j}}catch(C){try{await this.cb.delete(U)}catch(X){this.F.warn("Error while deleting the downloaded file",U.toString(),(0,L.$ab)(X))}throw(0,n.$Eq)(C)}}async qb(F,q,K,V){return{local:await this.ab.extractUserExtension(F,u.$nc(q.fsPath),{isApplicationScoped:K.isApplicationScoped,isMachineScoped:K.isMachineScoped,isBuiltin:K.isBuiltin,installedTimestamp:Date.now(),pinned:K.installGivenVersion?!0:!!K.pinned,source:"vsix"},!0,V)}}async rb(F){const q=async V=>{let P=await p.Promises.readdir(V);P=P.map(C=>u.$mc(V,C));const j=await Promise.all(P.map(C=>p.Promises.stat(C)));let U=Promise.resolve([]);return j.forEach((C,X)=>{const Z=P[X];C.isFile()&&(U=U.then(ne=>[...ne,Z])),C.isDirectory()&&(U=U.then(ne=>q(Z).then(ce=>[...ne,...ce])))}),U};return(await q(F.location.fsPath)).map(V=>({path:`extension/${u.$oc(F.location.fsPath,V)}`,localPath:V}))}async sb({added:F,removed:q}){if(q){const K=F&&this.D.extUri.isEqual(q.profileLocation,F.profileLocation)?q.extensions.filter(V=>F.extensions.every(P=>!(0,i.$Kp)(P,V))):q.extensions;for(const V of K)this.F.info("Extensions removed from another source",V.id,q.profileLocation.toString()),this.u.fire({identifier:V,profileLocation:q.profileLocation})}if(F){const V=(await this.getInstalled(A.ExtensionType.User,F.profileLocation)).filter(P=>F.extensions.some(j=>(0,i.$Kp)(j,P.identifier)));this.s.fire(V.map(P=>(this.F.info("Extensions added from another source",P.identifier.id,F.profileLocation.toString()),{identifier:P.identifier,local:P,profileLocation:F.profileLocation,operation:r.InstallOperation.None})))}}async ub(){this.B(this.ab.onExtract(q=>this.tb.add(q)));const F=await this.ib.resolve(this.eb.userExtensionsLocation);for(const q of F.children??[])q.isDirectory&&this.tb.add(q.resource);this.B(this.ib.watch(this.eb.userExtensionsLocation)),this.B(this.ib.onDidFilesChange(q=>this.vb(q)))}async vb(F){if(!F.affects(this.eb.userExtensionsLocation,J.FileChangeType.ADDED))return;const q=[];for(const K of F.rawAdded){if(this.tb.has(K)||!this.D.extUri.isEqual(this.D.extUri.dirname(K),this.eb.userExtensionsLocation)||this.D.extUri.isEqual(K,this.D.extUri.joinPath(this.eb.userExtensionsLocation,".obsolete"))||this.D.extUri.basename(K).startsWith(".")||!(await this.ib.stat(K)).isDirectory)continue;const V=await this.ab.scanUserExtensionAtLocation(K);V&&V.installedTimestamp===void 0&&(this.tb.add(K),q.push(V))}q.length&&(await this.wb(q.map(K=>[K,void 0]),this.H.defaultProfile.extensionsResource),this.F.info("Added extensions to default profile from external source",q.map(K=>K.identifier.id)))}async wb(F,q){const K=F.map(V=>V[0]);await this.xb(K),await this.fb.addExtensionsToProfile(F,q),this.s.fire(K.map(V=>({local:V,identifier:V.identifier,operation:r.InstallOperation.None,profileLocation:q})))}async xb(F){const q=await this.ab.getUninstalledExtensions();for(const K of F){const V=i.$Lp.create(K);q[V.toString()]&&(this.F.trace("Removing the extension from uninstalled list:",V.id),await this.ab.setInstalled(V),this.F.info("Removed the extension from uninstalled list:",V.id))}}};t.$Xq=B,t.$Xq=B=ye([re(0,r.$jp),re(1,ue.$_l),re(2,se.$ak),re(3,a.$Oi),re(4,o.$Lq),re(5,s.$Hq),re(6,e.$Zo),re(7,Q.$Fi),re(8,J.$al),re(9,le.$tk),re(10,fe.$Kl),re(11,x.$Ml)],B);let M=class extends l.$Xc{constructor(F,q,K,V,P,j,U){super(),this.n=F,this.s=q,this.t=K,this.u=V,this.w=P,this.y=j,this.z=U,this.h=this.B(new I.$ne),this.onExtract=this.h.event,this.j=new c.$Dc,this.m=new c.$Dc,this.c=(0,$.$hh)(this.t.userExtensionsLocation,".obsolete"),this.g=new E.$Nh}async cleanUp(){await this.J(),await this.I()}async scanExtensions(F,q,K){try{const V={includeInvalid:!0,profileLocation:q,productVersion:K};let P=[];if(F===null||F===A.ExtensionType.System){let j=this.j.get(q);j||(j=this.t.scanAllExtensions({includeInvalid:!0,useCache:!0},V,!1).finally(()=>this.j.delete(q)),this.j.set(q,j)),P.push(...await j)}else if(F===A.ExtensionType.User){let j=this.m.get(q);j||(j=this.t.scanUserExtensions(V).finally(()=>this.m.delete(q)),this.m.set(q,j)),P.push(...await j)}return P=F!==null?P.filter(j=>j.type===F):P,await Promise.all(P.map(j=>this.H(j)))}catch(V){throw(0,n.$Eq)(V,r.ExtensionManagementErrorCode.Scanning)}}async scanAllUserExtensions(F){try{const q=await this.t.scanUserExtensions({includeAllVersions:!F,includeInvalid:!0});return await Promise.all(q.map(K=>this.H(K)))}catch(q){throw(0,n.$Eq)(q,r.ExtensionManagementErrorCode.Scanning)}}async scanUserExtensionAtLocation(F){try{const q=await this.t.scanExistingExtension(F,A.ExtensionType.User,{includeInvalid:!0});if(q)return await this.H(q)}catch(q){this.z.error(q)}return null}async extractUserExtension(F,q,K,V,P){const j=F.toString(),U=v.URI.file(u.$mc(this.t.userExtensionsLocation.fsPath,`.${(0,d.$3g)()}`)),C=v.URI.file(u.$mc(this.t.userExtensionsLocation.fsPath,j));let X=await this.s.exists(C);if(X&&V){try{await this.D(F.id,C,"removeExisting")}catch{throw new r.$lp(y.localize(4,null,C.fsPath,F.id),r.ExtensionManagementErrorCode.Delete)}X=!1}if(X)try{await this.t.updateMetadata(C,K)}catch(Z){throw this.y.publicLog2("extension:extract",{extensionId:F.id,code:`${(0,J.$rl)(Z)}`}),(0,n.$Eq)(Z,r.ExtensionManagementErrorCode.UpdateExistingMetadata)}else try{if(P.isCancellationRequested)throw new L.$8;try{this.z.trace(`Started extracting the extension from ${q} to ${C.fsPath}`),await(0,k.$Bq)(q,U.fsPath,{sourcePath:"extension",overwrite:!0},P),this.z.info(`Extracted extension to ${C}:`,F.id)}catch(Z){throw(0,R.$Qq)(Z)}try{await this.t.updateMetadata(U,K)}catch(Z){throw this.y.publicLog2("extension:extract",{extensionId:F.id,code:`${(0,J.$rl)(Z)}`}),(0,n.$Eq)(Z,r.ExtensionManagementErrorCode.UpdateMetadata)}if(P.isCancellationRequested)throw new L.$8;try{this.z.trace(`Started renaming the extension from ${U.fsPath} to ${C.fsPath}`),await this.G(U.fsPath,C.fsPath),this.z.info("Renamed to",C.fsPath)}catch(Z){if(Z.code==="ENOTEMPTY"){this.z.info("Rename failed because extension was installed by another source. So ignoring renaming.",F.id);try{await this.s.del(U,{recursive:!0})}catch{}}else throw this.z.info(`Rename failed because of ${(0,L.$ab)(Z)}. Deleted from extracted location`,U),Z}this.h.fire(C)}catch(Z){try{await this.s.del(U,{recursive:!0})}catch{}throw Z}return this.scanLocalExtension(C,A.ExtensionType.User)}async scanMetadata(F,q){return q?(await this.C(F,q))?.metadata:this.t.scanMetadata(F.location)}async C(F,q){return(await this.u.scanProfileExtensions(q)).find(V=>(0,i.$Kp)(V.identifier,F.identifier))}async updateMetadata(F,q,K){try{K?await this.u.updateMetadata([[F,q]],K):await this.t.updateMetadata(F.location,q)}catch(V){throw this.y.publicLog2("extension:extract",{extensionId:F.identifier.id,code:`${(0,J.$rl)(V)}`}),(0,n.$Eq)(V,r.ExtensionManagementErrorCode.UpdateMetadata)}return this.scanLocalExtension(F.location,F.type,K)}async getUninstalledExtensions(){try{return await this.F()}catch(F){throw(0,n.$Eq)(F,r.ExtensionManagementErrorCode.ReadUninstalled)}}async setUninstalled(...F){const q=F.map(K=>i.$Lp.create(K));await this.F(K=>q.forEach(V=>{K[V.toString()]=!0,this.z.info("Marked extension as uninstalled",V.toString())}))}async setInstalled(F){try{await this.F(q=>delete q[F.toString()])}catch(q){throw(0,n.$Eq)(q,r.ExtensionManagementErrorCode.UnsetUninstalled)}}async removeExtension(F,q){if(this.w.extUri.isEqualOrParent(F.location,this.t.userExtensionsLocation))return this.D(F.identifier.id,F.location,q)}async removeUninstalledExtension(F){await this.removeExtension(F,"uninstalled"),await this.F(q=>delete q[i.$Lp.create(F).toString()])}async copyExtension(F,q,K,V){const P=await this.C(F,q),j=await this.C(F,K);if(V={...P?.metadata,...V},j)if(this.w.extUri.isEqual(j.location,F.location))await this.u.updateMetadata([[F,{...j.metadata,...V}]],K);else{const U=await this.scanLocalExtension(j.location,F.type,K);await this.u.removeExtensionFromProfile(U,K),await this.u.addExtensionsToProfile([[F,{...j.metadata,...V}]],K)}else await this.u.addExtensionsToProfile([[F,V]],K);return this.scanLocalExtension(F.location,F.type,K)}async copyExtensions(F,q,K){const V=await this.scanExtensions(A.ExtensionType.User,F,K),P=await Promise.all(V.filter(j=>!j.isApplicationScoped).map(async j=>[j,await this.scanMetadata(j,F)]));await this.u.addExtensionsToProfile(P,q)}async D(F,q,K){this.z.trace(`Deleting ${K} extension from disk`,F,q.fsPath);const V=this.w.extUri.joinPath(this.w.extUri.dirname(q),`${this.w.extUri.basename(q)}.${(0,m.$uj)((0,d.$3g)()).toString(16)}${_}`);await this.G(q.fsPath,V.fsPath),await this.s.del(V,{recursive:!0}),this.z.info(`Deleted ${K} extension from disk`,F,q.fsPath)}F(F){return this.g.queue(async()=>{let q;try{q=(await this.s.readFile(this.c,"utf8")).value.toString()}catch(V){if((0,J.$rl)(V)!==J.FileOperationResult.FILE_NOT_FOUND)throw V}let K={};if(q)try{K=JSON.parse(q)}catch{}return F&&(F(K),Object.keys(K).length?await this.s.writeFile(this.c,S.$Pe.fromString(JSON.stringify(K))):await this.s.del(this.c)),K})}async G(F,q){try{await p.Promises.rename(F,q,2*60*1e3)}catch(K){throw(0,n.$Eq)(K,r.ExtensionManagementErrorCode.Rename)}}async scanLocalExtension(F,q,K){try{if(K){const P=(await this.t.scanUserExtensions({profileLocation:K})).find(j=>this.w.extUri.isEqual(j.location,F));if(P)return await this.H(P)}else{const V=await this.t.scanExistingExtension(F,q,{includeInvalid:!0});if(V)return await this.H(V)}throw new r.$lp(y.localize(5,null,F.path),r.ExtensionManagementErrorCode.ScanningExtension)}catch(V){throw(0,n.$Eq)(V,r.ExtensionManagementErrorCode.ScanningExtension)}}async H(F){const q=await this.s.resolve(F.location);let K,V;return q.children&&(K=q.children.find(({name:P})=>/^readme(\.txt|\.md|)$/i.test(P))?.resource,V=q.children.find(({name:P})=>/^changelog(\.txt|\.md|)$/i.test(P))?.resource),{identifier:F.identifier,type:F.type,isBuiltin:F.isBuiltin||!!F.metadata?.isBuiltin,location:F.location,manifest:F.manifest,targetPlatform:F.targetPlatform,validations:F.validations,isValid:F.isValid,readmeUrl:K,changelogUrl:V,publisherDisplayName:F.metadata?.publisherDisplayName,publisherId:F.metadata?.publisherId||null,isApplicationScoped:!!F.metadata?.isApplicationScoped,isMachineScoped:!!F.metadata?.isMachineScoped,isPreReleaseVersion:!!F.metadata?.isPreReleaseVersion,hasPreReleaseVersion:!!F.metadata?.hasPreReleaseVersion,preRelease:!!F.metadata?.preRelease,installedTimestamp:F.metadata?.installedTimestamp,updated:!!F.metadata?.updated,pinned:!!F.metadata?.pinned,isWorkspaceScoped:!1,source:F.metadata?.source??(F.identifier.uuid?"gallery":"vsix")}}async I(){const F=await this.getUninstalledExtensions();if(Object.keys(F).length===0){this.z.debug("No uninstalled extensions found.");return}this.z.debug("Removing uninstalled extensions:",Object.keys(F));const q=await this.t.scanUserExtensions({includeAllVersions:!0,includeUninstalled:!0,includeInvalid:!0}),K=new Set;for(const P of q)F[i.$Lp.create(P).toString()]||K.add(P.identifier.id.toLowerCase());try{const P=(0,i.$Qp)(q,j=>j.identifier);await E.Promises.settled(P.map(async j=>{const U=j.sort((C,X)=>g.rcompare(C.manifest.version,X.manifest.version))[0];K.has(U.identifier.id.toLowerCase())||await this.n(await this.H(U))}))}catch(P){this.z.error(P)}const V=q.filter(P=>P.metadata&&F[i.$Lp.create(P).toString()]);await Promise.allSettled(V.map(P=>this.removeUninstalledExtension(P)))}async J(){this.z.trace("ExtensionManagementService#removeTempDeleteFolders");let F;try{F=await this.s.resolve(this.t.userExtensionsLocation)}catch(q){(0,J.$rl)(q)!==J.FileOperationResult.FILE_NOT_FOUND&&this.z.error(q);return}if(F?.children)try{await Promise.allSettled(F.children.map(async q=>{if(!(!q.isDirectory||!q.name.endsWith(_))){this.z.trace("Deleting the temporarily deleted folder",q.resource.toString());try{await this.s.del(q.resource,{recursive:!0}),this.z.trace("Deleted the temporarily deleted folder",q.resource.toString())}catch(K){(0,J.$rl)(K)!==J.FileOperationResult.FILE_NOT_FOUND&&this.z.error(K)}}}))}catch{}}};t.$Yq=M,t.$Yq=M=ye([re(1,J.$al),re(2,o.$Lq),re(3,s.$Hq),re(4,fe.$Kl),re(5,ue.$_l),re(6,se.$ak)],M);let G=class extends n.$Fq{get operation(){return this.options.operation??this.j}get verificationStatus(){return this.k}constructor(F,q,K,V,P,j,U,C,X,Z,ne,ce){super(),this.l=F,this.manifest=q,this.source=K,this.options=V,this.m=P,this.n=j,this.o=U,this.p=C,this.q=X,this.s=Z,this.t=ne,this.u=ce,this.j=r.InstallOperation.Install,this.identifier=this.l.identifier}async h(F){const K=(await this.n.scanExtensions(A.ExtensionType.User,this.options.profileLocation,this.options.productVersion)).find(U=>(0,i.$Kp)(U.identifier,this.identifier));K&&(this.j=r.InstallOperation.Update);const V={isApplicationScoped:this.options.isApplicationScoped||K?.isApplicationScoped,isMachineScoped:this.options.isMachineScoped||K?.isMachineScoped,isBuiltin:this.options.isBuiltin||K?.isBuiltin,isSystem:K?.type===A.ExtensionType.System?!0:void 0,installedTimestamp:Date.now(),pinned:this.options.installGivenVersion?!0:this.options.pinned??K?.pinned,source:this.source instanceof v.URI?"vsix":"gallery"};let P;if(this.source instanceof v.URI){if(K&&this.l.equals(new i.$Lp(K.identifier,K.manifest.version)))try{await this.n.removeExtension(K,"existing")}catch{throw new Error(y.localize(6,null,this.manifest.displayName||this.manifest.name))}const U=await this.w(this.l);if(U)try{await this.n.removeExtension(U,"existing")}catch{throw new Error(y.localize(7,null,this.manifest.displayName||this.manifest.name))}}else{if(V.id=this.source.identifier.uuid,V.publisherId=this.source.publisherId,V.publisherDisplayName=this.source.publisherDisplayName,V.targetPlatform=this.source.properties.targetPlatform,V.updated=!!K,V.isPreReleaseVersion=this.source.properties.isPreReleaseVersion,V.hasPreReleaseVersion=K?.hasPreReleaseVersion||this.source.properties.isPreReleaseVersion,V.preRelease=(0,N.$mg)(this.options.preRelease)?this.options.preRelease:this.options.installPreReleaseVersion||this.source.properties.isPreReleaseVersion||K?.preRelease,K&&K.type!==A.ExtensionType.System&&K.manifest.version===this.source.version)return this.n.updateMetadata(K,V,this.options.profileLocation);P=await this.w(this.l)}if(F.isCancellationRequested)throw(0,n.$Eq)(new L.$8);if(!P){const U=await this.m(this.operation,F);P=U.local,this.k=U.verificationStatus}if(this.o.extUri.isEqual(this.q.defaultProfile.extensionsResource,this.options.profileLocation))try{await this.s.initializeDefaultProfileExtensions()}catch(U){throw(0,n.$Eq)(U,r.ExtensionManagementErrorCode.IntializeDefaultProfile)}if(F.isCancellationRequested)throw(0,n.$Eq)(new L.$8);try{await this.t.addExtensionsToProfile([[P,V]],this.options.profileLocation,!P.isValid)}catch(U){throw(0,n.$Eq)(U,r.ExtensionManagementErrorCode.AddToProfile)}const j=await this.n.scanLocalExtension(P.location,A.ExtensionType.User,this.options.profileLocation);if(!j)throw new r.$lp("Cannot find the installed extension",r.ExtensionManagementErrorCode.InstalledExtensionNotFound);return this.source instanceof v.URI&&this.x(P,F),j}async w(F){return(await this.n.getUninstalledExtensions())[F.toString()]?(this.u.trace("Removing the extension from uninstalled list:",F.id),await this.n.setInstalled(F),this.u.info("Removed the extension from uninstalled list:",F.id),(await this.n.scanAllUserExtensions(!0)).find(V=>i.$Lp.create(V).equals(F))):void 0}async x(F,q){try{let[K]=await this.p.getExtensions([{id:F.identifier.id,version:F.manifest.version}],q);if(K||([K]=await this.p.getExtensions([{id:F.identifier.id}],q)),K){const V={id:K.identifier.uuid,publisherDisplayName:K.publisherDisplayName,publisherId:K.publisherId,isPreReleaseVersion:K.properties.isPreReleaseVersion,hasPreReleaseVersion:F.hasPreReleaseVersion||K.properties.isPreReleaseVersion,preRelease:K.properties.isPreReleaseVersion||this.options.installPreReleaseVersion};await this.n.updateMetadata(F,V,this.options.profileLocation)}}catch{}}};G=ye([re(6,fe.$Kl),re(7,r.$jp),re(8,x.$Ml),re(9,o.$Lq),re(10,s.$Hq),re(11,se.$ak)],G);class Y extends n.$Fq{constructor(F,q,K){super(),this.extension=F,this.j=q,this.k=K}async h(F){await this.k.removeExtensionFromProfile(this.extension,this.j)}}}),define(oe[164],ae([0,1,6,25,24,19,42,10,18,12]),function(H,t,E,S,w,O,L,I,m,l){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$nR=void 0;let c=class extends L.$Iq{constructor(u,$,g,N,v,d){super(l.URI.file(u.extensionsPath),$,g,N,v,d)}};t.$nR=c,t.$nR=c=ye([re(0,m.$Oi),re(1,I.$al),re(2,S.$Ml),re(3,w.$Kl),re(4,O.$_l),re(5,E.$ak)],c)}),define(oe[165],ae([0,1,12,18,42,54,10,11,6,33,24,25]),function(H,t,E,S,w,O,L,I,m,l,c,h){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$wgc=void 0;let u=class extends O.$Pq{constructor(g,N,v,d,p,k,y,e){super(E.URI.file(p.builtinExtensionsPath),E.URI.file(p.extensionsPath),p.userHome,g.defaultProfile,g,N,v,d,p,k,y,e)}};t.$wgc=u,t.$wgc=u=ye([re(0,h.$Ml),re(1,w.$Hq),re(2,L.$al),re(3,m.$ak),re(4,S.$Oi),re(5,l.$tk),re(6,c.$Kl),re(7,I.$Fi)],u)}),define(oe[73],ae([0,1,8,5,2,133,3,92,11,25]),function(H,t,E,S,w,O,L,I,m,l){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$kq=t.$iq=t.StorageTarget=t.StorageScope=t.WillSaveStateReason=t.$gq=t.$fq=t.$eq=void 0,t.$hq=$,t.$jq=N,t.$lq=d,t.$eq="__$__isNewStorageMarker",t.$fq="__$__targetStorageMarker",t.$gq=(0,m.$Gi)("storageService");var c;(function(p){p[p.NONE=0]="NONE",p[p.SHUTDOWN=1]="SHUTDOWN"})(c||(t.WillSaveStateReason=c={}));var h;(function(p){p[p.APPLICATION=-1]="APPLICATION",p[p.PROFILE=0]="PROFILE",p[p.WORKSPACE=1]="WORKSPACE"})(h||(t.StorageScope=h={}));var u;(function(p){p[p.USER=0]="USER",p[p.MACHINE=1]="MACHINE"})(u||(t.StorageTarget=u={}));function $(p){const k=p.get(t.$fq);if(k)try{return JSON.parse(k)}catch{}return Object.create(null)}class g extends w.$Xc{static{this.a=60*1e3}constructor(k={flushInterval:g.a}){super(),this.m=k,this.b=this.B(new S.$qe),this.c=this.B(new S.$qe),this.onDidChangeTarget=this.c.event,this.f=this.B(new S.$ne),this.onWillSaveState=this.f.event,this.h=this.B(new E.$Sh(()=>this.n(),this.m.flushInterval)),this.j=this.B(new w.$Yc),this.C=void 0,this.F=void 0,this.H=void 0}onDidChangeValue(k,y,e){return S.Event.filter(this.b.event,a=>a.scope===k&&(y===void 0||a.key===y),e)}n(){this.j.value=(0,E.$Wh)(()=>{this.r()&&this.flush(),this.h.schedule()})}r(){return!0}t(){(0,w.$Sc)([this.j,this.h])}initialize(){return this.g||(this.g=(async()=>{(0,O.mark)("code/willInitStorage");try{await this.O()}finally{(0,O.mark)("code/didInitStorage")}this.h.schedule()})()),this.g}u(k,y){const{key:e,external:a}=y;if(e===t.$fq){switch(k){case h.APPLICATION:this.H=void 0;break;case h.PROFILE:this.F=void 0;break;case h.WORKSPACE:this.C=void 0;break}this.c.fire({scope:k})}else this.b.fire({scope:k,key:e,target:this.J(k)[e],external:a})}w(k){this.f.fire({reason:k})}get(k,y,e){return this.P(y)?.get(k,e)}getBoolean(k,y,e){return this.P(y)?.getBoolean(k,e)}getNumber(k,y,e){return this.P(y)?.getNumber(k,e)}getObject(k,y,e){return this.P(y)?.getObject(k,e)}storeAll(k,y){this.y(()=>{for(const e of k)this.store(e.key,e.value,e.scope,e.target,y)})}store(k,y,e,a,n=!1){if((0,L.$pg)(y)){this.remove(k,e,n);return}this.y(()=>{this.z(k,e,a),this.P(e)?.set(k,y,n)})}remove(k,y,e=!1){this.y(()=>{this.z(k,y,void 0),this.P(y)?.delete(k,e)})}y(k){this.b.pause(),this.c.pause();try{k()}finally{this.b.resume(),this.c.resume()}}keys(k,y){const e=[],a=this.J(k);for(const n of Object.keys(a))a[n]===y&&e.push(n);return e}z(k,y,e,a=!1){const n=this.J(y);typeof e=="number"?n[k]!==e&&(n[k]=e,this.P(y)?.set(t.$fq,JSON.stringify(n),a)):typeof n[k]=="number"&&(delete n[k],this.P(y)?.set(t.$fq,JSON.stringify(n),a))}get D(){return this.C||(this.C=this.L(h.WORKSPACE)),this.C}get G(){return this.F||(this.F=this.L(h.PROFILE)),this.F}get I(){return this.H||(this.H=this.L(h.APPLICATION)),this.H}J(k){switch(k){case h.APPLICATION:return this.I;case h.PROFILE:return this.G;default:return this.D}}L(k){const y=this.P(k);return y?$(y):Object.create(null)}isNew(k){return this.getBoolean(t.$eq,k)===!0}async flush(k=c.NONE){this.f.fire({reason:k});const y=this.P(h.APPLICATION),e=this.P(h.PROFILE),a=this.P(h.WORKSPACE);switch(k){case c.NONE:await E.Promises.settled([y?.whenFlushed()??Promise.resolve(),e?.whenFlushed()??Promise.resolve(),a?.whenFlushed()??Promise.resolve()]);break;case c.SHUTDOWN:await E.Promises.settled([y?.flush(0)??Promise.resolve(),e?.flush(0)??Promise.resolve(),a?.flush(0)??Promise.resolve()]);break}}async log(){const k=this.P(h.APPLICATION)?.items??new Map,y=this.P(h.PROFILE)?.items??new Map,e=this.P(h.WORKSPACE)?.items??new Map;return d(k,y,e,this.Q(h.APPLICATION)??"",this.Q(h.PROFILE)??"",this.Q(h.WORKSPACE)??"")}async optimize(k){return await this.flush(),this.P(k)?.optimize()}async switch(k,y){return this.w(c.NONE),(0,l.$Ll)(k)?this.R(k,y):this.S(k,y)}M(k,y){return!(k.id===y.id||N(y)&&N(k))}N(k,y,e){this.y(()=>{const a=new Set;for(const[n,r]of k)a.add(n),y.get(n)!==r&&this.u(e,{key:n,external:!0});for(const[n]of y.items)a.has(n)||this.u(e,{key:n,external:!0})})}}t.$iq=g;function N(p){return p.isDefault||!!p.useDefaultFlags?.globalState}class v extends g{constructor(){super(),this.U=this.B(new I.$cq(new I.$dq,{hint:I.StorageHint.STORAGE_IN_MEMORY})),this.W=this.B(new I.$cq(new I.$dq,{hint:I.StorageHint.STORAGE_IN_MEMORY})),this.X=this.B(new I.$cq(new I.$dq,{hint:I.StorageHint.STORAGE_IN_MEMORY})),this.B(this.X.onDidChangeStorage(k=>this.u(h.WORKSPACE,k))),this.B(this.W.onDidChangeStorage(k=>this.u(h.PROFILE,k))),this.B(this.U.onDidChangeStorage(k=>this.u(h.APPLICATION,k)))}P(k){switch(k){case h.APPLICATION:return this.U;case h.PROFILE:return this.W;default:return this.X}}Q(k){switch(k){case h.APPLICATION:return"inMemory (application)";case h.PROFILE:return"inMemory (profile)";default:return"inMemory (workspace)"}}async O(){}async R(){}async S(){}r(){return!1}hasScope(k){return!1}}t.$kq=v;async function d(p,k,y,e,a,n){const r=A=>{try{return JSON.parse(A)}catch{return A}},i=new Map,s=new Map;p.forEach((A,z)=>{i.set(z,A),s.set(z,r(A))});const o=new Map,f=new Map;k.forEach((A,z)=>{o.set(z,A),f.set(z,r(A))});const b=new Map,R=new Map;y.forEach((A,z)=>{b.set(z,A),R.set(z,r(A))}),console.group(e!==a?`Storage: Application (path: ${e})`:`Storage: Application & Profile (path: ${e}, default profile)`);const T=[];if(i.forEach((A,z)=>{T.push({key:z,value:A})}),console.table(T),console.groupEnd(),console.log(s),e!==a){console.group(`Storage: Profile (path: ${a}, profile specific)`);const A=[];o.forEach((z,J)=>{A.push({key:J,value:z})}),console.table(A),console.groupEnd(),console.log(f)}console.group(`Storage: Workspace (path: ${n})`);const D=[];b.forEach((A,z)=>{D.push({key:z,value:A})}),console.table(D),console.groupEnd(),console.log(R)}}),define(oe[166],ae([0,1,14,29,73]),function(H,t,E,S,w){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$mq=O;async function O(L,I,m){let l=m&&m.get("storage.serviceMachineId",w.StorageScope.APPLICATION)||null;if(l)return l;try{const h=(await I.readFile(L.serviceMachineIdResource)).value.toString();l=(0,S.$2g)(h)?h:null}catch{l=null}if(!l){l=(0,S.$3g)();try{await I.writeFile(L.serviceMachineIdResource,E.$Pe.fromString(l))}catch{}}return m?.store("storage.serviceMachineId",l,w.StorageScope.APPLICATION,w.StorageTarget.MACHINE),l}}),define(oe[167],ae([0,1,166,19,41]),function(H,t,E,S,w){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$nq=O;async function O(L,I,m,l,c,h,u){const $={"X-Market-Client-Id":`VSCode ${L}`,"User-Agent":`VSCode ${L} (${I.nameShort})`};if((0,w.$Cp)(I,m)&&(0,w.$Ep)(l)===S.TelemetryLevel.USAGE){const g=await(0,E.$mq)(m,c,h);$["X-Market-User-Id"]=g,$["VSCode-SessionId"]=u.machineId||g}return $}}),define(oe[168],ae([0,1,20,22,9,13,36,3,12,30,18,21,27,23,44,10,6,33,46,167,73,19,180]),function(H,t,E,S,w,O,L,I,m,l,c,h,u,$,g,N,v,d,p,k,y,e,a){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$qq=t.$pq=void 0,t.$oq=F;const n=O.$o?$.TargetPlatform.WEB:(0,h.$fp)(O.$u,L.$hc),r="X-Market-Search-Activity-Id";var i;(function(U){U[U.None=0]="None",U[U.IncludeVersions=1]="IncludeVersions",U[U.IncludeFiles=2]="IncludeFiles",U[U.IncludeCategoryAndTags=4]="IncludeCategoryAndTags",U[U.IncludeSharedAccounts=8]="IncludeSharedAccounts",U[U.IncludeVersionProperties=16]="IncludeVersionProperties",U[U.ExcludeNonValidated=32]="ExcludeNonValidated",U[U.IncludeInstallationTargets=64]="IncludeInstallationTargets",U[U.IncludeAssetUri=128]="IncludeAssetUri",U[U.IncludeStatistics=256]="IncludeStatistics",U[U.IncludeLatestVersionOnly=512]="IncludeLatestVersionOnly",U[U.Unpublished=4096]="Unpublished",U[U.IncludeNameConflictInfo=32768]="IncludeNameConflictInfo"})(i||(i={}));function s(...U){return String(U.reduce((C,X)=>C|X,0))}var o;(function(U){U[U.Tag=1]="Tag",U[U.ExtensionId=4]="ExtensionId",U[U.Category=5]="Category",U[U.ExtensionName=7]="ExtensionName",U[U.Target=8]="Target",U[U.Featured=9]="Featured",U[U.SearchText=10]="SearchText",U[U.ExcludeWithFlags=12]="ExcludeWithFlags"})(o||(o={}));const f={Icon:"Microsoft.VisualStudio.Services.Icons.Default",Details:"Microsoft.VisualStudio.Services.Content.Details",Changelog:"Microsoft.VisualStudio.Services.Content.Changelog",Manifest:"Microsoft.VisualStudio.Code.Manifest",VSIX:"Microsoft.VisualStudio.Services.VSIXPackage",License:"Microsoft.VisualStudio.Services.Content.License",Repository:"Microsoft.VisualStudio.Services.Links.Source",Signature:"Microsoft.VisualStudio.Services.VsixSignature"},b={Dependency:"Microsoft.VisualStudio.Code.ExtensionDependencies",ExtensionPack:"Microsoft.VisualStudio.Code.ExtensionPack",Engine:"Microsoft.VisualStudio.Code.Engine",PreRelease:"Microsoft.VisualStudio.Code.PreRelease",EnabledApiProposals:"Microsoft.VisualStudio.Code.EnabledApiProposals",LocalizedLanguages:"Microsoft.VisualStudio.Code.LocalizedLanguages",WebExtension:"Microsoft.VisualStudio.Code.WebExtension",SponsorLink:"Microsoft.VisualStudio.Code.SponsorLink",SupportLink:"Microsoft.VisualStudio.Services.Links.Support"},T={pageNumber:1,pageSize:10,sortBy:h.SortBy.NoneOrRelevance,sortOrder:h.SortOrder.Default,flags:i.None,criteria:[],assetTypes:[]};class D{constructor(C=T){this.d=C}get pageNumber(){return this.d.pageNumber}get pageSize(){return this.d.pageSize}get sortBy(){return this.d.sortBy}get sortOrder(){return this.d.sortOrder}get flags(){return this.d.flags}get criteria(){return this.d.criteria}withPage(C,X=this.d.pageSize){return new D({...this.d,pageNumber:C,pageSize:X})}withFilter(C,...X){const Z=[...this.d.criteria,...X.length?X.map(ne=>({filterType:C,value:ne})):[{filterType:C}]];return new D({...this.d,criteria:Z})}withSortBy(C){return new D({...this.d,sortBy:C})}withSortOrder(C){return new D({...this.d,sortOrder:C})}withFlags(...C){return new D({...this.d,flags:C.reduce((X,Z)=>X|Z,0)})}withAssetTypes(...C){return new D({...this.d,assetTypes:C})}withSource(C){return new D({...this.d,source:C})}get raw(){const{criteria:C,pageNumber:X,pageSize:Z,sortBy:ne,sortOrder:ce,flags:pe,assetTypes:me}=this.d;return{filters:[{criteria:C,pageNumber:X,pageSize:Z,sortBy:ne,sortOrder:ce}],assetTypes:me,flags:pe}}get searchText(){const C=this.d.criteria.filter(X=>X.filterType===o.SearchText)[0];return C&&C.value?C.value:""}get telemetryData(){return{filterTypes:this.d.criteria.map(C=>String(C.filterType)),flags:this.d.flags,sortBy:String(this.sortBy),sortOrder:String(this.sortOrder),pageNumber:String(this.pageNumber),source:this.d.source,searchTextLength:this.searchText.length}}}function A(U,C){const X=(U||[]).filter(Z=>Z.statisticName===C)[0];return X?X.value:0}function z(U){const C="Microsoft.VisualStudio.Code.Translation.";return U.files.filter(Z=>Z.assetType.indexOf(C)===0).reduce((Z,ne)=>{const ce=se(U,ne.assetType);return ce&&Z.push([ne.assetType.substring(C.length),ce]),Z},[])}function J(U){if(U.properties){const C=U.properties.filter(ne=>ne.key===f.Repository),X=new RegExp("((git|ssh|http(s)?)|(git@[\\w.]+))(:(//)?)([\\w.@:/\\-~]+)(.git)(/)?"),Z=C.filter(ne=>X.test(ne.value))[0];return Z?{uri:Z.value,fallbackUri:Z.value}:null}return se(U,f.Repository)}function Q(U){return{uri:`${U.fallbackAssetUri}/${f.VSIX}?redirect=true${U.targetPlatform?`&targetPlatform=${U.targetPlatform}`:""}`,fallbackUri:`${U.fallbackAssetUri}/${f.VSIX}${U.targetPlatform?`?targetPlatform=${U.targetPlatform}`:""}`}}function se(U,C){return U.files.filter(Z=>Z.assetType===C)[0]?{uri:`${U.assetUri}/${C}${U.targetPlatform?`?targetPlatform=${U.targetPlatform}`:""}`,fallbackUri:`${U.fallbackAssetUri}/${C}${U.targetPlatform?`?targetPlatform=${U.targetPlatform}`:""}`}:null}function le(U,C){const X=U.properties?U.properties.filter(ne=>ne.key===C):[],Z=X.length>0&&X[0].value;return Z?Z.split(",").map(ne=>(0,u.$Op)(ne)):[]}function ue(U){const C=U.properties?U.properties.filter(X=>X.key===b.Engine):[];return C.length>0&&C[0].value||""}function fe(U){const C=U.properties?U.properties.filter(X=>X.key===b.PreRelease):[];return C.length>0&&C[0].value==="true"}function x(U){const C=U.properties?U.properties.filter(Z=>Z.key===b.EnabledApiProposals):[],X=C.length>0&&C[0].value||"";return X?X.split(","):[]}function _(U){const C=U.properties?U.properties.filter(Z=>Z.key===b.LocalizedLanguages):[],X=C.length>0&&C[0].value||"";return X?X.split(","):[]}function B(U){return U.properties?.find(C=>C.key===b.SponsorLink)?.value}function M(U){return U.properties?.find(C=>C.key===b.SupportLink)?.value}function G(U){return U.indexOf("preview")!==-1}function Y(U){return U.targetPlatform?(0,h.$ep)(U.targetPlatform):$.TargetPlatform.UNDEFINED}function te(U){const C=(0,E.$Pb)(U.versions.map(Y)),X=!!U.tags?.includes(h.$$o),Z=C.indexOf($.TargetPlatform.WEB);return X?Z===-1&&C.push($.TargetPlatform.WEB):Z!==-1&&C.splice(Z,1),C}function F(U,C){for(let X=0;X<U.length;X++){const Z=U[X];if(Z.version===U[X-1]?.version){let ne=X;if(Y(Z)===C)for(;ne>0&&U[ne-1].version===Z.version;)ne--;ne!==X&&(U.splice(X,1),U.splice(ne,0,Z))}}return U}function q(U,C,X){U.telemetryData={index:C,querySource:X,queryActivityId:U.queryContext?.[r]}}function K(U,C,X,Z){const ne=U.versions[0],ce={manifest:se(C,f.Manifest),readme:se(C,f.Details),changelog:se(C,f.Changelog),license:se(C,f.License),repository:J(C),download:Q(C),icon:se(C,f.Icon),signature:se(C,f.Signature),coreTranslations:z(C)};return{type:"gallery",identifier:{id:(0,u.$Pp)(U.publisher.publisherName,U.extensionName),uuid:U.extensionId},name:U.extensionName,version:C.version,displayName:U.displayName,publisherId:U.publisher.publisherId,publisher:U.publisher.publisherName,publisherDisplayName:U.publisher.displayName,publisherDomain:U.publisher.domain?{link:U.publisher.domain,verified:!!U.publisher.isDomainVerified}:void 0,publisherSponsorLink:B(ne),description:U.shortDescription??"",installCount:A(U.statistics,"install"),rating:A(U.statistics,"averagerating"),ratingCount:A(U.statistics,"ratingcount"),categories:U.categories||[],tags:U.tags||[],releaseDate:Date.parse(U.releaseDate),lastUpdated:Date.parse(U.lastUpdated),allTargetPlatforms:X,assets:ce,properties:{dependencies:le(C,b.Dependency),extensionPack:le(C,b.ExtensionPack),engine:ue(C),enabledApiProposals:x(C),localizedLanguages:_(C),targetPlatform:Y(C),isPreReleaseVersion:fe(C)},hasPreReleaseVersion:fe(ne),hasReleaseVersion:!0,preview:G(U.flags),isSigned:!!ce.signature,queryContext:Z,supportLink:M(ne)}}let V=class{constructor(C,X,Z,ne,ce,pe,me,ge){this.l=X,this.n=Z,this.o=ne,this.q=ce,this.u=pe,this.w=me,this.x=ge;const we=me.extensionsGallery,he=we?.servicePPEUrl&&ge.getValue("_extensionsGallery.enablePPE");this.d=he?we.servicePPEUrl:we?.serviceUrl,this.g=he?void 0:we?.searchUrl,this.h=we?.controlUrl,this.k=me.extensionsEnabledWithApiProposalVersion?.map(de=>de.toLowerCase())??[],this.j=(0,k.$nq)(me.version,me,this.o,this.x,this.u,C,this.q)}y(C=""){return`${this.d}${C}`}isEnabled(){return!!this.d}async getExtensions(C,X,Z){const ne=S.CancellationToken.isCancellationToken(X)?{}:X,ce=S.CancellationToken.isCancellationToken(X)?X:Z,pe=[],me=[],ge=[],we=[];let he=!0;for(const Pe of C){Pe.uuid?me.push(Pe.uuid):pe.push(Pe.id);const W=!!(Pe.version||Pe.preRelease);ge.push({id:Pe.id,uuid:Pe.uuid,includePreRelease:W}),Pe.version&&we.push({id:Pe.id,uuid:Pe.uuid,version:Pe.version}),he=he&&!!Pe.hasPreRelease&&!W}if(!me.length&&!pe.length)return[];let de=new D().withPage(1,C.length);me.length&&(de=de.withFilter(o.ExtensionId,...me)),pe.length&&(de=de.withFilter(o.ExtensionName,...pe)),(ne.queryAllVersions||he)&&(de=de.withFlags(de.flags,i.IncludeVersions)),ne.source&&(de=de.withSource(ne.source));const{extensions:ve}=await this.B(de,{targetPlatform:ne.targetPlatform??n,includePreRelease:ge,versions:we,compatible:!!ne.compatible,productVersion:ne.productVersion??{version:this.w.version,date:this.w.date}},ce);return ne.source&&ve.forEach((Pe,W)=>q(Pe,W,ne.source)),ve}async getCompatibleExtension(C,X,Z,ne={version:this.w.version,date:this.w.date}){if((0,h.$gp)(C.allTargetPlatforms,Z))return null;if(await this.isExtensionCompatible(C,X,Z))return C;const ce=new D().withFlags(i.IncludeVersions).withPage(1,1).withFilter(o.ExtensionId,C.identifier.uuid),{extensions:pe}=await this.B(ce,{targetPlatform:Z,compatible:!0,includePreRelease:X,productVersion:ne},S.CancellationToken.None);return pe[0]||null}async isExtensionCompatible(C,X,Z,ne={version:this.w.version,date:this.w.date}){if(!(0,h.$hp)(C.properties.targetPlatform,C.allTargetPlatforms,Z)||!X&&C.properties.isPreReleaseVersion)return!1;let ce=C.properties.engine;if(!ce){const pe=await this.getManifest(C,S.CancellationToken.None);if(!pe)throw new Error("Manifest was not found");ce=pe.engines.vscode}return!(!(0,g.$4p)(ce,ne.version,ne.date)||!this.z(C.identifier,C.properties.enabledApiProposals))}z(C,X){return!X||!this.k.includes(C.id.toLowerCase())?!0:(0,g.$5p)(X)}async A(C,X,Z,ne,ce,pe,me={version:this.w.version,date:this.w.date}){if(!(0,h.$hp)(Y(X),ce,pe)||Z!=="any"&&fe(X)!==(Z==="prerelease"))return!1;if(ne)try{const ge=await this.G(C,X);if(!(0,g.$4p)(ge,me.version,me.date))return!1}catch(ge){return this.n.error(`Error while getting the engine for the version ${X.version}.`,(0,w.$ab)(ge)),!1}return!0}async query(C,X){let Z=C.text||"";const ne=C.pageSize??50;let ce=new D().withPage(1,ne);Z?(Z=Z.replace(/\bcategory:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(he,de,ve)=>(ce=ce.withFilter(o.Category,ve||de),"")),Z=Z.replace(/\btag:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(he,de,ve)=>(ce=ce.withFilter(o.Tag,ve||de),"")),Z=Z.replace(/\bfeatured(\s+|\b|$)/g,()=>(ce=ce.withFilter(o.Featured),"")),Z=Z.trim(),Z&&(Z=Z.length<200?Z:Z.substring(0,200),ce=ce.withFilter(o.SearchText,Z)),ce=ce.withSortBy(h.SortBy.NoneOrRelevance)):C.ids?ce=ce.withFilter(o.ExtensionId,...C.ids):C.names?ce=ce.withFilter(o.ExtensionName,...C.names):ce=ce.withSortBy(h.SortBy.InstallCount),typeof C.sortBy=="number"&&(ce=ce.withSortBy(C.sortBy)),typeof C.sortOrder=="number"&&(ce=ce.withSortOrder(C.sortOrder)),C.source&&(ce=ce.withSource(C.source));const pe=async(he,de)=>{const{extensions:ve,total:Pe}=await this.B(he,{targetPlatform:n,compatible:!1,includePreRelease:!!C.includePreRelease,productVersion:C.productVersion??{version:this.w.version,date:this.w.date}},de);return ve.forEach((W,ee)=>q(W,(he.pageNumber-1)*he.pageSize+ee,C.source)),{extensions:ve,total:Pe}},{extensions:me,total:ge}=await pe(ce,X),we=async(he,de)=>{if(de.isCancellationRequested)throw new w.$8;const{extensions:ve}=await pe(ce.withPage(he+1),de);return ve};return{firstPage:me,total:ge,pageSize:ce.pageSize,getPage:we}}async B(C,X,Z){const ne=C.flags;C.flags&i.IncludeLatestVersionOnly&&C.flags&i.IncludeVersions&&(C=C.withFlags(C.flags&~i.IncludeVersions,i.IncludeLatestVersionOnly)),!(C.flags&i.IncludeLatestVersionOnly)&&!(C.flags&i.IncludeVersions)&&(C=C.withFlags(C.flags,i.IncludeLatestVersionOnly)),X.versions?.length&&(C=C.withFlags(C.flags&~i.IncludeLatestVersionOnly,i.IncludeVersions)),C=C.withFlags(C.flags,i.IncludeAssetUri,i.IncludeCategoryAndTags,i.IncludeFiles,i.IncludeStatistics,i.IncludeVersionProperties);const{galleryExtensions:ce,total:pe,context:me}=await this.D(C,Z);if(!(C.flags&i.IncludeLatestVersionOnly)){const de=[];for(const ve of ce){const Pe=await this.C(ve,X,me);Pe&&de.push(Pe)}return{extensions:de,total:pe}}const we=[],he=new Map;for(let de=0;de<ce.length;de++){const ve=ce[de],Pe={id:(0,u.$Pp)(ve.publisher.publisherName,ve.extensionName),uuid:ve.extensionId},W=(0,I.$mg)(X.includePreRelease)?X.includePreRelease:!!X.includePreRelease.find(ie=>(0,u.$Kp)(ie,Pe))?.includePreRelease;if(X.compatible&&(0,h.$gp)(te(ve),X.targetPlatform))continue;const ee=await this.C(ve,X,me);!ee||ee.properties.isPreReleaseVersion&&(!W||!ee.hasReleaseVersion)||!ee.properties.isPreReleaseVersion&&ee.properties.targetPlatform!==X.targetPlatform&&ee.hasPreReleaseVersion?he.set(ve.extensionId,de):we.push([de,ee])}if(he.size){const de=new a.$he,ve=new D().withFlags(ne&~i.IncludeLatestVersionOnly,i.IncludeVersions).withPage(1,he.size).withFilter(o.ExtensionId,...he.keys()),{extensions:Pe}=await this.B(ve,X,Z);this.q.publicLog2("galleryService:additionalQuery",{duration:de.elapsed(),count:he.size});for(const W of Pe){const ee=he.get(W.identifier.uuid);we.push([ee,W])}}return{extensions:we.sort((de,ve)=>de[0]-ve[0]).map(([,de])=>de),total:pe}}async C(C,X,Z){const ne={id:(0,u.$Pp)(C.publisher.publisherName,C.extensionName),uuid:C.extensionId},ce=X.versions?.find(we=>(0,u.$Kp)(we,ne))?.version,pe=(0,I.$mg)(X.includePreRelease)?X.includePreRelease:!!X.includePreRelease.find(we=>(0,u.$Kp)(we,ne))?.includePreRelease,me=te(C),ge=F(C.versions,X.targetPlatform);if(X.compatible&&(0,h.$gp)(me,X.targetPlatform))return null;for(let we=0;we<ge.length;we++){const he=ge[we];if(!(ce&&he.version!==ce)){if(await this.A(ne.id,he,pe?"any":"release",X.compatible,me,X.targetPlatform,X.productVersion))return X.compatible&&!this.z(ne,x(he))?null:K(C,he,me,Z);if(ce&&he.version===ce)return null}}return ce||X.compatible?null:K(C,C.versions[0],me)}async D(C,X){if(!this.isEnabled())throw new Error("No extension gallery service configured.");C=C.withFlags(C.flags,i.ExcludeNonValidated).withFilter(o.Target,"Microsoft.VisualStudio.Code").withFilter(o.ExcludeWithFlags,s(i.Unpublished));const Z=await this.j,ne=JSON.stringify(C.raw),ce={...Z,"Content-Type":"application/json",Accept:"application/json;api-version=3.0-preview.1","Accept-Encoding":"gzip","Content-Length":String(ne.length)},pe=new a.$he;let me,ge,we=0;try{if(me=await this.l.request({type:"POST",url:this.g&&C.criteria.some(de=>de.filterType===o.SearchText)?this.g:this.y("/extensionquery"),data:ne,headers:ce},X),me.res.statusCode&&me.res.statusCode>=400&&me.res.statusCode<500)return{galleryExtensions:[],total:we};const he=await(0,p.$_p)(me);if(he){const de=he.results[0],ve=de.extensions,Pe=de.resultMetadata&&de.resultMetadata.filter(W=>W.metadataType==="ResultCount")[0];return we=Pe&&Pe.metadataItems.filter(W=>W.name==="TotalCount")[0].count||0,{galleryExtensions:ve,total:we,context:{[r]:me.res.headers.activityid}}}return{galleryExtensions:[],total:we}}catch(he){if((0,w.$7)(he))throw ge=h.ExtensionGalleryErrorCode.Cancelled,he;{const de=(0,w.$ab)(he);throw ge=de.startsWith("XHR timeout")?h.ExtensionGalleryErrorCode.Timeout:h.ExtensionGalleryErrorCode.Failed,new h.$kp(de,ge)}}finally{this.q.publicLog2("galleryService:query",{...C.telemetryData,requestBodySize:String(ne.length),duration:pe.elapsed(),success:!!me&&(0,p.$8p)(me),responseBodySize:me?.res.headers["Content-Length"],statusCode:me?String(me.res.statusCode):void 0,errorCode:ge,count:String(we)})}}async reportStatistic(C,X,Z,ne){if(!this.isEnabled())return;const ce=O.$o?this.y(`/itemName/${C}.${X}/version/${Z}/statType/${ne===h.StatisticType.Install?"1":"3"}/vscodewebextension`):this.y(`/publishers/${C}/extensions/${X}/${Z}/stats?statType=${ne}`),pe=O.$o?"api-version=6.1-preview.1":"*/*;api-version=4.0-preview.1",ge={...await this.j,Accept:pe};try{await this.l.request({type:"POST",url:ce,headers:ge},S.CancellationToken.None)}catch{}}async download(C,X,Z){this.n.trace("ExtensionGalleryService#download",C.identifier.id);const ne=(0,u.$Sp)(C),ce=new Date().getTime(),pe=Z===h.InstallOperation.Install?"install":Z===h.InstallOperation.Update?"update":"",me=pe?{uri:`${C.assets.download.uri}${m.URI.parse(C.assets.download.uri).query?"&":"?"}${pe}=true`,fallbackUri:`${C.assets.download.fallbackUri}${m.URI.parse(C.assets.download.fallbackUri).query?"&":"?"}${pe}=true`}:C.assets.download,ge=C.queryContext?.[r]?{[r]:C.queryContext[r]}:void 0,we=await this.F(C.identifier.id,me,f.VSIX,ge?{headers:ge}:void 0);try{await this.u.writeFile(X,we.stream)}catch(he){try{await this.u.del(X)}catch(de){this.n.warn(`Error while deleting the file ${X.toString()}`,(0,w.$ab)(de))}throw new h.$kp((0,w.$ab)(he),h.ExtensionGalleryErrorCode.DownloadFailedWriting)}this.q.publicLog("galleryService:downloadVSIX",{...ne,duration:new Date().getTime()-ce})}async downloadSignatureArchive(C,X){if(!C.assets.signature)throw new Error("No signature asset found");this.n.trace("ExtensionGalleryService#downloadSignatureArchive",C.identifier.id);const Z=await this.F(C.identifier.id,C.assets.signature,f.Signature);try{await this.u.writeFile(X,Z.stream)}catch(ne){try{await this.u.del(X)}catch(ce){this.n.warn(`Error while deleting the file ${X.toString()}`,(0,w.$ab)(ce))}throw new h.$kp((0,w.$ab)(ne),h.ExtensionGalleryErrorCode.DownloadFailedWriting)}}async getReadme(C,X){if(C.assets.readme){const Z=await this.F(C.identifier.id,C.assets.readme,f.Details,{},X);return await(0,p.$$p)(Z)||""}return""}async getManifest(C,X){if(C.assets.manifest){const Z=await this.F(C.identifier.id,C.assets.manifest,f.Manifest,{},X),ne=await(0,p.$$p)(Z);return ne?JSON.parse(ne):null}return null}async E(C,X,Z){const ne=se(X,f.Manifest);if(!ne)throw new Error("Manifest was not found");const ce={"Accept-Encoding":"gzip"},pe=await this.F(C,ne,f.Manifest,{headers:ce});return await(0,p.$_p)(pe)}async getCoreTranslation(C,X){const Z=C.assets.coreTranslations.filter(ne=>ne[0]===X.toUpperCase())[0];if(Z){const ne=await this.F(C.identifier.id,Z[1],Z[0]),ce=await(0,p.$$p)(ne);return ce?JSON.parse(ce):null}return null}async getChangelog(C,X){if(C.assets.changelog){const Z=await this.F(C.identifier.id,C.assets.changelog,f.Changelog,{},X);return await(0,p.$$p)(Z)||""}return""}async getAllCompatibleVersions(C,X,Z){let ne=new D().withFlags(i.IncludeVersions,i.IncludeCategoryAndTags,i.IncludeFiles,i.IncludeVersionProperties).withPage(1,1);C.uuid?ne=ne.withFilter(o.ExtensionId,C.uuid):ne=ne.withFilter(o.ExtensionName,C.id);const{galleryExtensions:ce}=await this.D(ne,S.CancellationToken.None);if(!ce.length)return[];const pe=te(ce[0]);if((0,h.$gp)(pe,Z))return[];const me=[];await Promise.all(ce[0].versions.map(async he=>{try{await this.A(C.id,he,X?"any":"release",!0,pe,Z)&&this.z(C,x(he))&&me.push(he)}catch{}}));const ge=[],we=new Set;for(const he of F(me,Z))we.has(he.version)||(we.add(he.version),ge.push({version:he.version,date:he.lastUpdated,isPreReleaseVersion:fe(he)}));return ge}async F(C,X,Z,ne={},ce=S.CancellationToken.None){const pe=await this.j,me={type:"GET"},ge={...pe,...ne.headers||{}};ne={...ne,...me,headers:ge};const we=X.uri,he=X.fallbackUri,de={...ne,url:we};try{const ve=await this.l.request(de,ce);if(ve.res.statusCode===200)return ve;const Pe=await(0,p.$$p)(ve);throw new Error(`Expected 200, got back ${ve.res.statusCode} instead.

${Pe}`)}catch(ve){if((0,w.$7)(ve))throw ve;const Pe=(0,w.$ab)(ve);this.q.publicLog2("galleryService:cdnFallback",{extension:C,assetType:Z,message:Pe});const W={...ne,url:he};return this.l.request(W,ce)}}async G(C,X){let Z=ue(X);if(!Z){this.q.publicLog2("galleryService:engineFallback",{extension:C,version:X.version});const ne=await this.E(C,X,S.CancellationToken.None);if(!ne)throw new Error("Manifest was not found");Z=ne.engines.vscode}return Z}async getExtensionsControlManifest(){if(!this.isEnabled())throw new Error("No extension gallery service configured.");if(!this.h)return{malicious:[],deprecated:{},search:[]};const C=await this.l.request({type:"GET",url:this.h},S.CancellationToken.None);if(C.res.statusCode!==200)throw new Error("Could not get extensions report.");const X=await(0,p.$_p)(C),Z=[],ne={},ce=[],pe=[];if(X){for(const me of X.malicious)Z.push({id:me});if(X.migrateToPreRelease)for(const[me,ge]of Object.entries(X.migrateToPreRelease))(!ge.engine||(0,g.$4p)(ge.engine,this.w.version,this.w.date))&&(ne[me.toLowerCase()]={disallowInstall:!0,extension:{id:ge.id,displayName:ge.displayName,autoMigrate:{storage:!!ge.migrateStorage},preRelease:!0}});if(X.deprecated)for(const[me,ge]of Object.entries(X.deprecated))ge&&(ne[me.toLowerCase()]=(0,I.$mg)(ge)?{}:ge);if(X.search)for(const me of X.search)ce.push(me);if(Array.isArray(X.extensionsEnabledWithPreRelease))for(const me of X.extensionsEnabledWithPreRelease)pe.push(me.toLowerCase())}return{malicious:Z,deprecated:ne,search:ce,extensionsEnabledWithPreRelease:pe}}};V=ye([re(1,p.$6p),re(2,v.$ak),re(3,c.$Ni),re(4,e.$_l),re(5,N.$al),re(6,d.$tk),re(7,l.$aj)],V);let P=class extends V{constructor(C,X,Z,ne,ce,pe,me,ge){super(C,X,Z,ne,ce,pe,me,ge)}};t.$pq=P,t.$pq=P=ye([re(0,y.$gq),re(1,p.$6p),re(2,v.$ak),re(3,c.$Ni),re(4,e.$_l),re(5,N.$al),re(6,d.$tk),re(7,l.$aj)],P);let j=class extends V{constructor(C,X,Z,ne,ce,pe,me){super(void 0,C,X,Z,ne,ce,pe,me)}};t.$qq=j,t.$qq=j=ye([re(0,p.$6p),re(1,v.$ak),re(2,c.$Ni),re(3,e.$_l),re(4,N.$al),re(5,d.$tk),re(6,l.$aj)],j)}),define(oe[169],ae([0,1,12,18,10,6,148,24,25,3,69]),function(H,t,E,S,w,O,L,I,m,l,c){"use strict";var h,u;Object.defineProperty(t,"__esModule",{value:!0}),t.$mR=t.$lR=t.$kR=void 0;let $=class extends m.$Pl{static{h=this}static{this.a="profileAssociationsMigration"}constructor(d,p,k,y,e){super(k,y,p,e),this.U=d,this.W=k}O(){return this.U.getItem(h.b,[]).map(p=>({...p,location:(0,l.$gg)(p.location)?this.w.extUri.joinPath(this.profilesHome,p.location):E.URI.revive(p.location)}))}Q(){const d=this.U.getItem(h.c,{});return this.U.getItem(h.a,!1)?d:this.N(d)}S(){return this.w.extUri.joinPath(E.URI.file(this.W.extensionsPath).with({scheme:this.profilesHome.scheme}),"extensions.json")}};t.$kR=$,t.$kR=$=h=ye([re(0,L.$fR),re(1,I.$Kl),re(2,S.$Oi),re(3,w.$al),re(4,O.$ak)],$);let g=u=class extends ${constructor(d,p,k,y,e){super(d,p,k,y,e),this.$=d}P(d){d.length?this.$.setItem(u.b,d.map(p=>({...p,location:this.w.extUri.basename(p.location)}))):this.$.removeItem(u.b)}O(){const d=super.O();return this.$.getItem("userDataProfilesMigration",!1)||(this.P(d),this.$.setItem("userDataProfilesMigration",!0)),d}R(d){d.emptyWindows||d.workspaces?this.$.setItem(u.c,d):this.$.removeItem(u.c)}Q(){const d="workspaceAndProfileInfo",p=this.$.getItem(d,void 0);if(p){this.$.removeItem(d);const y=p.reduce((e,{workspace:a,profile:n})=>(e[E.URI.revive(a).toString()]=E.URI.revive(n).toString(),e),{});this.$.setItem(u.c,{workspaces:y})}const k=super.Q();return this.$.getItem(u.a,!1)||(this.R(k),this.$.setItem(u.a,!0)),k}};t.$lR=g,t.$lR=g=u=ye([re(0,L.$gR),re(1,I.$Kl),re(2,S.$Oi),re(3,w.$al),re(4,O.$ak)],g);let N=class extends g{constructor(d,p,k,y){super(new c.$jR(c.SaveStrategy.IMMEDIATE,p,y,k),d,p,k,y)}async init(){return await this.$.init(),super.init()}};t.$mR=N,t.$mR=N=ye([re(0,I.$Kl),re(1,S.$Oi),re(2,w.$al),re(3,O.$ak)],N)}),define(oe[170],ae([0,1,146,8,14,9,3,30,18,147,6,46,145,181]),function(H,t,E,S,w,O,L,I,m,l,c,h,u,$){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$ds=void 0,t.$es=v;let g=class extends h.$7p{constructor(p,k,y,e){super(e),this.m=p,this.n=k,this.r=y,this.s(),this.B(p.onDidChangeConfiguration(a=>{a.affectsConfiguration("http")&&this.s()}))}s(){const p=this.m.getValue("http");this.f=p?.proxy,this.g=!!p?.proxyStrictSSL,this.h=p?.proxyAuthorization}async request(p,k){const{f:y,g:e}=this;let a;try{a=await(0,l.$Rm)(this.m,this.r,this.n.args,process.env)}catch(i){this.j||(this.j=!0,this.r.error("resolving shell environment failed",(0,O.$ab)(i)))}const n={...process.env,...a},r=p.agent?p.agent:await(0,u.$cs)(p.url||"",n,{proxyUrl:y,strictSSL:e});return p.agent=r,p.strictSSL=e,this.h&&(p.headers={...p.headers||{},"Proxy-Authorization":this.h}),this.c(p.isChromiumNetwork?"electron":"node",p,()=>v(p,k))}async resolveProxy(p){}async loadCertificates(){return(await new Promise((k,y)=>{H(["@vscode/proxy-agent"],k,y)}).then(be)).loadSystemCertificates({log:this.r})}};t.$ds=g,t.$ds=g=ye([re(0,I.$aj),re(1,m.$Oi),re(2,c.$ak),re(3,c.$bk)],g);async function N(d){return((0,E.parse)(d.url).protocol==="https:"?await new Promise((y,e)=>{H(["https"],y,e)}).then(be):await new Promise((y,e)=>{H(["http"],y,e)}).then(be)).request}async function v(d,p){return S.Promises.withAsyncBody(async(k,y)=>{const e=(0,E.parse)(d.url),a=d.getRawRequest?d.getRawRequest(d):await N(d),n={hostname:e.hostname,port:e.port?parseInt(e.port):e.protocol==="https:"?443:80,protocol:e.protocol,path:e.path,method:d.type||"GET",headers:d.headers,agent:d.agent,rejectUnauthorized:(0,L.$mg)(d.strictSSL)?d.strictSSL:!0};d.user&&d.password&&(n.auth=d.user+":"+d.password);const r=a(n,i=>{const s=(0,L.$kg)(d.followRedirects)?d.followRedirects:3;if(i.statusCode&&i.statusCode>=300&&i.statusCode<400&&s>0&&i.headers.location)v({...d,url:i.headers.location,followRedirects:s-1},p).then(k,y);else{let o=i;!d.isChromiumNetwork&&i.headers["content-encoding"]==="gzip"&&(o=i.pipe((0,$.createGunzip)())),k({res:i,stream:(0,w.$5e)(o)})}});r.on("error",y),d.timeout&&r.setTimeout(d.timeout),d.isChromiumNetwork&&r.removeHeader("Content-Length"),d.data&&typeof d.data=="string"&&r.write(d.data),r.end(),p.onCancellationRequested(()=>{r.abort(),y(new O.$8)})})}});var qe=this&&this.__importDefault||function(H){return H&&H.__esModule?H:{default:H}};define(oe[182],ae([0,1,35,8,38,9,2,15,16,13,36,12,26,30,142,61,144,18,120,168,21,71,149,42,54,163,165,10,132,134,51,130,64,68,151,6,138,39,139,154,33,46,170,69,70,19,153,41,155,156,24,158,25,169,157,164,135,137,4,159,183]),function(H,t,E,S,w,O,L,I,m,l,c,h,u,$,g,N,v,d,p,k,y,e,a,n,r,i,s,o,f,b,R,T,D,A,z,J,Q,se,le,ue,fe,x,_,B,M,G,Y,te,F,q,K,V,P,j,U,C,X,Z,ne,ce,pe){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.main=ge,ue=qe(ue);class me extends L.$Xc{constructor(he){super(),this.b=he,this.c()}c(){process.once("exit",()=>this.dispose())}async run(){const[he,de]=await this.f();return he.invokeFunction(async ve=>{const Pe=ve.get(J.$ak),W=ve.get(o.$al),ee=ve.get(d.$Oi),ie=ve.get(P.$Ml);Pe.info("CLI main",this.b),this.h(Pe),await this.j(ee,W,ie,he),await Promise.all(de.map($e=>{(0,S.$xh)($e.flush(),1e3)}))})}async f(){const he=new D.$Ei,de={_serviceBrand:void 0,...ue.default};he.set(fe.$tk,de);const ve=new p.$9m(this.b,de);he.set(d.$Oi,ve),await Promise.all([this.g(ve.appSettingsHome.with({scheme:I.Schemas.file}).fsPath),this.g(ve.extensionsPath)].map(Ie=>Ie?u.Promises.mkdir(Ie,{recursive:!0}):void 0));const Pe=new Z.$eR((0,J.$ok)(ve),ve.logsHome);he.set(J.$bk,Pe);const W=this.B(Pe.createLogger("cli",{name:(0,ne.localize)(0,null)})),ee=[];Pe.getLogLevel()===J.LogLevel.Trace&&ee.push(new J.$ik(Pe.getLogLevel()));const ie=this.B(new X.$oR(W,ee));he.set(J.$ak,ie);const $e=this.B(new f.$1q(ie));he.set(o.$al,$e);const Ee=this.B(new b.$rr(ie));$e.registerProvider(I.Schemas.file,Ee);const Ae=new V.$Ss($e);he.set(K.$Kl,Ae);const ke=new B.$iR(B.SaveStrategy.DELAYED,ve,ie,$e),Ce=new j.$kR(ke,Ae,ve,$e,ie);he.set(P.$Ml,Ce),$e.registerProvider(I.Schemas.vscodeUserData,new ce.$Zgc(I.Schemas.file,Ee,I.Schemas.vscodeUserData,Ce,Ae,ie));const Re=l.$i&&de.win32RegValueName?this.B(new le.$Xgc(ie,de.win32RegValueName)):ve.policyFile?this.B(new Q.$Ygc(ve.policyFile,$e,ie)):new se.$vo;he.set(se.$to,Re);const Le=this.B(new g.$Vo(Ce.defaultProfile.settingsResource,$e,Re,ie));he.set($.$aj,Le),await Promise.all([ke.init(),Le.initialize()]);let Me;try{Me=await(0,U.$zgc)(ke,ie)}catch(Ie){Ie.code!=="ENOENT"&&ie.error(Ie)}const Ne=await(0,U.$Agc)(ke,ie),Te=await(0,U.$Bgc)(ke,ie);Ce.init(),he.set(K.$Kl,new V.$Ss($e));const Fe=new _.$ds(Le,ve,ie,Pe);he.set(x.$6p,Fe),he.set(N.$Zo,new R.$Di(v.$DR,void 0,!0)),he.set(n.$Hq,new R.$Di(C.$nR,void 0,!0)),he.set(r.$Lq,new R.$Di(s.$wgc,void 0,!0)),he.set(e.$rq,new R.$Di(e.$tq,void 0,!0)),he.set(i.$Wq,new R.$Di(i.$Xq,void 0,!0)),he.set(y.$jp,new R.$Di(k.$qq,void 0,!0)),he.set(A.$0r,new R.$Di(z.$_r,void 0,!1));const Ue=[],Se=(0,te.$Hp)(de,Le);if((0,te.$Cp)(de,ve)){de.aiConfig&&de.aiConfig.ariaKey&&Ue.push(new F.$cR(Fe,Se,"monacoworkbench",null,de.aiConfig.ariaKey));const Ie={appenders:Ue,sendErrorTelemetry:!1,commonProperties:(0,M.$tp)((0,E.release)(),(0,E.hostname)(),process.arch,de.commit,de.version,Me,Ne,Te,Se),piiPaths:(0,te.$Ip)(ve)};he.set(G.$_l,new R.$Di(Y.$fs,[Ie],!1))}else he.set(G.$_l,te.$xp);return[new T.$ur(he),Ue]}g(he){if(l.$i){const de=(0,pe.getUNCHost)(he);de&&(0,pe.addUNCHostToAllowlist)(de)}return he}h(he){(0,O.setUnexpectedErrorHandler)(de=>{const ve=(0,w.$rj)(de,!0);ve&&he.error(`[uncaught exception in CLI]: ${ve}`)}),process.on("uncaughtException",de=>{(0,O.$2)(de)||(0,O.$3)(de)}),process.on("unhandledRejection",de=>(0,O.$3)(de))}async j(he,de,ve,Pe){let W;if(he.args.profile&&(W=ve.profiles.find(ie=>ie.name===he.args.profile),!W))throw new Error(`Profile '${he.args.profile}' not found.`);const ee=(W??ve.defaultProfile).extensionsResource;if(this.b["list-extensions"])return Pe.createInstance(a.$uq,new J.$ik(J.LogLevel.Info,!1)).listExtensions(!!this.b["show-versions"],this.b.category,ee);if(this.b["install-extension"]||this.b["install-builtin-extension"]){const ie={isMachineScoped:!!this.b["do-not-sync"],installPreReleaseVersion:!!this.b["pre-release"],profileLocation:ee};return Pe.createInstance(a.$uq,new J.$ik(J.LogLevel.Info,!1)).installExtensions(this.m(this.b["install-extension"]||[]),this.m(this.b["install-builtin-extension"]||[]),ie,!!this.b.force)}else{if(this.b["uninstall-extension"])return Pe.createInstance(a.$uq,new J.$ik(J.LogLevel.Info,!1)).uninstallExtensions(this.m(this.b["uninstall-extension"]),!!this.b.force,ee);if(this.b["update-extensions"])return Pe.createInstance(a.$uq,new J.$ik(J.LogLevel.Info,!1)).updateExtensions(ee);if(this.b["locate-extension"])return Pe.createInstance(a.$uq,new J.$ik(J.LogLevel.Info,!1)).locateExtension(this.b["locate-extension"]);this.b.telemetry&&console.log(await(0,q.$dhc)(he.appRoot,he.extensionsPath))}}m(he){return he.map(de=>/\.vsix$/i.test(de)?h.URI.file((0,m.$lc)(de)?de:(0,m.$mc)((0,c.cwd)(),de)):de)}}async function ge(we){const he=new me(we);try{await he.run()}finally{he.dispose()}}})}).call(this);

//# sourceMappingURL=https://main.vscode-cdn.net/sourcemaps/undefined/core/vs/code/node/cliProcessMain.js.map
