/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var _e=["require","exports","vs/base/common/platform","vs/base/common/path","vs/base/common/lifecycle","vs/base/common/uri","vs/base/common/event","vs/base/common/strings","vs/base/common/async","vs/base/common/errors","vs/base/common/types","vs/base/common/charCode","vs/base/common/arrays","vs/base/common/cancellation","vs/base/common/extpath","vs/base/common/lazy","vs/base/common/buffer","fs","vs/platform/files/common/files","vs/platform/files/common/watcher","vs/base/common/map","vs/base/common/normalization","vs/base/common/resources","vs/base/common/glob","vs/base/node/pfs","vs/base/parts/ipc/common/ipc","vs/base/common/functional","vs/base/common/marshallingIds","vs/base/common/ternarySearchTree","vs/base/parts/sandbox/node/electronTypes","vs/nls","vs/nls!vs/platform/files/node/watcher/watcherMain","vs/base/common/process","vs/base/common/processes","vs/base/common/network","vs/base/node/extpath","vs/platform/files/node/watcher/baseWatcher","vs/platform/files/node/watcher/nodejs/nodejsWatcherLib","vs/base/common/arraysFind","vs/base/common/collections","vs/base/common/decorators","vs/base/common/iterator","vs/base/common/linkedList","vs/base/common/stopwatch","vs/base/common/cache","vs/base/common/stream","vs/base/common/symbols","vs/base/common/objects","vs/base/common/uint","vs/nls!vs/base/common/errorMessage","vs/base/common/errorMessage","vs/nls!vs/base/common/platform","vs/base/common/console","vs/base/common/marshalling","os","vs/base/node/processes","vs/base/parts/ipc/node/ipc.cp","vs/base/parts/ipc/node/ipc.mp","vs/nls!vs/platform/files/common/files","vs/platform/instantiation/common/instantiation","vs/platform/files/node/watcher/nodejs/nodejsWatcher","vs/platform/files/node/watcher/parcel/parcelWatcher","vs/platform/files/node/watcher/watcherStats","vs/platform/files/node/watcher/watcher","util","child_process","@parcel/watcher","vs/platform/files/node/watcher/watcherMain"],Ee=function(ae){for(var e=[],g=0,t=ae.length;g<t;g++)e[g]=_e[ae[g]];return e};define(_e[38],Ee([0,1]),function(ae,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pb=void 0,e.$ib=g,e.$jb=t,e.$kb=W,e.$lb=M,e.$mb=Y,e.$nb=F,e.$ob=U,e.$qb=N,e.$rb=_,e.$sb=v,e.$tb=k,e.$ub=o;function g(s,$){const m=t(s,$);if(m!==-1)return s[m]}function t(s,$,m=s.length-1){for(let f=m;f>=0;f--){const w=s[f];if($(w))return f}return-1}function W(s,$){const m=M(s,$);return m===-1?void 0:s[m]}function M(s,$,m=0,f=s.length){let w=m,y=f;for(;w<y;){const r=Math.floor((w+y)/2);$(s[r])?w=r+1:y=r}return w-1}function Y(s,$){const m=F(s,$);return m===s.length?void 0:s[m]}function F(s,$,m=0,f=s.length){let w=m,y=f;for(;w<y;){const r=Math.floor((w+y)/2);$(s[r])?y=r:w=r+1}return w}function U(s,$,m=0,f=s.length){const w=F(s,$,m,f);return w===s.length?-1:w}class P{static{this.assertInvariants=!1}constructor($){this.e=$,this.c=0}findLastMonotonous($){if(P.assertInvariants){if(this.d){for(const f of this.e)if(this.d(f)&&!$(f))throw new Error("MonotonousArray: current predicate must be weaker than (or equal to) the previous predicate.")}this.d=$}const m=M(this.e,$,this.c);return this.c=m+1,m===-1?void 0:this.e[m]}}e.$pb=P;function N(s,$){if(s.length===0)return;let m=s[0];for(let f=1;f<s.length;f++){const w=s[f];$(w,m)>0&&(m=w)}return m}function _(s,$){if(s.length===0)return;let m=s[0];for(let f=1;f<s.length;f++){const w=s[f];$(w,m)>=0&&(m=w)}return m}function v(s,$){return N(s,(m,f)=>-$(m,f))}function k(s,$){if(s.length===0)return-1;let m=0;for(let f=1;f<s.length;f++){const w=s[f];$(w,s[m])>0&&(m=f)}return m}function o(s,$){for(const m of s){const f=$(m);if(f!==void 0)return f}}}),define(_e[11],Ee([0,1]),function(ae,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CharCode=void 0;var g;(function(t){t[t.Null=0]="Null",t[t.Backspace=8]="Backspace",t[t.Tab=9]="Tab",t[t.LineFeed=10]="LineFeed",t[t.CarriageReturn=13]="CarriageReturn",t[t.Space=32]="Space",t[t.ExclamationMark=33]="ExclamationMark",t[t.DoubleQuote=34]="DoubleQuote",t[t.Hash=35]="Hash",t[t.DollarSign=36]="DollarSign",t[t.PercentSign=37]="PercentSign",t[t.Ampersand=38]="Ampersand",t[t.SingleQuote=39]="SingleQuote",t[t.OpenParen=40]="OpenParen",t[t.CloseParen=41]="CloseParen",t[t.Asterisk=42]="Asterisk",t[t.Plus=43]="Plus",t[t.Comma=44]="Comma",t[t.Dash=45]="Dash",t[t.Period=46]="Period",t[t.Slash=47]="Slash",t[t.Digit0=48]="Digit0",t[t.Digit1=49]="Digit1",t[t.Digit2=50]="Digit2",t[t.Digit3=51]="Digit3",t[t.Digit4=52]="Digit4",t[t.Digit5=53]="Digit5",t[t.Digit6=54]="Digit6",t[t.Digit7=55]="Digit7",t[t.Digit8=56]="Digit8",t[t.Digit9=57]="Digit9",t[t.Colon=58]="Colon",t[t.Semicolon=59]="Semicolon",t[t.LessThan=60]="LessThan",t[t.Equals=61]="Equals",t[t.GreaterThan=62]="GreaterThan",t[t.QuestionMark=63]="QuestionMark",t[t.AtSign=64]="AtSign",t[t.A=65]="A",t[t.B=66]="B",t[t.C=67]="C",t[t.D=68]="D",t[t.E=69]="E",t[t.F=70]="F",t[t.G=71]="G",t[t.H=72]="H",t[t.I=73]="I",t[t.J=74]="J",t[t.K=75]="K",t[t.L=76]="L",t[t.M=77]="M",t[t.N=78]="N",t[t.O=79]="O",t[t.P=80]="P",t[t.Q=81]="Q",t[t.R=82]="R",t[t.S=83]="S",t[t.T=84]="T",t[t.U=85]="U",t[t.V=86]="V",t[t.W=87]="W",t[t.X=88]="X",t[t.Y=89]="Y",t[t.Z=90]="Z",t[t.OpenSquareBracket=91]="OpenSquareBracket",t[t.Backslash=92]="Backslash",t[t.CloseSquareBracket=93]="CloseSquareBracket",t[t.Caret=94]="Caret",t[t.Underline=95]="Underline",t[t.BackTick=96]="BackTick",t[t.a=97]="a",t[t.b=98]="b",t[t.c=99]="c",t[t.d=100]="d",t[t.e=101]="e",t[t.f=102]="f",t[t.g=103]="g",t[t.h=104]="h",t[t.i=105]="i",t[t.j=106]="j",t[t.k=107]="k",t[t.l=108]="l",t[t.m=109]="m",t[t.n=110]="n",t[t.o=111]="o",t[t.p=112]="p",t[t.q=113]="q",t[t.r=114]="r",t[t.s=115]="s",t[t.t=116]="t",t[t.u=117]="u",t[t.v=118]="v",t[t.w=119]="w",t[t.x=120]="x",t[t.y=121]="y",t[t.z=122]="z",t[t.OpenCurlyBrace=123]="OpenCurlyBrace",t[t.Pipe=124]="Pipe",t[t.CloseCurlyBrace=125]="CloseCurlyBrace",t[t.Tilde=126]="Tilde",t[t.NoBreakSpace=160]="NoBreakSpace",t[t.U_Combining_Grave_Accent=768]="U_Combining_Grave_Accent",t[t.U_Combining_Acute_Accent=769]="U_Combining_Acute_Accent",t[t.U_Combining_Circumflex_Accent=770]="U_Combining_Circumflex_Accent",t[t.U_Combining_Tilde=771]="U_Combining_Tilde",t[t.U_Combining_Macron=772]="U_Combining_Macron",t[t.U_Combining_Overline=773]="U_Combining_Overline",t[t.U_Combining_Breve=774]="U_Combining_Breve",t[t.U_Combining_Dot_Above=775]="U_Combining_Dot_Above",t[t.U_Combining_Diaeresis=776]="U_Combining_Diaeresis",t[t.U_Combining_Hook_Above=777]="U_Combining_Hook_Above",t[t.U_Combining_Ring_Above=778]="U_Combining_Ring_Above",t[t.U_Combining_Double_Acute_Accent=779]="U_Combining_Double_Acute_Accent",t[t.U_Combining_Caron=780]="U_Combining_Caron",t[t.U_Combining_Vertical_Line_Above=781]="U_Combining_Vertical_Line_Above",t[t.U_Combining_Double_Vertical_Line_Above=782]="U_Combining_Double_Vertical_Line_Above",t[t.U_Combining_Double_Grave_Accent=783]="U_Combining_Double_Grave_Accent",t[t.U_Combining_Candrabindu=784]="U_Combining_Candrabindu",t[t.U_Combining_Inverted_Breve=785]="U_Combining_Inverted_Breve",t[t.U_Combining_Turned_Comma_Above=786]="U_Combining_Turned_Comma_Above",t[t.U_Combining_Comma_Above=787]="U_Combining_Comma_Above",t[t.U_Combining_Reversed_Comma_Above=788]="U_Combining_Reversed_Comma_Above",t[t.U_Combining_Comma_Above_Right=789]="U_Combining_Comma_Above_Right",t[t.U_Combining_Grave_Accent_Below=790]="U_Combining_Grave_Accent_Below",t[t.U_Combining_Acute_Accent_Below=791]="U_Combining_Acute_Accent_Below",t[t.U_Combining_Left_Tack_Below=792]="U_Combining_Left_Tack_Below",t[t.U_Combining_Right_Tack_Below=793]="U_Combining_Right_Tack_Below",t[t.U_Combining_Left_Angle_Above=794]="U_Combining_Left_Angle_Above",t[t.U_Combining_Horn=795]="U_Combining_Horn",t[t.U_Combining_Left_Half_Ring_Below=796]="U_Combining_Left_Half_Ring_Below",t[t.U_Combining_Up_Tack_Below=797]="U_Combining_Up_Tack_Below",t[t.U_Combining_Down_Tack_Below=798]="U_Combining_Down_Tack_Below",t[t.U_Combining_Plus_Sign_Below=799]="U_Combining_Plus_Sign_Below",t[t.U_Combining_Minus_Sign_Below=800]="U_Combining_Minus_Sign_Below",t[t.U_Combining_Palatalized_Hook_Below=801]="U_Combining_Palatalized_Hook_Below",t[t.U_Combining_Retroflex_Hook_Below=802]="U_Combining_Retroflex_Hook_Below",t[t.U_Combining_Dot_Below=803]="U_Combining_Dot_Below",t[t.U_Combining_Diaeresis_Below=804]="U_Combining_Diaeresis_Below",t[t.U_Combining_Ring_Below=805]="U_Combining_Ring_Below",t[t.U_Combining_Comma_Below=806]="U_Combining_Comma_Below",t[t.U_Combining_Cedilla=807]="U_Combining_Cedilla",t[t.U_Combining_Ogonek=808]="U_Combining_Ogonek",t[t.U_Combining_Vertical_Line_Below=809]="U_Combining_Vertical_Line_Below",t[t.U_Combining_Bridge_Below=810]="U_Combining_Bridge_Below",t[t.U_Combining_Inverted_Double_Arch_Below=811]="U_Combining_Inverted_Double_Arch_Below",t[t.U_Combining_Caron_Below=812]="U_Combining_Caron_Below",t[t.U_Combining_Circumflex_Accent_Below=813]="U_Combining_Circumflex_Accent_Below",t[t.U_Combining_Breve_Below=814]="U_Combining_Breve_Below",t[t.U_Combining_Inverted_Breve_Below=815]="U_Combining_Inverted_Breve_Below",t[t.U_Combining_Tilde_Below=816]="U_Combining_Tilde_Below",t[t.U_Combining_Macron_Below=817]="U_Combining_Macron_Below",t[t.U_Combining_Low_Line=818]="U_Combining_Low_Line",t[t.U_Combining_Double_Low_Line=819]="U_Combining_Double_Low_Line",t[t.U_Combining_Tilde_Overlay=820]="U_Combining_Tilde_Overlay",t[t.U_Combining_Short_Stroke_Overlay=821]="U_Combining_Short_Stroke_Overlay",t[t.U_Combining_Long_Stroke_Overlay=822]="U_Combining_Long_Stroke_Overlay",t[t.U_Combining_Short_Solidus_Overlay=823]="U_Combining_Short_Solidus_Overlay",t[t.U_Combining_Long_Solidus_Overlay=824]="U_Combining_Long_Solidus_Overlay",t[t.U_Combining_Right_Half_Ring_Below=825]="U_Combining_Right_Half_Ring_Below",t[t.U_Combining_Inverted_Bridge_Below=826]="U_Combining_Inverted_Bridge_Below",t[t.U_Combining_Square_Below=827]="U_Combining_Square_Below",t[t.U_Combining_Seagull_Below=828]="U_Combining_Seagull_Below",t[t.U_Combining_X_Above=829]="U_Combining_X_Above",t[t.U_Combining_Vertical_Tilde=830]="U_Combining_Vertical_Tilde",t[t.U_Combining_Double_Overline=831]="U_Combining_Double_Overline",t[t.U_Combining_Grave_Tone_Mark=832]="U_Combining_Grave_Tone_Mark",t[t.U_Combining_Acute_Tone_Mark=833]="U_Combining_Acute_Tone_Mark",t[t.U_Combining_Greek_Perispomeni=834]="U_Combining_Greek_Perispomeni",t[t.U_Combining_Greek_Koronis=835]="U_Combining_Greek_Koronis",t[t.U_Combining_Greek_Dialytika_Tonos=836]="U_Combining_Greek_Dialytika_Tonos",t[t.U_Combining_Greek_Ypogegrammeni=837]="U_Combining_Greek_Ypogegrammeni",t[t.U_Combining_Bridge_Above=838]="U_Combining_Bridge_Above",t[t.U_Combining_Equals_Sign_Below=839]="U_Combining_Equals_Sign_Below",t[t.U_Combining_Double_Vertical_Line_Below=840]="U_Combining_Double_Vertical_Line_Below",t[t.U_Combining_Left_Angle_Below=841]="U_Combining_Left_Angle_Below",t[t.U_Combining_Not_Tilde_Above=842]="U_Combining_Not_Tilde_Above",t[t.U_Combining_Homothetic_Above=843]="U_Combining_Homothetic_Above",t[t.U_Combining_Almost_Equal_To_Above=844]="U_Combining_Almost_Equal_To_Above",t[t.U_Combining_Left_Right_Arrow_Below=845]="U_Combining_Left_Right_Arrow_Below",t[t.U_Combining_Upwards_Arrow_Below=846]="U_Combining_Upwards_Arrow_Below",t[t.U_Combining_Grapheme_Joiner=847]="U_Combining_Grapheme_Joiner",t[t.U_Combining_Right_Arrowhead_Above=848]="U_Combining_Right_Arrowhead_Above",t[t.U_Combining_Left_Half_Ring_Above=849]="U_Combining_Left_Half_Ring_Above",t[t.U_Combining_Fermata=850]="U_Combining_Fermata",t[t.U_Combining_X_Below=851]="U_Combining_X_Below",t[t.U_Combining_Left_Arrowhead_Below=852]="U_Combining_Left_Arrowhead_Below",t[t.U_Combining_Right_Arrowhead_Below=853]="U_Combining_Right_Arrowhead_Below",t[t.U_Combining_Right_Arrowhead_And_Up_Arrowhead_Below=854]="U_Combining_Right_Arrowhead_And_Up_Arrowhead_Below",t[t.U_Combining_Right_Half_Ring_Above=855]="U_Combining_Right_Half_Ring_Above",t[t.U_Combining_Dot_Above_Right=856]="U_Combining_Dot_Above_Right",t[t.U_Combining_Asterisk_Below=857]="U_Combining_Asterisk_Below",t[t.U_Combining_Double_Ring_Below=858]="U_Combining_Double_Ring_Below",t[t.U_Combining_Zigzag_Above=859]="U_Combining_Zigzag_Above",t[t.U_Combining_Double_Breve_Below=860]="U_Combining_Double_Breve_Below",t[t.U_Combining_Double_Breve=861]="U_Combining_Double_Breve",t[t.U_Combining_Double_Macron=862]="U_Combining_Double_Macron",t[t.U_Combining_Double_Macron_Below=863]="U_Combining_Double_Macron_Below",t[t.U_Combining_Double_Tilde=864]="U_Combining_Double_Tilde",t[t.U_Combining_Double_Inverted_Breve=865]="U_Combining_Double_Inverted_Breve",t[t.U_Combining_Double_Rightwards_Arrow_Below=866]="U_Combining_Double_Rightwards_Arrow_Below",t[t.U_Combining_Latin_Small_Letter_A=867]="U_Combining_Latin_Small_Letter_A",t[t.U_Combining_Latin_Small_Letter_E=868]="U_Combining_Latin_Small_Letter_E",t[t.U_Combining_Latin_Small_Letter_I=869]="U_Combining_Latin_Small_Letter_I",t[t.U_Combining_Latin_Small_Letter_O=870]="U_Combining_Latin_Small_Letter_O",t[t.U_Combining_Latin_Small_Letter_U=871]="U_Combining_Latin_Small_Letter_U",t[t.U_Combining_Latin_Small_Letter_C=872]="U_Combining_Latin_Small_Letter_C",t[t.U_Combining_Latin_Small_Letter_D=873]="U_Combining_Latin_Small_Letter_D",t[t.U_Combining_Latin_Small_Letter_H=874]="U_Combining_Latin_Small_Letter_H",t[t.U_Combining_Latin_Small_Letter_M=875]="U_Combining_Latin_Small_Letter_M",t[t.U_Combining_Latin_Small_Letter_R=876]="U_Combining_Latin_Small_Letter_R",t[t.U_Combining_Latin_Small_Letter_T=877]="U_Combining_Latin_Small_Letter_T",t[t.U_Combining_Latin_Small_Letter_V=878]="U_Combining_Latin_Small_Letter_V",t[t.U_Combining_Latin_Small_Letter_X=879]="U_Combining_Latin_Small_Letter_X",t[t.LINE_SEPARATOR=8232]="LINE_SEPARATOR",t[t.PARAGRAPH_SEPARATOR=8233]="PARAGRAPH_SEPARATOR",t[t.NEXT_LINE=133]="NEXT_LINE",t[t.U_CIRCUMFLEX=94]="U_CIRCUMFLEX",t[t.U_GRAVE_ACCENT=96]="U_GRAVE_ACCENT",t[t.U_DIAERESIS=168]="U_DIAERESIS",t[t.U_MACRON=175]="U_MACRON",t[t.U_ACUTE_ACCENT=180]="U_ACUTE_ACCENT",t[t.U_CEDILLA=184]="U_CEDILLA",t[t.U_MODIFIER_LETTER_LEFT_ARROWHEAD=706]="U_MODIFIER_LETTER_LEFT_ARROWHEAD",t[t.U_MODIFIER_LETTER_RIGHT_ARROWHEAD=707]="U_MODIFIER_LETTER_RIGHT_ARROWHEAD",t[t.U_MODIFIER_LETTER_UP_ARROWHEAD=708]="U_MODIFIER_LETTER_UP_ARROWHEAD",t[t.U_MODIFIER_LETTER_DOWN_ARROWHEAD=709]="U_MODIFIER_LETTER_DOWN_ARROWHEAD",t[t.U_MODIFIER_LETTER_CENTRED_RIGHT_HALF_RING=722]="U_MODIFIER_LETTER_CENTRED_RIGHT_HALF_RING",t[t.U_MODIFIER_LETTER_CENTRED_LEFT_HALF_RING=723]="U_MODIFIER_LETTER_CENTRED_LEFT_HALF_RING",t[t.U_MODIFIER_LETTER_UP_TACK=724]="U_MODIFIER_LETTER_UP_TACK",t[t.U_MODIFIER_LETTER_DOWN_TACK=725]="U_MODIFIER_LETTER_DOWN_TACK",t[t.U_MODIFIER_LETTER_PLUS_SIGN=726]="U_MODIFIER_LETTER_PLUS_SIGN",t[t.U_MODIFIER_LETTER_MINUS_SIGN=727]="U_MODIFIER_LETTER_MINUS_SIGN",t[t.U_BREVE=728]="U_BREVE",t[t.U_DOT_ABOVE=729]="U_DOT_ABOVE",t[t.U_RING_ABOVE=730]="U_RING_ABOVE",t[t.U_OGONEK=731]="U_OGONEK",t[t.U_SMALL_TILDE=732]="U_SMALL_TILDE",t[t.U_DOUBLE_ACUTE_ACCENT=733]="U_DOUBLE_ACUTE_ACCENT",t[t.U_MODIFIER_LETTER_RHOTIC_HOOK=734]="U_MODIFIER_LETTER_RHOTIC_HOOK",t[t.U_MODIFIER_LETTER_CROSS_ACCENT=735]="U_MODIFIER_LETTER_CROSS_ACCENT",t[t.U_MODIFIER_LETTER_EXTRA_HIGH_TONE_BAR=741]="U_MODIFIER_LETTER_EXTRA_HIGH_TONE_BAR",t[t.U_MODIFIER_LETTER_HIGH_TONE_BAR=742]="U_MODIFIER_LETTER_HIGH_TONE_BAR",t[t.U_MODIFIER_LETTER_MID_TONE_BAR=743]="U_MODIFIER_LETTER_MID_TONE_BAR",t[t.U_MODIFIER_LETTER_LOW_TONE_BAR=744]="U_MODIFIER_LETTER_LOW_TONE_BAR",t[t.U_MODIFIER_LETTER_EXTRA_LOW_TONE_BAR=745]="U_MODIFIER_LETTER_EXTRA_LOW_TONE_BAR",t[t.U_MODIFIER_LETTER_YIN_DEPARTING_TONE_MARK=746]="U_MODIFIER_LETTER_YIN_DEPARTING_TONE_MARK",t[t.U_MODIFIER_LETTER_YANG_DEPARTING_TONE_MARK=747]="U_MODIFIER_LETTER_YANG_DEPARTING_TONE_MARK",t[t.U_MODIFIER_LETTER_UNASPIRATED=749]="U_MODIFIER_LETTER_UNASPIRATED",t[t.U_MODIFIER_LETTER_LOW_DOWN_ARROWHEAD=751]="U_MODIFIER_LETTER_LOW_DOWN_ARROWHEAD",t[t.U_MODIFIER_LETTER_LOW_UP_ARROWHEAD=752]="U_MODIFIER_LETTER_LOW_UP_ARROWHEAD",t[t.U_MODIFIER_LETTER_LOW_LEFT_ARROWHEAD=753]="U_MODIFIER_LETTER_LOW_LEFT_ARROWHEAD",t[t.U_MODIFIER_LETTER_LOW_RIGHT_ARROWHEAD=754]="U_MODIFIER_LETTER_LOW_RIGHT_ARROWHEAD",t[t.U_MODIFIER_LETTER_LOW_RING=755]="U_MODIFIER_LETTER_LOW_RING",t[t.U_MODIFIER_LETTER_MIDDLE_GRAVE_ACCENT=756]="U_MODIFIER_LETTER_MIDDLE_GRAVE_ACCENT",t[t.U_MODIFIER_LETTER_MIDDLE_DOUBLE_GRAVE_ACCENT=757]="U_MODIFIER_LETTER_MIDDLE_DOUBLE_GRAVE_ACCENT",t[t.U_MODIFIER_LETTER_MIDDLE_DOUBLE_ACUTE_ACCENT=758]="U_MODIFIER_LETTER_MIDDLE_DOUBLE_ACUTE_ACCENT",t[t.U_MODIFIER_LETTER_LOW_TILDE=759]="U_MODIFIER_LETTER_LOW_TILDE",t[t.U_MODIFIER_LETTER_RAISED_COLON=760]="U_MODIFIER_LETTER_RAISED_COLON",t[t.U_MODIFIER_LETTER_BEGIN_HIGH_TONE=761]="U_MODIFIER_LETTER_BEGIN_HIGH_TONE",t[t.U_MODIFIER_LETTER_END_HIGH_TONE=762]="U_MODIFIER_LETTER_END_HIGH_TONE",t[t.U_MODIFIER_LETTER_BEGIN_LOW_TONE=763]="U_MODIFIER_LETTER_BEGIN_LOW_TONE",t[t.U_MODIFIER_LETTER_END_LOW_TONE=764]="U_MODIFIER_LETTER_END_LOW_TONE",t[t.U_MODIFIER_LETTER_SHELF=765]="U_MODIFIER_LETTER_SHELF",t[t.U_MODIFIER_LETTER_OPEN_SHELF=766]="U_MODIFIER_LETTER_OPEN_SHELF",t[t.U_MODIFIER_LETTER_LOW_LEFT_ARROW=767]="U_MODIFIER_LETTER_LOW_LEFT_ARROW",t[t.U_GREEK_LOWER_NUMERAL_SIGN=885]="U_GREEK_LOWER_NUMERAL_SIGN",t[t.U_GREEK_TONOS=900]="U_GREEK_TONOS",t[t.U_GREEK_DIALYTIKA_TONOS=901]="U_GREEK_DIALYTIKA_TONOS",t[t.U_GREEK_KORONIS=8125]="U_GREEK_KORONIS",t[t.U_GREEK_PSILI=8127]="U_GREEK_PSILI",t[t.U_GREEK_PERISPOMENI=8128]="U_GREEK_PERISPOMENI",t[t.U_GREEK_DIALYTIKA_AND_PERISPOMENI=8129]="U_GREEK_DIALYTIKA_AND_PERISPOMENI",t[t.U_GREEK_PSILI_AND_VARIA=8141]="U_GREEK_PSILI_AND_VARIA",t[t.U_GREEK_PSILI_AND_OXIA=8142]="U_GREEK_PSILI_AND_OXIA",t[t.U_GREEK_PSILI_AND_PERISPOMENI=8143]="U_GREEK_PSILI_AND_PERISPOMENI",t[t.U_GREEK_DASIA_AND_VARIA=8157]="U_GREEK_DASIA_AND_VARIA",t[t.U_GREEK_DASIA_AND_OXIA=8158]="U_GREEK_DASIA_AND_OXIA",t[t.U_GREEK_DASIA_AND_PERISPOMENI=8159]="U_GREEK_DASIA_AND_PERISPOMENI",t[t.U_GREEK_DIALYTIKA_AND_VARIA=8173]="U_GREEK_DIALYTIKA_AND_VARIA",t[t.U_GREEK_DIALYTIKA_AND_OXIA=8174]="U_GREEK_DIALYTIKA_AND_OXIA",t[t.U_GREEK_VARIA=8175]="U_GREEK_VARIA",t[t.U_GREEK_OXIA=8189]="U_GREEK_OXIA",t[t.U_GREEK_DASIA=8190]="U_GREEK_DASIA",t[t.U_IDEOGRAPHIC_FULL_STOP=12290]="U_IDEOGRAPHIC_FULL_STOP",t[t.U_LEFT_CORNER_BRACKET=12300]="U_LEFT_CORNER_BRACKET",t[t.U_RIGHT_CORNER_BRACKET=12301]="U_RIGHT_CORNER_BRACKET",t[t.U_LEFT_BLACK_LENTICULAR_BRACKET=12304]="U_LEFT_BLACK_LENTICULAR_BRACKET",t[t.U_RIGHT_BLACK_LENTICULAR_BRACKET=12305]="U_RIGHT_BLACK_LENTICULAR_BRACKET",t[t.U_OVERLINE=8254]="U_OVERLINE",t[t.UTF8_BOM=65279]="UTF8_BOM",t[t.U_FULLWIDTH_SEMICOLON=65307]="U_FULLWIDTH_SEMICOLON",t[t.U_FULLWIDTH_COMMA=65292]="U_FULLWIDTH_COMMA"})(g||(e.CharCode=g={}))}),define(_e[39],Ee([0,1]),function(ae,e){"use strict";var g;Object.defineProperty(e,"__esModule",{value:!0}),e.$O=void 0,e.$K=t,e.$L=W,e.$M=M,e.$N=Y;function t(U,P){const N=Object.create(null);for(const _ of U){const v=P(_);let k=N[v];k||(k=N[v]=[]),k.push(_)}return N}function W(U,P){const N=[],_=[];for(const v of U)P.has(v)||N.push(v);for(const v of P)U.has(v)||_.push(v);return{removed:N,added:_}}function M(U,P){const N=[],_=[];for(const[v,k]of U)P.has(v)||N.push(k);for(const[v,k]of P)U.has(v)||_.push(k);return{removed:N,added:_}}function Y(U,P){const N=new Set;for(const _ of P)U.has(_)&&N.add(_);return N}class F{static{g=Symbol.toStringTag}constructor(P,N){this.b=N,this.a=new Map,this[g]="SetWithKey";for(const _ of P)this.add(_)}get size(){return this.a.size}add(P){const N=this.b(P);return this.a.set(N,P),this}delete(P){return this.a.delete(this.b(P))}has(P){return this.a.has(this.b(P))}*entries(){for(const P of this.a.values())yield[P,P]}keys(){return this.values()}*values(){for(const P of this.a.values())yield P}clear(){this.a.clear()}forEach(P,N){this.a.forEach(_=>P.call(N,_,_,this))}[Symbol.iterator](){return this.values()}}e.$O=F}),define(_e[40],Ee([0,1]),function(ae,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$h=t,e.$_h=W,e.$ai=M;function g(Y){return(F,U,P)=>{let N=null,_=null;if(typeof P.value=="function"?(N="value",_=P.value):typeof P.get=="function"&&(N="get",_=P.get),!_)throw new Error("not supported");P[N]=Y(_,U)}}function t(Y,F,U){let P=null,N=null;if(typeof U.value=="function"?(P="value",N=U.value,N.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof U.get=="function"&&(P="get",N=U.get),!N)throw new Error("not supported");const _=`$memoize$${F}`;U[P]=function(...v){return this.hasOwnProperty(_)||Object.defineProperty(this,_,{configurable:!1,enumerable:!1,writable:!1,value:N.apply(this,v)}),this[_]}}function W(Y,F,U){return g((P,N)=>{const _=`$debounce$${N}`,v=`$debounce$result$${N}`;return function(...k){this[v]||(this[v]=U?U():void 0),clearTimeout(this[_]),F&&(this[v]=F(this[v],...k),k=[this[v]]),this[_]=setTimeout(()=>{P.apply(this,k),this[v]=U?U():void 0},Y)}})}function M(Y,F,U){return g((P,N)=>{const _=`$throttle$timer$${N}`,v=`$throttle$result$${N}`,k=`$throttle$lastRun$${N}`,o=`$throttle$pending$${N}`;return function(...s){if(this[v]||(this[v]=U?U():void 0),(this[k]===null||this[k]===void 0)&&(this[k]=-Number.MAX_VALUE),F&&(this[v]=F(this[v],...s)),this[o])return;const $=this[k]+Y;$<=Date.now()?(this[k]=Date.now(),P.apply(this,[this[v]]),this[v]=U?U():void 0):(this[o]=!0,this[_]=setTimeout(()=>{this[o]=!1,this[k]=Date.now(),P.apply(this,[this[v]]),this[v]=U?U():void 0},$-Date.now()))}})}}),define(_e[9],Ee([0,1]),function(ae,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fb=e.$eb=e.$db=e.$cb=e.$bb=e.$_=e.$8=e.$Z=e.$Y=void 0,e.setUnexpectedErrorHandler=t,e.$2=W,e.$3=M,e.$4=Y,e.$5=F,e.$6=U,e.$7=N,e.$9=v,e.$0=k,e.$$=o,e.$ab=$;class g{constructor(){this.b=[],this.a=function(i){setTimeout(()=>{throw i.stack?y.isErrorNoTelemetry(i)?new y(i.message+`

`+i.stack):new Error(i.message+`

`+i.stack):i},0)}}addListener(i){return this.b.push(i),()=>{this.d(i)}}c(i){this.b.forEach(l=>{l(i)})}d(i){this.b.splice(this.b.indexOf(i),1)}setUnexpectedErrorHandler(i){this.a=i}getUnexpectedErrorHandler(){return this.a}onUnexpectedError(i){this.a(i),this.c(i)}onUnexpectedExternalError(i){this.a(i)}}e.$Y=g,e.$Z=new g;function t(n){e.$Z.setUnexpectedErrorHandler(n)}function W(n){if(!n||typeof n!="object")return!1;const i=n;return i.code==="EPIPE"&&i.syscall?.toUpperCase()==="WRITE"}function M(n){N(n)||e.$Z.onUnexpectedError(n)}function Y(n){N(n)||e.$Z.onUnexpectedExternalError(n)}function F(n){if(n instanceof Error){const{name:i,message:l}=n,c=n.stacktrace||n.stack;return{$isError:!0,name:i,message:l,stack:c,noTelemetry:y.isErrorNoTelemetry(n)}}return n}function U(n){let i;return n.noTelemetry?i=new y:(i=new Error,i.name=n.name),i.message=n.message,i.stack=n.stack,i}const P="Canceled";function N(n){return n instanceof _?!0:n instanceof Error&&n.name===P&&n.message===P}class _ extends Error{constructor(){super(P),this.name=this.message}}e.$8=_;function v(){const n=new Error(P);return n.name=n.message,n}function k(n){return n?new Error(`Illegal argument: ${n}`):new Error("Illegal argument")}function o(n){return n?new Error(`Illegal state: ${n}`):new Error("Illegal state")}class s extends TypeError{constructor(i){super(i?`${i} is read-only and cannot be changed`:"Cannot change read-only property")}}e.$_=s;function $(n){return n?n.message?n.message:n.stack?n.stack.split(`
`)[0]:String(n):"Error"}class m extends Error{constructor(i){super("NotImplemented"),i&&(this.message=i)}}e.$bb=m;class f extends Error{constructor(i){super("NotSupported"),i&&(this.message=i)}}e.$cb=f;class w extends Error{constructor(){super(...arguments),this.isExpected=!0}}e.$db=w;class y extends Error{constructor(i){super(i),this.name="CodeExpectedError"}static fromError(i){if(i instanceof y)return i;const l=new y;return l.message=i.message,l.stack=i.stack,l}static isErrorNoTelemetry(i){return i.name==="CodeExpectedError"}}e.$eb=y;class r extends Error{constructor(i){super(i||"An unexpected bug occurred."),Object.setPrototypeOf(this,r.prototype)}}e.$fb=r}),define(_e[12],Ee([0,1,9,38]),function(ae,e,g,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dc=e.$cc=e.$bc=e.$_b=e.$$b=e.CompareResult=void 0,e.$vb=W,e.$wb=M,e.$xb=Y,e.$yb=F,e.$zb=U,e.$Ab=P,e.$Bb=N,e.$Cb=_,e.$Db=v,e.$Eb=k,e.$Fb=o,e.$Gb=s,e.$Hb=$,e.top=m,e.$Jb=f,e.$Kb=y,e.$Lb=r,e.$Mb=n,e.$Nb=i,e.$Ob=l,e.$Pb=c,e.$Qb=O,e.$Rb=h,e.$Sb=A,e.$Tb=u,e.$Ub=S,e.$Vb=R,e.$Wb=b,e.$Xb=d,e.$Yb=K,e.$Zb=ie,e.$1b=ee,e.$2b=V,e.$3b=re,e.$4b=X,e.$5b=te,e.$6b=oe,e.$7b=ce,e.$8b=L,e.$9b=B,e.$0b=Q,e.$ac=x;function W(p,q=0){return p[p.length-(1+q)]}function M(p){if(p.length===0)throw new Error("Invalid tail call");return[p.slice(0,p.length-1),p[p.length-1]]}function Y(p,q,G=(j,E)=>j===E){if(p===q)return!0;if(!p||!q||p.length!==q.length)return!1;for(let j=0,E=p.length;j<E;j++)if(!G(p[j],q[j]))return!1;return!0}function F(p,q){const G=p.length-1;q<G&&(p[q]=p[G]),p.pop()}function U(p,q,G){return P(p.length,j=>G(p[j],q))}function P(p,q){let G=0,j=p-1;for(;G<=j;){const E=(G+j)/2|0,H=q(E);if(H<0)G=E+1;else if(H>0)j=E-1;else return E}return-(G+1)}function N(p,q,G){if(p=p|0,p>=q.length)throw new TypeError("invalid index");const j=q[Math.floor(q.length*Math.random())],E=[],H=[],J=[];for(const ne of q){const $e=G(ne,j);$e<0?E.push(ne):$e>0?H.push(ne):J.push(ne)}return p<E.length?N(p,E,G):p<E.length+J.length?J[0]:N(p-(E.length+J.length),H,G)}function _(p,q){const G=[];let j;for(const E of p.slice(0).sort(q))!j||q(j[0],E)!==0?(j=[E],G.push(j)):j.push(E);return G}function*v(p,q){let G,j;for(const E of p)j!==void 0&&q(j,E)?G.push(E):(G&&(yield G),G=[E]),j=E;G&&(yield G)}function k(p,q){for(let G=0;G<=p.length;G++)q(G===0?void 0:p[G-1],G===p.length?void 0:p[G])}function o(p,q){for(let G=0;G<p.length;G++)q(G===0?void 0:p[G-1],p[G],G+1===p.length?void 0:p[G+1])}function s(p,q,G){const j=[];function E(ne,$e,De){if($e===0&&De.length===0)return;const he=j[j.length-1];he&&he.start+he.deleteCount===ne?(he.deleteCount+=$e,he.toInsert.push(...De)):j.push({start:ne,deleteCount:$e,toInsert:De})}let H=0,J=0;for(;;){if(H===p.length){E(H,0,q.slice(J));break}if(J===q.length){E(H,p.length-H,[]);break}const ne=p[H],$e=q[J],De=G(ne,$e);De===0?(H+=1,J+=1):De<0?(E(H,1,[]),H+=1):De>0&&(E(H,0,[$e]),J+=1)}return j}function $(p,q,G){const j=s(p,q,G),E=[],H=[];for(const J of j)E.push(...p.slice(J.start,J.start+J.deleteCount)),H.push(...J.toInsert);return{removed:E,added:H}}function m(p,q,G){if(G===0)return[];const j=p.slice(0,G).sort(q);return w(p,q,j,G,p.length),j}function f(p,q,G,j,E){return G===0?Promise.resolve([]):new Promise((H,J)=>{(async()=>{const ne=p.length,$e=p.slice(0,G).sort(q);for(let De=G,he=Math.min(G+j,ne);De<ne;De=he,he=Math.min(he+j,ne)){if(De>G&&await new Promise(fe=>setTimeout(fe)),E&&E.isCancellationRequested)throw new g.$8;w(p,q,$e,De,he)}return $e})().then(H,J)})}function w(p,q,G,j,E){for(const H=G.length;j<E;j++){const J=p[j];if(q(J,G[H-1])<0){G.pop();const ne=(0,t.$nb)(G,$e=>q(J,$e)<0);G.splice(ne,0,J)}}}function y(p){return p.filter(q=>!!q)}function r(p){let q=0;for(let G=0;G<p.length;G++)p[G]&&(p[q]=p[G],q+=1);p.length=q}function n(p,q,G){p.splice(G,0,p.splice(q,1)[0])}function i(p){return!Array.isArray(p)||p.length===0}function l(p){return Array.isArray(p)&&p.length>0}function c(p,q=G=>G){const G=new Set;return p.filter(j=>{const E=q(j);return G.has(E)?!1:(G.add(E),!0)})}function O(p){const q=new Set;return G=>{const j=p(G);return q.has(j)?!1:(q.add(j),!0)}}function h(p,q){return p.length>0?p[0]:q}function A(p,q){return p.length>0?p[p.length-1]:q}function u(p,q,G=(j,E)=>j===E){let j=0;for(let E=0,H=Math.min(p.length,q.length);E<H&&G(p[E],q[E]);E++)j++;return j}function S(p,q){let G=typeof q=="number"?p:0;typeof q=="number"?G=p:(G=0,q=p);const j=[];if(G<=q)for(let E=G;E<q;E++)j.push(E);else for(let E=G;E>q;E--)j.push(E);return j}function R(p,q,G){return p.reduce((j,E)=>(j[q(E)]=G?G(E):E,j),Object.create(null))}function b(p,q){return p.push(q),()=>d(p,q)}function d(p,q){const G=p.indexOf(q);if(G>-1)return p.splice(G,1),q}function K(p,q,G){const j=p.slice(0,q),E=p.slice(q);return j.concat(G,E)}function ie(p,q){let G;if(typeof q=="number"){let j=q;G=()=>{const E=Math.sin(j++)*179426549;return E-Math.floor(E)}}else G=Math.random;for(let j=p.length-1;j>0;j-=1){const E=Math.floor(G()*(j+1)),H=p[j];p[j]=p[E],p[E]=H}}function ee(p,q){const G=p.indexOf(q);G>-1&&(p.splice(G,1),p.unshift(q))}function V(p,q){const G=p.indexOf(q);G>-1&&(p.splice(G,1),p.push(q))}function re(p,q){for(const G of q)p.push(G)}function X(p,q){return Array.isArray(p)?p.map(q):q(p)}function te(p){return Array.isArray(p)?p:[p]}function oe(p){return p[Math.floor(Math.random()*p.length)]}function ce(p,q,G){const j=a(p,q),E=p.length,H=G.length;p.length=E+H;for(let J=E-1;J>=j;J--)p[J+H]=p[J];for(let J=0;J<H;J++)p[J+j]=G[J]}function L(p,q,G,j){const E=a(p,q);let H=p.splice(E,G);return H===void 0&&(H=[]),ce(p,E,j),H}function a(p,q){return q<0?Math.max(q+p.length,0):Math.min(q,p.length)}var T;(function(p){function q(H){return H<0}p.isLessThan=q;function G(H){return H<=0}p.isLessThanOrEqual=G;function j(H){return H>0}p.isGreaterThan=j;function E(H){return H===0}p.isNeitherLessOrGreaterThan=E,p.greaterThan=1,p.lessThan=-1,p.neitherLessOrGreaterThan=0})(T||(e.CompareResult=T={}));function B(p,q){return(G,j)=>q(p(G),p(j))}function Q(...p){return(q,G)=>{for(const j of p){const E=j(q,G);if(!T.isNeitherLessOrGreaterThan(E))return E}return T.neitherLessOrGreaterThan}}const D=(p,q)=>p-q;e.$$b=D;const Z=(p,q)=>(0,e.$$b)(p?1:0,q?1:0);e.$_b=Z;function x(p){return(q,G)=>-p(q,G)}class se{constructor(q){this.g=q,this.c=0,this.d=this.g.length-1}get length(){return this.d-this.c+1}takeWhile(q){let G=this.c;for(;G<this.g.length&&q(this.g[G]);)G++;const j=G===this.c?null:this.g.slice(this.c,G);return this.c=G,j}takeFromEndWhile(q){let G=this.d;for(;G>=0&&q(this.g[G]);)G--;const j=G===this.d?null:this.g.slice(G+1,this.d+1);return this.d=G,j}peek(){if(this.length!==0)return this.g[this.c]}peekLast(){if(this.length!==0)return this.g[this.d]}dequeue(){const q=this.g[this.c];return this.c++,q}removeLast(){const q=this.g[this.d];return this.d--,q}takeCount(q){const G=this.g.slice(this.c,this.c+q);return this.c+=q,G}}e.$bc=se;class le{static{this.empty=new le(q=>{})}constructor(q){this.iterate=q}forEach(q){this.iterate(G=>(q(G),!0))}toArray(){const q=[];return this.iterate(G=>(q.push(G),!0)),q}filter(q){return new le(G=>this.iterate(j=>q(j)?G(j):!0))}map(q){return new le(G=>this.iterate(j=>G(q(j))))}some(q){let G=!1;return this.iterate(j=>(G=q(j),!G)),G}findFirst(q){let G;return this.iterate(j=>q(j)?(G=j,!1):!0),G}findLast(q){let G;return this.iterate(j=>(q(j)&&(G=j),!0)),G}findLastMaxBy(q){let G,j=!0;return this.iterate(E=>((j||T.isGreaterThan(q(E,G)))&&(j=!1,G=E),!0)),G}}e.$cc=le;class de{constructor(q){this.c=q}static createSortPermutation(q,G){const j=Array.from(q.keys()).sort((E,H)=>G(q[E],q[H]));return new de(j)}apply(q){return q.map((G,j)=>q[this.c[j]])}inverse(){const q=this.c.slice();for(let G=0;G<this.c.length;G++)q[this.c[G]]=G;return new de(q)}}e.$dc=de}),define(_e[26],Ee([0,1]),function(ae,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gb=g;function g(t,W){const M=this;let Y=!1,F;return function(){if(Y)return F;if(Y=!0,W)try{F=t.apply(M,arguments)}finally{W()}else F=t.apply(M,arguments);return F}}}),define(_e[41],Ee([0,1]),function(ae,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var g;(function(t){function W(i){return i&&typeof i=="object"&&typeof i[Symbol.iterator]=="function"}t.is=W;const M=Object.freeze([]);function Y(){return M}t.empty=Y;function*F(i){yield i}t.single=F;function U(i){return W(i)?i:F(i)}t.wrap=U;function P(i){return i||M}t.from=P;function*N(i){for(let l=i.length-1;l>=0;l--)yield i[l]}t.reverse=N;function _(i){return!i||i[Symbol.iterator]().next().done===!0}t.isEmpty=_;function v(i){return i[Symbol.iterator]().next().value}t.first=v;function k(i,l){let c=0;for(const O of i)if(l(O,c++))return!0;return!1}t.some=k;function o(i,l){for(const c of i)if(l(c))return c}t.find=o;function*s(i,l){for(const c of i)l(c)&&(yield c)}t.filter=s;function*$(i,l){let c=0;for(const O of i)yield l(O,c++)}t.map=$;function*m(i,l){let c=0;for(const O of i)yield*l(O,c++)}t.flatMap=m;function*f(...i){for(const l of i)yield*l}t.concat=f;function w(i,l,c){let O=c;for(const h of i)O=l(O,h);return O}t.reduce=w;function*y(i,l,c=i.length){for(l<0&&(l+=i.length),c<0?c+=i.length:c>i.length&&(c=i.length);l<c;l++)yield i[l]}t.slice=y;function r(i,l=Number.POSITIVE_INFINITY){const c=[];if(l===0)return[c,i];const O=i[Symbol.iterator]();for(let h=0;h<l;h++){const A=O.next();if(A.done)return[c,t.empty()];c.push(A.value)}return[c,{[Symbol.iterator](){return O}}]}t.consume=r;async function n(i){const l=[];for await(const c of i)l.push(c);return Promise.resolve(l)}t.asyncToArray=n})(g||(e.Iterable=g={}))}),define(_e[15],Ee([0,1]),function(ae,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$X=void 0;class g{constructor(W){this.d=W,this.a=!1}get hasValue(){return this.a}get value(){if(!this.a)try{this.b=this.d()}catch(W){this.c=W}finally{this.a=!0}if(this.c)throw this.c;return this.b}get rawValue(){return this.b}}e.$X=g}),define(_e[42],Ee([0,1]),function(ae,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8c=void 0;class g{static{this.Undefined=new g(void 0)}constructor(M){this.element=M,this.next=g.Undefined,this.prev=g.Undefined}}class t{constructor(){this.a=g.Undefined,this.b=g.Undefined,this.c=0}get size(){return this.c}isEmpty(){return this.a===g.Undefined}clear(){let M=this.a;for(;M!==g.Undefined;){const Y=M.next;M.prev=g.Undefined,M.next=g.Undefined,M=Y}this.a=g.Undefined,this.b=g.Undefined,this.c=0}unshift(M){return this.d(M,!1)}push(M){return this.d(M,!0)}d(M,Y){const F=new g(M);if(this.a===g.Undefined)this.a=F,this.b=F;else if(Y){const P=this.b;this.b=F,F.prev=P,P.next=F}else{const P=this.a;this.a=F,F.next=P,P.prev=F}this.c+=1;let U=!1;return()=>{U||(U=!0,this.e(F))}}shift(){if(this.a!==g.Undefined){const M=this.a.element;return this.e(this.a),M}}pop(){if(this.b!==g.Undefined){const M=this.b.element;return this.e(this.b),M}}e(M){if(M.prev!==g.Undefined&&M.next!==g.Undefined){const Y=M.prev;Y.next=M.next,M.next.prev=Y}else M.prev===g.Undefined&&M.next===g.Undefined?(this.a=g.Undefined,this.b=g.Undefined):M.next===g.Undefined?(this.b=this.b.prev,this.b.next=g.Undefined):M.prev===g.Undefined&&(this.a=this.a.next,this.a.prev=g.Undefined);this.c-=1}*[Symbol.iterator](){let M=this.a;for(;M!==g.Undefined;)yield M.element,M=M.next}}e.$8c=t}),define(_e[20],Ee([0,1]),function(ae,e){"use strict";var g,t,W;Object.defineProperty(e,"__esModule",{value:!0}),e.$Kc=e.$Jc=e.$Ic=e.$Hc=e.$Gc=e.$Fc=e.Touch=e.$Ec=e.$Dc=void 0,e.$Ac=M,e.$Bc=Y,e.$Cc=F,e.$Lc=y;function M(r,n,i){let l=r.get(n);return l===void 0&&(l=i,r.set(n,l)),l}function Y(r){const n=[];return r.forEach((i,l)=>{n.push(`${l} => ${i}`)}),`Map(${r.size}) {${n.join(", ")}}`}function F(r){const n=[];return r.forEach(i=>{n.push(i)}),`Set(${r.size}) {${n.join(", ")}}`}class U{constructor(n,i){this.uri=n,this.value=i}}function P(r){return Array.isArray(r)}class N{static{this.c=n=>n.toString()}constructor(n,i){if(this[g]="ResourceMap",n instanceof N)this.d=new Map(n.d),this.e=i??N.c;else if(P(n)){this.d=new Map,this.e=i??N.c;for(const[l,c]of n)this.set(l,c)}else this.d=new Map,this.e=n??N.c}set(n,i){return this.d.set(this.e(n),new U(n,i)),this}get(n){return this.d.get(this.e(n))?.value}has(n){return this.d.has(this.e(n))}get size(){return this.d.size}clear(){this.d.clear()}delete(n){return this.d.delete(this.e(n))}forEach(n,i){typeof i<"u"&&(n=n.bind(i));for(const[l,c]of this.d)n(c.value,c.uri,this)}*values(){for(const n of this.d.values())yield n.value}*keys(){for(const n of this.d.values())yield n.uri}*entries(){for(const n of this.d.values())yield[n.uri,n.value]}*[(g=Symbol.toStringTag,Symbol.iterator)](){for(const[,n]of this.d)yield[n.uri,n.value]}}e.$Dc=N;class _{constructor(n,i){this[t]="ResourceSet",!n||typeof n=="function"?this.c=new N(n):(this.c=new N(i),n.forEach(this.add,this))}get size(){return this.c.size}add(n){return this.c.set(n,n),this}clear(){this.c.clear()}delete(n){return this.c.delete(n)}forEach(n,i){this.c.forEach((l,c)=>n.call(i,c,c,this))}has(n){return this.c.has(n)}entries(){return this.c.entries()}keys(){return this.c.keys()}values(){return this.c.keys()}[(t=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}e.$Ec=_;var v;(function(r){r[r.None=0]="None",r[r.AsOld=1]="AsOld",r[r.AsNew=2]="AsNew"})(v||(e.Touch=v={}));class k{constructor(){this[W]="LinkedMap",this.c=new Map,this.d=void 0,this.e=void 0,this.f=0,this.g=0}clear(){this.c.clear(),this.d=void 0,this.e=void 0,this.f=0,this.g++}isEmpty(){return!this.d&&!this.e}get size(){return this.f}get first(){return this.d?.value}get last(){return this.e?.value}has(n){return this.c.has(n)}get(n,i=v.None){const l=this.c.get(n);if(l)return i!==v.None&&this.m(l,i),l.value}set(n,i,l=v.None){let c=this.c.get(n);if(c)c.value=i,l!==v.None&&this.m(c,l);else{switch(c={key:n,value:i,next:void 0,previous:void 0},l){case v.None:this.k(c);break;case v.AsOld:this.j(c);break;case v.AsNew:this.k(c);break;default:this.k(c);break}this.c.set(n,c),this.f++}return this}delete(n){return!!this.remove(n)}remove(n){const i=this.c.get(n);if(i)return this.c.delete(n),this.l(i),this.f--,i.value}shift(){if(!this.d&&!this.e)return;if(!this.d||!this.e)throw new Error("Invalid list");const n=this.d;return this.c.delete(n.key),this.l(n),this.f--,n.value}forEach(n,i){const l=this.g;let c=this.d;for(;c;){if(i?n.bind(i)(c.value,c.key,this):n(c.value,c.key,this),this.g!==l)throw new Error("LinkedMap got modified during iteration.");c=c.next}}keys(){const n=this,i=this.g;let l=this.d;const c={[Symbol.iterator](){return c},next(){if(n.g!==i)throw new Error("LinkedMap got modified during iteration.");if(l){const O={value:l.key,done:!1};return l=l.next,O}else return{value:void 0,done:!0}}};return c}values(){const n=this,i=this.g;let l=this.d;const c={[Symbol.iterator](){return c},next(){if(n.g!==i)throw new Error("LinkedMap got modified during iteration.");if(l){const O={value:l.value,done:!1};return l=l.next,O}else return{value:void 0,done:!0}}};return c}entries(){const n=this,i=this.g;let l=this.d;const c={[Symbol.iterator](){return c},next(){if(n.g!==i)throw new Error("LinkedMap got modified during iteration.");if(l){const O={value:[l.key,l.value],done:!1};return l=l.next,O}else return{value:void 0,done:!0}}};return c}[(W=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}h(n){if(n>=this.size)return;if(n===0){this.clear();return}let i=this.d,l=this.size;for(;i&&l>n;)this.c.delete(i.key),i=i.next,l--;this.d=i,this.f=l,i&&(i.previous=void 0),this.g++}i(n){if(n>=this.size)return;if(n===0){this.clear();return}let i=this.e,l=this.size;for(;i&&l>n;)this.c.delete(i.key),i=i.previous,l--;this.e=i,this.f=l,i&&(i.next=void 0),this.g++}j(n){if(!this.d&&!this.e)this.e=n;else if(this.d)n.next=this.d,this.d.previous=n;else throw new Error("Invalid list");this.d=n,this.g++}k(n){if(!this.d&&!this.e)this.d=n;else if(this.e)n.previous=this.e,this.e.next=n;else throw new Error("Invalid list");this.e=n,this.g++}l(n){if(n===this.d&&n===this.e)this.d=void 0,this.e=void 0;else if(n===this.d){if(!n.next)throw new Error("Invalid list");n.next.previous=void 0,this.d=n.next}else if(n===this.e){if(!n.previous)throw new Error("Invalid list");n.previous.next=void 0,this.e=n.previous}else{const i=n.next,l=n.previous;if(!i||!l)throw new Error("Invalid list");i.previous=l,l.next=i}n.next=void 0,n.previous=void 0,this.g++}m(n,i){if(!this.d||!this.e)throw new Error("Invalid list");if(!(i!==v.AsOld&&i!==v.AsNew)){if(i===v.AsOld){if(n===this.d)return;const l=n.next,c=n.previous;n===this.e?(c.next=void 0,this.e=c):(l.previous=c,c.next=l),n.previous=void 0,n.next=this.d,this.d.previous=n,this.d=n,this.g++}else if(i===v.AsNew){if(n===this.e)return;const l=n.next,c=n.previous;n===this.d?(l.previous=void 0,this.d=l):(l.previous=c,c.next=l),n.next=void 0,n.previous=this.e,this.e.next=n,this.e=n,this.g++}}}toJSON(){const n=[];return this.forEach((i,l)=>{n.push([l,i])}),n}fromJSON(n){this.clear();for(const[i,l]of n)this.set(i,l)}}e.$Fc=k;class o extends k{constructor(n,i=1){super(),this.n=n,this.o=Math.min(Math.max(0,i),1)}get limit(){return this.n}set limit(n){this.n=n,this.p()}get ratio(){return this.o}set ratio(n){this.o=Math.min(Math.max(0,n),1),this.p()}get(n,i=v.AsNew){return super.get(n,i)}peek(n){return super.get(n,v.None)}set(n,i){return super.set(n,i,v.AsNew),this}p(){this.size>this.n&&this.q(Math.round(this.n*this.o))}}class s extends o{constructor(n,i=1){super(n,i)}q(n){this.h(n)}set(n,i){return super.set(n,i),this.p(),this}}e.$Gc=s;class $ extends o{constructor(n,i=1){super(n,i)}q(n){this.i(n)}set(n,i){return this.n<=this.size&&!this.has(n)&&this.q(Math.round(this.n*this.o)-1),super.set(n,i),this}}e.$Hc=$;class m{constructor(){this.c=new Map}add(n){return this.c.set(n,(this.c.get(n)||0)+1),this}delete(n){let i=this.c.get(n)||0;return i===0?!1:(i--,i===0?this.c.delete(n):this.c.set(n,i),!0)}has(n){return this.c.has(n)}}e.$Ic=m;class f{constructor(n){if(this.c=new Map,this.d=new Map,n)for(const[i,l]of n)this.set(i,l)}clear(){this.c.clear(),this.d.clear()}set(n,i){this.c.set(n,i),this.d.set(i,n)}get(n){return this.c.get(n)}getKey(n){return this.d.get(n)}delete(n){const i=this.c.get(n);return i===void 0?!1:(this.c.delete(n),this.d.delete(i),!0)}forEach(n,i){this.c.forEach((l,c)=>{n.call(i,l,c,this)})}keys(){return this.c.keys()}values(){return this.c.values()}}e.$Jc=f;class w{constructor(){this.c=new Map}add(n,i){let l=this.c.get(n);l||(l=new Set,this.c.set(n,l)),l.add(i)}delete(n,i){const l=this.c.get(n);l&&(l.delete(i),l.size===0&&this.c.delete(n))}forEach(n,i){const l=this.c.get(n);l&&l.forEach(i)}get(n){const i=this.c.get(n);return i||new Set}}e.$Kc=w;function y(r,n){if(r===n)return!0;if(r.size!==n.size)return!1;for(const[i,l]of r)if(!n.has(i)||n.get(i)!==l)return!1;for(const[i]of n)if(!r.has(i))return!1;return!0}}),define(_e[4],Ee([0,1,12,39,20,26,41]),function(ae,e,g,t,W,M,Y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7c=e.$5c=e.$4c=e.$3c=e.$2c=e.$1c=e.$Zc=e.$Yc=e.$Xc=e.$Wc=e.$Mc=void 0,e.$Nc=N,e.$Oc=_,e.$Pc=v,e.$Qc=s,e.$Rc=$,e.$Sc=m,e.$Tc=f,e.$Uc=w,e.$Vc=y,e.$6c=S;const F=!1;let U=null;class P{constructor(){this.b=new Map}static{this.a=0}c(d){let K=this.b.get(d);return K||(K={parent:null,source:null,isSingleton:!1,value:d,idx:P.a++},this.b.set(d,K)),K}trackDisposable(d){const K=this.c(d);K.source||(K.source=new Error().stack)}setParent(d,K){const ie=this.c(d);ie.parent=K}markAsDisposed(d){this.b.delete(d)}markAsSingleton(d){this.c(d).isSingleton=!0}f(d,K){const ie=K.get(d);if(ie)return ie;const ee=d.parent?this.f(this.c(d.parent),K):d;return K.set(d,ee),ee}getTrackedDisposables(){const d=new Map;return[...this.b.entries()].filter(([,ie])=>ie.source!==null&&!this.f(ie,d).isSingleton).flatMap(([ie])=>ie)}computeLeakingDisposables(d=10,K){let ie;if(K)ie=K;else{const te=new Map,oe=[...this.b.values()].filter(L=>L.source!==null&&!this.f(L,te).isSingleton);if(oe.length===0)return;const ce=new Set(oe.map(L=>L.value));if(ie=oe.filter(L=>!(L.parent&&ce.has(L.parent))),ie.length===0)throw new Error("There are cyclic diposable chains!")}if(!ie)return;function ee(te){function oe(L,a){for(;L.length>0&&a.some(T=>typeof T=="string"?T===L[0]:L[0].match(T));)L.shift()}const ce=te.source.split(`
`).map(L=>L.trim().replace("at ","")).filter(L=>L!=="");return oe(ce,["Error",/^trackDisposable \(.*\)$/,/^DisposableTracker.trackDisposable \(.*\)$/]),ce.reverse()}const V=new W.$Kc;for(const te of ie){const oe=ee(te);for(let ce=0;ce<=oe.length;ce++)V.add(oe.slice(0,ce).join(`
`),te)}ie.sort((0,g.$9b)(te=>te.idx,g.$$b));let re="",X=0;for(const te of ie.slice(0,d)){X++;const oe=ee(te),ce=[];for(let L=0;L<oe.length;L++){let a=oe[L];a=`(shared with ${V.get(oe.slice(0,L+1).join(`
`)).size}/${ie.length} leaks) at ${a}`;const B=V.get(oe.slice(0,L).join(`
`)),Q=(0,t.$K)([...B].map(D=>ee(D)[L]),D=>D);delete Q[oe[L]];for(const[D,Z]of Object.entries(Q))ce.unshift(`    - stacktraces of ${Z.length} other leaks continue with ${D}`);ce.unshift(a)}re+=`


==================== Leaking disposable ${X}/${ie.length}: ${te.value.constructor.name} ====================
${ce.join(`
`)}
============================================================

`}return ie.length>d&&(re+=`


... and ${ie.length-d} more leaking disposables

`),{leaks:ie,details:re}}}e.$Mc=P;function N(b){U=b}if(F){const b="__is_disposable_tracked__";N(new class{trackDisposable(d){const K=new Error("Potentially leaked disposable").stack;setTimeout(()=>{d[b]||console.log(K)},3e3)}setParent(d,K){if(d&&d!==n.None)try{d[b]=!0}catch{}}markAsDisposed(d){if(d&&d!==n.None)try{d[b]=!0}catch{}}markAsSingleton(d){}})}function _(b){return U?.trackDisposable(b),b}function v(b){U?.markAsDisposed(b)}function k(b,d){U?.setParent(b,d)}function o(b,d){if(U)for(const K of b)U.setParent(K,d)}function s(b){return U?.markAsSingleton(b),b}function $(b){return typeof b=="object"&&b!==null&&typeof b.dispose=="function"&&b.dispose.length===0}function m(b){if(Y.Iterable.is(b)){const d=[];for(const K of b)if(K)try{K.dispose()}catch(ie){d.push(ie)}if(d.length===1)throw d[0];if(d.length>1)throw new AggregateError(d,"Encountered errors while disposing of store");return Array.isArray(b)?[]:b}else if(b)return b.dispose(),b}function f(b){for(const d of b)$(d)&&d.dispose();return[]}function w(...b){const d=y(()=>m(b));return o(b,d),d}function y(b){const d=_({dispose:(0,M.$gb)(()=>{v(d),b()})});return d}class r{static{this.DISABLE_DISPOSED_WARNING=!1}constructor(){this.f=new Set,this.g=!1,_(this)}dispose(){this.g||(v(this),this.g=!0,this.clear())}get isDisposed(){return this.g}clear(){if(this.f.size!==0)try{m(this.f)}finally{this.f.clear()}}add(d){if(!d)return d;if(d===this)throw new Error("Cannot register a disposable on itself!");return k(d,this),this.g?r.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this.f.add(d),d}delete(d){if(d){if(d===this)throw new Error("Cannot dispose a disposable on itself!");this.f.delete(d),d.dispose()}}deleteAndLeak(d){d&&this.f.has(d)&&(this.f.delete(d),k(d,null))}}e.$Wc=r;class n{static{this.None=Object.freeze({dispose(){}})}constructor(){this.q=new r,_(this),k(this.q,this)}dispose(){v(this),this.q.dispose()}B(d){if(d===this)throw new Error("Cannot register a disposable on itself!");return this.q.add(d)}}e.$Xc=n;class i{constructor(){this.b=!1,_(this)}get value(){return this.b?void 0:this.a}set value(d){this.b||d===this.a||(this.a?.dispose(),d&&k(d,this),this.a=d)}clear(){this.value=void 0}dispose(){this.b=!0,v(this),this.a?.dispose(),this.a=void 0}clearAndLeak(){const d=this.a;return this.a=void 0,d&&k(d,null),d}}e.$Yc=i;class l{constructor(d){this.a=new i,this.b=!1,this.a.value=d}get value(){return this.a.value}set value(d){this.b||d===this.a.value||(this.a.value=d)}dispose(){this.b=!0,this.a.dispose()}}e.$Zc=l;class c{constructor(d){this.b=d,this.a=1}acquire(){return this.a++,this}release(){return--this.a===0&&this.b.dispose(),this}}e.$1c=c;class O{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,_(this)}set(d){let K=d;return this.unset=()=>K=void 0,this.isset=()=>K!==void 0,this.dispose=()=>{K&&(K(),K=void 0,v(this))},this}}e.$2c=O;class h{constructor(){this.a=new Map}acquire(d,...K){let ie=this.a.get(d);ie||(ie={counter:0,object:this.b(d,...K)},this.a.set(d,ie));const{object:ee}=ie,V=(0,M.$gb)(()=>{--ie.counter===0&&(this.c(d,ie.object),this.a.delete(d))});return ie.counter++,{object:ee,dispose:V}}}e.$3c=h;class A{constructor(d){this.a=d}async acquire(d,...K){const ie=this.a.acquire(d,...K);try{return{object:await ie.object,dispose:()=>ie.dispose()}}catch(ee){throw ie.dispose(),ee}}}e.$4c=A;class u{constructor(d){this.object=d}dispose(){}}e.$5c=u;function S(b){const d=new r;try{b(d)}finally{d.dispose()}}class R{constructor(){this.a=new Map,this.b=!1,_(this)}dispose(){v(this),this.b=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(this.a.size)try{m(this.a.values())}finally{this.a.clear()}}has(d){return this.a.has(d)}get size(){return this.a.size}get(d){return this.a.get(d)}set(d,K,ie=!1){this.b&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),ie||this.a.get(d)?.dispose(),this.a.set(d,K)}deleteAndDispose(d){this.a.get(d)?.dispose(),this.a.delete(d)}deleteAndLeak(d){const K=this.a.get(d);return this.a.delete(d),K}keys(){return this.a.keys()}values(){return this.a.values()}[Symbol.iterator](){return this.a[Symbol.iterator]()}}e.$7c=R}),define(_e[27],Ee([0,1]),function(ae,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MarshalledId=void 0;var g;(function(t){t[t.Uri=1]="Uri",t[t.Regexp=2]="Regexp",t[t.ScmResource=3]="ScmResource",t[t.ScmResourceGroup=4]="ScmResourceGroup",t[t.ScmProvider=5]="ScmProvider",t[t.CommentController=6]="CommentController",t[t.CommentThread=7]="CommentThread",t[t.CommentThreadInstance=8]="CommentThreadInstance",t[t.CommentThreadReply=9]="CommentThreadReply",t[t.CommentNode=10]="CommentNode",t[t.CommentThreadNode=11]="CommentThreadNode",t[t.TimelineActionContext=12]="TimelineActionContext",t[t.NotebookCellActionContext=13]="NotebookCellActionContext",t[t.NotebookActionContext=14]="NotebookActionContext",t[t.TerminalContext=15]="TerminalContext",t[t.TestItemContext=16]="TestItemContext",t[t.Date=17]="Date",t[t.TestMessageMenuArgs=18]="TestMessageMenuArgs"})(g||(e.MarshalledId=g={}))}),define(_e[21],Ee([0,1,20]),function(ae,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pm=void 0,e.$nm=W,e.$om=Y;const t=new g.$Gc(1e4);function W(P){return U(P,"NFC",t)}const M=new g.$Gc(1e4);function Y(P){return U(P,"NFD",M)}const F=/[^\u0000-\u0080]/;function U(P,N,_){if(!P)return P;const v=_.get(P);if(v)return v;let k;return F.test(P)?k=P.normalize(N):k=P,_.set(P,k),k}e.$pm=function(){const P=/[\u0300-\u036f]/g;return function(N){return Y(N).replace(P,"")}}()}),define(_e[43],Ee([0,1]),function(ae,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$he=void 0;const g=globalThis.performance&&typeof globalThis.performance.now=="function";class t{static create(M){return new t(M)}constructor(M){this.c=g&&M===!1?Date.now:globalThis.performance.now.bind(globalThis.performance),this.a=this.c(),this.b=-1}stop(){this.b=this.c()}reset(){this.a=this.c(),this.b=-1}elapsed(){return this.b!==-1?this.b-this.a:this.c()-this.a}}e.$he=t}),define(_e[6],Ee([0,1,9,26,4,42,43]),function(ae,e,g,t,W,M,Y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xe=e.$we=e.$ve=e.$ue=e.$te=e.$se=e.$re=e.$qe=e.$pe=e.$oe=e.$ne=e.$me=e.$le=e.$je=e.Event=void 0,e.$ke=k;const F=!1,U=!1,P=!1;var N;(function(ee){ee.None=()=>W.$Xc.None;function V(he){if(P){const{onDidAddListener:fe}=he,be=s.create();let ge=0;he.onDidAddListener=()=>{++ge===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),be.print()),fe?.()}}}function re(he,fe){return D(he,()=>{},0,void 0,!0,void 0,fe)}ee.defer=re;function X(he){return(fe,be=null,ge)=>{let we=!1,ye;return ye=he(Re=>{if(!we)return ye?ye.dispose():we=!0,fe.call(be,Re)},null,ge),we&&ye.dispose(),ye}}ee.once=X;function te(he,fe,be){return B((ge,we=null,ye)=>he(Re=>ge.call(we,fe(Re)),null,ye),be)}ee.map=te;function oe(he,fe,be){return B((ge,we=null,ye)=>he(Re=>{fe(Re),ge.call(we,Re)},null,ye),be)}ee.forEach=oe;function ce(he,fe,be){return B((ge,we=null,ye)=>he(Re=>fe(Re)&&ge.call(we,Re),null,ye),be)}ee.filter=ce;function L(he){return he}ee.signal=L;function a(...he){return(fe,be=null,ge)=>{const we=(0,W.$Uc)(...he.map(ye=>ye(Re=>fe.call(be,Re))));return Q(we,ge)}}ee.any=a;function T(he,fe,be,ge){let we=be;return te(he,ye=>(we=fe(we,ye),we),ge)}ee.reduce=T;function B(he,fe){let be;const ge={onWillAddFirstListener(){be=he(we.fire,we)},onDidRemoveLastListener(){be?.dispose()}};fe||V(ge);const we=new i(ge);return fe?.add(we),we.event}function Q(he,fe){return fe instanceof Array?fe.push(he):fe&&fe.add(he),he}function D(he,fe,be=100,ge=!1,we=!1,ye,Re){let Ie,Ue,pe,je=0,Ae;const Pe={leakWarningThreshold:ye,onWillAddFirstListener(){Ie=he(ze=>{je++,Ue=fe(Ue,ze),ge&&!pe&&(Be.fire(Ue),Ue=void 0),Ae=()=>{const Ke=Ue;Ue=void 0,pe=void 0,(!ge||je>1)&&Be.fire(Ke),je=0},typeof be=="number"?(clearTimeout(pe),pe=setTimeout(Ae,be)):pe===void 0&&(pe=0,queueMicrotask(Ae))})},onWillRemoveListener(){we&&je>0&&Ae?.()},onDidRemoveLastListener(){Ae=void 0,Ie.dispose()}};Re||V(Pe);const Be=new i(Pe);return Re?.add(Be),Be.event}ee.debounce=D;function Z(he,fe=0,be){return ee.debounce(he,(ge,we)=>ge?(ge.push(we),ge):[we],fe,void 0,!0,void 0,be)}ee.accumulate=Z;function x(he,fe=(ge,we)=>ge===we,be){let ge=!0,we;return ce(he,ye=>{const Re=ge||!fe(ye,we);return ge=!1,we=ye,Re},be)}ee.latch=x;function se(he,fe,be){return[ee.filter(he,fe,be),ee.filter(he,ge=>!fe(ge),be)]}ee.split=se;function le(he,fe=!1,be=[],ge){let we=be.slice(),ye=he(Ue=>{we?we.push(Ue):Ie.fire(Ue)});ge&&ge.add(ye);const Re=()=>{we?.forEach(Ue=>Ie.fire(Ue)),we=null},Ie=new i({onWillAddFirstListener(){ye||(ye=he(Ue=>Ie.fire(Ue)),ge&&ge.add(ye))},onDidAddFirstListener(){we&&(fe?setTimeout(Re):Re())},onDidRemoveLastListener(){ye&&ye.dispose(),ye=null}});return ge&&ge.add(Ie),Ie.event}ee.buffer=le;function de(he,fe){return(ge,we,ye)=>{const Re=fe(new q);return he(function(Ie){const Ue=Re.evaluate(Ie);Ue!==p&&ge.call(we,Ue)},void 0,ye)}}ee.chain=de;const p=Symbol("HaltChainable");class q{constructor(){this.f=[]}map(fe){return this.f.push(fe),this}forEach(fe){return this.f.push(be=>(fe(be),be)),this}filter(fe){return this.f.push(be=>fe(be)?be:p),this}reduce(fe,be){let ge=be;return this.f.push(we=>(ge=fe(ge,we),ge)),this}latch(fe=(be,ge)=>be===ge){let be=!0,ge;return this.f.push(we=>{const ye=be||!fe(we,ge);return be=!1,ge=we,ye?we:p}),this}evaluate(fe){for(const be of this.f)if(fe=be(fe),fe===p)break;return fe}}function G(he,fe,be=ge=>ge){const ge=(...Ie)=>Re.fire(be(...Ie)),we=()=>he.on(fe,ge),ye=()=>he.removeListener(fe,ge),Re=new i({onWillAddFirstListener:we,onDidRemoveLastListener:ye});return Re.event}ee.fromNodeEventEmitter=G;function j(he,fe,be=ge=>ge){const ge=(...Ie)=>Re.fire(be(...Ie)),we=()=>he.addEventListener(fe,ge),ye=()=>he.removeEventListener(fe,ge),Re=new i({onWillAddFirstListener:we,onDidRemoveLastListener:ye});return Re.event}ee.fromDOMEventEmitter=j;function E(he){return new Promise(fe=>X(he)(fe))}ee.toPromise=E;function H(he){const fe=new i;return he.then(be=>{fe.fire(be)},()=>{fe.fire(void 0)}).finally(()=>{fe.dispose()}),fe.event}ee.fromPromise=H;function J(he,fe,be){return fe(be),he(ge=>fe(ge))}ee.runAndSubscribe=J;class ne{constructor(fe,be){this._observable=fe,this.f=0,this.g=!1;const ge={onWillAddFirstListener:()=>{fe.addObserver(this)},onDidRemoveLastListener:()=>{fe.removeObserver(this)}};be||V(ge),this.emitter=new i(ge),be&&be.add(this.emitter)}beginUpdate(fe){this.f++}handlePossibleChange(fe){}handleChange(fe,be){this.g=!0}endUpdate(fe){this.f--,this.f===0&&(this._observable.reportChanges(),this.g&&(this.g=!1,this.emitter.fire(this._observable.get())))}}function $e(he,fe){return new ne(he,fe).emitter.event}ee.fromObservable=$e;function De(he){return(fe,be,ge)=>{let we=0,ye=!1;const Re={beginUpdate(){we++},endUpdate(){we--,we===0&&(he.reportChanges(),ye&&(ye=!1,fe.call(be)))},handlePossibleChange(){},handleChange(){ye=!0}};he.addObserver(Re),he.reportChanges();const Ie={dispose(){he.removeObserver(Re)}};return ge instanceof W.$Wc?ge.add(Ie):Array.isArray(ge)&&ge.push(Ie),Ie}}ee.fromObservableLight=De})(N||(e.Event=N={}));class _{static{this.all=new Set}static{this.f=0}constructor(V){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${V}_${_.f++}`,_.all.add(this)}start(V){this.g=new Y.$he,this.listenerCount=V}stop(){if(this.g){const V=this.g.elapsed();this.durations.push(V),this.elapsedOverall+=V,this.invocationCount+=1,this.g=void 0}}}e.$je=_;let v=-1;function k(ee){const V=v;return v=ee,{dispose(){v=V}}}class o{static{this.f=1}constructor(V,re,X=(o.f++).toString(16).padStart(3,"0")){this.j=V,this.threshold=re,this.name=X,this.h=0}dispose(){this.g?.clear()}check(V,re){const X=this.threshold;if(X<=0||re<X)return;this.g||(this.g=new Map);const te=this.g.get(V.value)||0;if(this.g.set(V.value,te+1),this.h-=1,this.h<=0){this.h=X*.5;const[oe,ce]=this.getMostFrequentStack(),L=`[${this.name}] potential listener LEAK detected, having ${re} listeners already. MOST frequent listener (${ce}):`;console.warn(L),console.warn(oe);const a=new $(L,oe);this.j(a)}return()=>{const oe=this.g.get(V.value)||0;this.g.set(V.value,oe-1)}}getMostFrequentStack(){if(!this.g)return;let V,re=0;for(const[X,te]of this.g)(!V||re<te)&&(V=[X,te],re=te);return V}}class s{static create(){const V=new Error;return new s(V.stack??"")}constructor(V){this.value=V}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}class $ extends Error{constructor(V,re){super(V),this.name="ListenerLeakError",this.stack=re}}e.$le=$;class m extends Error{constructor(V,re){super(V),this.name="ListenerRefusalError",this.stack=re}}e.$me=m;let f=0;class w{constructor(V){this.value=V,this.id=f++}}const y=2,r=(ee,V)=>{if(ee instanceof w)V(ee);else for(let re=0;re<ee.length;re++){const X=ee[re];X&&V(X)}};let n;if(F){const ee=[];setInterval(()=>{ee.length!==0&&(console.warn("[LEAKING LISTENERS] GC'ed these listeners that were NOT yet disposed:"),console.warn(ee.join(`
`)),ee.length=0)},3e3),n=new FinalizationRegistry(V=>{typeof V=="string"&&ee.push(V)})}class i{constructor(V){this.z=0,this.f=V,this.g=v>0||this.f?.leakWarningThreshold?new o(V?.onListenerError??g.$3,this.f?.leakWarningThreshold??v):void 0,this.j=this.f?._profName?new _(this.f._profName):void 0,this.w=this.f?.deliveryQueue}dispose(){if(!this.m){if(this.m=!0,this.w?.current===this&&this.w.reset(),this.u){if(U){const V=this.u;queueMicrotask(()=>{r(V,re=>re.stack?.print())})}this.u=void 0,this.z=0}this.f?.onDidRemoveLastListener?.(),this.g?.dispose()}}get event(){return this.q??=(V,re,X)=>{if(this.g&&this.z>this.g.threshold**2){const a=`[${this.g.name}] REFUSES to accept new listeners because it exceeded its threshold by far (${this.z} vs ${this.g.threshold})`;console.warn(a);const T=this.g.getMostFrequentStack()??["UNKNOWN stack",-1],B=new m(`${a}. HINT: Stack shows most frequent listener (${T[1]}-times)`,T[0]);return(this.f?.onListenerError||g.$3)(B),W.$Xc.None}if(this.m)return W.$Xc.None;re&&(V=V.bind(re));const te=new w(V);let oe,ce;this.g&&this.z>=Math.ceil(this.g.threshold*.2)&&(te.stack=s.create(),oe=this.g.check(te.stack,this.z+1)),U&&(te.stack=ce??s.create()),this.u?this.u instanceof w?(this.w??=new c,this.u=[this.u,te]):this.u.push(te):(this.f?.onWillAddFirstListener?.(this),this.u=te,this.f?.onDidAddFirstListener?.(this)),this.z++;const L=(0,W.$Vc)(()=>{n?.unregister(L),oe?.(),this.A(te)});if(X instanceof W.$Wc?X.add(L):Array.isArray(X)&&X.push(L),n){const a=new Error().stack.split(`
`).slice(2,3).join(`
`).trim(),T=/(file:|vscode-file:\/\/vscode-app)?(\/[^:]*:\d+:\d+)/.exec(a);n.register(L,T?.[2]??a,L)}return L},this.q}A(V){if(this.f?.onWillRemoveListener?.(this),!this.u)return;if(this.z===1){this.u=void 0,this.f?.onDidRemoveLastListener?.(this),this.z=0;return}const re=this.u,X=re.indexOf(V);if(X===-1)throw console.log("disposed?",this.m),console.log("size?",this.z),console.log("arr?",JSON.stringify(this.u)),new Error("Attempted to dispose unknown listener");this.z--,re[X]=void 0;const te=this.w.current===this;if(this.z*y<=re.length){let oe=0;for(let ce=0;ce<re.length;ce++)re[ce]?re[oe++]=re[ce]:te&&(this.w.end--,oe<this.w.i&&this.w.i--);re.length=oe}}B(V,re){if(!V)return;const X=this.f?.onListenerError||g.$3;if(!X){V.value(re);return}try{V.value(re)}catch(te){X(te)}}C(V){const re=V.current.u;for(;V.i<V.end;)this.B(re[V.i++],V.value);V.reset()}fire(V){if(this.w?.current&&(this.C(this.w),this.j?.stop()),this.j?.start(this.z),this.u)if(this.u instanceof w)this.B(this.u,V);else{const re=this.w;re.enqueue(this,V,this.u.length),this.C(re)}this.j?.stop()}hasListeners(){return this.z>0}}e.$ne=i;const l=()=>new c;e.$oe=l;class c{constructor(){this.i=-1,this.end=0}enqueue(V,re,X){this.i=0,this.end=X,this.current=V,this.value=re}reset(){this.i=this.end,this.current=void 0,this.value=void 0}}class O extends i{async fireAsync(V,re,X){if(this.u)for(this.h||(this.h=new M.$8c),r(this.u,te=>this.h.push([te.value,V]));this.h.size>0&&!re.isCancellationRequested;){const[te,oe]=this.h.shift(),ce=[],L={...oe,token:re,waitUntil:a=>{if(Object.isFrozen(ce))throw new Error("waitUntil can NOT be called asynchronous");X&&(a=X(a,te)),ce.push(a)}};try{te(L)}catch(a){(0,g.$3)(a);continue}Object.freeze(ce),await Promise.allSettled(ce).then(a=>{for(const T of a)T.status==="rejected"&&(0,g.$3)(T.reason)})}}}e.$pe=O;class h extends i{get isPaused(){return this.h!==0}constructor(V){super(V),this.h=0,this.s=new M.$8c,this.t=V?.merge}pause(){this.h++}resume(){if(this.h!==0&&--this.h===0)if(this.t){if(this.s.size>0){const V=Array.from(this.s);this.s.clear(),super.fire(this.t(V))}}else for(;!this.h&&this.s.size!==0;)super.fire(this.s.shift())}fire(V){this.z&&(this.h!==0?this.s.push(V):super.fire(V))}}e.$qe=h;class A extends h{constructor(V){super(V),this.k=V.delay??100}fire(V){this.o||(this.pause(),this.o=setTimeout(()=>{this.o=void 0,this.resume()},this.k)),super.fire(V)}}e.$re=A;class u extends i{constructor(V){super(V),this.h=[],this.k=V?.merge}fire(V){this.hasListeners()&&(this.h.push(V),this.h.length===1&&queueMicrotask(()=>{this.k?super.fire(this.k(this.h)):this.h.forEach(re=>super.fire(re)),this.h=[]}))}}e.$se=u;class S{constructor(){this.g=!1,this.h=[],this.f=new i({onWillAddFirstListener:()=>this.j(),onDidRemoveLastListener:()=>this.k()})}get event(){return this.f.event}add(V){const re={event:V,listener:null};this.h.push(re),this.g&&this.m(re);const X=()=>{this.g&&this.o(re);const te=this.h.indexOf(re);this.h.splice(te,1)};return(0,W.$Vc)((0,t.$gb)(X))}j(){this.g=!0,this.h.forEach(V=>this.m(V))}k(){this.g=!1,this.h.forEach(V=>this.o(V))}m(V){V.listener=V.event(re=>this.f.fire(re))}o(V){V.listener?.dispose(),V.listener=null}dispose(){this.f.dispose();for(const V of this.h)V.listener?.dispose();this.h=[]}}e.$te=S;class R{constructor(V,re,X,te){this.f=new W.$Wc;const oe=this.f.add(new S),ce=this.f.add(new W.$7c);function L(a){ce.set(a,oe.add(te(a)))}for(const a of V)L(a);this.f.add(re(a=>{L(a)})),this.f.add(X(a=>{ce.deleteAndDispose(a)})),this.event=oe.event}dispose(){this.f.dispose()}}e.$ue=R;class b{constructor(){this.f=[]}wrapEvent(V,re,X){return(te,oe,ce)=>V(L=>{const a=this.f[this.f.length-1];if(!re){a?a.buffers.push(()=>te.call(oe,L)):te.call(oe,L);return}const T=a;if(!T){te.call(oe,re(X,L));return}T.items??=[],T.items.push(L),T.buffers.length===0&&a.buffers.push(()=>{T.reducedResult??=X?T.items.reduce(re,X):T.items.reduce(re),te.call(oe,T.reducedResult)})},void 0,ce)}bufferEvents(V){const re={buffers:new Array};this.f.push(re);const X=V();return this.f.pop(),re.buffers.forEach(te=>te()),X}}e.$ve=b;class d{constructor(){this.f=!1,this.g=N.None,this.h=W.$Xc.None,this.j=new i({onDidAddFirstListener:()=>{this.f=!0,this.h=this.g(this.j.fire,this.j)},onDidRemoveLastListener:()=>{this.f=!1,this.h.dispose()}}),this.event=this.j.event}set input(V){this.g=V,this.f&&(this.h.dispose(),this.h=V(this.j.fire,this.j))}dispose(){this.h.dispose(),this.j.dispose()}}e.$we=d;class K{static const(V){return new ie(V)}constructor(V){this.g=V,this.f=new i,this.onDidChange=this.f.event}get value(){return this.g}set value(V){V!==this.g&&(this.g=V,this.f.fire(void 0))}}e.$xe=K;class ie{constructor(V){this.value=V,this.onDidChange=N.None}}}),define(_e[13],Ee([0,1,6]),function(ae,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ye=e.CancellationToken=void 0,e.$ze=F;const t=Object.freeze(function(U,P){const N=setTimeout(U.bind(P),0);return{dispose(){clearTimeout(N)}}});var W;(function(U){function P(N){return N===U.None||N===U.Cancelled||N instanceof M?!0:!N||typeof N!="object"?!1:typeof N.isCancellationRequested=="boolean"&&typeof N.onCancellationRequested=="function"}U.isCancellationToken=P,U.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:g.Event.None}),U.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:t})})(W||(e.CancellationToken=W={}));class M{constructor(){this.a=!1,this.b=null}cancel(){this.a||(this.a=!0,this.b&&(this.b.fire(void 0),this.dispose()))}get isCancellationRequested(){return this.a}get onCancellationRequested(){return this.a?t:(this.b||(this.b=new g.$ne),this.b.event)}dispose(){this.b&&(this.b.dispose(),this.b=null)}}class Y{constructor(P){this.f=void 0,this.g=void 0,this.g=P&&P.onCancellationRequested(this.cancel,this)}get token(){return this.f||(this.f=new M),this.f}cancel(){this.f?this.f instanceof M&&this.f.cancel():this.f=W.Cancelled}dispose(P=!1){P&&this.cancel(),this.g?.dispose(),this.f?this.f instanceof M&&this.f.dispose():this.f=W.None}}e.$ye=Y;function F(U){const P=new Y;return U.add({dispose(){P.cancel()}}),P.token}}),define(_e[44],Ee([0,1,13]),function(ae,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bf=e.$af=e.$$e=void 0,e.$_e=W;class t{constructor(U){this.b=U,this.a=null}get(){if(this.a)return this.a;const U=new g.$ye,P=this.b(U.token);return this.a={promise:P,dispose:()=>{this.a=null,U.cancel(),U.dispose()}},this.a}}e.$$e=t;function W(F){return F}class M{constructor(U,P){this.a=void 0,this.b=void 0,typeof U=="function"?(this.c=U,this.d=W):(this.c=P,this.d=U.getCacheKey)}get(U){const P=this.d(U);return this.b!==P&&(this.b=P,this.a=this.c(U)),this.a}}e.$af=M;class Y{get cachedValues(){return this.a}constructor(U,P){this.a=new Map,this.b=new Map,typeof U=="function"?(this.c=U,this.d=W):(this.c=P,this.d=U.getCacheKey)}get(U){const P=this.d(U);if(this.b.has(P))return this.b.get(P);const N=this.c(U);return this.a.set(U,N),this.b.set(P,N),N}}e.$bf=Y}),define(_e[45],Ee([0,1,9,4]),function(ae,e,g,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ae=W,e.$Be=M,e.$Ce=Y,e.$De=F,e.$Ee=P,e.$Fe=N,e.$Ge=_,e.$He=v,e.$Ie=k,e.$Je=o,e.$Ke=s,e.$Le=$,e.$Me=m,e.$Ne=f,e.$Oe=w;function W(y){const r=y;return r?typeof r.read=="function":!1}function M(y){const r=y;return r?[r.on,r.pause,r.resume,r.destroy].every(n=>typeof n=="function"):!1}function Y(y){const r=y;return r?M(r.stream)&&Array.isArray(r.buffer)&&typeof r.ended=="boolean":!1}function F(y,r){return new U(y,r)}class U{constructor(r,n){this.e=r,this.f=n,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(r){if(!this.a.destroyed){if(this.a.flowing)this.g(r);else if(this.b.data.push(r),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(n=>this.d.push(n))}}error(r){this.a.destroyed||(this.a.flowing?this.h(r):this.b.error.push(r))}end(r){this.a.destroyed||(typeof r<"u"&&this.write(r),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(r){this.c.data.slice(0).forEach(n=>n(r))}h(r){this.c.error.length===0?(0,g.$3)(r):this.c.error.slice(0).forEach(n=>n(r))}i(){this.c.end.slice(0).forEach(r=>r())}on(r,n){if(!this.a.destroyed)switch(r){case"data":this.c.data.push(n),this.resume();break;case"end":this.c.end.push(n),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(n),this.a.flowing&&this.k();break}}removeListener(r,n){if(this.a.destroyed)return;let i;switch(r){case"data":i=this.c.data;break;case"end":i=this.c.end;break;case"error":i=this.c.error;break}if(i){const l=i.indexOf(n);l>=0&&i.splice(l,1)}}j(){if(this.b.data.length>0){const r=this.e(this.b.data);this.g(r),this.b.data.length=0;const n=[...this.d];this.d.length=0,n.forEach(i=>i())}}k(){if(this.c.error.length>0){for(const r of this.b.error)this.h(r);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function P(y,r){const n=[];let i;for(;(i=y.read())!==null;)n.push(i);return r(n)}function N(y,r,n){const i=[];let l;for(;(l=y.read())!==null&&i.length<n;)i.push(l);return l===null&&i.length>0?r(i):{read:()=>{if(i.length>0)return i.shift();if(typeof l<"u"){const c=l;return l=void 0,c}return y.read()}}}function _(y,r){return new Promise((n,i)=>{const l=[];v(y,{onData:c=>{r&&l.push(c)},onError:c=>{r?i(c):n(void 0)},onEnd:()=>{n(r?r(l):void 0)}})})}function v(y,r,n){y.on("error",i=>{n?.isCancellationRequested||r.onError(i)}),y.on("end",()=>{n?.isCancellationRequested||r.onEnd()}),y.on("data",i=>{n?.isCancellationRequested||r.onData(i)})}function k(y,r){return new Promise((n,i)=>{const l=new t.$Wc,c=[],O=u=>{if(c.push(u),c.length>r)return l.dispose(),y.pause(),n({stream:y,buffer:c,ended:!1})},h=u=>(l.dispose(),i(u)),A=()=>(l.dispose(),n({stream:y,buffer:c,ended:!0}));l.add((0,t.$Vc)(()=>y.removeListener("error",h))),y.on("error",h),l.add((0,t.$Vc)(()=>y.removeListener("end",A))),y.on("end",A),l.add((0,t.$Vc)(()=>y.removeListener("data",O))),y.on("data",O)})}function o(y,r){const n=F(r);return n.end(y),n}function s(){const y=F(()=>{throw new Error("not supported")});return y.end(),y}function $(y){let r=!1;return{read:()=>r?null:(r=!0,y)}}function m(y,r,n){const i=F(n);return v(y,{onData:l=>i.write(r.data(l)),onError:l=>i.error(r.error?r.error(l):l),onEnd:()=>i.end()}),i}function f(y,r,n){let i=!1;return{read:()=>{const l=r.read();return i?l:(i=!0,l!==null?n([y,l]):y)}}}function w(y,r,n){let i=!1;const l=F(n);return v(r,{onData:c=>i?l.write(c):(i=!0,l.write(n([y,c]))),onError:c=>l.error(c),onEnd:()=>{i||(i=!0,l.write(y)),l.end()}}),l}});var Xe=this&&this.__createBinding||(Object.create?function(ae,e,g,t){t===void 0&&(t=g);var W=Object.getOwnPropertyDescriptor(e,g);(!W||("get"in W?!e.__esModule:W.writable||W.configurable))&&(W={enumerable:!0,get:function(){return e[g]}}),Object.defineProperty(ae,t,W)}:function(ae,e,g,t){t===void 0&&(t=g),ae[t]=e[g]}),Ye=this&&this.__setModuleDefault||(Object.create?function(ae,e){Object.defineProperty(ae,"default",{enumerable:!0,value:e})}:function(ae,e){ae.default=e}),Le=this&&this.__importStar||function(ae){if(ae&&ae.__esModule)return ae;var e={};if(ae!=null)for(var g in ae)g!=="default"&&Object.prototype.hasOwnProperty.call(ae,g)&&Xe(e,ae,g);return Ye(e,ae),e};define(_e[16],Ee([0,1,15,45]),function(ae,e,g,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pe=void 0,e.$Qe=P,e.$Re=N,e.$Se=_,e.$Te=v,e.$Ue=k,e.$Ve=o,e.$We=s,e.$Xe=$,e.$Ye=m,e.$Ze=f,e.$1e=w,e.$2e=y,e.$3e=r,e.$4e=n,e.$5e=i,e.$6e=l,e.$7e=c,e.$8e=O,e.$9e=h,e.$0e=S,t=Le(t);const W=typeof Buffer<"u",M=new g.$X(()=>new Uint8Array(256));let Y,F;class U{static alloc(b){return W?new U(Buffer.allocUnsafe(b)):new U(new Uint8Array(b))}static wrap(b){return W&&!Buffer.isBuffer(b)&&(b=Buffer.from(b.buffer,b.byteOffset,b.byteLength)),new U(b)}static fromString(b,d){return!(d?.dontUseNodeBuffer||!1)&&W?new U(Buffer.from(b)):(Y||(Y=new TextEncoder),new U(Y.encode(b)))}static fromByteArray(b){const d=U.alloc(b.length);for(let K=0,ie=b.length;K<ie;K++)d.buffer[K]=b[K];return d}static concat(b,d){if(typeof d>"u"){d=0;for(let ee=0,V=b.length;ee<V;ee++)d+=b[ee].byteLength}const K=U.alloc(d);let ie=0;for(let ee=0,V=b.length;ee<V;ee++){const re=b[ee];K.set(re,ie),ie+=re.byteLength}return K}constructor(b){this.buffer=b,this.byteLength=this.buffer.byteLength}clone(){const b=U.alloc(this.byteLength);return b.set(this),b}toString(){return W?this.buffer.toString():(F||(F=new TextDecoder),F.decode(this.buffer))}slice(b,d){return new U(this.buffer.subarray(b,d))}set(b,d){if(b instanceof U)this.buffer.set(b.buffer,d);else if(b instanceof Uint8Array)this.buffer.set(b,d);else if(b instanceof ArrayBuffer)this.buffer.set(new Uint8Array(b),d);else if(ArrayBuffer.isView(b))this.buffer.set(new Uint8Array(b.buffer,b.byteOffset,b.byteLength),d);else throw new Error("Unknown argument 'array'")}readUInt32BE(b){return v(this.buffer,b)}writeUInt32BE(b,d){k(this.buffer,b,d)}readUInt32LE(b){return o(this.buffer,b)}writeUInt32LE(b,d){s(this.buffer,b,d)}readUInt8(b){return $(this.buffer,b)}writeUInt8(b,d){m(this.buffer,b,d)}indexOf(b,d=0){return P(this.buffer,b instanceof U?b.buffer:b,d)}}e.$Pe=U;function P(R,b,d=0){const K=b.byteLength,ie=R.byteLength;if(K===0)return 0;if(K===1)return R.indexOf(b[0]);if(K>ie-d)return-1;const ee=M.value;ee.fill(b.length);for(let te=0;te<b.length;te++)ee[b[te]]=b.length-te-1;let V=d+b.length-1,re=V,X=-1;for(;V<ie;)if(R[V]===b[re]){if(re===0){X=V;break}V--,re--}else V+=Math.max(b.length-re,ee[R[V]]),re=b.length-1;return X}function N(R,b){return R[b+0]<<0>>>0|R[b+1]<<8>>>0}function _(R,b,d){R[d+0]=b&255,b=b>>>8,R[d+1]=b&255}function v(R,b){return R[b]*2**24+R[b+1]*2**16+R[b+2]*2**8+R[b+3]}function k(R,b,d){R[d+3]=b,b=b>>>8,R[d+2]=b,b=b>>>8,R[d+1]=b,b=b>>>8,R[d]=b}function o(R,b){return R[b+0]<<0>>>0|R[b+1]<<8>>>0|R[b+2]<<16>>>0|R[b+3]<<24>>>0}function s(R,b,d){R[d+0]=b&255,b=b>>>8,R[d+1]=b&255,b=b>>>8,R[d+2]=b&255,b=b>>>8,R[d+3]=b&255}function $(R,b){return R[b]}function m(R,b,d){R[d]=b}function f(R){return t.$Ee(R,b=>U.concat(b))}function w(R){return t.$Le(R)}function y(R){return t.$Ge(R,b=>U.concat(b))}async function r(R){return R.ended?U.concat(R.buffer):U.concat([...R.buffer,await y(R.stream)])}function n(R){return t.$Je(R,b=>U.concat(b))}function i(R){return t.$Me(R,{data:b=>typeof b=="string"?U.fromString(b):U.wrap(b)},b=>U.concat(b))}function l(R){return t.$De(b=>U.concat(b),R)}function c(R,b){return t.$Ne(R,b,d=>U.concat(d))}function O(R,b){return t.$Oe(R,b,d=>U.concat(d))}function h(R){let b=0,d=0,K=0;const ie=new Uint8Array(Math.floor(R.length/4*3)),ee=re=>{switch(d){case 3:ie[K++]=b|re,d=0;break;case 2:ie[K++]=b|re>>>2,b=re<<6,d=3;break;case 1:ie[K++]=b|re>>>4,b=re<<4,d=2;break;default:b=re<<2,d=1}};for(let re=0;re<R.length;re++){const X=R.charCodeAt(re);if(X>=65&&X<=90)ee(X-65);else if(X>=97&&X<=122)ee(X-97+26);else if(X>=48&&X<=57)ee(X-48+52);else if(X===43||X===45)ee(62);else if(X===47||X===95)ee(63);else{if(X===61)break;throw new SyntaxError(`Unexpected base64 character ${R[re]}`)}}const V=K;for(;d>0;)ee(0);return U.wrap(ie).slice(0,V)}const A="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",u="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function S({buffer:R},b=!0,d=!1){const K=d?u:A;let ie="";const ee=R.byteLength%3;let V=0;for(;V<R.byteLength-ee;V+=3){const re=R[V+0],X=R[V+1],te=R[V+2];ie+=K[re>>>2],ie+=K[(re<<4|X>>>4)&63],ie+=K[(X<<2|te>>>6)&63],ie+=K[te&63]}if(ee===1){const re=R[V+0];ie+=K[re>>>2],ie+=K[re<<4&63],b&&(ie+="==")}else if(ee===2){const re=R[V+0],X=R[V+1];ie+=K[re>>>2],ie+=K[(re<<4|X>>>4)&63],ie+=K[X<<2&63],b&&(ie+="=")}return ie}}),define(_e[46],Ee([0,1]),function(ae,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ie=void 0,e.$ie=Symbol("MicrotaskDelay")}),define(_e[10],Ee([0,1]),function(ae,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gg=g,e.$hg=t,e.$ig=W,e.$jg=M,e.$kg=Y,e.$lg=F,e.$mg=U,e.$ng=P,e.$og=N,e.$pg=_,e.$qg=v,e.$rg=k,e.$sg=o,e.$tg=$,e.$ug=m,e.$vg=f,e.$wg=w,e.$xg=y;function g(r){return typeof r=="string"}function t(r){return Array.isArray(r)&&r.every(n=>g(n))}function W(r){return typeof r=="object"&&r!==null&&!Array.isArray(r)&&!(r instanceof RegExp)&&!(r instanceof Date)}function M(r){const n=Object.getPrototypeOf(Uint8Array);return typeof r=="object"&&r instanceof n}function Y(r){return typeof r=="number"&&!isNaN(r)}function F(r){return!!r&&typeof r[Symbol.iterator]=="function"}function U(r){return r===!0||r===!1}function P(r){return typeof r>"u"}function N(r){return!_(r)}function _(r){return P(r)||r===null}function v(r,n){if(!r)throw new Error(n?`Unexpected type, expected '${n}'`:"Unexpected type")}function k(r){if(_(r))throw new Error("Assertion Failed: argument is undefined or null");return r}function o(...r){const n=[];for(let i=0;i<r.length;i++){const l=r[i];if(_(l))throw new Error(`Assertion Failed: argument at index ${i} is undefined or null`);n.push(l)}return n}const s=Object.prototype.hasOwnProperty;function $(r){if(!W(r))return!1;for(const n in r)if(s.call(r,n))return!1;return!0}function m(r){return typeof r=="function"}function f(...r){return r.length>0&&r.every(m)}function w(r,n){const i=Math.min(r.length,n.length);for(let l=0;l<i;l++)y(r[l],n[l])}function y(r,n){if(g(n)){if(typeof r!==n)throw new Error(`argument does not match constraint: typeof ${n}`)}else if(m(n)){try{if(r instanceof n)return}catch{}if(!_(r)&&r.constructor===n||n.length===1&&n.call(void 0,r)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}}),define(_e[47],Ee([0,1,10]),function(ae,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$eo=t,e.$fo=W,e.$go=Y,e.$ho=U,e.$io=P,e.$jo=N,e.$ko=_,e.$lo=v,e.$mo=k,e.$no=o,e.$oo=s,e.$po=$,e.$qo=m;function t(f){if(!f||typeof f!="object"||f instanceof RegExp)return f;const w=Array.isArray(f)?[]:{};return Object.entries(f).forEach(([y,r])=>{w[y]=r&&typeof r=="object"?t(r):r}),w}function W(f){if(!f||typeof f!="object")return f;const w=[f];for(;w.length>0;){const y=w.shift();Object.freeze(y);for(const r in y)if(M.call(y,r)){const n=y[r];typeof n=="object"&&!Object.isFrozen(n)&&!(0,g.$jg)(n)&&w.push(n)}}return f}const M=Object.prototype.hasOwnProperty;function Y(f,w){return F(f,w,new Set)}function F(f,w,y){if((0,g.$pg)(f))return f;const r=w(f);if(typeof r<"u")return r;if(Array.isArray(f)){const n=[];for(const i of f)n.push(F(i,w,y));return n}if((0,g.$ig)(f)){if(y.has(f))throw new Error("Cannot clone recursive data-structure");y.add(f);const n={};for(const i in f)M.call(f,i)&&(n[i]=F(f[i],w,y));return y.delete(f),n}return f}function U(f,w,y=!0){return(0,g.$ig)(f)?((0,g.$ig)(w)&&Object.keys(w).forEach(r=>{r in f?y&&((0,g.$ig)(f[r])&&(0,g.$ig)(w[r])?U(f[r],w[r],y):f[r]=w[r]):f[r]=w[r]}),f):w}function P(f,w){if(f===w)return!0;if(f==null||w===null||w===void 0||typeof f!=typeof w||typeof f!="object"||Array.isArray(f)!==Array.isArray(w))return!1;let y,r;if(Array.isArray(f)){if(f.length!==w.length)return!1;for(y=0;y<f.length;y++)if(!P(f[y],w[y]))return!1}else{const n=[];for(r in f)n.push(r);n.sort();const i=[];for(r in w)i.push(r);if(i.sort(),!P(n,i))return!1;for(y=0;y<n.length;y++)if(!P(f[n[y]],w[n[y]]))return!1}return!0}function N(f){const w=new Set;return JSON.stringify(f,(y,r)=>{if((0,g.$ig)(r)||Array.isArray(r)){if(w.has(r))return"[Circular]";w.add(r)}return typeof r=="bigint"?`[BigInt ${r.toString()}]`:r})}function _(f,w){const y=Object.create(null);return!f||!w||Object.keys(w).forEach(n=>{const i=f[n],l=w[n];P(i,l)||(y[n]=l)}),y}function v(f,w){const y=w.toLowerCase(),r=Object.keys(f).find(n=>n.toLowerCase()===y);return r?f[r]:f[w]}function k(f,w){const y=Object.create(null);for(const[r,n]of Object.entries(f))w(r,n)&&(y[r]=n);return y}function o(f){let w=[];for(;Object.prototype!==f;)w=w.concat(Object.getOwnPropertyNames(f)),f=Object.getPrototypeOf(f);return w}function s(f){const w=[];for(const y of o(f))typeof f[y]=="function"&&w.push(y);return w}function $(f,w){const y=n=>function(){const i=Array.prototype.slice.call(arguments,0);return w(n,i)},r={};for(const n of f)r[n]=y(n);return r}function m(f,w){const y={};for(const[r,n]of Object.entries(f))y[r]=w(n,r);return y}}),define(_e[48],Ee([0,1]),function(ae,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Constants=void 0,e.$cf=t,e.$df=W;var g;(function(M){M[M.MAX_SAFE_SMALL_INTEGER=1073741824]="MAX_SAFE_SMALL_INTEGER",M[M.MIN_SAFE_SMALL_INTEGER=-1073741824]="MIN_SAFE_SMALL_INTEGER",M[M.MAX_UINT_8=255]="MAX_UINT_8",M[M.MAX_UINT_16=65535]="MAX_UINT_16",M[M.MAX_UINT_32=4294967295]="MAX_UINT_32",M[M.UNICODE_SUPPLEMENTARY_PLANE_BEGIN=65536]="UNICODE_SUPPLEMENTARY_PLANE_BEGIN"})(g||(e.Constants=g={}));function t(M){return M<0?0:M>g.MAX_UINT_8?g.MAX_UINT_8:M|0}function W(M){return M<0?0:M>g.MAX_UINT_32?g.MAX_UINT_32:M|0}}),define(_e[7],Ee([0,1,44,11,15,48]),function(ae,e,g,t,W,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fg=e.$eg=e.$dg=e.GraphemeBreakType=e.$6f=e.$Xf=e.$Qf=e.$Pf=void 0,e.$ef=Y,e.$ff=U,e.$gf=N,e.$hf=_,e.$if=v,e.$jf=k,e.$kf=o,e.$lf=s,e.$mf=$,e.$nf=m,e.$of=f,e.$pf=w,e.$qf=y,e.$rf=r,e.$sf=n,e.$tf=i,e.$uf=l,e.$vf=c,e.$wf=O,e.$xf=h,e.$yf=A,e.$zf=u,e.$Af=S,e.$Bf=R,e.$Cf=b,e.$Df=d,e.$Ef=K,e.$Ff=ie,e.$Gf=ee,e.$Hf=V,e.$If=re,e.$Jf=X,e.$Kf=te,e.$Lf=oe,e.$Mf=ce,e.$Nf=L,e.$Of=a,e.$Rf=D,e.$Sf=Z,e.$Tf=x,e.$Uf=se,e.$Vf=p,e.$Wf=G,e.$Yf=j,e.$Zf=E,e.$1f=H,e.$2f=J,e.$3f=$e,e.$4f=De,e.$5f=fe,e.$7f=be,e.$8f=ge,e.$9f=we,e.$0f=ye,e.$$f=Re,e.$_f=Ie,e.$ag=Ue,e.$bg=pe,e.$cg=ze;function Y(I){return!I||typeof I!="string"?!0:I.trim().length===0}const F=/{(\d+)}/g;function U(I,...z){return z.length===0?I:I.replace(F,function(C,ue){const me=parseInt(ue,10);return isNaN(me)||me<0||me>=z.length?C:z[me]})}const P=/{([^}]+)}/g;function N(I,z){return Object.keys(z).length===0?I:I.replace(P,(C,ue)=>z[ue]??C)}function _(I){return I.replace(/[<>"'&]/g,z=>{switch(z){case"<":return"&lt;";case">":return"&gt;";case'"':return"&quot;";case"'":return"&apos;";case"&":return"&amp;"}return z})}function v(I){return I.replace(/[<>&]/g,function(z){switch(z){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return z}})}function k(I){return I.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}function o(I,z){let C=0,ue=I.indexOf(z);for(;ue!==-1;)C++,ue=I.indexOf(z,ue+z.length);return C}function s(I,z,C="\u2026"){return I.length<=z?I:`${I.substr(0,z)}${C}`}function $(I,z,C="\u2026"){if(I.length<=z)return I;const ue=Math.ceil(z/2)-C.length/2,me=Math.floor(z/2)-C.length/2;return`${I.substr(0,ue)}${C}${I.substr(I.length-me)}`}function m(I,z=" "){const C=f(I,z);return w(C,z)}function f(I,z){if(!I||!z)return I;const C=z.length;if(C===0||I.length===0)return I;let ue=0;for(;I.indexOf(z,ue)===ue;)ue=ue+C;return I.substring(ue)}function w(I,z){if(!I||!z)return I;const C=z.length,ue=I.length;if(C===0||ue===0)return I;let me=ue,ve=-1;for(;ve=I.lastIndexOf(z,me-1),!(ve===-1||ve+C!==me);){if(ve===0)return"";me=ve}return I.substring(0,me)}function y(I){return I.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}function r(I){return I.replace(/\*/g,"")}function n(I,z,C={}){if(!I)throw new Error("Cannot create regex from empty string");z||(I=k(I)),C.wholeWord&&(/\B/.test(I.charAt(0))||(I="\\b"+I),/\B/.test(I.charAt(I.length-1))||(I=I+"\\b"));let ue="";return C.global&&(ue+="g"),C.matchCase||(ue+="i"),C.multiline&&(ue+="m"),C.unicode&&(ue+="u"),new RegExp(I,ue)}function i(I){return I.source==="^"||I.source==="^$"||I.source==="$"||I.source==="^\\s*$"?!1:!!(I.exec("")&&I.lastIndex===0)}function l(I){return I.split(/\r\n|\r|\n/)}function c(I){const z=[],C=I.split(/(\r\n|\r|\n)/);for(let ue=0;ue<Math.ceil(C.length/2);ue++)z.push(C[2*ue]+(C[2*ue+1]??""));return z}function O(I){for(let z=0,C=I.length;z<C;z++){const ue=I.charCodeAt(z);if(ue!==t.CharCode.Space&&ue!==t.CharCode.Tab)return z}return-1}function h(I,z=0,C=I.length){for(let ue=z;ue<C;ue++){const me=I.charCodeAt(ue);if(me!==t.CharCode.Space&&me!==t.CharCode.Tab)return I.substring(z,ue)}return I.substring(z,C)}function A(I,z=I.length-1){for(let C=z;C>=0;C--){const ue=I.charCodeAt(C);if(ue!==t.CharCode.Space&&ue!==t.CharCode.Tab)return C}return-1}function u(I,z,C){const ue=[];let me=0;for(const ve of I.matchAll(z)){if(ue.push(I.slice(me,ve.index)),ve.index===void 0)throw new Error("match.index should be defined");me=ve.index+ve[0].length,ue.push(C(ve[0],...ve.slice(1),ve.index,I,ve.groups))}return ue.push(I.slice(me)),Promise.all(ue).then(ve=>ve.join(""))}function S(I,z){return I<z?-1:I>z?1:0}function R(I,z,C=0,ue=I.length,me=0,ve=z.length){for(;C<ue&&me<ve;C++,me++){const Se=I.charCodeAt(C),ke=z.charCodeAt(me);if(Se<ke)return-1;if(Se>ke)return 1}const Oe=ue-C,Fe=ve-me;return Oe<Fe?-1:Oe>Fe?1:0}function b(I,z){return d(I,z,0,I.length,0,z.length)}function d(I,z,C=0,ue=I.length,me=0,ve=z.length){for(;C<ue&&me<ve;C++,me++){let Se=I.charCodeAt(C),ke=z.charCodeAt(me);if(Se===ke)continue;if(Se>=128||ke>=128)return R(I.toLowerCase(),z.toLowerCase(),C,ue,me,ve);ie(Se)&&(Se-=32),ie(ke)&&(ke-=32);const Te=Se-ke;if(Te!==0)return Te}const Oe=ue-C,Fe=ve-me;return Oe<Fe?-1:Oe>Fe?1:0}function K(I){return I>=t.CharCode.Digit0&&I<=t.CharCode.Digit9}function ie(I){return I>=t.CharCode.a&&I<=t.CharCode.z}function ee(I){return I>=t.CharCode.A&&I<=t.CharCode.Z}function V(I,z){return I.length===z.length&&d(I,z)===0}function re(I,z){const C=z.length;return z.length>I.length?!1:d(I,z,0,C)===0}function X(I,z){const C=Math.min(I.length,z.length);let ue;for(ue=0;ue<C;ue++)if(I.charCodeAt(ue)!==z.charCodeAt(ue))return ue;return C}function te(I,z){const C=Math.min(I.length,z.length);let ue;const me=I.length-1,ve=z.length-1;for(ue=0;ue<C;ue++)if(I.charCodeAt(me-ue)!==z.charCodeAt(ve-ue))return ue;return C}function oe(I){return 55296<=I&&I<=56319}function ce(I){return 56320<=I&&I<=57343}function L(I,z){return(I-55296<<10)+(z-56320)+65536}function a(I,z,C){const ue=I.charCodeAt(C);if(oe(ue)&&C+1<z){const me=I.charCodeAt(C+1);if(ce(me))return L(ue,me)}return ue}function T(I,z){const C=I.charCodeAt(z-1);if(ce(C)&&z>1){const ue=I.charCodeAt(z-2);if(oe(ue))return L(ue,C)}return C}class B{get offset(){return this.e}constructor(z,C=0){this.c=z,this.d=z.length,this.e=C}setOffset(z){this.e=z}prevCodePoint(){const z=T(this.c,this.e);return this.e-=z>=M.Constants.UNICODE_SUPPLEMENTARY_PLANE_BEGIN?2:1,z}nextCodePoint(){const z=a(this.c,this.d,this.e);return this.e+=z>=M.Constants.UNICODE_SUPPLEMENTARY_PLANE_BEGIN?2:1,z}eol(){return this.e>=this.d}}e.$Pf=B;class Q{get offset(){return this.c.offset}constructor(z,C=0){this.c=new B(z,C)}nextGraphemeLength(){const z=Pe.getInstance(),C=this.c,ue=C.offset;let me=z.getGraphemeBreakType(C.nextCodePoint());for(;!C.eol();){const ve=C.offset,Oe=z.getGraphemeBreakType(C.nextCodePoint());if(je(me,Oe)){C.setOffset(ve);break}me=Oe}return C.offset-ue}prevGraphemeLength(){const z=Pe.getInstance(),C=this.c,ue=C.offset;let me=z.getGraphemeBreakType(C.prevCodePoint());for(;C.offset>0;){const ve=C.offset,Oe=z.getGraphemeBreakType(C.prevCodePoint());if(je(Oe,me)){C.setOffset(ve);break}me=Oe}return ue-C.offset}eol(){return this.c.eol()}}e.$Qf=Q;function D(I,z){return new Q(I,z).nextGraphemeLength()}function Z(I,z){return new Q(I,z).prevGraphemeLength()}function x(I,z){z>0&&ce(I.charCodeAt(z))&&z--;const C=z+D(I,z);return[C-Z(I,C),C]}function se(I){const z=new Q(I);let C=0;for(;!z.eol();)C++,z.nextGraphemeLength();return C}let le;function de(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function p(I){return le||(le=de()),le.test(I)}const q=/^[\t\n\r\x20-\x7E]*$/;function G(I){return q.test(I)}e.$Xf=/[\u2028\u2029]/;function j(I){return e.$Xf.test(I)}function E(I){return I>=11904&&I<=55215||I>=63744&&I<=64255||I>=65281&&I<=65374}function H(I){return I>=127462&&I<=127487||I===8986||I===8987||I===9200||I===9203||I>=9728&&I<=10175||I===11088||I===11093||I>=127744&&I<=128591||I>=128640&&I<=128764||I>=128992&&I<=129008||I>=129280&&I<=129535||I>=129648&&I<=129782}function J(I,z,C=""){const ue=I.trimStart();if(ue.length<z)return ue;const me=/\b/g;let ve=0;for(;me.test(ue)&&!(ue.length-me.lastIndex<z);)ve=me.lastIndex,me.lastIndex+=1;return ve===0?ue:C+ue.substring(ve).trimStart()}const ne=/(?:(?:\x1b\[|\x9B)[=?>!]?[\d;:]*["$#'* ]?[a-zA-Z@^`{}|~])|(:?\x1b\].*?\x07)/g;function*$e(I){let z=0;for(const C of I.matchAll(ne))z!==C.index&&(yield{isCode:!1,str:I.substring(z,C.index)}),yield{isCode:!0,str:C[0]},z=C.index+C[0].length;z!==I.length&&(yield{isCode:!1,str:I.substring(z)})}function De(I){return I&&(I=I.replace(ne,"")),I}const he=/\\\[.*?\\\]/g;function fe(I){return De(I).replace(he,"")}e.$6f=String.fromCharCode(t.CharCode.UTF8_BOM);function be(I){return!!(I&&I.length>0&&I.charCodeAt(0)===t.CharCode.UTF8_BOM)}function ge(I){return be(I)?I.substr(1):I}function we(I,z){if(!I||!z||I.length<z.length)return!1;const C=z.length,ue=I.toLowerCase();let me=0,ve=-1;for(;me<C;){const Oe=ue.indexOf(z[me],ve+1);if(Oe<0)return!1;ve=Oe,me++}return!0}function ye(I,z=!1){return I?(z&&(I=I.replace(/\\./g,"")),I.toLowerCase()!==I):!1}function Re(I){return I.charAt(0).toUpperCase()+I.slice(1)}function Ie(I,z=1){if(z===0)return"";let C=-1;do C=I.indexOf(`
`,C+1),z--;while(z>0&&C>=0);return C===-1?I:(I[C-1]==="\r"&&C--,I.substr(0,C))}function Ue(I){const z=t.CharCode.Z-t.CharCode.A+1;return I=I%(2*z),I<z?String.fromCharCode(t.CharCode.a+I):String.fromCharCode(t.CharCode.A+I-z)}function pe(I){return Pe.getInstance().getGraphemeBreakType(I)}function je(I,z){return I===Ae.Other?z!==Ae.Extend&&z!==Ae.SpacingMark:I===Ae.CR&&z===Ae.LF?!1:I===Ae.Control||I===Ae.CR||I===Ae.LF||z===Ae.Control||z===Ae.CR||z===Ae.LF?!0:!(I===Ae.L&&(z===Ae.L||z===Ae.V||z===Ae.LV||z===Ae.LVT)||(I===Ae.LV||I===Ae.V)&&(z===Ae.V||z===Ae.T)||(I===Ae.LVT||I===Ae.T)&&z===Ae.T||z===Ae.Extend||z===Ae.ZWJ||z===Ae.SpacingMark||I===Ae.Prepend||I===Ae.ZWJ&&z===Ae.Extended_Pictographic||I===Ae.Regional_Indicator&&z===Ae.Regional_Indicator)}var Ae;(function(I){I[I.Other=0]="Other",I[I.Prepend=1]="Prepend",I[I.CR=2]="CR",I[I.LF=3]="LF",I[I.Control=4]="Control",I[I.Extend=5]="Extend",I[I.Regional_Indicator=6]="Regional_Indicator",I[I.SpacingMark=7]="SpacingMark",I[I.L=8]="L",I[I.V=9]="V",I[I.T=10]="T",I[I.LV=11]="LV",I[I.LVT=12]="LVT",I[I.ZWJ=13]="ZWJ",I[I.Extended_Pictographic=14]="Extended_Pictographic"})(Ae||(e.GraphemeBreakType=Ae={}));class Pe{static{this.c=null}static getInstance(){return Pe.c||(Pe.c=new Pe),Pe.c}constructor(){this.d=Be()}getGraphemeBreakType(z){if(z<32)return z===t.CharCode.LineFeed?Ae.LF:z===t.CharCode.CarriageReturn?Ae.CR:Ae.Control;if(z<127)return Ae.Other;const C=this.d,ue=C.length/3;let me=1;for(;me<=ue;)if(z<C[3*me])me=2*me;else if(z>C[3*me+1])me=2*me+1;else return C[3*me+2];return Ae.Other}}function Be(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function ze(I,z){if(I===0)return 0;const C=Ke(I,z);if(C!==void 0)return C;const ue=new B(z,I);return ue.prevCodePoint(),ue.offset}function Ke(I,z){const C=new B(z,I);let ue=C.prevCodePoint();for(;Je(ue)||ue===Ge.emojiVariantSelector||ue===Ge.enclosingKeyCap;){if(C.offset===0)return;ue=C.prevCodePoint()}if(!H(ue))return;let me=C.offset;return me>0&&C.prevCodePoint()===Ge.zwj&&(me=C.offset),me}function Je(I){return 127995<=I&&I<=127999}var Ge;(function(I){I[I.zwj=8205]="zwj",I[I.emojiVariantSelector=65039]="emojiVariantSelector",I[I.enclosingKeyCap=8419]="enclosingKeyCap"})(Ge||(Ge={})),e.$dg="\xA0";class qe{static{this.c=new W.$X(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125,119846,109],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}'))}static{this.d=new g.$af({getCacheKey:JSON.stringify},z=>{function C(Te){const Me=new Map;for(let Ne=0;Ne<Te.length;Ne+=2)Me.set(Te[Ne],Te[Ne+1]);return Me}function ue(Te,Me){const Ne=new Map(Te);for(const[He,Ve]of Me)Ne.set(He,Ve);return Ne}function me(Te,Me){if(!Te)return Me;const Ne=new Map;for(const[He,Ve]of Te)Me.has(He)&&Ne.set(He,Ve);return Ne}const ve=this.c.value;let Oe=z.filter(Te=>!Te.startsWith("_")&&Te in ve);Oe.length===0&&(Oe=["_default"]);let Fe;for(const Te of Oe){const Me=C(ve[Te]);Fe=me(Fe,Me)}const Se=C(ve._common),ke=ue(Se,Fe);return new qe(ke)})}static getInstance(z){return qe.d.get(Array.from(z))}static{this.e=new W.$X(()=>Object.keys(qe.c.value).filter(z=>!z.startsWith("_")))}static getLocales(){return qe.e.value}constructor(z){this.f=z}isAmbiguous(z){return this.f.has(z)}containsAmbiguousCharacter(z){for(let C=0;C<z.length;C++){const ue=z.codePointAt(C);if(typeof ue=="number"&&this.isAmbiguous(ue))return!0}return!1}getPrimaryConfusable(z){return this.f.get(z)}getConfusableCodePoints(){return new Set(this.f.keys())}}e.$eg=qe;class We{static c(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static{this.d=void 0}static e(){return this.d||(this.d=new Set(We.c())),this.d}static isInvisibleCharacter(z){return We.e().has(z)}static containsInvisibleCharacter(z){for(let C=0;C<z.length;C++){const ue=z.codePointAt(C);if(typeof ue=="number"&&We.isInvisibleCharacter(ue))return!0}return!1}static get codePoints(){return We.e()}}e.$fg=We}),define(_e[28],Ee([0,1,12,11,7]),function(ae,e,g,t,W){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mi=e.$Li=e.$Ki=e.$Ji=e.$Ii=void 0;class M{constructor(){this.b="",this.c=0}reset(o){return this.b=o,this.c=0,this}next(){return this.c+=1,this}hasNext(){return this.c<this.b.length-1}cmp(o){const s=o.charCodeAt(0),$=this.b.charCodeAt(this.c);return s-$}value(){return this.b[this.c]}}e.$Ii=M;class Y{constructor(o=!0){this.e=o}reset(o){return this.b=o,this.c=0,this.d=0,this.next()}hasNext(){return this.d<this.b.length}next(){this.c=this.d;let o=!0;for(;this.d<this.b.length;this.d++)if(this.b.charCodeAt(this.d)===t.CharCode.Period)if(o)this.c++;else break;else o=!1;return this}cmp(o){return this.e?(0,W.$Bf)(o,this.b,0,o.length,this.c,this.d):(0,W.$Df)(o,this.b,0,o.length,this.c,this.d)}value(){return this.b.substring(this.c,this.d)}}e.$Ji=Y;class F{constructor(o=!0,s=!0){this.f=o,this.g=s}reset(o){this.d=0,this.e=0,this.b=o,this.c=o.length;for(let s=o.length-1;s>=0;s--,this.c--){const $=this.b.charCodeAt(s);if(!($===t.CharCode.Slash||this.f&&$===t.CharCode.Backslash))break}return this.next()}hasNext(){return this.e<this.c}next(){this.d=this.e;let o=!0;for(;this.e<this.c;this.e++){const s=this.b.charCodeAt(this.e);if(s===t.CharCode.Slash||this.f&&s===t.CharCode.Backslash)if(o)this.d++;else break;else o=!1}return this}cmp(o){return this.g?(0,W.$Bf)(o,this.b,0,o.length,this.d,this.e):(0,W.$Df)(o,this.b,0,o.length,this.d,this.e)}value(){return this.b.substring(this.d,this.e)}}e.$Ki=F;var U;(function(k){k[k.Scheme=1]="Scheme",k[k.Authority=2]="Authority",k[k.Path=3]="Path",k[k.Query=4]="Query",k[k.Fragment=5]="Fragment"})(U||(U={}));class P{constructor(o,s){this.f=o,this.g=s,this.d=[],this.e=0}reset(o){return this.c=o,this.d=[],this.c.scheme&&this.d.push(U.Scheme),this.c.authority&&this.d.push(U.Authority),this.c.path&&(this.b=new F(!1,!this.f(o)),this.b.reset(o.path),this.b.value()&&this.d.push(U.Path)),this.g(o)||(this.c.query&&this.d.push(U.Query),this.c.fragment&&this.d.push(U.Fragment)),this.e=0,this}next(){return this.d[this.e]===U.Path&&this.b.hasNext()?this.b.next():this.e+=1,this}hasNext(){return this.d[this.e]===U.Path&&this.b.hasNext()||this.e<this.d.length-1}cmp(o){if(this.d[this.e]===U.Scheme)return(0,W.$Cf)(o,this.c.scheme);if(this.d[this.e]===U.Authority)return(0,W.$Cf)(o,this.c.authority);if(this.d[this.e]===U.Path)return this.b.cmp(o);if(this.d[this.e]===U.Query)return(0,W.$Af)(o,this.c.query);if(this.d[this.e]===U.Fragment)return(0,W.$Af)(o,this.c.fragment);throw new Error}value(){if(this.d[this.e]===U.Scheme)return this.c.scheme;if(this.d[this.e]===U.Authority)return this.c.authority;if(this.d[this.e]===U.Path)return this.b.value();if(this.d[this.e]===U.Query)return this.c.query;if(this.d[this.e]===U.Fragment)return this.c.fragment;throw new Error}}e.$Li=P;class N{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const o=this.right;return this.right=o.left,o.left=this,this.updateHeight(),o.updateHeight(),o}rotateRight(){const o=this.left;return this.left=o.right,o.right=this,this.updateHeight(),o.updateHeight(),o}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var _;(function(k){k[k.Left=-1]="Left",k[k.Mid=0]="Mid",k[k.Right=1]="Right"})(_||(_={}));class v{static forUris(o=()=>!1,s=()=>!1){return new v(new P(o,s))}static forPaths(o=!1){return new v(new F(void 0,!o))}static forStrings(){return new v(new M)}static forConfigKeys(){return new v(new Y)}constructor(o){this.b=o}clear(){this.c=void 0}fill(o,s){if(s){const $=s.slice(0);(0,g.$Zb)($);for(const m of $)this.set(m,o)}else{const $=o.slice(0);(0,g.$Zb)($);for(const m of $)this.set(m[0],m[1])}}set(o,s){const $=this.b.reset(o);let m;this.c||(this.c=new N,this.c.segment=$.value());const f=[];for(m=this.c;;){const y=$.cmp(m.segment);if(y>0)m.left||(m.left=new N,m.left.segment=$.value()),f.push([_.Left,m]),m=m.left;else if(y<0)m.right||(m.right=new N,m.right.segment=$.value()),f.push([_.Right,m]),m=m.right;else if($.hasNext())$.next(),m.mid||(m.mid=new N,m.mid.segment=$.value()),f.push([_.Mid,m]),m=m.mid;else break}const w=m.value;m.value=s,m.key=o;for(let y=f.length-1;y>=0;y--){const r=f[y][1];r.updateHeight();const n=r.balanceFactor();if(n<-1||n>1){const i=f[y][0],l=f[y+1][0];if(i===_.Right&&l===_.Right)f[y][1]=r.rotateLeft();else if(i===_.Left&&l===_.Left)f[y][1]=r.rotateRight();else if(i===_.Right&&l===_.Left)r.right=f[y+1][1]=f[y+1][1].rotateRight(),f[y][1]=r.rotateLeft();else if(i===_.Left&&l===_.Right)r.left=f[y+1][1]=f[y+1][1].rotateLeft(),f[y][1]=r.rotateRight();else throw new Error;if(y>0)switch(f[y-1][0]){case _.Left:f[y-1][1].left=f[y][1];break;case _.Right:f[y-1][1].right=f[y][1];break;case _.Mid:f[y-1][1].mid=f[y][1];break}else this.c=f[0][1]}}return w}get(o){return this.d(o)?.value}d(o){const s=this.b.reset(o);let $=this.c;for(;$;){const m=s.cmp($.segment);if(m>0)$=$.left;else if(m<0)$=$.right;else if(s.hasNext())s.next(),$=$.mid;else break}return $}has(o){const s=this.d(o);return!(s?.value===void 0&&s?.mid===void 0)}delete(o){return this.e(o,!1)}deleteSuperstr(o){return this.e(o,!0)}e(o,s){const $=this.b.reset(o),m=[];let f=this.c;for(;f;){const w=$.cmp(f.segment);if(w>0)m.push([_.Left,f]),f=f.left;else if(w<0)m.push([_.Right,f]),f=f.right;else if($.hasNext())$.next(),m.push([_.Mid,f]),f=f.mid;else break}if(f){if(s?(f.left=void 0,f.mid=void 0,f.right=void 0,f.height=1):(f.key=void 0,f.value=void 0),!f.mid&&!f.value)if(f.left&&f.right){const w=this.f(f.right);if(w.key){const{key:y,value:r,segment:n}=w;this.e(w.key,!1),f.key=y,f.value=r,f.segment=n}}else{const w=f.left??f.right;if(m.length>0){const[y,r]=m[m.length-1];switch(y){case _.Left:r.left=w;break;case _.Mid:r.mid=w;break;case _.Right:r.right=w;break}}else this.c=w}for(let w=m.length-1;w>=0;w--){const y=m[w][1];y.updateHeight();const r=y.balanceFactor();if(r>1?(y.right.balanceFactor()>=0||(y.right=y.right.rotateRight()),m[w][1]=y.rotateLeft()):r<-1&&(y.left.balanceFactor()<=0||(y.left=y.left.rotateLeft()),m[w][1]=y.rotateRight()),w>0)switch(m[w-1][0]){case _.Left:m[w-1][1].left=m[w][1];break;case _.Right:m[w-1][1].right=m[w][1];break;case _.Mid:m[w-1][1].mid=m[w][1];break}else this.c=m[0][1]}}}f(o){for(;o.left;)o=o.left;return o}findSubstr(o){const s=this.b.reset(o);let $=this.c,m;for(;$;){const f=s.cmp($.segment);if(f>0)$=$.left;else if(f<0)$=$.right;else if(s.hasNext())s.next(),m=$.value||m,$=$.mid;else break}return $&&$.value||m}findSuperstr(o){return this.g(o,!1)}g(o,s){const $=this.b.reset(o);let m=this.c;for(;m;){const f=$.cmp(m.segment);if(f>0)m=m.left;else if(f<0)m=m.right;else if($.hasNext())$.next(),m=m.mid;else return m.mid?this.h(m.mid):s?m.value:void 0}}hasElementOrSubtree(o){return this.g(o,!0)!==void 0}forEach(o){for(const[s,$]of this)o($,s)}*[Symbol.iterator](){yield*this.h(this.c)}h(o){const s=[];return this.j(o,s),s[Symbol.iterator]()}j(o,s){o&&(o.left&&this.j(o.left,s),o.value&&s.push([o.key,o.value]),o.mid&&this.j(o.mid,s),o.right&&this.j(o.right,s))}_isBalanced(){const o=s=>{if(!s)return!0;const $=s.balanceFactor();return $<-1||$>1?!1:o(s.left)&&o(s.right)};return o(this.c)}}e.$Mi=v}),define(_e[29],Ee([0,1]),function(ae,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$RX=g;function g(t){return!!t.parentPort}}),define(_e[49],Ee([30,31]),function(ae,e){return ae.create("vs/base/common/errorMessage",e)}),define(_e[50],Ee([0,1,12,10,49]),function(ae,e,g,t,W){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rj=U,e.$sj=P,e.$tj=N,g=Le(g),t=Le(t),W=Le(W);function M(_,v){return v&&(_.stack||_.stacktrace)?W.localize(0,null,F(_),Y(_.stack)||Y(_.stacktrace)):F(_)}function Y(_){return Array.isArray(_)?_.join(`
`):_}function F(_){return _.code==="ERR_UNC_HOST_NOT_ALLOWED"?`${_.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`:typeof _.code=="string"&&typeof _.errno=="number"&&typeof _.syscall=="string"?W.localize(1,null,_.message):_.message||W.localize(2,null)}function U(_=null,v=!1){if(!_)return W.localize(3,null);if(Array.isArray(_)){const k=g.$Kb(_),o=U(k[0],v);return k.length>1?W.localize(4,null,o,k.length):o}if(t.$gg(_))return _;if(_.detail){const k=_.detail;if(k.error)return M(k.error,v);if(k.exception)return M(k.exception,v)}return _.stack?M(_,v):_.message?_.message:W.localize(5,null)}function P(_){const v=_;return v instanceof Error&&Array.isArray(v.actions)}function N(_,v){let k;return typeof _=="string"?k=new Error(_):k=_,k.actions=v,k}}),define(_e[51],Ee([30,31]),function(ae,e){return ae.create("vs/base/common/platform",e)}),define(_e[2],Ee([0,1,51]),function(ae,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$I=e.$H=e.$G=e.$F=e.$E=e.OS=e.OperatingSystem=e.$B=e.$A=e.$z=e.$y=e.$x=e.Language=e.$w=e.$v=e.$u=e.$t=e.$s=e.$r=e.$q=e.$p=e.$o=e.$n=e.$m=e.$l=e.$k=e.$j=e.$i=e.Platform=e.$g=void 0,e.$h=i,e.$D=u,e.$J=S,g=Le(g),e.$g="en";let t=!1,W=!1,M=!1,Y=!1,F=!1,U=!1,P=!1,N=!1,_=!1,v=!1,k,o=e.$g,s=e.$g,$,m;const f=globalThis;let w;typeof f.vscode<"u"&&typeof f.vscode.process<"u"?w=f.vscode.process:typeof process<"u"&&typeof process?.versions?.node=="string"&&(w=process);const y=typeof w?.versions?.electron=="string",r=y&&w?.type==="renderer";if(typeof w=="object"){t=w.platform==="win32",W=w.platform==="darwin",M=w.platform==="linux",Y=M&&!!w.env.SNAP&&!!w.env.SNAP_REVISION,P=y,_=!!w.env.CI||!!w.env.BUILD_ARTIFACTSTAGINGDIRECTORY,k=e.$g,o=e.$g;const R=w.env.VSCODE_NLS_CONFIG;if(R)try{const b=JSON.parse(R),d=b.availableLanguages["*"];k=b.locale,s=b.osLocale,o=d||e.$g,$=b._translationsConfigFile}catch{}F=!0}else typeof navigator=="object"&&!r?(m=navigator.userAgent,t=m.indexOf("Windows")>=0,W=m.indexOf("Macintosh")>=0,N=(m.indexOf("Macintosh")>=0||m.indexOf("iPad")>=0||m.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,M=m.indexOf("Linux")>=0,v=m?.indexOf("Mobi")>=0,U=!0,k=g.getConfiguredDefaultLocale(g.localize(0,null))||e.$g,o=k,s=navigator.language):console.error("Unable to resolve platform.");var n;(function(R){R[R.Web=0]="Web",R[R.Mac=1]="Mac",R[R.Linux=2]="Linux",R[R.Windows=3]="Windows"})(n||(e.Platform=n={}));function i(R){switch(R){case n.Web:return"Web";case n.Mac:return"Mac";case n.Linux:return"Linux";case n.Windows:return"Windows"}}let l=n.Web;W?l=n.Mac:t?l=n.Windows:M&&(l=n.Linux),e.$i=t,e.$j=W,e.$k=M,e.$l=Y,e.$m=F,e.$n=P,e.$o=U,e.$p=U&&typeof f.importScripts=="function",e.$q=e.$p?f.origin:void 0,e.$r=N,e.$s=v,e.$t=_,e.$u=l,e.$v=m,e.$w=o;var c;(function(R){function b(){return e.$w}R.value=b;function d(){return e.$w.length===2?e.$w==="en":e.$w.length>=3?e.$w[0]==="e"&&e.$w[1]==="n"&&e.$w[2]==="-":!1}R.isDefaultVariant=d;function K(){return e.$w==="en"}R.isDefault=K})(c||(e.Language=c={})),e.$x=k,e.$y=s,e.$z=$,e.$A=typeof f.postMessage=="function"&&!f.importScripts,e.$B=(()=>{if(e.$A){const R=[];f.addEventListener("message",d=>{if(d.data&&d.data.vscodeScheduleAsyncWork)for(let K=0,ie=R.length;K<ie;K++){const ee=R[K];if(ee.id===d.data.vscodeScheduleAsyncWork){R.splice(K,1),ee.callback();return}}});let b=0;return d=>{const K=++b;R.push({id:K,callback:d}),f.postMessage({vscodeScheduleAsyncWork:K},"*")}}return R=>setTimeout(R)})();var O;(function(R){R[R.Windows=1]="Windows",R[R.Macintosh=2]="Macintosh",R[R.Linux=3]="Linux"})(O||(e.OperatingSystem=O={})),e.OS=W||N?O.Macintosh:t?O.Windows:O.Linux;let h=!0,A=!1;function u(){if(!A){A=!0;const R=new Uint8Array(2);R[0]=1,R[1]=2,h=new Uint16Array(R.buffer)[0]===513}return h}e.$E=!!(e.$v&&e.$v.indexOf("Chrome")>=0),e.$F=!!(e.$v&&e.$v.indexOf("Firefox")>=0),e.$G=!!(!e.$E&&e.$v&&e.$v.indexOf("Safari")>=0),e.$H=!!(e.$v&&e.$v.indexOf("Edg/")>=0),e.$I=!!(e.$v&&e.$v.indexOf("Android")>=0);function S(R){return parseFloat(R)>=20}}),define(_e[32],Ee([0,1,2]),function(ae,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hc=e.$gc=e.env=e.cwd=void 0;let t;const W=globalThis.vscode;if(typeof W<"u"&&typeof W.process<"u"){const M=W.process;t={get platform(){return M.platform},get arch(){return M.arch},get env(){return M.env},cwd(){return M.cwd()}}}else typeof process<"u"?t={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:t={get platform(){return g.$i?"win32":g.$j?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};e.cwd=t.cwd,e.env=t.env,e.$gc=t.platform,e.$hc=t.arch}),define(_e[3],Ee([0,1,32]),function(ae,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wc=e.sep=e.$uc=e.$tc=e.$sc=e.$rc=e.$qc=e.$pc=e.$oc=e.$nc=e.$mc=e.$lc=e.$kc=e.$jc=e.$ic=void 0,g=Le(g);const t=65,W=97,M=90,Y=122,F=46,U=47,P=92,N=58,_=63;class v extends Error{constructor(i,l,c){let O;typeof l=="string"&&l.indexOf("not ")===0?(O="must not be",l=l.replace(/^not /,"")):O="must be";const h=i.indexOf(".")!==-1?"property":"argument";let A=`The "${i}" ${h} ${O} of type ${l}`;A+=`. Received type ${typeof c}`,super(A),this.code="ERR_INVALID_ARG_TYPE"}}function k(n,i){if(n===null||typeof n!="object")throw new v(i,"Object",n)}function o(n,i){if(typeof n!="string")throw new v(i,"string",n)}const s=g.$gc==="win32";function $(n){return n===U||n===P}function m(n){return n===U}function f(n){return n>=t&&n<=M||n>=W&&n<=Y}function w(n,i,l,c){let O="",h=0,A=-1,u=0,S=0;for(let R=0;R<=n.length;++R){if(R<n.length)S=n.charCodeAt(R);else{if(c(S))break;S=U}if(c(S)){if(!(A===R-1||u===1))if(u===2){if(O.length<2||h!==2||O.charCodeAt(O.length-1)!==F||O.charCodeAt(O.length-2)!==F){if(O.length>2){const b=O.lastIndexOf(l);b===-1?(O="",h=0):(O=O.slice(0,b),h=O.length-1-O.lastIndexOf(l)),A=R,u=0;continue}else if(O.length!==0){O="",h=0,A=R,u=0;continue}}i&&(O+=O.length>0?`${l}..`:"..",h=2)}else O.length>0?O+=`${l}${n.slice(A+1,R)}`:O=n.slice(A+1,R),h=R-A-1;A=R,u=0}else S===F&&u!==-1?++u:u=-1}return O}function y(n,i){k(i,"pathObject");const l=i.dir||i.root,c=i.base||`${i.name||""}${i.ext||""}`;return l?l===i.root?`${l}${c}`:`${l}${n}${c}`:c}e.$ic={resolve(...n){let i="",l="",c=!1;for(let O=n.length-1;O>=-1;O--){let h;if(O>=0){if(h=n[O],o(h,"path"),h.length===0)continue}else i.length===0?h=g.cwd():(h=g.env[`=${i}`]||g.cwd(),(h===void 0||h.slice(0,2).toLowerCase()!==i.toLowerCase()&&h.charCodeAt(2)===P)&&(h=`${i}\\`));const A=h.length;let u=0,S="",R=!1;const b=h.charCodeAt(0);if(A===1)$(b)&&(u=1,R=!0);else if($(b))if(R=!0,$(h.charCodeAt(1))){let d=2,K=d;for(;d<A&&!$(h.charCodeAt(d));)d++;if(d<A&&d!==K){const ie=h.slice(K,d);for(K=d;d<A&&$(h.charCodeAt(d));)d++;if(d<A&&d!==K){for(K=d;d<A&&!$(h.charCodeAt(d));)d++;(d===A||d!==K)&&(S=`\\\\${ie}\\${h.slice(K,d)}`,u=d)}}}else u=1;else f(b)&&h.charCodeAt(1)===N&&(S=h.slice(0,2),u=2,A>2&&$(h.charCodeAt(2))&&(R=!0,u=3));if(S.length>0)if(i.length>0){if(S.toLowerCase()!==i.toLowerCase())continue}else i=S;if(c){if(i.length>0)break}else if(l=`${h.slice(u)}\\${l}`,c=R,R&&i.length>0)break}return l=w(l,!c,"\\",$),c?`${i}\\${l}`:`${i}${l}`||"."},normalize(n){o(n,"path");const i=n.length;if(i===0)return".";let l=0,c,O=!1;const h=n.charCodeAt(0);if(i===1)return m(h)?"\\":n;if($(h))if(O=!0,$(n.charCodeAt(1))){let u=2,S=u;for(;u<i&&!$(n.charCodeAt(u));)u++;if(u<i&&u!==S){const R=n.slice(S,u);for(S=u;u<i&&$(n.charCodeAt(u));)u++;if(u<i&&u!==S){for(S=u;u<i&&!$(n.charCodeAt(u));)u++;if(u===i)return`\\\\${R}\\${n.slice(S)}\\`;u!==S&&(c=`\\\\${R}\\${n.slice(S,u)}`,l=u)}}}else l=1;else f(h)&&n.charCodeAt(1)===N&&(c=n.slice(0,2),l=2,i>2&&$(n.charCodeAt(2))&&(O=!0,l=3));let A=l<i?w(n.slice(l),!O,"\\",$):"";return A.length===0&&!O&&(A="."),A.length>0&&$(n.charCodeAt(i-1))&&(A+="\\"),c===void 0?O?`\\${A}`:A:O?`${c}\\${A}`:`${c}${A}`},isAbsolute(n){o(n,"path");const i=n.length;if(i===0)return!1;const l=n.charCodeAt(0);return $(l)||i>2&&f(l)&&n.charCodeAt(1)===N&&$(n.charCodeAt(2))},join(...n){if(n.length===0)return".";let i,l;for(let h=0;h<n.length;++h){const A=n[h];o(A,"path"),A.length>0&&(i===void 0?i=l=A:i+=`\\${A}`)}if(i===void 0)return".";let c=!0,O=0;if(typeof l=="string"&&$(l.charCodeAt(0))){++O;const h=l.length;h>1&&$(l.charCodeAt(1))&&(++O,h>2&&($(l.charCodeAt(2))?++O:c=!1))}if(c){for(;O<i.length&&$(i.charCodeAt(O));)O++;O>=2&&(i=`\\${i.slice(O)}`)}return e.$ic.normalize(i)},relative(n,i){if(o(n,"from"),o(i,"to"),n===i)return"";const l=e.$ic.resolve(n),c=e.$ic.resolve(i);if(l===c||(n=l.toLowerCase(),i=c.toLowerCase(),n===i))return"";let O=0;for(;O<n.length&&n.charCodeAt(O)===P;)O++;let h=n.length;for(;h-1>O&&n.charCodeAt(h-1)===P;)h--;const A=h-O;let u=0;for(;u<i.length&&i.charCodeAt(u)===P;)u++;let S=i.length;for(;S-1>u&&i.charCodeAt(S-1)===P;)S--;const R=S-u,b=A<R?A:R;let d=-1,K=0;for(;K<b;K++){const ee=n.charCodeAt(O+K);if(ee!==i.charCodeAt(u+K))break;ee===P&&(d=K)}if(K!==b){if(d===-1)return c}else{if(R>b){if(i.charCodeAt(u+K)===P)return c.slice(u+K+1);if(K===2)return c.slice(u+K)}A>b&&(n.charCodeAt(O+K)===P?d=K:K===2&&(d=3)),d===-1&&(d=0)}let ie="";for(K=O+d+1;K<=h;++K)(K===h||n.charCodeAt(K)===P)&&(ie+=ie.length===0?"..":"\\..");return u+=d,ie.length>0?`${ie}${c.slice(u,S)}`:(c.charCodeAt(u)===P&&++u,c.slice(u,S))},toNamespacedPath(n){if(typeof n!="string"||n.length===0)return n;const i=e.$ic.resolve(n);if(i.length<=2)return n;if(i.charCodeAt(0)===P){if(i.charCodeAt(1)===P){const l=i.charCodeAt(2);if(l!==_&&l!==F)return`\\\\?\\UNC\\${i.slice(2)}`}}else if(f(i.charCodeAt(0))&&i.charCodeAt(1)===N&&i.charCodeAt(2)===P)return`\\\\?\\${i}`;return n},dirname(n){o(n,"path");const i=n.length;if(i===0)return".";let l=-1,c=0;const O=n.charCodeAt(0);if(i===1)return $(O)?n:".";if($(O)){if(l=c=1,$(n.charCodeAt(1))){let u=2,S=u;for(;u<i&&!$(n.charCodeAt(u));)u++;if(u<i&&u!==S){for(S=u;u<i&&$(n.charCodeAt(u));)u++;if(u<i&&u!==S){for(S=u;u<i&&!$(n.charCodeAt(u));)u++;if(u===i)return n;u!==S&&(l=c=u+1)}}}}else f(O)&&n.charCodeAt(1)===N&&(l=i>2&&$(n.charCodeAt(2))?3:2,c=l);let h=-1,A=!0;for(let u=i-1;u>=c;--u)if($(n.charCodeAt(u))){if(!A){h=u;break}}else A=!1;if(h===-1){if(l===-1)return".";h=l}return n.slice(0,h)},basename(n,i){i!==void 0&&o(i,"ext"),o(n,"path");let l=0,c=-1,O=!0,h;if(n.length>=2&&f(n.charCodeAt(0))&&n.charCodeAt(1)===N&&(l=2),i!==void 0&&i.length>0&&i.length<=n.length){if(i===n)return"";let A=i.length-1,u=-1;for(h=n.length-1;h>=l;--h){const S=n.charCodeAt(h);if($(S)){if(!O){l=h+1;break}}else u===-1&&(O=!1,u=h+1),A>=0&&(S===i.charCodeAt(A)?--A===-1&&(c=h):(A=-1,c=u))}return l===c?c=u:c===-1&&(c=n.length),n.slice(l,c)}for(h=n.length-1;h>=l;--h)if($(n.charCodeAt(h))){if(!O){l=h+1;break}}else c===-1&&(O=!1,c=h+1);return c===-1?"":n.slice(l,c)},extname(n){o(n,"path");let i=0,l=-1,c=0,O=-1,h=!0,A=0;n.length>=2&&n.charCodeAt(1)===N&&f(n.charCodeAt(0))&&(i=c=2);for(let u=n.length-1;u>=i;--u){const S=n.charCodeAt(u);if($(S)){if(!h){c=u+1;break}continue}O===-1&&(h=!1,O=u+1),S===F?l===-1?l=u:A!==1&&(A=1):l!==-1&&(A=-1)}return l===-1||O===-1||A===0||A===1&&l===O-1&&l===c+1?"":n.slice(l,O)},format:y.bind(null,"\\"),parse(n){o(n,"path");const i={root:"",dir:"",base:"",ext:"",name:""};if(n.length===0)return i;const l=n.length;let c=0,O=n.charCodeAt(0);if(l===1)return $(O)?(i.root=i.dir=n,i):(i.base=i.name=n,i);if($(O)){if(c=1,$(n.charCodeAt(1))){let d=2,K=d;for(;d<l&&!$(n.charCodeAt(d));)d++;if(d<l&&d!==K){for(K=d;d<l&&$(n.charCodeAt(d));)d++;if(d<l&&d!==K){for(K=d;d<l&&!$(n.charCodeAt(d));)d++;d===l?c=d:d!==K&&(c=d+1)}}}}else if(f(O)&&n.charCodeAt(1)===N){if(l<=2)return i.root=i.dir=n,i;if(c=2,$(n.charCodeAt(2))){if(l===3)return i.root=i.dir=n,i;c=3}}c>0&&(i.root=n.slice(0,c));let h=-1,A=c,u=-1,S=!0,R=n.length-1,b=0;for(;R>=c;--R){if(O=n.charCodeAt(R),$(O)){if(!S){A=R+1;break}continue}u===-1&&(S=!1,u=R+1),O===F?h===-1?h=R:b!==1&&(b=1):h!==-1&&(b=-1)}return u!==-1&&(h===-1||b===0||b===1&&h===u-1&&h===A+1?i.base=i.name=n.slice(A,u):(i.name=n.slice(A,h),i.base=n.slice(A,u),i.ext=n.slice(h,u))),A>0&&A!==c?i.dir=n.slice(0,A-1):i.dir=i.root,i},sep:"\\",delimiter:";",win32:null,posix:null};const r=(()=>{if(s){const n=/\\/g;return()=>{const i=g.cwd().replace(n,"/");return i.slice(i.indexOf("/"))}}return()=>g.cwd()})();e.$jc={resolve(...n){let i="",l=!1;for(let c=n.length-1;c>=-1&&!l;c--){const O=c>=0?n[c]:r();o(O,"path"),O.length!==0&&(i=`${O}/${i}`,l=O.charCodeAt(0)===U)}return i=w(i,!l,"/",m),l?`/${i}`:i.length>0?i:"."},normalize(n){if(o(n,"path"),n.length===0)return".";const i=n.charCodeAt(0)===U,l=n.charCodeAt(n.length-1)===U;return n=w(n,!i,"/",m),n.length===0?i?"/":l?"./":".":(l&&(n+="/"),i?`/${n}`:n)},isAbsolute(n){return o(n,"path"),n.length>0&&n.charCodeAt(0)===U},join(...n){if(n.length===0)return".";let i;for(let l=0;l<n.length;++l){const c=n[l];o(c,"path"),c.length>0&&(i===void 0?i=c:i+=`/${c}`)}return i===void 0?".":e.$jc.normalize(i)},relative(n,i){if(o(n,"from"),o(i,"to"),n===i||(n=e.$jc.resolve(n),i=e.$jc.resolve(i),n===i))return"";const l=1,c=n.length,O=c-l,h=1,A=i.length-h,u=O<A?O:A;let S=-1,R=0;for(;R<u;R++){const d=n.charCodeAt(l+R);if(d!==i.charCodeAt(h+R))break;d===U&&(S=R)}if(R===u)if(A>u){if(i.charCodeAt(h+R)===U)return i.slice(h+R+1);if(R===0)return i.slice(h+R)}else O>u&&(n.charCodeAt(l+R)===U?S=R:R===0&&(S=0));let b="";for(R=l+S+1;R<=c;++R)(R===c||n.charCodeAt(R)===U)&&(b+=b.length===0?"..":"/..");return`${b}${i.slice(h+S)}`},toNamespacedPath(n){return n},dirname(n){if(o(n,"path"),n.length===0)return".";const i=n.charCodeAt(0)===U;let l=-1,c=!0;for(let O=n.length-1;O>=1;--O)if(n.charCodeAt(O)===U){if(!c){l=O;break}}else c=!1;return l===-1?i?"/":".":i&&l===1?"//":n.slice(0,l)},basename(n,i){i!==void 0&&o(i,"ext"),o(n,"path");let l=0,c=-1,O=!0,h;if(i!==void 0&&i.length>0&&i.length<=n.length){if(i===n)return"";let A=i.length-1,u=-1;for(h=n.length-1;h>=0;--h){const S=n.charCodeAt(h);if(S===U){if(!O){l=h+1;break}}else u===-1&&(O=!1,u=h+1),A>=0&&(S===i.charCodeAt(A)?--A===-1&&(c=h):(A=-1,c=u))}return l===c?c=u:c===-1&&(c=n.length),n.slice(l,c)}for(h=n.length-1;h>=0;--h)if(n.charCodeAt(h)===U){if(!O){l=h+1;break}}else c===-1&&(O=!1,c=h+1);return c===-1?"":n.slice(l,c)},extname(n){o(n,"path");let i=-1,l=0,c=-1,O=!0,h=0;for(let A=n.length-1;A>=0;--A){const u=n.charCodeAt(A);if(u===U){if(!O){l=A+1;break}continue}c===-1&&(O=!1,c=A+1),u===F?i===-1?i=A:h!==1&&(h=1):i!==-1&&(h=-1)}return i===-1||c===-1||h===0||h===1&&i===c-1&&i===l+1?"":n.slice(i,c)},format:y.bind(null,"/"),parse(n){o(n,"path");const i={root:"",dir:"",base:"",ext:"",name:""};if(n.length===0)return i;const l=n.charCodeAt(0)===U;let c;l?(i.root="/",c=1):c=0;let O=-1,h=0,A=-1,u=!0,S=n.length-1,R=0;for(;S>=c;--S){const b=n.charCodeAt(S);if(b===U){if(!u){h=S+1;break}continue}A===-1&&(u=!1,A=S+1),b===F?O===-1?O=S:R!==1&&(R=1):O!==-1&&(R=-1)}if(A!==-1){const b=h===0&&l?1:h;O===-1||R===0||R===1&&O===A-1&&O===h+1?i.base=i.name=n.slice(b,A):(i.name=n.slice(b,O),i.base=n.slice(b,A),i.ext=n.slice(O,A))}return h>0?i.dir=n.slice(0,h-1):l&&(i.dir="/"),i},sep:"/",delimiter:":",win32:null,posix:null},e.$jc.win32=e.$ic.win32=e.$ic,e.$jc.posix=e.$ic.posix=e.$jc,e.$kc=s?e.$ic.normalize:e.$jc.normalize,e.$lc=s?e.$ic.isAbsolute:e.$jc.isAbsolute,e.$mc=s?e.$ic.join:e.$jc.join,e.$nc=s?e.$ic.resolve:e.$jc.resolve,e.$oc=s?e.$ic.relative:e.$jc.relative,e.$pc=s?e.$ic.dirname:e.$jc.dirname,e.$qc=s?e.$ic.basename:e.$jc.basename,e.$rc=s?e.$ic.extname:e.$jc.extname,e.$sc=s?e.$ic.format:e.$jc.format,e.$tc=s?e.$ic.parse:e.$jc.parse,e.$uc=s?e.$ic.toNamespacedPath:e.$jc.toNamespacedPath,e.sep=s?e.$ic.sep:e.$jc.sep,e.$wc=s?e.$ic.delimiter:e.$jc.delimiter}),define(_e[14],Ee([0,1,11,3,2,7,10]),function(ae,e,g,t,W,M,Y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yg=F,e.$zg=U,e.$Ag=P,e.$Bg=N,e.$Cg=_,e.$Dg=s,e.$Eg=$,e.$Fg=m,e.$Gg=f,e.$Hg=w,e.$Ig=y,e.$Jg=r,e.$Kg=n,e.$Lg=i,e.$Mg=l,e.$Ng=c,e.$Og=A;function F(u){return u===g.CharCode.Slash||u===g.CharCode.Backslash}function U(u){return u.replace(/[\\/]/g,t.$jc.sep)}function P(u){return u.indexOf("/")===-1&&(u=U(u)),/^[a-zA-Z]:(\/|$)/.test(u)&&(u="/"+u),u}function N(u,S=t.$jc.sep){if(!u)return"";const R=u.length,b=u.charCodeAt(0);if(F(b)){if(F(u.charCodeAt(1))&&!F(u.charCodeAt(2))){let K=3;const ie=K;for(;K<R&&!F(u.charCodeAt(K));K++);if(ie!==K&&!F(u.charCodeAt(K+1))){for(K+=1;K<R;K++)if(F(u.charCodeAt(K)))return u.slice(0,K+1).replace(/[\\/]/g,S)}}return S}else if(f(b)&&u.charCodeAt(1)===g.CharCode.Colon)return F(u.charCodeAt(2))?u.slice(0,2)+S:u.slice(0,2);let d=u.indexOf("://");if(d!==-1){for(d+=3;d<R;d++)if(F(u.charCodeAt(d)))return u.slice(0,d+1)}return""}function _(u){if(!W.$i||!u||u.length<5)return!1;let S=u.charCodeAt(0);if(S!==g.CharCode.Backslash||(S=u.charCodeAt(1),S!==g.CharCode.Backslash))return!1;let R=2;const b=R;for(;R<u.length&&(S=u.charCodeAt(R),S!==g.CharCode.Backslash);R++);return!(b===R||(S=u.charCodeAt(R+1),isNaN(S)||S===g.CharCode.Backslash))}const v=/[\\/:\*\?"<>\|]/g,k=/[/]/g,o=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function s(u,S=W.$i){const R=S?v:k;return!(!u||u.length===0||/^\s+$/.test(u)||(R.lastIndex=0,R.test(u))||S&&o.test(u)||u==="."||u===".."||S&&u[u.length-1]==="."||S&&u.length!==u.trim().length||u.length>255)}function $(u,S,R){const b=u===S;return!R||b?b:!u||!S?!1:(0,M.$Hf)(u,S)}function m(u,S,R,b=t.sep){if(u===S)return!0;if(!u||!S||S.length>u.length)return!1;if(R){if(!(0,M.$If)(u,S))return!1;if(S.length===u.length)return!0;let K=S.length;return S.charAt(S.length-1)===b&&K--,u.charAt(K)===b}return S.charAt(S.length-1)!==b&&(S+=b),u.indexOf(S)===0}function f(u){return u>=g.CharCode.A&&u<=g.CharCode.Z||u>=g.CharCode.a&&u<=g.CharCode.z}function w(u,S){return W.$i&&u.endsWith(":")&&(u+=t.sep),(0,t.$lc)(u)||(u=(0,t.$mc)(S,u)),u=(0,t.$kc)(u),y(u)}function y(u){return W.$i?(u=(0,M.$pf)(u,t.sep),u.endsWith(":")&&(u+=t.sep)):(u=(0,M.$pf)(u,t.sep),u||(u=t.sep)),u}function r(u){const S=(0,t.$kc)(u);return W.$i?u.length>3?!1:n(S)&&(u.length===2||S.charCodeAt(2)===g.CharCode.Backslash):S===t.$jc.sep}function n(u,S=W.$i){return S?f(u.charCodeAt(0))&&u.charCodeAt(1)===g.CharCode.Colon:!1}function i(u,S=W.$i){return n(u,S)?u[0]:void 0}function l(u,S,R){return S.length>u.length?-1:u===S?0:(R&&(u=u.toLowerCase(),S=S.toLowerCase()),u.indexOf(S))}function c(u){const S=u.split(":");let R,b,d;for(const K of S){const ie=Number(K);(0,Y.$kg)(ie)?b===void 0?b=ie:d===void 0&&(d=ie):R=R?[R,K].join(":"):K}if(!R)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:R,line:b!==void 0?b:void 0,column:d!==void 0?d:b!==void 0?1:void 0}}const O="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",h="BDEFGHIJKMOQRSTUVWXYZbdefghijkmoqrstuvwxyz0123456789";function A(u,S,R=8){let b="";for(let K=0;K<R;K++){let ie;K===0&&W.$i&&!S&&(R===3||R===4)?ie=h:ie=O,b+=ie.charAt(Math.floor(Math.random()*ie.length))}let d;return S?d=`${S}-${b}`:d=b,u?(0,t.$mc)(u,d):d}}),define(_e[33],Ee([0,1,2]),function(ae,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminateResponseCode=e.Source=void 0,e.$lm=M,e.$mm=Y;var t;(function(F){F[F.stdout=0]="stdout",F[F.stderr=1]="stderr"})(t||(e.Source=t={}));var W;(function(F){F[F.Success=0]="Success",F[F.Unknown=1]="Unknown",F[F.AccessDenied=2]="AccessDenied",F[F.ProcessNotFound=3]="ProcessNotFound"})(W||(e.TerminateResponseCode=W={}));function M(F,...U){const P=U.reduce((v,k)=>(v[k]=!0,v),{}),N=[/^ELECTRON_.+$/,/^VSCODE_(?!(PORTABLE|SHELL_LOGIN|ENV_REPLACE|ENV_APPEND|ENV_PREPEND)).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(F).filter(v=>!P[v]).forEach(v=>{for(let k=0;k<N.length;k++)if(v.search(N[k])!==-1){delete F[v];break}})}function Y(F){F&&(delete F.DEBUG,g.$j&&delete F.DYLD_LIBRARY_PATH,g.$k&&delete F.LD_PRELOAD)}}),define(_e[5],Ee([0,1,11,27,3,2]),function(ae,e,g,t,W,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URI=void 0,e.$yc=$,e.$zc=n,W=Le(W);const Y=/^\w[\w\d+.-]*$/,F=/^\//,U=/^\/\//;function P(h,A){if(!h.scheme&&A)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${h.authority}", path: "${h.path}", query: "${h.query}", fragment: "${h.fragment}"}`);if(h.scheme&&!Y.test(h.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(h.path){if(h.authority){if(!F.test(h.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(U.test(h.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function N(h,A){return!h&&!A?"file":h}function _(h,A){switch(h){case"https":case"http":case"file":A?A[0]!==k&&(A=k+A):A=k;break}return A}const v="",k="/",o=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class s{static isUri(A){return A instanceof s?!0:A?typeof A.authority=="string"&&typeof A.fragment=="string"&&typeof A.path=="string"&&typeof A.query=="string"&&typeof A.scheme=="string"&&typeof A.fsPath=="string"&&typeof A.with=="function"&&typeof A.toString=="function":!1}constructor(A,u,S,R,b,d=!1){typeof A=="object"?(this.scheme=A.scheme||v,this.authority=A.authority||v,this.path=A.path||v,this.query=A.query||v,this.fragment=A.fragment||v):(this.scheme=N(A,d),this.authority=u||v,this.path=_(this.scheme,S||v),this.query=R||v,this.fragment=b||v,P(this,d))}get fsPath(){return n(this,!1)}with(A){if(!A)return this;let{scheme:u,authority:S,path:R,query:b,fragment:d}=A;return u===void 0?u=this.scheme:u===null&&(u=v),S===void 0?S=this.authority:S===null&&(S=v),R===void 0?R=this.path:R===null&&(R=v),b===void 0?b=this.query:b===null&&(b=v),d===void 0?d=this.fragment:d===null&&(d=v),u===this.scheme&&S===this.authority&&R===this.path&&b===this.query&&d===this.fragment?this:new f(u,S,R,b,d)}static parse(A,u=!1){const S=o.exec(A);return S?new f(S[2]||v,O(S[4]||v),O(S[5]||v),O(S[7]||v),O(S[9]||v),u):new f(v,v,v,v,v)}static file(A){let u=v;if(M.$i&&(A=A.replace(/\\/g,k)),A[0]===k&&A[1]===k){const S=A.indexOf(k,2);S===-1?(u=A.substring(2),A=k):(u=A.substring(2,S),A=A.substring(S)||k)}return new f("file",u,A,v,v)}static from(A,u){return new f(A.scheme,A.authority,A.path,A.query,A.fragment,u)}static joinPath(A,...u){if(!A.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let S;return M.$i&&A.scheme==="file"?S=s.file(W.$ic.join(n(A,!0),...u)).path:S=W.$jc.join(A.path,...u),A.with({path:S})}toString(A=!1){return i(this,A)}toJSON(){return this}static revive(A){if(A){if(A instanceof s)return A;{const u=new f(A);return u._formatted=A.external??null,u._fsPath=A._sep===m?A.fsPath??null:null,u}}else return A}}e.URI=s;function $(h){return!h||typeof h!="object"?!1:typeof h.scheme=="string"&&(typeof h.authority=="string"||typeof h.authority>"u")&&(typeof h.path=="string"||typeof h.path>"u")&&(typeof h.query=="string"||typeof h.query>"u")&&(typeof h.fragment=="string"||typeof h.fragment>"u")}const m=M.$i?1:void 0;class f extends s{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=n(this,!1)),this._fsPath}toString(A=!1){return A?i(this,!0):(this._formatted||(this._formatted=i(this,!1)),this._formatted)}toJSON(){const A={$mid:t.MarshalledId.Uri};return this._fsPath&&(A.fsPath=this._fsPath,A._sep=m),this._formatted&&(A.external=this._formatted),this.path&&(A.path=this.path),this.scheme&&(A.scheme=this.scheme),this.authority&&(A.authority=this.authority),this.query&&(A.query=this.query),this.fragment&&(A.fragment=this.fragment),A}}const w={[g.CharCode.Colon]:"%3A",[g.CharCode.Slash]:"%2F",[g.CharCode.QuestionMark]:"%3F",[g.CharCode.Hash]:"%23",[g.CharCode.OpenSquareBracket]:"%5B",[g.CharCode.CloseSquareBracket]:"%5D",[g.CharCode.AtSign]:"%40",[g.CharCode.ExclamationMark]:"%21",[g.CharCode.DollarSign]:"%24",[g.CharCode.Ampersand]:"%26",[g.CharCode.SingleQuote]:"%27",[g.CharCode.OpenParen]:"%28",[g.CharCode.CloseParen]:"%29",[g.CharCode.Asterisk]:"%2A",[g.CharCode.Plus]:"%2B",[g.CharCode.Comma]:"%2C",[g.CharCode.Semicolon]:"%3B",[g.CharCode.Equals]:"%3D",[g.CharCode.Space]:"%20"};function y(h,A,u){let S,R=-1;for(let b=0;b<h.length;b++){const d=h.charCodeAt(b);if(d>=g.CharCode.a&&d<=g.CharCode.z||d>=g.CharCode.A&&d<=g.CharCode.Z||d>=g.CharCode.Digit0&&d<=g.CharCode.Digit9||d===g.CharCode.Dash||d===g.CharCode.Period||d===g.CharCode.Underline||d===g.CharCode.Tilde||A&&d===g.CharCode.Slash||u&&d===g.CharCode.OpenSquareBracket||u&&d===g.CharCode.CloseSquareBracket||u&&d===g.CharCode.Colon)R!==-1&&(S+=encodeURIComponent(h.substring(R,b)),R=-1),S!==void 0&&(S+=h.charAt(b));else{S===void 0&&(S=h.substr(0,b));const K=w[d];K!==void 0?(R!==-1&&(S+=encodeURIComponent(h.substring(R,b)),R=-1),S+=K):R===-1&&(R=b)}}return R!==-1&&(S+=encodeURIComponent(h.substring(R))),S!==void 0?S:h}function r(h){let A;for(let u=0;u<h.length;u++){const S=h.charCodeAt(u);S===g.CharCode.Hash||S===g.CharCode.QuestionMark?(A===void 0&&(A=h.substr(0,u)),A+=w[S]):A!==void 0&&(A+=h[u])}return A!==void 0?A:h}function n(h,A){let u;return h.authority&&h.path.length>1&&h.scheme==="file"?u=`//${h.authority}${h.path}`:h.path.charCodeAt(0)===g.CharCode.Slash&&(h.path.charCodeAt(1)>=g.CharCode.A&&h.path.charCodeAt(1)<=g.CharCode.Z||h.path.charCodeAt(1)>=g.CharCode.a&&h.path.charCodeAt(1)<=g.CharCode.z)&&h.path.charCodeAt(2)===g.CharCode.Colon?A?u=h.path.substr(1):u=h.path[1].toLowerCase()+h.path.substr(2):u=h.path,M.$i&&(u=u.replace(/\//g,"\\")),u}function i(h,A){const u=A?r:y;let S="",{scheme:R,authority:b,path:d,query:K,fragment:ie}=h;if(R&&(S+=R,S+=":"),(b||R==="file")&&(S+=k,S+=k),b){let ee=b.indexOf("@");if(ee!==-1){const V=b.substr(0,ee);b=b.substr(ee+1),ee=V.lastIndexOf(":"),ee===-1?S+=u(V,!1,!1):(S+=u(V.substr(0,ee),!1,!1),S+=":",S+=u(V.substr(ee+1),!1,!0)),S+="@"}b=b.toLowerCase(),ee=b.lastIndexOf(":"),ee===-1?S+=u(b,!1,!0):(S+=u(b.substr(0,ee),!1,!0),S+=b.substr(ee))}if(d){if(d.length>=3&&d.charCodeAt(0)===g.CharCode.Slash&&d.charCodeAt(2)===g.CharCode.Colon){const ee=d.charCodeAt(1);ee>=g.CharCode.A&&ee<=g.CharCode.Z&&(d=`/${String.fromCharCode(ee+32)}:${d.substr(3)}`)}else if(d.length>=2&&d.charCodeAt(1)===g.CharCode.Colon){const ee=d.charCodeAt(0);ee>=g.CharCode.A&&ee<=g.CharCode.Z&&(d=`${String.fromCharCode(ee+32)}:${d.substr(2)}`)}S+=u(d,!0,!1)}return K&&(S+="?",S+=u(K,!1,!1)),ie&&(S+="#",S+=A?ie:y(ie,!1,!1)),S}function l(h){try{return decodeURIComponent(h)}catch{return h.length>3?h.substr(0,3)+l(h.substr(3)):h}}const c=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function O(h){return h.match(c)?h.replace(c,A=>l(A)):h}}),define(_e[52],Ee([0,1,5]),function(ae,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$br=t,e.$cr=W,e.$dr=M,e.log=F;function t(P){const N=P;return N&&typeof N.type=="string"&&typeof N.severity=="string"}function W(P){const N=[];let _;try{const v=JSON.parse(P.arguments),k=v[v.length-1];k&&k.__$stack&&(v.pop(),_=k.__$stack),N.push(...v)}catch{N.push("Unable to log remote console arguments",P.arguments)}return{args:N,stack:_}}function M(P){if(typeof P!="string")return M(W(P).stack);const N=P;if(N){const _=Y(N),v=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(_||"");if(v&&v.length===4)return{uri:g.URI.file(v[1]),line:Number(v[2]),column:Number(v[3])}}}function Y(P){if(!P)return P;const N=P.indexOf(`
`);return N===-1?P:P.substring(0,N)}function F(P,N){const{args:_,stack:v}=W(P),k=typeof _[0]=="string"&&_.length===1;let o=Y(v);o&&(o=`(${o.trim()})`);let s=[];if(typeof _[0]=="string"?o&&k?s=[`%c[${N}] %c${_[0]} %c${o}`,U("blue"),U(""),U("grey")]:s=[`%c[${N}] %c${_[0]}`,U("blue"),U(""),..._.slice(1)]:s=[`%c[${N}]%`,U("blue"),..._],o&&!k&&s.push(o),typeof console[P.severity]!="function")throw new Error("Unknown console method");console[P.severity].apply(console,s)}function U(P){return`color: ${P}`}}),define(_e[53],Ee([0,1,16,5,27]),function(ae,e,g,t,W){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bi=M,e.$ci=Y,e.$di=U;function M(P){return JSON.stringify(P,F)}function Y(P){let N=JSON.parse(P);return N=U(N),N}function F(P,N){return N instanceof RegExp?{$mid:W.MarshalledId.Regexp,source:N.source,flags:N.flags}:N}function U(P,N=0){if(!P||N>200)return P;if(typeof P=="object"){switch(P.$mid){case W.MarshalledId.Uri:return t.URI.revive(P);case W.MarshalledId.Regexp:return new RegExp(P.source,P.flags);case W.MarshalledId.Date:return new Date(P.source)}if(P instanceof g.$Pe||P instanceof Uint8Array)return P;if(Array.isArray(P))for(let _=0;_<P.length;++_)P[_]=U(P[_],N+1);else for(const _ in P)Object.hasOwnProperty.call(P,_)&&(P[_]=U(P[_],N+1))}return P}}),define(_e[34],Ee([0,1,9,2,7,5,3]),function(ae,e,g,t,W,M,Y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.$1g=e.$Zg=e.$Yg=e.$Xg=e.$Wg=e.$Vg=e.$Tg=e.$Sg=e.$Rg=e.Schemas=void 0,e.$Pg=U,e.$Qg=P,e.$Ug=_,g=Le(g),t=Le(t),Y=Le(Y);var F;(function(o){o.inMemory="inmemory",o.vscode="vscode",o.internal="private",o.walkThrough="walkThrough",o.walkThroughSnippet="walkThroughSnippet",o.http="http",o.https="https",o.file="file",o.mailto="mailto",o.untitled="untitled",o.data="data",o.command="command",o.vscodeRemote="vscode-remote",o.vscodeRemoteResource="vscode-remote-resource",o.vscodeManagedRemoteResource="vscode-managed-remote-resource",o.vscodeUserData="vscode-userdata",o.vscodeCustomEditor="vscode-custom-editor",o.vscodeNotebookCell="vscode-notebook-cell",o.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",o.vscodeNotebookCellOutput="vscode-notebook-cell-output",o.vscodeInteractiveInput="vscode-interactive-input",o.vscodeSettings="vscode-settings",o.vscodeWorkspaceTrust="vscode-workspace-trust",o.vscodeTerminal="vscode-terminal",o.vscodeChatCodeBlock="vscode-chat-code-block",o.vscodeCopilotBackingChatCodeBlock="vscode-copilot-chat-code-block",o.vscodeChatCodeCompareBlock="vscode-chat-code-compare-block",o.vscodeChatSesssion="vscode-chat-editor",o.webviewPanel="webview-panel",o.vscodeWebview="vscode-webview",o.extension="extension",o.vscodeFileResource="vscode-file",o.tmp="tmp",o.vsls="vsls",o.vscodeSourceControl="vscode-scm",o.commentsInput="comment",o.codeSetting="code-setting"})(F||(e.Schemas=F={}));function U(o,s){return M.URI.isUri(o)?(0,W.$Hf)(o.scheme,s):(0,W.$If)(o,s+":")}function P(o,...s){return s.some($=>U(o,$))}e.$Rg="vscode-tkn",e.$Sg="tkn";class N{constructor(){this.a=Object.create(null),this.b=Object.create(null),this.c=Object.create(null),this.d="http",this.e=null,this.f="/"}setPreferredWebSchema(s){this.d=s}setDelegate(s){this.e=s}setServerRootPath(s,$){this.f=_(s,$)}getServerRootPath(){return this.f}get g(){return Y.$jc.join(this.f,F.vscodeRemoteResource)}set(s,$,m){this.a[s]=$,this.b[s]=m}setConnectionToken(s,$){this.c[s]=$}getPreferredWebSchema(){return this.d}rewrite(s){if(this.e)try{return this.e(s)}catch(r){return g.$3(r),s}const $=s.authority;let m=this.a[$];m&&m.indexOf(":")!==-1&&m.indexOf("[")===-1&&(m=`[${m}]`);const f=this.b[$],w=this.c[$];let y=`path=${encodeURIComponent(s.path)}`;return typeof w=="string"&&(y+=`&${e.$Sg}=${encodeURIComponent(w)}`),M.URI.from({scheme:t.$o?this.d:F.vscodeRemoteResource,authority:`${m}:${f}`,path:this.g,query:y})}}e.$Tg=new N;function _(o,s){return Y.$jc.join(s??"/",`${o.quality??"oss"}-${o.commit??"dev"}`)}e.$Vg="vs/../../extensions",e.$Wg="vs/../../node_modules",e.$Xg="vs/../../node_modules.asar",e.$Yg="vs/../../node_modules.asar.unpacked",e.$Zg="vscode-app";class v{static{this.a=e.$Zg}asBrowserUri(s){const $=this.b(s,ae);return this.uriToBrowserUri($)}uriToBrowserUri(s){return s.scheme===F.vscodeRemote?e.$Tg.rewrite(s):s.scheme===F.file&&(t.$m||t.$q===`${F.vscodeFileResource}://${v.a}`)?s.with({scheme:F.vscodeFileResource,authority:s.authority||v.a,query:null,fragment:null}):s}asFileUri(s){const $=this.b(s,ae);return this.uriToFileUri($)}uriToFileUri(s){return s.scheme===F.vscodeFileResource?s.with({scheme:F.file,authority:s.authority!==v.a?s.authority:null,query:null,fragment:null}):s}b(s,$){return M.URI.isUri(s)?s:M.URI.parse($.toUrl(s))}}e.$1g=new v;var k;(function(o){const s=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);o.CoopAndCoep=Object.freeze(s.get("3"));const $="vscode-coi";function m(w){let y;typeof w=="string"?y=new URL(w).searchParams:w instanceof URL?y=w.searchParams:M.URI.isUri(w)&&(y=new URL(w.toString(!0)).searchParams);const r=y?.get($);if(r)return s.get(r)}o.getHeadersFromQuery=m;function f(w,y,r){if(!globalThis.crossOriginIsolated)return;const n=y&&r?"3":r?"2":"1";w instanceof URLSearchParams?w.set($,n):w[$]=n}o.addSearchParam=f})(k||(e.COI=k={}))}),define(_e[22],Ee([0,1,11,14,34,3,2,7,5]),function(ae,e,g,t,W,M,Y,F,U){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DataUri=e.$ph=e.$oh=e.$nh=e.$mh=e.$lh=e.$kh=e.$jh=e.$ih=e.$hh=e.$gh=e.$fh=e.$eh=e.$dh=e.$ch=e.$bh=e.$ah=e.$_g=e.$$g=e.$0g=e.$9g=void 0,e.$8g=P,e.$qh=_,e.$rh=k,t=Le(t),M=Le(M);function P(o){return(0,U.$zc)(o,!0)}class N{constructor(s){this.a=s}compare(s,$,m=!1){return s===$?0:(0,F.$Af)(this.getComparisonKey(s,m),this.getComparisonKey($,m))}isEqual(s,$,m=!1){return s===$?!0:!s||!$?!1:this.getComparisonKey(s,m)===this.getComparisonKey($,m)}getComparisonKey(s,$=!1){return s.with({path:this.a(s)?s.path.toLowerCase():void 0,fragment:$?null:void 0}).toString()}ignorePathCasing(s){return this.a(s)}isEqualOrParent(s,$,m=!1){if(s.scheme===$.scheme){if(s.scheme===W.Schemas.file)return t.$Fg(P(s),P($),this.a(s))&&s.query===$.query&&(m||s.fragment===$.fragment);if((0,e.$mh)(s.authority,$.authority))return t.$Fg(s.path,$.path,this.a(s),"/")&&s.query===$.query&&(m||s.fragment===$.fragment)}return!1}joinPath(s,...$){return U.URI.joinPath(s,...$)}basenameOrAuthority(s){return(0,e.$eh)(s)||s.authority}basename(s){return M.$jc.basename(s.path)}extname(s){return M.$jc.extname(s.path)}dirname(s){if(s.path.length===0)return s;let $;return s.scheme===W.Schemas.file?$=U.URI.file(M.$pc(P(s))).path:($=M.$jc.dirname(s.path),s.authority&&$.length&&$.charCodeAt(0)!==g.CharCode.Slash&&(console.error(`dirname("${s.toString})) resulted in a relative path`),$="/")),s.with({path:$})}normalizePath(s){if(!s.path.length)return s;let $;return s.scheme===W.Schemas.file?$=U.URI.file(M.$kc(P(s))).path:$=M.$jc.normalize(s.path),s.with({path:$})}relativePath(s,$){if(s.scheme!==$.scheme||!(0,e.$mh)(s.authority,$.authority))return;if(s.scheme===W.Schemas.file){const w=M.$oc(P(s),P($));return Y.$i?t.$zg(w):w}let m=s.path||"/";const f=$.path||"/";if(this.a(s)){let w=0;for(const y=Math.min(m.length,f.length);w<y&&!(m.charCodeAt(w)!==f.charCodeAt(w)&&m.charAt(w).toLowerCase()!==f.charAt(w).toLowerCase());w++);m=f.substr(0,w)+m.substr(w)}return M.$jc.relative(m,f)}resolvePath(s,$){if(s.scheme===W.Schemas.file){const m=U.URI.file(M.$nc(P(s),$));return s.with({authority:m.authority,path:m.path})}return $=t.$Ag($),s.with({path:M.$jc.resolve(s.path,$)})}isAbsolutePath(s){return!!s.path&&s.path[0]==="/"}isEqualAuthority(s,$){return s===$||s!==void 0&&$!==void 0&&(0,F.$Hf)(s,$)}hasTrailingPathSeparator(s,$=M.sep){if(s.scheme===W.Schemas.file){const m=P(s);return m.length>t.$Bg(m).length&&m[m.length-1]===$}else{const m=s.path;return m.length>1&&m.charCodeAt(m.length-1)===g.CharCode.Slash&&!/^[a-zA-Z]:(\/$|\\$)/.test(s.fsPath)}}removeTrailingPathSeparator(s,$=M.sep){return(0,e.$nh)(s,$)?s.with({path:s.path.substr(0,s.path.length-1)}):s}addTrailingPathSeparator(s,$=M.sep){let m=!1;if(s.scheme===W.Schemas.file){const f=P(s);m=f!==void 0&&f.length===t.$Bg(f).length&&f[f.length-1]===$}else{$="/";const f=s.path;m=f.length===1&&f.charCodeAt(f.length-1)===g.CharCode.Slash}return!m&&!(0,e.$nh)(s,$)?s.with({path:s.path+"/"}):s}}e.$9g=N,e.$0g=new N(()=>!1),e.$$g=new N(o=>o.scheme===W.Schemas.file?!Y.$k:!0),e.$_g=new N(o=>!0),e.$ah=e.$0g.isEqual.bind(e.$0g),e.$bh=e.$0g.isEqualOrParent.bind(e.$0g),e.$ch=e.$0g.getComparisonKey.bind(e.$0g),e.$dh=e.$0g.basenameOrAuthority.bind(e.$0g),e.$eh=e.$0g.basename.bind(e.$0g),e.$fh=e.$0g.extname.bind(e.$0g),e.$gh=e.$0g.dirname.bind(e.$0g),e.$hh=e.$0g.joinPath.bind(e.$0g),e.$ih=e.$0g.normalizePath.bind(e.$0g),e.$jh=e.$0g.relativePath.bind(e.$0g),e.$kh=e.$0g.resolvePath.bind(e.$0g),e.$lh=e.$0g.isAbsolutePath.bind(e.$0g),e.$mh=e.$0g.isEqualAuthority.bind(e.$0g),e.$nh=e.$0g.hasTrailingPathSeparator.bind(e.$0g),e.$oh=e.$0g.removeTrailingPathSeparator.bind(e.$0g),e.$ph=e.$0g.addTrailingPathSeparator.bind(e.$0g);function _(o,s){const $=[];for(let m=0;m<o.length;m++){const f=s(o[m]);o.some((w,y)=>y===m?!1:(0,e.$bh)(f,s(w)))||$.push(o[m])}return $}var v;(function(o){o.META_DATA_LABEL="label",o.META_DATA_DESCRIPTION="description",o.META_DATA_SIZE="size",o.META_DATA_MIME="mime";function s($){const m=new Map;$.path.substring($.path.indexOf(";")+1,$.path.lastIndexOf(";")).split(";").forEach(y=>{const[r,n]=y.split(":");r&&n&&m.set(r,n)});const w=$.path.substring(0,$.path.indexOf(";"));return w&&m.set(o.META_DATA_MIME,w),m}o.parseMetaData=s})(v||(e.DataUri=v={}));function k(o,s,$){if(s){let m=o.path;return m&&m[0]!==M.$jc.sep&&(m=M.$jc.sep+m),o.with({scheme:$,authority:s,path:m})}return o.with({scheme:$})}}),define(_e[8],Ee([0,1,13,9,6,4,22,2,46,15]),function(ae,e,g,t,W,M,Y,F,U,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0h=e.$8h=e.$7h=e.$6h=e.$5h=e.Promises=e.$4h=e.$3h=e.$2h=e.$Zh=e.$Yh=e.$Xh=e.$Wh=e.$Vh=e.$Uh=e.$Th=e.$Sh=e.$Rh=e.$Qh=e.$Ph=e.$Oh=e.$Nh=e.$Mh=e.$Gh=e.$Fh=e.$Eh=e.$Dh=e.$Ch=e.$Bh=e.$Ah=void 0,e.$sh=N,e.$th=_,e.$uh=v,e.$vh=k,e.$wh=o,e.$xh=s,e.$yh=$,e.$zh=m,e.$Hh=h,e.$Ih=A,e.$Jh=u,e.$Kh=S,e.$Lh=R,e.$1h=a,e.$9h=q;function N(j){return!!j&&typeof j.then=="function"}function _(j){const E=new g.$ye,H=j(E.token),J=new Promise((ne,$e)=>{const De=E.token.onCancellationRequested(()=>{De.dispose(),$e(new t.$8)});Promise.resolve(H).then(he=>{De.dispose(),E.dispose(),ne(he)},he=>{De.dispose(),E.dispose(),$e(he)})});return new class{cancel(){E.cancel(),E.dispose()}then(ne,$e){return J.then(ne,$e)}catch(ne){return this.then(void 0,ne)}finally(ne){return J.finally(ne)}}}function v(j,E,H){return new Promise((J,ne)=>{const $e=E.onCancellationRequested(()=>{$e.dispose(),J(H)});j.then(J,ne).finally(()=>$e.dispose())})}function k(j,E){return new Promise((H,J)=>{const ne=E.onCancellationRequested(()=>{ne.dispose(),J(new t.$8)});j.then(H,J).finally(()=>ne.dispose())})}async function o(j){let E=-1;const H=j.map((J,ne)=>J.then($e=>(E=ne,$e)));try{return await Promise.race(H)}finally{j.forEach((J,ne)=>{ne!==E&&J.cancel()})}}function s(j,E,H){let J;const ne=setTimeout(()=>{J?.(void 0),H?.()},E);return Promise.race([j.finally(()=>clearTimeout(ne)),new Promise($e=>J=$e)])}function $(j){return new Promise((E,H)=>{const J=j();N(J)?J.then(E,H):E(J)})}function m(){let j,E;return{promise:new Promise((J,ne)=>{j=J,E=ne}),resolve:j,reject:E}}class f{constructor(){this.f=!1,this.a=null,this.b=null,this.d=null}queue(E){if(this.f)return Promise.reject(new Error("Throttler is disposed"));if(this.a){if(this.d=E,!this.b){const H=()=>{if(this.b=null,this.f)return;const J=this.queue(this.d);return this.d=null,J};this.b=new Promise(J=>{this.a.then(H,H).then(J)})}return new Promise((H,J)=>{this.b.then(H,J)})}return this.a=E(),new Promise((H,J)=>{this.a.then(ne=>{this.a=null,H(ne)},ne=>{this.a=null,J(ne)})})}dispose(){this.f=!0}}e.$Ah=f;class w{constructor(){this.a=Promise.resolve(null)}queue(E){return this.a=this.a.then(()=>E(),()=>E())}}e.$Bh=w;class y{constructor(){this.a=new Map}queue(E,H){const ne=(this.a.get(E)??Promise.resolve()).catch(()=>{}).then(H).finally(()=>{this.a.get(E)===ne&&this.a.delete(E)});return this.a.set(E,ne),ne}}e.$Ch=y;const r=(j,E)=>{let H=!0;const J=setTimeout(()=>{H=!1,E()},j);return{isTriggered:()=>H,dispose:()=>{clearTimeout(J),H=!1}}},n=j=>{let E=!0;return queueMicrotask(()=>{E&&(E=!1,j())}),{isTriggered:()=>E,dispose:()=>{E=!1}}};class i{constructor(E){this.defaultDelay=E,this.a=null,this.b=null,this.d=null,this.f=null,this.g=null}trigger(E,H=this.defaultDelay){this.g=E,this.h(),this.b||(this.b=new Promise((ne,$e)=>{this.d=ne,this.f=$e}).then(()=>{if(this.b=null,this.d=null,this.g){const ne=this.g;return this.g=null,ne()}}));const J=()=>{this.a=null,this.d?.(null)};return this.a=H===U.$ie?n(J):r(H,J),this.b}isTriggered(){return!!this.a?.isTriggered()}cancel(){this.h(),this.b&&(this.f?.(new t.$8),this.b=null)}h(){this.a?.dispose(),this.a=null}dispose(){this.cancel()}}e.$Dh=i;class l{constructor(E){this.a=new i(E),this.b=new f}trigger(E,H){return this.a.trigger(()=>this.b.queue(E),H)}isTriggered(){return this.a.isTriggered()}cancel(){this.a.cancel()}dispose(){this.a.dispose(),this.b.dispose()}}e.$Eh=l;class c{constructor(){this.a=!1,this.b=new Promise((E,H)=>{this.d=E})}isOpen(){return this.a}open(){this.a=!0,this.d(!0)}wait(){return this.b}}e.$Fh=c;class O extends c{constructor(E){super(),this.f=setTimeout(()=>this.open(),E)}open(){clearTimeout(this.f),super.open()}}e.$Gh=O;function h(j,E){return E?new Promise((H,J)=>{const ne=setTimeout(()=>{$e.dispose(),H()},j),$e=E.onCancellationRequested(()=>{clearTimeout(ne),$e.dispose(),J(new t.$8)})}):_(H=>h(j,H))}function A(j,E=0,H){const J=setTimeout(()=>{j(),H&&ne.dispose()},E),ne=(0,M.$Vc)(()=>{clearTimeout(J),H?.deleteAndLeak(ne)});return H?.add(ne),ne}function u(j){const E=[];let H=0;const J=j.length;function ne(){return H<J?j[H++]():null}function $e(De){De!=null&&E.push(De);const he=ne();return he?he.then($e):Promise.resolve(E)}return Promise.resolve(null).then($e)}function S(j,E=J=>!!J,H=null){let J=0;const ne=j.length,$e=()=>{if(J>=ne)return Promise.resolve(H);const De=j[J++];return Promise.resolve(De()).then(fe=>E(fe)?Promise.resolve(fe):$e())};return $e()}function R(j,E=J=>!!J,H=null){if(j.length===0)return Promise.resolve(H);let J=j.length;const ne=()=>{J=-1;for(const $e of j)$e.cancel?.()};return new Promise(($e,De)=>{for(const he of j)he.then(fe=>{--J>=0&&E(fe)?(ne(),$e(fe)):J===0&&$e(H)}).catch(fe=>{--J>=0&&(ne(),De(fe))})})}class b{constructor(E){this.a=0,this.b=!1,this.f=E,this.g=[],this.d=0,this.h=new W.$ne}whenIdle(){return this.size>0?W.Event.toPromise(this.onDrained):Promise.resolve()}get onDrained(){return this.h.event}get size(){return this.a}queue(E){if(this.b)throw new Error("Object has been disposed");return this.a++,new Promise((H,J)=>{this.g.push({factory:E,c:H,e:J}),this.j()})}j(){for(;this.g.length&&this.d<this.f;){const E=this.g.shift();this.d++;const H=E.factory();H.then(E.c,E.e),H.then(()=>this.k(),()=>this.k())}}k(){this.b||(this.d--,--this.a===0&&this.h.fire(),this.g.length>0&&this.j())}clear(){if(this.b)throw new Error("Object has been disposed");this.g.length=0,this.a=this.d}dispose(){this.b=!0,this.g.length=0,this.a=0,this.h.dispose()}}e.$Mh=b;class d extends b{constructor(){super(1)}}e.$Nh=d;class K{constructor(){this.a=new T,this.b=0}queue(E){return this.a.isRunning()?this.a.queue(()=>this.a.run(this.b++,E())):this.a.run(this.b++,E())}}e.$Oh=K;class ie{constructor(){this.a=new Map,this.b=new Set,this.d=void 0,this.f=0}async whenDrained(){if(this.g())return;const E=new D;return this.b.add(E),E.p}g(){for(const[,E]of this.a)if(E.size>0)return!1;return!0}queueSize(E,H=Y.$0g){const J=H.getComparisonKey(E);return this.a.get(J)?.size??0}queueFor(E,H,J=Y.$0g){const ne=J.getComparisonKey(E);let $e=this.a.get(ne);if(!$e){$e=new d;const De=this.f++,he=W.Event.once($e.onDrained)(()=>{$e?.dispose(),this.a.delete(ne),this.h(),this.d?.deleteAndDispose(De),this.d?.size===0&&(this.d.dispose(),this.d=void 0)});this.d||(this.d=new M.$7c),this.d.set(De,he),this.a.set(ne,$e)}return $e.queue(H)}h(){this.g()&&this.j()}j(){for(const E of this.b)E.complete();this.b.clear()}dispose(){for(const[,E]of this.a)E.dispose();this.a.clear(),this.j(),this.d?.dispose()}}e.$Ph=ie;class ee{constructor(E,H){this.b=!1,this.a=-1,typeof E=="function"&&typeof H=="number"&&this.setIfNotSet(E,H)}dispose(){this.cancel(),this.b=!0}cancel(){this.a!==-1&&(clearTimeout(this.a),this.a=-1)}cancelAndSet(E,H){if(this.b)throw new t.$fb("Calling 'cancelAndSet' on a disposed TimeoutTimer");this.cancel(),this.a=setTimeout(()=>{this.a=-1,E()},H)}setIfNotSet(E,H){if(this.b)throw new t.$fb("Calling 'setIfNotSet' on a disposed TimeoutTimer");this.a===-1&&(this.a=setTimeout(()=>{this.a=-1,E()},H))}}e.$Qh=ee;class V{constructor(){this.d=void 0,this.f=!1}cancel(){this.d?.dispose(),this.d=void 0}cancelAndSet(E,H,J=globalThis){if(this.f)throw new t.$fb("Calling 'cancelAndSet' on a disposed IntervalTimer");this.cancel();const ne=J.setInterval(()=>{E()},H);this.d=(0,M.$Vc)(()=>{J.clearInterval(ne),this.d=void 0})}dispose(){this.cancel(),this.f=!0}}e.$Rh=V;class re{constructor(E,H){this.b=-1,this.a=E,this.d=H,this.f=this.g.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearTimeout(this.b),this.b=-1)}schedule(E=this.d){this.cancel(),this.b=setTimeout(this.f,E)}get delay(){return this.d}set delay(E){this.d=E}isScheduled(){return this.b!==-1}flush(){this.isScheduled()&&(this.cancel(),this.h())}g(){this.b=-1,this.a&&this.h()}h(){this.a?.()}}e.$Sh=re;class X{constructor(E,H){H%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${H}ms is not a multiple of 1000ms.`),this.a=E,this.b=H,this.d=0,this.f=-1,this.g=this.h.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearInterval(this.f),this.f=-1)}schedule(E=this.b){E%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${E}ms is not a multiple of 1000ms.`),this.cancel(),this.d=Math.ceil(E/1e3),this.f=setInterval(this.g,1e3)}isScheduled(){return this.f!==-1}h(){this.d--,!(this.d>0)&&(clearInterval(this.f),this.f=-1,this.a?.())}}e.$Th=X;class te extends re{constructor(E,H){super(E,H),this.j=[]}work(E){this.j.push(E),this.isScheduled()||this.schedule()}h(){const E=this.j;this.j=[],this.a?.(E)}dispose(){this.j=[],super.dispose()}}e.$Uh=te;class oe extends M.$Xc{constructor(E,H){super(),this.g=E,this.h=H,this.a=[],this.b=this.B(new M.$Yc),this.f=!1}get pending(){return this.a.length}work(E){if(this.f)return!1;if(typeof this.g.maxBufferedWork=="number"){if(this.b.value){if(this.pending+E.length>this.g.maxBufferedWork)return!1}else if(this.pending+E.length-this.g.maxWorkChunkSize>this.g.maxBufferedWork)return!1}for(const H of E)this.a.push(H);return this.b.value||this.j(),!0}j(){this.h(this.a.splice(0,this.g.maxWorkChunkSize)),this.a.length>0&&(this.b.value=new re(()=>{this.b.clear(),this.j()},this.g.throttleDelay),this.b.value.schedule())}dispose(){super.dispose(),this.f=!0}}e.$Vh=oe,function(){typeof globalThis.requestIdleCallback!="function"||typeof globalThis.cancelIdleCallback!="function"?e.$Xh=(j,E)=>{(0,F.$B)(()=>{if(H)return;const J=Date.now()+15;E(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,J-Date.now())}}))});let H=!1;return{dispose(){H||(H=!0)}}}:e.$Xh=(j,E,H)=>{const J=j.requestIdleCallback(E,typeof H=="number"?{timeout:H}:void 0);let ne=!1;return{dispose(){ne||(ne=!0,j.cancelIdleCallback(J))}}},e.$Wh=j=>(0,e.$Xh)(globalThis,j)}();class ce{constructor(E,H){this.g=!1,this.d=()=>{try{this.j=H()}catch(J){this.l=J}finally{this.g=!0}},this.f=(0,e.$Xh)(E,()=>this.d())}dispose(){this.f.dispose()}get value(){if(this.g||(this.f.dispose(),this.d()),this.l)throw this.l;return this.j}get isInitialized(){return this.g}}e.$Yh=ce;class L extends ce{constructor(E){super(globalThis,E)}}e.$Zh=L;async function a(j,E,H){let J;for(let ne=0;ne<H;ne++)try{return await j()}catch($e){J=$e,await h(E)}throw J}class T{isRunning(E){return typeof E=="number"?this.a?.taskId===E:!!this.a}get running(){return this.a?.promise}cancelRunning(){this.a?.cancel()}run(E,H,J){return this.a={taskId:E,cancel:()=>J?.(),promise:H},H.then(()=>this.d(E),()=>this.d(E)),H}d(E){this.a&&E===this.a.taskId&&(this.a=void 0,this.f())}f(){if(this.b){const E=this.b;this.b=void 0,E.run().then(E.promiseResolve,E.promiseReject)}}queue(E){if(this.b)this.b.run=E;else{const{promise:H,resolve:J,reject:ne}=m();this.b={run:E,promise:H,promiseResolve:J,promiseReject:ne}}return this.b.promise}hasQueued(){return!!this.b}async join(){return this.b?.promise??this.a?.promise}}e.$2h=T;class B{constructor(E,H=()=>Date.now()){this.d=E,this.f=H,this.a=0,this.b=0}increment(){const E=this.f();return E-this.a>this.d&&(this.a=E,this.b=0),this.b++,this.b}}e.$3h=B;var Q;(function(j){j[j.Resolved=0]="Resolved",j[j.Rejected=1]="Rejected"})(Q||(Q={}));class D{get isRejected(){return this.d?.outcome===Q.Rejected}get isResolved(){return this.d?.outcome===Q.Resolved}get isSettled(){return!!this.d}get value(){return this.d?.outcome===Q.Resolved?this.d?.value:void 0}constructor(){this.p=new Promise((E,H)=>{this.a=E,this.b=H})}complete(E){return new Promise(H=>{this.a(E),this.d={outcome:Q.Resolved,value:E},H()})}error(E){return new Promise(H=>{this.b(E),this.d={outcome:Q.Rejected,value:E},H()})}cancel(){return this.error(new t.$8)}}e.$4h=D;var Z;(function(j){async function E(J){let ne;const $e=await Promise.all(J.map(De=>De.then(he=>he,he=>{ne||(ne=he)})));if(typeof ne<"u")throw ne;return $e}j.settled=E;function H(J){return new Promise(async(ne,$e)=>{try{await J(ne,$e)}catch(De){$e(De)}})}j.withAsyncBody=H})(Z||(e.Promises=Z={}));class x{get value(){return this.a}get error(){return this.b}get isResolved(){return this.d}constructor(E){this.a=void 0,this.b=void 0,this.d=!1,this.promise=E.then(H=>(this.a=H,this.d=!0,H),H=>{throw this.b=H,this.d=!0,H})}requireValue(){if(!this.d)throw new t.$fb("Promise is not resolved yet");if(this.b)throw this.b;return this.a}}e.$5h=x;class se{constructor(E){this.b=E,this.a=new P.$X(()=>new x(this.b()))}requireValue(){return this.a.value.requireValue()}getPromise(){return this.a.value.promise}get currentValue(){return this.a.rawValue?.value}}e.$6h=se;var le;(function(j){j[j.Initial=0]="Initial",j[j.DoneOK=1]="DoneOK",j[j.DoneError=2]="DoneError"})(le||(le={}));class de{static fromArray(E){return new de(H=>{H.emitMany(E)})}static fromPromise(E){return new de(async H=>{H.emitMany(await E)})}static fromPromises(E){return new de(async H=>{await Promise.all(E.map(async J=>H.emitOne(await J)))})}static merge(E){return new de(async H=>{await Promise.all(E.map(async J=>{for await(const ne of J)H.emitOne(ne)}))})}static{this.EMPTY=de.fromArray([])}constructor(E,H){this.a=le.Initial,this.b=[],this.d=null,this.f=H,this.g=new W.$ne,queueMicrotask(async()=>{const J={emitOne:ne=>this.h(ne),emitMany:ne=>this.j(ne),reject:ne=>this.l(ne)};try{await Promise.resolve(E(J)),this.k()}catch(ne){this.l(ne)}finally{J.emitOne=void 0,J.emitMany=void 0,J.reject=void 0}})}[Symbol.asyncIterator](){let E=0;return{next:async()=>{do{if(this.a===le.DoneError)throw this.d;if(E<this.b.length)return{done:!1,value:this.b[E++]};if(this.a===le.DoneOK)return{done:!0,value:void 0};await W.Event.toPromise(this.g.event)}while(!0)},return:async()=>(this.f?.(),{done:!0,value:void 0})}}static map(E,H){return new de(async J=>{for await(const ne of E)J.emitOne(H(ne))})}map(E){return de.map(this,E)}static filter(E,H){return new de(async J=>{for await(const ne of E)H(ne)&&J.emitOne(ne)})}filter(E){return de.filter(this,E)}static coalesce(E){return de.filter(E,H=>!!H)}coalesce(){return de.coalesce(this)}static async toPromise(E){const H=[];for await(const J of E)H.push(J);return H}toPromise(){return de.toPromise(this)}h(E){this.a===le.Initial&&(this.b.push(E),this.g.fire())}j(E){this.a===le.Initial&&(this.b=this.b.concat(E),this.g.fire())}k(){this.a===le.Initial&&(this.a=le.DoneOK,this.g.fire())}l(E){this.a===le.Initial&&(this.a=le.DoneError,this.d=E,this.g.fire())}}e.$7h=de;class p extends de{constructor(E,H){super(H),this.m=E}cancel(){this.m.cancel()}}e.$8h=p;function q(j){const E=new g.$ye,H=j(E.token);return new p(E,async J=>{const ne=E.token.onCancellationRequested(()=>{ne.dispose(),E.dispose(),J.reject(new t.$8)});try{for await(const $e of H){if(E.token.isCancellationRequested)return;J.emitOne($e)}ne.dispose(),E.dispose()}catch($e){ne.dispose(),E.dispose(),J.reject($e)}})}class G{constructor(E){this.a=new D,this.b=new de(ne=>{if(H){ne.reject(H);return}return J&&ne.emitMany(J),this.d=$e=>ne.reject($e),this.f=$e=>ne.emitOne($e),this.a.p},E);let H,J;this.f=ne=>{J||(J=[]),J.push(ne)},this.d=ne=>{H||(H=ne)}}get asyncIterable(){return this.b}resolve(){this.a.complete()}reject(E){this.d(E),this.a.complete()}emitOne(E){this.f(E)}}e.$0h=G}),define(_e[23],Ee([0,1,12,8,11,14,20,3,2,7]),function(ae,e,g,t,W,M,Y,F,U,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xk=e.$wk=void 0,e.$vk=N,e.$yk=s,e.$zk=K,e.$Ak=ie,e.$Bk=ee,e.$Ck=V,e.$Dk=re,e.$Ek=ce;function N(){return Object.create(null)}e.$wk="**",e.$xk="/";const _="[/\\\\]",v="[^/\\\\]",k=/\//g;function o(L,a){switch(L){case 0:return"";case 1:return`${v}*?`;default:return`(?:${_}|${v}+${_}${a?`|${_}${v}+`:""})*?`}}function s(L,a){if(!L)return[];const T=[];let B=!1,Q=!1,D="";for(const Z of L){switch(Z){case a:if(!B&&!Q){T.push(D),D="";continue}break;case"{":B=!0;break;case"}":B=!1;break;case"[":Q=!0;break;case"]":Q=!1;break}D+=Z}return D&&T.push(D),T}function $(L){if(!L)return"";let a="";const T=s(L,e.$xk);if(T.every(B=>B===e.$wk))a=".*";else{let B=!1;T.forEach((Q,D)=>{if(Q===e.$wk){if(B)return;a+=o(2,D===T.length-1)}else{let Z=!1,x="",se=!1,le="";for(const de of Q){if(de!=="}"&&Z){x+=de;continue}if(se&&(de!=="]"||!le)){let p;de==="-"?p=de:(de==="^"||de==="!")&&!le?p="^":de===e.$xk?p="":p=(0,P.$jf)(de),le+=p;continue}switch(de){case"{":Z=!0;continue;case"[":se=!0;continue;case"}":{const q=`(?:${s(x,",").map(G=>$(G)).join("|")})`;a+=q,Z=!1,x="";break}case"]":{a+="["+le+"]",se=!1,le="";break}case"?":a+=v;continue;case"*":a+=o(1);continue;default:a+=(0,P.$jf)(de)}}D<T.length-1&&(T[D+1]!==e.$wk||D+2<T.length)&&(a+=_)}B=Q===e.$wk})}return a}const m=/^\*\*\/\*\.[\w\.-]+$/,f=/^\*\*\/([\w\.-]+)\/?$/,w=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,y=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,r=/^\*\*((\/[\w\.-]+)+)\/?$/,n=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,i=new Y.$Gc(1e4),l=function(){return!1},c=function(){return null};function O(L,a){if(!L)return c;let T;typeof L!="string"?T=L.pattern:T=L,T=T.trim();const B=`${T}_${!!a.trimForExclusions}`;let Q=i.get(B);if(Q)return h(Q,L);let D;return m.test(T)?Q=u(T.substr(4),T):(D=f.exec(A(T,a)))?Q=S(D[1],T):(a.trimForExclusions?y:w).test(T)?Q=R(T,a):(D=r.exec(A(T,a)))?Q=b(D[1].substr(1),T,!0):(D=n.exec(A(T,a)))?Q=b(D[1],T,!1):Q=d(T),i.set(B,Q),h(Q,L)}function h(L,a){if(typeof a=="string")return L;const T=function(B,Q){return(0,M.$Fg)(B,a.base,!U.$k)?L((0,P.$of)(B.substr(a.base.length),F.sep),Q):null};return T.allBasenames=L.allBasenames,T.allPaths=L.allPaths,T.basenames=L.basenames,T.patterns=L.patterns,T}function A(L,a){return a.trimForExclusions&&L.endsWith("/**")?L.substr(0,L.length-2):L}function u(L,a){return function(T,B){return typeof T=="string"&&T.endsWith(L)?a:null}}function S(L,a){const T=`/${L}`,B=`\\${L}`,Q=function(Z,x){return typeof Z!="string"?null:x?x===L?a:null:Z===L||Z.endsWith(T)||Z.endsWith(B)?a:null},D=[L];return Q.basenames=D,Q.patterns=[a],Q.allBasenames=D,Q}function R(L,a){const T=oe(L.slice(1,-1).split(",").map(x=>O(x,a)).filter(x=>x!==c),L),B=T.length;if(!B)return c;if(B===1)return T[0];const Q=function(x,se){for(let le=0,de=T.length;le<de;le++)if(T[le](x,se))return L;return null},D=T.find(x=>!!x.allBasenames);D&&(Q.allBasenames=D.allBasenames);const Z=T.reduce((x,se)=>se.allPaths?x.concat(se.allPaths):x,[]);return Z.length&&(Q.allPaths=Z),Q}function b(L,a,T){const B=F.sep===F.$jc.sep,Q=B?L:L.replace(k,F.sep),D=F.sep+Q,Z=F.$jc.sep+L;let x;return T?x=function(se,le){return typeof se=="string"&&(se===Q||se.endsWith(D)||!B&&(se===L||se.endsWith(Z)))?a:null}:x=function(se,le){return typeof se=="string"&&(se===Q||!B&&se===L)?a:null},x.allPaths=[(T?"*/":"./")+L],x}function d(L){try{const a=new RegExp(`^${$(L)}$`);return function(T){return a.lastIndex=0,typeof T=="string"&&a.test(T)?L:null}}catch{return c}}function K(L,a,T){return!L||typeof a!="string"?!1:ie(L)(a,void 0,T)}function ie(L,a={}){if(!L)return l;if(typeof L=="string"||ee(L)){const T=O(L,a);if(T===c)return l;const B=function(Q,D){return!!T(Q,D)};return T.allBasenames&&(B.allBasenames=T.allBasenames),T.allPaths&&(B.allPaths=T.allPaths),B}return X(L,a)}function ee(L){const a=L;return a?typeof a.base=="string"&&typeof a.pattern=="string":!1}function V(L){return L.allBasenames||[]}function re(L){return L.allPaths||[]}function X(L,a){const T=oe(Object.getOwnPropertyNames(L).map(x=>te(x,L[x],a)).filter(x=>x!==c)),B=T.length;if(!B)return c;if(!T.some(x=>!!x.requiresSiblings)){if(B===1)return T[0];const x=function(de,p){let q;for(let G=0,j=T.length;G<j;G++){const E=T[G](de,p);if(typeof E=="string")return E;(0,t.$sh)(E)&&(q||(q=[]),q.push(E))}return q?(async()=>{for(const G of q){const j=await G;if(typeof j=="string")return j}return null})():null},se=T.find(de=>!!de.allBasenames);se&&(x.allBasenames=se.allBasenames);const le=T.reduce((de,p)=>p.allPaths?de.concat(p.allPaths):de,[]);return le.length&&(x.allPaths=le),x}const Q=function(x,se,le){let de,p;for(let q=0,G=T.length;q<G;q++){const j=T[q];j.requiresSiblings&&le&&(se||(se=(0,F.$qc)(x)),de||(de=se.substr(0,se.length-(0,F.$rc)(x).length)));const E=j(x,se,de,le);if(typeof E=="string")return E;(0,t.$sh)(E)&&(p||(p=[]),p.push(E))}return p?(async()=>{for(const q of p){const G=await q;if(typeof G=="string")return G}return null})():null},D=T.find(x=>!!x.allBasenames);D&&(Q.allBasenames=D.allBasenames);const Z=T.reduce((x,se)=>se.allPaths?x.concat(se.allPaths):x,[]);return Z.length&&(Q.allPaths=Z),Q}function te(L,a,T){if(a===!1)return c;const B=O(L,T);if(B===c)return c;if(typeof a=="boolean")return B;if(a){const Q=a.when;if(typeof Q=="string"){const D=(Z,x,se,le)=>{if(!le||!B(Z,x))return null;const de=Q.replace("$(basename)",()=>se),p=le(de);return(0,t.$sh)(p)?p.then(q=>q?L:null):p?L:null};return D.requiresSiblings=!0,D}}return B}function oe(L,a){const T=L.filter(x=>!!x.basenames);if(T.length<2)return L;const B=T.reduce((x,se)=>{const le=se.basenames;return le?x.concat(le):x},[]);let Q;if(a){Q=[];for(let x=0,se=B.length;x<se;x++)Q.push(a)}else Q=T.reduce((x,se)=>{const le=se.patterns;return le?x.concat(le):x},[]);const D=function(x,se){if(typeof x!="string")return null;if(!se){let de;for(de=x.length;de>0;de--){const p=x.charCodeAt(de-1);if(p===W.CharCode.Slash||p===W.CharCode.Backslash)break}se=x.substr(de)}const le=B.indexOf(se);return le!==-1?Q[le]:null};D.basenames=B,D.patterns=Q,D.allBasenames=B;const Z=L.filter(x=>!x.basenames);return Z.push(D),Z}function ce(L,a){return(0,g.$xb)(L,a,(T,B)=>typeof T=="string"&&typeof B=="string"?T===B:typeof T!="string"&&typeof B!="string"?T.base===B.base&&T.pattern===B.pattern:!1)}}),define(_e[24],Ee([0,1,17,54,64,8,14,21,3,2,22,5]),function(ae,e,g,t,W,M,Y,F,U,P,N,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.SymlinkSupport=e.RimRafMode=void 0,e.rimrafSync=$,e.readdirSync=w,e.whenDeleted=n,e.configureFlushOnWrite=h,e.writeFileSync=u,g=Le(g);var v;(function(X){X[X.UNLINK=0]="UNLINK",X[X.MOVE=1]="MOVE"})(v||(e.RimRafMode=v={}));async function k(X,te=v.UNLINK,oe){if((0,Y.$Jg)(X))throw new Error("rimraf - will refuse to recursively delete root");return te===v.UNLINK?s(X):o(X,oe)}async function o(X,te=(0,Y.$Og)((0,t.tmpdir)())){try{try{await g.promises.rename(X,te)}catch(oe){return oe.code==="ENOENT"?void 0:s(X)}s(te).catch(oe=>{})}catch(oe){if(oe.code!=="ENOENT")throw oe}}async function s(X){return g.promises.rm(X,{recursive:!0,force:!0,maxRetries:3})}function $(X){if((0,Y.$Jg)(X))throw new Error("rimraf - will refuse to recursively delete root");g.rmSync(X,{recursive:!0,force:!0,maxRetries:3})}async function m(X,te){return y(await(te?f(X):g.promises.readdir(X)))}async function f(X){try{return await g.promises.readdir(X,{withFileTypes:!0})}catch(ce){console.warn("[node.js fs] readdir with filetypes failed with error: ",ce)}const te=[],oe=await m(X);for(const ce of oe){let L=!1,a=!1,T=!1;try{const B=await e.Promises.lstat((0,U.$mc)(X,ce));L=B.isFile(),a=B.isDirectory(),T=B.isSymbolicLink()}catch(B){console.warn("[node.js fs] unexpected error from lstat after readdir: ",B)}te.push({name:ce,isFile:()=>L,isDirectory:()=>a,isSymbolicLink:()=>T})}return te}function w(X){return y(g.readdirSync(X))}function y(X){return X.map(te=>typeof te=="string"?P.$j?(0,F.$nm)(te):te:(te.name=P.$j?(0,F.$nm)(te.name):te.name,te))}async function r(X){const te=await m(X),oe=[];for(const ce of te)await i.existsDirectory((0,U.$mc)(X,ce))&&oe.push(ce);return oe}function n(X,te=1e3){return new Promise(oe=>{let ce=!1;const L=setInterval(()=>{ce||(ce=!0,g.access(X,a=>{ce=!1,a&&(clearInterval(L),oe(void 0))}))},te)})}var i;(function(X){async function te(L){let a;try{if(a=await e.Promises.lstat(L),!a.isSymbolicLink())return{stat:a}}catch{}try{return{stat:await e.Promises.stat(L),symbolicLink:a?.isSymbolicLink()?{dangling:!1}:void 0}}catch(T){if(T.code==="ENOENT"&&a)return{stat:a,symbolicLink:{dangling:!0}};if(P.$i&&T.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(L)),symbolicLink:{dangling:!1}}}catch(B){if(B.code==="ENOENT"&&a)return{stat:a,symbolicLink:{dangling:!0}};throw B}throw T}}X.stat=te;async function oe(L){try{const{stat:a,symbolicLink:T}=await X.stat(L);return a.isFile()&&T?.dangling!==!0}catch{}return!1}X.existsFile=oe;async function ce(L){try{const{stat:a,symbolicLink:T}=await X.stat(L);return a.isDirectory()&&T?.dangling!==!0}catch{}return!1}X.existsDirectory=ce})(i||(e.SymlinkSupport=i={}));const l=new M.$Ph;function c(X,te,oe){return l.queueFor(_.URI.file(X),()=>{const ce=S(oe);return new Promise((L,a)=>A(X,te,ce,T=>T?a(T):L()))},N.$$g)}let O=!0;function h(X){O=X}function A(X,te,oe,ce){if(!O)return g.writeFile(X,te,{mode:oe.mode,flag:oe.flag},ce);g.open(X,oe.flag,oe.mode,(L,a)=>{if(L)return ce(L);g.writeFile(a,te,T=>{if(T)return g.close(a,()=>ce(T));g.fdatasync(a,B=>(B&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",B),h(!1)),g.close(a,Q=>ce(Q))))})})}function u(X,te,oe){const ce=S(oe);if(!O)return g.writeFileSync(X,te,{mode:ce.mode,flag:ce.flag});const L=g.openSync(X,ce.flag,ce.mode);try{g.writeFileSync(L,te);try{g.fdatasyncSync(L)}catch(a){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",a),h(!1)}}finally{g.closeSync(L)}}function S(X){return X?{mode:typeof X.mode=="number"?X.mode:438,flag:typeof X.flag=="string"?X.flag:"w"}:{mode:438,flag:"w"}}async function R(X,te,oe=6e4){if(X!==te)try{P.$i&&typeof oe=="number"?await b(X,te,Date.now(),oe):await g.promises.rename(X,te)}catch(ce){if(X.toLowerCase()!==te.toLowerCase()&&ce.code==="EXDEV"||X.endsWith("."))await d(X,te,{preserveSymlinks:!1}),await k(X,v.MOVE);else throw ce}}async function b(X,te,oe,ce,L=0){try{return await g.promises.rename(X,te)}catch(a){if(a.code!=="EACCES"&&a.code!=="EPERM"&&a.code!=="EBUSY")throw a;if(Date.now()-oe>=ce)throw console.error(`[node.js fs] rename failed after ${L} retries with error: ${a}`),a;if(L===0){let T=!1;try{const{stat:B}=await i.stat(te);B.isFile()||(T=!0)}catch{}if(T)throw a}return await(0,M.$Hh)(Math.min(100,L*10)),b(X,te,oe,ce,L+1)}}async function d(X,te,oe){return ie(X,te,{root:{source:X,target:te},options:oe,handledSourcePaths:new Set})}const K=511;async function ie(X,te,oe){if(oe.handledSourcePaths.has(X))return;oe.handledSourcePaths.add(X);const{stat:ce,symbolicLink:L}=await i.stat(X);if(L){if(oe.options.preserveSymlinks)try{return await re(X,te,oe)}catch{}if(L.dangling)return}return ce.isDirectory()?ee(X,te,ce.mode&K,oe):V(X,te,ce.mode&K)}async function ee(X,te,oe,ce){await e.Promises.mkdir(te,{recursive:!0,mode:oe});const L=await m(X);for(const a of L)await ie((0,U.$mc)(X,a),(0,U.$mc)(te,a),ce)}async function V(X,te,oe){await e.Promises.copyFile(X,te),await e.Promises.chmod(te,oe)}async function re(X,te,oe){let ce=await e.Promises.readlink(X);(0,Y.$Fg)(ce,oe.root.source,!P.$k)&&(ce=(0,U.$mc)(oe.root.target,ce.substr(oe.root.source.length+1))),await e.Promises.symlink(ce,te)}e.Promises=new class{get access(){return g.promises.access}get stat(){return g.promises.stat}get lstat(){return g.promises.lstat}get utimes(){return g.promises.utimes}get read(){return(X,te,oe,ce,L)=>new Promise((a,T)=>{g.read(X,te,oe,ce,L,(B,Q,D)=>B?T(B):a({bytesRead:Q,buffer:D}))})}get readFile(){return g.promises.readFile}get write(){return(X,te,oe,ce,L)=>new Promise((a,T)=>{g.write(X,te,oe,ce,L,(B,Q,D)=>B?T(B):a({bytesWritten:Q,buffer:D}))})}get appendFile(){return g.promises.appendFile}get fdatasync(){return(0,W.promisify)(g.fdatasync)}get truncate(){return g.promises.truncate}get copyFile(){return g.promises.copyFile}get open(){return(0,W.promisify)(g.open)}get close(){return(0,W.promisify)(g.close)}get symlink(){return g.promises.symlink}get readlink(){return g.promises.readlink}get chmod(){return g.promises.chmod}get mkdir(){return g.promises.mkdir}get unlink(){return g.promises.unlink}get rmdir(){return g.promises.rmdir}get realpath(){return(0,W.promisify)(g.realpath)}async exists(X){try{return await e.Promises.access(X),!0}catch{return!1}}get readdir(){return m}get readDirsInDir(){return r}get writeFile(){return c}get rm(){return k}get rename(){return R}get copy(){return d}}}),define(_e[35],Ee([0,1,17,3,2,7,24]),function(ae,e,g,t,W,M,Y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jr=F,e.$kr=U,e.$lr=P,e.$mr=N,g=Le(g);function F(v){if(W.$k)return v;const k=(0,t.$pc)(v);if(v===k)return v;const o=((0,t.$qc)(v)||v).toLowerCase();try{const $=(0,Y.readdirSync)(k).filter(m=>m.toLowerCase()===o);if($.length===1){const m=F(k);if(m)return(0,t.$mc)(m,$[0])}else if($.length>1){const m=$.indexOf(o);if(m>=0){const f=F(k);if(f)return(0,t.$mc)(f,$[m])}}}catch{}return null}async function U(v,k){if(W.$k)return v;const o=(0,t.$pc)(v);if(v===o)return v;const s=((0,t.$qc)(v)||v).toLowerCase();try{if(k?.isCancellationRequested)return null;const m=(await Y.Promises.readdir(o)).filter(f=>f.toLowerCase()===s);if(m.length===1){const f=await U(o,k);if(f)return(0,t.$mc)(f,m[0])}else if(m.length>1){const f=m.indexOf(s);if(f>=0){const w=await U(o,k);if(w)return(0,t.$mc)(w,m[f])}}}catch{}return null}async function P(v){try{return await Y.Promises.realpath(v)}catch{const o=_(v);return await Y.Promises.access(o,g.constants.R_OK),o}}function N(v){try{return g.realpathSync(v)}catch{const o=_(v);return g.accessSync(o,g.constants.R_OK),o}}function _(v){return(0,M.$pf)((0,t.$kc)(v),t.sep)}}),define(_e[55],Ee([0,1,3,2,32,33,10,24]),function(ae,e,g,t,W,M,Y,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.TerminateResponseCode=e.Source=void 0,e.$ym=U,e.$zm=P,g=Le(g),t=Le(t),W=Le(W),Y=Le(Y),F=Le(F),Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return M.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return M.TerminateResponseCode}});function U(_=W.env){return _.comspec||"cmd.exe"}function P(_){let v=[],k=!1;const o=function(s){if(k){v.push(s);return}(!_.send(s,m=>{if(m&&console.error(m),k=!1,v.length>0){const f=v.slice(0);v=[],f.forEach(w=>o(w))}})||t.$i)&&(k=!0)};return{send:o}}var N;(function(_){async function v(k,o,s){if(g.$lc(k))return k;if(o===void 0&&(o=W.cwd()),g.$pc(k)!=="."||(s===void 0&&Y.$gg(W.env.PATH)&&(s=W.env.PATH.split(g.$wc)),s===void 0||s.length===0))return g.$mc(o,k);async function m(f){if(await F.Promises.exists(f)){let w;try{w=await F.Promises.stat(f)}catch(y){y.message.startsWith("EACCES")&&(w=await F.Promises.lstat(f))}return w?!w.isDirectory():!1}return!1}for(const f of s){let w;if(g.$lc(f)?w=g.$mc(f,k):w=g.$mc(o,f,k),await m(w))return w;let y=w+".com";if(await m(y)||(y=w+".exe",await m(y)))return y}return g.$mc(o,k)}_.findExecutable=v})(N||(e.win32=N={}))});var Qe=this&&this.__decorate||function(ae,e,g,t){var W=arguments.length,M=W<3?e:t===null?t=Object.getOwnPropertyDescriptor(e,g):t,Y;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")M=Reflect.decorate(ae,e,g,t);else for(var F=ae.length-1;F>=0;F--)(Y=ae[F])&&(M=(W<3?Y(M):W>3?Y(e,g,M):Y(e,g))||M);return W>3&&M&&Object.defineProperty(e,g,M),M};define(_e[25],Ee([0,1,12,8,16,13,40,9,6,4,53,7,10]),function(ae,e,g,t,W,M,Y,F,U,P,N,_,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pi=e.ProxyChannel=e.$oi=e.$li=e.$ki=e.$ji=e.RequestInitiator=e.$ii=e.$fi=e.$ei=void 0,e.$gi=h,e.$hi=A,e.$mi=K,e.$ni=ie,_=Le(_);var k;(function(L){L[L.Promise=100]="Promise",L[L.PromiseCancel=101]="PromiseCancel",L[L.EventListen=102]="EventListen",L[L.EventDispose=103]="EventDispose"})(k||(k={}));function o(L){switch(L){case k.Promise:return"req";case k.PromiseCancel:return"cancel";case k.EventListen:return"subscribe";case k.EventDispose:return"unsubscribe"}}var s;(function(L){L[L.Initialize=200]="Initialize",L[L.PromiseSuccess=201]="PromiseSuccess",L[L.PromiseError=202]="PromiseError",L[L.PromiseErrorObj=203]="PromiseErrorObj",L[L.EventFire=204]="EventFire"})(s||(s={}));function $(L){switch(L){case s.Initialize:return"init";case s.PromiseSuccess:return"reply:";case s.PromiseError:case s.PromiseErrorObj:return"replyErr:";case s.EventFire:return"event:"}}var m;(function(L){L[L.Uninitialized=0]="Uninitialized",L[L.Idle=1]="Idle"})(m||(m={}));function f(L){let a=0;for(let T=0;;T+=7){const B=L.read(1);if(a|=(B.buffer[0]&127)<<T,!(B.buffer[0]&128))return a}}const w=l(0);function y(L,a){if(a===0){L.write(w);return}let T=0;for(let Q=a;Q!==0;Q=Q>>>7)T++;const B=W.$Pe.alloc(T);for(let Q=0;a!==0;Q++)B.buffer[Q]=a&127,a=a>>>7,a>0&&(B.buffer[Q]|=128);L.write(B)}class r{constructor(a){this.b=a,this.a=0}read(a){const T=this.b.slice(this.a,this.a+a);return this.a+=T.byteLength,T}}e.$ei=r;class n{constructor(){this.a=[]}get buffer(){return W.$Pe.concat(this.a)}write(a){this.a.push(a)}}e.$fi=n;var i;(function(L){L[L.Undefined=0]="Undefined",L[L.String=1]="String",L[L.Buffer=2]="Buffer",L[L.VSBuffer=3]="VSBuffer",L[L.Array=4]="Array",L[L.Object=5]="Object",L[L.Int=6]="Int"})(i||(i={}));function l(L){const a=W.$Pe.alloc(1);return a.writeUInt8(L,0),a}const c={Undefined:l(i.Undefined),String:l(i.String),Buffer:l(i.Buffer),VSBuffer:l(i.VSBuffer),Array:l(i.Array),Object:l(i.Object),Uint:l(i.Int)},O=typeof Buffer<"u";function h(L,a){if(typeof a>"u")L.write(c.Undefined);else if(typeof a=="string"){const T=W.$Pe.fromString(a);L.write(c.String),y(L,T.byteLength),L.write(T)}else if(O&&Buffer.isBuffer(a)){const T=W.$Pe.wrap(a);L.write(c.Buffer),y(L,T.byteLength),L.write(T)}else if(a instanceof W.$Pe)L.write(c.VSBuffer),y(L,a.byteLength),L.write(a);else if(Array.isArray(a)){L.write(c.Array),y(L,a.length);for(const T of a)h(L,T)}else if(typeof a=="number"&&(a|0)===a)L.write(c.Uint),y(L,a);else{const T=W.$Pe.fromString(JSON.stringify(a));L.write(c.Object),y(L,T.byteLength),L.write(T)}}function A(L){switch(L.read(1).readUInt8(0)){case i.Undefined:return;case i.String:return L.read(f(L)).toString();case i.Buffer:return L.read(f(L)).buffer;case i.VSBuffer:return L.read(f(L));case i.Array:{const T=f(L),B=[];for(let Q=0;Q<T;Q++)B.push(A(L));return B}case i.Object:return JSON.parse(L.read(f(L)).toString());case i.Int:return f(L)}}class u{constructor(a,T,B=null,Q=1e3){this.h=a,this.j=T,this.k=B,this.l=Q,this.b=new Map,this.d=new Map,this.g=new Map,this.f=this.h.onMessage(D=>this.q(D)),this.m({type:s.Initialize})}registerChannel(a,T){this.b.set(a,T),setTimeout(()=>this.w(a),0)}m(a){switch(a.type){case s.Initialize:{const T=this.o([a.type]);this.k?.logOutgoing(T,0,S.OtherSide,$(a.type));return}case s.PromiseSuccess:case s.PromiseError:case s.EventFire:case s.PromiseErrorObj:{const T=this.o([a.type,a.id],a.data);this.k?.logOutgoing(T,a.id,S.OtherSide,$(a.type),a.data);return}}}o(a,T=void 0){const B=new n;return h(B,a),h(B,T),this.p(B.buffer)}p(a){try{return this.h.send(a),a.byteLength}catch{return 0}}q(a){const T=new r(a),B=A(T),Q=A(T),D=B[0];switch(D){case k.Promise:return this.k?.logIncoming(a.byteLength,B[1],S.OtherSide,`${o(D)}: ${B[2]}.${B[3]}`,Q),this.s({type:D,id:B[1],channelName:B[2],name:B[3],arg:Q});case k.EventListen:return this.k?.logIncoming(a.byteLength,B[1],S.OtherSide,`${o(D)}: ${B[2]}.${B[3]}`,Q),this.t({type:D,id:B[1],channelName:B[2],name:B[3],arg:Q});case k.PromiseCancel:return this.k?.logIncoming(a.byteLength,B[1],S.OtherSide,`${o(D)}`),this.u({type:D,id:B[1]});case k.EventDispose:return this.k?.logIncoming(a.byteLength,B[1],S.OtherSide,`${o(D)}`),this.u({type:D,id:B[1]})}}s(a){const T=this.b.get(a.channelName);if(!T){this.v(a);return}const B=new M.$ye;let Q;try{Q=T.call(this.j,a.name,a.arg,B.token)}catch(x){Q=Promise.reject(x)}const D=a.id;Q.then(x=>{this.m({id:D,data:x,type:s.PromiseSuccess})},x=>{x instanceof Error?this.m({id:D,data:{message:x.message,name:x.name,stack:x.stack?x.stack.split(`
`):void 0},type:s.PromiseError}):this.m({id:D,data:x,type:s.PromiseErrorObj})}).finally(()=>{Z.dispose(),this.d.delete(a.id)});const Z=(0,P.$Vc)(()=>B.cancel());this.d.set(a.id,Z)}t(a){const T=this.b.get(a.channelName);if(!T){this.v(a);return}const B=a.id,D=T.listen(this.j,a.name,a.arg)(Z=>this.m({id:B,data:Z,type:s.EventFire}));this.d.set(a.id,D)}u(a){const T=this.d.get(a.id);T&&(T.dispose(),this.d.delete(a.id))}v(a){let T=this.g.get(a.channelName);T||(T=[],this.g.set(a.channelName,T));const B=setTimeout(()=>{console.error(`Unknown channel: ${a.channelName}`),a.type===k.Promise&&this.m({id:a.id,data:{name:"Unknown channel",message:`Channel name '${a.channelName}' timed out after ${this.l}ms`,stack:void 0},type:s.PromiseError})},this.l);T.push({request:a,timeoutTimer:B})}w(a){const T=this.g.get(a);if(T){for(const B of T)switch(clearTimeout(B.timeoutTimer),B.request.type){case k.Promise:this.s(B.request);break;case k.EventListen:this.t(B.request);break}this.g.delete(a)}}dispose(){this.f&&(this.f.dispose(),this.f=null),(0,P.$Sc)(this.d.values()),this.d.clear()}}e.$ii=u;var S;(function(L){L[L.LocalSide=0]="LocalSide",L[L.OtherSide=1]="OtherSide"})(S||(e.RequestInitiator=S={}));class R{constructor(a,T=null){this.l=a,this.a=!1,this.b=m.Uninitialized,this.d=new Set,this.f=new Map,this.g=0,this.k=new U.$ne,this.onDidInitialize=this.k.event,this.h=this.l.onMessage(B=>this.s(B)),this.j=T}getChannel(a){const T=this;return{call(B,Q,D){return T.a?Promise.reject(new F.$8):T.m(a,B,Q,D)},listen(B,Q){return T.a?U.Event.None:T.o(a,B,Q)}}}m(a,T,B,Q=M.CancellationToken.None){const D=this.g++,Z=k.Promise,x={id:D,type:Z,channelName:a,name:T,arg:B};if(Q.isCancellationRequested)return Promise.reject(new F.$8);let se;return new Promise((de,p)=>{if(Q.isCancellationRequested)return p(new F.$8);const q=()=>{const H=J=>{switch(J.type){case s.PromiseSuccess:this.f.delete(D),de(J.data);break;case s.PromiseError:{this.f.delete(D);const ne=new Error(J.data.message);ne.stack=Array.isArray(J.data.stack)?J.data.stack.join(`
`):J.data.stack,ne.name=J.data.name,p(ne);break}case s.PromiseErrorObj:this.f.delete(D),p(J.data);break}};this.f.set(D,H),this.p(x)};let G=null;this.b===m.Idle?q():(G=(0,t.$th)(H=>this.u()),G.then(()=>{G=null,q()}));const j=()=>{G?(G.cancel(),G=null):this.p({id:D,type:k.PromiseCancel}),p(new F.$8)},E=Q.onCancellationRequested(j);se=(0,P.$Uc)((0,P.$Vc)(j),E),this.d.add(se)}).finally(()=>{se.dispose(),this.d.delete(se)})}o(a,T,B){const Q=this.g++,D=k.EventListen,Z={id:Q,type:D,channelName:a,name:T,arg:B};let x=null;const se=new U.$ne({onWillAddFirstListener:()=>{x=(0,t.$th)(de=>this.u()),x.then(()=>{x=null,this.d.add(se),this.p(Z)})},onDidRemoveLastListener:()=>{x?(x.cancel(),x=null):(this.d.delete(se),this.p({id:Q,type:k.EventDispose}))}}),le=de=>se.fire(de.data);return this.f.set(Q,le),se.event}p(a){switch(a.type){case k.Promise:case k.EventListen:{const T=this.q([a.type,a.id,a.channelName,a.name],a.arg);this.j?.logOutgoing(T,a.id,S.LocalSide,`${o(a.type)}: ${a.channelName}.${a.name}`,a.arg);return}case k.PromiseCancel:case k.EventDispose:{const T=this.q([a.type,a.id]);this.j?.logOutgoing(T,a.id,S.LocalSide,o(a.type));return}}}q(a,T=void 0){const B=new n;return h(B,a),h(B,T),this.r(B.buffer)}r(a){try{return this.l.send(a),a.byteLength}catch{return 0}}s(a){const T=new r(a),B=A(T),Q=A(T),D=B[0];switch(D){case s.Initialize:return this.j?.logIncoming(a.byteLength,0,S.LocalSide,$(D)),this.t({type:B[0]});case s.PromiseSuccess:case s.PromiseError:case s.EventFire:case s.PromiseErrorObj:return this.j?.logIncoming(a.byteLength,B[1],S.LocalSide,$(D),Q),this.t({type:B[0],id:B[1],data:Q})}}t(a){if(a.type===s.Initialize){this.b=m.Idle,this.k.fire();return}this.f.get(a.id)?.(a)}get onDidInitializePromise(){return U.Event.toPromise(this.onDidInitialize)}u(){return this.b===m.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.a=!0,this.h&&(this.h.dispose(),this.h=null),(0,P.$Sc)(this.d.values()),this.d.clear()}}e.$ji=R,Qe([Y.$$h],R.prototype,"onDidInitializePromise",null);class b{get connections(){const a=[];return this.f.forEach(T=>a.push(T)),a}constructor(a,T,B){this.a=new Map,this.f=new Set,this.g=new U.$ne,this.onDidAddConnection=this.g.event,this.h=new U.$ne,this.onDidRemoveConnection=this.h.event,this.j=new P.$Wc,this.j.add(a(({protocol:Q,onDidClientDisconnect:D})=>{const Z=U.Event.once(Q.onMessage);this.j.add(Z(x=>{const se=new r(x),le=A(se),de=new u(Q,le,T,B),p=new R(Q,T);this.a.forEach((G,j)=>de.registerChannel(j,G));const q={channelServer:de,channelClient:p,ctx:le};this.f.add(q),this.g.fire(q),this.j.add(D(()=>{de.dispose(),p.dispose(),this.f.delete(q),this.h.fire(q)}))}))}))}getChannel(a,T){const B=this;return{call(Q,D,Z){let x;if((0,v.$ug)(T)){const le=(0,g.$6b)(B.connections.filter(T));x=le?Promise.resolve(le):U.Event.toPromise(U.Event.filter(B.onDidAddConnection,T))}else x=T.routeCall(B,Q,D);const se=x.then(le=>le.channelClient.getChannel(a));return K(se).call(Q,D,Z)},listen(Q,D){if((0,v.$ug)(T))return B.k(a,T,Q,D);const Z=T.routeEvent(B,Q,D).then(x=>x.channelClient.getChannel(a));return K(Z).listen(Q,D)}}}k(a,T,B,Q){const D=this;let Z;const x=new U.$ne({onWillAddFirstListener:()=>{Z=new P.$Wc;const se=new U.$te,le=new Map,de=q=>{const j=q.channelClient.getChannel(a).listen(B,Q),E=se.add(j);le.set(q,E)},p=q=>{const G=le.get(q);G&&(G.dispose(),le.delete(q))};D.connections.filter(T).forEach(de),U.Event.filter(D.onDidAddConnection,T)(de,void 0,Z),D.onDidRemoveConnection(p,void 0,Z),se.event(x.fire,x,Z),Z.add(se)},onDidRemoveLastListener:()=>{Z?.dispose(),Z=void 0}});return x.event}registerChannel(a,T){this.a.set(a,T);for(const B of this.f)B.channelServer.registerChannel(a,T)}dispose(){this.j.dispose();for(const a of this.f)a.channelClient.dispose(),a.channelServer.dispose();this.f.clear(),this.a.clear(),this.g.dispose(),this.h.dispose()}}e.$ki=b;class d{constructor(a,T,B=null){const Q=new n;h(Q,T),a.send(Q.buffer),this.a=new R(a,B),this.d=new u(a,T,B)}getChannel(a){return this.a.getChannel(a)}registerChannel(a,T){this.d.registerChannel(a,T)}dispose(){this.a.dispose(),this.d.dispose()}}e.$li=d;function K(L){return{call(a,T,B){return L.then(Q=>Q.call(a,T,B))},listen(a,T){const B=new U.$we;return L.then(Q=>B.input=Q.listen(a,T)),B.event}}}function ie(L){let a=!1;return{call(T,B,Q){return a?L.call(T,B,Q):(0,t.$Hh)(0).then(()=>a=!0).then(()=>L.call(T,B,Q))},listen(T,B){if(a)return L.listen(T,B);const Q=new U.$we;return(0,t.$Hh)(0).then(()=>a=!0).then(()=>Q.input=L.listen(T,B)),Q.event}}}class ee{constructor(a){this.a=a}routeCall(a){return this.b(a)}routeEvent(a){return this.b(a)}async b(a){for(const T of a.connections)if(await Promise.resolve(this.a(T.ctx)))return Promise.resolve(T);return await U.Event.toPromise(a.onDidAddConnection),await this.b(a)}}e.$oi=ee;var V;(function(L){function a(D,Z,x){const se=D,le=x&&x.disableMarshalling,de=new Map;for(const p in se)B(p)&&de.set(p,U.Event.buffer(se[p],!0,void 0,Z));return new class{listen(p,q,G){const j=de.get(q);if(j)return j;const E=se[q];if(typeof E=="function"){if(Q(q))return E.call(se,G);if(B(q))return de.set(q,U.Event.buffer(se[q],!0,void 0,Z)),de.get(q)}throw new F.$eb(`Event not found: ${q}`)}call(p,q,G){const j=se[q];if(typeof j=="function"){if(!le&&Array.isArray(G))for(let H=0;H<G.length;H++)G[H]=(0,N.$di)(G[H]);let E=j.apply(se,G);return E instanceof Promise||(E=Promise.resolve(E)),E}throw new F.$eb(`Method not found: ${q}`)}}}L.fromService=a;function T(D,Z){const x=Z&&Z.disableMarshalling;return new Proxy({},{get(se,le){if(typeof le=="string")return Z?.properties?.has(le)?Z.properties.get(le):Q(le)?function(de){return D.listen(le,de)}:B(le)?D.listen(le):async function(...de){let p;Z&&!(0,v.$pg)(Z.context)?p=[Z.context,...de]:p=de;const q=await D.call(le,p);return x?q:(0,N.$di)(q)};throw new F.$eb(`Property not found: ${String(le)}`)}})}L.toService=T;function B(D){return D[0]==="o"&&D[1]==="n"&&_.$Gf(D.charCodeAt(2))}function Q(D){return/^onDynamic/.test(D)&&_.$Gf(D.charCodeAt(9))}})(V||(e.ProxyChannel=V={}));const re=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function X(L){if(Array.isArray(L))return L;if(L&&typeof L=="object"&&typeof L.toString=="function"){const a=L.toString();if(a!=="[object Object]")return a}return L}function te(L){return Array.isArray(L)?L.map(X):X(L)}function oe(L,a,T,B,Q,D,Z){Z=te(Z);const x=re[Q],se=x[B%x.length];let le=[`%c[${L}]%c[${String(a).padStart(7," ")}]%c[len: ${String(T).padStart(5," ")}]%c${String(B).padStart(5," ")} - ${D}`,"color: darkgreen","color: grey","color: grey",`color: ${se}`];/\($/.test(D)?(le=le.concat(Z),le.push(")")):le.push(Z),console.log.apply(console,le)}class ce{constructor(a,T){this.d=a,this.f=T,this.a=0,this.b=0}logOutgoing(a,T,B,Q,D){this.b+=a,oe(this.d,this.b,a,T,B,Q,D)}logIncoming(a,T,B,Q,D){this.a+=a,oe(this.f,this.a,a,T,B,Q,D)}}e.$pi=ce}),define(_e[56],Ee([0,1,65,8,16,13,52,9,6,4,47,55,33,25]),function(ae,e,g,t,W,M,Y,F,U,P,N,_,v,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gr=e.$fr=void 0,F=Le(F);class o extends k.$ii{constructor(m){super({send:f=>{try{process.send?.(f.buffer.toString("base64"))}catch{}},onMessage:U.Event.fromNodeEventEmitter(process,"message",f=>W.$Pe.wrap(Buffer.from(f,"base64")))},m),process.once("disconnect",()=>this.dispose())}}e.$fr=o;class s{constructor(m,f){this.i=m,this.j=f,this.c=new Set,this.g=new Map,this.h=new U.$ne,this.onDidProcessExit=this.h.event;const w=f&&f.timeout?f.timeout:6e4;this.b=new t.$Dh(w),this.d=null,this.f=null}getChannel(m){const f=this;return{call(w,y,r){return f.k(m,w,y,r)},listen(w,y){return f.l(m,w,y)}}}k(m,f,w,y=M.CancellationToken.None){if(!this.b)return Promise.reject(new Error("disposed"));if(y.isCancellationRequested)return Promise.reject(F.$9());this.b.cancel();const r=this.n(m),n=(0,t.$th)(c=>r.call(f,w,c)),i=y.onCancellationRequested(()=>n.cancel()),l=(0,P.$Vc)(()=>n.cancel());return this.c.add(l),n.finally(()=>{i.dispose(),this.c.delete(l),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}),n}l(m,f,w){if(!this.b)return U.Event.None;this.b.cancel();let y;const r=new U.$ne({onWillAddFirstListener:()=>{y=this.n(m).listen(f,w)(r.fire,r),this.c.add(y)},onDidRemoveLastListener:()=>{this.c.delete(y),y.dispose(),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}});return r.event}get m(){if(!this.f){const m=this.j&&this.j.args?this.j.args:[],f=Object.create(null);f.env={...(0,N.$eo)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.j&&this.j.env&&(f.env={...f.env,...this.j.env}),this.j&&this.j.freshExecArgv&&(f.execArgv=[]),this.j&&typeof this.j.debug=="number"&&(f.execArgv=["--nolazy","--inspect="+this.j.debug]),this.j&&typeof this.j.debugBrk=="number"&&(f.execArgv=["--nolazy","--inspect-brk="+this.j.debugBrk]),f.execArgv===void 0&&(f.execArgv=process.execArgv.filter(h=>!/^--inspect(-brk)?=/.test(h)).filter(h=>!h.startsWith("--vscode-"))),(0,v.$mm)(f.env),this.d=(0,g.fork)(this.i,m,f);const w=new U.$ne,r=U.Event.fromNodeEventEmitter(this.d,"message",h=>h)(h=>{if((0,Y.$br)(h)){(0,Y.log)(h,`IPC Library: ${this.j.serverName}`);return}w.fire(W.$Pe.wrap(Buffer.from(h,"base64")))}),n=this.j.useQueue?(0,_.$zm)(this.d):this.d,i=h=>this.d&&this.d.connected&&n.send(h.buffer.toString("base64")),l=w.event,c={send:i,onMessage:l};this.f=new k.$ji(c);const O=()=>this.o();process.once("exit",O),this.d.on("error",h=>console.warn('IPC "'+this.j.serverName+'" errored with '+h)),this.d.on("exit",(h,A)=>{process.removeListener("exit",O),r.dispose(),this.c.forEach(u=>(0,P.$Sc)(u)),this.c.clear(),h!==0&&A!=="SIGTERM"&&console.warn('IPC "'+this.j.serverName+'" crashed with exit code '+h+" and signal "+A),this.b?.cancel(),this.o(),this.h.fire({code:h,signal:A})})}return this.f}n(m){let f=this.g.get(m);return f||(f=this.m.getChannel(m),this.g.set(m,f)),f}o(){this.f&&(this.d&&(this.d.kill(),this.d=null),this.f=null,this.g.clear())}dispose(){this.h.dispose(),this.b?.cancel(),this.b=void 0,this.o(),this.c.clear()}}e.$gr=s}),define(_e[57],Ee([0,1,29,16,25,6,10,12]),function(ae,e,g,t,W,M,Y,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$SX=void 0,e.$TX=N;class U{constructor(v){this.a=v,this.onMessage=M.Event.fromNodeEventEmitter(this.a,"message",k=>k.data?t.$Pe.wrap(k.data):t.$Pe.alloc(0)),v.start()}send(v){this.a.postMessage(v.buffer)}disconnect(){this.a.close()}}class P extends W.$ki{static b(v){(0,Y.$qg)((0,g.$RX)(process),"Electron Utility Process");const k=new M.$ne;return process.parentPort.on("message",o=>{if(v?.handledClientConnection(o))return;const s=(0,F.$Rb)(o.ports);s&&k.fire(s)}),M.Event.map(k.event,o=>({protocol:new U(o),onDidClientDisconnect:M.Event.fromNodeEventEmitter(o,"close")}))}constructor(v){super(P.b(v))}}e.$SX=P;function N(_,v,k){const o=s=>{s.data===v&&(_.removeListener("message",o),k())};_.on("message",o)}}),define(_e[58],Ee([30,31]),function(ae,e){return ae.create("vs/platform/files/common/files",e)}),define(_e[59],Ee([0,1]),function(ae,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fi=e._util=void 0,e.$Gi=W,e.$Hi=M;var g;(function(Y){Y.serviceIds=new Map,Y.DI_TARGET="$di$target",Y.DI_DEPENDENCIES="$di$dependencies";function F(U){return U[Y.DI_DEPENDENCIES]||[]}Y.getServiceDependencies=F})(g||(e._util=g={})),e.$Fi=W("instantiationService");function t(Y,F,U){F[g.DI_TARGET]===F?F[g.DI_DEPENDENCIES].push({id:Y,index:U}):(F[g.DI_DEPENDENCIES]=[{id:Y,index:U}],F[g.DI_TARGET]=F)}function W(Y){if(g.serviceIds.has(Y))return g.serviceIds.get(Y);const F=function(U,P,N){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");t(F,U,N)};return F.toString=()=>Y,g.serviceIds.set(Y,F),F}function M(Y){return Y}}),define(_e[18],Ee([0,1,28,3,7,10,5,58,59,2,34,15]),function(ae,e,g,t,W,M,Y,F,U,P,N,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Il=e.$Fl=e.FileKind=e.$El=e.$Dl=e.$Cl=e.$Bl=e.$Al=e.$zl=e.$yl=e.FileOperationResult=e.$xl=e.$wl=e.$vl=e.$tl=e.FileChangeType=e.$sl=e.FileOperation=e.$ml=e.FileSystemProviderErrorCode=e.FileSystemProviderCapabilities=e.FileChangeFilter=e.FilePermission=e.FileType=e.$al=void 0,e.$bl=v,e.$cl=$,e.$dl=f,e.$el=w,e.$fl=y,e.$gl=r,e.$hl=n,e.$il=i,e.$jl=l,e.$kl=c,e.$ll=O,e.$nl=u,e.$ol=S,e.$pl=R,e.$ql=b,e.$rl=d,e.$ul=re,e.$Gl=a,e.$Hl=T,e.$Jl=Q,e.$al=(0,U.$Gi)("fileService");function v(D){return D.create===!0}var k;(function(D){D[D.Unknown=0]="Unknown",D[D.File=1]="File",D[D.Directory=2]="Directory",D[D.SymbolicLink=64]="SymbolicLink"})(k||(e.FileType=k={}));var o;(function(D){D[D.Readonly=1]="Readonly",D[D.Locked=2]="Locked"})(o||(e.FilePermission=o={}));var s;(function(D){D[D.UPDATED=2]="UPDATED",D[D.ADDED=4]="ADDED",D[D.DELETED=8]="DELETED"})(s||(e.FileChangeFilter=s={}));function $(D){const Z=D;return!!Z&&typeof Z.onDidChange=="function"}var m;(function(D){D[D.None=0]="None",D[D.FileReadWrite=2]="FileReadWrite",D[D.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",D[D.FileReadStream=16]="FileReadStream",D[D.FileFolderCopy=8]="FileFolderCopy",D[D.PathCaseSensitive=1024]="PathCaseSensitive",D[D.Readonly=2048]="Readonly",D[D.Trash=4096]="Trash",D[D.FileWriteUnlock=8192]="FileWriteUnlock",D[D.FileAtomicRead=16384]="FileAtomicRead",D[D.FileAtomicWrite=32768]="FileAtomicWrite",D[D.FileAtomicDelete=65536]="FileAtomicDelete",D[D.FileClone=131072]="FileClone"})(m||(e.FileSystemProviderCapabilities=m={}));function f(D){return!!(D.capabilities&m.FileReadWrite)}function w(D){return!!(D.capabilities&m.FileFolderCopy)}function y(D){return!!(D.capabilities&m.FileClone)}function r(D){return!!(D.capabilities&m.FileOpenReadWriteClose)}function n(D){return!!(D.capabilities&m.FileReadStream)}function i(D){return f(D)?!!(D.capabilities&m.FileAtomicRead):!1}function l(D){return f(D)?!!(D.capabilities&m.FileAtomicWrite):!1}function c(D){return!!(D.capabilities&m.FileAtomicDelete)}function O(D){return!!(D.capabilities&m.Readonly)}var h;(function(D){D.FileExists="EntryExists",D.FileNotFound="EntryNotFound",D.FileNotADirectory="EntryNotADirectory",D.FileIsADirectory="EntryIsADirectory",D.FileExceedsStorageQuota="EntryExceedsStorageQuota",D.FileTooLarge="EntryTooLarge",D.FileWriteLocked="EntryWriteLocked",D.NoPermissions="NoPermissions",D.Unavailable="Unavailable",D.Unknown="Unknown"})(h||(e.FileSystemProviderErrorCode=h={}));class A extends Error{static create(Z,x){const se=new A(Z.toString(),x);return R(se,x),se}constructor(Z,x){super(Z),this.code=x}}e.$ml=A;function u(D,Z){return A.create(D,Z)}function S(D){return D||u((0,F.localize)(0,null),h.Unknown)}function R(D,Z){return D.name=Z?`${Z} (FileSystemError)`:"FileSystemError",D}function b(D){if(!D)return h.Unknown;if(D instanceof A)return D.code;const Z=/^(.+) \(FileSystemError\)$/.exec(D.name);if(!Z)return h.Unknown;switch(Z[1]){case h.FileExists:return h.FileExists;case h.FileIsADirectory:return h.FileIsADirectory;case h.FileNotADirectory:return h.FileNotADirectory;case h.FileNotFound:return h.FileNotFound;case h.FileTooLarge:return h.FileTooLarge;case h.FileWriteLocked:return h.FileWriteLocked;case h.NoPermissions:return h.NoPermissions;case h.Unavailable:return h.Unavailable}return h.Unknown}function d(D){if(D instanceof X)return D.fileOperationResult;switch(b(D)){case h.FileNotFound:return ce.FILE_NOT_FOUND;case h.FileIsADirectory:return ce.FILE_IS_DIRECTORY;case h.FileNotADirectory:return ce.FILE_NOT_DIRECTORY;case h.FileWriteLocked:return ce.FILE_WRITE_LOCKED;case h.NoPermissions:return ce.FILE_PERMISSION_DENIED;case h.FileExists:return ce.FILE_MOVE_CONFLICT;case h.FileTooLarge:return ce.FILE_TOO_LARGE;default:return ce.FILE_OTHER_ERROR}}var K;(function(D){D[D.CREATE=0]="CREATE",D[D.DELETE=1]="DELETE",D[D.MOVE=2]="MOVE",D[D.COPY=3]="COPY",D[D.WRITE=4]="WRITE"})(K||(e.FileOperation=K={}));class ie{constructor(Z,x,se){this.resource=Z,this.operation=x,this.target=se}isOperation(Z){return this.operation===Z}}e.$sl=ie;var ee;(function(D){D[D.UPDATED=0]="UPDATED",D[D.ADDED=1]="ADDED",D[D.DELETED=2]="DELETED"})(ee||(e.FileChangeType=ee={}));class V{static{this.a=null}constructor(Z,x){this.c=x,this.b=void 0,this.d=new _.$X(()=>{const se=g.$Mi.forUris(()=>this.c);return se.fill(this.rawAdded.map(le=>[le,!0])),se}),this.f=new _.$X(()=>{const se=g.$Mi.forUris(()=>this.c);return se.fill(this.rawUpdated.map(le=>[le,!0])),se}),this.g=new _.$X(()=>{const se=g.$Mi.forUris(()=>this.c);return se.fill(this.rawDeleted.map(le=>[le,!0])),se}),this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];for(const se of Z){switch(se.type){case ee.ADDED:this.rawAdded.push(se.resource);break;case ee.UPDATED:this.rawUpdated.push(se.resource);break;case ee.DELETED:this.rawDeleted.push(se.resource);break}this.b!==V.a&&(typeof se.cId=="number"?this.b===void 0?this.b=se.cId:this.b!==se.cId&&(this.b=V.a):this.b!==void 0&&(this.b=V.a))}}contains(Z,...x){return this.h(Z,{includeChildren:!1},...x)}affects(Z,...x){return this.h(Z,{includeChildren:!0},...x)}h(Z,x,...se){if(!Z)return!1;const le=se.length>0;return!!((!le||se.includes(ee.ADDED))&&(this.d.value.get(Z)||x.includeChildren&&this.d.value.findSuperstr(Z))||(!le||se.includes(ee.UPDATED))&&(this.f.value.get(Z)||x.includeChildren&&this.f.value.findSuperstr(Z))||(!le||se.includes(ee.DELETED))&&(this.g.value.findSubstr(Z)||x.includeChildren&&this.g.value.findSuperstr(Z)))}gotAdded(){return this.rawAdded.length>0}gotDeleted(){return this.rawDeleted.length>0}gotUpdated(){return this.rawUpdated.length>0}correlates(Z){return this.b===Z}hasCorrelation(){return typeof this.b=="number"}}e.$tl=V;function re(D,Z,x){return!D||!Z||D===Z||Z.length>D.length?!1:(Z.charAt(Z.length-1)!==t.sep&&(Z+=t.sep),x?(0,W.$If)(D,Z):D.indexOf(Z)===0)}class X extends Error{constructor(Z,x,se){super(Z),this.fileOperationResult=x,this.options=se}}e.$vl=X;class te extends X{constructor(Z,x,se,le){super(Z,x,le),this.fileOperationResult=x,this.size=se}}e.$wl=te;class oe extends X{constructor(Z,x,se){super(Z,ce.FILE_NOT_MODIFIED_SINCE,se),this.stat=x}}e.$xl=oe;var ce;(function(D){D[D.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",D[D.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",D[D.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",D[D.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",D[D.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",D[D.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",D[D.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",D[D.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",D[D.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",D[D.FILE_NOT_DIRECTORY=9]="FILE_NOT_DIRECTORY",D[D.FILE_OTHER_ERROR=10]="FILE_OTHER_ERROR"})(ce||(e.FileOperationResult=ce={})),e.$yl={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.$zl={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.$Al="files.associations",e.$Bl="files.exclude",e.$Cl="files.readonlyInclude",e.$Dl="files.readonlyExclude",e.$El="files.readonlyFromPermissions";var L;(function(D){D[D.FILE=0]="FILE",D[D.FOLDER=1]="FOLDER",D[D.ROOT_FOLDER=2]="ROOT_FOLDER"})(L||(e.FileKind=L={})),e.$Fl="";function a(D){if(!(typeof D.size!="number"||typeof D.mtime!="number"))return D.mtime.toString(29)+D.size.toString(31)}async function T(D,Z){if(!Z.hasProvider(Y.URI.from({scheme:D.scheme})))return new Promise(x=>{const se=Z.onDidChangeFileSystemProviderRegistrations(le=>{le.scheme===D.scheme&&le.added&&(se.dispose(),x())})})}class B{static{this.KB=1024}static{this.MB=B.KB*B.KB}static{this.GB=B.MB*B.KB}static{this.TB=B.GB*B.KB}static formatSize(Z){return(0,M.$kg)(Z)||(Z=0),Z<B.KB?(0,F.localize)(1,null,Z.toFixed(0)):Z<B.MB?(0,F.localize)(2,null,(Z/B.KB).toFixed(2)):Z<B.GB?(0,F.localize)(3,null,(Z/B.MB).toFixed(2)):Z<B.TB?(0,F.localize)(4,null,(Z/B.GB).toFixed(2)):(0,F.localize)(5,null,(Z/B.TB).toFixed(2))}}e.$Il=B;function Q(D){const Z=typeof D=="string"||D?.scheme===N.Schemas.vscodeRemote;return typeof D!="string"&&D?.scheme===N.Schemas.file?1024*B.MB:Z?10*B.MB:P.$o?50*B.MB:1024*B.MB}}),define(_e[19],Ee([0,1,23,4,3,2,5,18]),function(ae,e,g,t,W,M,Y,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6q=e.$5q=e.$4q=void 0,e.$2q=U,e.$3q=P,e.$7q=k,e.$8q=o,e.$9q=s,e.$0q=$,e.$$q=f,e.$_q=w;function U(y){return typeof y.correlationId=="number"}function P(y){return y.recursive===!0}class N extends t.$Xc{static{this.a=5}constructor(r,n,i,l){super(),this.h=r,this.j=n,this.m=i,this.n=l,this.c=this.B(new t.$Yc),this.f=void 0,this.g=0}s(){const r=new t.$Wc;this.c.value=r,this.b=this.r(r),this.b.setVerboseLogging(this.m),r.add(this.b.onDidChangeFile(n=>this.h(n))),r.add(this.b.onDidLogMessage(n=>this.j(n))),r.add(this.b.onDidError(n=>this.t(n.error,n.request)))}t(r,n){this.u(r,n)?this.g<N.a&&this.f?(this.y(`restarting watcher after unexpected error: ${r}`),this.w(this.f)):this.y(`gave up attempting to restart watcher after unexpected error: ${r}`):this.y(r)}u(r,n){return!(!this.n.restartOnError||n||r.indexOf("No space left on device")!==-1||r.indexOf("EMFILE")!==-1)}w(r){this.g++,this.s(),this.watch(r)}async watch(r){this.f=r,await this.b?.watch(r)}async setVerboseLogging(r){this.m=r,await this.b?.setVerboseLogging(r)}y(r){this.j({type:"error",message:`[File Watcher (${this.n.type})] ${r}`})}z(r){this.j({type:"trace",message:`[File Watcher (${this.n.type})] ${r}`})}dispose(){return this.b=void 0,super.dispose()}}e.$4q=N;class _ extends N{constructor(r,n,i){super(r,n,i,{type:"node.js",restartOnError:!1})}}e.$5q=_;class v extends N{constructor(r,n,i){super(r,n,i,{type:"universal",restartOnError:!0})}}e.$6q=v;function k(y){return y.map(r=>({type:r.type,resource:Y.URI.revive(r.resource),cId:r.cId}))}function o(y){const r=new m;for(const n of y)r.processEvent(n);return r.coalesce()}function s(y,r){return typeof r=="string"&&!r.startsWith(g.$wk)&&!(0,W.$lc)(r)?{base:y,pattern:r}:r}function $(y,r){const n=[];for(const i of r)n.push((0,g.$Ak)(s(y,i)));return n}class m{constructor(){this.a=new Set,this.b=new Map}c(r){return M.$k?r.resource.fsPath:r.resource.fsPath.toLowerCase()}processEvent(r){const n=this.b.get(this.c(r));let i=!1;if(n){const l=n.type,c=r.type;n.resource.fsPath!==r.resource.fsPath&&(r.type===F.FileChangeType.DELETED||r.type===F.FileChangeType.ADDED)?i=!0:l===F.FileChangeType.ADDED&&c===F.FileChangeType.DELETED?(this.b.delete(this.c(r)),this.a.delete(n)):l===F.FileChangeType.DELETED&&c===F.FileChangeType.ADDED?n.type=F.FileChangeType.UPDATED:l===F.FileChangeType.ADDED&&c===F.FileChangeType.UPDATED||(n.type=c)}else i=!0;i&&(this.a.add(r),this.b.set(this.c(r),r))}coalesce(){const r=[],n=[];return Array.from(this.a).filter(i=>i.type!==F.FileChangeType.DELETED?(r.push(i),!1):!0).sort((i,l)=>i.resource.fsPath.length-l.resource.fsPath.length).filter(i=>n.some(l=>(0,F.$ul)(i.resource.fsPath,l,!M.$k))?!1:(n.push(i.resource.fsPath),!0)).concat(r)}}function f(y,r){if(typeof r=="number")switch(y.type){case F.FileChangeType.ADDED:return(r&F.FileChangeFilter.ADDED)===0;case F.FileChangeType.DELETED:return(r&F.FileChangeFilter.DELETED)===0;case F.FileChangeType.UPDATED:return(r&F.FileChangeFilter.UPDATED)===0}return!1}function w(y){if(typeof y=="number"){const r=[];return y&F.FileChangeFilter.ADDED&&r.push("Added"),y&F.FileChangeFilter.DELETED&&r.push("Deleted"),y&F.FileChangeFilter.UPDATED&&r.push("Updated"),r.length===0?"<all>":`[${r.join(", ")}]`}return"<none>"}}),define(_e[36],Ee([0,1,17,4,19,6,18,5,8]),function(ae,e,g,t,W,M,Y,F,U){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ir=void 0;class P extends t.$Xc{constructor(){super(),this.a=this.B(new M.$ne),this.onDidChangeFile=this.a.event,this.b=this.B(new M.$ne),this.onDidLogMessage=this.b.event,this.c=this.B(new M.$ne),this.f=this.c.event,this.g=new Set,this.h=new Map,this.j=this.B(new t.$7c),this.m=new Set,this.n=this.B(new U.$Eh(this.y())),this.r=5007,this.s=new U.$4h,this.R=!1,this.B(this.f(_=>this.t(_)))}t(_){this.u(_)&&this.z(_)}u(_){return(0,W.$2q)(_)}async watch(_){this.s.isSettled||this.s.complete(),this.s=new U.$4h;try{this.h.clear(),this.g.clear();for(const v of _)this.u(v)?this.h.set(v.correlationId,v):this.g.add(v);for(const[v]of this.j)this.h.has(v)||(this.j.deleteAndDispose(v),this.m.delete(v));return await this.w(!1)}finally{this.s.complete()}}w(_){return this.n.trigger(()=>this.N([...this.g,...Array.from(this.h.values()).filter(v=>!this.j.has(v.correlationId))]),_?this.y():0)}y(){return 800}isSuspended(_){return typeof _.correlationId!="number"?!1:this.m.has(_.correlationId)?"polling":this.j.has(_.correlationId)}async z(_){if(this.j.has(_.correlationId))return;const v=new t.$Wc;this.j.set(_.correlationId,v),await this.s.p,!v.isDisposed&&(this.D(_,v),this.w(!0))}C(_){this.j.deleteAndDispose(_.correlationId),this.m.delete(_.correlationId),this.w(!1)}D(_,v){this.F(_,v)?(this.P(`reusing an existing recursive watcher to monitor ${_.path}`),this.m.delete(_.correlationId)):(this.G(_,v),this.m.add(_.correlationId))}F(_,v){const k=this.O?.subscribe(_.path,(o,s)=>{v.isDisposed||(o?this.D(_,v):s?.type===Y.FileChangeType.ADDED&&this.H(_))});return k?(v.add(k),!0):!1}G(_,v){let k=!1;const o=(s,$)=>{if(v.isDisposed)return;const m=this.I(s),f=this.I($),w=k;k=m,!m&&(f||w)&&this.H(_)};this.P(`starting fs.watchFile() on ${_.path} (correlationId: ${_.correlationId})`);try{(0,g.watchFile)(_.path,{persistent:!1,interval:this.r},o)}catch(s){this.Q(`fs.watchFile() failed with error ${s} on path ${_.path} (correlationId: ${_.correlationId})`)}v.add((0,t.$Vc)(()=>{this.P(`stopping fs.watchFile() on ${_.path} (correlationId: ${_.correlationId})`);try{(0,g.unwatchFile)(_.path,o)}catch(s){this.Q(`fs.unwatchFile() failed with error ${s} on path ${_.path} (correlationId: ${_.correlationId})`)}}))}H(_){this.P(`detected ${_.path} exists again, resuming watcher (correlationId: ${_.correlationId})`);const v={resource:F.URI.file(_.path),type:Y.FileChangeType.ADDED,cId:_.correlationId};this.a.fire([v]),this.J(v,_),this.C(_)}I(_){return _.ctimeMs===0&&_.ino===0}async stop(){this.j.clearAndDisposeAll(),this.m.clear()}J(_,v){if(this.R){const k=` >> normalized ${_.type===Y.FileChangeType.ADDED?"[ADDED]":_.type===Y.FileChangeType.DELETED?"[DELETED]":"[CHANGED]"} ${_.resource.fsPath}`;this.L(k,v)}}L(_,v){this.R&&this.P(`${_}${typeof v.correlationId=="number"?` <${v.correlationId}> `:""}`)}M(_){return`${_.path} (excludes: ${_.excludes.length>0?_.excludes:"<none>"}, includes: ${_.includes&&_.includes.length>0?JSON.stringify(_.includes):"<all>"}, filter: ${(0,W.$_q)(_.filter)}, correlationId: ${typeof _.correlationId=="number"?_.correlationId:"<none>"})`}async setVerboseLogging(_){this.R=_}}e.$ir=P}),define(_e[37],Ee([0,1,17,8,13,14,4,21,3,2,22,5,35,24,18,19]),function(ae,e,g,t,W,M,Y,F,U,P,N,_,v,k,o,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nr=void 0,e.$or=m;class $ extends Y.$Xc{static{this.a=100}static{this.b=75}get isReusingRecursiveWatcher(){return this.n}get failed(){return this.r}constructor(w,y,r,n,i,l){super(),this.s=w,this.t=y,this.u=r,this.w=n,this.y=i,this.z=l,this.c=this.B(new t.$Vh({maxWorkChunkSize:100,throttleDelay:200,maxBufferedWork:1e4},c=>this.u(c))),this.f=this.B(new t.$Uh(c=>this.M(c),$.b)),this.g=(0,s.$0q)(this.s.path,this.s.excludes),this.h=this.s.includes?(0,s.$0q)(this.s.path,this.s.includes):void 0,this.j=(0,s.$2q)(this.s)?this.s.filter:void 0,this.m=new W.$ye,this.ready=this.C(),this.n=!1,this.r=!1}async C(){try{const w=await this.F(this.s);if(this.m.token.isCancellationRequested)return;const y=await k.Promises.stat(w);if(this.m.token.isCancellationRequested)return;this.B(await this.G(w,y.isDirectory()))}catch(w){w.code!=="ENOENT"?this.O(w):this.Q(`ignoring a path for watching who's stat info failed to resolve: ${this.s.path} (error: ${w})`),this.D()}}D(){this.r=!0,this.w?.()}async F(w){let y=w.path;try{y=await k.Promises.realpath(w.path),w.path===y&&(y=await(0,v.$kr)(w.path,this.m.token)??w.path),w.path!==y&&this.Q(`correcting a path to watch that seems to be a symbolic link or wrong casing (original: ${w.path}, real: ${y})`)}catch{}return y}async G(w,y){const r=new Y.$Wc;return this.H(w,y,r)?(this.Q(`reusing an existing recursive watcher for ${this.s.path}`),this.n=!0):(this.n=!1,await this.I(w,y,r)),r}H(w,y,r){if(y)return!1;const n=_.URI.file(this.s.path),i=this.t?.subscribe(this.s.path,async(l,c)=>{if(!r.isDisposed)if(l){const O=await this.G(w,y);r.isDisposed?O.dispose():r.add(O)}else c&&(typeof c.cId=="number"||typeof this.s.correlationId=="number")&&this.L({resource:n,type:c.type,cId:this.s.correlationId},!0)});return i?(r.add(i),!0):!1}async I(w,y,r){if(P.$j&&(0,M.$Fg)(w,"/Volumes/",!0)){this.O(`Refusing to watch ${w} for changes using fs.watch() for possibly being a network share where watching is unreliable and unstable.`);return}const n=new W.$ye(this.m.token);r.add((0,Y.$Vc)(()=>n.dispose(!0)));const i=new Y.$Wc;r.add(i);try{const l=_.URI.file(this.s.path),c=(0,U.$qc)(w),O=(0,g.watch)(w);i.add((0,Y.$Vc)(()=>{O.removeAllListeners(),O.close()})),this.Q(`Started watching: '${w}'`);const h=new Set;if(y)try{for(const u of await k.Promises.readdir(w))h.add(u)}catch(u){this.O(u)}if(n.token.isCancellationRequested)return;const A=new Map;i.add((0,Y.$Vc)(()=>{for(const[,u]of A)u.dispose();A.clear()})),O.on("error",(u,S)=>{n.token.isCancellationRequested||(this.O(`Failed to watch ${w} for changes using fs.watch() (${u}, ${S})`),this.D())}),O.on("change",(u,S)=>{if(n.token.isCancellationRequested)return;this.z&&this.R(`[raw] ["${u}"] ${S}`);let R="";if(S&&(R=S.toString(),P.$j&&(R=(0,F.$nm)(R))),!(!R||u!=="change"&&u!=="rename"))if(y)if(u==="rename"){A.get(R)?.dispose();const b=setTimeout(async()=>{if(A.delete(R),R===c&&!await k.Promises.exists(w)){this.J(l);return}if(n.token.isCancellationRequested)return;const d=await this.N((0,U.$mc)(w,R));if(n.token.isCancellationRequested)return;let K;d?h.has(R)?K=o.FileChangeType.UPDATED:(K=o.FileChangeType.ADDED,h.add(R)):(h.delete(R),K=o.FileChangeType.DELETED),this.L({resource:(0,N.$hh)(l,R),type:K,cId:this.s.correlationId})},$.a);A.set(R,(0,Y.$Vc)(()=>clearTimeout(b)))}else{let b;h.has(R)?b=o.FileChangeType.UPDATED:(b=o.FileChangeType.ADDED,h.add(R)),this.L({resource:(0,N.$hh)(l,R),type:b,cId:this.s.correlationId})}else if(u==="rename"||R!==c){const b=setTimeout(async()=>{const d=await k.Promises.exists(w);n.token.isCancellationRequested||(d?(this.L({resource:l,type:o.FileChangeType.UPDATED,cId:this.s.correlationId},!0),i.add(await this.G(w,!1))):this.J(l))},$.a);i.clear(),i.add((0,Y.$Vc)(()=>clearTimeout(b)))}else this.L({resource:l,type:o.FileChangeType.UPDATED,cId:this.s.correlationId},!0)})}catch(l){n.token.isCancellationRequested||this.O(`Failed to watch ${w} for changes using fs.watch() (${l.toString()})`),this.D()}}J(w){this.P("Watcher shutdown because watched path got deleted"),this.L({resource:w,type:o.FileChangeType.DELETED,cId:this.s.correlationId},!0),this.f.flush(),this.D()}L(w,y=!1){this.m.token.isCancellationRequested||(this.z&&this.R(`${w.type===o.FileChangeType.ADDED?"[ADDED]":w.type===o.FileChangeType.DELETED?"[DELETED]":"[CHANGED]"} ${w.resource.fsPath}`),!y&&this.g.some(r=>r(w.resource.fsPath))?this.z&&this.R(` >> ignored (excluded) ${w.resource.fsPath}`):!y&&this.h&&this.h.length>0&&!this.h.some(r=>r(w.resource.fsPath))?this.z&&this.R(` >> ignored (not included) ${w.resource.fsPath}`):this.f.work(w))}M(w){const y=(0,s.$8q)(w),r=[];for(const i of y){if((0,s.$$q)(i,this.j)){this.z&&this.R(` >> ignored (filtered) ${i.resource.fsPath}`);continue}r.push(i)}if(r.length===0)return;if(this.z)for(const i of r)this.R(` >> normalized ${i.type===o.FileChangeType.ADDED?"[ADDED]":i.type===o.FileChangeType.DELETED?"[DELETED]":"[CHANGED]"} ${i.resource.fsPath}`);this.c.work(r)?this.c.pending>0&&this.Q(`started throttling events due to large amount of file change events at once (pending: ${this.c.pending}, most recent change: ${r[0].resource.fsPath}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`):this.P(`started ignoring events due to too many file change events at once (incoming: ${r.length}, most recent change: ${r[0].resource.fsPath}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`)}async N(w){if(P.$k)return k.Promises.exists(w);try{const y=(0,U.$qc)(w);return(await k.Promises.readdir((0,U.$pc)(w))).some(n=>n===y)}catch(y){return this.Q(y),!1}}setVerboseLogging(w){this.z=w}O(w){this.m.token.isCancellationRequested||this.y?.({type:"error",message:`[File Watcher (node.js)] ${w}`})}P(w){this.m.token.isCancellationRequested||this.y?.({type:"warn",message:`[File Watcher (node.js)] ${w}`})}Q(w){!this.m.token.isCancellationRequested&&this.z&&this.y?.({type:"trace",message:`[File Watcher (node.js)] ${w}`})}R(w){!this.m.token.isCancellationRequested&&this.z&&this.Q(`${w}${typeof this.s.correlationId=="number"?` <${this.s.correlationId}> `:""}`)}dispose(){this.m.dispose(!0),super.dispose()}}e.$nr=$;async function m(f,w,y,r,n=512){const i=await k.Promises.open(f,"r"),l=Buffer.allocUnsafe(n),c=new W.$ye(r);let O,h=!1;const A={path:f,excludes:[],recursive:!1},u=new $(A,void 0,S=>{(async()=>{for(const{type:R}of S)if(R===o.FileChangeType.UPDATED){if(h)return;h=!0;try{for(;!c.token.isCancellationRequested;){const{bytesRead:b}=await k.Promises.read(i,l,0,n,null);if(!b||c.token.isCancellationRequested)break;w(l.slice(0,b))}}catch(b){O=new Error(b),c.dispose(!0)}finally{h=!1}}})()});return await u.ready,y(),new Promise((S,R)=>{c.token.onCancellationRequested(async()=>{u.dispose();try{await k.Promises.close(i)}catch(b){O=new Error(b)}O?R(O):S()})})}}),define(_e[60],Ee([0,1,6,23,36,2,37,14]),function(ae,e,g,t,W,M,Y,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pr=void 0;class U extends W.$ir{constructor(N){super(),this.O=N,this.onDidError=g.Event.None,this.watchers=new Set}async N(N){N=this.Z(N);const _=[],v=new Set(Array.from(this.watchers));for(const k of N){const o=this.W(k);o&&(0,t.$Ek)(o.request.excludes,k.excludes)&&(0,t.$Ek)(o.request.includes,k.includes)?v.delete(o):_.push(k)}_.length&&this.P(`Request to start watching: ${_.map(k=>this.M(k)).join(",")}`),v.size&&this.P(`Request to stop watching: ${Array.from(v).map(k=>this.M(k.request)).join(",")}`);for(const k of v)this.Y(k);for(const k of _)this.X(k)}W(N){for(const _ of this.watchers)if(typeof N.correlationId=="number"||typeof _.request.correlationId=="number"){if(_.request.correlationId===N.correlationId)return _}else if((0,F.$Eg)(_.request.path,N.path,!M.$k))return _}X(N){const _=new Y.$nr(N,this.O,k=>this.a.fire(k),()=>this.c.fire(N),k=>this.b.fire(k),this.R),v={request:N,instance:_};this.watchers.add(v)}async stop(){await super.stop();for(const N of this.watchers)this.Y(N)}Y(N){this.P("stopping file watcher",N),this.watchers.delete(N),N.instance.dispose()}Z(N){const _=new Map;for(const v of N){const k=M.$k?v.path:v.path.toLowerCase();let o=_.get(v.correlationId);o||(o=new Map,_.set(v.correlationId,o)),o.has(k)&&this.P(`ignoring a request for watching who's path is already watched: ${this.M(v)}`),o.set(k,v)}return Array.from(_.values()).map(v=>Array.from(v.values())).flat()}async setVerboseLogging(N){super.setVerboseLogging(N);for(const _ of this.watchers)_.instance.setVerboseLogging(N)}P(N,_){this.R&&this.b.fire({type:"trace",message:this.bb(N,_)})}Q(N){this.b.fire({type:"warn",message:this.bb(N)})}bb(N,_){return _?`[File Watcher (node.js)] ${N} (${this.M(_.request)})`:`[File Watcher (node.js)] ${N}`}}e.$pr=U}),define(_e[61],Ee([0,1,66,17,54,5,8,13,50,6,14,23,36,28,21,3,2,35,37,18,19,4]),function(ae,e,g,t,W,M,Y,F,U,P,N,_,v,k,o,s,$,m,f,w,y,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ulc=e.$tlc=void 0,g=Le(g);class n extends r.$Xc{get failed(){return this.c}get stopped(){return this.f}constructor(c,O,h,A,u,S){super(),this.ready=c,this.request=O,this.restarts=h,this.token=A,this.worker=u,this.m=S,this.a=this.B(new P.$ne),this.onDidStop=this.a.event,this.b=this.B(new P.$ne),this.onDidFail=this.b.event,this.c=!1,this.f=!1,this.g=this.request.includes?(0,y.$0q)(this.request.path,this.request.includes):void 0,this.h=this.request.excludes?(0,y.$0q)(this.request.path,this.request.excludes):void 0,this.j=new Map,this.B((0,r.$Vc)(()=>this.j.clear()))}subscribe(c,O){c=M.URI.file(c).fsPath;let h=this.j.get(c);return h||(h=new Set,this.j.set(c,h)),h.add(O),(0,r.$Vc)(()=>{const A=this.j.get(c);A&&(A.delete(O),A.size===0&&this.j.delete(c))})}get subscriptionsCount(){return this.j.size}notifyFileChange(c,O){const h=this.j.get(c);if(h)for(const A of h)A(O)}notifyWatchFailed(){this.c=!0,this.b.fire()}include(c){return!this.g||this.g.length===0?!0:this.g.some(O=>O(c))}exclude(c){return!!this.h?.some(O=>O(c))}async stop(c){this.f=!0;try{await this.m()}finally{this.a.fire({joinRestart:c}),this.dispose()}}}e.$tlc=n;class i extends v.$ir{static{this.S=new Map([["create",w.FileChangeType.ADDED],["update",w.FileChangeType.UPDATED],["delete",w.FileChangeType.DELETED]])}static{this.U=$.$i?"windows":$.$k?"inotify":"fs-events"}static{this.X=75}constructor(){super(),this.W=this.B(new P.$ne),this.onDidError=this.W.event,this.watchers=new Set,this.Y=this.B(new Y.$Vh({maxWorkChunkSize:500,throttleDelay:200,maxBufferedWork:3e4},c=>this.a.fire(c))),this.Z=!1,this.$()}$(){process.on("uncaughtException",c=>this.nb(c)),process.on("unhandledRejection",c=>this.nb(c))}async N(c){c=this.qb(c);const O=[],h=new Set(Array.from(this.watchers));for(const A of c){const u=this.bb(A);u&&(0,_.$Ek)(u.request.excludes,A.excludes)&&(0,_.$Ek)(u.request.includes,A.includes)&&u.request.pollingInterval===A.pollingInterval?h.delete(u):O.push(A)}O.length&&this.P(`Request to start watching: ${O.map(A=>this.M(A)).join(",")}`),h.size&&this.P(`Request to stop watching: ${Array.from(h).map(A=>this.M(A.request)).join(",")}`);for(const A of h)await this.pb(A);for(const A of O)A.pollingInterval?this.cb(A,A.pollingInterval):await this.db(A)}bb(c){for(const O of this.watchers)if(this.u(c)||this.u(O.request)){if(O.request.correlationId===c.correlationId)return O}else if((0,N.$Eg)(O.request.path,c.path,!$.$k))return O}cb(c,O,h=0){const A=new F.$ye,u=new Y.$4h,S=(0,N.$Og)((0,W.tmpdir)(),"vscode-watcher-snapshot"),R=new n(u.p,c,h,A.token,new Y.$Uh(V=>this.gb(V,R),i.X),async()=>{A.dispose(!0),R.worker.flush(),R.worker.dispose(),ee.dispose(),(0,t.unlinkSync)(S)});this.watchers.add(R);const{realPath:b,realPathDiffers:d,realPathLength:K}=this.ib(c);this.P(`Started watching: '${b}' with polling interval '${O}'`);let ie=0;const ee=new Y.$Sh(async()=>{if(ie++,!A.token.isCancellationRequested){if(ie>1){const V=await g.getEventsSince(b,S,{ignore:c.excludes,backend:i.U});if(A.token.isCancellationRequested)return;this.eb(V,R,d,K)}await g.writeSnapshot(b,S,{ignore:c.excludes,backend:i.U}),ie===1&&u.complete(),!A.token.isCancellationRequested&&ee.schedule()}},O);ee.schedule(0)}async db(c,O=0){const h=new F.$ye,A=new Y.$4h,u=new n(A.p,c,O,h.token,new Y.$Uh(d=>this.gb(d,u),i.X),async()=>{h.dispose(!0),u.worker.flush(),u.worker.dispose(),await(await A.p)?.unsubscribe()});this.watchers.add(u);const{realPath:S,realPathDiffers:R,realPathLength:b}=this.ib(c);try{const d=await g.subscribe(S,(K,ie)=>{u.token.isCancellationRequested||(K&&this.nb(K,c),this.eb(ie,u,R,b))},{backend:i.U,ignore:u.request.excludes});this.P(`Started watching: '${S}' with backend '${i.U}'`),A.complete(d)}catch(d){this.nb(d,c),A.complete(void 0),u.notifyWatchFailed(),this.c.fire(c)}}eb(c,O,h,A){if(c.length===0)return;this.jb(c,O.request,h,A);const u=this.fb(O,c);for(const S of u)O.worker.work(S)}fb(c,O){const h=[];for(const{path:A,type:u}of O){const S=i.S.get(u);this.R&&this.L(`${S===w.FileChangeType.ADDED?"[ADDED]":S===w.FileChangeType.DELETED?"[DELETED]":"[CHANGED]"} ${A}`,c.request),c.include(A)?h.push({type:S,resource:M.URI.file(A),cId:c.request.correlationId}):this.R&&this.L(` >> ignored (not included) ${A}`,c.request)}return h}gb(c,O){const h=(0,y.$8q)(c),{events:A,rootDeleted:u}=this.kb(h,O);this.hb(A,O),u&&this.lb(O)}hb(c,O){if(c.length===0)return;this.Y.work(c)?this.Y.pending>0&&this.P(`started throttling events due to large amount of file change events at once (pending: ${this.Y.pending}, most recent change: ${c[0].resource.fsPath}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`,O):this.Q(`started ignoring events due to too many file change events at once (incoming: ${c.length}, most recent change: ${c[0].resource.fsPath}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`)}ib(c){let O=c.path,h=!1,A=c.path.length;try{O=(0,m.$mr)(c.path),c.path===O&&(O=(0,m.$jr)(c.path)??c.path),c.path!==O&&(A=O.length,h=!0,this.P(`correcting a path to watch that seems to be a symbolic link or wrong casing (original: ${c.path}, real: ${O})`))}catch{}return{realPath:O,realPathDiffers:h,realPathLength:A}}jb(c,O,h,A){for(const u of c)$.$j&&(u.path=(0,o.$nm)(u.path)),$.$i&&O.path.length<=3&&(u.path=(0,s.$kc)(u.path)),h&&(u.path=O.path+u.path.substr(A))}kb(c,O){const h=[];let A=!1;const u=this.u(O.request)?O.request.filter:void 0;for(const S of c){if(O.subscriptionsCount>0&&O.notifyFileChange(S.resource.fsPath,S),A=S.type===w.FileChangeType.DELETED&&(0,N.$Eg)(S.resource.fsPath,O.request.path,!$.$k),(0,y.$$q)(S,u)||A&&!this.u(O.request)){this.R&&this.L(` >> ignored (filtered) ${S.resource.fsPath}`,O.request);continue}this.J(S,O.request),h.push(S)}return{events:h,rootDeleted:A}}lb(c){this.Q("Watcher shutdown because watched path got deleted",c);let O=!1;this.u(c.request)||(O=this.mb(c)),O||(c.notifyWatchFailed(),this.c.fire(c.request))}mb(c){const O=(0,s.$pc)(c.request.path);if((0,t.existsSync)(O)){this.P("Trying to watch on the parent path to restart the watcher...",c);const h=new f.$nr({path:O,excludes:[],recursive:!1,correlationId:c.request.correlationId},void 0,A=>{if(!c.token.isCancellationRequested){for(const{resource:u,type:S}of A)if((0,N.$Eg)(u.fsPath,c.request.path,!$.$k)&&(S===w.FileChangeType.ADDED||S===w.FileChangeType.UPDATED)&&this.rb(c.request.path)){this.Q("Watcher restarts because watched path got created again",c),h.dispose(),this.ob(c);break}}},void 0,A=>this.b.fire(A),this.R);return c.token.onCancellationRequested(()=>h.dispose()),!0}return!1}nb(c,O){const h=(0,U.$rj)(c);h.indexOf("No space left on device")!==-1?this.Z||(this.ub("Inotify limit reached (ENOSPC)",O),this.Z=!0):(this.ub(`Unexpected error: ${h} (EUNKNOWN)`,O),this.W.fire({request:O,error:h}))}async stop(){await super.stop();for(const c of this.watchers)await this.pb(c)}ob(c,O=800){const h=new Y.$Sh(async()=>{if(c.token.isCancellationRequested)return;const A=new Y.$4h;try{await this.pb(c,A.p),c.request.pollingInterval?this.cb(c.request,c.request.pollingInterval,c.restarts+1):await this.db(c.request,c.restarts+1)}finally{A.complete()}},O);h.schedule(),c.token.onCancellationRequested(()=>h.dispose())}async pb(c,O){this.P("stopping file watcher",c),this.watchers.delete(c);try{await c.stop(O)}catch(h){this.ub(`Unexpected error stopping watcher: ${(0,U.$rj)(h)}`,c.request)}}qb(c,O=!0){c.sort((u,S)=>u.path.length-S.path.length);const h=new Map;for(const u of c){if(u.excludes.includes(_.$wk))continue;const S=$.$k?u.path:u.path.toLowerCase();let R=h.get(u.correlationId);R||(R=new Map,h.set(u.correlationId,R)),R.has(S)&&this.P(`ignoring a request for watching who's path is already watched: ${this.M(u)}`),R.set(S,u)}const A=[];for(const u of h.values()){const S=k.$Mi.forPaths(!$.$k);for(const R of u.values()){if(S.findSubstr(R.path))try{if((0,m.$mr)(R.path)===R.path){this.P(`ignoring a request for watching who's parent is already watched: ${this.M(R)}`);continue}}catch(b){this.P(`ignoring a request for watching who's realpath failed to resolve: ${this.M(R)} (error: ${b})`),this.c.fire(R);continue}if(O&&!this.rb(R.path)){this.c.fire(R);continue}S.set(R.path,R)}A.push(...Array.from(S).map(([,R])=>R))}return A}rb(c){try{if(!(0,t.statSync)(c).isDirectory())return this.P(`ignoring a path for watching that is a file and not a folder: ${c}`),!1}catch(O){return this.P(`ignoring a path for watching who's stat info failed to resolve: ${c} (error: ${O})`),!1}return!0}subscribe(c,O){for(const h of this.watchers){if(h.failed||!(0,N.$Fg)(c,h.request.path,!$.$k)||h.exclude(c)||!h.include(c))continue;const A=new r.$Wc;return A.add(P.Event.once(h.onDidStop)(async u=>{await u.joinRestart,!A.isDisposed&&O(!0)})),A.add(P.Event.once(h.onDidFail)(()=>O(!0))),A.add(h.subscribe(c,u=>O(null,u))),A}}P(c,O){this.R&&this.b.fire({type:"trace",message:this.vb(c,O?.request)})}Q(c,O){this.b.fire({type:"warn",message:this.vb(c,O?.request)})}ub(c,O){this.b.fire({type:"error",message:this.vb(c,O)})}vb(c,O){return O?`[File Watcher (parcel)] ${c} (path: ${O.path})`:`[File Watcher (parcel)] ${c}`}get O(){return this}}e.$ulc=i}),define(_e[62],Ee([0,1,19]),function(ae,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vlc=t;function t(o,s,$){const m=[],f=U(o.filter(K=>K.recursive)),w=f.filter(K=>s.isSuspended(K)===!1),y=f.filter(K=>s.isSuspended(K)==="polling"),r=f.filter(K=>s.isSuspended(K)===!0),n=M(f,s),i=Y(s),l=U(o.filter(K=>!K.recursive)),c=l.filter(K=>$.isSuspended(K)===!1),O=l.filter(K=>$.isSuspended(K)==="polling"),h=l.filter(K=>$.isSuspended(K)===!0),A=M(l,$),u=F($);m.push("[Summary]"),m.push(`- Recursive Requests:     total: ${f.length}, suspended: ${n.suspended}, polling: ${n.polling}`),m.push(`- Non-Recursive Requests: total: ${l.length}, suspended: ${A.suspended}, polling: ${A.polling}`),m.push(`- Recursive Watchers:     total: ${s.watchers.size}, active: ${i.active}, failed: ${i.failed}, stopped: ${i.stopped}`),m.push(`- Non-Recursive Watchers: total: ${$.watchers.size}, active: ${u.active}, failed: ${u.failed}, reusing: ${u.reusing}`),m.push(`- I/O Handles Impact:     total: ${n.polling+A.polling+i.active+u.active}`),m.push(`
[Recursive Requests (${f.length}, suspended: ${n.suspended}, polling: ${n.polling})]:`);const S=[];for(const K of[w,y,r].flat())N(S,K,s);m.push(...W(S));const R=[];v(R,s),m.push(...W(R)),m.push(`
[Non-Recursive Requests (${l.length}, suspended: ${A.suspended}, polling: ${A.polling})]:`);const b=[];for(const K of[c,O,h].flat())N(b,K,$);m.push(...W(b));const d=[];return k(d,$),m.push(...W(d)),`

[File Watcher] request stats:

${m.join(`
`)}

`}function W(o){let s=0;for(const $ of o)s=Math.max(s,$.split("	")[0].length);for(let $=0;$<o.length;$++){const f=o[$].split("	");if(f.length===2){const w=" ".repeat(s-f[0].length);o[$]=`${f[0]}${w}	${f[1]}`}}return o}function M(o,s){let $=0,m=0;for(const f of o){const w=s.isSuspended(f);w!==!1&&(m++,w==="polling"&&$++)}return{suspended:m,polling:$}}function Y(o){let s=0,$=0,m=0;for(const f of o.watchers.values())!f.failed&&!f.stopped&&s++,f.failed&&$++,f.stopped&&m++;return{active:s,failed:$,stopped:m}}function F(o){let s=0,$=0,m=0;for(const f of o.watchers)!f.instance.failed&&!f.instance.isReusingRecursiveWatcher&&s++,f.instance.failed&&$++,f.instance.isReusingRecursiveWatcher&&m++;return{active:s,failed:$,reusing:m}}function U(o){return o.sort((s,$)=>{const m=P(s)?s.path:s.request.path,f=P($)?$.path:$.request.path,w=Math.min(m.length,f.length);for(let y=0;y<w;y++)if(m[y]!==f[y])return m[y]<f[y]?-1:1;return m.length-f.length}),o}function P(o){return typeof o?.path=="string"}function N(o,s,$){const m=[],f=$.isSuspended(s);f!==!1&&(f==="polling"?m.push("[SUSPENDED <polling>]"):m.push("[SUSPENDED <non-polling>]")),o.push(` ${s.path}	${m.length>0?m.join(" ")+" ":""}(${_(s)})`)}function _(o){return`excludes: ${o.excludes.length>0?o.excludes:"<none>"}, includes: ${o.includes&&o.includes.length>0?JSON.stringify(o.includes):"<all>"}, filter: ${(0,g.$_q)(o.filter)}, correlationId: ${typeof o.correlationId=="number"?o.correlationId:"<none>"}`}function v(o,s){const $=U(Array.from(s.watchers.values())),{active:m,failed:f,stopped:w}=Y(s);o.push(`
[Recursive Watchers (${$.length}, active: ${m}, failed: ${f}, stopped: ${w})]:`);for(const y of $){const r=[];y.failed&&r.push("[FAILED]"),y.stopped&&r.push("[STOPPED]"),y.subscriptionsCount>0&&r.push(`[SUBSCRIBED:${y.subscriptionsCount}]`),y.restarts>0&&r.push(`[RESTARTED:${y.restarts}]`),o.push(` ${y.request.path}	${r.length>0?r.join(" ")+" ":""}(${_(y.request)})`)}}function k(o,s){const $=U(Array.from(s.watchers.values())),m=$.filter(i=>!i.instance.failed&&!i.instance.isReusingRecursiveWatcher),f=$.filter(i=>i.instance.failed),w=$.filter(i=>i.instance.isReusingRecursiveWatcher),{active:y,failed:r,reusing:n}=F(s);o.push(`
[Non-Recursive Watchers (${$.length}, active: ${y}, failed: ${r}, reusing: ${n})]:`);for(const i of[m,f,w].flat()){const l=[];i.instance.failed&&l.push("[FAILED]"),i.instance.isReusingRecursiveWatcher&&l.push("[REUSING]"),o.push(` ${i.request.path}	${l.length>0?l.join(" ")+" ":""}(${_(i.request)})`)}}}),define(_e[63],Ee([0,1,4,6,61,60,8,62]),function(ae,e,g,t,W,M,Y,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wlc=void 0;class U extends g.$Xc{constructor(){super(...arguments),this.a=this.B(new W.$ulc),this.b=this.B(new M.$pr(this.a)),this.onDidChangeFile=t.Event.any(this.a.onDidChangeFile,this.b.onDidChangeFile),this.onDidError=t.Event.any(this.a.onDidError,this.b.onDidError),this.c=this.B(new t.$ne),this.onDidLogMessage=t.Event.any(this.c.event,this.a.onDidLogMessage,this.b.onDidLogMessage),this.f=[]}async watch(N){this.f=N;let _;try{await this.a.watch(N.filter(v=>v.recursive))}catch(v){_=v}try{await this.b.watch(N.filter(v=>!v.recursive))}catch(v){_||(_=v)}if(_)throw _}async setVerboseLogging(N){N&&this.f.length>0&&this.c.fire({type:"trace",message:(0,F.$vlc)(this.f,this.a,this.b)}),await Y.Promises.settled([this.a.setVerboseLogging(N),this.b.setVerboseLogging(N)])}async stop(){await Y.Promises.settled([this.a.stop(),this.b.stop()])}}e.$wlc=U}),define(_e[67],Ee([0,1,4,25,56,57,29,63]),function(ae,e,g,t,W,M,Y,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let U;(0,Y.$RX)(process)?U=new M.$SX:U=new W.$fr("watcher");const P=new F.$wlc;U.registerChannel("watcher",t.ProxyChannel.fromService(P,new g.$Wc))})}).call(this);

//# sourceMappingURL=https://main.vscode-cdn.net/sourcemaps/undefined/core/vs/platform/files/node/watcher/watcherMain.js.map
